using Kentico.CMS.DataEngine; 
using Kentico.CMS.EventLog; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class EventLogList : System.Web.UI.Page { 
        
        protected string viewHint; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by Page_PreRender
             
            base.PreRender += new System.EventHandler( Page_PreRender ); 
            // events handled by BasicDataGrid1_ItemDataBound
             
            BasicDataGrid1.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler( BasicDataGrid1_ItemDataBound ); 
            // events handled by btnClear_Click
             
            btnClear.Click += new System.EventHandler( btnClear_Click ); 
            // events handled by btnFilter_Click
             
            btnFilter.Click += new System.EventHandler( btnFilter_Click ); 
        } 
        
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ Kentico.CMS.CMSControls.BasicDataGrid BasicDataGrid1; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblEventType; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblUserName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblNodeName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtUserName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtNodeName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.DropDownList lstEventType; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnClear; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlConfirmScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnFilter; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblEventCode; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtEventCode; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // Check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.Administration", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.Administration", "Read" ); 
                return; 
            } 
            
            // Set view hint
            viewHint = ResMan.GetString( "EventLogList.ViewHint" ); 
            
            // Set filter labels
            lblEventType.Text = ResMan.GetString( "EventLogList.FilterEventType" ); 
            lblUserName.Text = ResMan.GetString( "EventLogList.FilterUserName" ); 
            lblNodeName.Text = ResMan.GetString( "EventLogList.FilterNodeName" ); 
            lblEventCode.Text = ResMan.GetString( "EventLogList.FilterEventCode" ); 
            
            // Set button labels
            btnClear.Text = ResMan.GetString( "EventLogList.Clear" ); 
            btnClear.Attributes.Add( "onclick", "return ConfirmDelete();" ); 
            btnFilter.Text = ResMan.GetString( "EventLogList.FilterButton" ); 
            
            // Confirmation question
            ltlConfirmScript.Text = @"<input type=""hidden"" id=""confirmationText"" value=""" + ResMan.GetString( "EventLogList.ConfirmDelete" ) + @""">"; 
            
            // Set column header names
            BasicDataGrid1.Columns[ 0 ].HeaderText = ResMan.GetString( "EventLogList.Action" ); 
            BasicDataGrid1.Columns[ 1 ].HeaderText = ResMan.GetString( "EventLogList.EventType" ); 
            BasicDataGrid1.Columns[ 2 ].HeaderText = ResMan.GetString( "EventLogList.EventTime" ); 
            BasicDataGrid1.Columns[ 3 ].HeaderText = ResMan.GetString( "EventLogList.Source" ); 
            BasicDataGrid1.Columns[ 4 ].HeaderText = ResMan.GetString( "EventLogList.EventCode" ); 
            BasicDataGrid1.Columns[ 5 ].HeaderText = ResMan.GetString( "EventLogList.UserName" ); 
            BasicDataGrid1.Columns[ 6 ].HeaderText = ResMan.GetString( "EventLogList.IPAddress" ); 
            lblHeader.Text = ResMan.GetString( "EventLogList.Header" ); 
            
            // Disable ViewState
            txtNodeName.EnableViewState = false; 
            txtUserName.EnableViewState = false; 
            
            if ( !( Page.IsPostBack ) ) { 
                // Assign event type options
                lstEventType.Items.Add( new ListItem( ResMan.GetString( "EventLogList.EventTypeAll" ), "" ) ); 
                lstEventType.Items.Add( new ListItem( ResMan.GetString( "EventLogList.EventTypeInformation" ), "I" ) ); 
                lstEventType.Items.Add( new ListItem( ResMan.GetString( "EventLogList.EventTypeError" ), "E" ) ); 
                lstEventType.Items.Add( new ListItem( ResMan.GetString( "EventLogList.EventTypeWarning" ), "W" ) ); 
            } 
        } 
        
        
        private void Page_PreRender( System.Object sender, System.EventArgs e ) { 
            // Get filter values
            string eventType = this.lstEventType.SelectedValue; //  CStr(ViewState("EventType")) & ""
            string nodeName = this.txtNodeName.Text; // CStr(ViewState("NodeName")) & ""
            string userName = this.txtUserName.Text; // CStr(ViewState("UserName")) & ""
            string eventCode = this.txtEventCode.Text; 
            
            // lstEventType.SelectedValue = eventType
            // txtNodeName.Text = nodeName
            // txtUserName.Text = userName
            
            // Build where condition
            string where = ""; 
            if ( eventType.Length == 1 && "IEW".IndexOf( eventType ) >= 0 ) { where += "EventType = '" + eventType + "'"; } 
            if ( !( nodeName == null ) && nodeName.Length > 0 ) { 
                if ( where.Length > 0 ) { where += " AND"; } 
                where += " NodeNamePath LIKE N'%" + nodeName.Replace( "'", "''" ) + "%' "; 
            } 
            if ( !( userName == null ) && userName.Length > 0 ) { 
                if ( where.Length > 0 ) { where += " AND"; } 
                where += " UserName LIKE N'%" + userName.Replace( "'", "''" ) + "%' "; 
            } 
            if ( !( eventCode == null ) && eventCode.Length > 0 ) { 
                if ( where.Length > 0 ) { where += " AND"; } 
                where += " EventCode LIKE N'%" + eventCode.Replace( "'", "''" ) + "%' "; 
            } 
            
            // Display events
            this.DisplayEventLog( where ); 
        } 
        
        
        ///<summary>Displays events in the list.</summary>
        ///<param name="where">Where condition.</param>
        private void DisplayEventLog( string where ) { 
            EventLogProvider eventLog = new EventLogProvider( Functions.GetTreeProvider().Connection ); 
            
            BasicDataGrid1.DataSource = eventLog.GetAllEvents( where, "" ); 
            BasicDataGrid1.DataBind(); 
        } 
        
        
        private void BasicDataGrid1_ItemDataBound( System.Object sender, DataGridItemEventArgs e ) { 
            if ( e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem ) { 
                string eventType = e.Item.Cells[ 1 ].Text; 
                
                if ( eventType == null ) { return; } 
                
                // Rewrite event type text.
                switch ( eventType.ToUpper() ) {
                    case "I":
                        e.Item.Cells[ 1 ].Text = ResMan.GetString( "EventLogList.EventTypeInformation" ); 
                        break;
                    case "E":
                        e.Item.Cells[ 1 ].Text = ResMan.GetString( "EventLogList.EventTypeError" ); 
                        break;
                    case "W":
                        e.Item.Cells[ 1 ].Text = ResMan.GetString( "EventLogList.EventTypeWarning" ); 
                        break;
                }
                
            } 
        } 
        
        
        private void btnClear_Click( System.Object sender, System.EventArgs e ) { 
            // Check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.Administration", "Delete" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.Administration", "Delete" ); 
                return; 
            } 
            
            EventLogProvider eventLog = new EventLogProvider( Functions.GetTreeProvider().Connection ); 
            
            // Clear event log
            eventLog.ClearEventLog( Functions.GetUserID(), System.Web.HttpContext.Current.User.Identity.Name, Request.UserHostAddress ); 
        } 
        
        
        private void btnFilter_Click( System.Object sender, System.EventArgs e ) { 
            // ViewState("EventType") = lstEventType.SelectedValue
            // ViewState("NodeName") = txtNodeName.Text
            // ViewState("UserName") = txtUserName.Text
            // ViewState("UserName") = txtUserName.Text
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
} 
