using Kentico.CMS.DataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class PermissionMatrix : System.Web.UI.Page { 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlMatrix; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlPageURL; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.Administration", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.Administration", "Read" ); 
                return; 
            } 
            
            if ( "" + Request.QueryString[ "id" ] + "" == "" ) { 
                // no matrix specified
                ltlMatrix.Text = ResMan.GetString( "PermissionMatrix.ChooseSome" ); 
            } 
            else { 
                if ( "" + Request.QueryString[ "action" ] + "" != "" ) { 
                    SetPermission( int.Parse( "" + Request.QueryString[ "action" ] ), int.Parse( "" + Request.QueryString[ "RoleID" ] ), int.Parse( "" + Request.QueryString[ "PermissionID" ] ) ); 
                } 
                ltlMatrix.Text = GetMatrix( "" + Request.QueryString[ "id" ] ); 
            } 
            
            ltlPageURL.Text = @"<input type=""hidden"" ID=""pageURL"" value=""" + Page.Request.Path + "?id=" + "" + Request.QueryString[ "id" ] + @""">"; 
        } 
        
        
        ///<summary>Returns HTML code of the permission matrix for specified class or resource.</summary>
        ///<param name="combinedID">String value consisting of the type ("c" for class, "r" for resource) and its ID.</param>
        private string GetMatrix( string combinedID ) { 
            GeneralConnection cn = new GeneralConnection(); 
            DataRow dr = null; 
            int lastRoleID = -1; 
            object[,] paramsIdent = new object[ 2, 3 ]; 
            string itemType = Strings.Left( combinedID, 1 ).ToLower(); 
            int itemID = 0; 
            DataSet ds = null; 
            string result = null; 
            
            // retrive permission matrix data
            itemID = int.Parse( Strings.Right( combinedID, Strings.Len( combinedID ) - 1 ) ); 
            paramsIdent[ 0, 0 ] = "@ID"; 
            paramsIdent[ 0, 1 ] = itemID; 
            paramsIdent[ 1, 0 ] = "@Type"; 
            paramsIdent[ 1, 1 ] = itemType; 
            cn.ConnectionString = Functions.GetConnectionString(); 
            ds = cn.ExecuteQuery( "CMS.Permission.GetPermissionMatrix", paramsIdent ); 
            // render the matrix
            if ( ds.Tables[ 0 ].Rows.Count == 0 ) { 
                result = ResMan.GetString( "PermissionMatrix.Empty" ); 
            } 
            else { 
                result = @"<table cellpadding=0 cellspacing=0 class=""PermissionMatrixTable""><tr><td class=""PermissionMatrixEmptyCell"">&nbsp;</td>"; 
                lastRoleID = System.Convert.ToInt32( ds.Tables[ 0 ].Rows[ 0 ][ "RoleID" ] ); 
                // render header
                foreach ( System.Data.DataRow transTemp0 in ds.Tables[ 0 ].Rows ) { 
                    dr = transTemp0;  
                    if ( lastRoleID != System.Convert.ToInt32( dr[ "RoleID" ] ) ) { 
                        result += "</tr>"; 
                        break;  
                    } 
                    else { 
                        result += @"<td class=""PermissionMatrixHeader"">" + System.Convert.ToString( dr[ "PermissionDisplayName" ] ) + "</td>"; 
                    } 
                }
                lastRoleID = -1; 
                // render matrix rows
                foreach ( System.Data.DataRow transTemp1 in ds.Tables[ 0 ].Rows ) { 
                    dr = transTemp1;  
                    if ( lastRoleID != System.Convert.ToInt32( dr[ "RoleID" ] ) ) { 
                        // new row - start with role name
                        result += @"</tr><tr><td class=""PermissionMatrixHeader"">" + System.Convert.ToString( dr[ "RoleDisplayName" ] ) + "</td>"; 
                        lastRoleID = System.Convert.ToInt32( dr[ "RoleID" ] ); 
                    } 
                    result += @"<td class=""PermissionMatrixCell"">"; 
                    if ( System.Convert.ToInt32( dr[ "Allowed" ] ) == 1 ) { 
                        result += @"<img src=""../../design/buttons/allowed.gif"" style=""cursor:hand"" onclick=""javascript:setPerm('" + System.Convert.ToInt32( dr[ "RoleID" ] ) + "', '" + System.Convert.ToInt32( dr[ "PermissionID" ] ) + @"', '0')"">"; 
                    } 
                    else { 
                        result += @"<img src=""../../design/buttons/denied.gif"" style=""cursor:hand"" onclick=""javascript:setPerm('" + System.Convert.ToInt32( dr[ "RoleID" ] ) + "', '" + System.Convert.ToInt32( dr[ "PermissionID" ] ) + @"', '1')"">"; 
                    } 
                    result += "</td>"; 
                }
                result += "</tr></table>"; 
            } 
            return result; 
        } 
        
        
        
        ///<summary>Sets or removes specified permission</summary>
        ///<param name="action">Indicates if the permission should be set (1) or removed (0).</param>
        ///<param name="roleID">Role ID.</param>
        ///<param name="permissionID">Permission ID.</param>
        private void SetPermission( int action, int roleID, int permissionID ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.Administration", "Modify" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.Administration", "Modify" ); 
                return; 
            } 
            
            GeneralConnection cn = new GeneralConnection(); 
            object[,] paramsIdent = new object[ 2, 3 ]; 
            cn.ConnectionString = Functions.GetConnectionString(); 
            
            paramsIdent[ 0, 0 ] = "@roleid"; 
            paramsIdent[ 0, 1 ] = roleID; 
            paramsIdent[ 1, 0 ] = "@permissionid"; 
            paramsIdent[ 1, 1 ] = permissionID; 
            if ( action == 1 ) { 
                // grant
                cn.ExecuteQuery( "CMS.Permission.AllowPermission", paramsIdent ); 
            } 
            else { 
                // remove
                cn.ExecuteQuery( "CMS.Permission.DenyPermission", paramsIdent ); 
            } 
            
            // log event
            string roleName = ""; 
            string permissionName = ""; 
            string resourceName = ""; 
            DataClass roleObj = new DataClass( "cms.role", roleID, cn ); 
            DataClass permissionNameObj = new DataClass( "cms.permission", permissionID, cn ); 
            DataClass resourceObj = null; 
            if ( !( ( roleObj.IsEmpty() | permissionNameObj.IsEmpty() ) ) ) { 
                roleName = System.Convert.ToString( roleObj.GetValue( "RoleDisplayName" ) ); 
                permissionName = System.Convert.ToString( permissionNameObj.GetValue( "PermissionName" ) ); 
                if ( permissionNameObj.GetValue( "ClassID" ) == null ) { 
                    // resource
                    resourceObj = new DataClass( "cms.resource", System.Convert.ToInt32( permissionNameObj.GetValue( "resourceid" ) ), cn ); 
                    if ( !( resourceObj.IsEmpty() ) ) { 
                        resourceName = System.Convert.ToString( resourceObj.GetValue( "ResourceName" ) ); 
                    } 
                } 
                else { 
                    // permission
                    resourceObj = new DataClass( "cms.class", System.Convert.ToInt32( permissionNameObj.GetValue( "classid" ) ), cn ); 
                    if ( !( resourceObj.IsEmpty() ) ) { 
                        resourceName = System.Convert.ToString( resourceObj.GetValue( "ClassName" ) ); 
                    } 
                } 
                if ( action == 1 ) { 
                    // grant
                    Functions.LogEvent( "I", "CMS-Administration", "GRANTGLOBALPERMISSION", 0, "", roleName + "," + permissionName + "," + resourceName ); 
                } 
                else { 
                    // remove
                    Functions.LogEvent( "I", "CMS-Administration", "REMOVEGLOBALPERMISSION", 0, "", roleName + "," + permissionName + "," + resourceName ); 
                } 
            } 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
