using Kentico.CMS.DataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class EditRole : System.Web.UI.Page { 
        
        protected int RoleID; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by btnOK_Click
             
            btnOK.Click += new System.EventHandler( btnOK_Click ); 
            // events handled by btnCancel_Click
             
            btnCancel.Click += new System.EventHandler( btnCancel_Click ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblInfo; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblError; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblRoleID; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblRoleIDValue; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblRoleDisplayName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtRoleDisplayName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblRoleName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtRoleName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnOK; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnCancel; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            GeneralConnection cn = null; 
            DataClass roleObj = null; 
            
            if ( "" + Request.QueryString[ "id" ] + "" != "" ) { 
                // check permissions
                if ( !( Functions.IsAuthorizedPerResource( "CMS.Administration", "Modify" ) ) ) { 
                    Functions.RedirectToAccessDenied( "CMS.Administration", "Modify" ); 
                    return; 
                } 
                RoleID = int.Parse( "" + Request.QueryString[ "id" ] ); 
            } 
            else { 
                // check permissions
                if ( !( Functions.IsAuthorizedPerResource( "CMS.Administration", "Create" ) ) ) { 
                    Functions.RedirectToAccessDenied( "CMS.Administration", "Create" ); 
                    return; 
                } 
                RoleID = 0; 
            } 
            lblError.Text = ""; 
            lblError.Visible = false; 
            lblInfo.Text = ""; 
            lblInfo.Visible = false; 
            lblHeader.Text = ResMan.GetString( "EditRole.Header" ); 
            lblRoleID.Text = ResMan.GetString( "EditRole.RoleID" ); 
            lblRoleName.Text = ResMan.GetString( "EditRole.RoleName" ); 
            lblRoleDisplayName.Text = ResMan.GetString( "EditRole.RoleDisplayName" ); 
            btnOK.Text = ResMan.GetString( "EditRole.OK" ); 
            btnCancel.Text = ResMan.GetString( "EditRole.Cancel" ); 
            
            // set values
            if ( !( Page.IsPostBack ) & RoleID != 0 ) { 
                cn = new GeneralConnection( Functions.GetConnectionString() ); 
                roleObj = new DataClass( "CMS.Role", RoleID, cn ); 
                txtRoleName.Text = System.Convert.ToString( roleObj.GetValue( "RoleName" ) ); 
                txtRoleDisplayName.Text = System.Convert.ToString( roleObj.GetValue( "RoleDisplayName" ) ); 
                lblRoleIDValue.Text = System.Convert.ToString( roleObj.GetValue( "RoleID" ) ); 
            } 
            else { 
                lblRoleIDValue.Text = ResMan.GetString( "EditRole.NoRoleIDValue" ); 
            } 
        } 
        
        
        
        private void btnOK_Click( System.Object sender, System.EventArgs e ) { 
            // validate input
            string errorMessage = ""; 
            GeneralConnection cn = null; 
            string[,] paramsIdent = new string[ 1, 3 ]; 
            DataRow roleDR = null; 
            DataSet roleNamesDS = null; 
            string infoMessage = null; 
            DataClass roleObj = null; 
            
            if ( txtRoleName.Text.Trim() + "" == "" ) { 
                errorMessage += ResMan.GetString( "EditRole.ErrorEmptyRoleName" ) + " "; 
            } 
            if ( txtRoleDisplayName.Text.Trim() + "" == "" ) { 
                errorMessage += ResMan.GetString( "EditRole.ErrorEmptyRoleDisplayName" ) + " "; 
            } 
            
            if ( errorMessage + "" == "" ) { 
                // check for existing role
                paramsIdent[ 0, 0 ] = "@RoleName"; 
                paramsIdent[ 0, 1 ] = txtRoleName.Text.Trim(); 
                cn = new GeneralConnection( Functions.GetConnectionString() ); 
                cn.DataConnection.Open(); 
                
                roleNamesDS = cn.ExecuteQuery( "CMS.Role.SelectByRoleName", paramsIdent ); 
                if ( RoleID == 0 ) { 
                    if ( roleNamesDS.Tables[ 0 ].Rows.Count > 0 ) { 
                        // role name already exists
                        errorMessage += ResMan.GetString( "EditRole.ErrorExistingRoleName" ) + " "; 
                    } 
                } 
                else { 
                    foreach ( System.Data.DataRow transTemp0 in roleNamesDS.Tables[ 0 ].Rows ) { 
                        roleDR = transTemp0;  
                        if ( System.Convert.ToInt32( roleDR[ "RoleID" ] ) != RoleID ) { 
                            // role name already exists
                            errorMessage += ResMan.GetString( "EditRole.ErrorExistingRoleName" ) + " "; 
                        } 
                    }
                } 
                
                if ( errorMessage + "" == "" ) { 
                    // save role info
                    if ( RoleID == 0 ) { 
                        // insert a new role
                        roleObj = new DataClass( "CMS.Role", cn ); 
                        roleObj.SetValue( "RoleName", txtRoleName.Text ); 
                        roleObj.SetValue( "RoleDisplayName", txtRoleDisplayName.Text ); 
                        roleObj.Insert(); 
                        Functions.LogEvent( "I", "CMS-Administration", "INSERTROLE", 0, "", this.txtRoleDisplayName.Text ); 
                        txtRoleName.Text = ""; 
                        txtRoleDisplayName.Text = ""; 
                        infoMessage = ResMan.GetString( "EditRole.ChangesInserted" ); 
                    } 
                    else { 
                        // update an existing user
                        roleObj = new DataClass( "CMS.Role", RoleID, cn ); 
                        roleObj.SetValue( "RoleName", txtRoleName.Text ); 
                        roleObj.SetValue( "RoleDisplayName", txtRoleDisplayName.Text ); 
                        roleObj.Update(); 
                        Functions.LogEvent( "I", "CMS-Administration", "UPDATEROLE", 0, "", this.txtRoleDisplayName.Text ); 
                        infoMessage = ResMan.GetString( "EditRole.ChangesSaved" ); 
                    } 
                } 
                cn.DataConnection.Close(); 
            } 
            
            if ( errorMessage + "" != "" ) { 
                lblError.Text = errorMessage; 
                lblError.Visible = true; 
            } 
            if ( infoMessage + "" != "" ) { 
                lblInfo.Text = infoMessage; 
                lblInfo.Visible = true; 
            } 
        } 
        
        
        
        private void btnCancel_Click( System.Object sender, System.EventArgs e ) { 
            ltlScript.Text = @"<script language=""javascript"">"; 
            ltlScript.Text += " GoBack(); "; 
            ltlScript.Text += "</script>"; 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
