using Kentico.CMS.DataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class EditRoleUsers : System.Web.UI.Page { 
        
        protected int RoleID; 
        protected string deleteHint; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by dtg_ItemDataBound
             
            Querydatagrid1.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler( dtg_ItemDataBound ); 
            // events handled by btnOK_Click
             
            btnOK.Click += new System.EventHandler( btnOK_Click ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblUsersHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlButtonAddUser; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.ImageButton btnDelete; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlConfirmScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ Kentico.CMS.CMSControls.QueryDataGrid Querydatagrid1; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnOK; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.Administration", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.Administration", "Read" ); 
                return; 
            } 
            
            RoleID = int.Parse( "" + Request.QueryString[ "id" ] ); 
            lblHeader.Text = ResMan.GetString( "EditRoleUsers.Header" ); 
            Querydatagrid1.Columns[ 0 ].HeaderText = ResMan.GetString( "EditRoleUsers.Delete" ); 
            Querydatagrid1.Columns[ 1 ].HeaderText = ResMan.GetString( "EditRoleUsers.Username" ); 
            Querydatagrid1.Columns[ 2 ].HeaderText = ResMan.GetString( "EditRoleUsers.Fullname" ); 
            Querydatagrid1.Columns[ 3 ].HeaderText = ResMan.GetString( "EditRoleUsers.Email" ); 
            btnOK.Text = ResMan.GetString( "EditRoleUsers.OK" ); 
            deleteHint = ResMan.GetString( "EditRoleUsers.DeleteHint" ); 
            ltlButtonAddUser.Text = @"<input type=""button"" value=""" + ResMan.GetString( "EditRoleUsers.AddUser" ) + @""" class=""FormButton"" onclick=""javascript:AddUser('" + RoleID + @"');"">"; 
            // confirmation question
            ltlConfirmScript.Text = @"<input type=""hidden"" id=""confirmationText"" value=""" + ResMan.GetString( "EditRoleUsers.ConfirmDelete" ) + @""">"; 
            
            DisplayUsers(); 
            if ( !( Page.IsPostBack ) ) { 
                // display user name in the header
                DataClass roleObj = new DataClass( "cms.role", RoleID, Functions.GetTreeProvider().Connection ); 
                string roleName = ""; 
                if ( !( roleObj.IsEmpty() ) ) { 
                    roleName = "<b>" + System.Convert.ToString( roleObj.GetValue( "RoleDisplayName" ) ) + "</b>"; 
                } 
                lblUsersHeader.Text = Strings.Replace( ResMan.GetString( "EditRoleUsers.Description" ), "{%rolename%}", roleName, 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ); 
            } 
        } 
        
        
        
        public void DeleteItem( object sender, System.Web.UI.WebControls.DataGridCommandEventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.Administration", "Modify" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.Administration", "Modify" ); 
                return; 
            } 
            
            // remove user from the selected role
            int id = int.Parse( System.Convert.ToString( e.CommandArgument ) ); 
            GeneralConnection cn = new GeneralConnection(); 
            string[,] paramsIdent = new string[ 2, 3 ]; 
            
            paramsIdent[ 0, 0 ] = "@RoleID"; 
            paramsIdent[ 0, 1 ] = RoleID.ToString(); 
            paramsIdent[ 1, 0 ] = "@UserID"; 
            paramsIdent[ 1, 1 ] = id.ToString(); 
            cn.ConnectionString = Functions.GetConnectionString(); 
            cn.ExecuteQuery( "CMS.User.RemoveFromRole", paramsIdent ); 
            
            // log event
            string removedUserName = ""; 
            DataClass removedUserObj = new DataClass( "cms.user", id, cn ); 
            if ( !( removedUserObj.IsEmpty() ) ) { 
                removedUserName = System.Convert.ToString( removedUserObj.GetValue( "username" ) ); 
            } 
            string removedRoleName = ""; 
            DataClass removedRoleObj = new DataClass( "cms.role", RoleID, cn ); 
            if ( !( removedRoleObj.IsEmpty() ) ) { 
                removedRoleName = System.Convert.ToString( removedRoleObj.GetValue( "rolename" ) ); 
            } 
            Functions.LogEvent( "I", "CMS-Administration", "REMOVEUSERFROMROLE", 0, "", removedUserName + "," + removedRoleName ); 
            Response.Redirect( Page.Request.Url.ToString() ); 
        } 
        
        
        
        ///<summary>Displays roles the user is member of in the grid.</summary>
        private void DisplayUsers() { 
            GeneralConnection cn = new GeneralConnection(); 
            cn.ConnectionString = Functions.GetConnectionString(); 
            Querydatagrid1.GeneralConnection = cn; 
            Querydatagrid1.QueryName = "CMS.Role.GetUsers"; 
            Querydatagrid1.WhereCondition = " RoleID = '" + RoleID + "' "; 
        } 
        
        
        
        private void dtg_ItemDataBound( System.Object sender, System.Web.UI.WebControls.DataGridItemEventArgs e ) { 
            ImageButton btnCurrentButton = null; 
            
            // set up the Delete button
            if ( e.Item.ItemType == ListItemType.Item | e.Item.ItemType == ListItemType.AlternatingItem ) { 
                btnCurrentButton = ( ( ImageButton )( e.Item.Cells[ 0 ].FindControl( "btnDelete" ) ) ); 
                btnCurrentButton.Attributes.Add( "OnClick", "return ConfirmDelete();" ); 
                btnCurrentButton.Attributes.Add( "title", deleteHint ); 
            } 
        } 
        
        
        
        private void btnOK_Click( System.Object sender, System.EventArgs e ) { 
            GoBack(); 
        } 
        
        
        
        private void btnCancel_Click( System.Object sender, System.EventArgs e ) { 
            GoBack(); 
        } 
        
        
        
        ///<summary>Returns user to the list of users.</summary>
        private void GoBack() { 
            ltlScript.Text = @"<script language=""javascript"">"; 
            ltlScript.Text += " GoBack(); "; 
            ltlScript.Text += "</script>"; 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
