using Kentico.CMS.DataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class RoleList : System.Web.UI.Page { 
        
        protected string editHint; 
        protected string deleteHint; 
        protected string usersHint; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by dtg_ItemDataBound
             
            QueryDataGrid1.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler( dtg_ItemDataBound ); 
        } 
        
        
        protected /* TRANSINFO: WithEvents */ Kentico.CMS.CMSControls.QueryDataGrid QueryDataGrid1; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlConfirmScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.Administration", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.Administration", "Read" ); 
                return; 
            } 
            editHint = ResMan.GetString( "RoleList.EditHint" ); 
            deleteHint = ResMan.GetString( "RoleList.DeleteHint" ); 
            usersHint = ResMan.GetString( "RoleList.UsersHint" ); 
            // set column header names
            QueryDataGrid1.Columns[ 0 ].HeaderText = ResMan.GetString( "RoleList.Action" ); 
            QueryDataGrid1.Columns[ 1 ].HeaderText = ResMan.GetString( "RoleList.RoleDisplayName" ); 
            QueryDataGrid1.Columns[ 2 ].HeaderText = ResMan.GetString( "RoleList.RoleName" ); 
            // confirmation question
            ltlConfirmScript.Text = @"<input type=""hidden"" id=""confirmationText"" value=""" + ResMan.GetString( "RoleList.ConfirmDelete" ) + @""">"; 
            lblHeader.Text = ResMan.GetString( "RoleList.Header" ); 
            
            DisplayRoles(); 
        } 
        
        
        
        public void DeleteItem( object sender, System.Web.UI.WebControls.DataGridCommandEventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.Administration", "Delete" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.Administration", "Delete" ); 
                return; 
            } 
            
            // delete the selected item
            int id = int.Parse( System.Convert.ToString( e.CommandArgument ) ); 
            GeneralConnection cn = new GeneralConnection(); 
            cn.ConnectionString = Functions.GetConnectionString(); 
            DataClass roleObj = new DataClass( "cms.role", id, cn ); 
            string deletedRoleName = null; 
            if ( !( roleObj.IsEmpty() ) ) { 
                deletedRoleName = System.Convert.ToString( roleObj.GetValue( "roledisplayname" ) ); 
                roleObj.Delete(); 
                Functions.LogEvent( "I", "CMS-Administration", "DELETEROLE", 0, "", deletedRoleName ); 
            } 
            Response.Redirect( Page.Request.Url.ToString() ); 
        } 
        
        
        
        ///<summary>Displays roles in the grid.</summary>
        private void DisplayRoles() { 
            GeneralConnection cn = new GeneralConnection(); 
            cn.ConnectionString = Functions.GetConnectionString(); 
            QueryDataGrid1.GeneralConnection = cn; 
            QueryDataGrid1.QueryName = "CMS.Role.SelectList"; 
        } 
        
        
        
        private void dtg_ItemDataBound( System.Object sender, DataGridItemEventArgs e ) { 
            ImageButton btnCurrentButton = null; 
            
            // set up the Delete button
            if ( e.Item.ItemType == ListItemType.Item | e.Item.ItemType == ListItemType.AlternatingItem ) { 
                btnCurrentButton = ( ( ImageButton )( e.Item.Cells[ 0 ].FindControl( "btnDelete" ) ) ); 
                btnCurrentButton.Attributes.Add( "OnClick", "return ConfirmDelete();" ); 
                btnCurrentButton.Attributes.Add( "title", deleteHint ); 
            } 
        } 
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
