using Kentico.CMS.DataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class AddRole : System.Web.UI.Page { 
        
        protected int UserID; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
            /* TRANSWARNING: check EventHandler assignment */ 
            base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
            /* TRANSWARNING: check EventHandler assignment */ 
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by btnSearch_Click
            /* TRANSWARNING: check EventHandler assignment */ 
            btnSearch.Click += new System.EventHandler( btnSearch_Click ); 
            // events handled by btnOK_Click
            /* TRANSWARNING: check EventHandler assignment */ 
            btnOK.Click += new System.EventHandler( btnOK_Click ); 
            // events handled by btnCancel_Click
            /* TRANSWARNING: check EventHandler assignment */ 
            btnCancel.Click += new System.EventHandler( btnCancel_Click ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtSearch; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnSearch; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.ListBox lstItems; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnOK; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnCancel; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.Administration", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.Administration", "Read" ); 
                return; 
            } 
            
            UserID = int.Parse( Request.QueryString[ "userid" ] ); 
            lblHeader.Text = ResMan.GetString( "AddRole.Header" ); 
            btnSearch.Text = ResMan.GetString( "AddRole.SearchButton" ); 
            btnOK.Text = ResMan.GetString( "AddRole.OK" ); 
            btnCancel.Text = ResMan.GetString( "AddRole.Cancel" ); 
        } 
        
        
        
        private void btnSearch_Click( System.Object sender, System.EventArgs e ) { 
            GeneralConnection cn = new GeneralConnection(); 
            DataSet ds = null; 
            
            // find all roles whose name contains specified string
            cn.ConnectionString = Functions.GetConnectionString(); 
            ds = cn.ExecuteQuery( "CMS.Role.SelectList", null, " RoleDisplayName LIKE N'%" + txtSearch.Text.Replace( "'", "''" ) + "%' ", "RoleDisplayName" ); 
            lstItems.DataSource = ds.Tables[ 0 ]; 
            lstItems.DataTextField = "RoleDisplayName"; 
            lstItems.DataValueField = "RoleID"; 
            lstItems.DataBind(); 
        } 
        
        
        
        private void btnOK_Click( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.Administration", "Modify" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.Administration", "Modify" ); 
                return; 
            } 
            
            ListItem item = null; 
            GeneralConnection cn = new GeneralConnection(); 
            object[,] paramsIdent = new object[ 2, 3 ]; 
            
            paramsIdent[ 0, 0 ] = "@UserID"; 
            paramsIdent[ 0, 1 ] = UserID; 
            cn.ConnectionString = Functions.GetConnectionString(); 
            cn.DataConnection.Open(); 
            // get IDs of the selected roles and save changes
            foreach ( System.Web.UI.WebControls.ListItem transTemp0 in lstItems.Items ) { 
                item = transTemp0; /* TRANSWARNING: check temp variable in foreach */ 
                if ( item.Selected ) { 
                    paramsIdent[ 1, 0 ] = "@RoleID"; 
                    paramsIdent[ 1, 1 ] = item.Value; 
                    cn.ExecuteQuery( "CMS.User.AddToRole", paramsIdent ); 
                    string addedUserName = ""; 
                    DataClass addedUserObj = new DataClass( "cms.user", UserID, cn ); 
                    if ( !( addedUserObj.IsEmpty() ) ) { 
                        addedUserName = System.Convert.ToString( addedUserObj.GetValue( "username" ) ); 
                    } 
                    Functions.LogEvent( "I", "CMS-Administration", "ADDUSERTOROLE", 0, "", addedUserName + "," + item.Text ); 
                } 
            }
            cn.DataConnection.Close(); 
            CloseWindow(); 
        } 
        
        
        
        private void btnCancel_Click( System.Object sender, System.EventArgs e ) { 
            CloseWindow(); 
        } 
        
        
        
        // ''<summary>Generates script that closes the window and refreshes the parent page.</summary>
        private void CloseWindow() { 
            ltlScript.Text = @"<script language=""javascript"">"; 
            ltlScript.Text += " CloseAndRefresh(); "; 
            ltlScript.Text += "</script>"; 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
