using Kentico.CMS.DataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class UserList : System.Web.UI.Page { 
        
        protected string editHint; 
        protected string rolesHint; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnSearch; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtFilter; 
        protected string deleteHint; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by dtg_ItemDataBound
             
            QueryDataGrid1.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler( dtg_ItemDataBound ); 
        } 
        
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ Kentico.CMS.CMSControls.QueryDataGrid QueryDataGrid1; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlConfirmScript; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.Administration", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.Administration", "Read" ); 
                return; 
            } 
            editHint = ResMan.GetString( "UserList.EditHint" ); 
            rolesHint = ResMan.GetString( "UserList.RolesHint" ); 
            deleteHint = ResMan.GetString( "UserList.DeleteHint" ); 
            // set column header names
            QueryDataGrid1.Columns[ 0 ].HeaderText = ResMan.GetString( "UserList.Action" ); 
            QueryDataGrid1.Columns[ 1 ].HeaderText = ResMan.GetString( "UserList.UserName" ); 
            QueryDataGrid1.Columns[ 2 ].HeaderText = ResMan.GetString( "UserList.FullName" ); 
            QueryDataGrid1.Columns[ 3 ].HeaderText = ResMan.GetString( "UserList.Email" ); 
            // confirmation question
            ltlConfirmScript.Text = @"<input type=""hidden"" id=""confirmationText"" value=""" + ResMan.GetString( "UserList.ConfirmDelete" ) + @""">"; 
            lblHeader.Text = ResMan.GetString( "UserList.Header" ); 
            btnSearch.Text = ResMan.GetString( "UserList.Search" ); 
            
            if ( this.IsPostBack ) { 
                string filter = this.txtFilter.Text; 
                if ( !( filter == null ) && filter + "" != "" ) { 
                    string where = "UserName LIKE '%" + filter + "%' OR FirstName LIKE '%" + filter + "%' OR MiddleName LIKE '%" + filter + "%' OR LastName LIKE '%" + filter + "%' OR FullName LIKE '%" + filter + "%' OR Email LIKE '%" + filter + "%' "; 
                    this.QueryDataGrid1.WhereCondition = where; 
                } 
            } 
            DisplayUsers(); 
        } 
        
        
        
        public void DeleteItem( object sender, System.Web.UI.WebControls.DataGridCommandEventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.Administration", "Delete" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.Administration", "Delete" ); 
                return; 
            } 
            
            // delete user
            int id = int.Parse( System.Convert.ToString( e.CommandArgument ) ); 
            GeneralConnection cn = new GeneralConnection(); 
            DataClass userObj = null; 
            string deletedUserName = ""; 
            
            cn.ConnectionString = Functions.GetConnectionString(); 
            userObj = new DataClass( "cms.user", id, cn ); 
            if ( !( userObj.IsEmpty() ) ) { 
                deletedUserName = System.Convert.ToString( userObj.GetValue( "username" ) ); 
                userObj.Delete(); 
                Functions.LogEvent( "I", "CMS-Administration", "DELETEUSER", 0, "", deletedUserName ); 
            } 
            Response.Redirect( Page.Request.Url.ToString() ); 
        } 
        
        
        
        ///<summary>Displays users in the list.</summary>
        private void DisplayUsers() { 
            GeneralConnection cn = new GeneralConnection(); 
            cn.ConnectionString = Functions.GetConnectionString(); 
            QueryDataGrid1.GeneralConnection = cn; 
            QueryDataGrid1.QueryName = "CMS.User.SelectList"; 
        } 
        
        
        
        private void dtg_ItemDataBound( System.Object sender, DataGridItemEventArgs e ) { 
            ImageButton btnCurrentButton = null; 
            
            // set up the Delete button
            if ( e.Item.ItemType == ListItemType.Item | e.Item.ItemType == ListItemType.AlternatingItem ) { 
                btnCurrentButton = ( ( ImageButton )( e.Item.Cells[ 0 ].FindControl( "btnDelete" ) ) ); 
                btnCurrentButton.Attributes.Add( "OnClick", "return ConfirmDelete();" ); 
                btnCurrentButton.Attributes.Add( "title", deleteHint ); 
            } 
        } 
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
