using Kentico.CMS.TreeEngine; 
using System.IO; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class Attachments : System.Web.UI.Page { 
        
        protected string aliasPath; 
        protected string imgPath; 
        protected string idpath; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlConfirmScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnSave; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.HtmlControls.HtmlInputFile upload; 
        protected string folderDiskPath; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Panel pnlFiles; 
        protected TreeProvider tree; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by dtg_ItemDataBound
             
            CMSDataGrid1.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler( dtg_ItemDataBound ); 
            // events handled by CMSDataGrid1_Delete
             
            CMSDataGrid1.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler( CMSDataGrid1_Delete ); 
            // events handled by CMSDataGrid1_Edit
             
            CMSDataGrid1.EditCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler( CMSDataGrid1_Edit ); 
            // events handled by CMSDataGrid1_Update
             
            CMSDataGrid1.UpdateCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler( CMSDataGrid1_Update ); 
            // events handled by CMSDataGrid1_Cancel
             
            CMSDataGrid1.CancelCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler( CMSDataGrid1_Cancel ); 
            // events handled by btnSave_Click
             
            btnSave.Click += new System.EventHandler( btnSave_Click ); 
            // events handled by cmsdatagrid1_binditem
             
            CMSDataGrid1.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler( cmsdatagrid1_binditem ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblInfo; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblError; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblUpload; 
        protected /* TRANSINFO: WithEvents */ Kentico.CMS.CMSControls.CMSDataGrid CMSDataGrid1; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // check if the document has already been saved
            this.lblHeader.Text = ResMan.GetString( "Attachments.Header" ); 
            if ( "" + Request.QueryString[ "mode" ] == "insert" ) { 
                pnlFiles.Visible = false; 
                this.lblError.Text = ResMan.GetString( "Attachments.SaveDocumentFirst" ); 
                return; 
            } 
            idpath = "" + Request.QueryString[ "idpath" ]; 
            if ( !( ( Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read ) | Functions.IsAuthorizedPerResource( "CMS.Content", "Read" ) ) ) ) { 
                Functions.RedirectToAccessDenied( idpath, "Read attachment (attachments.aspx)" ); 
                return; 
            } 
            
            if ( idpath.EndsWith( "/" ) ) { 
                this.CMSDataGrid1.SelectNodesPath = idpath + "%"; 
            } 
            else { 
                this.CMSDataGrid1.SelectNodesPath = idpath + "/%"; 
            } 
            
            this.CMSDataGrid1.Columns[ 0 ].HeaderText = ResMan.GetString( "Attachments.GridPreview" ); 
            this.CMSDataGrid1.Columns[ 1 ].HeaderText = ResMan.GetString( "Attachments.GridSelect" ); 
            this.CMSDataGrid1.Columns[ 2 ].HeaderText = ResMan.GetString( "Attachments.Delete" ); 
            // CType(Me.CMSDataGrid1.Columns(3), ButtonColumn).Text = ResMan.GetString("Attachments.Delete")
            this.btnSave.Text = ResMan.GetString( "Attachments.btnSave" ); 
            ltlConfirmScript.Text = @"<input type=""hidden"" id=""confirmationText"" value=""" + ResMan.GetString( "Attachments.ConfirmDelete" ) + @""">"; 
            this.lblUpload.Text = ResMan.GetString( "Attachments.Upload" ); 
            this.lblError.Text = ""; 
            
            tree = Functions.GetTreeProvider(); 
            TreeNode node = tree.SelectSingleNode( idpath, TreePathTypeEnum.IDPath ); 
            aliasPath = Functions.RemoveCultureFromAliasPath( System.Convert.ToString( node.GetValue( "aliaspath" ) ) ); 
            folderDiskPath = Functions.GetFileFolderPath( System.Convert.ToString( node.GetValue( "aliaspath" ) ) + "/temp" ); 
            if ( Functions.GetConfigValue( "CMSWebApplicationVirtualPath" ) + "" != "" ) { 
                imgPath = Functions.GetConfigValue( "CMSWebApplicationVirtualPath" ); 
                if ( imgPath.EndsWith( "/" ) ) { 
                    imgPath = imgPath.Substring( 0, imgPath.Length - 1 ); 
                } 
                imgPath = imgPath + aliasPath; 
            } 
            else { 
                imgPath = ResolveUrl( "~" + aliasPath ); 
            } 
            if ( !( imgPath.EndsWith( "/" ) ) ) { 
                imgPath += "/"; 
            } 
            
        } 
        
        
        private void dtg_ItemDataBound( System.Object sender, DataGridItemEventArgs e ) { 
            // Dim btnCurrentButton As ImageButton
            
            // 'set up the Delete button
            // If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            //     btnCurrentButton = CType(e.Item.Cells(0).FindControl("btnDelete"), ImageButton)
            //     btnCurrentButton.Attributes.Add("OnClick", "return ConfirmDelete();")
            //     btnCurrentButton.Attributes.Add("title", deleteHint)
            //     btnCurrentButton = CType(e.Item.Cells(0).FindControl("btnEdit"), ImageButton)
            //     btnCurrentButton.Attributes.Add("title", editHint)
            // End If
        } 
        
        
        
        public void CMSDataGrid1_Delete( object sender, System.Web.UI.WebControls.DataGridCommandEventArgs e ) { 
            if ( e.CommandName != "Delete" ) { 
                return; 
            } 
            
            // check permissions
            if ( !( ( Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Delete ) | Functions.IsAuthorizedPerResource( "CMS.Content", "Delete" ) ) ) ) { 
                Functions.RedirectToAccessDenied( idpath, "Delete attachment (attachments.aspx)" ); 
                return; 
            } 
            
            TableCell itemCell = e.Item.Cells[ 3 ]; 
            string delIdPath = itemCell.Text; 
            TreeNode delFile = tree.SelectSingleNode( delIdPath, TreePathTypeEnum.IDPath, "cms.file" ); 
            string delFileName = System.Convert.ToString( delFile.GetValue( "FileName" ) ); 
            string filePath = folderDiskPath + @"\" + delFileName; 
            
            // check if it's not used in the article
            string publishedText = ""; 
            string lastVersionText = ""; 
            TreeNode articleNode = tree.SelectSingleNode( idpath, TreePathTypeEnum.IDPath ); 
            publishedText = System.Convert.ToString( articleNode.GetValue( "ArticleText" ) ).ToLower(); 
            if ( !( articleNode.GetValue( "CheckedOutVersionHistoryID" ) == null ) ) { 
                VersionManager verMan = new VersionManager( tree ); 
                articleNode = verMan.GetVersion( System.Convert.ToInt32( articleNode.GetValue( "CheckedOutVersionHistoryID" ) ) ); 
                lastVersionText = System.Convert.ToString( articleNode.GetValue( "ArticleText" ) ).ToLower(); 
            } 
            if ( Strings.InStr( publishedText, delFileName.ToLower(), (Microsoft.VisualBasic.CompareMethod)(0) ) > 0 | Strings.InStr( lastVersionText, delFileName.ToLower(), (Microsoft.VisualBasic.CompareMethod)(0) ) > 0 | Strings.InStr( publishedText, delFileName.ToLower().Replace( " ", "%20" ), (Microsoft.VisualBasic.CompareMethod)(0) ) > 0 | Strings.InStr( lastVersionText, delFileName.ToLower().Replace( " ", "%20" ), (Microsoft.VisualBasic.CompareMethod)(0) ) > 0 ) { 
                this.lblError.Text = ResMan.GetString( "Attachments.ErrorAttachmentUsed" ); 
                return; 
            } 
            
            // delete file
            if ( File.Exists( filePath ) ) { 
                File.Delete( filePath ); 
            } 
            delFile.Delete(); 
            UpdateArticle( 0 ); 
        } 
        
        
        
        public void CMSDataGrid1_Edit( object sender, System.Web.UI.WebControls.DataGridCommandEventArgs e ) { 
            // check permissions
            if ( !( ( Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Modify ) | Functions.IsAuthorizedPerResource( "CMS.Content", "Modify" ) ) ) ) { 
                Functions.RedirectToAccessDenied( idpath, "Modify attachment (attachments.aspx)" ); 
                return; 
            } 
            
            CMSDataGrid1.EditItemIndex = e.Item.ItemIndex; 
            ViewState[ "selectedIdPath" ] = e.Item.Cells[ 3 ].Text; 
        } 
        
        
        private void CMSDataGrid1_Update( System.Object source, System.Web.UI.WebControls.DataGridCommandEventArgs e ) { 
            TextBox editBox = ( ( TextBox )( e.Item.FindControl( "txtFileName" ) ) ); 
            Label extensionLabel = ( ( Label )( e.Item.FindControl( "lblFileExtension" ) ) ); 
            string oldFileName = null; 
            TreeNode oldFileNode = tree.SelectSingleNode( System.Convert.ToString( ViewState[ "selectedIdPath" ] ).Trim(), TreePathTypeEnum.IDPath, "cms.file" ); 
            oldFileName = System.Convert.ToString( oldFileNode.GetValue( "FileName" ) ); 
            if ( editBox == null ) { 
                return; 
            } 
            // check entered file name
            if ( editBox.Text.Trim() + "" == "" ) { 
                this.lblError.Text = ResMan.GetString( "Attachments.ErrorEmptyFileName" ); 
                return; 
            } 
            // check duplicit file names
            string newFileName = editBox.Text.Trim() + extensionLabel.Text.Trim(); 
            string newFilePath = folderDiskPath + @"\" + newFileName; 
            if ( File.Exists( newFilePath ) ) { 
                this.lblError.Text = ResMan.GetString( "Attachments.ErrorFileAlreadyExists" ); 
                return; 
            } 
            // rename file
            File.Move( folderDiskPath + @"\" + oldFileName, folderDiskPath + @"\" + newFileName ); 
            oldFileNode.SetValue( "FileName", newFileName ); 
            oldFileNode.Update(); 
            CMSDataGrid1.EditItemIndex = -1; 
        } 
        
        
        private void CMSDataGrid1_Cancel( System.Object source, System.Web.UI.WebControls.DataGridCommandEventArgs e ) { 
            CMSDataGrid1.EditItemIndex = -1; 
        } 
        
        
        private void btnSave_Click( System.Object sender, System.EventArgs e ) { 
            // check permissions for editing
            if ( !( ( Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Create ) | Functions.IsAuthorizedPerResource( "CMS.Content", "Create" ) ) ) ) { 
                Functions.RedirectToAccessDenied( idpath, "Create attachment (attachments.aspx)" ); 
                return; 
            } 
            
            // save file
            if ( !( upload.PostedFile == null ) && upload.PostedFile.FileName.Trim() + "" != "" ) { 
                byte[] mFileBinary = null; 
                string currentFileName = null; 
                currentFileName = upload.PostedFile.FileName.Split( '\\' )[ upload.PostedFile.FileName.Split( '\\' ).GetUpperBound( 0 ) ].Trim(); 
                // get last ID
                TreeNode articleNode = tree.SelectSingleNode( idpath, TreePathTypeEnum.IDPath ); 
                if ( !( articleNode.GetValue( "CheckedOutVersionHistoryID" ) == null ) ) { 
                    VersionManager verMan = new VersionManager( tree ); 
                    articleNode = verMan.GetVersion( System.Convert.ToInt32( articleNode.GetValue( "CheckedOutVersionHistoryID" ) ) ); 
                } 
                int lastAttachmentID = 0; 
                if ( articleNode.GetValue( "LastAttachmentID" ) == null ) { 
                    lastAttachmentID = 0; 
                } 
                else { 
                    lastAttachmentID = System.Convert.ToInt32( articleNode.GetValue( "LastAttachmentID" ) ); 
                } 
                lastAttachmentID += 1; 
                UpdateArticle( lastAttachmentID ); 
                currentFileName = System.IO.Path.GetFileNameWithoutExtension( currentFileName ) + "-" + Strings.Right( "0000" + lastAttachmentID.ToString(), 4 ) + System.IO.Path.GetExtension( currentFileName ); 
                string savePath = null; 
                if ( folderDiskPath.EndsWith( @"\" ) ) { 
                    savePath = folderDiskPath + currentFileName; 
                } 
                else { 
                    savePath = folderDiskPath + @"\" + currentFileName; 
                } 
                string extension = System.IO.Path.GetExtension( upload.PostedFile.FileName ); 
                if ( extension.StartsWith( "." ) ) { 
                    extension = extension.Substring( 1 ); 
                } 
                // check if the file extension is allowed
                if ( ( !( ConfigurationSettings.AppSettings[ "CMSAllowedFileExtensions" ] == null ) ) && ConfigurationSettings.AppSettings[ "CMSAllowedFileExtensions" ] + "" != "" ) { 
                    if ( Strings.InStr( ";" + ConfigurationSettings.AppSettings[ "CMSAllowedFileExtensions" ].ToLower() + ";", ";" + extension.ToLower() + ";", (Microsoft.VisualBasic.CompareMethod)(0) ) == 0 ) { 
                        this.lblError.Text = ResMan.GetString( "Attachments.ErrorExtensionNotAllowed" ); 
                        return; 
                    } 
                } 
                // check if there's no other file of that name already
                // If File.Exists(savePath) Then
                //     Me.lblError.Text = ResMan.GetString("Attachments.ErrorFileAlreadyExists")
                //     Exit Sub
                // End If
                Functions.EnsureDiskPath( savePath, HttpContext.Current.Server.MapPath( "~/." ) ); 
                // save file to the database
                mFileBinary = new byte[ upload.PostedFile.ContentLength ]; 
                upload.PostedFile.InputStream.Read( mFileBinary, 0, upload.PostedFile.ContentLength ); 
                // do not save file to the disk if versioning is used and file is only being updated            
                upload.PostedFile.SaveAs( savePath ); 
                TreeNode newFile = new TreeNode( "cms.file", tree ); 
                newFile.SetValue( "NodeName", currentFileName ); 
                newFile.SetValue( "FileName", currentFileName ); 
                newFile.SetValue( "FileExtension", extension ); 
                newFile.SetValue( "FileSize", upload.PostedFile.ContentLength ); 
                newFile.SetValue( "FileMimeType", upload.PostedFile.ContentType ); 
                newFile.SetValue( "FileBinary", mFileBinary ); 
                newFile.Insert( idpath, TreePathTypeEnum.IDPath ); 
            } 
        } 
        
        
        protected void cmsdatagrid1_binditem( object sender, DataGridItemEventArgs e ) { 
            if ( e.Item.ItemType == ListItemType.Item | e.Item.ItemType == ListItemType.AlternatingItem ) { 
                ( ( LinkButton )( e.Item.FindControl( "deleteButton" ) ) ).Attributes.Add( "onclick", "return ConfirmDelete();" ); 
                ( ( LinkButton )( e.Item.FindControl( "deleteButton" ) ) ).Text = ResMan.GetString( "Attachments.Delete" ); 
            } 
        } 
        
        
        protected string GetFileScript( string fileName ) { 
            string script = ""; 
            if ( Strings.InStr( ";.gif;.jpg;.jpeg;.png;.bmp;", ";" + Path.GetExtension( fileName ).ToLower() + ";", (Microsoft.VisualBasic.CompareMethod)(0) ) > 0 ) { 
                // paste image
                script = @"PasteImage(""" + "" + Request.QueryString[ "ftbName" ] + @""", """ + imgPath + fileName + @""");"; 
            } 
            else { 
                // paste link
                script = @"PasteLink(""" + "" + Request.QueryString[ "ftbName" ] + @""", """ + imgPath + fileName + @""", """ + fileName + @""");"; 
            } 
            return script; 
        } 
        
        
        
        protected string GetImageTag( string fileName ) { 
            string code = ""; 
            if ( Strings.InStr( ";.gif;.jpg;.jpeg;.png;.bmp;", ";" + Path.GetExtension( fileName ).ToLower() + ";", (Microsoft.VisualBasic.CompareMethod)(0) ) > 0 ) { 
                // image
                code = @"PasteImage(""" + "" + Request.QueryString[ "ftbName" ] + @""", """ + imgPath + fileName + @""");"; 
                code = @"<img width=""50"" height=""50"" src=""" + imgPath + fileName + @""">"; 
            } 
            else { 
                // other type
                code = "&nbsp;"; 
            } 
            return code; 
        } 
        
        
        
        protected void UpdateArticle( int lastAttachmentId ) { 
            VersionManager verMan = new VersionManager( tree ); 
            TreeNode node = null; 
            node = tree.SelectSingleNode( idpath, TreePathTypeEnum.IDPath ); 
            TreeNode originalNode = node; 
            node = verMan.GetVersion( System.Convert.ToInt32( node.GetValue( "CheckedOutVersionHistoryID" ) ) ); 
            if ( node == null ) { 
                node = originalNode; 
            } 
            try { 
                tree.Connection.DataConnection.Open(); 
                tree.Connection.DataConnection.BeginTransaction(); 
                if ( ConfigurationSettings.AppSettings[ "CMSUseCheckinCheckout" ] == "false" ) { 
                    verMan.CheckOut( System.Convert.ToInt32( node.GetValue( "NodeID" ) ), "" ); 
                } 
                node.SetValue( "CheckedOutByUserID", originalNode.GetValue( "CheckedOutByUserID" ) ); 
                node.SetValue( "CheckedOutWhen", originalNode.GetValue( "CheckedOutWhen" ) ); 
                node.SetValue( "CheckedOutVersionHistoryID", originalNode.GetValue( "CheckedOutVersionHistoryID" ) ); 
                if ( lastAttachmentId != 0 ) { 
                    node.SetValue( "LastAttachmentID", lastAttachmentId ); 
                } 
                verMan.SaveVersion( node ); 
                // check in the document if content locking is not used
                if ( ConfigurationSettings.AppSettings[ "CMSUseCheckinCheckout" ] == "false" ) { 
                    verMan.CheckIn( System.Convert.ToInt32( node.GetValue( "NodeID" ) ), "", "" ); 
                } 
                tree.Connection.DataConnection.CommitTransaction(); 
                tree.Connection.DataConnection.Close(); 
            } 
            catch ( Exception ex ) { 
                tree.Connection.DataConnection.RollbackTransaction(); 
                tree.Connection.DataConnection.Close(); 
                throw ex; 
            } 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
