using Kentico.CMS.TreeEngine; 
using Kentico.CMS.MetadataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class BrowseAndEditFrameset : System.Web.UI.Page { 
        
        protected string targetUrl; 
        protected string idpath; 
        protected string cultureCode = ""; 
        protected int headerSize; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
        } 
        
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            string path = null; 
            TreePathTypeEnum pathtype = 0; 
            string mode = null; 
            string classname = null; 
            TreeProvider tree = null; 
            TreeNode node = null; 
            DataSet nodes = null; 
            string childpath = null; 
            string closeAndUpdate = null; 
            headerSize = 50; 
            
            // get parameters
            path = "" + Request.QueryString[ "path" ] + ""; 
            mode = "" + Request.QueryString[ "mode" ] + ""; 
            classname = "" + Request.QueryString[ "classname" ] + ""; 
            closeAndUpdate = "" + Request.QueryString[ "closeandupdate" ] + ""; 
            
            // if not path or mode were specified, exit
            if ( Strings.Trim( path ) + "" == "" | Strings.Trim( mode ) + "" == "" ) { 
                return; 
            } 
            
            if ( Functions.UseMultilingualSupport() ) { 
                cultureCode = path.Split( '/' )[ 1 ]; 
            } 
            
            
            // get path type
            switch ( ( "" + Request.QueryString[ "pathtype" ] + "" ).ToLower() ) {
                case "aliaspath":
                    pathtype = TreePathTypeEnum.AliasPath; 
                    break;
                case "namepath":
                    pathtype = TreePathTypeEnum.NamePath; 
                    break;
                default:
                    pathtype = TreePathTypeEnum.IDPath; 
                    break;
            }
            
            tree = Functions.GetTreeProvider(); 
            
            // get aliaspath if necessary
            if ( pathtype != TreePathTypeEnum.AliasPath ) { 
                TreeNode tmpNode = tree.SelectSingleNode( path, pathtype ); 
                if ( !( tmpNode == null ) ) { 
                    path = System.Convert.ToString( tmpNode.GetValue( "AliasPath" ) ); 
                    pathtype = TreePathTypeEnum.AliasPath; 
                } 
            } 
            
            if ( Functions.UseMultilingualSupport() ) { 
                cultureCode = path.Split( '/' )[ 1 ]; 
            } 
            
            // get node object to receive its IDPath
            if ( mode == "new" ) { 
                node = tree.SelectSingleNode( path, pathtype ); 
                headerSize = 0; 
            } 
            else { 
                node = tree.SelectSingleNode( path, pathtype, classname ); 
            } 
            if ( mode == "delete" ) { 
                headerSize = 0; 
            } 
            if ( !( node == null ) ) { 
                idpath = System.Convert.ToString( node.GetValue( "IDPath" ) ); 
            } 
            else { 
                // node not found - try to get the first child node of specified type
                if ( path == "/" ) { 
                    childpath = "/%"; 
                } 
                else { 
                    childpath = path + "/%"; 
                } 
                nodes = tree.SelectNodes( childpath, TreePathTypeEnum.AliasPath, classname ); 
                if ( nodes.Tables[ 0 ].Rows.Count == 0 ) { 
                    if ( mode != "new" ) { 
                        node = tree.SelectSingleNode( path, pathtype ); 
                        if ( node == null ) { 
                            if ( Functions.UseMultilingualSupport() ) { 
                                TreeNode defaultCultureNode = null; 
                                if ( classname + "" != "" ) { 
                                    defaultCultureNode = tree.SelectSingleNode( "/" + Functions.GetDefaultCulture() + Functions.RemoveCultureFromAliasPath( path ), TreePathTypeEnum.AliasPath, classname ); 
                                } 
                                else { 
                                    defaultCultureNode = tree.SelectSingleNode( "/" + Functions.GetDefaultCulture() + Functions.RemoveCultureFromAliasPath( path ), TreePathTypeEnum.AliasPath ); 
                                } 
                                if ( defaultCultureNode == null ) { 
                                    // new node
                                    mode = "new"; 
                                    TreeNode parentNode = tree.SelectSingleNode( "/" + Functions.GetDefaultCulture() + Functions.RemoveCultureFromAliasPath( path ), TreePathTypeEnum.AliasPath ); 
                                    if ( parentNode == null ) { 
                                        return; 
                                    } 
                                    else { 
                                        cultureCode = Functions.GetDefaultCulture(); 
                                        idpath = System.Convert.ToString( parentNode.GetValue( "idpath" ) ); 
                                    } 
                                } 
                                else { 
                                    // new culture version
                                    mode = "edit"; 
                                    idpath = System.Convert.ToString( defaultCultureNode.GetValue( "IDPath" ) ); 
                                } 
                            } 
                            else { 
                                return; 
                            } 
                        } 
                        else { 
                            mode = "new"; 
                            idpath = System.Convert.ToString( node.GetValue( "idpath" ) ); 
                        } 
                    } 
                    else { 
                        return; 
                    } 
                } 
                else { 
                    idpath = System.Convert.ToString( nodes.Tables[ 0 ].Rows[ 0 ][ "idpath" ] ); 
                } 
            } 
            // set bottom frame URL according to mode and redirect user to the right form
            switch ( mode ) {
                case "new":
                    if ( classname + "" == "" ) { 
                        // no class name specified - let user choose one
                        targetUrl = "new.aspx?newwindow=true&idpath=" + idpath + "&culture=" + cultureCode; 
                    } 
                    else { 
                        // check permissions and redirect user to an appropriate editing form
                        if ( Functions.IsAuthorizedPerClass( classname, "create" ) | Functions.IsAuthorizedPerResource( "CMS.Content", "Create" ) | Functions.IsAuthorizedPerNode( idpath, Kentico.CMS.TreeEngine.TreePathTypeEnum.IDPath, Kentico.CMS.TreeEngine.NodePermissionsEnum.Create ) ) { 
                            string editingPage = MetadataProvider.GetSettingsValue( classname, "CMSEditPage" ); 
                            if ( editingPage + "" == "" ) { 
                                editingPage = "Edit.aspx"; 
                            } 
                            targetUrl = editingPage + "?newwindow=true&idpath=" + idpath + "&action=insert&classname=" + classname + "&culture=" + cultureCode; 
                        } 
                        else { 
                            Functions.RedirectToAccessDenied( idpath, "create" ); 
                        } 
                    } 
                    break;
                case "edit":
                    targetUrl = "edit.aspx?newwindow=true&idpath=" + idpath + "&culture=" + cultureCode; 
                    break;
                case "view":
                    targetUrl = "viewFrameset.aspx?newwindow=true&idpath=" + idpath + "&culture=" + cultureCode; 
                    break;
                case "delete":
                    targetUrl = "delete.aspx?idpath=" + idpath + "&culture=" + cultureCode; 
                    break;
                case "properties":
                    targetUrl = "properties.aspx?idpath=" + idpath + "&culture=" + cultureCode; 
                    break;
                case "lock":
                    targetUrl = "lock.aspx?idpath=" + idpath + "&culture=" + cultureCode; 
                    break;
                case "history":
                    targetUrl = "history.aspx?idpath=" + idpath + "&culture=" + cultureCode; 
                    break;
            }
            
            if ( closeAndUpdate == "1" ) { targetUrl += "&closeandupdate=1"; } 
        } 
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
