using Kentico.CMS.TreeEngine; 
using Kentico.CMS.MetadataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class Delete : System.Web.UI.Page { 
        
        protected TreeNode node; 
        protected bool usesVersioning = false; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by btnNo_Click
             
            btnNo.Click += new System.EventHandler( btnNo_Click ); 
            // events handled by btnYes_Click
             
            btnYes.Click += new System.EventHandler( btnYes_Click ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblInfo; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnYes; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.CheckBox chkDestroy; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnNo; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            if ( !( Page.IsPostBack ) ) { 
                this.lblHeader.Text = ResMan.GetString( "Delete.Header" ); 
                this.chkDestroy.Text = ResMan.GetString( "Delete.Destroy" ); 
                this.btnYes.Text = ResMan.GetString( "Delete.Yes" ); 
                this.btnNo.Text = ResMan.GetString( "Delete.No" ); 
            } 
            this.ltlScript.Text = ""; 
            
            string idpath = "" + Request.QueryString[ "idpath" ] + ""; 
            string culture = "" + Request.QueryString[ "culture" ] + ""; 
            TreeProvider tree = Functions.GetTreeProvider(); 
            
            // get node
            node = Functions.GetNodeByIDPathAndCulture( idpath, culture ); 
            
            // multilingual support
            if ( node == null ) { 
                // culture version does not exist            
                node = tree.SelectSingleNode( idpath, TreePathTypeEnum.IDPath ); 
                Response.Redirect( "NewCultureVersion.aspx?idpath=" + idpath + "&aliaspath=" + System.Convert.ToString( node.GetValue( "aliaspath" ) ) + "&culture=" + culture ); 
                return; 
            } 
            else { 
                idpath = System.Convert.ToString( node.GetValue( "idpath" ) ); 
            } 
            
            this.lblInfo.Text = ResMan.GetString( "Delete.Info" ); 
            if ( !( node == null ) ) { 
                this.lblInfo.Text += @" """ + System.Convert.ToString( node.GetValue( "NodeName" ) ) + @"""?"; 
            } 
            
            // check permissions
            if ( !( ( Functions.IsAuthorizedPerResource( "CMS.Content", "Delete" ) | Functions.IsAuthorizedPerResource( "CMS.Content", "Destroy" ) | Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Delete ) | Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Destroy ) ) ) ) { 
                Functions.RedirectToAccessDenied( idpath, "Delete (lock.aspx)" ); 
                return; 
            } 
            
            // check if document type supports versioning
            if ( !( System.Convert.ToBoolean( Functions.GetClassDRValue( System.Convert.ToInt32( node.GetValue( "ClassID" ) ), "UseVersioning" ) ) ) ) { 
                this.chkDestroy.Visible = false; 
                usesVersioning = false; 
            } 
            else { 
                // check if document is checked out
                if ( !( node.GetValue( "CheckedOutByUserID" ) == null ) && System.Convert.ToInt32( node.GetValue( "CheckedOutByUserID" ) ) != Functions.GetUserID() ) { 
                    this.lblInfo.Text = ResMan.GetString( "Delete.ErrorDocumentIsCheckedOut" ); 
                    this.chkDestroy.Enabled = false; 
                    this.btnYes.Enabled = false; 
                    this.btnNo.Enabled = false; 
                } 
                
                // check if user is not authorized to destroy documents
                if ( !( ( Functions.IsAuthorizedPerResource( "CMS.Content", "Destroy" ) | Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Destroy ) ) ) ) { 
                    this.chkDestroy.Visible = false; 
                } 
            } 
        } 
        
        
        private void btnNo_Click( System.Object sender, System.EventArgs e ) { 
            // redirect user back to the previous screen
            ltlScript.Text = @"<script language=""javascript"">"; 
            ltlScript.Text += "   history.go(-2);"; 
            ltlScript.Text += "</script>"; 
        } 
        
        
        private void btnYes_Click( System.Object sender, System.EventArgs e ) { 
            // delete and update tree
            string parentPath = node.GetParentPath( TreePathTypeEnum.IDPath ); 
            ltlScript.Text = @"<script language=""javascript"">" + Constants.vbCrLf; 
            ltlScript.Text += " parent.frames['header'].DeleteSelectedNode('" + this.chkDestroy.Checked.ToString().ToLower() + "'); " + Constants.vbCrLf; 
            ltlScript.Text += "</script>"; 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
