using Kentico.CMS.DataEngine; 
using Kentico.CMS.TreeEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class DocumentPermissionsAddOperator : System.Web.UI.Page { 
        
        protected string idpath; 
        protected string title; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by btnSearch_Click
             
            btnSearch.Click += new System.EventHandler( btnSearch_Click ); 
            // events handled by btnOK_Click
             
            btnOK.Click += new System.EventHandler( btnOK_Click ); 
            // events handled by btnCancel_Click
             
            btnCancel.Click += new System.EventHandler( btnCancel_Click ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtSearch; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnSearch; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.ListBox lstItems; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnOK; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnCancel; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            idpath = "" + Request.QueryString[ "idpath" ]; 
            lblHeader.Text = ResMan.GetString( "DocumentPermissionsAddOperator.Header" ); 
            btnSearch.Text = ResMan.GetString( "DocumentPermissionsAddOperator.SearchButton" ); 
            btnOK.Text = ResMan.GetString( "DocumentPermissionsAddOperator.OK" ); 
            btnCancel.Text = ResMan.GetString( "DocumentPermissionsAddOperator.Cancel" ); 
            title = ResMan.GetString( "DocumentPermissionsAddOperator.Title" ); 
            
            // check permissions
            if ( !( ( Functions.IsAuthorizedPerResource( "CMS.Content", "ModifyPermissions" ) | Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.ModifyPermissions ) ) ) ) { 
                Functions.RedirectToAccessDenied( idpath, "Modify permissions (documentpermissions.aspx)" ); 
                return; 
            } 
        } 
        
        
        
        private void btnSearch_Click( System.Object sender, System.EventArgs e ) { 
            GeneralConnection cn = new GeneralConnection(); 
            DataSet ds = null; 
            object[,] searchParams = new object[ 1, 3 ]; 
            searchParams[ 0, 0 ] = "@search"; 
            searchParams[ 0, 1 ] = "%" + this.txtSearch.Text + "%"; 
            
            // find all users and roles whose name contains specified string
            cn.ConnectionString = Functions.GetConnectionString(); 
            ds = cn.ExecuteQuery( "CMS.Role.SelectRolesAndUsers", searchParams ); 
            lstItems.DataSource = ds.Tables[ 0 ]; 
            lstItems.DataTextField = "OperatorName"; 
            lstItems.DataValueField = "OperatorID"; 
            lstItems.DataBind(); 
        } 
        
        
        
        private void btnOK_Click( System.Object sender, System.EventArgs e ) { 
            ListItem item = null; 
            object[,] queryParams = new object[ 2, 3 ]; 
            AclProvider aclProv = new AclProvider( Functions.GetTreeProvider() ); 
            
            // get IDs of the selected users/roles and save changes
            foreach ( System.Web.UI.WebControls.ListItem transTemp0 in lstItems.Items ) { 
                item = transTemp0;  
                if ( item.Selected ) { 
                    if ( item.Value.StartsWith( "U" ) ) { 
                        aclProv.SetUserPermissions( idpath, TreePathTypeEnum.IDPath, 0, 0, int.Parse( item.Value.Substring( 1 ) ) ); 
                    } 
                    else { 
                        aclProv.SetRolePermissions( idpath, TreePathTypeEnum.IDPath, 0, 0, int.Parse( item.Value.Substring( 1 ) ) ); 
                    } 
                } 
            }
            CloseWindow(); 
        } 
        
        
        
        private void btnCancel_Click( System.Object sender, System.EventArgs e ) { 
            CloseWindow(); 
        } 
        
        
        
        ///<summary>Generates script that closes the window and refreshes the parent page.</summary>
        private void CloseWindow() { 
            ltlScript.Text = @"<script language=""javascript"">"; 
            ltlScript.Text += " CloseAndRefresh(); "; 
            ltlScript.Text += "</script>"; 
        } 
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
