using Kentico.CMS.MetadataEngine; 
using Kentico.CMS.TreeEngine; 
using Kentico.CMS.Form; 
using Kentico.CMS.DataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class Edit : System.Web.UI.Page { 
        
        protected string action; 
        protected string idpath; 
        protected string classname; 
        protected string nodeculture; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlSetModeScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtNativeIDPath; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtMode; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected string defaultCultureIDPath; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblInfo; 
        protected /* TRANSINFO: WithEvents */ Kentico.CMS.Form.CMSForm CMSForm1; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            CMSForm1.OnBeforeSave += new Form.CMSForm.OnBeforeSaveEventHandler( CheckPermissions ); 
            CMSForm1.OnAfterSave += new Form.CMSForm.OnAfterSaveEventHandler( AfterSave ); 
            ltlScript.Text = ""; 
            idpath = "" + Request.QueryString[ "IDPath" ]; 
            action = "" + Request.QueryString[ "action" ] + ""; 
            classname = "" + Request.QueryString[ "classname" ]; 
            nodeculture = "" + Request.QueryString[ "culture" ]; 
            defaultCultureIDPath = "" + Request.QueryString[ "defaultcultureidpath" ] + ""; 
            
            // set editing mode
            if ( !( Page.IsPostBack ) ) { 
                ltlSetModeScript.Text = @"<script language=""JavaScript"">" + Constants.vbCrLf; 
                ltlSetModeScript.Text += " try " + Constants.vbCrLf; 
                ltlSetModeScript.Text += " { " + Constants.vbCrLf; 
                ltlSetModeScript.Text += "  parent.parent.frames['header'].SetMode('edit'); " + Constants.vbCrLf; 
                ltlSetModeScript.Text += " } " + Constants.vbCrLf; 
                ltlSetModeScript.Text += " catch (e)" + Constants.vbCrLf; 
                ltlSetModeScript.Text += " { " + Constants.vbCrLf; 
                ltlSetModeScript.Text += " } " + Constants.vbCrLf; 
                ltlSetModeScript.Text += "</script>" + Constants.vbCrLf; 
            } 
            else { 
                ltlSetModeScript.Text = ""; 
            } 
            
            CMSForm1.TreeProvider = Functions.GetTreeProvider(); 
            // set correctly current culture even when postback occurs
            Functions.GetPreferredUICulture(); 
            
            if ( !( Page.IsPostBack ) ) { 
                TreeProvider tree = Functions.GetTreeProvider(); 
                TreeNode node = null; 
                string editPage = null; 
                string aliaspath = null; 
                
                // get class name of the node
                if ( action.ToLower() == "insert" ) { 
                    lblHeader.Text = ResMan.GetString( "ContentEdit.HeaderCreateDoc" ); 
                } 
                else { 
                    lblHeader.Text = ResMan.GetString( "ContentEdit.Header" ); 
                    node = tree.SelectSingleNode( idpath, TreePathTypeEnum.IDPath ); 
                    if ( Functions.UseMultilingualSupport() & nodeculture + "" != "" ) { 
                        aliaspath = System.Convert.ToString( node.GetValue( "AliasPath" ) ); 
                        node = tree.SelectSingleNode( "/" + nodeculture + Functions.RemoveCultureFromAliasPath( aliaspath ), TreePathTypeEnum.AliasPath ); 
                        if ( node == null ) { 
                            Response.Redirect( "NewCultureVersion.aspx?idpath=" + idpath + "&aliaspath=" + aliaspath + "&culture=" + nodeculture ); 
                            return; 
                        } 
                        else { 
                            idpath = System.Convert.ToString( node.GetValue( "idpath" ) ); 
                        } 
                    } 
                    classname = node.ClassName; 
                    ViewState[ "oldAliasPath" ] = node.GetValue( "AliasPath" ); 
                } 
                lblHeader.Text += " - " + System.Convert.ToString( ClassInformationProvider.GetClassRow( classname, tree )[ "ClassDisplayName" ] ); 
                
                // get the address of the editing page for specified class        
                editPage = Strings.Trim( MetadataProvider.GetSettingsValue( classname, "CMSEditPage" ) + "" ); 
                this.txtNativeIDPath.Text = idpath; 
                this.txtMode.Text = action.ToLower(); 
                // check permissions
                if ( action.ToLower() == "insert" ) { 
                    // check permissions for inserting
                    if ( !( ( Functions.IsAuthorizedPerClass( classname, "Create" ) | Functions.IsAuthorizedPerResource( "CMS.Content", "Create" ) | Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Create ) ) ) ) { 
                        Functions.RedirectToAccessDenied( idpath, "Read document (edit.aspx)" ); 
                        return; 
                    } 
                    TreeNode parentNode = tree.SelectSingleNode( idpath, TreePathTypeEnum.IDPath ); 
                    if ( !( parentNode == null ) ) { 
                        int parentClassID = System.Convert.ToInt32( parentNode.GetValue( "ClassID" ) ); 
                        DataRow dr = ClassInformationProvider.GetClassRow( classname, tree ); 
                        if ( !( dr == null ) ) { 
                            int childClassID = System.Convert.ToInt32( dr[ "ClassID" ] ); 
                            if ( !( CheckAllowedChildType( parentClassID, childClassID ) ) ) { 
                                Response.Redirect( "new.aspx?idpath=" + idpath + "&action=insert&classname=" + classname ); 
                            } 
                        } 
                    } 
                } 
                else { 
                    // check permissions for editing
                    if ( !( ( Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read ) | Functions.IsAuthorizedPerResource( "CMS.Content", "Read" ) ) ) ) { 
                        Functions.RedirectToAccessDenied( idpath, "Read document (edit.aspx)" ); 
                        return; 
                    } 
                } 
                if ( editPage + "" == "" ) { 
                    // use KentiForm
                    if ( action.ToLower() == "insert" ) { 
                        CMSForm1.FormMode = FormModeEnum.Insert; 
                        CMSForm1.FormName = classname + ".default"; 
                    } 
                    else { 
                        CMSForm1.FormMode = FormModeEnum.Update; 
                    } 
                    CMSForm1.SelectPath = idpath; 
                    CMSForm1.SelectPathType = TreePathTypeEnum.IDPath; 
                    
                    if ( ( !( ConfigurationSettings.AppSettings[ "CMSWysiwygEditor" ] == null ) ) && ( ConfigurationSettings.AppSettings[ "CMSWysiwygEditor" ].ToLower().Trim() == "fckeditor" ) ) { 
                        CMSForm1.FreeTextBoxSupportFolder = "../aspnet_client/FCKEditor/"; 
                    } 
                    else { 
                        CMSForm1.FreeTextBoxSupportFolder = "../aspnet_client/FreeTextBox/"; 
                    } 
                    CMSForm1.Visible = true; 
                } 
                else { 
                    // redirect user to the editing page
                    lblInfo.Text = ResMan.GetString( "ContentEdit.Redirect" ); 
                    if ( action == "insert" ) { 
                        Response.Redirect( editPage + "?idpath=" + idpath + "&action=insert&defaultcultureidpath=" + "" + Request.QueryString[ "defaultcultureidpath" ] + "&copydefaultculture=" + "" + Request.QueryString[ "copydefaultculture" ] ); 
                    } 
                    else { 
                        Response.Redirect( editPage + "?idpath=" + idpath + "&action=edit&defaultcultureidpath=" + "" + Request.QueryString[ "defaultcultureidpath" ] ); 
                    } 
                } 
                // prefill values if required
                if ( Functions.UseMultilingualSupport() && ( !( Request.QueryString[ "copydefaultculture" ] == null ) ) && Request.QueryString[ "copydefaultculture" ].Trim() == "1" ) {  
                    CMSForm1.DefaultValuesIdPath = defaultCultureIDPath; 
                } 
            } 
            
            
            // If Request.QueryString("newwindow") = "true" Then
            //     Me.CMSForm1.DisplayCloseWindowButton = True
            // End If
        } 
        
        
        
        private void CheckPermissions() { 
            string className = null; 
            string IDPath = "" + Request.QueryString[ "idpath" ]; 
            className = "" + Request.QueryString[ "classname" ]; 
            TreeNode node = null; 
            TreeProvider tree = Functions.GetTreeProvider(); 
            string aliaspath = null; 
            
            node = tree.SelectSingleNode( IDPath, TreePathTypeEnum.IDPath ); 
            if ( Functions.UseMultilingualSupport() & nodeculture + "" != "" ) { 
                aliaspath = System.Convert.ToString( node.GetValue( "AliasPath" ) ); 
                node = tree.SelectSingleNode( "/" + nodeculture + Functions.RemoveCultureFromAliasPath( aliaspath ), TreePathTypeEnum.AliasPath ); 
                if ( node == null ) { 
                    Response.Redirect( "NewCultureVersion.aspx?idpath=" + IDPath + "&aliaspath=" + aliaspath + "&culture=" + nodeculture ); 
                    return; 
                } 
                else { 
                    IDPath = System.Convert.ToString( node.GetValue( "idpath" ) ); 
                } 
            } 
            
            if ( action.ToLower() == "insert" ) { 
                // check permissions for inserting
                if ( !( ( Functions.IsAuthorizedPerClass( className, "create" ) | Functions.IsAuthorizedPerResource( "CMS.Content", "Create" ) | Functions.IsAuthorizedPerNode( IDPath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Create ) ) ) ) { 
                    CMSForm1.StopProcessing = true; 
                    Functions.RedirectToAccessDenied( IDPath, "Create document (edit.aspx)" ); 
                    return; 
                } 
            } 
            else { 
                // check permissions for editing
                if ( !( ( Functions.IsAuthorizedPerNode( IDPath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Modify ) | Functions.IsAuthorizedPerResource( "CMS.Content", "Modify" ) ) ) ) { 
                    CMSForm1.StopProcessing = true; 
                    Functions.RedirectToAccessDenied( IDPath, "Edit document (edit.aspx)" ); 
                    return; 
                } 
            } 
            
            // set the same alias path or all values in case that the node is a translated version of an existing node
            if ( Functions.UseMultilingualSupport() & defaultCultureIDPath + "" != "" ) { 
                TreeNode defaultCultureNode = null; 
                string nodealias = null; 
                tree = Functions.GetTreeProvider(); 
                defaultCultureNode = tree.SelectSingleNode( defaultCultureIDPath, TreePathTypeEnum.IDPath ); 
                nodealias = System.Convert.ToString( defaultCultureNode.GetValue( "NodeAlias" ) ); 
                CMSForm1.BasicForm.DataRow[ "NodeAlias" ] = nodealias; 
            } 
        } 
        
        
        
        private void AfterSave() { 
            string defaultCultureIDPath = "" + Request.QueryString[ "defaultcultureidpath" ] + ""; 
            
            // ensure folders and for friendly URLs
            Functions.EnsureFriendlyURL( System.Convert.ToString( CMSForm1.BasicForm.DataRow[ "AliasPath" ] ), System.Convert.ToString( ViewState[ "oldAliasPath" ] ) ); 
            ltlScript.Text = @"<script language=""javascript"">"; 
            if ( "" + Request.QueryString[ "closeandupdate" ] == "1" ) { 
                ltlScript.Text += " parent.parent.frames['header'].ReloadSelectedNode(); "; 
            } 
            else { 
                if ( action == "insert" ) { 
                    if ( !( ( Functions.UseMultilingualSupport() & defaultCultureIDPath + "" != "" ) ) ) { 
                        ltlScript.Text += " if (top.frames['desktop']) {" + Constants.vbCrLf; 
                        ltlScript.Text += "     top.frames['desktop'].frames['header'].RefreshAfterInsert('" + System.Convert.ToString( CMSForm1.BasicForm.DataRow[ "idpath" ] ) + "', '" + idpath + "'); "; 
                        ltlScript.Text += " }" + Constants.vbCrLf; 
                        ltlScript.Text += " else {" + Constants.vbCrLf; 
                        ltlScript.Text += "     top.frames['header'].RefreshAfterInsert('" + System.Convert.ToString( CMSForm1.BasicForm.DataRow[ "idpath" ] ) + "', '" + idpath + "'); "; 
                        ltlScript.Text += " }" + Constants.vbCrLf; 
                    } 
                } 
                else { 
                    if ( !( ( Functions.UseMultilingualSupport() & defaultCultureIDPath + "" != "" ) ) ) { 
                        ltlScript.Text += " if (top.frames['desktop']) {" + Constants.vbCrLf; 
                        ltlScript.Text += "     top.frames['desktop'].frames['header'].ReloadSelectedNode(); "; 
                        ltlScript.Text += " }" + Constants.vbCrLf; 
                        ltlScript.Text += " else {" + Constants.vbCrLf; 
                        ltlScript.Text += "     top.frames['header'].ReloadSelectedNode(); "; 
                        ltlScript.Text += " }" + Constants.vbCrLf; 
                    } 
                } 
            } 
            ltlScript.Text += "</script>"; 
            
            if ( txtMode.Text == "insert" ) { 
                this.txtNativeIDPath.Text = System.Convert.ToString( CMSForm1.BasicForm.DataRow[ "idpath" ] ); 
                this.txtMode.Text = "edit"; 
            } 
        } 
        
        
        ///<summary>Returns true if specified child type can be placed under specified parent type.</summary>
        private bool CheckAllowedChildType( int parentClassID, int childClassID ) { 
            GeneralConnection cn = new GeneralConnection( Functions.GetConnectionString() ); 
            DataSet ds = null; 
            
            ds = cn.ExecuteQuery( "cms.allowedchildclasses.selectallowed", null, " parentClassID = '" + parentClassID.ToString() + "' AND childClassID = '" + childClassID.ToString() + "' " ); 
            if ( ds.Tables[ 0 ].Rows.Count > 0 ) { 
                return true; 
            } 
            else { 
                return false; 
            } 
        } 
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
