using Kentico.CMS.TreeEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class EditFrameset : System.Web.UI.Page { 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
        } 
        
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        protected string url; 
        protected string urlParams; 
        protected string idPath; 
        protected string headerParams; 
        protected string action; 
        protected string classname; 
        protected string nodeculture; 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            string aliaspath = ""; 
            TreeProvider tree = null; 
            TreeNode node = null; 
            idPath = "" + Request.QueryString[ "idpath" ] + ""; 
            
            idPath = "" + Request.QueryString[ "IDPath" ]; 
            action = "" + Request.QueryString[ "action" ] + ""; 
            classname = "" + Request.QueryString[ "classname" ]; 
            nodeculture = "" + Request.QueryString[ "culture" ]; 
            
            tree = Functions.GetTreeProvider(); 
            node = tree.SelectSingleNode( idPath, TreePathTypeEnum.IDPath ); 
            // if multilingual support is used and the required culture version is not available, redirect user to the NewCultureVersion page
            if ( Functions.UseMultilingualSupport() & Strings.LCase( Strings.Trim( nodeculture ) ) != Strings.LCase( Strings.Trim( ConfigurationSettings.AppSettings[ "CMSDefaultCultureCode" ] + "" ) ) & nodeculture + "" + "" != "" ) { 
                aliaspath = "/" + nodeculture + Functions.RemoveCultureFromAliasPath( System.Convert.ToString( node.GetValue( "AliasPath" ) ) ); 
                node = tree.SelectSingleNode( "/" + nodeculture + Functions.RemoveCultureFromAliasPath( aliaspath ), TreePathTypeEnum.AliasPath ); 
                if ( node == null ) { 
                    Response.Redirect( "NewCultureVersion.aspx?idpath=" + idPath + "&aliaspath=" + aliaspath + "&culture=" + nodeculture ); 
                    return; 
                } 
                // viewstate("oldAliasPath") = node.GetValue("AliasPath")
            } 
            aliaspath = ( System.Convert.ToString( node.GetValue( "AliasPath" ) ) ); 
            aliaspath = Functions.RemoveCultureFromAliasPath( aliaspath ); 
            
            if ( action.ToLower() == "insert" ) { 
                // check permissions for inserting
                if ( !( ( Functions.IsAuthorizedPerClass( classname, "Create" ) | Functions.IsAuthorizedPerResource( "CMS.Content", "Create" ) | Functions.IsAuthorizedPerNode( idPath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Create ) ) ) ) { 
                    Functions.RedirectToAccessDenied( idPath, "Read document (edit.aspx)" ); 
                    return; 
                } 
            } 
            else { 
                // check permissions for editing
                if ( !( ( Functions.IsAuthorizedPerNode( idPath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read ) | Functions.IsAuthorizedPerResource( "CMS.Content", "Read" ) ) ) ) { 
                    Functions.RedirectToAccessDenied( idPath, "Read document (edit.aspx)" ); 
                    return; 
                } 
            } 
            
            url = "edit.aspx?culture=" + nodeculture + "&idpath=" + idPath + "&classname=" + classname + "&action=" + action + "&closeandupdate=" + "" + Request.QueryString[ "closeandupdate" ] + "&defaultcultureidpath=" + "" + Request.QueryString[ "defaultcultureidpath" ] + "&copydefaultculture=" + "" + Request.QueryString[ "copydefaultculture" ]; 
            
            headerParams = "aliaspath=" + aliaspath + "&culture=" + nodeculture + "&idpath=" + idPath + "&classname=" + classname + "&action=" + action + "&closeandupdate=" + "" + Request.QueryString[ "closeandupdate" ] + "&defaultcultureidpath=" + "" + Request.QueryString[ "defaultcultureidpath" ] + "&copydefaultculture=" + "" + Request.QueryString[ "copydefaultculture" ]; 
            
        } 
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
