using Kentico.CMS.DataEngine; 
using Kentico.CMS.MetadataEngine; 
using Kentico.CMS.TreeEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class EditRelationship : System.Web.UI.Page { 
        
        protected int mainNodeID = 0; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by btnOK_Click
             
            btnOK.Click += new System.EventHandler( btnOK_Click ); 
            // events handled by btnCancel_Click
             
            btnCancel.Click += new System.EventHandler( btnCancel_Click ); 
            // events handled by btnSwitch_Click
             
            btnSwitch.Click += new System.EventHandler( btnSwitch_Click ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblError; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblInfo; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Panel pnlLeftNode; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Panel pnlRightNode; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnOK; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.DropDownList drpRelationshipName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblLeftNode; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblRightNode; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblRelationshipName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnCancel; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnSwitch; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            Functions.RedirectExpressEdition( "CMSDesk.Relationships" ); 
            
            int leftNodeID = 0; 
            int rightNodeID = 0; 
            int relationshipNameID = 0; 
            GeneralConnection cn = null; 
            DataClass relNameObj = null; 
            
            // get return page
            if ( !( Page.IsPostBack ) ) { 
                ViewState[ "ReturnPage" ] = Request.UrlReferrer.ToString(); 
            } 
            
            // get main node id
            mainNodeID = int.Parse( "" + Request.QueryString[ "MainNodeID" ] ); 
            lblError.Text = ""; 
            lblInfo.Text = ""; 
            lblHeader.Text = ResMan.GetString( "EditRelationship.Header" ); 
            lblLeftNode.Text = ResMan.GetString( "EditRelationship.lblLeftNodeName" ); 
            lblRightNode.Text = ResMan.GetString( "EditRelationship.lblRightNodeName" ); 
            lblRelationshipName.Text = ResMan.GetString( "EditRelationship.lblRelationshipName" ); 
            btnOK.Text = ResMan.GetString( "EditRelationship.btnOK" ); 
            btnCancel.Text = ResMan.GetString( "EditRelationship.btnCancel" ); 
            btnSwitch.Text = ResMan.GetString( "EditRelationship.btnSwitch" ); 
            
            // set values
            cn = new GeneralConnection( Functions.GetConnectionString() ); 
            // new relationship
            if ( !( Page.IsPostBack ) ) { 
                FillRelationshipNames( relationshipNameID ); 
            } 
            LoadNodeControls(); 
            relNameObj = new DataClass( "CMS.Relationship", relationshipNameID, cn ); 
        } 
        
        
        private void btnOK_Click( System.Object sender, System.EventArgs e ) { 
            TreeNode mainNode = Functions.GetTreeProvider().SelectSingleNode( mainNodeID ); 
            string mainNodeIDPath = System.Convert.ToString( mainNode.GetValue( "idpath" ) ); 
            
            // check permissions
            if ( !( ( Functions.IsAuthorizedPerResource( "CMS.Content", "Modify" ) | Functions.IsAuthorizedPerNode( mainNodeIDPath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Modify ) ) ) ) { 
                Functions.RedirectToAccessDenied( mainNodeIDPath, "Modify (EditRelationship.aspx)" ); 
                return; 
            } 
            
            // check if other node is selected
            int leftNodeID = GetLeftNodeID(); 
            int rightNodeID = GetRightNodeID(); 
            if ( leftNodeID == 0 | rightNodeID == 0 ) { 
                this.lblError.Text = ResMan.GetString( "EditRelationship.ErrorNoNodeSelected" ); 
                return; 
            } 
            
            // check if relationshipname is selected
            if ( this.drpRelationshipName.SelectedItem == null ) { 
                this.lblError.Text = ResMan.GetString( "EditRelationship.ErrorNoRelationshipNameSelected" ); 
                return; 
            } 
            
            GeneralConnection cn = new GeneralConnection( Functions.GetConnectionString() ); 
            int relationshipNameID = int.Parse( this.drpRelationshipName.SelectedValue ); 
            
            object[,] paramsIdent = new object[ 3, 3 ]; 
            paramsIdent[ 0, 0 ] = "@LeftNodeID"; 
            paramsIdent[ 0, 1 ] = leftNodeID; 
            paramsIdent[ 1, 0 ] = "@RightNodeID"; 
            paramsIdent[ 1, 1 ] = rightNodeID; 
            paramsIdent[ 2, 0 ] = "@RelationshipNameID"; 
            paramsIdent[ 2, 1 ] = relationshipNameID; 
            
            // check if relationship already exists
            DataSet ds = cn.ExecuteQuery( "cms.relationship.selectrecord", paramsIdent ); 
            if ( ds.Tables[ 0 ].Rows.Count > 0 ) { 
                // relationship already exists
                this.lblError.Text = ResMan.GetString( "EditRelationship.ErrorRelationshipAlreadyExists" ); 
                return; 
            } 
            
            // save relationship
            cn.ExecuteQuery( "cms.relationship.insert", paramsIdent ); 
            Response.Redirect( System.Convert.ToString( ViewState[ "ReturnPage" ] ) ); 
        } 
        
        
        private void btnCancel_Click( System.Object sender, System.EventArgs e ) { 
            Response.Redirect( System.Convert.ToString( ViewState[ "ReturnPage" ] ) ); 
        } 
        
        
        private void FillRelationshipNames( int relationshipNameID ) { 
            DataSet ds = null; 
            DataRow dr = null; 
            GeneralConnection cn = new GeneralConnection( Functions.GetConnectionString() ); 
            
            // load values
            ds = cn.ExecuteQuery( "cms.relationshipName.select", null ); 
            foreach ( System.Data.DataRow transTemp0 in ds.Tables[ 0 ].Rows ) { 
                dr = transTemp0;  
                this.drpRelationshipName.Items.Add( new ListItem( System.Convert.ToString( dr[ "RelationshipDisplayName" ] ), System.Convert.ToInt32( dr[ "RelationshipNameID" ] ).ToString() ) ); 
            }
            
            // select value
            if ( relationshipNameID != 0 ) { 
                this.drpRelationshipName.SelectedValue = relationshipNameID.ToString(); 
            } 
        } 
        
        
        private LiteralControl GetMainNode( int nodeID ) { 
            LiteralControl ctrl = new LiteralControl(); 
            TreeNode node = Functions.GetTreeProvider().SelectSingleNode( nodeID ); 
            ctrl.Text = System.Convert.ToString( node.GetValue( "NodeName" ) ); 
            return ctrl; 
        } 
        
        
        private Panel GetOtherNode( int nodeID ) { 
            Panel pnl = new Panel(); 
            TextBox hiddenField = new TextBox(); 
            TextBox txtOtherName = new TextBox(); 
            
            hiddenField.ID = "otherNodeID"; 
            hiddenField.Attributes.Add( "style", "display:none" ); 
            hiddenField.Text = nodeID.ToString(); 
            
            txtOtherName.ID = "otherNodeID_name"; 
            txtOtherName.ReadOnly = true; 
            txtOtherName.Attributes.Add( "style", "width:200px" ); 
            
            // add node name
            if ( nodeID != 0 ) { 
                TreeNode node = Functions.GetTreeProvider().SelectSingleNode( nodeID ); 
                txtOtherName.Text = System.Convert.ToString( node.GetValue( "NamePath" ) ); 
                // pnl.Controls.Add(New LiteralControl(CType(node.GetValue("NodeName"), String)))
                pnl.Controls.Add( hiddenField ); 
                pnl.Controls.Add( txtOtherName ); 
            } 
            else { 
                pnl.Controls.Add( hiddenField ); 
                pnl.Controls.Add( txtOtherName ); 
            } 
            
            // add select button
            pnl.Controls.Add( new LiteralControl( @"<br><input style=""width:155px"" class=""FormButton"" onclick=""window.open('SelectNodeFrameset.aspx?targetID=" + hiddenField.ClientID + @"', '_blank', 'height=500,width=600,left=100,top=50,location=no,menubar=no,resizable=yes,scrollbars=yes,status=no,titlebar=yes,toolbar=no');"" type=""button"" value=""" + ResMan.GetString( "EditRelationship.btnSelectNode" ) + @""">" ) ); 
            return pnl; 
        } 
        
        
        public int GetLeftNodeID() { 
            if ( this.MainNodePosition == "left" ) { 
                return mainNodeID; 
            } 
            else { 
                TextBox hiddenField = ( ( TextBox )( this.pnlLeftNode.FindControl( "otherNodeID" ) ) ); 
                return int.Parse( hiddenField.Text ); 
            } 
        } 
        
        
        public int GetRightNodeID() { 
            if ( this.MainNodePosition == "left" ) { 
                TextBox hiddenField = ( ( TextBox )( this.pnlLeftNode.FindControl( "otherNodeID" ) ) ); 
                return int.Parse( hiddenField.Text ); 
            } 
            else { 
                return mainNodeID; 
            } 
        } 
        
        
        
        private void btnSwitch_Click( System.Object sender, System.EventArgs e ) { 
            if ( this.MainNodePosition == "left" ) { 
                this.SelectedNodeID = this.GetRightNodeID(); 
                this.MainNodePosition = "right"; 
            } 
            else { 
                this.SelectedNodeID = this.GetLeftNodeID(); 
                this.MainNodePosition = "left"; 
            } 
            LoadNodeControls(); 
        } 
        
        
        
        protected string MainNodePosition { 
            get { 
                if ( ViewState[ "MainNodePosition" ] == null ) { 
                    ViewState[ "MainNodePosition" ] = "left"; 
                } 
                return System.Convert.ToString( ViewState[ "MainNodePosition" ] ); 
            } 
            set { 
                ViewState[ "MainNodePosition" ] = value; 
            } 
        } 
        
        
        protected int SelectedNodeID { 
            get { 
                if ( ViewState[ "SelectedNodeID" ] == null ) { 
                    ViewState[ "SelectedNodeID" ] = 0; 
                } 
                return System.Convert.ToInt32( ViewState[ "SelectedNodeID" ] ); 
            } 
            set { 
                ViewState[ "SelectedNodeID" ] = value; 
            } 
        } 
        
        
        private void LoadNodeControls() { 
            this.pnlLeftNode.Controls.Clear(); 
            this.pnlRightNode.Controls.Clear(); 
            if ( this.MainNodePosition == "left" ) { 
                // set left node        
                this.pnlLeftNode.Controls.Add( GetMainNode( mainNodeID ) ); 
                // set right node
                this.pnlRightNode.Controls.Add( GetOtherNode( this.SelectedNodeID ) ); 
            } 
            else { 
                // set left node        
                this.pnlLeftNode.Controls.Add( GetOtherNode( this.SelectedNodeID ) ); 
                // set right node
                this.pnlRightNode.Controls.Add( GetMainNode( mainNodeID ) ); 
            } 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
