using Kentico.CMS.TreeEngine; 
using System.IO; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class GetFile : System.Web.UI.Page { 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
        } 
        
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            TreeProvider tree = Functions.GetTreeProvider(); 
            TreeNode fileNode = null; 
            string fileName = null; 
            string idpath = "" + Request.QueryString[ "idpath" ]; 
            string aliaspath = null; 
            string fileDiskPath = null; 
            byte[] data = null; 
            FileStream strm = null; 
            int length = 0; 
            int versionHistoryID = 0; 
            string filepath = "" + Request.QueryString[ "filepath" ]; 
            
            if ( !( Request.QueryString[ "VersionHistoryID" ] == null ) ) { 
                versionHistoryID = int.Parse( "" + Request.QueryString[ "VersionHistoryID" ] ); 
            } 
            
            if ( versionHistoryID == 0 ) { 
                // current version            
                // if it's filepath, convert it to the IDPath
                if ( ( !( filepath == null ) ) && filepath + "" != "" ) { 
                    string parentAliasPath = System.IO.Path.GetDirectoryName( filepath ).Replace( @"\", "/" ); 
                    string searchedFileName = System.IO.Path.GetFileName( filepath ); 
                    if ( !( parentAliasPath.EndsWith( "/" ) ) ) { 
                        parentAliasPath += "/"; 
                    } 
                    parentAliasPath += "%"; 
                    // when multilingual support add language string to parentaliaspath
                    if ( ( !( ConfigurationSettings.AppSettings[ "CMSUseMultilingualSupport" ] == null ) ) && ( ConfigurationSettings.AppSettings[ "CMSUseMultilingualSupport" ] == "true" ) ) { 
                        HttpCookie lang = Request.Cookies[ "CMSPreferredCulture" ]; 
                        if ( !( lang == null ) ) { 
                            parentAliasPath = "/" + lang.Value + parentAliasPath; 
                        } 
                        else { 
                            parentAliasPath = "/" + Functions.GetPreferredContentCultureCode() + parentAliasPath; 
                        } 
                    } 
                    DataSet dsFiles = tree.SelectNodes( parentAliasPath, TreePathTypeEnum.AliasPath, "cms.file", " filename = '" + searchedFileName.Replace( "'", "''" ) + "' " ); 
                    if ( dsFiles.Tables[ 0 ].Rows.Count > 0 ) { 
                        idpath = System.Convert.ToString( dsFiles.Tables[ 0 ].Rows[ 0 ][ "IDPath" ] ); 
                    } 
                    else { 
                        return; 
                    } 
                } 
                // check permissions
                if ( Functions.IsAuthorizedPerResource( "CMS.Content", "read" ) | Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read ) ) { 
                    // get file specified by IDPath
                    // get file name
                    fileNode = tree.SelectSingleNode( idpath, TreePathTypeEnum.IDPath, "cms.file" ); 
                    if ( fileNode == null ) { 
                        return; 
                    } 
                    fileName = System.Convert.ToString( fileNode.GetValue( "FileName" ) ); 
                    aliaspath = System.Convert.ToString( fileNode.GetValue( "AliasPath" ) ); 
                    fileDiskPath = Functions.GetFileFolderPath( aliaspath ) + @"\" + fileName; 
                    
                    if ( File.Exists( fileDiskPath ) ) { 
                        strm = File.OpenRead( fileDiskPath ); 
                        length = System.Convert.ToInt32( strm.Length ); 
                        data = new byte[ length ]; 
                        strm.Read( data, 0, length ); 
                        strm.Close(); 
                    } 
                    // display file
                    Response.Clear(); 
                    Response.ContentType = System.Convert.ToString( fileNode.GetValue( "FileMimeType" ) ); 
                    Response.AddHeader( "Content-Disposition", "attachment; filename=" + fileName ); 
                    Response.OutputStream.Write( data, 0, length ); 
                    Response.End(); 
                } 
            } 
            else { 
                // get specified earlier version
                VersionManager verMan = new VersionManager( tree ); 
                fileNode = verMan.GetVersion( versionHistoryID ); 
                if ( fileNode == null ) { 
                    return; 
                } 
                
                // check permissions
                TreeNode currentNode = tree.SelectSingleNode( System.Convert.ToInt32( fileNode.GetValue( "NodeID" ) ) ); 
                if ( !( ( Functions.IsAuthorizedPerResource( "CMS.Content", "Read" ) | Functions.IsAuthorizedPerNode( System.Convert.ToString( currentNode.GetValue( "IDPath" ) ), TreePathTypeEnum.IDPath, NodePermissionsEnum.Read ) ) ) ) { 
                    return; 
                } 
                
                // get file name
                fileName = System.Convert.ToString( fileNode.GetValue( "FileName" ) ); 
                aliaspath = System.Convert.ToString( fileNode.GetValue( "AliasPath" ) ); 
                data = ( ( byte[] )( fileNode.GetValue( "FileBinary" ) ) ); 
                // display file
                Response.Clear(); 
                Response.ContentType = System.Convert.ToString( fileNode.GetValue( "FileMimeType" ) ); 
                Response.OutputStream.Write( data, 0, data.Length ); 
                Response.AddHeader( "Content-Disposition", "attachment; filename=" + fileName ); 
                Response.End(); 
            } 
        } 
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
