using Kentico.CMS.TreeEngine; 
using Kentico.CMS.DataEngine; 
using Kentico.CMS.MetadataEngine; 
using Kentico.CMS.WorkflowEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class History : System.Web.UI.Page { 
        
        protected bool allowRollback = true; 
        protected string viewHint; 
        protected string rollbackHint; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblError; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlConfirmScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnDestroyHistory; 
        protected string destroyHint; 
        protected string idpath; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by DeleteItem
             
            QueryDataGrid1.DeleteCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler( DeleteItem ); 
            // events handled by QueryDataGrid1_DataBind
             
            QueryDataGrid1.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler( QueryDataGrid1_DataBind ); 
            // events handled by btnDestroyHistory_Click
             
            btnDestroyHistory.Click += new System.EventHandler( btnDestroyHistory_Click ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ Kentico.CMS.CMSControls.QueryDataGrid QueryDataGrid1; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblInfo; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            idpath = "" + Request.QueryString[ "idpath" ] + ""; 
            string culture = "" + Request.QueryString[ "culture" ] + ""; 
            TreeNode node = null; 
            TreeProvider tree = Functions.GetTreeProvider(); 
            int nodeid = 0; 
            
            lblError.Text = ""; 
            lblHeader.Text = ResMan.GetString( "History.Header" ); 
            viewHint = ResMan.GetString( "History.ViewHint" ); 
            rollbackHint = ResMan.GetString( "History.RollbackHint" ); 
            destroyHint = ResMan.GetString( "History.DestroyHint" ); 
            ltlConfirmScript.Text = @"<input type=""hidden"" id=""confirmationText"" value=""" + ResMan.GetString( "RecycleBin.ConfirmDestroy" ) + @""">"; 
            btnDestroyHistory.Text = ResMan.GetString( "History.DestroyHistory" ); 
            if ( !( Page.IsPostBack ) ) { 
                btnDestroyHistory.Attributes.Add( "onclick", "return confirm('" + ResMan.GetString( "History.ConfirmHistoryDestroy" ) + "');" ); 
            } 
            QueryDataGrid1.Columns[ 0 ].HeaderText = ResMan.GetString( "History.Action" ); 
            QueryDataGrid1.Columns[ 1 ].HeaderText = ResMan.GetString( "History.ModifiedWhen" ); 
            QueryDataGrid1.Columns[ 2 ].HeaderText = ResMan.GetString( "History.ModifiedByUserFullName" ); 
            QueryDataGrid1.Columns[ 3 ].HeaderText = ResMan.GetString( "History.VersionNumber" ); 
            QueryDataGrid1.Columns[ 4 ].HeaderText = ResMan.GetString( "History.VersionComment" ); 
            QueryDataGrid1.Columns[ 5 ].HeaderText = ResMan.GetString( "History.PublishFrom" ); 
            QueryDataGrid1.Columns[ 6 ].HeaderText = ResMan.GetString( "History.PublishTo" ); 
            QueryDataGrid1.Columns[ 7 ].HeaderText = ResMan.GetString( "History.WasPublishedFrom" ); 
            QueryDataGrid1.Columns[ 8 ].HeaderText = ResMan.GetString( "History.WasPublishedTo" ); 
            
            // get node
            node = Functions.GetNodeByIDPathAndCulture( idpath, culture ); 
            
            // multilingual support
            if ( node == null ) { 
                // culture version does not exist
                node = tree.SelectSingleNode( idpath, TreePathTypeEnum.IDPath ); 
                Response.Redirect( "NewCultureVersion.aspx?idpath=" + idpath + "&aliaspath=" + System.Convert.ToString( node.GetValue( "aliaspath" ) ) + "&culture=" + culture ); 
                return; 
            } 
            else { 
                idpath = System.Convert.ToString( node.GetValue( "idpath" ) ); 
            } 
            nodeid = System.Convert.ToInt32( node.GetValue( "NodeID" ) ); 
            
            // check permissions        
            if ( !( ( Functions.IsAuthorizedPerResource( "CMS.Content", "Read" ) | Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read ) ) ) ) { 
                Functions.RedirectToAccessDenied( idpath, "Read (history.aspx)" ); 
                return; 
            } 
            if ( !( ( Functions.IsAuthorizedPerResource( "CMS.Content", "Modify" ) | Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Modify ) ) ) ) { 
                // do not allow rollback
                // allowRollback = False
            } 
            else { 
                // allowRollback = True
            } 
            
            // check if document type supports versioning
            if ( !( System.Convert.ToBoolean( Functions.GetClassDRValue( System.Convert.ToInt32( node.GetValue( "ClassID" ) ), "UseVersioning" ) ) ) ) { 
                QueryDataGrid1.Visible = false; 
                lblInfo.Visible = true; 
                lblError.Visible = false; 
                btnDestroyHistory.Visible = false; 
                lblInfo.Text = ResMan.GetString( "Lock.InfoDocumentDoesNotSupportVersioning" ); 
                return; 
            } 
            
            QueryDataGrid1.WhereCondition = " NodeID = " + nodeid.ToString(); 
        } 
        
        
        public void DeleteItem( object sender, System.Web.UI.WebControls.DataGridCommandEventArgs e ) { 
            // get node info
            TreeProvider tree = Functions.GetTreeProvider(); 
            int versionHistoryId = int.Parse( System.Convert.ToString( e.CommandArgument ) ); 
            DataClass versionHistoryObj = new DataClass( "cms.versionhistory", versionHistoryId, tree.Connection ); 
            VersionManager verMan = new VersionManager( tree ); 
            TreeNode node = tree.SelectSingleNode( System.Convert.ToInt32( versionHistoryObj.GetValue( "NodeID" ) ) ); 
            string idpath = System.Convert.ToString( node.GetValue( "IDPath" ) ); 
            
            // check permissions
            if ( !( Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Destroy ) ) ) { 
                lblError.Text = ResMan.GetString( "History.ErrorNotAllowedToDestroy" ); 
                return; 
            } 
            
            verMan.DestroyVersion( versionHistoryId ); 
            Response.Redirect( Page.Request.Url.ToString() ); 
        } 
        
        
        
        private void QueryDataGrid1_DataBind( System.Object sender, DataGridItemEventArgs e ) { 
            ImageButton btnCurrentButton = null; 
            
            // set up the Delete button
            if ( e.Item.ItemType == ListItemType.Item | e.Item.ItemType == ListItemType.AlternatingItem ) { 
                btnCurrentButton = ( ( ImageButton )( e.Item.Cells[ 0 ].FindControl( "btnDelete" ) ) ); 
                btnCurrentButton.Attributes.Add( "OnClick", "return ConfirmDestroy();" ); 
                btnCurrentButton.Attributes.Add( "title", destroyHint ); 
            } 
        } 
        
        
        private void btnDestroyHistory_Click( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Destroy ) ) ) { 
                lblError.Text = ResMan.GetString( "History.ErrorNotAllowedToDestroy" ); 
                return; 
            } 
            
            TreeNode node = Functions.GetTreeProvider().SelectSingleNode( idpath, TreePathTypeEnum.IDPath ); 
            if ( !( node == null ) ) { 
                int nodeId = System.Convert.ToInt32( node.GetValue( "NodeID" ) ); 
                VersionManager verMan = new VersionManager( Functions.GetTreeProvider() ); 
                verMan.DestroyNodeHistory( nodeId ); 
                Response.Redirect( Page.Request.Url.ToString() ); 
            } 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
