using Kentico.CMS.TreeEngine; 
using Kentico.CMS.MetadataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class Listing : System.Web.UI.Page { 
        
        protected string parentIDPath; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by btnSearch_Click
             
            btnSearch.Click += new System.EventHandler( btnSearch_Click ); 
            // events handled by CMSDataGrid1_SelectedIndexChanged
             
            CMSDataGrid1.SelectedIndexChanged += new System.EventHandler( CMSDataGrid1_SelectedIndexChanged ); 
            // events handled by CMSDataGrid1_ItemCommand
             
            CMSDataGrid1.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler( CMSDataGrid1_ItemCommand ); 
            // events handled by cmsdatagrid_bound
             
            CMSDataGrid1.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler( cmsdatagrid_bound ); 
            // events handled by ImageButton1_Click
             
            ImageButton1.Click += new System.Web.UI.ImageClickEventHandler( ImageButton1_Click ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblRedirect; 
        protected /* TRANSINFO: WithEvents */ Kentico.CMS.CMSControls.QueryDataGrid QueryDataGrid1; 
        protected /* TRANSINFO: WithEvents */ Kentico.CMS.CMSControls.CMSDataGrid CMSDataGrid1; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblSearchFor; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtSearchFor; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnSearch; 
        
        protected string selectText; 
        protected string unfoldText; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.ImageButton ImageButton1; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label Label1; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            string idPath = null; 
            TreeProvider tree = null; 
            TreeNode parentNode = null; 
            TreeNode node = null; 
            string listingPage = null; 
            string culture = null; 
            DataSet ds = null; 
            
            idPath = "" + Request.QueryString[ "idpath" ] + ""; 
            culture = "" + Request.QueryString[ "culture" ] + ""; 
            ltlScript.Text = ""; 
            SelectNodeScript( idPath ); 
            
            // get default culture parentIDPath
            if ( idPath == "/" ) { 
                parentIDPath = "/"; 
            } 
            else { 
                parentIDPath = idPath.Substring( 0, idPath.LastIndexOf( "/" ) ); 
            } 
            if ( parentIDPath + "" == "" ) { 
                parentIDPath = "/"; 
            } 
            // set onclick even of the "go up" button
            ImageButton1.Attributes.Add( "onclick", "javascript:unfold('" + parentIDPath + "');" ); 
            
            // optional redirection
            tree = Functions.GetTreeProvider(); 
            // get class name of the node
            node = tree.SelectSingleNode( idPath, TreePathTypeEnum.IDPath ); 
            // get the address of the listing page for specified class
            listingPage = Strings.Trim( MetadataProvider.GetSettingsValue( System.Convert.ToString( node.GetValue( "ClassName" ) ), "CMSListPage" ) + "" ); 
            if ( listingPage + "" != "" ) { 
                // redirect user to the listing page
                tree.Connection.DataConnection.Close(); 
                CMSDataGrid1.Visible = false; 
                lblRedirect.Visible = true; 
                lblRedirect.Text = ResMan.GetString( "ContentListing.Redirect" ); 
                Response.Redirect( listingPage + "?idpath=" + idPath ); 
            } 
            
            // display grid        
            TreeNode parent = tree.SelectSingleNode( idPath, TreePathTypeEnum.IDPath ); 
            string aliasPath = System.Convert.ToString( parent.GetValue( "AliasPath" ) ); 
            if ( Functions.UseMultilingualSupport() & culture + "" != "" & idPath != "/" ) { 
                aliasPath = "/" + culture + Functions.RemoveCultureFromAliasPath( aliasPath ); 
                // check if the node exists
                TreeNode testNode = tree.SelectSingleNode( aliasPath, TreePathTypeEnum.AliasPath ); 
                if ( testNode == null ) { 
                    Response.Redirect( "NewCultureVersion.aspx?idpath=" + idPath + "&aliaspath=" + aliasPath + "&culture=" + culture ); 
                    return; 
                } 
                else { 
                    idPath = System.Convert.ToString( testNode.GetValue( "IDPath" ) ); 
                } 
            } 
            if ( aliasPath == "/" ) { 
                aliasPath = "/%"; 
            } 
            else { 
                aliasPath += "/%"; 
            } 
            
            // check permissions
            if ( ( !( ( Functions.IsAuthorizedPerResource( "CMS.Content", "ExploreTree" ) | Functions.IsAuthorizedPerNode( idPath, TreePathTypeEnum.IDPath, NodePermissionsEnum.ExploreTree ) ) ) | ( ConfigurationSettings.AppSettings[ "CMSAllowUnfoldingOfAnyDocument" ] + "" ).ToLower().Trim() == "false" & !( Functions.IsAuthorizedPerNode( idPath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read ) ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.Content", "ExploreTree (listing.aspx)" ); 
                return; 
            } 
            
            // get dataset
            string gridPreferredCultureCode = null; 
            string gridSelectNodesPath = null; 
            string gridSelectNodesWhere = null; 
            int gridSelectNodesMaxRelativeLevel = 0; 
            
            CMSDataGrid1.TreeProvider = tree; 
            if ( Functions.UseMultilingualSupport() & culture + "" != "" & idPath != "/" ) { 
                gridPreferredCultureCode = culture; 
                if ( Functions.RemoveCultureFromAliasPath( aliasPath ) == "/" ) { 
                    gridSelectNodesPath = "/" + culture; 
                } 
                else { 
                    gridSelectNodesPath = "/" + culture + Functions.RemoveCultureFromAliasPath( aliasPath ); 
                } 
            } 
            else { 
                gridSelectNodesPath = aliasPath; 
            } 
            gridSelectNodesWhere = " NodeLevel <> 0 AND NodeName LIKE N'%" + this.txtSearchFor.Text.Replace( "'", "''" ) + "%' "; 
            if ( culture + "" != "" ) { 
                CMSDataGrid1.PreferredCultureCode = culture; 
            } 
            CMSDataGrid1.SelectNodesPath = Functions.RemoveCultureFromAliasPath( gridSelectNodesPath ); 
            CMSDataGrid1.SelectNodesPathType = TreePathTypeEnum.AliasPath; 
            CMSDataGrid1.SelectNodesWhere = gridSelectNodesWhere; 
            CMSDataGrid1.SelectNodesMaxRelativeLevel = 1; 
            
            CMSDataGrid1.Columns[ 0 ].HeaderText = ResMan.GetString( "ContentListing.HeaderNodeName" ); 
            CMSDataGrid1.Columns[ 1 ].HeaderText = ResMan.GetString( "ContentListing.HeaderType" ); 
            CMSDataGrid1.Columns[ 2 ].HeaderText = ResMan.GetString( "ContentListing.HeaderModified" ); 
            string currentPath = gridSelectNodesPath; 
            if ( currentPath.EndsWith( "%" ) ) { 
                currentPath = currentPath.Substring( 0, currentPath.Length - 1 ); 
            } 
            if ( currentPath.EndsWith( "/" ) && currentPath != "/" ) { 
                currentPath = currentPath.Substring( 0, currentPath.Length - 1 ); 
            } 
            
            // get parent path and display it
            TreeNode currentNode = Functions.GetTreeProvider().SelectSingleNode( currentPath, TreePathTypeEnum.AliasPath ); 
            string currentNamePath = System.Convert.ToString( currentNode.GetValue( "NamePath" ) ); 
            string usersStartingNamePath = System.Convert.ToString( Functions.GetTreeProvider().SelectSingleNode( Functions.GetUsersStartingAliasPath(), TreePathTypeEnum.AliasPath ).GetValue( "NamePath" ) ); 
            bool isTopMostPath = false; 
            currentNamePath = Functions.RemoveCultureFromAliasPath( currentNamePath ); 
            if ( currentNamePath + "" == "" ) { 
                currentNamePath = "/"; 
            } 
            usersStartingNamePath = Functions.RemoveCultureFromAliasPath( usersStartingNamePath ); 
            if ( usersStartingNamePath + "" == "" ) { 
                usersStartingNamePath = "/"; 
            } 
            string[] tmpCurrentNamePathSplit = currentNamePath.Split( '/' ); 
            string[] tmpUsersStartingNamePathSplit = usersStartingNamePath.Split( '/' ); 
            if ( ( tmpCurrentNamePathSplit.GetUpperBound( 0 ) == tmpUsersStartingNamePathSplit.GetUpperBound( 0 ) & usersStartingNamePath != "/" ) | ( usersStartingNamePath == "/" & currentNamePath == "/" ) ) { 
                isTopMostPath = true; 
            } 
            if ( usersStartingNamePath != "/" ) { 
                int i = 0; 
                string tmpNamePath = ""; 
                for ( i=tmpUsersStartingNamePathSplit.GetUpperBound( 0 ); i<=tmpCurrentNamePathSplit.GetUpperBound( 0 ); i++ ) { 
                    if ( tmpCurrentNamePathSplit[ i ] + "" != "" ) { 
                        tmpNamePath += "/" + tmpCurrentNamePathSplit[ i ]; 
                    } 
                } 
                currentNamePath = tmpNamePath; 
            } 
            // hide "folder up" image if the current path is the top most path
            if ( isTopMostPath ) { 
                this.ImageButton1.Visible = false; 
                this.Label1.Visible = false; 
            } 
            else { 
                this.ImageButton1.Visible = true; 
                this.Label1.Visible = true; 
            } 
            lblHeader.Text = ResMan.GetString( "ContentListing.Header" ) + " " + currentNamePath; 
            lblSearchFor.Text = ResMan.GetString( "ContentListing.SearchFor" ); 
            btnSearch.Text = ResMan.GetString( "ContentListing.SearchButton" ); 
            selectText = ResMan.GetString( "ContentListing.SelectText" ); 
            unfoldText = ResMan.GetString( "ContentListing.UnfoldText" ); 
            
            if ( Page.IsPostBack ) { 
                CMSDataGrid1.SelectedIndex = -1; 
            } 
        } 
        
        
        private void btnSearch_Click( System.Object sender, System.EventArgs e ) { 
            CMSDataGrid1.CurrentPageIndex = 0; 
        } 
        
        
        private void CMSDataGrid1_SelectedIndexChanged( System.Object sender, System.EventArgs e ) { 
            string idpath = CMSDataGrid1.SelectedItem.Cells[ 4 ].Text; 
            SelectNodeScript( idpath ); 
        } 
        
        
        private void CMSDataGrid1_ItemCommand( System.Object sender, DataGridCommandEventArgs e ) { 
            if ( e.CommandName == "Unfold" ) { 
                string idpath = System.Convert.ToString( e.CommandArgument ); 
                Response.Redirect( "listing.aspx?idpath=" + idpath + "&culture=" + "" + Request.QueryString[ "culture" ] ); 
            } 
        } 
        
        
        
        private void cmsdatagrid_bound( object sender, DataGridItemEventArgs e ) { 
            LinkButton selectButton = null; 
            LinkButton unfoldButton = null; 
            
            // set up the Delete button
            if ( e.Item.ItemType == ListItemType.Item | e.Item.ItemType == ListItemType.AlternatingItem | e.Item.ItemType == ListItemType.SelectedItem ) { 
                unfoldButton = ( ( LinkButton )( e.Item.Cells[ 0 ].FindControl( "UnfoldButton" ) ) ); 
                unfoldButton.CommandArgument = System.Convert.ToString( ( ( DataRowView )( e.Item.DataItem ) ).Row[ "IDPath" ] ); 
                unfoldButton.Attributes.Add( "onclick", "javascript:unfold('" + System.Convert.ToString( ( ( DataRowView )( e.Item.DataItem ) ).Row[ "IDPath" ] ) + "');" ); 
            } 
            
        } 
        
        
        private void ImageButton1_Click( System.Object sender, System.Web.UI.ImageClickEventArgs e ) { 
            string culture = null; 
            culture = "" + Request.QueryString[ "culture" ] + ""; 
            Response.Redirect( "listing.aspx?idpath=" + parentIDPath + "&culture=" + culture ); 
        } 
        
        
        
        private void SelectNodeScript( string idpath ) { 
            // update selected node info at the header
            ltlScript.Text = @"<script language=""JavaScript"">" + Constants.vbCrLf; 
            ltlScript.Text += " try { " + Constants.vbCrLf; 
            ltlScript.Text += " parent.frames['header'].SelectNodeWithoutSelectingMode('" + idpath + "'); " + Constants.vbCrLf; 
            ltlScript.Text += " } catch (e) {} " + Constants.vbCrLf; 
            ltlScript.Text += "</script>"; 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
