using Kentico.CMS.TreeEngine; 
using Kentico.CMS.DataEngine; 
using Kentico.CMS.MetadataEngine; 
using Kentico.CMS.WorkflowEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class Lock : System.Web.UI.Page { 
        
        protected TreeNode node; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnCancel; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlSetModeScript; 
        protected TreeProvider tree; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by btnCheckOut_Click
             
            btnCheckOut.Click += new System.EventHandler( btnCheckOut_Click ); 
            // events handled by btnCheckIn_Click
             
            btnCheckIn.Click += new System.EventHandler( btnCheckIn_Click ); 
            // events handled by btnUndoCheckOut_Click
             
            btnUndoCheckOut.Click += new System.EventHandler( btnUndoCheckOut_Click ); 
            // events handled by btnCancel_Click
             
            btnCancel.Click += new System.EventHandler( btnCancel_Click ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblInfo; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnCheckOut; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnCheckIn; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnUndoCheckOut; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Panel pnlVersionInfo; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblVersionNumber; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblVersionComment; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtVersionNumber; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtVersionComment; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            string idpath = "" + Request.QueryString[ "idpath" ] + ""; 
            string culture = "" + Request.QueryString[ "culture" ] + ""; 
            tree = Functions.GetTreeProvider(); 
            
            // set lock mode
            if ( !( Page.IsPostBack ) ) { 
                ltlSetModeScript.Text = @"<script language=""JavaScript"">" + Constants.vbCrLf; 
                ltlSetModeScript.Text += " try " + Constants.vbCrLf; 
                ltlSetModeScript.Text += " { " + Constants.vbCrLf; 
                ltlSetModeScript.Text += "  parent.frames['header'].SetMode('lock'); " + Constants.vbCrLf; 
                ltlSetModeScript.Text += " } " + Constants.vbCrLf; 
                ltlSetModeScript.Text += " catch (e)" + Constants.vbCrLf; 
                ltlSetModeScript.Text += " { " + Constants.vbCrLf; 
                ltlSetModeScript.Text += " } " + Constants.vbCrLf; 
                ltlSetModeScript.Text += "</script>" + Constants.vbCrLf; 
            } 
            else { 
                ltlSetModeScript.Text = ""; 
            } 
            
            // generate correct return URL
            if ( ( !( Page.IsPostBack ) ) & "" + Request.QueryString[ "returnback" ] + "" + "" != "" ) { 
                this.btnCancel.Visible = true; 
                if ( Strings.InStr( Request.UrlReferrer.ToString().ToLower(), "edit.aspx", (Microsoft.VisualBasic.CompareMethod)(0) ) > 0 && Strings.InStr( Request.UrlReferrer.ToString().ToLower(), "action=insert", (Microsoft.VisualBasic.CompareMethod)(0) ) > 0 ) { 
                    ViewState[ "returnback" ] = "edit.aspx?idpath=" + idpath + "&culture=" + culture; 
                } 
                else { 
                    ViewState[ "returnback" ] = Request.UrlReferrer.ToString(); 
                } 
            } 
            
            this.lblHeader.Text = ResMan.GetString( "Lock.Header" ); 
            this.btnCheckOut.Text = ResMan.GetString( "Lock.CheckOut" ); 
            this.btnCheckIn.Text = ResMan.GetString( "Lock.CheckIn" ); 
            this.btnUndoCheckOut.Text = ResMan.GetString( "Lock.UndoCheckOut" ); 
            this.lblVersionNumber.Text = ResMan.GetString( "Lock.VersionNumber" ); 
            this.lblVersionComment.Text = ResMan.GetString( "Lock.VersionComment" ); 
            this.btnCancel.Text = ResMan.GetString( "Lock.Cancel" ); 
            
            if ( Functions.UseMultilingualSupport() ) { // multilingual support
                // get node
                node = Functions.GetNodeByIDPathAndCulture( idpath, culture ); 
                if ( node == null ) { 
                    // culture version does not exist            
                    node = tree.SelectSingleNode( idpath, TreePathTypeEnum.IDPath ); 
                    Response.Redirect( "NewCultureVersion.aspx?idpath=" + idpath + "&aliaspath=" + System.Convert.ToString( node.GetValue( "aliaspath" ) ) + "&culture=" + culture ); 
                    return; 
                } 
                else { 
                    idpath = System.Convert.ToString( node.GetValue( "idpath" ) ); 
                } 
            } 
            else { 
                node = tree.SelectSingleNode( idpath, TreePathTypeEnum.IDPath ); 
            } 
            
            // check permissions
            if ( !( ( Functions.IsAuthorizedPerResource( "CMS.Content", "Read" ) | Functions.IsAuthorizedPerResource( "CMS.Content", "CheckInAll" ) | Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read ) ) ) ) { 
                Functions.RedirectToAccessDenied( idpath, "Read (lock.aspx)" ); 
                return; 
            } 
            if ( !( ( Functions.IsAuthorizedPerResource( "CMS.Content", "Modify" ) | Functions.IsAuthorizedPerResource( "CMS.Content", "CheckInAll" ) | Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Modify ) ) ) ) { 
                // disable form
                pnlVersionInfo.Enabled = false; 
            } 
            
            // check if document type supports versioning
            if ( !( System.Convert.ToBoolean( Functions.GetClassDRValue( System.Convert.ToInt32( node.GetValue( "ClassID" ) ), "UseVersioning" ) ) ) ) { 
                pnlVersionInfo.Visible = false; 
                lblInfo.Text = ResMan.GetString( "Lock.InfoDocumentDoesNotSupportVersioning" ); 
                return; 
            } 
            
            // check if document is checked out
            if ( !( Page.IsPostBack ) ) { 
                if ( node.GetValue( "CheckedOutByUserID" ) == null ) { 
                    // document is not checked out - allow checkout
                    DisplayCheckedInInfo( System.Convert.ToString( node.GetValue( "IDPath" ) ) ); 
                } 
                else { 
                    // document is checked out - display information about user
                    DisplayCheckedOutInfo( System.Convert.ToString( node.GetValue( "IDPath" ) ) ); 
                } 
            } 
        } 
        
        
        
        // do check-out
        private void btnCheckOut_Click( System.Object sender, System.EventArgs e ) { 
            VersionManager verman = new VersionManager( Functions.GetTreeProvider() ); 
            
            // check out the document
            if ( node.GetValue( "CheckedOutVersionHistoryID" ) == null ) { 
                // insert new version history
                DataClass versionHistoryObj = null; 
                int versionHistoryID = 0; 
                versionHistoryObj = new DataClass( "cms.versionhistory", tree.Connection ); 
                versionHistoryObj.SetValue( "NodeID", node.GetValue( "NodeID" ) ); 
                versionHistoryObj.SetValue( "NodeNamePath", node.GetValue( "NamePath" ) ); 
                versionHistoryObj.SetValue( "NodeXML", node.DataRow.Table.DataSet.GetXml() ); 
                versionHistoryObj.SetValue( "ModifiedByUserID", Functions.GetUserID() ); 
                versionHistoryObj.SetValue( "ModifiedWhen", DateTime.Now ); 
                versionHistoryObj.SetValue( "VersionNumber", "" ); 
                versionHistoryObj.SetValue( "VersionComment", "" ); 
                versionHistoryObj.SetValue( "ToBePublished", 1 ); 
                versionHistoryObj.Insert(); 
                versionHistoryID = System.Convert.ToInt32( versionHistoryObj.GetValue( "VersionHistoryID" ) ); 
                node.SetValue( "CheckedOutVersionHistoryID", versionHistoryID ); 
                node.SetValue( "PublishedVersionHistoryID", versionHistoryID ); 
                node.Update(); 
            } 
            verman.CheckOut( System.Convert.ToInt32( node.GetValue( "NodeID" ) ), this.txtVersionComment.Text ); 
            
            if ( ViewState[ "returnback" ] == null ) { 
                DisplayCheckedOutInfo( System.Convert.ToString( node.GetValue( "IDPath" ) ) ); 
            } 
            else { 
                Response.Redirect( System.Convert.ToString( ViewState[ "returnback" ] ) ); 
            } 
        } 
        
        
        
        // display checked-out information 
        private void DisplayCheckedOutInfo( string idpath ) { 
            TreeProvider tree = Functions.GetTreeProvider(); 
            TreeNode node = tree.SelectSingleNode( idpath, TreePathTypeEnum.IDPath ); 
            string checkedoutby = System.Convert.ToString( node.GetValue( "CheckedOutByFullName" ) ) + " (" + System.Convert.ToString( node.GetValue( "CheckedOutByUserName" ) ) + ")"; 
            DateTime checkedoutwhen = System.Convert.ToDateTime( node.GetValue( "CheckedOutWhen" ) ); 
            DataClass versionHistoryObj = null; 
            
            this.lblInfo.Text = Strings.Replace( Strings.Replace( ResMan.GetString( "Lock.InfoDocumentCheckedOut" ), "{%username%}", checkedoutby, 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ), "{%when%}", checkedoutwhen.ToString(), 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ); 
            this.btnCheckOut.Visible = false; 
            this.btnCheckIn.Visible = true; 
            this.txtVersionNumber.Enabled = true; 
            if ( !( node.GetValue( "CheckedOutVersionHistoryID" ) == null ) ) { 
                versionHistoryObj = new DataClass( "cms.versionhistory", System.Convert.ToInt32( node.GetValue( "CheckedOutVersionHistoryID" ) ), tree.Connection ); 
                this.txtVersionNumber.Text = System.Convert.ToString( versionHistoryObj.GetValue( "VersionNumber" ) ); 
                this.txtVersionComment.Text = System.Convert.ToString( versionHistoryObj.GetValue( "VersionComment" ) ); 
            } 
            
            // check if it's possible to undo checkout
            this.btnUndoCheckOut.Visible = false; 
            object[,] paramsIdent = new object[ 1, 3 ]; 
            DataSet ds = null; 
            
            paramsIdent[ 0, 0 ] = "@NodeID"; 
            paramsIdent[ 0, 1 ] = System.Convert.ToInt32( node.GetValue( "NodeID" ) ); 
            ds = tree.Connection.ExecuteQuery( "cms.versionhistory.selecthistoryversionscount", paramsIdent ); 
            if ( ds.Tables[ 0 ].Rows.Count > 0 ) { 
                if ( System.Convert.ToInt32( ds.Tables[ 0 ].Rows[ 0 ][ "versioncount" ] ) > 1 ) { 
                    this.btnUndoCheckOut.Visible = true; 
                } 
            } 
            
            // check if current user is allowed to check in the checked out document
            if ( System.Convert.ToInt32( node.GetValue( "CheckedOutByUserID" ) ) == Functions.GetUserID() | Functions.IsAuthorizedPerResource( "CMS.Content", "CheckInAll" ) ) { 
                this.txtVersionComment.Enabled = true; 
                this.txtVersionNumber.Enabled = true; 
                this.btnCheckIn.Enabled = true; 
                this.btnCheckIn.CssClass = "FormButton200"; 
                this.btnUndoCheckOut.Enabled = true; 
                this.btnUndoCheckOut.CssClass = "FormButton200"; 
            } 
            else { 
                this.txtVersionComment.Enabled = false; 
                this.txtVersionNumber.Enabled = false; 
                this.btnCheckIn.Enabled = false; 
                this.btnCheckIn.CssClass = "FormButtonDisabled200"; 
                this.btnUndoCheckOut.Enabled = false; 
                this.btnUndoCheckOut.CssClass = "FormButtonDisabled200"; 
            } 
        } 
        
        
        
        // display checked-in information
        private void DisplayCheckedInInfo( string idpath ) { 
            TreeProvider tree = Functions.GetTreeProvider(); 
            TreeNode node = tree.SelectSingleNode( idpath, TreePathTypeEnum.IDPath ); 
            int versionHistoryID = System.Convert.ToInt32( node.GetValue( "CheckedOutVersionHistoryID" ) ); 
            DataClass versionHistoryObj = null; 
            WorkflowManager workMan = new WorkflowManager( tree ); 
            DataClass stepInfo = null; 
            string stepName = null; 
            
            this.lblInfo.Text = ResMan.GetString( "Lock.InfoDocumentNotCheckedOut" ); 
            if ( versionHistoryID != 0 ) { 
                versionHistoryObj = new DataClass( "cms.versionhistory", versionHistoryID, tree.Connection ); 
                this.txtVersionNumber.Text = System.Convert.ToString( versionHistoryObj.GetValue( "VersionNumber" ) ); 
            } 
            this.txtVersionNumber.Enabled = false; 
            this.txtVersionComment.Text = ""; 
            this.btnUndoCheckOut.Visible = false; 
            this.btnCheckOut.Visible = true; 
            this.btnCheckIn.Visible = false; 
            
            stepInfo = workMan.GetStepInfo( System.Convert.ToInt32( node.GetValue( "NodeID" ) ) ); 
            stepName = System.Convert.ToString( stepInfo.GetValue( "StepName" ) ).ToLower(); 
            
            // test if current user is allowed to edit document in the current workflow step
            if ( ( stepName != "edit" & stepName != "published" ) && ( !( workMan.CanUserApprove( System.Convert.ToInt32( node.GetValue( "NodeID" ) ) ) ) ) ) { 
                this.pnlVersionInfo.Enabled = false; 
                this.lblInfo.Text += " " + ResMan.GetString( "Lock.InfoCannotEditDueToWorkflowStatus" ); 
            } 
        } 
        
        
        
        // do check-in
        private void btnCheckIn_Click( System.Object sender, System.EventArgs e ) { 
            VersionManager verman = new VersionManager( Functions.GetTreeProvider() ); 
            
            // check out the document        
            verman.CheckIn( System.Convert.ToInt32( node.GetValue( "NodeID" ) ), this.txtVersionNumber.Text, this.txtVersionComment.Text ); 
            if ( ViewState[ "returnback" ] == null ) { 
                DisplayCheckedInInfo( System.Convert.ToString( node.GetValue( "IDPath" ) ) ); 
            } 
            else { 
                Response.Redirect( System.Convert.ToString( ViewState[ "returnback" ] ) ); 
            } 
        } 
        
        
        
        // undo checkout
        private void btnUndoCheckOut_Click( System.Object sender, System.EventArgs e ) { 
            VersionManager verman = new VersionManager( Functions.GetTreeProvider() ); 
            
            // undo check out
            verman.UndoCheckOut( System.Convert.ToInt32( node.GetValue( "NodeID" ) ) ); 
            DisplayCheckedInInfo( System.Convert.ToString( node.GetValue( "IDPath" ) ) ); 
        } 
        
        
        private void btnCancel_Click( System.Object sender, System.EventArgs e ) { 
            Response.Redirect( System.Convert.ToString( ViewState[ "returnback" ] ) ); 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
