using Kentico.CMS.DataEngine; 
using Kentico.CMS.TreeEngine; 
using Kentico.CMS.MetadataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class NewDoc : System.Web.UI.Page { 
        
        protected string parentIDPath; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by btnOK_Click
             
            btnOK.Click += new System.EventHandler( btnOK_Click ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblChooseType; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.ListBox lstClasses; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnOK; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Panel Panel1; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Panel Panel2; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblNoAllowedChild; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblError; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlSetModeScript; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            parentIDPath = "" + Request.QueryString[ "IDPath" ]; 
            ltlScript.Text = ""; 
            
            // set editing mode
            if ( !( Page.IsPostBack ) ) { 
                ltlSetModeScript.Text = @"<script language=""JavaScript"">" + Constants.vbCrLf; 
                ltlSetModeScript.Text += " try " + Constants.vbCrLf; 
                ltlSetModeScript.Text += " { " + Constants.vbCrLf; 
                ltlSetModeScript.Text += "  parent.frames['header'].SetMode('edit'); " + Constants.vbCrLf; 
                ltlSetModeScript.Text += " } " + Constants.vbCrLf; 
                ltlSetModeScript.Text += " catch (e)" + Constants.vbCrLf; 
                ltlSetModeScript.Text += " { " + Constants.vbCrLf; 
                ltlSetModeScript.Text += " } " + Constants.vbCrLf; 
                ltlSetModeScript.Text += "</script>" + Constants.vbCrLf; 
            } 
            else { 
                ltlSetModeScript.Text = ""; 
            } 
            
            if ( !( Page.IsPostBack ) ) { 
                lblHeader.Text = ResMan.GetString( "New.Header" ); 
                lblChooseType.Text = ResMan.GetString( "New.ChooseType" ); 
                btnOK.Text = ResMan.GetString( "New.OK" ); 
                lblNoAllowedChild.Text = ResMan.GetString( "New.NoAllowedChild" ); 
                
                // get allowed child types
                DataSet ds = null; 
                object[,] paramsIdent = new object[ 1, 3 ]; 
                TreeProvider tree = null; 
                TreeNode parentNode = null; 
                int parentClassID = 0; 
                
                tree = Functions.GetTreeProvider(); 
                tree.Connection.DataConnection.Open(); 
                // get the parent node to read its ClassID
                parentNode = tree.SelectSingleNode( parentIDPath, TreePathTypeEnum.IDPath ); 
                if ( parentNode == null ) { 
                    parentClassID = -1; 
                } 
                else { 
                    parentClassID = System.Convert.ToInt32( parentNode.GetValue( "ClassID" ) ); 
                } 
                // read allowed child classes and display them
                paramsIdent[ 0, 0 ] = "@ParentClassID"; 
                paramsIdent[ 0, 1 ] = parentClassID; 
                ds = tree.Connection.ExecuteQuery( "CMS.Class.SelectByParentClassID", paramsIdent ); 
                tree.Connection.DataConnection.Close(); 
                lstClasses.DataSource = ds.Tables[ 0 ]; 
                lstClasses.DataTextField = "ClassDisplayName"; 
                lstClasses.DataValueField = "ClassName"; 
                lstClasses.DataBind(); 
                
                if ( ds.Tables[ 0 ].Rows.Count > 0 ) { 
                    Panel1.Visible = true; 
                    Panel2.Visible = false; 
                    if ( lstClasses.Items.Count == 1 ) { 
                        lstClasses.SelectedIndex = 0; 
                        btnOK_Click( sender, e ); 
                    } 
                } 
                else { 
                    // no allowed child classes
                    Panel1.Visible = false; 
                    Panel2.Visible = true; 
                } 
            } 
        } 
        
        
        
        private void btnOK_Click( System.Object sender, System.EventArgs e ) { 
            // get selected item and redirect user to the appropriate edit page
            if ( lstClasses.SelectedItem == null ) { 
                lblError.Visible = true; 
                lblError.Text = ResMan.GetString( "New.Error_NoItemSelected" ); 
            } 
            else { 
                // If Functions.IsAuthorizedPerClass(lstClasses.SelectedItem.Value, "create") Or Functions.IsAuthorizedPerResource("CMS.Content", "Create") Then
                string editingPage = MetadataProvider.GetSettingsValue( lstClasses.SelectedItem.Value, "CMSEditPage" ); 
                if ( editingPage + "" == "" ) { 
                    editingPage = "Edit.aspx"; 
                } 
                Response.Redirect( editingPage + "?idpath=" + parentIDPath + "&action=insert&classname=" + lstClasses.SelectedValue ); 
                // Else
                // lblError.Text = ResMan.GetString("AccessDenied.NotAllowedToCreateDocument")
                // End If
            } 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
