using Kentico.CMS.TreeEngine; 
using System.IO; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class Properties : System.Web.UI.Page { 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by btnOK_Click
             
            btnOK.Click += new System.EventHandler( btnOK_Click ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblNodeName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblNodeType; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblNodeTypeValue; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblLastModified; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblLastModifiedValue; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblModifiedBy; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblModifiedByValue; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblNodeNameValue; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblNodeAlias; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlShowAdvanced; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblNodeIDPath; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblNodeAliasPath; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblNodeIDPathValue; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblNodeAliasPathValue; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblNodeNamePath; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblNodeNamePathValue; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtNodeAlias; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnOK; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblInfo; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblError; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblCreatedWhen; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblCreatedBy; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblCreatedWhenValue; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblCreatedByValue; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            string idpath = "" + Request.QueryString[ "idpath" ] + ""; 
            string culture = "" + Request.QueryString[ "culture" ] + ""; 
            lblInfo.Text = ""; 
            lblError.Text = ""; 
            ltlScript.Text = ""; 
            
            lblHeader.Text = ResMan.GetString( "ContentProperties.Header" ); 
            lblNodeName.Text = ResMan.GetString( "ContentProperties.NodeName" ); 
            lblNodeType.Text = ResMan.GetString( "ContentProperties.NodeType" ); 
            lblLastModified.Text = ResMan.GetString( "ContentProperties.LastModified" ); 
            lblModifiedBy.Text = ResMan.GetString( "ContentProperties.ModifiedBy" ); 
            lblNodeAlias.Text = ResMan.GetString( "ContentProperties.NodeAlias" ); 
            lblNodeIDPath.Text = ResMan.GetString( "ContentProperties.NodeIDPath" ); 
            lblNodeAliasPath.Text = ResMan.GetString( "ContentProperties.NodeAliasPath" ); 
            lblNodeNamePath.Text = ResMan.GetString( "ContentProperties.NodeNamePath" ); 
            lblCreatedBy.Text = ResMan.GetString( "ContentProperties.CreatedBy" ); 
            lblCreatedWhen.Text = ResMan.GetString( "ContentProperties.CreatedWhen" ); 
            ltlShowAdvanced.Text = "<b>" + ResMan.GetString( "ContentProperties.ShowAdvanced" ) + "</b>"; 
            btnOK.Text = ResMan.GetString( "ContentProperties.OK" ); 
            
            TreeProvider tree = null; 
            TreeNode node = null; 
            
            if ( !( Page.IsPostBack ) ) { 
                // set values
                tree = Functions.GetTreeProvider(); 
                node = tree.SelectSingleNode( idpath, TreePathTypeEnum.IDPath ); 
                if ( Functions.UseMultilingualSupport() & culture + "" != "" ) { 
                    string aliaspath = System.Convert.ToString( node.GetValue( "AliasPath" ) ); 
                    node = tree.SelectSingleNode( "/" + culture + Functions.RemoveCultureFromAliasPath( aliaspath ), TreePathTypeEnum.AliasPath ); 
                    if ( node == null ) { 
                        Response.Redirect( "NewCultureVersion.aspx?idpath=" + idpath + "&aliaspath=" + aliaspath + "&culture=" + culture ); 
                        return; 
                    } 
                    else { 
                        idpath = System.Convert.ToString( node.GetValue( "idpath" ) ); 
                    } 
                } 
                // check permissions
                if ( !( ( Functions.IsAuthorizedPerResource( "CMS.Content", "Read" ) | Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read ) ) ) ) { 
                    Functions.RedirectToAccessDenied( idpath, "Read (properties.aspx)" ); 
                    return; 
                } 
                if ( !( ( Functions.IsAuthorizedPerResource( "CMS.Content", "Modify" ) | Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Modify ) ) ) ) { 
                    this.txtNodeAlias.ReadOnly = true; 
                    this.btnOK.Enabled = false; 
                } 
                if ( !( node == null ) ) { 
                    lblNodeNameValue.Text = Server.HtmlEncode( System.Convert.ToString( node.GetValue( "NodeName" ) ) ); 
                    txtNodeAlias.Text = Server.HtmlEncode( System.Convert.ToString( node.GetValue( "NodeAlias" ) ) ); 
                    lblNodeTypeValue.Text = System.Convert.ToString( node.GetValue( "ClassDisplayName" ) ); 
                    lblLastModifiedValue.Text = System.Convert.ToDateTime( node.GetValue( "ModifiedWhen" ) ).ToString(); 
                    lblModifiedByValue.Text = System.Convert.ToString( node.GetValue( "FullName" ) ) + " (" + System.Convert.ToString( node.GetValue( "UserName" ) ) + ")"; 
                    lblNodeIDPathValue.Text = System.Convert.ToString( node.GetValue( "IDPath" ) ); 
                    lblNodeAliasPathValue.Text = Server.HtmlEncode( System.Convert.ToString( node.GetValue( "AliasPath" ) ) ); 
                    lblNodeNamePathValue.Text = Server.HtmlEncode( System.Convert.ToString( node.GetValue( "NamePath" ) ) ); 
                    lblCreatedWhenValue.Text = System.Convert.ToDateTime( node.GetValue( "CreatedWhen" ) ).ToString(); 
                    lblCreatedByValue.Text = System.Convert.ToString( node.GetValue( "CreatorFullName" ) ) + " (" + System.Convert.ToString( node.GetValue( "CreatorUserName" ) ) + ")"; 
                    if ( System.Convert.ToString( node.GetValue( "NodeAlias" ) ) + "" == "" || ( Functions.UseMultilingualSupport() && node.ClassName.ToLower() == "cms.culture" ) ) { 
                        this.btnOK.Enabled = false; 
                        this.txtNodeAlias.ReadOnly = true; 
                    } 
                } 
            } 
        } 
        
        
        private void btnOK_Click( System.Object sender, System.EventArgs e ) { 
            // save alias
            string nodeAlias = null; 
            TreeProvider tree = null; 
            TreeNode node = null; 
            string oldAliasPath = null; 
            string culture = "" + Request.QueryString[ "culture" ]; 
            
            // check values
            nodeAlias = txtNodeAlias.Text.Trim(); 
            if ( nodeAlias + "" == "" ) { 
                lblError.Visible = true; 
                lblError.Text = ResMan.GetString( "ContentProperties.ErrorNoAliasEntered" ); 
            } 
            else { 
                tree = Functions.GetTreeProvider(); 
                
                node = tree.SelectSingleNode( "" + Request.QueryString[ "idpath" ], TreePathTypeEnum.IDPath ); 
                if ( Functions.UseMultilingualSupport() & culture + "" != "" ) { 
                    // find appropriate culture version
                    string aliaspath = System.Convert.ToString( node.GetValue( "AliasPath" ) ); 
                    node = tree.SelectSingleNode( "/" + culture + Functions.RemoveCultureFromAliasPath( aliaspath ), TreePathTypeEnum.AliasPath ); 
                } 
                if ( !( node == null ) ) { 
                    oldAliasPath = System.Convert.ToString( node.GetValue( "AliasPath" ) ); 
                    node.SetValue( "NodeAlias", nodeAlias ); 
                    node.Update(); 
                    Functions.EnsureFriendlyURL( System.Convert.ToString( node.GetValue( "AliasPath" ) ), oldAliasPath ); 
                    txtNodeAlias.Text = System.Convert.ToString( node.GetValue( "NodeAlias" ) ); 
                    lblNodeAliasPathValue.Text = System.Convert.ToString( node.GetValue( "aliaspath" ) ); 
                    lblInfo.Text = ResMan.GetString( "ContentProperties.ChangesSaved" ); 
                    // Refresh page which opened this dialog.
                    if ( "" + Request.QueryString[ "closeandupdate" ] == "1" ) { 
                        string path = null; 
                        
                        if ( ( !( ConfigurationSettings.AppSettings[ "CMSWebApplicationVirtualPath" ] == null ) ) && ConfigurationSettings.AppSettings[ "CMSWebApplicationVirtualPath" ] + "" != "" && ConfigurationSettings.AppSettings[ "CMSWebApplicationVirtualPath" ] != "/" ) { 
                            path = ConfigurationSettings.AppSettings[ "CMSWebApplicationVirtualPath" ] + Functions.RemoveCultureFromAliasPath( System.Convert.ToString( node.GetValue( "AliasPath" ) ) ); 
                        } 
                        else { 
                            path = Functions.RemoveCultureFromAliasPath( System.Convert.ToString( node.GetValue( "AliasPath" ) ) ); 
                        } 
                        
                        // Render client script.
                        ltlScript.Text = @"<script language=""javascript"">"; 
                        ltlScript.Text += " parent.frames['header'].UpdateContentAndClose('" + Strings.Replace( path, "'", @"\'", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + "'); "; 
                        ltlScript.Text += "</script>"; 
                    } 
                } 
            } 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
