using Kentico.CMS.DataEngine; 
using Kentico.CMS.MetadataEngine; 
using Kentico.CMS.TreeEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class Relationships : System.Web.UI.Page { 
        
        protected string editHint; 
        protected string deleteHint; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnAddRelationship; 
        protected bool deleteAllowed = false; 
        protected int nodeID; 
        protected string idpath; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by dtg_ItemDataBound
             
            QueryDataGrid1.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler( dtg_ItemDataBound ); 
            // events handled by btnAddRelationship_Click
             
            btnAddRelationship.Click += new System.EventHandler( btnAddRelationship_Click ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.ImageButton btnDelete; 
        protected /* TRANSINFO: WithEvents */ Kentico.CMS.CMSControls.QueryDataGrid QueryDataGrid1; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlConfirmScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            Functions.RedirectExpressEdition( "CMSDesk.Relationships" ); 
            
            idpath = "" + Request.QueryString[ "idpath" ] + ""; 
            string culture = "" + Request.QueryString[ "culture" ] + ""; 
            TreeProvider tree = null; 
            TreeNode node = null; 
            
            tree = Functions.GetTreeProvider(); 
            node = tree.SelectSingleNode( idpath, TreePathTypeEnum.IDPath ); 
            
            // multilingual support
            if ( Functions.UseMultilingualSupport() & culture + "" != "" ) { 
                string aliaspath = System.Convert.ToString( node.GetValue( "AliasPath" ) ); 
                node = tree.SelectSingleNode( "/" + culture + Functions.RemoveCultureFromAliasPath( aliaspath ), TreePathTypeEnum.AliasPath ); 
                if ( node == null ) { 
                    Response.Redirect( "NewCultureVersion.aspx?idpath=" + idpath + "&aliaspath=" + aliaspath + "&culture=" + culture ); 
                    return; 
                } 
                else { 
                    idpath = System.Convert.ToString( node.GetValue( "idpath" ) ); 
                } 
            } 
            
            ViewState[ "idpath" ] = idpath; 
            
            // check permissions
            if ( !( ( Functions.IsAuthorizedPerResource( "CMS.Content", "Read" ) | Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read ) ) ) ) { 
                Functions.RedirectToAccessDenied( idpath, "Read (properties.aspx)" ); 
                return; 
            } 
            
            // get node id
            nodeID = System.Convert.ToInt32( node.GetValue( "NodeID" ) ); 
            this.QueryDataGrid1.WhereCondition = " LeftNodeID = '" + nodeID.ToString() + "' OR RightNodeID = '" + nodeID.ToString() + "' "; 
            
            editHint = ResMan.GetString( "Relationships.EditHint" ); 
            deleteHint = ResMan.GetString( "Relationships.DeleteHint" ); 
            // set column header names
            QueryDataGrid1.Columns[ 0 ].HeaderText = ResMan.GetString( "Relationships.Action" ); 
            QueryDataGrid1.Columns[ 1 ].HeaderText = ResMan.GetString( "Relationships.LeftNodeDisplayName" ); 
            QueryDataGrid1.Columns[ 2 ].HeaderText = ResMan.GetString( "Relationships.RelationshipDisplayName" ); 
            QueryDataGrid1.Columns[ 3 ].HeaderText = ResMan.GetString( "Relationships.RightNodeDisplayName" ); 
            btnAddRelationship.Text = ResMan.GetString( "Relationships.btnAddRelationship" ); 
            
            // confirmation question
            if ( !( ( Functions.IsAuthorizedPerResource( "CMS.Content", "Modify" ) | Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Modify ) ) ) ) { 
                ltlConfirmScript.Text = @"<input type=""hidden"" id=""confirmationText"" value=""" + ResMan.GetString( "Relationships.DeleteDenied" ) + @""">"; 
                deleteAllowed = false; 
            } 
            else { 
                ltlConfirmScript.Text = @"<input type=""hidden"" id=""confirmationText"" value=""" + ResMan.GetString( "Relationships.ConfirmDelete" ) + @""">"; 
                deleteAllowed = true; 
            } 
            
            lblHeader.Text = ResMan.GetString( "Relationships.Header" ); 
        } 
        
        
        
        ///<summary>Deletes selected relationship name.</summary>
        public void DeleteItem( object sender, System.Web.UI.WebControls.DataGridCommandEventArgs e ) { 
            string[] arg = System.Convert.ToString( e.CommandArgument ).Split( ',' ); 
            int leftNodeId = int.Parse( arg[ 0 ] ); 
            int rightNodeId = int.Parse( arg[ 1 ] ); 
            int relationshipNameId = int.Parse( arg[ 2 ] ); 
            GeneralConnection cn = Functions.GetTreeProvider().Connection; 
            
            // delete the workflow
            object[,] paramsIdent = new object[ 3, 3 ]; 
            paramsIdent[ 0, 0 ] = "@LeftNodeID"; 
            paramsIdent[ 0, 1 ] = leftNodeId; 
            paramsIdent[ 1, 0 ] = "@RightNodeID"; 
            paramsIdent[ 1, 1 ] = rightNodeId; 
            paramsIdent[ 2, 0 ] = "@RelationshipNameID"; 
            paramsIdent[ 2, 1 ] = relationshipNameId; 
            
            cn.ConnectionString = Functions.GetConnectionString(); 
            cn.ExecuteQuery( "CMS.Relationship.Delete", paramsIdent ); 
            
            Response.Redirect( Page.Request.Url.ToString() ); 
        } 
        
        
        
        private void dtg_ItemDataBound( System.Object sender, DataGridItemEventArgs e ) { 
            ImageButton btnCurrentButton = null; 
            
            // set up the delete button
            if ( e.Item.ItemType == ListItemType.Item | e.Item.ItemType == ListItemType.AlternatingItem ) { 
                btnCurrentButton = ( ( ImageButton )( e.Item.Cells[ 0 ].FindControl( "btnDelete" ) ) ); 
                if ( deleteAllowed ) { 
                    btnCurrentButton.Attributes.Add( "OnClick", "return ConfirmDelete();" ); 
                } 
                else { 
                    btnCurrentButton.Attributes.Add( "OnClick", "DeleteDenied();" ); 
                } 
                btnCurrentButton.Attributes.Add( "title", deleteHint ); 
            } 
        } 
        
        
        private void btnAddRelationship_Click( System.Object sender, System.EventArgs e ) { 
            Response.Redirect( "editrelationship.aspx?mainnodeid=" + nodeID ); 
        } 
        
        
        private static string GetNodeText( object nodeName, object nodeIDPath ) { 
            return @"<a href=""contentframeset.aspx?expandmode=view&expandidpath=" + System.Convert.ToString( nodeIDPath ) + @""">" + System.Convert.ToString( nodeName ) + "</a>"; 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
