using Kentico.CMS.TreeEngine; 
using Kentico.CMS.WorkflowEngine; 
using Kentico.CMS.DataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class Rollback : System.Web.UI.Page { 
        
        protected int versionHistoryId; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by btnRollBack_Click
             
            btnRollBack.Click += new System.EventHandler( btnRollBack_Click ); 
            // events handled by btnCancel_Click
             
            btnCancel.Click += new System.EventHandler( btnCancel_Click ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblInfo; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnRollBack; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnCancel; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            this.lblHeader.Text = ResMan.GetString( "Rollback.Header" ); 
            this.btnRollBack.Text = ResMan.GetString( "Rollback.Rollback" ); 
            this.lblInfo.Text = ResMan.GetString( "Rollback.Confirm" ); 
            this.btnCancel.Text = ResMan.GetString( "Rollback.Cancel" ); 
            
            ViewState[ "historyUrl" ] = "history.aspx?idpath=" + "" + Request.QueryString[ "idpath" ] + "&nodeid=" + "" + Request.QueryString[ "nodeid" ] + "&culture=" + "" + Request.QueryString[ "culture" ]; 
            versionHistoryId = int.Parse( "" + Request.QueryString[ "VersionHistoryID" ] ); 
            int nodeID = int.Parse( "" + Request.QueryString[ "NodeID" ] ); 
            TreeProvider tree = Functions.GetTreeProvider(); 
            TreeNode node = tree.SelectSingleNode( nodeID ); 
            string idpath = System.Convert.ToString( node.GetValue( "idpath" ) ); 
            bool allowRollback = false; 
            
            // check permissions        
            if ( !( ( Functions.IsAuthorizedPerResource( "CMS.Content", "Read" ) | Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read ) ) ) ) { 
                Functions.RedirectToAccessDenied( idpath, "Read (history.aspx)" ); 
                return; 
            } 
            if ( !( ( Functions.IsAuthorizedPerResource( "CMS.Content", "Modify" ) | Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Modify ) ) ) ) { 
                // do not allow rollback
                allowRollback = false; 
                this.lblInfo.Text = ResMan.GetString( "Rollback.NotAllowedToModify" ); 
            } 
            else { 
                allowRollback = true; 
            } 
            
            // check status (checked-in/out)
            if ( allowRollback && !( node.GetValue( "CheckedOutByUserID" ) == null ) ) { 
                allowRollback = false; 
                this.lblInfo.Text = ResMan.GetString( "Rollback.DocumentIsCheckedOut" ); 
            } 
            
            // check workflow step
            WorkflowManager workMan = new WorkflowManager( tree ); 
            DataClass stepInfo = workMan.GetStepInfo( nodeID ); 
            if ( allowRollback && System.Convert.ToString( stepInfo.GetValue( "StepName" ) ).ToLower().Trim() != "edit" && System.Convert.ToString( stepInfo.GetValue( "StepName" ) ).ToLower().Trim() != "published" && !( workMan.CanUserApprove( nodeID ) ) ) { 
                allowRollback = false; 
                this.lblInfo.Text = ResMan.GetString( "Rollback.CannotModifyInThisStep" ); 
            } 
            
            this.btnRollBack.Enabled = allowRollback; 
        } 
        
        
        
        private void btnRollBack_Click( System.Object sender, System.EventArgs e ) { 
            VersionManager verMan = new VersionManager( Functions.GetTreeProvider() ); 
            verMan.RollbackVersion( versionHistoryId ); 
            this.lblInfo.Text = ResMan.GetString( "Rollback.RollbackDone" ); 
            this.btnRollBack.Enabled = false; 
        } 
        
        
        
        private void btnCancel_Click( System.Object sender, System.EventArgs e ) { 
            // redirect user back to the list of versions
            Response.Redirect( System.Convert.ToString( ViewState[ "historyUrl" ] ) ); 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
