using Kentico.CMS.CMSControls; 
using Kentico.CMS.TreeEngine; 
using Kentico.CMS.DataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class TreeData : System.Web.UI.Page { 
        
        private TreeProvider tree; 
        private const string cImageBasePath = "../Design/Tree"; 
        private const string cIconsBasePath = "../Design/Icons/"; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlRender; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            ltlRender.Text = @"<script language=""javascript"">" + Constants.vbCrLf; 
            ltlRender.Text += " try { " + Constants.vbCrLf; 
            
            try { 
                string action = null; 
                string idpath = null; 
                string aliasPath = null; 
                string nodeid = null; 
                string findIDPath = null; 
                string parentAliasPath = null; 
                
                if ( ( Request.QueryString[ "idpath" ] == null || Request.QueryString[ "idpath" ] == "" ) && ( !( Request.QueryString[ "nodeid" ] == null ) ) && Request.QueryString[ "nodeid" ].Trim() != "" ) { 
                    idpath = "" + Request.QueryString[ "nodeid" ]; 
                } 
                else { 
                    idpath = "" + Request.QueryString[ "idpath" ]; 
                } 
                action = Strings.LCase( Strings.Trim( "" + Request.QueryString[ "action" ] + "" ) ); 
                nodeid = "" + Request.QueryString[ "nodeid" ]; 
                findIDPath = "" + Request.QueryString[ "findidpath" ]; 
                tree = Functions.GetTreeProvider(); 
                switch ( action ) {
                    case "expandnode": case "findnode":
                        if ( ( !( ( Functions.IsAuthorizedPerResource( "CMS.Content", "ExploreTree" ) | Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.ExploreTree ) ) ) | ( ConfigurationSettings.AppSettings[ "CMSAllowUnfoldingOfAnyDocument" ] + "" ).ToLower().Trim() == "false" & !( Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read ) ) ) ) { 
                            ShowErrorMessage( ResMan.GetString( "AccessDenied.NotAllowedToUnfold" ) ); 
                        } 
                        else { 
                            if ( action == "findnode" && findIDPath.StartsWith( idpath ) ) { 
                                string currentExpandPath = idpath; 
                                string newExpandPath = null; 
                                if ( currentExpandPath == "/" ) { 
                                    newExpandPath = currentExpandPath + findIDPath.Split( '/' )[ 1 ]; 
                                } 
                                else { 
                                    if ( findIDPath == currentExpandPath ) { 
                                        newExpandPath = currentExpandPath; 
                                    } 
                                    else { 
                                        newExpandPath = currentExpandPath + "/" + findIDPath.Substring( currentExpandPath.Length ).Split( '/' )[ 1 ]; 
                                    } 
                                } 
                                AddRenderScript( GetChildNodes( currentExpandPath, "" + Request.QueryString[ "sample" ], "" + Request.QueryString[ "value" ] ), currentExpandPath ); 
                                if ( findIDPath != newExpandPath ) { 
                                    // find child node
                                    ltlRender.Text += " parent.frames['tree'].FindNode('" + findIDPath + "', '" + newExpandPath + "'); "; 
                                } 
                                else { 
                                    // select node
                                    AddSelectNodeScript( newExpandPath, false, true ); 
                                    ltlRender.Text += " parent.frames['header'].SelectNodeWithMode('" + newExpandPath + "', ''); "; 
                                } 
                            } 
                            else { 
                                AddRenderScript( GetChildNodes( "" + Request.QueryString[ "nodeid" ], "" + Request.QueryString[ "sample" ], "" + Request.QueryString[ "value" ] ), "" + Request.QueryString[ "nodeid" ] ); 
                                if ( "" + Request.QueryString[ "selectID" ] + "" + "" != "" ) { 
                                    AddSelectNodeScript( "" + Request.QueryString[ "selectID" ], false, true ); 
                                } 
                            } 
                        } 
                        break;
                    case "delete":
                        if ( !( ( Functions.IsAuthorizedPerResource( "CMS.Content", "Delete" ) | Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Delete ) ) ) ) { 
                            ShowErrorMessage( ResMan.GetString( "AccessDenied.NotAllowedToDeleteDocument" ) ); 
                        } 
                        else { 
                            string deletedIDPathParent = null; 
                            string culture = "" + Request.QueryString[ "culture" ] + ""; 
                            bool destroy = false; 
                            TreeNode node = null; 
                            bool useVersioning = false; 
                            
                            if ( ( "" + Request.QueryString[ "destroy" ] + "" ).ToLower().Trim() == "true" ) { 
                                destroy = true; 
                            } 
                            if ( Functions.UseMultilingualSupport() & culture + "" != "" ) { 
                                // aliasPath = "/" & culture & Functions.RemoveCultureFromAliasPath(GetAliasPath(idpath))
                                aliasPath = Functions.GetMultilingualAliasPath( idpath, culture ); 
                            } 
                            else { 
                                aliasPath = GetAliasPath( idpath ); 
                            } 
                            node = tree.SelectSingleNode( aliasPath, TreePathTypeEnum.AliasPath ); 
                            parentAliasPath = node.GetParentPath( TreePathTypeEnum.AliasPath ); 
                            useVersioning = System.Convert.ToBoolean( Functions.GetClassDRValue( System.Convert.ToInt32( node.GetValue( "ClassID" ) ), "UseVersioning" ) ); 
                            if ( ( destroy == true & useVersioning == true ) | ( useVersioning == false ) ) { 
                                Functions.DeleteFriendlyURL( aliasPath ); 
                                DeleteAttachements( idpath ); 
                            } 
                            deletedIDPathParent = DeleteNode( idpath, destroy ); 
                            // update UI
                            if ( "" + Request.QueryString[ "closewindow" ] == "true" ) { 
                                string path = null; 
                                if ( ( !( ConfigurationSettings.AppSettings[ "CMSWebApplicationVirtualPath" ] == null ) ) && ConfigurationSettings.AppSettings[ "CMSWebApplicationVirtualPath" ] + "" != "" && ConfigurationSettings.AppSettings[ "CMSWebApplicationVirtualPath" ] != "/" ) { 
                                    path = ConfigurationSettings.AppSettings[ "CMSWebApplicationVirtualPath" ] + Functions.RemoveCultureFromAliasPath( parentAliasPath ); 
                                } 
                                else { 
                                    path = Functions.RemoveCultureFromAliasPath( parentAliasPath ); 
                                } 
                                path = Functions.GetUrlForAliasPath( path ); 
                                this.ltlRender.Text += " parent.frames['header'].UpdateContentAndClose('" + Strings.Replace( path, "'", @"\'", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + "'); " + Constants.vbCrLf; 
                            } 
                            else { 
                                // reload node only if it is of default culture or multilingual support is not used
                                if ( Functions.UseMultilingualSupport() == false | ( Functions.UseMultilingualSupport() & aliasPath.Split( '/' ).Length > 2 && ( Strings.Trim( Strings.LCase( culture + "" ) ) == Strings.Trim( Strings.LCase( ConfigurationSettings.AppSettings[ "CMSDefaultCultureCode" ] + "" ) ) ) ) ) { 
                                    AddSelectNodeScript( deletedIDPathParent, true, false ); 
                                    AddReloadSelectedNodeScript(); 
                                } 
                                if ( Functions.UseMultilingualSupport() == true & Strings.Trim( Strings.LCase( culture + "" ) ) != Strings.Trim( Strings.LCase( ConfigurationSettings.AppSettings[ "CMSDefaultCultureCode" ] + "" ) ) ) { 
                                    AddSelectNodeScript( idpath, true, false ); 
                                    AddReloadSelectedNodeScript(); 
                                } 
                            } 
                        } 
                        break;
                    case "copy":
                        if ( !( ( ( Functions.IsAuthorizedPerResource( "CMS.Content", "read" ) | Functions.IsAuthorizedPerNode( "" + Request.QueryString[ "sourceIDPath" ], TreePathTypeEnum.IDPath, NodePermissionsEnum.Read ) ) & ( Functions.IsAuthorizedPerResource( "CMS.Content", "create" ) | Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Create ) ) ) ) ) { 
                            ShowErrorMessage( ResMan.GetString( "AccessDenied.NotAllowedToCopyDocument" ) ); 
                        } 
                        else { 
                            if ( ( "" + Request.QueryString[ "idpath" ] + "/" ).StartsWith( "" + Request.QueryString[ "sourceIDPath" ] + "/" ) ) { 
                                ShowErrorMessage( ResMan.GetString( "TreeData.CannotCopyNodeToItself" ) ); 
                            } 
                            else { 
                                // check allowed child types
                                int sourceClassID = System.Convert.ToInt32( tree.SelectSingleNode( "" + Request.QueryString[ "sourceIDPath" ], TreePathTypeEnum.IDPath ).GetValue( "ClassID" ) ); 
                                int targetClassID = System.Convert.ToInt32( tree.SelectSingleNode( "" + Request.QueryString[ "idpath" ], TreePathTypeEnum.IDPath ).GetValue( "ClassID" ) ); 
                                if ( !( CheckAllowedChildType( targetClassID, sourceClassID ) ) ) { 
                                    ShowErrorMessage( ResMan.GetString( "TreeData.CannotCopyNodeHere" ) ); 
                                } 
                                else { 
                                    // copy node
                                    CopyNode( "" + Request.QueryString[ "sourceIDPath" ], "" + Request.QueryString[ "idpath" ] ); 
                                    AddSelectNodeScript( "" + Request.QueryString[ "idpath" ], true, false ); 
                                    AddReloadSelectedNodeScript(); 
                                } 
                            } 
                        } 
                        break;
                    case "move":
                        if ( !( ( ( Functions.IsAuthorizedPerResource( "CMS.Content", "modify" ) | Functions.IsAuthorizedPerNode( "" + Request.QueryString[ "sourceIDPath" ], TreePathTypeEnum.IDPath, NodePermissionsEnum.Modify ) ) & ( Functions.IsAuthorizedPerResource( "CMS.Content", "create" ) | Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Create ) ) ) ) ) { 
                            ShowErrorMessage( ResMan.GetString( "AccessDenied.NotAllowedToMoveDocument" ) ); 
                        } 
                        else { 
                            if ( ( "" + Request.QueryString[ "idpath" ] + "/" ).StartsWith( "" + Request.QueryString[ "sourceIDPath" ] + "/" ) ) { 
                                ShowErrorMessage( ResMan.GetString( "TreeData.CannotMoveNodeToItself" ) ); 
                            } 
                            else { 
                                // check allowed child types
                                int sourceClassID = System.Convert.ToInt32( tree.SelectSingleNode( "" + Request.QueryString[ "sourceIDPath" ], TreePathTypeEnum.IDPath ).GetValue( "ClassID" ) ); 
                                int targetClassID = System.Convert.ToInt32( tree.SelectSingleNode( "" + Request.QueryString[ "idpath" ], TreePathTypeEnum.IDPath ).GetValue( "ClassID" ) ); 
                                if ( !( CheckAllowedChildType( targetClassID, sourceClassID ) ) ) { 
                                    ShowErrorMessage( ResMan.GetString( "TreeData.CannotMoveNodeHere" ) ); 
                                } 
                                else { 
                                    // move node
                                    MoveNode( "" + Request.QueryString[ "sourceIDPath" ], "" + Request.QueryString[ "idpath" ] ); 
                                    AddSelectNodeScript( "" + Request.QueryString[ "idpath" ], true, false ); 
                                    AddRemoveNodeScript( "" + Request.QueryString[ "sourceIDPath" ] ); 
                                    AddReloadSelectedNodeScript(); 
                                } 
                            } 
                        } 
                        break;
                }
                
            } 
            catch ( Exception ex ) { 
                ShowErrorMessage( "Error:" + ex.Message.Replace( Constants.vbCrLf, " " ) ); 
            } 
            ltlRender.Text += " } " + Constants.vbCrLf; 
            ltlRender.Text += " catch (e) { " + Constants.vbCrLf; 
            ltlRender.Text += " } " + Constants.vbCrLf; 
            ltlRender.Text += "</script>"; 
        } 
        
        
        
        ///<summary>Adds script that removes the given node from the displayed tree.</summary>
        ///<param name="nodeIDPath">IDPath of the node to be removed.</param>
        public void AddRemoveNodeScript( string nodeIDPath ) { 
            ltlRender.Text += " parent.frames['tree'].document.getElementById('nodeID_" + nodeIDPath + "').innerHTML = '';"; 
        } 
        
        
        
        ///<summary>Adds script that reloads the selected node.</summary>
        public void AddReloadSelectedNodeScript() { 
            ltlRender.Text += " parent.frames['tree'].ReloadSelectedNode();" + Constants.vbCrLf; 
        } 
        
        
        
        ///<summary>Adds script that selects given node.</summary>
        ///<param name="selectIDPath">IDPath of the node to be selected.</param>
        ///<param name="selectDesktop">Indicates if desktop should be updated.</param>
        ///<param name="selectMenu">Indicates if menu (header) selected item value should be updated.</param>
        public void AddSelectNodeScript( string selectIDPath, bool selectDesktop, bool selectMenu ) { 
            ltlRender.Text += " function SelectNode(selectID) {" + Constants.vbCrLf + "  //try {" + Constants.vbCrLf + "  parent.frames['tree'].SelectNode(selectID);" + Constants.vbCrLf; 
            if ( selectDesktop ) { 
                ltlRender.Text += "  parent.frames['header'].SelectNode(selectID);" + Constants.vbCrLf; 
            } 
            if ( selectMenu ) { 
                ltlRender.Text += "  parent.frames['header'].document.getElementById('idpath').value = selectID;" + Constants.vbCrLf; 
            } 
            ltlRender.Text += "  //} catch(e) { } " + Constants.vbCrLf + " } " + Constants.vbCrLf; 
            ltlRender.Text += " SelectNode('" + selectIDPath + "'); " + Constants.vbCrLf; 
        } 
        
        
        
        ///<summary>Adds content that will be rendered under given parent node.</summary>
        ///<param name="content">Content to be rendered.</param>
        ///<param name="targetNodeIDPath">Target node IDPath.</param>
        public void AddRenderScript( string content, string targetNodeIDPath ) { 
            string innerHTML = null; 
            innerHTML = Strings.Replace( content + "", "'", @"\'", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ); 
            innerHTML = Strings.Replace( innerHTML, @"""", @"\""", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ); 
            innerHTML = Strings.Replace( innerHTML, Constants.vbCrLf, " ", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ); 
            
            ltlRender.Text += " function RenderData() {" + Constants.vbCrLf + "  parent.frames['tree'].document.getElementById('sub_" + targetNodeIDPath + "').innerHTML = '" + innerHTML + "'; " + Constants.vbCrLf; 
            if ( innerHTML + "" + "" == "" ) { 
                ltlRender.Text += " parent.frames['tree'].document.getElementById('sub_" + targetNodeIDPath + "').style.display = 'none'; " + Constants.vbCrLf; 
            } 
            ltlRender.Text += " } " + Constants.vbCrLf; 
            ltlRender.Text += " RenderData(); " + Constants.vbCrLf; 
        } 
        
        
        
        ///<summary>Displays an error message.</summary>
        ///<param name="message">Error message.</param>
        public void ShowErrorMessage( string message ) { 
            ltlRender.Text += " alert('" + Strings.Replace( Strings.Replace( message + "", @"\", @"\\", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ), "'", @"\'", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + "');" + Constants.vbCrLf; 
            ltlRender.Text += " parent.frames['tree'].document.getElementById('sub_" + "" + Request.QueryString[ "NodeID" ] + "').innerHTML = ''; " + Constants.vbCrLf; 
            ltlRender.Text += " parent.frames['tree'].document.getElementById('sub_" + "" + Request.QueryString[ "NodeID" ] + "').style.display = 'none'; " + Constants.vbCrLf; 
        } 
        
        
        
        ///<summary>Returns child nodes at 2nd and lower level.</summary>
        ///<param name="NodeID">Parent node ID (IDPath).</param>
        ///<param name="Sample">Sample for displaying tree.</param>
        ///<param name="Value">Value of the parent node.</param>
        public string GetChildNodes( string NodeID, string Sample, string Value ) { 
            TreeNodes nodes = new TreeNodes(); 
            DataRow dr = null; 
            DataRowCollection nodeRows = null; 
            int maxNodeNumber = 100; 
            if ( ( !( ConfigurationSettings.AppSettings[ "CMSMaxTreeNodes" ] == null ) ) && ( ConfigurationSettings.AppSettings[ "CMSMaxTreeNodes" ] + "" != "" ) ) { 
                maxNodeNumber = int.Parse( ConfigurationSettings.AppSettings[ "CMSMaxTreeNodes" ] ); 
            } 
            int nodeNumber = 0; 
            
            nodes.ImagePathBase = cImageBasePath; 
            if ( NodeID == "/" ) { 
                nodeRows = tree.SelectNodes( "/%", TreePathTypeEnum.IDPath, "", " NodeLevel <> 0 ", "", 1 ).Tables[ 0 ].Rows; 
            } 
            else { 
                nodeRows = tree.SelectNodes( Value + "/%", TreePathTypeEnum.IDPath, "", "", "", 1 ).Tables[ 0 ].Rows; 
            } 
            foreach ( System.Data.DataRow transTemp0 in nodeRows ) { 
                dr = transTemp0;  
                nodes.NewNode( System.Convert.ToString( dr[ "NodeName" ] ), Value, cIconsBasePath + System.Convert.ToString( dr[ "classname" ] ) + ".gif", cIconsBasePath + System.Convert.ToString( dr[ "classname" ] ) + "_open.gif", System.Convert.ToString( dr[ "NodeName" ] ), "parent.frames['header'].SelectNode('" + System.Convert.ToString( dr[ "IDPath" ] ) + "')", System.Convert.ToString( dr[ "IDPath" ] ), Sample, true ); 
                nodeNumber += 1; 
                if ( nodeNumber >= maxNodeNumber ) { 
                    nodes.NewNode( ResMan.GetString( "treedata.uselisting" ), Value, cIconsBasePath + "blank.gif", cIconsBasePath + "blank.gif", ResMan.GetString( "treedata.uselisting" ), "parent.frames['header'].ChooseMode('listing'); parent.frames['header'].SetMode('listing'); parent.frames.header.SelectNode('" + NodeID + "');", "...", Sample, false ); 
                    break;  
                } 
            }
            return nodes.NodesHTML(); 
        } 
        
        
        
        ///<summary>Deletes specified node and returns IDPath of its parent.</summary>
        ///<param name="IDPath">IDPath of the node to be deleted.</param>
        public string DeleteNode( string IDPath, bool destroy ) { 
            // delete the node
            TreeProvider tree = Functions.GetTreeProvider(); 
            TreeNode node = null; 
            string parentIDPath = null; 
            string aliaspath = null; 
            string culture = "" + Request.QueryString[ "culture" ]; 
            VersionManager verMan = new VersionManager( tree ); 
            bool isMultilingualContent = false; 
            TreeNode cultureNode = null; 
            
            node = tree.SelectSingleNode( IDPath, TreePathTypeEnum.IDPath ); 
            parentIDPath = node.GetParentPath( TreePathTypeEnum.IDPath ); 
            if ( !( node == null ) ) { 
                // check if this is a multilingual content
                if ( IDPath.Split( '/' )[ 1 ] + "" != "" ) { 
                    cultureNode = tree.SelectSingleNode( "/" + IDPath.Split( '/' )[ 1 ], TreePathTypeEnum.IDPath ); 
                    if ( cultureNode.ClassName.ToLower() == "cms.culture" ) { 
                        isMultilingualContent = true; 
                    } 
                } 
                if ( Functions.UseMultilingualSupport() & culture + "" != "" & isMultilingualContent ) { 
                    if ( Strings.Trim( Strings.LCase( culture + "" ) ) == Strings.Trim( Strings.LCase( ConfigurationSettings.AppSettings[ "CMSDefaultCultureCode" ] + "" ) ) ) { 
                        // delete all culture versions
                        DataRow drCulture = null; 
                        string aliasPathWithoutCulture = Functions.RemoveCultureFromAliasPath( System.Convert.ToString( node.GetValue( "AliasPath" ) ) ); 
                        foreach ( System.Data.DataRow transTemp1 in GetCulturesDataSet( tree ).Tables[ 0 ].Rows ) { 
                            drCulture = transTemp1;  
                            try { 
                                aliaspath = "/" + System.Convert.ToString( drCulture[ "CultureCode" ] ) + aliasPathWithoutCulture; 
                                node = tree.SelectSingleNode( aliaspath, TreePathTypeEnum.AliasPath ); 
                                if ( !( node == null ) ) { 
                                    if ( destroy ) { 
                                        verMan.DestroyNodeHistory( System.Convert.ToInt32( node.GetValue( "NodeID" ) ) ); 
                                    } 
                                    node.Delete(); 
                                } 
                            } 
                            catch  { 
                            } 
                        }
                    } 
                    else { 
                        // delete only selected culture
                        aliaspath = Functions.GetMultilingualAliasPath( IDPath, culture ); 
                        node = tree.SelectSingleNode( aliaspath, TreePathTypeEnum.AliasPath ); 
                        if ( destroy ) { 
                            verMan.DestroyNodeHistory( System.Convert.ToInt32( node.GetValue( "NodeID" ) ) ); 
                        } 
                        node.Delete(); 
                    } 
                } 
                else { 
                    if ( destroy ) { 
                        verMan.DestroyNodeHistory( System.Convert.ToInt32( node.GetValue( "NodeID" ) ) ); 
                    } 
                    node.Delete(); 
                } 
            } 
            return parentIDPath; 
        } 
        
        
        ///<summary>Deletes attachements from the disk.</summary>
        ///<param name="IDPath">IDPath of the node to be deleted.</param>
        public void DeleteAttachements( string IDPath ) { 
            // delete the node
            TreeProvider tree = Functions.GetTreeProvider(); 
            TreeNode node = null; 
            string parentIDPath = null; 
            string aliaspath = null; 
            string culture = "" + Request.QueryString[ "culture" ]; 
            VersionManager verMan = new VersionManager( tree ); 
            bool isMultilingualContent = false; 
            TreeNode cultureNode = null; 
            
            node = tree.SelectSingleNode( IDPath, TreePathTypeEnum.IDPath ); 
            parentIDPath = node.GetParentPath( TreePathTypeEnum.IDPath ); 
            if ( !( node == null ) ) { 
                // check if this is a multilingual content
                if ( IDPath.Split( '/' )[ 1 ] + "" != "" ) { 
                    cultureNode = tree.SelectSingleNode( "/" + IDPath.Split( '/' )[ 1 ], TreePathTypeEnum.IDPath ); 
                    if ( cultureNode.ClassName.ToLower() == "cms.culture" ) { 
                        isMultilingualContent = true; 
                    } 
                } 
                if ( Functions.UseMultilingualSupport() & culture + "" != "" & isMultilingualContent ) { 
                    if ( Strings.Trim( Strings.LCase( culture + "" ) ) == Strings.Trim( Strings.LCase( ConfigurationSettings.AppSettings[ "CMSDefaultCultureCode" ] + "" ) ) ) { 
                        // delete all culture versions
                        DataRow drCulture = null; 
                        string aliasPathWithoutCulture = Functions.RemoveCultureFromAliasPath( System.Convert.ToString( node.GetValue( "AliasPath" ) ) ); 
                        foreach ( System.Data.DataRow transTemp2 in GetCulturesDataSet( tree ).Tables[ 0 ].Rows ) { 
                            drCulture = transTemp2;  
                            try { 
                                aliaspath = "/" + System.Convert.ToString( drCulture[ "CultureCode" ] ) + aliasPathWithoutCulture; 
                                node = tree.SelectSingleNode( aliaspath, TreePathTypeEnum.AliasPath ); 
                                if ( !( node == null ) ) { 
                                    Functions.DeleteAttachment( aliaspath ); 
                                } 
                            } 
                            catch  { 
                            } 
                        }
                    } 
                    else { 
                        // delete only selected culture
                        aliaspath = Functions.GetMultilingualAliasPath( IDPath, culture ); 
                        Functions.DeleteAttachment( aliaspath ); 
                    } 
                } 
                else { 
                    // if not multilingual version
                    aliaspath = GetAliasPath( IDPath ); 
                    Functions.DeleteAttachment( aliaspath ); 
                } 
            } 
        } 
        
        
        ///<summary>Copies specified node.</summary>
        ///<param name="sourceID">Source IDPath.</param>
        ///<param name="targetIDPath">Target IDPath.</param>
        public void CopyNode( string sourceIDPath, string targetIDPath ) { 
            if ( sourceIDPath == targetIDPath ) { 
                return; 
            } 
            TreeProvider tree = null; 
            TreeNode newNode = null; 
            TreeNode copiedNode = null; 
            bool isSourceMultilingualContent = false; 
            bool isTargetMultilingualContent = false; 
            TreeNode cultureNode = null; 
            
            tree = Functions.GetTreeProvider(); 
            if ( Functions.UseMultilingualSupport() ) { 
                if ( sourceIDPath.Split( '/' )[ 1 ] + "" != "" ) { 
                    cultureNode = tree.SelectSingleNode( "/" + sourceIDPath.Split( '/' )[ 1 ], TreePathTypeEnum.IDPath ); 
                    if ( cultureNode.ClassName.ToLower() == "cms.culture" ) { 
                        isSourceMultilingualContent = true; 
                    } 
                } 
                if ( targetIDPath.Split( '/' )[ 1 ] + "" != "" ) { 
                    cultureNode = tree.SelectSingleNode( "/" + targetIDPath.Split( '/' )[ 1 ], TreePathTypeEnum.IDPath ); 
                    if ( cultureNode.ClassName.ToLower() == "cms.culture" ) { 
                        isTargetMultilingualContent = true; 
                    } 
                } 
                
                string sourceAliasPath = null; 
                if ( isSourceMultilingualContent == true ) { 
                    sourceAliasPath = Functions.RemoveCultureFromAliasPath( GetAliasPath( sourceIDPath ) ); 
                } 
                else { 
                    sourceAliasPath = GetAliasPath( sourceIDPath ); 
                } 
                
                string targetAliasPath = null; 
                if ( isTargetMultilingualContent == true ) { 
                    targetAliasPath = Functions.RemoveCultureFromAliasPath( GetAliasPath( targetIDPath ) ); 
                } 
                else { 
                    targetAliasPath = GetAliasPath( targetIDPath ); 
                } 
                
                if ( isSourceMultilingualContent & isTargetMultilingualContent ) { 
                    DataSet dsCultures = null; 
                    DataRow drCulture = null; 
                    foreach ( System.Data.DataRow transTemp3 in this.GetCulturesDataSet( tree ).Tables[ 0 ].Rows ) { 
                        drCulture = transTemp3;  
                        try { 
                            string copySourcePath = "/" + System.Convert.ToString( drCulture[ "CultureCode" ] ) + sourceAliasPath; 
                            string copyTargetPath = "/" + System.Convert.ToString( drCulture[ "CultureCode" ] ) + targetAliasPath; 
                            copiedNode = null; 
                            // create a all parent nodes in drCulture
                            Functions.CreateNodePath( copyTargetPath ); 
                            copiedNode = tree.CopyNode( copySourcePath, copyTargetPath, TreePathTypeEnum.AliasPath ); 
                            if ( !( copiedNode == null ) ) { 
                                newNode = copiedNode; 
                                
                                copyTargetPath = System.Convert.ToString( newNode.GetValue( "AliasPath" ) ); 
                                if ( newNode.ClassName.ToLower() != "cms.file" ) { 
                                    Functions.CopyFriendlyURL( copySourcePath, copyTargetPath ); 
                                } 
                                // copy file for each language version
                                if ( newNode.ClassName.ToLower() == "cms.file" ) { 
                                    Functions.CopyAttachment( copySourcePath, copyTargetPath ); 
                                } 
                            } 
                        } 
                        catch  { 
                        } 
                    }
                } 
                
                if ( isSourceMultilingualContent == false & isTargetMultilingualContent ) { 
                    copiedNode = tree.CopyNode( sourceAliasPath, "/" + ConfigurationSettings.AppSettings[ "CMSDefaultCultureCode" ] + targetAliasPath, TreePathTypeEnum.AliasPath ); 
                } 
                if ( isSourceMultilingualContent & isTargetMultilingualContent == false ) { 
                    copiedNode = tree.CopyNode( "/" + ConfigurationSettings.AppSettings[ "CMSDefaultCultureCode" ] + sourceAliasPath, targetAliasPath, TreePathTypeEnum.AliasPath ); 
                } 
            } 
            else { 
                newNode = tree.CopyNode( sourceIDPath, targetIDPath, TreePathTypeEnum.IDPath ); 
                
                string copySourcePath = GetAliasPath( sourceIDPath ); 
                string copyTargetPath = System.Convert.ToString( newNode.GetValue( "AliasPath" ) ); 
                if ( newNode.ClassName.ToLower() != "cms.file" ) { 
                    Functions.CopyFriendlyURL( copySourcePath, copyTargetPath ); 
                } 
                if ( newNode.ClassName.ToLower() == "cms.file" ) { 
                    Functions.CopyAttachment( copySourcePath, copyTargetPath ); 
                } 
            } 
        } 
        
        
        ///<summary>Moves specified node.</summary>
        ///<param name="sourceID">Source IDPath.</param>
        ///<param name="targetIDPath">Target IDPath.</param>
        public void MoveNode( string sourceIDPath, string targetIDPath ) { 
            TreeProvider tree = null; 
            string newAliasPath = null; 
            string oldAliasPath = null; 
            int nodeID = 0; 
            TreeNode node = null; 
            TreeNode newNode = null; 
            TreeNode movedNode = null; 
            
            tree = Functions.GetTreeProvider(); 
            node = tree.SelectSingleNode( sourceIDPath, TreePathTypeEnum.IDPath ); 
            if ( node == null ) { 
                return; 
            } 
            oldAliasPath = System.Convert.ToString( node.GetValue( "AliasPath" ) ); 
            nodeID = System.Convert.ToInt32( node.GetValue( "NodeID" ) ); 
            
            if ( Functions.UseMultilingualSupport() ) { 
                bool isSourceMultilingualContent = false; 
                bool isTargetMultilingualContent = false; 
                TreeNode cultureNode = null; 
                
                if ( sourceIDPath.Split( '/' )[ 1 ] + "" != "" ) { 
                    cultureNode = tree.SelectSingleNode( "/" + sourceIDPath.Split( '/' )[ 1 ], TreePathTypeEnum.IDPath ); 
                    if ( cultureNode.ClassName.ToLower() == "cms.culture" ) { 
                        isSourceMultilingualContent = true; 
                    } 
                } 
                if ( targetIDPath.Split( '/' )[ 1 ] + "" != "" ) { 
                    cultureNode = tree.SelectSingleNode( "/" + targetIDPath.Split( '/' )[ 1 ], TreePathTypeEnum.IDPath ); 
                    if ( cultureNode.ClassName.ToLower() == "cms.culture" ) { 
                        isTargetMultilingualContent = true; 
                    } 
                } 
                
                string sourceAliasPath = null; 
                if ( isSourceMultilingualContent == true ) { 
                    sourceAliasPath = Functions.RemoveCultureFromAliasPath( GetAliasPath( sourceIDPath ) ); 
                } 
                else { 
                    sourceAliasPath = GetAliasPath( sourceIDPath ); 
                } 
                
                string targetAliasPath = null; 
                if ( isTargetMultilingualContent == true ) { 
                    targetAliasPath = Functions.RemoveCultureFromAliasPath( GetAliasPath( targetIDPath ) ); 
                } 
                else { 
                    targetAliasPath = GetAliasPath( targetIDPath ); 
                } 
                
                if ( isSourceMultilingualContent & isTargetMultilingualContent ) { 
                    DataSet dsCultures = null; 
                    DataRow drCulture = null; 
                    
                    foreach ( System.Data.DataRow transTemp4 in GetCulturesDataSet( tree ).Tables[ 0 ].Rows ) { 
                        drCulture = transTemp4;  
                        try { 
                            string copySourcePath = "/" + System.Convert.ToString( drCulture[ "CultureCode" ] ) + sourceAliasPath; 
                            string copyTargetPath = "/" + System.Convert.ToString( drCulture[ "CultureCode" ] ) + targetAliasPath; 
                            movedNode = null; 
                            // create a all parent nodes in drCulture
                            Functions.CreateNodePath( copyTargetPath ); 
                            movedNode = tree.MoveNode( copySourcePath, copyTargetPath, TreePathTypeEnum.AliasPath ); 
                            if ( !( movedNode == null ) ) { 
                                newNode = movedNode; 
                                
                                copyTargetPath = System.Convert.ToString( newNode.GetValue( "AliasPath" ) ); 
                                if ( newNode.ClassName.ToLower() != "cms.file" ) { 
                                    Functions.EnsureFriendlyURL( copyTargetPath, oldAliasPath ); 
                                } 
                                else { 
                                    Functions.MoveAttachment( oldAliasPath, copyTargetPath ); 
                                } 
                            } 
                        } 
                        catch  { 
                        } 
                    }
                    return; 
                } 
                
                if ( isSourceMultilingualContent == false & isTargetMultilingualContent ) { 
                    newNode = tree.MoveNode( sourceAliasPath, "/" + ConfigurationSettings.AppSettings[ "CMSDefaultCultureCode" ] + targetAliasPath, TreePathTypeEnum.AliasPath ); 
                } 
                if ( isSourceMultilingualContent & isTargetMultilingualContent == false ) { 
                    newNode = tree.MoveNode( "/" + ConfigurationSettings.AppSettings[ "CMSDefaultCultureCode" ] + sourceAliasPath, targetAliasPath, TreePathTypeEnum.AliasPath ); 
                } 
            } 
            else { 
                newNode = tree.MoveNode( sourceIDPath, targetIDPath, TreePathTypeEnum.IDPath ); 
            } 
            
            if ( newNode.ClassName.ToLower() != "cms.file" ) { 
                Functions.EnsureFriendlyURL( System.Convert.ToString( newNode.GetValue( "AliasPath" ) ), oldAliasPath ); 
            } 
            else { 
                Functions.MoveAttachment( oldAliasPath, System.Convert.ToString( newNode.GetValue( "AliasPath" ) ) ); 
            } 
        } 
        
        
        
        ///<summary>Converts IDPath to AliasPath.</summary>
        ///<param name="idpath">IDPath to be converted.</param>
        private string GetAliasPath( string idpath ) { 
            TreeProvider tree = Functions.GetTreeProvider(); 
            TreeNode node = tree.SelectSingleNode( idpath, TreePathTypeEnum.IDPath ); 
            if ( node == null ) { 
                return ""; 
            } 
            else { 
                return System.Convert.ToString( node.GetValue( "AliasPath" ) ); 
            } 
        } 
        
        
        
        ///<summary>Returns DataSet containing all cultures.</summary>
        private DataSet GetCulturesDataSet( TreeProvider tree ) { 
            return tree.Connection.ExecuteQuery( "cms.culture.selectbypath", null, " 1=1 ", " 1 " ); 
        } 
        
        
        
        ///<summary>Returns true if specified child type can be placed under specified parent type.</summary>
        private bool CheckAllowedChildType( int parentClassID, int childClassID ) { 
            GeneralConnection cn = new GeneralConnection( Functions.GetConnectionString() ); 
            DataSet ds = null; 
            
            ds = cn.ExecuteQuery( "cms.allowedchildclasses.selectallowed", null, " parentClassID = '" + parentClassID.ToString() + "' AND childClassID = '" + childClassID.ToString() + "' " ); 
            if ( ds.Tables[ 0 ].Rows.Count > 0 ) { 
                return true; 
            } 
            else { 
                return false; 
            } 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
