using Kentico.CMS.TreeEngine; 
using Kentico.CMS.ContentEngine; 
using Kentico.CMS.MetadataEngine; 
using System.IO; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class View : System.Web.UI.Page { 
        
        protected string cssPath; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblRedirect; 
        protected /* TRANSINFO: WithEvents */ Kentico.CMS.CMSControls.CMSViewer CMSViewer1; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            string idpath = "" + Request.QueryString[ "idpath" ] + ""; 
            string culture = "" + Request.QueryString[ "culture" ] + ""; 
            int versionHistoryID = 0; 
            TreeProvider tree = Functions.GetTreeProvider(); 
            TreeNode node = null; 
            string viewPage = null; 
            string aliaspath = null; 
            VersionManager verMan = null; 
            
            if ( "" + Request.QueryString[ "versionhistoryid" ] + "" + "" != "" ) { 
                versionHistoryID = int.Parse( "" + Request.QueryString[ "versionhistoryid" ] + "" ); 
            } 
            
            if ( versionHistoryID == 0 ) { 
                // get node to read its class name
                node = tree.SelectSingleNode( idpath, TreePathTypeEnum.IDPath ); 
                aliaspath = System.Convert.ToString( node.GetValue( "AliasPath" ) ); 
                if ( Functions.UseMultilingualSupport() & culture + "" != "" ) { 
                    node = tree.SelectSingleNode( "/" + culture + Functions.RemoveCultureFromAliasPath( aliaspath ), TreePathTypeEnum.AliasPath ); 
                    if ( node == null ) { 
                        Response.Redirect( "NewCultureVersion.aspx?idpath=" + idpath + "&aliaspath=" + aliaspath + "&culture=" + culture ); 
                        return; 
                    } 
                    else { 
                        idpath = System.Convert.ToString( node.GetValue( "idpath" ) ); 
                    } 
                } 
                
                // check permissions
                if ( !( ( Functions.IsAuthorizedPerResource( "CMS.Content", "Read" ) | Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read ) ) ) ) { 
                    Functions.RedirectToAccessDenied( idpath, "Read (view.aspx)" ); 
                    return; 
                } 
                
                if ( node.ClassName.ToLower() == "cms.root" | ( node.ClassName.ToLower() == "cms.menuitem" && System.Convert.ToString( node.GetValue( "MenuItemPageTemplate" ) ) + "" + "" != "" ) ) { 
                    // this is a page, show it
                    string url = null; 
                    string targetAliasPath = null; 
                    
                    if ( Functions.UseMultilingualSupport() & culture + "" != "" ) { 
                        targetAliasPath = Functions.RemoveCultureFromAliasPath( aliaspath ); 
                        Session[ "CMSPreferredCulture" ] = culture; 
                        Response.Cookies.Add( new HttpCookie( "CMSPreferredCulture", culture ) ); 
                    } 
                    else { 
                        targetAliasPath = aliaspath; 
                    } 
                    if ( ConfigurationSettings.AppSettings[ "CMSWebApplicationVirtualPath" ] == "/" ) { 
                        Response.Redirect( Functions.GetUrlForAliasPath( targetAliasPath ) ); 
                    } 
                    else { 
                        Response.Redirect( ConfigurationSettings.AppSettings[ "CMSWebApplicationVirtualPath" ] + Functions.GetUrlForAliasPath( targetAliasPath ) ); 
                    } 
                    return; 
                } 
                if ( idpath == "/" ) { 
                    Response.Redirect( ConfigurationSettings.AppSettings[ "CMSWebApplicationVirtualPath" ] ); 
                } 
                // display item using the default transformation
                CMSViewer1.SelectNodesPathType = TreePathTypeEnum.IDPath; 
                CMSViewer1.SelectNodesPath = idpath; 
            } 
            else { 
                CMSViewer1.VersionHistoryID = versionHistoryID; 
                verMan = new VersionManager( tree ); 
                node = verMan.GetVersion( versionHistoryID ); 
                // check permissions
                TreeNode currentNode = tree.SelectSingleNode( System.Convert.ToInt32( node.GetValue( "NodeID" ) ) ); 
                if ( !( ( Functions.IsAuthorizedPerResource( "CMS.Content", "Read" ) | Functions.IsAuthorizedPerNode( System.Convert.ToString( currentNode.GetValue( "IDPath" ) ), TreePathTypeEnum.IDPath, NodePermissionsEnum.Read ) ) ) ) { 
                    Functions.RedirectToAccessDenied( System.Convert.ToString( node.GetValue( "AliasPath" ) ), "Read (View.aspx)" ); 
                    return; 
                } 
            } 
            
            // find out if there's a special viewing page for the specified node
            viewPage = MetadataProvider.GetSettingsValue( node.ClassName, "CMSViewPage" ); 
            if ( viewPage + "" != "" ) { 
                lblRedirect.Text = ResMan.GetString( "ContentView.Redirect" ); 
                lblRedirect.Visible = true; 
                string styleParams = "style=" + "" + Request.QueryString[ "style" ] + "&ftbName=" + "" + Request.QueryString[ "ftbName" ]; 
                if ( versionHistoryID == 0 ) { 
                    Response.Redirect( viewPage + "?idpath=" + idpath + "&" + styleParams ); 
                } 
                else { 
                    Response.Redirect( viewPage + "?versionhistoryid=" + versionHistoryID + "&" + styleParams ); 
                } 
            } 
            
            CMSViewer1.SelectNodesClassName = node.ClassName; 
            CMSViewer1.TreeProvider = tree; 
            
            // set css path        
            if ( File.Exists( ConfigurationSettings.AppSettings[ "CMSMetadataFolder" ] + "/" + Strings.Replace( node.ClassName + "", ".", "/", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + "/transformations/default.css" ) ) { 
                cssPath = ConfigurationSettings.AppSettings[ "CMSMetadataFolder" ] + "/" + Strings.Replace( node.ClassName + "", ".", "/", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + "/transformations/default.css"; 
            } 
            else { 
                // class'es default css, use main web site css
                if ( ConfigurationSettings.AppSettings[ "CMSCSSVirtualPath" ] + "" + "" == "" ) { 
                    // no default css specified - use ~/main.css instead
                    cssPath = ResolveUrl( "~/main.css" ); 
                } 
                else { 
                    // css specified
                    cssPath = ConfigurationSettings.AppSettings[ "CMSCSSVirtualPath" ]; 
                } 
            } 
        } 
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
