using Kentico.CMS.TreeEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class ViewFile : System.Web.UI.Page { 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblFileName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblFileNameValue; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblFileSize; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblFileSizeValue; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblFilePath; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblFilePathValue; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblViewFile; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlViewFileValue; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            string idpath = "" + Request.QueryString[ "idpath" ] + ""; 
            string culture = "" + Request.QueryString[ "culture" ] + ""; 
            TreeProvider tree = Functions.GetTreeProvider(); 
            TreeNode node = null; 
            int versionHistoryID = 0; 
            
            if ( !( Request.QueryString[ "VersionHistoryID" ] == null ) ) { 
                versionHistoryID = int.Parse( "" + Request.QueryString[ "VersionHistoryID" ] ); 
            } 
            
            // set labels
            if ( !( Page.IsPostBack ) ) { 
                this.lblFileName.Text = ResMan.GetString( "ViewFile.FileName" ); 
                this.lblFilePath.Text = ResMan.GetString( "ViewFile.FilePath" ); 
                this.lblFileSize.Text = ResMan.GetString( "ViewFile.FileSize" ); 
                this.lblViewFile.Text = ResMan.GetString( "ViewFile.ViewFile" ); 
            } 
            
            // get node
            if ( versionHistoryID == 0 ) { 
                node = Functions.GetNodeByIDPathAndCulture( idpath, culture ); 
                
                // multilingual support
                if ( node == null ) { 
                    // culture version does not exist            
                    node = tree.SelectSingleNode( idpath, TreePathTypeEnum.IDPath ); 
                    Response.Redirect( "NewCultureVersion.aspx?idpath=" + idpath + "&aliaspath=" + System.Convert.ToString( node.GetValue( "aliaspath" ) ) + "&culture=" + culture ); 
                    return; 
                } 
                else { 
                    idpath = System.Convert.ToString( node.GetValue( "idpath" ) ); 
                } 
                
                // check permissions        
                if ( !( ( Functions.IsAuthorizedPerResource( "CMS.Content", "Read" ) | Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read ) ) ) ) { 
                    Functions.RedirectToAccessDenied( idpath, "Read (publish.aspx)" ); 
                    return; 
                } 
                
                node = tree.SelectSingleNode( idpath, TreePathTypeEnum.IDPath, "cms.file" ); 
            } 
            else { 
                VersionManager verMan = new VersionManager( tree ); 
                node = verMan.GetVersion( versionHistoryID ); 
                // check permissions
                TreeNode currentNode = tree.SelectSingleNode( System.Convert.ToInt32( node.GetValue( "NodeID" ) ) ); 
                if ( !( ( Functions.IsAuthorizedPerResource( "CMS.Content", "Read" ) | Functions.IsAuthorizedPerNode( System.Convert.ToString( currentNode.GetValue( "IDPath" ) ), TreePathTypeEnum.IDPath, NodePermissionsEnum.Read ) ) ) ) { 
                    Functions.RedirectToAccessDenied( System.Convert.ToString( node.GetValue( "AliasPath" ) ), "Read (ViewFile.aspx)" ); 
                    return; 
                } 
            } 
            
            this.lblFileNameValue.Text = System.Convert.ToString( node.GetValue( "FileName" ) ); 
            string parentPath = Functions.RemoveCultureFromAliasPath( node.GetParentPath( TreePathTypeEnum.AliasPath ) ); 
            if ( !( parentPath.EndsWith( "/" ) ) ) { 
                parentPath += "/"; 
            } 
            this.lblFilePathValue.Text = parentPath + System.Convert.ToString( node.GetValue( "FileName" ) ); 
            this.lblFileSizeValue.Text = System.Convert.ToInt32( node.GetValue( "FileSize" ) ).ToString(); 
            // If versionHistoryID = 0 Then
            // optionally add "paste" link
            if ( "" + Request.QueryString[ "style" ] + "" != "" ) { 
                string path = null; 
                string selectorPath = null; 
                if ( ( !( ConfigurationSettings.AppSettings[ "CMSFilesFolder" ] == null ) ) && ConfigurationSettings.AppSettings[ "CMSFilesFolder" ] + "" != "" && this.lblFilePathValue.Text.ToLower().StartsWith( "/files" ) ) { 
                    path = ResolveUrl( ConfigurationSettings.AppSettings[ "CMSFilesFolder" ] + this.lblFilePathValue.Text.Substring( "/files".Length ) ); 
                } 
                else { 
                    path = ResolveUrl( "~" + this.lblFilePathValue.Text ); 
                } 
                // freetextbox
                if ( ( ConfigurationSettings.AppSettings[ "CMSWysiwygEditor" ] + "" ).ToLower().Trim() == "freetextbox" & Strings.LCase( "" + Request.QueryString[ "style" ] + "" ) == "selectimage" ) { 
                    if ( "" + Request.QueryString[ "ftbName" ] + "" + "" != "" ) { 
                        ltlViewFileValue.Text = @"<span onclick=""top.window.opener.FTB_InsertText('" + "" + Request.QueryString[ "ftbName" ] + "'"; 
                        ltlViewFileValue.Text += @", '<img src=\'" + path + @"\'>');top.window.close();"" style=""cursor:pointer;text-decoration:underline;color:blue"">" + ResMan.GetString( "FileViewHeader.PasteImage" ) + "</span><br>"; 
                    } 
                    else { 
                        ltlViewFileValue.Text = @"<span onclick=""window.top.opener.SetUrl('" + path.Replace( "'", @"\'" ) + @"');window.top.close();window.top.opener.focus();"" style=""cursor:pointer;color:blue;text-decoration:underline"">" + ResMan.GetString( "FileViewHeader.PasteImage" ) + "</span><br>"; 
                    } 
                } 
                // file selector 
                if ( Strings.LCase( "" + Request.QueryString[ "style" ] + "" ) == "selectpicturepath" ) { 
                    string id1 = "" + Request.QueryString[ "ftbName" ].Split( ',' )[ 0 ]; 
                    string id2 = "" + Request.QueryString[ "ftbName" ].Split( ',' )[ 1 ]; 
                    ltlViewFileValue.Text = @"<span onclick="""; 
                    ltlViewFileValue.Text += "top.window.opener.document.getElementById('" + id1 + "').value = '" + this.lblFilePathValue.Text.Replace( "'", @"\'" ) + "';"; 
                    ltlViewFileValue.Text += "if (top.window.opener.document.getElementById('" + id2 + "') != null) {top.window.opener.document.getElementById('" + id2 + "').src = 'getfile.aspx?filepath=" + this.lblFilePathValue.Text.Replace( "'", @"\'" ) + "';"; 
                    ltlViewFileValue.Text += "top.window.opener.document.getElementById('" + id2 + "').style.display = 'block';}"; 
                    ltlViewFileValue.Text += @"top.window.close();"" style=""cursor:pointer;text-decoration:underline;color:blue"">" + ResMan.GetString( "FileViewHeader.SelectDocument" ) + "</span><br>"; 
                } 
                // fckeditor
                if ( ( ConfigurationSettings.AppSettings[ "CMSWysiwygEditor" ] + "" ).ToLower().Trim() != "freetextbox" && ( "" + Request.QueryString[ "style" ] + "" ).ToLower().Trim() == "selectimage" ) { 
                    ltlViewFileValue.Text = @"<span onclick=""window.top.opener.SetUrl('" + path.Replace( "'", @"\'" ) + @"');window.top.close();window.top.opener.focus();"" style=""cursor:pointer;color:blue;text-decoration:underline"">" + ResMan.GetString( "FileViewHeader.PasteImage" ) + "</span><br>"; 
                } 
            } 
            // End If
            if ( Strings.InStr( ";.jpg;.gif;.bmp;.png;", ";" + System.IO.Path.GetExtension( System.Convert.ToString( node.GetValue( "FileName" ) ) ).ToLower() + ";", (Microsoft.VisualBasic.CompareMethod)(0) ) > 0 ) { 
                // display image preview
                if ( versionHistoryID == 0 ) { 
                    this.ltlViewFileValue.Text += @"<img src=""GetFile.aspx?idpath=" + System.Convert.ToString( node.GetValue( "idpath" ) ) + @""">"; 
                } 
                else { 
                    this.ltlViewFileValue.Text += @"<img src=""GetFile.aspx?versionHistoryID=" + versionHistoryID.ToString() + @""">"; 
                } 
            } 
            else { 
                // display document link
                if ( versionHistoryID == 0 ) { 
                    this.ltlViewFileValue.Text += @"<a href=""GetFile.aspx?idpath=" + System.Convert.ToString( node.GetValue( "idpath" ) ) + @""" target=""_blank"">" + ResMan.GetString( "ViewFile.OpenDocument" ) + "</a>"; 
                } 
                else { 
                    this.ltlViewFileValue.Text += @"<a href=""GetFile.aspx?versionhistoryid=" + versionHistoryID.ToString() + @""" target=""_blank"">" + ResMan.GetString( "ViewFile.OpenDocument" ) + "</a>"; 
                } 
            } 
        } 
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
