using Kentico.CMS.TreeEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class ViewFrameset : System.Web.UI.Page { 
        
        protected string url; 
        protected string urlParams; 
        protected string idPath; 
        protected string headerParams; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
        } 
        
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            string culture = "" + Request.QueryString[ "culture" ] + ""; 
            string aliaspath = ""; 
            TreeProvider tree = null; 
            TreeNode node = null; 
            idPath = "" + Request.QueryString[ "idpath" ] + ""; 
            
            tree = Functions.GetTreeProvider(); 
            node = tree.SelectSingleNode( idPath, TreePathTypeEnum.IDPath ); 
            // if multilingual support is used and the required culture version is not available, redirect user to the NewCultureVersion page
            if ( Functions.UseMultilingualSupport() & Strings.LCase( Strings.Trim( culture ) ) != Strings.LCase( Strings.Trim( ConfigurationSettings.AppSettings[ "CMSDefaultCultureCode" ] + "" ) ) & culture + "" + "" != "" ) { 
                aliaspath = "/" + culture + Functions.RemoveCultureFromAliasPath( System.Convert.ToString( node.GetValue( "AliasPath" ) ) ); 
                node = tree.SelectSingleNode( "/" + culture + Functions.RemoveCultureFromAliasPath( aliaspath ), TreePathTypeEnum.AliasPath ); 
                if ( node == null ) { 
                    Response.Redirect( "NewCultureVersion.aspx?idpath=" + idPath + "&aliaspath=" + aliaspath + "&culture=" + culture ); 
                    return; 
                } 
            } 
            
            if ( ( !( node == null ) ) && ( !( node.GetValue( "CheckedOutVersionHistoryID" ) == null ) ) && System.Convert.ToBoolean( Functions.GetClassDRValue( System.Convert.ToInt32( node.GetValue( "ClassID" ) ), "UseVersioning" ) ) ) { 
                // use versioning
                urlParams = "versionhistoryid=" + System.Convert.ToInt32( node.GetValue( "CheckedOutVersionHistoryID" ) ).ToString() + "&culture=" + culture; 
                headerParams = urlParams + "&idpath=" + idPath; 
            } 
            else { 
                // do not use versioning
                urlParams = "idpath=" + idPath + "&culture=" + culture; 
                headerParams = urlParams; 
            } 
            
            // check permissions
            if ( !( ( Functions.IsAuthorizedPerResource( "CMS.Content", "Read" ) | Functions.IsAuthorizedPerNode( idPath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read ) ) ) ) { 
                Functions.RedirectToAccessDenied( idPath, "Read (view.aspx)" ); 
                return; 
            } 
            
            // Set the view page depending on the document class type
            if ( !( node == null ) ) { 
                if ( node.ClassName.ToLower() == "cms.file" ) { 
                    url = "viewfile.aspx?ftbname=" + "" + Request.QueryString[ "ftbName" ] + "&style=" + "" + Request.QueryString[ "style" ] + "&" + urlParams; 
                } 
                else if ( node.ClassName.ToLower() == "cms.newslettercontainer" ) { 
                    url = "../Tools/Newsletter/NewsletterContainerView.aspx?" + urlParams; 
                } 
                else if ( node.ClassName.ToLower() == "cms.newsletter" ) { 
                    url = "../Tools/Newsletter/NewsletterView.aspx?" + urlParams; 
                } 
                else if ( node.ClassName.ToLower() == "cms.newsletterissue" ) { 
                    url = "view.aspx?" + urlParams; 
                } 
                else { 
                    url = ""; 
                } 
            } 
        } 
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
