using Kentico.CMS.TreeEngine; 
using Kentico.CMS.MetadataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class ViewHeader : System.Web.UI.Page { 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.RadioButton radShowLastVersion; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.RadioButton radShowPublishedVersion; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.RadioButton radEdit; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            lblHeader.Text = ResMan.GetString( "ContentView.Header" ); 
            radShowLastVersion.Text = ResMan.GetString( "ViewHeader.radShowLastVersion" ); 
            radShowPublishedVersion.Text = ResMan.GetString( "ViewHeader.radShowPublishedVersion" ); 
            radEdit.Text = ResMan.GetString( "ViewHeader.radEdit" ); 
            
            string idpath = "" + Request.QueryString[ "idpath" ]; 
            string culture = "" + Request.QueryString[ "culture" ] + ""; 
            TreeProvider tree = Functions.GetTreeProvider(); 
            TreeNode node = null; // latest version (current document if versioning not supported
            string aliaspath = null; 
            
            node = tree.SelectSingleNode( idpath, TreePathTypeEnum.IDPath ); 
            // multilingual support
            aliaspath = System.Convert.ToString( node.GetValue( "AliasPath" ) ); 
            if ( Functions.UseMultilingualSupport() & culture + "" != "" ) { 
                node = tree.SelectSingleNode( "/" + culture + Functions.RemoveCultureFromAliasPath( aliaspath ), TreePathTypeEnum.AliasPath ); 
            } 
            
            // check permissions
            if ( !( ( Functions.IsAuthorizedPerResource( "CMS.Content", "Read" ) | Functions.IsAuthorizedPerNode( System.Convert.ToString( node.GetValue( "idpath" ) ), TreePathTypeEnum.IDPath, NodePermissionsEnum.Read ) ) ) ) { 
                Functions.RedirectToAccessDenied( idpath, "Read (view.aspx)" ); 
                return; 
            } 
            
            // get web path of the node
            string webpath = GetWebPath( node ); 
            
            // display or hide radio buttons 
            if ( ( !( node == null ) ) ) { 
                string publishedscript = null; 
                // File view mode?
                switch ( System.Convert.ToString( node.GetValue( "className" ) ).ToLower() ) {
                    case "cms.file": case "cms.newsletter": case "cms.newsletterissue": case "cms.newslettercontainer":
                        string viewpage = null; 
                        switch ( System.Convert.ToString( node.GetValue( "className" ) ).ToLower() ) {
                            case "cms.file":
                                viewpage = "viewfile.aspx"; 
                                break;
                            case "cms.newsletter":
                                viewpage = "../Tools/Newsletter/NewsletterView.aspx"; 
                                break;
                            case "cms.newslettercontainer":
                                viewpage = "../Tools/Newsletter/NewsletterContainerView.aspx"; 
                                break;
                            case "cms.newsletterissue":
                                viewpage = "View.aspx"; 
                                break;
                        }
                        
                        this.ltlScript.Text = ""; 
                        this.radEdit.Visible = false; 
                        if ( !( IsPostBack ) ) { 
                            this.radShowPublishedVersion.Checked = true; 
                        } 
                        // check if document type supports versioning
                        if ( ( !( node.GetValue( "CheckedOutVersionHistoryID" ) == null ) ) && System.Convert.ToBoolean( Functions.GetClassDRValue( System.Convert.ToInt32( node.GetValue( "ClassID" ) ), "UseVersioning" ) ) ) { 
                            // get latest version of the node
                            string lastversionscript = "parent.frames['viewer'].location.href = '" + ResolveUrl( viewpage ) + "?idpath=" + idpath + "&culture=" + "" + Request.QueryString[ "culture" ] + "&versionhistoryid=" + System.Convert.ToInt32( node.GetValue( "CheckedOutVersionHistoryID" ) ).ToString() + "';"; 
                            // display last version radio button
                            radShowLastVersion.Visible = true; 
                            // get VersionHistoryID of the latest version
                            radShowLastVersion.Attributes.Add( "OnClick", "javascript:" + lastversionscript ); 
                        } 
                        else { 
                            this.radShowLastVersion.Visible = false; 
                        } 
                        TreeNode pubnode = tree.SelectSingleNode( System.Convert.ToString( node.GetValue( "AliasPath" ) ), TreePathTypeEnum.AliasPath, System.Convert.ToString( node.GetValue( "ClassName" ) ), true ); 
                        if ( !( pubnode == null ) ) { 
                            publishedscript = "parent.frames['viewer'].location.href = '" + ResolveUrl( viewpage ) + "?idpath=" + System.Convert.ToString( pubnode.GetValue( "IDPath" ) ) + "&culture=" + "" + Request.QueryString[ "culture" ] + "';"; 
                            radShowPublishedVersion.Attributes.Add( "OnClick", "javascript:" + publishedscript ); 
                        } 
                        else { 
                            this.radShowPublishedVersion.Visible = false; 
                        } 
                        break;
                    default:
                        this.radEdit.Visible = true; 
                        string editscript = null; 
                        // check if document type supports versioning
                        if ( ( !( node.GetValue( "CheckedOutVersionHistoryID" ) == null ) ) && System.Convert.ToBoolean( Functions.GetClassDRValue( System.Convert.ToInt32( node.GetValue( "ClassID" ) ), "UseVersioning" ) ) ) { 
                            // get latest version of the node
                            VersionManager verMan = new VersionManager( tree ); 
                            TreeNode vernode = verMan.GetVersion( System.Convert.ToInt32( node.GetValue( "CheckedOutVersionHistoryID" ) ) ); 
                            if ( vernode == null ) { 
                                vernode = node; 
                            } 
                            string verwebpath = GetWebPath( vernode ); 
                            string lastversionscript = "parent.frames['viewer'].location.href = '" + ResolveUrl( "../Browse/redirBrowse.aspx" ) + "?target=" + verwebpath + "&culture=" + culture + "&setmode=browse';"; 
                            editscript = "parent.frames['viewer'].location.href = '" + ResolveUrl( "../Browse/redirBrowse.aspx" ) + "?target=" + verwebpath + "&culture=" + culture + "&setmode=edit';"; 
                            // display last version radio button
                            radShowLastVersion.Visible = true; 
                            // get VersionHistoryID of the latest version
                            radShowLastVersion.Attributes.Add( "OnClick", "javascript:" + lastversionscript ); 
                            // remove - WebSite does not support versioning yet
                            this.radShowLastVersion.Visible = false; 
                        } 
                        else { 
                            this.radShowLastVersion.Visible = false; 
                            editscript = "parent.frames['viewer'].location.href = '" + ResolveUrl( "../Browse/redirBrowse.aspx" ) + "?target=" + webpath + "&culture=" + culture + "&setmode=edit';"; 
                        } 
                        // Other choices
                        publishedscript = "parent.frames['viewer'].location.href = '" + ResolveUrl( "../Browse/redirBrowse.aspx" ) + "?target=" + webpath + "&culture=" + culture + "&setmode=browse';"; 
                        radShowPublishedVersion.Attributes.Add( "OnClick", "javascript:" + publishedscript ); 
                        radEdit.Attributes.Add( "OnClick", "javascript:" + editscript ); 
                        this.ltlScript.Text = "<script language='javascript'>" + Constants.vbCrLf; 
                        if ( radEdit.Checked ) { 
                            this.ltlScript.Text += this.radEdit.Attributes[ "OnClick" ] + Constants.vbCrLf; 
                        } 
                        else if ( this.radShowLastVersion.Checked ) { 
                            this.ltlScript.Text += this.radShowLastVersion.Attributes[ "OnClick" ] + Constants.vbCrLf; 
                        } 
                        else if ( this.radShowPublishedVersion.Checked ) { 
                            this.ltlScript.Text += this.radShowPublishedVersion.Attributes[ "OnClick" ] + Constants.vbCrLf; 
                        } 
                        this.ltlScript.Text += "</script>" + Constants.vbCrLf; 
                        break;
                }
                
            } 
            else { 
                // hide radio buttons
                radShowLastVersion.Visible = false; 
                this.radEdit.Visible = false; 
                this.radShowPublishedVersion.Visible = false; 
            } 
        } 
        
        
        ///<summary>Returns web path of the node</summary>
        ///<param name="node">Node to get webpath to</param>
        public string GetWebPath( TreeNode node ) { 
            if ( node == null ) { return null; } 
            string webpath = null; 
            if ( ConfigurationSettings.AppSettings[ "CMSWebApplicationVirtualPath" ] + "" + "" == "" ) { 
                webpath = "/"; 
            } 
            else { 
                webpath = ConfigurationSettings.AppSettings[ "CMSWebApplicationVirtualPath" ]; 
            } 
            // page in editing mode
            if ( !( node == null ) ) { 
                string relPath = Functions.RemoveCultureFromAliasPath( System.Convert.ToString( node.GetValue( "AliasPath" ) ) ); 
                if ( relPath != "/" & relPath + "" != "" ) { 
                    if ( webpath == "/" ) { 
                        webpath = Functions.GetUrlForAliasPath( relPath ); 
                    } 
                    else { 
                        webpath += Functions.GetUrlForAliasPath( relPath ); 
                    } 
                } 
            } 
            return webpath; 
        } 
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
