using System.IO; 
using Kentico.DirectoryUtilities; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class FileManagerEdit : System.Web.UI.Page { 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by btnFileOK_Click
             
            btnFileOK.Click += new System.EventHandler( btnFileOK_Click ); 
            // events handled by radFileRename_CheckedChanged
             
            radFileRename.CheckedChanged += new System.EventHandler( radFileRename_CheckedChanged ); 
            // events handled by radFileUpdate_CheckedChanged
             
            radFileUpdate.CheckedChanged += new System.EventHandler( radFileUpdate_CheckedChanged ); 
            // events handled by btnFileCancel_Click
             
            btnFileCancel.Click += new System.EventHandler( btnFileCancel_Click ); 
            // events handled by btnFolderCancel_Click
             
            btnFolderCancel.Click += new System.EventHandler( btnFolderCancel_Click ); 
            // events handled by btnFolderOK_Click
             
            btnFolderOK.Click += new System.EventHandler( btnFolderOK_Click ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblInfo; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblError; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Panel pnlFile; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Panel pnlFolder; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnFileOK; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnFolderOK; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnFolderCancel; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.RadioButton radFileRename; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.RadioButton radFileUpdate; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblFolderName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtFolderName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblFileUpdate; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtFileName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnFileCancel; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.HtmlControls.HtmlInputFile upload; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblFileName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.Files", "Modify" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.Files", "Modify" ); 
                return; 
            } 
            
            if ( "" + Request.QueryString[ "idpath" ] == "/" ) { 
                // do not allow editing of the root folder
                pnlFile.Visible = false; 
                pnlFolder.Visible = false; 
                lblError.Text = ResMan.GetString( "FileManagerEdit.ErrorRootPath" ); 
                lblHeader.Text = ResMan.GetString( "FileManagerEdit.Header.Edit" ); 
                return; 
            } 
            
            if ( !( Page.IsPostBack ) ) { 
                SetDiskParentPath(); 
                SetIsFile(); 
                SetParentIDPath(); 
                txtFolderName.Text = Strings.Split( "" + Request.QueryString[ "idpath" ] + "", "/", -1, (Microsoft.VisualBasic.CompareMethod)(0) )[ Strings.Split( "" + Request.QueryString[ "idpath" ] + "", "/", -1, (Microsoft.VisualBasic.CompareMethod)(0) ).GetUpperBound( 0 ) ]; 
                txtFileName.Text = txtFolderName.Text; 
                SetLastSavedName(); 
            } 
            
            if ( IsFile() ) { 
                // file
                pnlFile.Visible = true; 
                pnlFolder.Visible = false; 
                if ( !( Page.IsPostBack ) ) { 
                    radFileRename.Checked = true; 
                    EnableFileRename(); 
                } 
            } 
            else { 
                // folder
                pnlFile.Visible = false; 
                pnlFolder.Visible = true; 
            } 
            
            if ( !( Page.IsPostBack ) ) { 
                lblFileName.Text = ResMan.GetString( "FileManagerEdit.FileName" ); 
                lblFileUpdate.Text = ResMan.GetString( "FileManagerEdit.FileUpdate" ); 
                lblFolderName.Text = ResMan.GetString( "FileManagerEdit.FolderName" ); 
                radFileRename.Text = ResMan.GetString( "FileManagerEdit.RenameFile" ); 
                radFileUpdate.Text = ResMan.GetString( "FileManagerEdit.UpdateFile" ); 
                if ( IsFile() ) { 
                    lblHeader.Text = ResMan.GetString( "FileManagerEdit.Header.File" ); 
                } 
                else { 
                    lblHeader.Text = ResMan.GetString( "FileManagerEdit.Header.Folder" ); 
                } 
                btnFileOK.Text = ResMan.GetString( "FileManagerEdit.OK" ); 
                btnFileCancel.Text = ResMan.GetString( "FileManagerEdit.Cancel" ); 
                btnFolderOK.Text = ResMan.GetString( "FileManagerEdit.OK" ); 
                btnFolderCancel.Text = ResMan.GetString( "FileManagerEdit.Cancel" ); 
            } 
            
            lblError.Text = ""; 
            lblInfo.Text = ""; 
        } 
        
        
        
        private void btnFileOK_Click( System.Object sender, System.EventArgs e ) { 
            string newPath = null; 
            
            if ( radFileRename.Checked == true ) { 
                // check if specified file name already exists
                newPath = GetDiskParentPath() + txtFileName.Text.Trim(); 
                if ( File.Exists( GetDiskParentPath() + txtFileName.Text.Trim() ) & !( ( Strings.LCase( GetDiskParentPath() + txtFileName.Text.Trim() ) == Strings.LCase( GetDiskPath() ) ) ) ) { 
                    lblError.Text = ResMan.GetString( "FileManagerEdit.ErrorExistingFile" ); 
                } 
                else { 
                    // rename file
                    if ( GetDiskPath() != newPath ) { 
                        try { 
                            File.Move( GetDiskPath(), newPath ); 
                            SetLastSavedName(); 
                            lblInfo.Text = ResMan.GetString( "FileManagerEdit.FileRenamed" ); 
                            Refresh(); 
                        } 
                        catch ( Exception ex ) { 
                            lblError.Text = ResMan.GetString( "FileManager.WriteError" ) + "<br>&nbsp;<br>" + ex.Message; 
                        } 
                    } 
                } 
            } 
            else { 
                // upload file
                try { 
                    upload.PostedFile.SaveAs( GetDiskPath() ); 
                    lblInfo.Text = ResMan.GetString( "FileManagerEdit.FileUpdated" ); 
                } 
                catch ( Exception ex ) { 
                    lblError.Text = ResMan.GetString( "FileManager.WriteError" ) + "<br>&nbsp;<br>" + ex.Message; 
                } 
            } 
        } 
        
        
        
        private void radFileRename_CheckedChanged( System.Object sender, System.EventArgs e ) { 
            EnableFileRename(); 
        } 
        
        
        
        private void radFileUpdate_CheckedChanged( System.Object sender, System.EventArgs e ) { 
            EnableFileUpdate(); 
        } 
        
        
        
        private void btnFileCancel_Click( System.Object sender, System.EventArgs e ) { 
            Cancel(); 
        } 
        
        
        
        private void Cancel() { 
            // redirects user back to the previous dialog
            ltlScript.Text = @"<script language=""javascript"">"; 
            ltlScript.Text += " Cancel('" + Strings.Replace( System.Convert.ToString( ViewState[ "parentidpath" ] ), "'", "&apos;", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + "') "; 
            ltlScript.Text += "</script>"; 
        } 
        
        
        
        ///<summary>Enables controls for renaming files.</summary>
        private void EnableFileRename() { 
            lblFileName.Enabled = true; 
            txtFileName.Enabled = true; 
            lblFileUpdate.Enabled = false; 
            upload.Disabled = true; 
        } 
        
        
        
        ///<summary>Enables controls for uploading a new version of the file.</summary>
        private void EnableFileUpdate() { 
            lblFileName.Enabled = false; 
            txtFileName.Enabled = false; 
            lblFileUpdate.Enabled = true; 
            upload.Disabled = false; 
        } 
        
        
        
        ///<summary>Sets a parent ID path.</summary>
        private void SetParentIDPath() { 
            string idpath = "" + Request.QueryString[ "idpath" ]; 
            
            if ( idpath == "/" ) { 
                ViewState[ "parentidpath" ] = "/"; 
            } 
            else { 
                ViewState[ "parentidpath" ] = Strings.Left( idpath, Strings.Len( idpath ) - Strings.Len( Strings.Split( idpath, "/", -1, (Microsoft.VisualBasic.CompareMethod)(0) )[ Strings.Split( idpath, "/", -1, (Microsoft.VisualBasic.CompareMethod)(0) ).GetUpperBound( 0 ) ] ) ); 
            } 
        } 
        
        
        
        ///<summary>Returns parent path (parent folder) on the disk.</summary>
        private string GetDiskParentPath() { 
            return System.Convert.ToString( ViewState[ "DiskParentPath" ] ); 
        } 
        
        
        
        ///<summary>Returns disk path of the current file or folder.</summary>
        private string GetDiskPath() { 
            if ( Strings.Right( GetDiskParentPath(), 1 ) == @"\" ) { 
                return GetDiskParentPath() + System.Convert.ToString( ViewState[ "LastSavedName" ] ); 
            } 
            else { 
                return GetDiskParentPath() + @"\" + System.Convert.ToString( ViewState[ "LastSavedName" ] ); 
            } 
        } 
        
        
        
        ///<summary>Sets disk path of the parent folder.</summary>
        private void SetDiskParentPath() { 
            string parentIDPath = null; 
            parentIDPath = Strings.Left( "" + Request.QueryString[ "idpath" ], Strings.Len( "" + Request.QueryString[ "idpath" ] ) - Strings.Len( Strings.Split( "" + Request.QueryString[ "idpath" ] + "", "/", -1, (Microsoft.VisualBasic.CompareMethod)(0) )[ Strings.Split( "" + Request.QueryString[ "idpath" ], "/", -1, (Microsoft.VisualBasic.CompareMethod)(0) ).GetUpperBound( 0 ) ] ) ); 
            ViewState[ "DiskParentPath" ] = Functions.GetFilesPath() + Strings.Replace( parentIDPath, "/", @"\", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ); 
        } 
        
        
        
        ///<summary>Sets last saved name for comparisons in future.</summary>
        private void SetLastSavedName() { 
            if ( IsFile() ) { 
                ViewState[ "LastSavedName" ] = txtFileName.Text; 
            } 
            else { 
                ViewState[ "LastSavedName" ] = txtFolderName.Text; 
            } 
        } 
        
        
        
        ///<summary>Checks if the current item is file or folder and sets an inner variable.</summary>
        private void SetIsFile() { 
            string idpath = null; 
            FileInfo fileInf = null; 
            
            idpath = "" + Request.QueryString[ "idpath" ]; 
            fileInf = new FileInfo( Functions.GetFilesPath() + Strings.Replace( idpath, "/", @"\", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) ); 
            if ( ( fileInf.Attributes & FileAttributes.Directory ) != FileAttributes.Directory ) { 
                ViewState[ "IsFile" ] = 1; 
            } 
            else { 
                ViewState[ "IsFile" ] = 0; 
            } 
        } 
        
        
        
        ///<summary>Return true if the current item is a file, returns false if it's a folder.</summary>
        protected bool IsFile() { 
            if ( System.Convert.ToInt32( ViewState[ "IsFile" ] ) == 1 ) { 
                return true; 
            } 
            else { 
                return false; 
            } 
        } 
        
        
        
        ///<summary>Refreshes the tree.</summary>
        protected void Refresh() { 
            string parentPath = null; 
            
            if ( System.Convert.ToString( ViewState[ "parentidpath" ] ) == "/" ) { 
                parentPath = "/"; 
            } 
            else { 
                parentPath = Strings.Left( System.Convert.ToString( ViewState[ "parentidpath" ] ), Strings.Len( ViewState[ "parentidpath" ] ) - 1 ); 
            } 
            ltlScript.Text = @"<script language=""javascript"">"; 
            ltlScript.Text += " Refresh('" + Strings.Replace( System.Convert.ToString( ViewState[ "parentidpath" ] ) + System.Convert.ToString( ViewState[ "LastSavedName" ] ), "'", "&apos;", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + "', '" + parentPath.Replace( "'", "&apos;" ) + "'); "; 
            ltlScript.Text += "</script>"; 
        } 
        
        
        
        private void btnFolderCancel_Click( System.Object sender, System.EventArgs e ) { 
            Cancel(); 
        } 
        
        
        
        private void btnFolderOK_Click( System.Object sender, System.EventArgs e ) { 
            string oldPath = null; 
            string newPath = null; 
            
            oldPath = GetDiskParentPath() + System.Convert.ToString( ViewState[ "LastSavedName" ] ); 
            newPath = GetDiskParentPath() + txtFolderName.Text; 
            if ( System.Convert.ToString( ViewState[ "LastSavedName" ] ) != txtFolderName.Text ) { 
                if ( Directory.Exists( newPath ) ) { 
                    // folder already exists
                    lblError.Text = ResMan.GetString( "FileManagerEdit.ErrorExistingFolder" ); 
                } 
                else { 
                    // rename folder            
                    DirectoryHelper.MoveDirectory( oldPath, newPath ); 
                    SetLastSavedName(); 
                    lblInfo.Text = ResMan.GetString( "FileManagerEdit.FolderRenamed" ); 
                    Refresh(); 
                } 
            } 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
