using System.IO; 
using Kentico.CMS.CMSControls; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class FileManagerListing : System.Web.UI.Page { 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
        } 
        
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblRedirect; 
        protected /* TRANSINFO: WithEvents */ BasicDataGrid BasicDataGrid1; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            string idPath = null; 
            FileInfo fileInf = null; 
            
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.Files", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.Files", "Read" ); 
                return; 
            } 
            
            idPath = "" + Request.QueryString[ "idpath" ]; 
            // redirect if it's a file
            fileInf = new FileInfo( Functions.GetFilesPath() + Strings.Replace( idPath + "", "/", @"\", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) ); 
            if ( ( fileInf.Attributes & FileAttributes.Directory ) != FileAttributes.Directory ) { 
                // redirect user to the edit page
                lblRedirect.Text = ResMan.GetString( "FileManagerListing.Redirect" ); 
                Response.Redirect( "FileViewFrameset.aspx?idpath=" + idPath + "&style=" + "" + Request.QueryString[ "style" ] + "&ftbName=" + "" + Request.QueryString[ "ftbName" ] ); 
                return; 
            } 
            
            lblHeader.Text = ResMan.GetString( "FileManagerListing.Header" ); 
            BasicDataGrid1.DataSource = GetFoldersAndFiles( idPath ); 
            BasicDataGrid1.Columns[ 0 ].HeaderText = ResMan.GetString( "FileManagerListing.FileName" ); 
            BasicDataGrid1.Columns[ 1 ].HeaderText = ResMan.GetString( "FileManagerListing.FileLastModified" ); 
        } 
        
        
        
        ///<summary>Returns a dataset containing all files and folder in the specified folder.</summary>
        ///<param name="relativePath">Relative path to the parent folder.</param>
        protected DataSet GetFoldersAndFiles( string relativePath ) { 
            FileSystemInfo[] items = null; 
            DataSet ds = new DataSet(); 
            DataRow dr = null; 
            int i = 0; 
            
            items = GetFileSystemInfos( relativePath ); 
            // create an empty table
            ds.Tables.Add( new DataTable() ); 
            ds.Tables[ 0 ].Columns.Add( new DataColumn( "FileName" ) ); 
            ds.Tables[ 0 ].Columns.Add( new DataColumn( "FileLastModified" ) ); 
            // add files
            for ( i=items.GetLowerBound( 0 ); i<=items.GetUpperBound( 0 ); i++ ) { 
                if ( ( items[ i ].Attributes & FileAttributes.Directory ) != FileAttributes.Directory ) { 
                    dr = ds.Tables[ 0 ].NewRow(); 
                    dr[ "FileName" ] = items[ i ].Name; 
                    dr[ "FileLastModified" ] = items[ i ].LastWriteTime; 
                    ds.Tables[ 0 ].Rows.Add( dr ); 
                } 
            } 
            return ds; 
        } 
        
        
        
        ///<summary>Returns informatino about files and folders in the specified folder.</summary>
        ///<param name="relativePath">Relative path to the parent folder.</param>
        protected FileSystemInfo[] GetFileSystemInfos( string relativePath ) { 
            string folderPath = null; 
            DirectoryInfo di = null; 
            
            folderPath = Functions.GetFilesPath() + Strings.Replace( relativePath + "", "/", @"\", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ); 
            di = new DirectoryInfo( folderPath ); 
            return di.GetFileSystemInfos(); 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
