using System.IO; 
using Kentico.DirectoryUtilities; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class FileManagerNew : System.Web.UI.Page { 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by btnOK_Click
             
            btnOK.Click += new System.EventHandler( btnOK_Click ); 
            // events handled by btnCancel_Click
             
            btnCancel.Click += new System.EventHandler( btnCancel_Click ); 
            // events handled by radFolder_CheckedChanged
             
            radFolder.CheckedChanged += new System.EventHandler( radFolder_CheckedChanged ); 
            // events handled by radFile_CheckedChanged
             
            radFile.CheckedChanged += new System.EventHandler( radFile_CheckedChanged ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.HtmlControls.HtmlInputFile upload; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnOK; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnCancel; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblInfo; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblFileName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblFolderName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtFolderName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.RadioButton radFile; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.RadioButton radFolder; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblError; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Panel pnlForm; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        protected void Page_Load( System.Object sender, System.EventArgs e ) { 
            string idpath = null; 
            FileInfo fileInf = null; 
            
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.Files", "Create" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.Files", "Create" ); 
                return; 
            } 
            
            if ( !( Page.IsPostBack ) ) { 
                lblHeader.Text = ResMan.GetString( "FileManagerNew.Header" ); 
                lblFileName.Text = ResMan.GetString( "FileManagerNew.FileName" ); 
                btnOK.Text = ResMan.GetString( "FileManagerNew.OK" ); 
                btnCancel.Text = ResMan.GetString( "FileManagerNew.Cancel" ); 
                radFile.Text = ResMan.GetString( "FileManagerNew.CreateFile" ); 
                radFolder.Text = ResMan.GetString( "FileManagerNew.CreateFolder" ); 
                lblFolderName.Text = ResMan.GetString( "FileManagerNew.FolderName" ); 
                enableNewFile(); 
                
                idpath = "" + Request.QueryString[ "idpath" ]; 
                // redirect if parent node is a file
                fileInf = new FileInfo( Functions.GetFilesPath() + Strings.Replace( idpath + "", "/", @"\", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) ); 
                if ( ( fileInf.Attributes & FileAttributes.Directory ) != FileAttributes.Directory ) { 
                    // redirect user to the edit page
                    lblError.Text = ResMan.GetString( "FileManagerNew.ErrorCreateOnlyInFolder" ); 
                    pnlForm.Visible = false; 
                    return; 
                } 
            } 
            lblInfo.Text = ""; 
            lblError.Text = ""; 
            ltlScript.Text = ""; 
        } 
        
        
        
        protected void btnOK_Click( System.Object sender, System.EventArgs e ) { 
            string diskpath = null; 
            string idpath = null; 
            
            idpath = "" + Request.QueryString[ "idpath" ]; 
            if ( radFile.Checked == true ) { 
                if ( upload.Name.Trim() + "" == "" ) { 
                    lblError.Text = ResMan.GetString( "FileManagerNew.ErrorNoFileSpecified" ); 
                } 
                else if ( !( upload.PostedFile == null ) ) { 
                    if ( idpath == "/" ) { 
                        diskpath = Functions.GetFilesPath() + Strings.Replace( idpath, "..", "", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + System.IO.Path.GetFileName( upload.PostedFile.FileName ); 
                    } 
                    else { 
                        diskpath = Functions.GetFilesPath() + Strings.Replace( idpath, "..", "", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + "/" + System.IO.Path.GetFileName( upload.PostedFile.FileName ); 
                    } 
                    if ( File.Exists( diskpath ) ) { 
                        lblError.Text = ResMan.GetString( "FileManagerNew.ErrorFileExists" ); 
                        return; 
                    } 
                    try { 
                        upload.PostedFile.SaveAs( diskpath ); 
                        lblInfo.Text = ResMan.GetString( "FileManagerNew.FileUploaded" ); 
                        RefreshTree(); 
                    } 
                    catch ( Exception ex ) { 
                        lblError.Text = ResMan.GetString( "FileManager.WriteError" ) + "<br>&nbsp;<br>" + ex.Message; 
                    } 
                } 
            } 
            else { 
                if ( txtFolderName.Text.Trim() + "" == "" ) { 
                    lblError.Text = ResMan.GetString( "FileManagerNew.ErrorNoFolderName" ); 
                } 
                else { 
                    if ( idpath == "/" ) { 
                        diskpath = Strings.Replace( Functions.GetFilesPath() + Strings.Replace( idpath, "..", "", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + txtFolderName.Text.Trim(), "/", @"\", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ); 
                    } 
                    else { 
                        diskpath = Strings.Replace( Functions.GetFilesPath() + Strings.Replace( idpath, "..", "", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + @"\" + txtFolderName.Text.Trim(), "/", @"\", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ); 
                    } 
                    if ( Directory.Exists( diskpath ) ) { 
                        lblError.Text = ResMan.GetString( "FileManagerNew.ErrorFolderExists" ); 
                    } 
                    else { 
                        try { 
                            DirectoryHelper.CreateDirectory( diskpath ); 
                            lblInfo.Text = ResMan.GetString( "FileManagerNew.FolderCreated" ); 
                            txtFolderName.Text = ""; 
                            RefreshTree(); 
                        } 
                        catch ( Exception ex ) { 
                            lblError.Text = ResMan.GetString( "FileManager.WriteError" ) + "<br>&nbsp;<br>" + ex.Message; 
                        } 
                    } 
                } 
            } 
        } 
        
        
        
        protected void btnCancel_Click( System.Object sender, System.EventArgs e ) { 
            // redirect user back to the listing page
            ltlScript.Text = @"<script language=""javascript"">"; 
            ltlScript.Text += "  Cancel('" + "" + Request.QueryString[ "idpath" ] + "');"; 
            ltlScript.Text += "</script>"; 
        } 
        
        
        
        protected void radFolder_CheckedChanged( System.Object sender, System.EventArgs e ) { 
            enableNewFolder(); 
        } 
        
        
        
        protected void radFile_CheckedChanged( System.Object sender, System.EventArgs e ) { 
            enableNewFile(); 
        } 
        
        
        
        protected void enableNewFolder() { 
            // show controls for creating a new folder
            lblFileName.Enabled = false; 
            upload.Disabled = true; 
            lblFolderName.Enabled = true; 
            txtFolderName.Enabled = true; 
        } 
        
        
        
        protected void enableNewFile() { 
            // show controls for uploading a new file
            lblFileName.Enabled = true; 
            upload.Disabled = false; 
            lblFolderName.Enabled = false; 
            txtFolderName.Enabled = false; 
        } 
        
        
        
        ///<summary>Refreshes the tree file structure.</summary>
        protected void RefreshTree() { 
            ltlScript.Text = @"<script language=""javascript"">"; 
            ltlScript.Text += "  RefreshTree();"; 
            ltlScript.Text += "</script>"; 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
