using System.IO; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class FileManagerPreviewFolder : System.Web.UI.Page { 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlPreview; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            FileSystemInfo[] files = null; 
            string idpath = "" + Request.QueryString[ "idpath" ]; 
            int i = 0; 
            string imagepath = null; 
            
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.Files", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.Files", "Read" ); 
                return; 
            } 
            
            files = GetFileSystemInfos( idpath ); 
            // display the table of preview images
            ltlPreview.Text = "<table>"; 
            for ( i=files.GetLowerBound( 0 ); i<=files.GetUpperBound( 0 ); i++ ) { 
                if ( ( files[ i ].Attributes & FileAttributes.Directory ) != FileAttributes.Directory ) { 
                    if ( idpath == "/" ) { 
                        imagepath = ConfigurationSettings.AppSettings[ "CMSFilesFolder" ] + "/" + files[ i ].Name; 
                    } 
                    else { 
                        imagepath = ConfigurationSettings.AppSettings[ "CMSFilesFolder" ] + "/" + idpath + "/" + files[ i ].Name; 
                    } 
                    ltlPreview.Text += @"<tr valign=""middle""><td><table class=""PreviewImageBorder""><tr valign=""middle""><td align=""center""><img width=""50px"" height=""50"" src=""" + imagepath + @""" align=""center""></td></tr></table></td><td><a href=""" + imagepath + @"""> " + files[ i ].Name + "</a></td></tr>"; 
                } 
            } 
            ltlPreview.Text += "</table>"; 
        } 
        
        
        
        ///<summary>Returns information about files and folders in the specified parent folder.</summary>
        ///<param name="relativePath">Relative path to the parent folder.</param>
        protected FileSystemInfo[] GetFileSystemInfos( string relativePath ) { 
            string folderPath = null; 
            DirectoryInfo di = null; 
            
            folderPath = Functions.GetFilesPath() + Strings.Replace( relativePath + "", "/", @"\", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ); 
            di = new DirectoryInfo( folderPath ); 
            return di.GetFileSystemInfos(); 
        } 
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
