using Kentico.CMS.CMSControls; 
using System.IO; 
using Kentico.DirectoryUtilities; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class FileManagerTreeData : System.Web.UI.Page { 
        
        private const string cImageBasePath = "../Design/Tree"; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlRender; 
        private const string cIconsBasePath = "../Design/FileIcons/"; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
        } 
        
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            string action = null; 
            
            action = Strings.LCase( Strings.Trim( "" + Request.QueryString[ "action" ] + "" ) ); 
            ltlRender.Text = @"<script language=""javascript"">" + Constants.vbCrLf; 
            switch ( action ) {
                case "expandnode":
                    if ( !( Functions.IsAuthorizedPerResource( "CMS.Files", "Read" ) ) ) { 
                        ShowErrorMessage( ResMan.GetString( "AccessDenied.NotAllowedToRead" ) ); 
                    } 
                    else { 
                        AddRenderScript( GetChildNodes( "" + Request.QueryString[ "nodeid" ], "" + Request.QueryString[ "sample" ], "" + Request.QueryString[ "value" ] ), "" + Request.QueryString[ "nodeid" ] ); 
                        if ( "" + Request.QueryString[ "selectID" ] + "" + "" != "" ) { 
                            AddSelectNodeScript( "" + Request.QueryString[ "selectID" ], false, true ); 
                        } 
                    } 
                    break;
                case "delete":
                    if ( !( Functions.IsAuthorizedPerResource( "CMS.Files", "Delete" ) ) ) { 
                        ShowErrorMessage( ResMan.GetString( "AccessDenied.NotAllowedToDeleteFile" ) ); 
                    } 
                    else { 
                        AddSelectNodeScript( DeleteNode( "" + Request.QueryString[ "idpath" ] ), true, false ); 
                        AddReloadSelectedNodeScript(); 
                    } 
                    break;
                case "copy":
                    if ( !( ( Functions.IsAuthorizedPerResource( "CMS.Files", "Read" ) & Functions.IsAuthorizedPerResource( "CMS.Files", "Create" ) ) ) ) { 
                        ShowErrorMessage( ResMan.GetString( "AccessDenied.NotAllowedToCopyFile" ) ); 
                    } 
                    else { 
                        if ( ( "" + Request.QueryString[ "idpath" ] + "" ).ToLower().StartsWith( "" + Request.QueryString[ "sourceIDPath" ].ToLower() ) ) { 
                            ShowErrorMessage( ResMan.GetString( "FileManagerTreeData.CannotCopyInside" ) ); 
                        } 
                        else { 
                            CopyNode( "" + Request.QueryString[ "sourceIDPath" ], "" + Request.QueryString[ "idpath" ] ); 
                            AddSelectNodeScript( "" + Request.QueryString[ "idpath" ], true, false ); 
                            AddReloadSelectedNodeScript(); 
                        } 
                    } 
                    break;
                case "move":
                    if ( !( Functions.IsAuthorizedPerResource( "CMS.Files", "Modify" ) ) ) { 
                        ShowErrorMessage( ResMan.GetString( "AccessDenied.NotAllowedToMove" ) ); 
                    } 
                    else { 
                        if ( ( "" + Request.QueryString[ "idpath" ] + "" ).ToLower().StartsWith( "" + Request.QueryString[ "sourceIDPath" ].ToLower() ) ) { 
                            ShowErrorMessage( ResMan.GetString( "FileManagerTreeData.CannotMoveInside" ) ); 
                        } 
                        else { 
                            MoveNode( "" + Request.QueryString[ "sourceIDPath" ], "" + Request.QueryString[ "idpath" ] ); 
                            AddSelectNodeScript( "" + Request.QueryString[ "idpath" ], true, false ); 
                            AddRemoveNodeScript( "" + Request.QueryString[ "sourceIDPath" ] ); 
                            AddReloadSelectedNodeScript(); 
                        } 
                    } 
                    break;
            }
            
            ltlRender.Text += "</script>"; 
        } 
        
        
        
        ///<summary>Adds script that removes the given node from the displayed tree.</summary>
        ///<param name="nodeIDPath">IDPath of the node to be removed.</param>
        public void AddRemoveNodeScript( string nodeIDPath ) { 
            ltlRender.Text += " parent.frames['tree'].document.getElementById('nodeID_" + nodeIDPath + "').innerHTML = '';"; 
        } 
        
        
        
        ///<summary>Adds script that reloads the selected node.</summary>
        public void AddReloadSelectedNodeScript() { 
            ltlRender.Text += " parent.frames['tree'].ReloadSelectedNode();" + Constants.vbCrLf; 
        } 
        
        
        
        ///<summary>Adds script that selects given node.</summary>
        ///<param name="selectIDPath">IDPath of the node to be selected.</param>
        ///<param name="selectDesktop">Indicates if desktop should be updated.</param>
        ///<param name="selectMenu">Indicates if menu (header) selected item value should be updated.</param>
        public void AddSelectNodeScript( string selectIDPath, bool selectDesktop, bool selectMenu ) { 
            ltlRender.Text += " SelectNode('" + selectIDPath.Replace( "'", "&apos;" ) + "'); " + Constants.vbCrLf + " function SelectNode(selectID) {" + Constants.vbCrLf + "  //try {" + Constants.vbCrLf + "  parent.frames['tree'].SelectNode(selectID);" + Constants.vbCrLf; 
            if ( selectDesktop ) { 
                ltlRender.Text += "  parent.frames['header'].SelectNode(selectID);" + Constants.vbCrLf; 
            } 
            if ( selectMenu ) { 
                ltlRender.Text += "  parent.frames['header'].document.getElementById('idpath').value = selectID;" + Constants.vbCrLf; 
            } 
            ltlRender.Text += "  //} catch(e) { } " + Constants.vbCrLf + " } " + Constants.vbCrLf; 
        } 
        
        
        
        ///<summary>Adds content that will be rendered under given parent node.</summary>
        ///<param name="content">Content to be rendered.</param>
        ///<param name="targetNodeIDPath">Target node IDPath.</param>
        public void AddRenderScript( string content, string targetNodeIDPath ) { 
            string innerHTML = null; 
            innerHTML = Strings.Replace( content + "", "'", @"\'", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ); 
            innerHTML = Strings.Replace( innerHTML, @"""", @"\""", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ); 
            innerHTML = Strings.Replace( innerHTML, Constants.vbCrLf, " ", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ); 
            
            ltlRender.Text += " RenderData(); " + Constants.vbCrLf + " function RenderData() {" + Constants.vbCrLf + "  // try {" + Constants.vbCrLf + "  parent.frames['tree'].document.getElementById('sub_" + targetNodeIDPath + "').innerHTML = '" + innerHTML + "'; " + Constants.vbCrLf; 
            if ( innerHTML + "" + "" == "" ) { 
                ltlRender.Text += " parent.frames['tree'].document.getElementById('sub_" + targetNodeIDPath + "').style.display = 'none'; " + Constants.vbCrLf; 
            } 
            ltlRender.Text += "  // } catch(e) { } " + Constants.vbCrLf + " } " + Constants.vbCrLf; 
        } 
        
        
        
        ///<summary>Returns child nodes at 2nd and lower level.</summary>
        ///<param name="NodeID">Parent node ID (IDPath).</param>
        ///<param name="Sample">Sample for displaying tree.</param>
        ///<param name="Value">Value of the parent node.</param>
        public string GetChildNodes( string NodeID, string Sample, string Value ) { 
            TreeNodes nodes = new TreeNodes(); 
            int i = 0; 
            FileSystemInfo[] items = null; 
            
            nodes.ImagePathBase = cImageBasePath; 
            items = GetFileSystemInfos( NodeID ); 
            if ( NodeID == "/" ) { 
                NodeID = ""; 
            } 
            // render folders
            for ( i=items.GetLowerBound( 0 ); i<=items.GetUpperBound( 0 ); i++ ) { 
                if ( ( items[ i ].Attributes & FileAttributes.Directory ) == FileAttributes.Directory ) { 
                    // test if hidden folders should be displayed
                    if ( !( ( !( ConfigurationSettings.AppSettings[ "CMSShowHiddenFolders" ] == null ) && ConfigurationSettings.AppSettings[ "CMSShowHiddenFolders" ].ToLower() == "false" && ( items[ i ].Attributes & FileAttributes.Hidden ) == FileAttributes.Hidden ) ) ) { 
                        nodes.NewNode( items[ i ].Name, Value, cIconsBasePath + "folder.gif", cIconsBasePath + "folder_open.gif", items[ i ].Name, "parent.frames['header'].SelectNode('" + NodeID + "/" + items[ i ].Name + "')", NodeID + "/" + items[ i ].Name, Sample, true ); 
                    } 
                } 
            } 
            // render files
            for ( i=items.GetLowerBound( 0 ); i<=items.GetUpperBound( 0 ); i++ ) { 
                if ( ( items[ i ].Attributes & FileAttributes.Directory ) != FileAttributes.Directory ) { 
                    // test if hiddend files should be displayed
                    if ( !( ( !( ConfigurationSettings.AppSettings[ "CMSShowHiddenFiles" ] == null ) && ConfigurationSettings.AppSettings[ "CMSShowHiddenFiles" ].ToLower() == "false" && ( items[ i ].Attributes & FileAttributes.Hidden ) == FileAttributes.Hidden ) ) ) { 
                        nodes.NewNode( items[ i ].Name, Value, cIconsBasePath + "file.gif", cIconsBasePath + "file_open.gif", items[ i ].Name, "parent.frames['header'].SelectNode('" + Server.UrlEncode( NodeID + "/" + items[ i ].Name.Replace( "'", "&apos;" ) ) + "')", NodeID + "/" + items[ i ].Name, Sample, false ); 
                    } 
                } 
            } 
            return nodes.NodesHTML(); 
        } 
        
        
        
        ///<summary>Deletes specified node and returns IDPath of its parent.</summary>
        ///<param name="IDPath">IDPath of the node to be deleted.</param>
        public string DeleteNode( string IDPath ) { 
            // delete the node
            string parentIDPath = null; 
            
            if ( IsFile( IDPath ) ) { 
                // file
                File.Delete( GetDiskPath( IDPath ) ); 
            } 
            else { 
                // folder
                Directory.Delete( GetDiskPath( IDPath ), true ); 
            } 
            
            parentIDPath = Strings.Left( IDPath, Strings.Len( IDPath ) - Strings.Len( Strings.Split( IDPath, "/", -1, (Microsoft.VisualBasic.CompareMethod)(0) )[ Strings.Split( IDPath, "/", -1, (Microsoft.VisualBasic.CompareMethod)(0) ).GetUpperBound( 0 ) ] ) ); 
            if ( parentIDPath != "/" & Strings.Right( parentIDPath, 1 ) == "/" ) { 
                parentIDPath = Strings.Left( parentIDPath, Strings.Len( parentIDPath ) - 1 ); 
            } 
            return parentIDPath; 
        } 
        
        
        
        ///<summary>Copies specified node.</summary>
        ///<param name="sourceID">Source IDPath.</param>
        ///<param name="targetIDPath">Target IDPath.</param>
        public void CopyNode( string sourceIDPath, string targetIDPath ) { 
            string safeTargetPath = null; 
            
            if ( IsFile( sourceIDPath ) ) { 
                safeTargetPath = GetUniqueFilePath( GetDiskPath( targetIDPath ) + @"\" + Path.GetFileName( GetDiskPath( sourceIDPath ) ) ); 
                File.Copy( GetDiskPath( sourceIDPath ), safeTargetPath, true ); 
            } 
            else { 
                safeTargetPath = GetUniqueFolderPath( GetDiskPath( targetIDPath ) + @"\" + Path.GetFileName( GetDiskPath( sourceIDPath ) ) ); 
                CopyDirectory( GetDiskPath( sourceIDPath ), safeTargetPath ); 
            } 
        } 
        
        
        
        ///<summary>Moves specified node.</summary>
        ///<param name="sourceID">Source IDPath.</param>
        ///<param name="targetIDPath">Target IDPath.</param>
        public void MoveNode( string sourceIDPath, string targetIDPath ) { 
            string safeTargetPath = null; 
            
            if ( IsFile( sourceIDPath ) ) { 
                safeTargetPath = GetUniqueFilePath( GetDiskPath( targetIDPath ) + @"\" + Path.GetFileName( GetDiskPath( sourceIDPath ) ) ); 
                File.Move( GetDiskPath( sourceIDPath ), safeTargetPath ); 
            } 
            else { 
                safeTargetPath = GetUniqueFolderPath( GetDiskPath( targetIDPath ) + @"\" + Path.GetFileName( GetDiskPath( sourceIDPath ) ) ); 
                DirectoryHelper.MoveDirectory( GetDiskPath( sourceIDPath ), safeTargetPath ); 
            } 
        } 
        
        
        
        ///<summary>Checks if provided file already exists and if so, it adds a number at the end of its name.</summary>
        protected string GetUniqueFilePath( string path ) { 
            int i = 0; 
            string newPath = null; 
            string extension = null; 
            string trimExtension = null; 
            
            newPath = path; 
            while ( File.Exists( newPath ) ) { 
                if ( Strings.InStr( newPath, ".", (Microsoft.VisualBasic.CompareMethod)(0) ) > 0 ) { 
                    trimExtension = newPath.Substring( 0, newPath.LastIndexOf( "." ) ); 
                    extension = newPath.Substring( newPath.LastIndexOf( "." ) ); 
                    newPath = trimExtension + " (" + i + ")" + extension; 
                } 
                else { 
                    newPath = path + " (" + i + ")"; 
                } 
                i += 1; 
            } 
            return newPath; 
        } 
        
        
        
        ///<summary>Checks if provided folder already exists and if so, it adds a number at the end of its name.</summary>
        protected string GetUniqueFolderPath( string path ) { 
            int i = 0; 
            string newPath = null; 
            
            newPath = path; 
            while ( Directory.Exists( newPath ) ) { 
                newPath = path + " (" + i + ")"; 
                i += 1; 
            } 
            return newPath; 
        } 
        
        
        
        ///<summary>Returns information about files and folders.</summary>
        ///<param name="relativePath">Relative path to the parent folder.</param>
        protected FileSystemInfo[] GetFileSystemInfos( string relativePath ) { 
            string folderPath = null; 
            DirectoryInfo di = null; 
            
            folderPath = Functions.GetFilesPath() + Strings.Replace( relativePath + "", "/", @"\", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ); 
            di = new DirectoryInfo( folderPath ); 
            return di.GetFileSystemInfos(); 
        } 
        
        
        
        ///<summary>Returns true in case the provided item is a file.</summary>
        ///<param name="IDPath">Relative path to the item (file or folder).</param>
        protected bool IsFile( string IDPath ) { 
            FileInfo fileInf = null; 
            string diskPath = null; 
            
            diskPath = GetDiskPath( IDPath ); 
            fileInf = new FileInfo( diskPath ); 
            if ( ( fileInf.Attributes & FileAttributes.Directory ) != FileAttributes.Directory ) { 
                // file
                return true; 
            } 
            else { 
                // folder
                return false; 
            } 
        } 
        
        
        
        ///<summary>Returns disk path for the given relative path.</summary>
        ///<param name="IDPath">Relative path to the file or folder.</param>
        protected string GetDiskPath( string IDPath ) { 
            return Functions.GetFilesPath() + Strings.Replace( IDPath, "/", @"\", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ); 
        } 
        
        
        
        ///<summary>Copies folder including its subfolders and all files.</summary>
        ///<param name="sourceDirectory">Physical path of the source folder.</param>
        ///<param name="targetDirectory">Physical path of the target folder.</param>
        public void CopyDirectory( string sourceDirectory, string targetDirectory ) { 
            DirectoryHelper.CopyDirectory( sourceDirectory, targetDirectory ); 
        } 
        
        
        
        ///<summary>Displays an error message.</summary>
        ///<param name="message">Error message.</param>
        public void ShowErrorMessage( string message ) { 
            ltlRender.Text += " alert('" + Strings.Replace( message + "", "'", @"\'", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + "');"; 
        } 
        
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
