using Kentico.CMS.MetadataEngine; 
using Kentico.CMS.TreeEngine; 
using Kentico.LicenseProvider; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class Header : System.Web.UI.Page { 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by DoSignOut
             
            SignOutButton1.BeforeSignOut += new Kentico.CMS.CMSControls.SignOutButton.BeforeSignOutEventHandler( DoSignOut ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ Kentico.CMS.CMSControls.SignOutButton SignOutButton1; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblCurrentUser; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblVersion; 
        protected /* TRANSINFO: WithEvents */ Kentico.CMS.CMSControls.BasicTabControl TabControl1; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblDBName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblEdition; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            TreeProvider tree = Functions.GetTreeProvider(); 
            string showTabs = null; 
            string databaseName = null; 
            int i = 0; 
            string contentURL = null; 
            
            if ( tree.SelectSingleNode( Functions.GetUsersStartingAliasPath(), TreePathTypeEnum.AliasPath ) == null ) { 
                // user doesn't have the starting path set up correctly
                ShowPage( "InvalidStartingPath.aspx" ); 
                return; 
            } 
            
            tree.Connection.DataConnection.Open(); 
            databaseName = tree.Connection.DataConnection.NativeConnection.Database; 
            tree.Connection.DataConnection.Close(); 
            lblCurrentUser.Text = ResMan.GetString( "Header.UserName" ) + "&nbsp;" + User.Identity.Name; 
            lblVersion.Text = ResMan.GetString( "Header.Version" ) + "&nbsp;" + tree.GetType().Assembly.GetName().Version.Major + "." + tree.GetType().Assembly.GetName().Version.Minor + "." + tree.GetType().Assembly.GetName().Version.Build; 
            lblDBName.Text = ResMan.GetString( "Header.DBName" ) + "&nbsp;" + databaseName; 
            ltlScript.Text = ""; 
            lblEdition.Text = ResMan.GetString( "Header.Edition" ) + "&nbsp;"; 
            if ( LicenseManager.GetProductCode() == "CX" ) { 
                lblEdition.Text += "Express"; 
            } 
            else { 
                lblEdition.Text += "Professional"; 
            } 
            
            // hide Sign Out button if Windows authentication is used
            if ( Strings.Trim( Strings.LCase( User.Identity.AuthenticationType + "" ) ) == "forms" ) { 
                // forms authentication
                SignOutButton1.Visible = true; 
            } 
            else { 
                // windows authentication             
                SignOutButton1.Visible = false; 
            } 
            
            // check permissions and show or hide tabs
            if ( Functions.IsAuthorizedPerResource( "CMS.Content", "ExploreTree" ) | Functions.IsAuthorizedPerNode( Functions.GetUsersStartingPath(), TreePathTypeEnum.IDPath, NodePermissionsEnum.ExploreTree ) | ( ConfigurationSettings.AppSettings[ "CMSAllowUnfoldingOfAnyDocument" ] + "" ).ToLower().Trim() == "true" ) { 
                showTabs += "C"; 
            } 
            if ( Functions.IsAuthorizedPerResource( "CMS.Files", "Read" ) && ( !( ConfigurationSettings.AppSettings[ "CMSUseFileManagerForImages" ] == null ) ) && ( ConfigurationSettings.AppSettings[ "CMSUseFileManagerForImages" ] == "true" ) ) { 
                showTabs += "F"; 
            } 
            if ( Functions.IsAuthorizedPerResource( "CMS.Tools", "Read" ) && ( ( ConfigurationSettings.AppSettings[ "CMSShowToolsModule" ] == null ) || ( ConfigurationSettings.AppSettings[ "CMSShowToolsModule" ] != "false" ) ) ) { 
                showTabs += "T"; 
            } 
            if ( Functions.IsAuthorizedPerResource( "CMS.Administration", "Read" ) ) { 
                showTabs += "A"; 
            } 
            if ( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Read" ) ) { 
                showTabs += "M"; 
            } 
            // decide if the Content section should be hidden
            bool showContent = true; 
            if ( Functions.GetConfigValue( "CMSHideContentModuleFromRoles" ) + "" != "" ) { 
                TreeSecurityProvider treeSec = new TreeSecurityProvider( Functions.GetTreeProvider() ); 
                string[] roles = Functions.GetConfigValue( "CMSHideContentModuleFromRoles" ).Split( ';' ); 
                int index = 0; 
                for ( index=0; index<=roles.GetUpperBound( 0 ); index++ ) { 
                    if ( treeSec.IsInRole( roles[ index ] ) ) { 
                        showContent = false; 
                    } 
                } 
            } 
            
            if ( showTabs + "" + "" == "" ) { 
                // user has no permissions
                ShowPage( "NoPermissions.aspx" ); 
                return; 
            } 
            string[,] tabs = new string[ 1, 1 ]; 
            int plusConstant = 0; 
            if ( showContent ) { 
                if ( !( ConfigurationSettings.AppSettings[ "CMSUseSiteModule" ] == null ) && ConfigurationSettings.AppSettings[ "CMSUseSiteModule" ].ToLower() == "true" ) { 
                    tabs = new string[ showTabs.Length + 2, 4 ]; 
                } 
                else { 
                    tabs = new string[ showTabs.Length + 1, 4 ]; 
                } 
                plusConstant = 1; 
            } 
            else { 
                if ( !( ConfigurationSettings.AppSettings[ "CMSUseSiteModule" ] == null ) && ConfigurationSettings.AppSettings[ "CMSUseSiteModule" ].ToLower() == "true" ) { 
                    tabs = new string[ showTabs.Length + 1, 4 ]; 
                } 
                else { 
                    tabs = new string[ showTabs.Length - 1, 3 ]; 
                } 
                plusConstant = 0; 
            } 
            tabs[ 0, 0 ] = ResMan.GetString( "Header.MyDesk" ); 
            tabs[ 0, 1 ] = "parent.frames['desktop'].document.location.href='MyDesk/MyDeskFrameset.aspx';"; 
            // Show site tab?
            if ( !( ConfigurationSettings.AppSettings[ "CMSUseSiteModule" ] == null ) && ConfigurationSettings.AppSettings[ "CMSUseSiteModule" ].ToLower() == "true" ) { 
                tabs[ plusConstant, 0 ] = ResMan.GetString( "Header.Browse" ); 
                tabs[ plusConstant, 1 ] = "parent.frames['desktop'].document.location.href='browse/default.aspx';"; 
                plusConstant = plusConstant + 1; 
            } 
            
            if ( ( "" + Request.QueryString[ "expandmode" ] + "" ).ToLower().StartsWith( "browse" ) ) { 
                TabControl1.SelectedTab = 1; 
                ShowPage( "browse/default.aspx?expandidpath=" + "" + Request.QueryString[ "expandidpath" ] + "&expandmode=" + "" + Request.QueryString[ "expandmode" ] ); 
            } 
            for ( i=0; i<=showTabs.Length - 1; i++ ) { 
                switch ( showTabs[ i ] ) {
                    case 'C':
                        if ( showContent ) { 
                            tabs[ i + plusConstant, 0 ] = ResMan.GetString( "Header.Content" ); 
                            contentURL = "content/contentframeset.aspx?expandmode=" + "" + Request.QueryString[ "expandmode" ] + "&expandidpath=" + "" + Request.QueryString[ "expandidpath" ]; 
                            tabs[ i + plusConstant, 1 ] = "parent.frames['desktop'].document.location.href='" + contentURL + "';"; 
                            if ( "" + Request.QueryString[ "expandidpath" ] + "" + "" != "" && ( !( ( "" + Request.QueryString[ "expandmode" ] + "" ).ToLower().StartsWith( "browse" ) ) ) ) { 
                                this.TabControl1.SelectedTab = i + 2; 
                                ShowPage( contentURL ); 
                            } 
                        } 
                        break;
                    case 'F':
                        tabs[ i + plusConstant, 0 ] = ResMan.GetString( "Header.Files" ); 
                        tabs[ i + plusConstant, 1 ] = "parent.frames['desktop'].document.location.href='filemanager/filemanagerframeset.aspx';"; 
                        break;
                    case 'T':
                        tabs[ i + plusConstant, 0 ] = ResMan.GetString( "Header.Tools" ); 
                        tabs[ i + plusConstant, 1 ] = "parent.frames['desktop'].document.location.href='tools/toolsframeset.aspx';"; 
                        break;
                    case 'A':
                        tabs[ i + plusConstant, 0 ] = ResMan.GetString( "Header.Administration" ); 
                        tabs[ i + plusConstant, 1 ] = "parent.frames['desktop'].document.location.href='administration/administrationframeset.aspx';"; 
                        break;
                    case 'M':
                        tabs[ i + plusConstant, 0 ] = ResMan.GetString( "Header.MetaDesigner" ); 
                        tabs[ i + plusConstant, 1 ] = "parent.frames['desktop'].document.location.href='metadesigner/metadesignerframeset.aspx';"; 
                        break;
                }
                
            } 
            TabControl1.Tabs = tabs; 
        } 
        
        
        
        ///<summary>Generates client script for displaying the selected page.</summary>
        ///<param name="url">URL of the page to be displayed.</param>
        private void ShowPage( string url ) { 
            ltlScript.Text = @"<script language=""javascript"">"; 
            ltlScript.Text += " parent.frames['desktop'].document.location.href='" + url + "'; "; 
            ltlScript.Text += "</script>"; 
        } 
        
        
        
        ///<summary>Cleans all session variables when user signs out.</summary>
        private void DoSignOut() { 
            Session[ "CMSUserID" ] = null; 
            Session[ "CMSPreferredCulture" ] = null; 
            Session[ "CMSUserPreferredUICulture" ] = null; 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
