using Kentico.CMS.CMSControls; 
using Kentico.CMS.TreeEngine; 
using System.IO; 
using Kentico.CMS.Newsletter; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class Logon : System.Web.UI.Page { 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by LogonSuccessful
             
            LogonForm1.LogonSuccessful += new Kentico.CMS.CMSControls.LogonForm.LogonSuccessfulEventHandler( LogonSuccessful ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ Kentico.CMS.CMSControls.LogonForm LogonForm1; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlFrameNameScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblError; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // Get the parent frame name to view the logon form page in the right frame after the session time outs.
            string frameName = ConfigurationSettings.AppSettings[ "CMSParentFrameName" ]; 
            if ( Strings.Trim( frameName + "" ) + "" == "" ) { 
                frameName = "top"; 
            } 
            ltlFrameNameScript.Text = ""; 
            ltlFrameNameScript.Text += @"<script language=""javascript"">"; 
            ltlFrameNameScript.Text += " frameName = '" + Strings.Replace( frameName, "'", @"\'", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + "';"; 
            ltlFrameNameScript.Text += "</script>"; 
            
            if ( !( Page.IsPostBack ) ) { 
                CheckSystemSettings(); 
                if ( "" + Request.QueryString[ "expandidpath" ] + "" + "" != "" ) { 
                    this.LogonForm1.RedirectTo = "default.aspx?expandidpath=" + "" + Request.QueryString[ "expandidpath" ] + "&expandmode=" + "" + Request.QueryString[ "expandmode" ]; 
                } 
                if ( "" + Request.QueryString[ "user" ] + "" != "" ) { 
                    this.LogonForm1.UserNameTextBox.Text = "" + Request.QueryString[ "user" ]; 
                } 
            } 
            
            // run scheduled jobs
            RunScheduledJobs(); 
        } 
        
        
        
        public void LogonSuccessful() { 
            Functions.SetCurrentUserID( LogonForm1.UserNameTextBox.Text ); 
        } 
        
        
        
        private void CheckSystemSettings() { 
            string errorMessage = null; 
            // check file system permissions        
            try { 
                string path = Server.MapPath( "." ) + @"\testsystemsettings_" + Session.SessionID + ".txt"; 
                StreamWriter sw = File.CreateText( path ); 
                sw.WriteLine( "Test of permissions." ); 
                sw.Flush(); 
                sw.Close(); 
                File.Delete( path ); 
                path = HttpContext.Current.Server.MapPath( "~/testsystemsettings_" + HttpContext.Current.Session.SessionID ); 
                Kentico.DirectoryUtilities.DirectoryHelper.CreateDirectory( path ); 
                Directory.Delete( path ); 
            } 
            catch ( Exception ex ) { 
                errorMessage += Strings.Replace( ResMan.GetString( "Logon.ErrorDiskAccess" ), "#ACCOUNT#", System.Security.Principal.WindowsIdentity.GetCurrent().Name, 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + Server.MapPath( ".." ) + "<br>"; 
                errorMessage += ResMan.GetString( "Logon.ErrorDiskAccessSetupPermissions" ) + @"<br><img src=""Design\Images\"; 
                if ( Strings.InStr( System.Security.Principal.WindowsIdentity.GetCurrent().Name.ToLower(), "network", (Microsoft.VisualBasic.CompareMethod)(0) ) > 0 ) { 
                    errorMessage += @"NetworkServiceW2003.gif""><br>"; 
                } 
                else { 
                    errorMessage += @"setuppermissions.jpg""><br>"; 
                } 
            } 
            // check database connection
            try { 
                TreeProvider tree = Functions.GetTreeProvider(); 
                TreeNode node = tree.SelectSingleNode( "/", TreePathTypeEnum.IDPath ); 
            } 
            catch ( Exception ex ) { 
                errorMessage += ResMan.GetString( "Logon.ErrorSQLConnection" ) + " " + ex.Message + "<br>"; 
            } 
            if ( errorMessage + "" != "" ) { 
                this.lblError.Text = errorMessage; 
            } 
        } 
        
        
        
        protected void RunScheduledJobs() { 
            int scheduleMinutes = 0; 
            DateTime lastTime = DateTime.MinValue; 
            
            if ( ConfigurationSettings.AppSettings[ "CMSSchedulerInterval" ] + "" + "" == "" ) { 
                return; 
            } 
            else { 
                scheduleMinutes = int.Parse( ConfigurationSettings.AppSettings[ "CMSSchedulerInterval" ] ); 
            } 
            if ( Application[ "CMSLastJobRun" ] == null ) { 
                Application[ "CMSLastJobRun" ] = DateTime.Now.Add( new TimeSpan( 0, -1 - scheduleMinutes, 0 ) ); 
            } 
            lastTime = System.Convert.ToDateTime( Application[ "CMSLastJobRun" ] ); 
            if ( lastTime.Add( new TimeSpan( 0, scheduleMinutes, 0 ) ) <= DateTime.Now ) { 
                // run job
                // publish scheduled documents
                TreeProvider tree = Functions.GetTreeProvider(); 
                VersionManager verMan = new VersionManager( tree ); 
                verMan.PublishAllScheduled(); 
                tree = null; 
                verMan = null; 
                // send scheduled newsletters
                NewsletterManager newsMan = new NewsletterManager( Functions.GetTreeProvider() ); 
                newsMan.SendAllScheduledIssues( HttpContext.Current.Request.Url.GetLeftPart( UriPartial.Authority ) + HttpContext.Current.Request.ApplicationPath ); 
                // update last job run
                Application.Lock(); 
                Application[ "CMSLastJobRun" ] = DateTime.Now; 
                Application.UnLock(); 
            } 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
    
} 
