using Kentico.CMS.DataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class AddStepRole : System.Web.UI.Page { 
        
        protected int stepID; 
        protected string title; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by btnSearch_Click
             
            btnSearch.Click += new System.EventHandler( btnSearch_Click ); 
            // events handled by btnOK_Click
             
            btnOK.Click += new System.EventHandler( btnOK_Click ); 
            // events handled by btnCancel_Click
             
            btnCancel.Click += new System.EventHandler( btnCancel_Click ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtSearch; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnSearch; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.ListBox lstItems; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnOK; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnCancel; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Read" ); 
                return; 
            } 
            
            stepID = int.Parse( "" + Request.QueryString[ "stepid" ] ); 
            lblHeader.Text = ResMan.GetString( "AddStepRole.Header" ); 
            btnSearch.Text = ResMan.GetString( "AddStepRole.SearchButton" ); 
            btnOK.Text = ResMan.GetString( "AddStepRole.OK" ); 
            btnCancel.Text = ResMan.GetString( "AddStepRole.Cancel" ); 
            title = ResMan.GetString( "AddStepRole.Title" ); 
        } 
        
        
        
        private void btnSearch_Click( System.Object sender, System.EventArgs e ) { 
            GeneralConnection cn = new GeneralConnection(); 
            DataSet ds = null; 
            
            // find all roles whose name contains specified string
            cn.ConnectionString = Functions.GetConnectionString(); 
            ds = cn.ExecuteQuery( "CMS.Role.SelectList", null, " RoleDisplayName LIKE N'%" + txtSearch.Text.Replace( "'", "''" ) + "%' ", "RoleDisplayName" ); 
            lstItems.DataSource = ds.Tables[ 0 ]; 
            lstItems.DataTextField = "RoleDisplayName"; 
            lstItems.DataValueField = "RoleID"; 
            lstItems.DataBind(); 
        } 
        
        
        
        private void btnOK_Click( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Modify" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Modify" ); 
                return; 
            } 
            
            ListItem item = null; 
            GeneralConnection cn = Functions.GetTreeProvider().Connection; 
            object[,] paramsIdent = new object[ 2, 3 ]; 
            
            paramsIdent[ 0, 0 ] = "@stepID"; 
            paramsIdent[ 0, 1 ] = stepID; 
            cn.DataConnection.Open(); 
            // get IDs of the selected roles and save changes
            foreach ( System.Web.UI.WebControls.ListItem transTemp0 in lstItems.Items ) { 
                item = transTemp0;  
                if ( item.Selected ) { 
                    paramsIdent[ 1, 0 ] = "@RoleID"; 
                    paramsIdent[ 1, 1 ] = item.Value; 
                    cn.ExecuteQuery( "CMS.WorkflowStep.AddRole", paramsIdent ); 
                } 
            }
            cn.DataConnection.Close(); 
            Session.Add( "WorkflowRefreshID", stepID ); 
            CloseWindow(); 
        } 
        
        
        
        private void btnCancel_Click( System.Object sender, System.EventArgs e ) { 
            CloseWindow(); 
        } 
        
        
        
        ///<summary>Generates script that closes the window and refreshes the parent page.</summary>
        private void CloseWindow() { 
            ltlScript.Text = @"<script language=""javascript"">"; 
            ltlScript.Text += " CloseAndRefresh(); "; 
            ltlScript.Text += "</script>"; 
        } 
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
