using Kentico.CMS.DataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class AllowedList : System.Web.UI.Page { 
        
        protected string deleteHint; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by dtg_ItemDataBound
             
            QueryDataGrid1.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler( dtg_ItemDataBound ); 
        } 
        
        
        protected /* TRANSINFO: WithEvents */ Kentico.CMS.CMSControls.QueryDataGrid QueryDataGrid1; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlConfirmScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Read" ); 
                return; 
            } 
            
            deleteHint = ResMan.GetString( "AllowedList.DeleteHint" ); 
            // set column header names
            QueryDataGrid1.Columns[ 0 ].HeaderText = ResMan.GetString( "AllowedList.Action" ); 
            QueryDataGrid1.Columns[ 1 ].HeaderText = ResMan.GetString( "AllowedList.ChildClassDisplayName" ); 
            QueryDataGrid1.Columns[ 2 ].HeaderText = ResMan.GetString( "AllowedList.ChildClassName" ); 
            // confirmation question
            ltlConfirmScript.Text = @"<input type=""hidden"" id=""confirmationText"" value=""" + ResMan.GetString( "AllowedList.ConfirmDelete" ) + @""">"; 
            lblHeader.Text = ResMan.GetString( "AllowedList.Header" ); 
            
            if ( !( Page.IsPostBack ) ) { 
                DisplayAllowed(); 
            } 
        } 
        
        
        public void DeleteItem( object sender, System.Web.UI.WebControls.DataGridCommandEventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Delete" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Delete" ); 
                return; 
            } 
            
            // get allowed child classes
            int id = int.Parse( System.Convert.ToString( e.CommandArgument ) ); 
            GeneralConnection cn = new GeneralConnection(); 
            string[,] paramsIdent = new string[ 2, 3 ]; 
            
            paramsIdent[ 0, 0 ] = "@ChildClassID"; 
            paramsIdent[ 0, 1 ] = id.ToString(); 
            paramsIdent[ 1, 0 ] = "@ParentClassID"; 
            paramsIdent[ 1, 1 ] = "" + Request.QueryString[ "classid" ]; 
            cn.ConnectionString = Functions.GetConnectionString(); 
            cn.ExecuteQuery( "CMS.AllowedChildClasses.Delete", paramsIdent ); 
            Response.Redirect( Page.Request.Url.ToString() ); 
        } 
        
        
        
        ///<summary>Displays list of all allowed classes.</summary>
        private void DisplayAllowed() { 
            GeneralConnection cn = new GeneralConnection(); 
            
            cn.ConnectionString = Functions.GetConnectionString(); 
            QueryDataGrid1.GeneralConnection = cn; 
            QueryDataGrid1.QueryName = "CMS.AllowedChildClasses.SelectAllowed"; 
            QueryDataGrid1.WhereCondition = " parentclassid = '" + Strings.Replace( "" + Request.QueryString[ "classid" ], "'", "''", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + "'"; 
        } 
        
        
        
        private void dtg_ItemDataBound( System.Object sender, DataGridItemEventArgs e ) { 
            ImageButton btnCurrentButton = null; 
            
            // set up the Delete button
            if ( e.Item.ItemType == ListItemType.Item | e.Item.ItemType == ListItemType.AlternatingItem ) { 
                btnCurrentButton = ( ( ImageButton )( e.Item.Cells[ 0 ].FindControl( "btnDelete" ) ) ); 
                btnCurrentButton.Attributes.Add( "OnClick", "return ConfirmDelete();" ); 
                btnCurrentButton.Attributes.Add( "title", deleteHint ); 
            } 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
