using Kentico.CMS.DataEngine; 
using Kentico.CMS.MetadataEngine; 
using System.IO; 
using Kentico.DirectoryUtilities; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class ApplicationEdit : System.Web.UI.Page { 
        
        protected int ApplicationID; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by btnOK_Click
             
            btnOK.Click += new System.EventHandler( btnOK_Click ); 
            // events handled by btnCancel_Click
             
            btnCancel.Click += new System.EventHandler( btnCancel_Click ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblError; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblInfo; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox TextBox1; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox TextBox2; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnOK; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnCancel; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtApplicationDisplayName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtApplicationName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblApplicationID; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblApplicationIDValue; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblApplicationDisplayName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblApplicationName; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Read" ); 
                return; 
            } 
            
            GeneralConnection cn = null; 
            DataClass applicationObj = null; 
            
            if ( "" + Request.QueryString[ "id" ] + "" != "" ) { 
                ApplicationID = int.Parse( "" + Request.QueryString[ "id" ] ); 
            } 
            else { 
                ApplicationID = 0; 
            } 
            lblError.Text = ""; 
            lblError.Visible = false; 
            lblInfo.Text = ""; 
            lblInfo.Visible = false; 
            lblHeader.Text = ResMan.GetString( "ApplicationEdit.Header" ); 
            lblApplicationID.Text = ResMan.GetString( "ApplicationEdit.ApplicationID" ); 
            lblApplicationName.Text = ResMan.GetString( "ApplicationEdit.ApplicationName" ); 
            lblApplicationDisplayName.Text = ResMan.GetString( "ApplicationEdit.ApplicationDisplayName" ); 
            btnOK.Text = ResMan.GetString( "ApplicationEdit.OK" ); 
            btnCancel.Text = ResMan.GetString( "ApplicationEdit.Cancel" ); 
            
            if ( !( Page.IsPostBack ) & ApplicationID != 0 ) { 
                // set values
                cn = new GeneralConnection( Functions.GetConnectionString() ); 
                applicationObj = new DataClass( "CMS.Application", ApplicationID, cn ); 
                txtApplicationName.Text = System.Convert.ToString( applicationObj.GetValue( "ApplicationName" ) ); 
                txtApplicationDisplayName.Text = System.Convert.ToString( applicationObj.GetValue( "ApplicationDisplayName" ) ); 
                lblApplicationIDValue.Text = System.Convert.ToString( applicationObj.GetValue( "ApplicationID" ) ); 
            } 
            else { 
                lblApplicationIDValue.Text = ResMan.GetString( "EditApplication.NoApplicationIDValue" ); 
            } 
        } 
        
        
        
        private void btnOK_Click( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( ApplicationID == 0 ) { 
                if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Create" ) ) ) { 
                    Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Create" ); 
                    return; 
                } 
            } 
            else { 
                if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Modify" ) ) ) { 
                    Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Modify" ); 
                    return; 
                } 
            } 
            
            // validate input
            string errorMessage = ""; 
            GeneralConnection cn = null; 
            string[,] paramsIdent = new string[ 1, 3 ]; 
            DataRow ApplicationDR = null; 
            DataSet ApplicationNamesDS = null; 
            string infoMessage = null; 
            DataClass ApplicationObj = null; 
            bool applicationNameChanged = false; 
            string originalApplicationName = null; 
            
            txtApplicationName.Text = txtApplicationName.Text.Trim(); 
            if ( txtApplicationName.Text.Trim() + "" == "" ) { 
                errorMessage += ResMan.GetString( "ApplicationEdit.ErrorEmptyApplicationName" ) + " "; 
            } 
            if ( Strings.InStr( txtApplicationName.Text, " ", (Microsoft.VisualBasic.CompareMethod)(0) ) > 0 ) { 
                errorMessage += ResMan.GetString( "ApplicationEdit.ErrorApplicationNameWithSpaces" ) + " "; 
            } 
            if ( txtApplicationDisplayName.Text.Trim() + "" == "" ) { 
                errorMessage += ResMan.GetString( "ApplicationEdit.ErrorEmptyApplicationDisplayName" ) + " "; 
            } 
            if ( Strings.InStr( txtApplicationName.Text, ".", (Microsoft.VisualBasic.CompareMethod)(0) ) > 0 ) { 
                errorMessage += ResMan.GetString( "ApplicationEdit.ErrorDot" ); 
            } 
            
            if ( errorMessage + "" == "" ) { 
                // check for existing application
                paramsIdent[ 0, 0 ] = "@ApplicationName"; 
                paramsIdent[ 0, 1 ] = txtApplicationName.Text.Trim(); 
                cn = new GeneralConnection( Functions.GetConnectionString() ); 
                cn.DataConnection.Open(); 
                
                ApplicationNamesDS = cn.ExecuteQuery( "CMS.Application.SelectByApplicationName", paramsIdent ); 
                if ( ApplicationID == 0 ) { 
                    if ( ApplicationNamesDS.Tables[ 0 ].Rows.Count > 0 ) { 
                        // application name already exists
                        errorMessage += ResMan.GetString( "ApplicationEdit.ErrorExistingApplicationName" ) + " "; 
                    } 
                } 
                else { 
                    foreach ( System.Data.DataRow transTemp0 in ApplicationNamesDS.Tables[ 0 ].Rows ) { 
                        ApplicationDR = transTemp0;  
                        if ( System.Convert.ToInt32( ApplicationDR[ "ApplicationID" ] ) != ApplicationID ) { 
                            // application name already exists
                            errorMessage += ResMan.GetString( "ApplicationEdit.ErrorExistingApplicationName" ) + " "; 
                        } 
                    }
                } 
                
                if ( errorMessage + "" == "" ) { 
                    // save application info
                    if ( ApplicationID == 0 ) { 
                        // insert a new application
                        ApplicationObj = new DataClass( "CMS.Application", cn ); 
                        ApplicationObj.SetValue( "ApplicationName", txtApplicationName.Text ); 
                        ApplicationObj.SetValue( "ApplicationDisplayName", txtApplicationDisplayName.Text ); 
                        ApplicationObj.Insert(); 
                        txtApplicationName.Text = ""; 
                        txtApplicationDisplayName.Text = ""; 
                        infoMessage = ResMan.GetString( "ApplicationEdit.ChangesInserted" ); 
                    } 
                    else { 
                        // update an existing application
                        ApplicationObj = new DataClass( "CMS.Application", ApplicationID, cn ); 
                        originalApplicationName = ( System.Convert.ToString( ApplicationObj.GetValue( "ApplicationName" ) ) + "" ); 
                        if ( originalApplicationName.Trim().ToLower() != txtApplicationName.Text.Trim().ToLower() ) { 
                            applicationNameChanged = true; 
                        } 
                        ApplicationObj.SetValue( "ApplicationName", txtApplicationName.Text ); 
                        ApplicationObj.SetValue( "ApplicationDisplayName", txtApplicationDisplayName.Text ); 
                        ApplicationObj.Update(); 
                        MetadataProvider.ClearMetadata(); 
                        infoMessage = ResMan.GetString( "ApplicationEdit.ChangesSaved" ); 
                        // if application name was changed, change application folder name in the file system
                        if ( applicationNameChanged ) { 
                            if ( Directory.Exists( Functions.GetMetadataPath() + @"\" + originalApplicationName ) ) { 
                                DirectoryHelper.MoveDirectory( Functions.GetMetadataPath() + @"\" + originalApplicationName, Functions.GetMetadataPath() + @"\" + this.txtApplicationName.Text.Trim() ); 
                            } 
                            // update underlying classes
                            DataSet dsClasses = null; 
                            DataRow drClass = null; 
                            DataClass classObj = null; 
                            string newClassName = null; 
                            string originalClassName = null; 
                            
                            dsClasses = cn.ExecuteQuery( "cms.class.selectclassesofapplication", null, " applicationid = '" + ApplicationID.ToString() + "'" ); 
                            foreach ( System.Data.DataRow transTemp1 in dsClasses.Tables[ 0 ].Rows ) { 
                                drClass = transTemp1;  
                                classObj = new DataClass( "cms.class", drClass, cn ); 
                                originalClassName = System.Convert.ToString( classObj.GetValue( "ClassName" ) ); 
                                newClassName = this.txtApplicationName.Text.Trim() + "." + originalClassName.Split( '.' )[ 1 ]; 
                                classObj.SetValue( "ClassName", newClassName ); 
                                classObj.Update(); 
                                // rename icon files
                                if ( File.Exists( Server.MapPath( "../design/icons/" ) + originalClassName + ".gif" ) ) { 
                                    File.Move( Server.MapPath( "../design/icons/" ) + originalClassName + ".gif", Server.MapPath( "../design/icons/" ) + newClassName + ".gif" ); 
                                } 
                                if ( File.Exists( Server.MapPath( "../design/icons/" ) + originalClassName + "_open.gif" ) ) { 
                                    File.Move( Server.MapPath( "../design/icons/" ) + originalClassName + "_open.gif", Server.MapPath( "../design/icons/" ) + newClassName + "_open.gif" ); 
                                } 
                            }
                        } 
                    } 
                    ltlScript.Text = @"<script language=""javascript"">"; 
                    ltlScript.Text += " RefreshTree(); "; 
                    ltlScript.Text += "</script>"; 
                } 
                cn.DataConnection.Close(); 
            } 
            
            if ( errorMessage + "" != "" ) { 
                lblError.Text = errorMessage; 
                lblError.Visible = true; 
            } 
            if ( infoMessage + "" != "" ) { 
                lblInfo.Text = infoMessage; 
                lblInfo.Visible = true; 
            } 
        } 
        
        
        
        private void btnCancel_Click( System.Object sender, System.EventArgs e ) { 
            // redirect user back to the previous dialog
            ltlScript.Text = @"<script language=""javascript"">"; 
            ltlScript.Text += " Cancel(); "; 
            ltlScript.Text += "</script>"; 
        } 
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
