using System.IO; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class CSSStylesEdit : System.Web.UI.Page { 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by btnOK_Click
             
            btnOK.Click += new System.EventHandler( btnOK_Click ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblError; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblInfo; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnOK; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtStyles; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Read" ); 
                return; 
            } 
            
            if ( !( Page.IsPostBack ) ) { 
                lblError.Text = ""; 
                lblError.Visible = false; 
                lblInfo.Text = ""; 
                lblInfo.Visible = false; 
                lblHeader.Text = ResMan.GetString( "CSSStylesEdit.Header" ); 
                btnOK.Text = ResMan.GetString( "CSSStylesEdit.OK" ); 
                TextReader txt = null; 
                try { 
                    txt = new StreamReader( getCSSFilePath() ); 
                    txtStyles.Text = txt.ReadToEnd(); 
                } 
                catch  { 
                } 
                finally { 
                    if ( !( txt == null ) ) { 
                        txt.Close(); 
                    } 
                } 
            } 
        } 
        
        
        ///<summary>Returns path to CSS file name</summary>
        private string getCSSFilePath() { 
            string cssfile = null; 
            if ( ConfigurationSettings.AppSettings[ "CMSCSSVirtualPath" ] == null ) { 
                cssfile = MapPath( "~/main.css" ); 
            } 
            else { 
                cssfile = MapPath( ConfigurationSettings.AppSettings[ "CMSCSSVirtualPath" ] ); 
            } 
            return cssfile; 
        } 
        
        
        
        private void btnOK_Click( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Modify" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Modify" ); 
                return; 
            } 
            //  write content to file
            TextWriter txt = null; 
            try { 
                txt = new StreamWriter( getCSSFilePath() ); 
                txt.Write( txtStyles.Text ); 
            } 
            finally { 
                if ( !( txt == null ) ) { txt.Close(); } 
            } 
            lblInfo.Text = ResMan.GetString( "CSSStylesEdit.ChangesSaved" ); 
            lblInfo.Visible = true; 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
