using Kentico.CMS.DataEngine; 
using Kentico.CMS.MetadataEngine; 
using Kentico.CMS.TreeEngine; 
using System.IO; 
using Kentico.DirectoryUtilities; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class ClassEdit : System.Web.UI.Page { 
        
        protected int ApplicationID; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblIsCoupledClass; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.CheckBox chkIsCoupledClass; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblApplicationName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblUseVersioningAndWorkflow; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.DropDownList drpWorkflow; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.CheckBox chkUseVersioning; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblWorkflow; 
        protected int ClassID; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by btnOK_Click
             
            btnOK.Click += new System.EventHandler( btnOK_Click ); 
            // events handled by btnCancel_Click
             
            btnCancel.Click += new System.EventHandler( btnCancel_Click ); 
            // events handled by chkUseVersioning_CheckedChanged
             
            chkUseVersioning.CheckedChanged += new System.EventHandler( chkUseVersioning_CheckedChanged ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblError; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblInfo; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblClassID; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblClassIDValue; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblClassDisplayName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtClassDisplayName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblClassName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtClassName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnOK; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnCancel; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Read" ); 
                return; 
            } 
            
            GeneralConnection cn = null; 
            DataClass classObj = null; 
            
            if ( "" + Request.QueryString[ "id" ] + "" != "" ) { 
                ClassID = int.Parse( "" + Request.QueryString[ "id" ] ); 
            } 
            else { 
                ClassID = 0; 
            } 
            if ( "" + Request.QueryString[ "applicationid" ] + "" != "" ) { 
                ApplicationID = int.Parse( "" + Request.QueryString[ "applicationid" ] ); 
            } 
            else { 
                ApplicationID = 0; 
            } 
            lblError.Text = ""; 
            lblError.Visible = false; 
            lblInfo.Text = ""; 
            lblInfo.Visible = false; 
            lblHeader.Text = ResMan.GetString( "ClassEdit.Header" ); 
            lblClassID.Text = ResMan.GetString( "ClassEdit.ClassID" ); 
            lblClassName.Text = ResMan.GetString( "ClassEdit.ClassName" ); 
            lblClassDisplayName.Text = ResMan.GetString( "ClassEdit.ClassDisplayName" ); 
            lblIsCoupledClass.Text = ResMan.GetString( "ClassEdit.IsCoupledClass" ); 
            btnOK.Text = ResMan.GetString( "ClassEdit.OK" ); 
            btnCancel.Text = ResMan.GetString( "ClassEdit.Cancel" ); 
            this.lblUseVersioningAndWorkflow.Text = ResMan.GetString( "ClassEdit.UseVersioningAndWorkflow" ); 
            this.lblWorkflow.Text = ResMan.GetString( "ClassEdit.Workflow" ); 
            
            if ( !( Page.IsPostBack ) & ClassID != 0 ) { 
                // set values
                cn = new GeneralConnection( Functions.GetConnectionString() ); 
                classObj = new DataClass( "CMS.Class", ClassID, cn ); 
                lblApplicationName.Text = System.Convert.ToString( classObj.GetValue( "ClassName" ) ).Split( '.' )[ 0 ]; 
                txtClassName.Text = System.Convert.ToString( classObj.GetValue( "ClassName" ) ).Split( '.' )[ 1 ]; 
                txtClassDisplayName.Text = System.Convert.ToString( classObj.GetValue( "ClassDisplayName" ) ); 
                lblClassIDValue.Text = System.Convert.ToString( classObj.GetValue( "ClassID" ) ); 
                chkIsCoupledClass.Checked = System.Convert.ToBoolean( classObj.GetValue( "IsCoupledClass" ) ); 
                chkUseVersioning.Checked = System.Convert.ToBoolean( classObj.GetValue( "UseVersioning" ) ); 
                if ( chkUseVersioning.Checked ) { 
                    this.drpWorkflow.Enabled = true; 
                    LoadWorkflows( System.Convert.ToInt32( classObj.GetValue( "WorkflowID" ) ) ); 
                } 
                else { 
                    this.drpWorkflow.Enabled = false; 
                    LoadWorkflows( 0 ); 
                } 
            } 
            
            if ( !( Page.IsPostBack ) & ClassID == 0 ) { 
                LoadWorkflows( 0 ); 
                this.chkUseVersioning.Checked = true; 
                this.drpWorkflow.Enabled = true; 
                lblClassIDValue.Text = ResMan.GetString( "EditClass.NoClassIDValue" ); 
            } 
        } 
        
        
        private void btnOK_Click( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( ClassID == 0 ) { 
                if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Create" ) ) ) { 
                    Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Create" ); 
                    return; 
                } 
            } 
            else { 
                if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Modify" ) ) ) { 
                    Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Modify" ); 
                    return; 
                } 
            } 
            
            // validate input
            string errorMessage = ""; 
            GeneralConnection cn = null; 
            string[,] paramsIdent = new string[ 1, 3 ]; 
            DataRow ClassDR = null; 
            DataSet ClassNamesDS = null; 
            string infoMessage = null; 
            DataClass ClassObj = null; 
            string originalClassName = null; 
            string newClassName = null; 
            
            txtClassName.Text = txtClassName.Text.Trim(); 
            txtClassDisplayName.Text = txtClassDisplayName.Text.Trim(); 
            if ( txtClassName.Text + "" == "" ) { 
                errorMessage += ResMan.GetString( "ClassEdit.ErrorEmptyClassName" ) + " "; 
            } 
            if ( txtClassDisplayName.Text + "" == "" ) { 
                errorMessage += ResMan.GetString( "ClassEdit.ErrorEmptyClassDisplayName" ) + " "; 
            } 
            if ( Strings.InStr( txtClassName.Text, " ", (Microsoft.VisualBasic.CompareMethod)(0) ) > 0 ) { 
                errorMessage += ResMan.GetString( "ClassEdit.ErrorClassNameWithSpaces" ) + " "; 
            } 
            
            if ( errorMessage + "" == "" ) { 
                // check for existing class
                paramsIdent[ 0, 0 ] = "@ClassName"; 
                paramsIdent[ 0, 1 ] = lblApplicationName.Text + "." + txtClassName.Text.Trim(); 
                cn = new GeneralConnection( Functions.GetConnectionString() ); 
                cn.DataConnection.Open(); 
                
                ClassNamesDS = cn.ExecuteQuery( "CMS.Class.SelectByClassName", paramsIdent ); 
                if ( ClassID == 0 ) { 
                    if ( ClassNamesDS.Tables[ 0 ].Rows.Count > 0 ) { 
                        // class name already exists
                        errorMessage += ResMan.GetString( "ClassEdit.ErrorExistingClassName" ) + " "; 
                    } 
                } 
                else { 
                    foreach ( System.Data.DataRow transTemp0 in ClassNamesDS.Tables[ 0 ].Rows ) { 
                        ClassDR = transTemp0;  
                        if ( System.Convert.ToInt32( ClassDR[ "ClassID" ] ) != ClassID ) { 
                            // class name already exists
                            errorMessage += ResMan.GetString( "ClassEdit.ErrorExistingClassName" ) + " "; 
                        } 
                    }
                } 
                
                if ( errorMessage + "" == "" ) { 
                    // save class info
                    if ( ClassID == 0 ) { 
                        // insert a new class
                        ClassObj = new DataClass( "CMS.Class", cn ); 
                        ClassObj.SetValue( "ClassName", this.lblApplicationName.Text + "." + txtClassName.Text ); 
                        ClassObj.SetValue( "ClassDisplayName", txtClassDisplayName.Text ); 
                        if ( chkIsCoupledClass.Checked ) { 
                            ClassObj.SetValue( "IsCoupledClass", 1 ); 
                        } 
                        else { 
                            ClassObj.SetValue( "IsCoupledClass", 0 ); 
                        } 
                        ClassObj.SetValue( "ApplicationID", ApplicationID ); 
                        if ( this.chkUseVersioning.Checked ) { 
                            ClassObj.SetValue( "UseVersioning", true ); 
                            ClassObj.SetValue( "WorkflowID", this.drpWorkflow.SelectedValue ); 
                        } 
                        else { 
                            ClassObj.SetValue( "UseVersioning", false ); 
                            ClassObj.SetValue( "WorkflowID", null ); 
                        } 
                        ClassObj.Insert(); 
                        txtClassName.Text = ""; 
                        txtClassDisplayName.Text = ""; 
                        chkIsCoupledClass.Checked = false; 
                        infoMessage = ResMan.GetString( "ClassEdit.ChangesInserted" ); 
                        ltlScript.Text = @"<script language=""javascript"">"; 
                        ltlScript.Text += " RefreshTreeAfterInsert(); "; 
                        ltlScript.Text += "</script>"; 
                    } 
                    else { 
                        // update an existing class
                        ClassObj = new DataClass( "CMS.Class", ClassID, cn ); 
                        originalClassName = System.Convert.ToString( ClassObj.GetValue( "ClassName" ) ); 
                        ClassObj.SetValue( "ClassName", this.lblApplicationName.Text + "." + txtClassName.Text ); 
                        newClassName = System.Convert.ToString( ClassObj.GetValue( "ClassName" ) ); 
                        ClassObj.SetValue( "ClassDisplayName", txtClassDisplayName.Text ); 
                        if ( chkIsCoupledClass.Checked ) { 
                            ClassObj.SetValue( "IsCoupledClass", 1 ); 
                        } 
                        else { 
                            ClassObj.SetValue( "IsCoupledClass", 0 ); 
                        } 
                        if ( this.chkUseVersioning.Checked ) { 
                            ClassObj.SetValue( "UseVersioning", true ); 
                            ClassObj.SetValue( "WorkflowID", this.drpWorkflow.SelectedValue ); 
                        } 
                        else { 
                            ClassObj.SetValue( "UseVersioning", false ); 
                            ClassObj.SetValue( "WorkflowID", null ); 
                        } 
                        ClassObj.Update(); 
                        MetadataProvider.ClearMetadata(); 
                        infoMessage = ResMan.GetString( "ClassEdit.ChangesSaved" ); 
                        ltlScript.Text = @"<script language=""javascript"">"; 
                        ltlScript.Text += " RefreshTree(); "; 
                        ltlScript.Text += "</script>"; 
                        if ( originalClassName.Trim().ToLower() != newClassName.Trim().ToLower() ) { 
                            // rename folder
                            if ( Directory.Exists( Functions.GetMetadataPath() + @"\" + originalClassName.Split( '.' )[ 0 ] + @"\" + originalClassName.Split( '.' )[ 1 ] ) ) { 
                                DirectoryHelper.MoveDirectory( Functions.GetMetadataPath() + @"\" + originalClassName.Split( '.' )[ 0 ] + @"\" + originalClassName.Split( '.' )[ 1 ], Functions.GetMetadataPath() + @"\" + newClassName.Split( '.' )[ 0 ] + @"\" + newClassName.Split( '.' )[ 1 ] ); 
                            } 
                            // rename icon files
                            if ( File.Exists( Server.MapPath( "../design/icons/" ) + originalClassName + ".gif" ) ) { 
                                File.Move( Server.MapPath( "../design/icons/" ) + originalClassName + ".gif", Server.MapPath( "../design/icons/" ) + newClassName + ".gif" ); 
                            } 
                            if ( File.Exists( Server.MapPath( "../design/icons/" ) + originalClassName + "_open.gif" ) ) { 
                                File.Move( Server.MapPath( "../design/icons/" ) + originalClassName + "_open.gif", Server.MapPath( "../design/icons/" ) + newClassName + "_open.gif" ); 
                            } 
                            // update queries
                            MetadataQuery query = null; 
                            query = QueryGenerator.GetQuery( newClassName, BasicQueriesEnum.SelectByPathQuery ); 
                            MetadataProvider.SetQuery( newClassName + ".selectbypath", query ); 
                            query = QueryGenerator.GetQuery( newClassName, BasicQueriesEnum.SearchTreeQuery ); 
                            MetadataProvider.SetQuery( newClassName + ".searchtree", query ); 
                        } 
                    } 
                    ClassInformationProvider.ClearMetadata(); 
                } 
                cn.DataConnection.Close(); 
            } 
            
            if ( errorMessage + "" != "" ) { 
                lblError.Text = errorMessage; 
                lblError.Visible = true; 
            } 
            if ( infoMessage + "" != "" ) { 
                lblInfo.Text = infoMessage; 
                lblInfo.Visible = true; 
            } 
        } 
        
        
        private void btnCancel_Click( System.Object sender, System.EventArgs e ) { 
            // redirect user back to the list of classes
            ltlScript.Text = @"<script language=""javascript"">"; 
            ltlScript.Text += " function Cancel()"; 
            ltlScript.Text += " {"; 
            ltlScript.Text += "   document.location.href='ClassList.aspx?applicationid=" + "" + Request.QueryString[ "applicationid" ] + "';"; 
            ltlScript.Text += " }"; 
            ltlScript.Text += " Cancel(); "; 
            ltlScript.Text += "</script>"; 
        } 
        
        
        
        private void LoadWorkflows( int selectedWorkflowId ) { 
            DataSet workflowsDS = null; 
            DataRow workflowDR = null; 
            GeneralConnection cn = Functions.GetTreeProvider().Connection; 
            
            workflowsDS = cn.ExecuteQuery( "cms.workflow.selectall", null, "", "WorkflowDisplayName" ); 
            drpWorkflow.Items.Clear(); 
            foreach ( System.Data.DataRow transTemp1 in workflowsDS.Tables[ 0 ].Rows ) { 
                workflowDR = transTemp1;  
                drpWorkflow.Items.Add( new ListItem( System.Convert.ToString( workflowDR[ "WorkflowDisplayName" ] ), System.Convert.ToInt32( workflowDR[ "WorkflowID" ] ).ToString() ) ); 
                if ( ( selectedWorkflowId == System.Convert.ToInt32( workflowDR[ "WorkflowID" ] ) ) | ( selectedWorkflowId == 0 & System.Convert.ToString( workflowDR[ "WorkflowName" ] ).ToLower().Trim() == "default" ) ) { 
                    drpWorkflow.SelectedIndex = drpWorkflow.Items.Count - 1; 
                } 
            }
        } 
        
        
        
        private void chkUseVersioning_CheckedChanged( System.Object sender, System.EventArgs e ) { 
            if ( this.chkUseVersioning.Checked == true ) { 
                this.drpWorkflow.Enabled = true; 
            } 
            else { 
                this.drpWorkflow.Enabled = false; 
            } 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
