using Kentico.CMS.DataEngine; 
using Kentico.CMS.MetadataEngine; 
using Kentico.CMS.TreeEngine; 
using System.IO; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class ClassList : System.Web.UI.Page { 
        
        protected string editHint; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblError; 
        protected string deleteHint; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by dtg_ItemDataBound
             
            QueryDataGrid1.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler( dtg_ItemDataBound ); 
        } 
        
        
        protected /* TRANSINFO: WithEvents */ Kentico.CMS.CMSControls.QueryDataGrid QueryDataGrid1; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlConfirmScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Read" ); 
                return; 
            } 
            
            editHint = ResMan.GetString( "ClassList.EditHint" ); 
            deleteHint = ResMan.GetString( "ClassList.DeleteHint" ); 
            this.lblError.Text = ""; 
            // set column header names
            QueryDataGrid1.Columns[ 0 ].HeaderText = ResMan.GetString( "ClassList.Action" ); 
            QueryDataGrid1.Columns[ 1 ].HeaderText = ResMan.GetString( "ClassList.ClassDisplayName" ); 
            QueryDataGrid1.Columns[ 2 ].HeaderText = ResMan.GetString( "ClassList.ClassName" ); 
            
            // confirmation question
            ltlConfirmScript.Text = @"<input type=""hidden"" id=""confirmationText"" value=""" + ResMan.GetString( "ClassList.ConfirmDelete" ) + @""">"; 
            lblHeader.Text = ResMan.GetString( "ClassList.Header" ); 
            
            if ( !( Page.IsPostBack ) ) { 
                DisplayClasses(); 
            } 
        } 
        
        
        
        public void DeleteItem( object sender, System.Web.UI.WebControls.DataGridCommandEventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Delete" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Delete" ); 
                return; 
            } 
            
            // delete class
            int id = int.Parse( System.Convert.ToString( e.CommandArgument ) ); 
            GeneralConnection cn = Functions.GetTreeProvider().Connection; 
            string[,] paramsIdent = new string[ 1, 3 ]; 
            string className = System.Convert.ToString( ClassInformationProvider.GetClassRow( id, Functions.GetTreeProvider() )[ ( ( "ClassName" ) ) ] ); 
            if ( className.ToLower().Trim() == "cms.root" ) { 
                this.lblError.Text = ResMan.GetString( "ClassList.ErrorCannotDeleteRootClass" ); 
                return; 
            } 
            string tableName = MetadataProvider.GetSettingsValue( className, "tablename" ); 
            
            paramsIdent[ 0, 0 ] = "@ID"; 
            paramsIdent[ 0, 1 ] = id.ToString(); 
            cn.ConnectionString = Functions.GetConnectionString(); 
            cn.ExecuteQuery( "CMS.Class.Delete", paramsIdent ); 
            
            // delete table if the class is coupled
            if ( tableName + "" != "" ) { 
                cn.DataConnection.ExecuteQuery( "DROP TABLE [" + tableName + "]", null, MetadataQueryTypeEnum.SQLQuery ); 
            } 
            
            // delete folder
            try { 
                Directory.Delete( Functions.GetMetadataPath() + @"\" + className.Split( '.' )[ 0 ] + @"\" + className.Split( '.' )[ 1 ], true ); 
            } 
            catch ( Exception ex ) { 
            } 
            
            // delete image
            try { 
                File.Delete( Server.MapPath( @"..\design\icons\" + className + ".gif" ) ); 
                File.Delete( Server.MapPath( @"..\design\icons\" + className + "_open.gif" ) ); 
            } 
            catch ( Exception ex ) { 
            } 
            
            // clear metadata
            MetadataProvider.ClearMetadata(); 
            ClassInformationProvider.ClearMetadata(); 
            
            // udpate tree
            ltlScript.Text = @"<script language=""javascript"">"; 
            ltlScript.Text += " Reload(); "; 
            ltlScript.Text += "</script>"; 
        } 
        
        
        
        ///<summary>Displays list of classes in the grid.</summary>
        private void DisplayClasses() { 
            GeneralConnection cn = new GeneralConnection(); 
            cn.ConnectionString = Functions.GetConnectionString(); 
            QueryDataGrid1.GeneralConnection = cn; 
            QueryDataGrid1.QueryName = "CMS.Class.SelectClassesOfApplication"; 
            QueryDataGrid1.WhereCondition = " applicationid = '" + Strings.Replace( "" + Request.QueryString[ "applicationid" ], "'", "''", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + "'"; 
        } 
        
        
        
        private void dtg_ItemDataBound( System.Object sender, DataGridItemEventArgs e ) { 
            ImageButton btnCurrentButton = null; 
            
            // set up the delete button
            if ( e.Item.ItemType == ListItemType.Item | e.Item.ItemType == ListItemType.AlternatingItem ) { 
                btnCurrentButton = ( ( ImageButton )( e.Item.Cells[ 0 ].FindControl( "btnDelete" ) ) ); 
                btnCurrentButton.Attributes.Add( "OnClick", "return ConfirmDelete();" ); 
                btnCurrentButton.Attributes.Add( "title", deleteHint ); 
            } 
        } 
        
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
