using Kentico.CMS.CMSControls; 
using Kentico.CMS.TreeEngine; 
using Kentico.CMS.DataEngine; 
using System.IO; 
using System.Xml; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class DesignerTreeData : System.Web.UI.Page { 
        
        private TreeProvider tree; 
        private const string cImageBasePath = "../Design/Tree"; 
        private const string cIconsBasePath = "../Design/Icons/"; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlRender; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // Put user code to initialize the page here
            string action = null; 
            
            action = Strings.LCase( Strings.Trim( "" + Request.QueryString[ "action" ] + "" ) ); 
            tree = Functions.GetTreeProvider(); 
            ltlRender.Text = @"<script language=""javascript"">" + Constants.vbCrLf; 
            switch ( action ) {
                case "expandnode":
                    if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Read" ) ) ) { 
                        ShowErrorMessage( ResMan.GetString( "AccessDenied.NotAllowedToRead" ) ); 
                    } 
                    else { 
                        AddRenderScript( GetChildNodes( "" + Request.QueryString[ "nodeid" ], "" + Request.QueryString[ "sample" ], "" + Request.QueryString[ "value" ] ), "" + Request.QueryString[ "nodeid" ] ); 
                        if ( "" + Request.QueryString[ "selectID" ] + "" + "" != "" ) { 
                            AddSelectNodeScript( "" + Request.QueryString[ "selectID" ], false, true ); 
                        } 
                    } 
                    break;
            }
            
            ltlRender.Text += "</script>"; 
        } 
        
        
        
        ///<summary>Adds script that removes the given node from the displayed tree.</summary>
        ///<param name="nodeIDPath">IDPath of the node to be removed.</param>
        public void AddRemoveNodeScript( string nodeIDPath ) { 
            ltlRender.Text += " parent.frames['tree'].document.getElementById('nodeID_" + nodeIDPath + "').innerHTML = '';"; 
        } 
        
        
        
        ///<summary>Adds script that reloads the selected node.</summary>
        public void AddReloadSelectedNodeScript() { 
            ltlRender.Text += " parent.frames['tree'].ReloadSelectedNode();" + Constants.vbCrLf; 
        } 
        
        
        
        ///<summary>Adds script that selects given node.</summary>
        ///<param name="selectIDPath">IDPath of the node to be selected.</param>
        ///<param name="selectDesktop">Indicates if desktop should be updated.</param>
        ///<param name="selectMenu">Indicates if menu (header) selected item value should be updated.</param>
        public void AddSelectNodeScript( string selectIDPath, bool selectDesktop, bool selectMenu ) { 
            ltlRender.Text += " SelectNode('" + selectIDPath + "'); " + Constants.vbCrLf + " function SelectNode(selectID) {" + Constants.vbCrLf + "  //try {" + Constants.vbCrLf + "  parent.frames['tree'].SelectNode(selectID);" + Constants.vbCrLf; 
            if ( selectDesktop ) { 
                ltlRender.Text += "  parent.frames['header'].SelectNode(selectID);" + Constants.vbCrLf; 
            } 
            if ( selectMenu ) { 
                ltlRender.Text += "  parent.frames['header'].document.getElementById('idpath').value = selectID;" + Constants.vbCrLf; 
            } 
            ltlRender.Text += "  //} catch(e) { } " + Constants.vbCrLf + " } " + Constants.vbCrLf; 
        } 
        
        
        
        ///<summary>Adds content that will be rendered under given parent node.</summary>
        ///<param name="content">Content to be rendered.</param>
        ///<param name="targetNodeIDPath">Target node IDPath.</param>
        public void AddRenderScript( string content, string targetNodeIDPath ) { 
            string innerHTML = null; 
            innerHTML = Strings.Replace( content + "", "'", @"\'", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ); 
            innerHTML = Strings.Replace( innerHTML, @"""", @"\""", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ); 
            innerHTML = Strings.Replace( innerHTML, Constants.vbCrLf, " ", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ); 
            
            ltlRender.Text += " RenderData(); " + Constants.vbCrLf + " function RenderData() {" + Constants.vbCrLf + "  // try {" + Constants.vbCrLf + "  parent.frames['tree'].document.getElementById('sub_" + targetNodeIDPath + "').innerHTML = '" + innerHTML + "'; " + Constants.vbCrLf; 
            if ( innerHTML + "" + "" == "" ) { 
                ltlRender.Text += " parent.frames['tree'].document.getElementById('sub_" + targetNodeIDPath + "').style.display = 'none'; " + Constants.vbCrLf; 
            } 
            ltlRender.Text += "  // } catch(e) { } " + Constants.vbCrLf + " } " + Constants.vbCrLf; 
        } 
        
        
        
        ///<summary>Returns child nodes at 2nd and lower level.</summary>
        ///<param name="NodeID">Parent node ID (IDPath).</param>
        ///<param name="Sample">Sample for displaying tree.</param>
        ///<param name="Value">Value of the parent node.</param>
        public string GetChildNodes( string NodeID, string Sample, string Value ) { 
            TreeNodes nodes = new TreeNodes(); 
            DataRow dr = null; 
            DataRowCollection nodeRows = null; 
            GeneralConnection cn = new GeneralConnection(); 
            int classid = 0; 
            string classIDPart = null; 
            string className = null; 
            DirectoryInfo transformationsDirectory = null; 
            FileInfo[] transformations = null; 
            int i = 0; 
            string transformationName = null; 
            string transformationsDirPath = null; 
            
            cn.ConnectionString = Functions.GetConnectionString(); 
            nodes.ImagePathBase = cImageBasePath; 
            // root
            if ( NodeID == "/" ) { 
                nodes.NewNode( ResMan.GetString( "DesignerTreeData.Applications" ), "/", cIconsBasePath + "applications.gif", cIconsBasePath + "applications.gif", ResMan.GetString( "DesignerTreeData.Applications" ), "parent.frames['header'].SelectNode('/apps')", "/apps", "", true ); 
                nodes.NewNode( ResMan.GetString( "DesignerTreeData.PageTemplates" ), "/", cIconsBasePath + "pagetemplates.gif", cIconsBasePath + "pagetemplates.gif", ResMan.GetString( "DesignerTreeData.PageTemplates" ), "parent.frames['header'].SelectNode('/pagetemplates')", "/pagetemplates", "", false ); 
                nodes.NewNode( ResMan.GetString( "DesignerTreeData.Workflow" ), "/", cIconsBasePath + "workflows.gif", cIconsBasePath + "workflows.gif", ResMan.GetString( "DesignerTreeData.Workflow" ), "parent.frames['header'].SelectNode('/workflow')", "/workflow", "", false ); 
                if ( Functions.GetConfigValue( "CMSEnableRelationships" ).ToLower().Trim() != "false" ) { 
                    nodes.NewNode( ResMan.GetString( "DesignerTreeData.Relationshipnames" ), "/", cIconsBasePath + "relationships.gif", cIconsBasePath + "relationships.gif", ResMan.GetString( "DesignerTreeData.Relationshipnames" ), "parent.frames['header'].SelectNode('/relationshipnames')", "/relationshipnames", "", false ); 
                } 
                nodes.NewNode( ResMan.GetString( "DesignerTreeData.Resources" ), "/", cIconsBasePath + "resources.gif", cIconsBasePath + "resources.gif", ResMan.GetString( "DesignerTreeData.Resources" ), "parent.frames['header'].SelectNode('/resources')", "/resources", "", true ); 
                nodes.NewNode( ResMan.GetString( "DesignerTreeData.CSSStyles" ), "/", cIconsBasePath + "cssstyles.gif", cIconsBasePath + "cssstyles.gif", ResMan.GetString( "DesignerTreeData.CSSStyles" ), "parent.frames['header'].SelectNode('/cssstyles')", "/cssstyles", "", false ); 
            } 
            // apps
            if ( NodeID == "/apps" ) { 
                foreach ( System.Data.DataRow transTemp0 in cn.ExecuteQuery( "CMS.Application.SelectList", null, "", "ApplicationDisplayName" ).Tables[ 0 ].Rows ) { 
                    dr = transTemp0;  
                    nodes.NewNode( ResMan.GetString( "DesignerTreeData.Application" ) + " " + System.Convert.ToString( dr[ "ApplicationDisplayName" ] ), NodeID, cIconsBasePath + "application.gif", cIconsBasePath + "application.gif", ResMan.GetString( "DesignerTreeData.Application" ) + " " + System.Convert.ToString( dr[ "ApplicationDisplayName" ] ), "parent.frames['header'].SelectNode('/apps/app_" + System.Convert.ToString( dr[ "applicationid" ] ) + "')", "/apps/app_" + System.Convert.ToString( dr[ "ApplicationID" ] ), 
                    Sample, true ); 
                }
            } 
            // resources
            if ( NodeID == "/resources" ) { 
                foreach ( System.Data.DataRow transTemp1 in cn.ExecuteQuery( "CMS.Resource.SelectList", null, "", "ResourceDisplayName" ).Tables[ 0 ].Rows ) { 
                    dr = transTemp1;  
                    nodes.NewNode( System.Convert.ToString( dr[ "ResourceDisplayName" ] ), NodeID, cIconsBasePath + "resource.gif", cIconsBasePath + "resource.gif", System.Convert.ToString( dr[ "ResourceDisplayName" ] ), "parent.frames['header'].SelectNode('/resources/res_" + System.Convert.ToString( dr[ "resourceid" ] ) + "')", "/resources/res_" + System.Convert.ToString( dr[ "ResourceID" ] ), Sample, true ); 
                }
            } 
            // application - read classes
            if ( Strings.Left( NodeID + "1234567890", 10 ) == "/apps/app_" && Information.IsNumeric( Strings.Replace( NodeID, "/apps/app_", "", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) ) ) { 
                foreach ( System.Data.DataRow transTemp2 in cn.ExecuteQuery( "CMS.Class.SelectClassesOfApplication", null, " applicationid = '" + Strings.Replace( Strings.Replace( NodeID, "/apps/app_", "", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ), "'", "''", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + "'", "ClassDisplayName" ).Tables[ 0 ].Rows ) { 
                    dr = transTemp2;  
                    nodes.NewNode( System.Convert.ToString( dr[ "ClassDisplayName" ] ), NodeID, cIconsBasePath + "class.gif", cIconsBasePath + "class.gif", System.Convert.ToString( dr[ "ClassDisplayName" ] ), "parent.frames['header'].SelectNode('" + NodeID + "/class_" + System.Convert.ToInt32( dr[ "classid" ] ) + "')", NodeID + "/class_" + System.Convert.ToString( dr[ "ClassID" ] ), Sample, true ); 
                }
            } 
            // class - allowed child classes, EditTemplateFields
            if ( Strings.InStr( NodeID, "/class_", (Microsoft.VisualBasic.CompareMethod)(0) ) > 0 & NodeID.Split( '/' ).GetUpperBound( 0 ) == 3 ) { 
                nodes.NewNode( ResMan.GetString( "DesignerTreeData.EditTemplateFields" ), NodeID, cIconsBasePath + "EditTemplateFields.gif", cIconsBasePath + "EditTemplateFields.gif", ResMan.GetString( "DesignerTreeData.EditTemplateFields" ), "parent.frames['header'].SelectNode('" + NodeID + "/EditTemplateFields')", NodeID + "/EditTemplateFields", Sample, false ); 
                nodes.NewNode( ResMan.GetString( "DesignerTreeData.Transformations" ), NodeID, cIconsBasePath + "Transformations.gif", cIconsBasePath + "Transformations.gif", ResMan.GetString( "DesignerTreeData.Transformations" ), "parent.frames['header'].SelectNode('" + NodeID + "/Transformations')", NodeID + "/Transformations", Sample, false ); 
                nodes.NewNode( ResMan.GetString( "DesignerTreeData.Queries" ), NodeID, cIconsBasePath + "Queries.gif", cIconsBasePath + "Queries.gif", ResMan.GetString( "DesignerTreeData.Queries" ), "parent.frames['header'].SelectNode('" + NodeID + "/Queries')", NodeID + "/Queries", Sample, false ); 
                nodes.NewNode( ResMan.GetString( "DesignerTreeData.Settings" ), NodeID, cIconsBasePath + "Settings.gif", cIconsBasePath + "Settings.gif", ResMan.GetString( "DesignerTreeData.Settings" ), "parent.frames['header'].SelectNode('" + NodeID + "/Settings')", NodeID + "/Settings", Sample, false ); 
                nodes.NewNode( ResMan.GetString( "DesignerTreeData.AllowedChildClasses" ), NodeID, cIconsBasePath + "allowedchildclasses.gif", cIconsBasePath + "allowedchildclasses.gif", ResMan.GetString( "DesignerTreeData.AllowedChildClasses" ), "parent.frames['header'].SelectNode('" + NodeID + "/allowedchildclasses')", NodeID + "/allowedchildclasses", Sample, false ); 
                nodes.NewNode( ResMan.GetString( "DesignerTreeData.PermissionNames" ), NodeID, cIconsBasePath + "permissionnames.gif", cIconsBasePath + "permissionnames.gif", ResMan.GetString( "DesignerTreeData.PermissionNames" ), "parent.frames['header'].SelectNode('" + NodeID + "/permissionnames')", NodeID + "/permissionnames", Sample, false ); 
            } 
            // resource - add "permission names" node
            if ( Strings.InStr( NodeID, "/res_", (Microsoft.VisualBasic.CompareMethod)(0) ) > 0 ) { 
                nodes.NewNode( ResMan.GetString( "DesignerTreeData.PermissionNames" ), NodeID, cIconsBasePath + "permissionnames.gif", cIconsBasePath + "permissionnames.gif", ResMan.GetString( "DesignerTreeData.PermissionNames" ), "parent.frames['header'].SelectNode('" + NodeID + "/permissionnames')", NodeID + "/permissionnames", Sample, false ); 
            } 
            return nodes.NodesHTML(); 
        } 
        
        
        
        ///<summary>Displays an error message.</summary>
        ///<param name="message">Error message.</param>
        public void ShowErrorMessage( string message ) { 
            ltlRender.Text += " alert('" + Strings.Replace( message + "", "'", @"\'", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + "');"; 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
