using Kentico.CMS.MetadataEngine; 
using Kentico.CMS.DataEngine; 
using System.Data.SqlClient; 
using System.IO; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class EditXMLSchema : System.Web.UI.Page { 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by btnGenerate_Click
             
            btnGenerate.Click += new System.EventHandler( btnGenerate_Click ); 
            // events handled by btnOK_Click
             
            btnOK.Click += new System.EventHandler( btnOK_Click ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblError; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblInfo; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnOK; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblSchema; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblGenerate; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnGenerate; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtTableName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtSchema; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Read" ); 
                return; 
            } 
            
            int classid = int.Parse( "" + Request.QueryString[ "classid" ] ); 
            string className = GetClassName(); 
            string path = null; 
            StreamReader str = null; 
            
            lblInfo.Text = ""; 
            lblError.Text = ""; 
            if ( !( Page.IsPostBack ) ) { 
                // read file from the disk
                path = MetadataProvider.GetMetadataPath() + @"\" + Strings.Replace( className + "", ".", @"\", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + @"\schema.config"; 
                if ( File.Exists( path ) ) { 
                    str = File.OpenText( path ); 
                    txtSchema.Text = str.ReadToEnd(); 
                    str.Close(); 
                } 
                // set labels and buttons
                lblHeader.Text = ResMan.GetString( "EditXMLSchema.Header" ); 
                lblGenerate.Text = ResMan.GetString( "EditXMLSchema.LabelGenerate" ); 
                btnGenerate.Text = ResMan.GetString( "EditXMLSchema.ButtonGenerate" ); 
                lblSchema.Text = ResMan.GetString( "EditXMLSchema.XMLSchema" ); 
                btnOK.Text = ResMan.GetString( "EditXMLSchema.OK" ); 
            } 
        } 
        
        
        
        ///<summary>Returns name of the current class in format application.class.</summary>
        private string GetClassName() { 
            if ( System.Convert.ToString( ViewState[ "classname" ] ) + "" == "" ) { 
                GeneralConnection cn = new GeneralConnection( Functions.GetConnectionString() ); 
                object[,] paramsIdent = new object[ 1, 3 ]; 
                DataSet ds = null; 
                int classid = int.Parse( "" + Request.QueryString[ "classid" ] ); 
                
                paramsIdent[ 0, 0 ] = "@ID"; 
                paramsIdent[ 0, 1 ] = classid; 
                ds = cn.ExecuteQuery( "CMS.Class.Select", paramsIdent ); 
                if ( ds.Tables[ 0 ].Rows.Count > 0 ) { 
                    ViewState[ "classname" ] = ds.Tables[ 0 ].Rows[ 0 ][ "classname" ]; 
                } 
                else { 
                    ViewState[ "classname" ] = ""; 
                } 
            } 
            return System.Convert.ToString( ViewState[ "classname" ] ); 
        } 
        
        
        
        private void btnGenerate_Click( System.Object sender, System.EventArgs e ) { 
            // getting XML Schema
            SqlConnection cn = new SqlConnection( Functions.GetConnectionString() ); 
            SqlDataAdapter da = new SqlDataAdapter( "select top 1 * from " + txtTableName.Text + " order by 1 ", cn ); 
            DataSet ds = new DataSet(); 
            try { 
                cn.Open(); 
                da.FillSchema( ds, SchemaType.Mapped, GetClassName() ); 
                txtSchema.Text = Strings.Replace( ds.GetXmlSchema() + "", "utf-16", "utf-8", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ); 
                cn.Close(); 
            } 
            catch  { 
                lblError.Text = ResMan.GetString( "EditXMLSchema.Error.CannotGetSchema" ); 
            } 
        } 
        
        
        
        private void btnOK_Click( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Modify" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Modify" ); 
                return; 
            } 
            
            if ( txtSchema.Text.Trim() + "" == "" ) { 
                lblError.Text = ResMan.GetString( "EditXMLSchema.Error.NoSchema" ); 
            } 
            else { 
                try { 
                    MetadataProvider.SetXMLSchema( GetClassName(), txtSchema.Text ); 
                    lblInfo.Text = ResMan.GetString( "EditXMLSchema.ChangesSaved" ); 
                } 
                catch ( Exception ex ) { 
                    lblError.Text = ResMan.GetString( "EditXMLSchema.Error.CannotSaveSchema" ) + " " + ex.Message.ToString(); 
                } 
            } 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
