using System.Xml; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class PageTemplateEdit : System.Web.UI.Page { 
        
        protected string filename; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by btnOK_Click
             
            btnOK.Click += new System.EventHandler( btnOK_Click ); 
            // events handled by btnCancel_Click
             
            btnCancel.Click += new System.EventHandler( btnCancel_Click ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblError; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblInfo; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblPageTemplateName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblPageTemplateFileName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnOK; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnCancel; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblPageTemplateDescription; 
        [ CLSCompliantAttribute( false ) ]protected /* TRANSINFO: WithEvents */ FreeTextBoxControls.FreeTextBox txtPageTemplateDescription; 
        // Protected WithEvents txtPageTemplateDescription As FreeTextBoxControls.FreeTextBox
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtPageTemplateName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtPageTemplateFileName; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Read" ); 
                return; 
            } 
            
            if ( "" + Request.QueryString[ "filename" ] + "" != "" ) { 
                if ( ViewState[ "filename" ] == null ) { 
                    filename = "" + Request.QueryString[ "filename" ]; 
                    ViewState[ "filename" ] = filename; 
                } 
                else { 
                    filename = System.Convert.ToString( ViewState[ "filename" ] ); 
                } 
            } 
            else { 
                filename = System.Convert.ToString( ViewState[ "filename" ] ) + ""; 
            } 
            
            lblError.Text = ""; 
            lblError.Visible = false; 
            lblInfo.Text = ""; 
            lblInfo.Visible = false; 
            lblHeader.Text = ResMan.GetString( "PageTemplateEdit.Header" ); 
            lblPageTemplateDescription.Text = ResMan.GetString( "PageTemplateEdit.TemplateDescription" ); 
            lblPageTemplateFileName.Text = ResMan.GetString( "PageTemplateEdit.TemplateFileName" ); 
            lblPageTemplateName.Text = ResMan.GetString( "PageTemplateEdit.TemplateName" ); 
            btnOK.Text = ResMan.GetString( "PageTemplateEdit.OK" ); 
            btnCancel.Text = ResMan.GetString( "PageTemplateEdit.Cancel" ); 
            
            if ( !( Page.IsPostBack ) & filename + "" != "" ) { 
                XmlDocument xml = GetXML(); 
                XmlNode node = xml.SelectSingleNode( "/templates/template[@filename='" + filename + "']" ); 
                if ( !( node == null ) ) { 
                    txtPageTemplateName.Text = node.SelectSingleNode( "name" ).InnerText; 
                    txtPageTemplateFileName.Text = node.Attributes[ "filename" ].Value; 
                    txtPageTemplateDescription.Text = node.SelectSingleNode( "description" ).InnerText; 
                } 
            } 
        } 
        
        
        
        private void btnOK_Click( System.Object sender, System.EventArgs e ) { 
            XmlDocument xml = null; 
            xml = GetXML(); 
            XmlNode node = null; 
            
            // check permissions
            if ( filename + "" == "" ) { 
                if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Create" ) ) ) { 
                    Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Create" ); 
                    return; 
                } 
            } 
            else { 
                if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Modify" ) ) ) { 
                    Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Modify" ); 
                    return; 
                } 
            } 
            
            // validate input
            string errorMessage = ""; 
            string infoMessage = null; 
            
            if ( this.txtPageTemplateName.Text.Trim() + "" == "" ) { 
                errorMessage += ResMan.GetString( "PageTemplateEdit.ErrorEmptyPageTemplateName" ) + " "; 
            } 
            if ( this.txtPageTemplateFileName.Text.Trim() + "" == "" ) { 
                errorMessage += ResMan.GetString( "PageTemplateEdit.ErrorEmptyPageTemplateFileName" ) + " "; 
            } 
            
            if ( errorMessage + "" == "" ) { 
                // check for existing file name or name
                if ( ( filename + "" == "" ) | ( filename + "" != "" & filename != this.txtPageTemplateFileName.Text ) ) { 
                    if ( xml.SelectNodes( "/templates/template[@filename='" + this.txtPageTemplateFileName.Text + "']" ).Count > 0 ) { 
                        errorMessage += ResMan.GetString( "PageTemplateEdit.ErrorExistingPageTemplateFileName" ) + " "; 
                    } 
                } 
                
                if ( errorMessage + "" == "" ) { 
                    // save template details
                    if ( filename + "" == "" ) { 
                        // insert mode
                        node = xml.CreateElement( "template" ); 
                        xml.SelectSingleNode( "/templates" ).AppendChild( node ); 
                        node.Attributes.Append( xml.CreateAttribute( "filename" ) ); 
                        node.AppendChild( xml.CreateElement( "name" ) ); 
                        node.AppendChild( xml.CreateElement( "description" ) ); 
                    } 
                    else { 
                        // update mode
                        node = xml.SelectSingleNode( "/templates/template[@filename='" + filename + "']" ); 
                    } 
                    node.Attributes[ "filename" ].Value = this.txtPageTemplateFileName.Text; 
                    node.SelectSingleNode( "name" ).InnerText = this.txtPageTemplateName.Text; 
                    node.SelectSingleNode( "description" ).InnerText = this.txtPageTemplateDescription.Text; 
                    xml.Save( Functions.GetMetadataPath() + @"\_PageTemplates\pagetemplates.config" ); 
                    ViewState[ "filename" ] = this.txtPageTemplateFileName.Text; 
                    infoMessage = ResMan.GetString( "PageTemplateEdit.ChangesSaved" ); 
                } 
            } 
            
            if ( errorMessage + "" != "" ) { 
                lblError.Text = errorMessage; 
                lblError.Visible = true; 
            } 
            if ( infoMessage + "" != "" ) { 
                lblInfo.Text = infoMessage; 
                lblInfo.Visible = true; 
            } 
        } 
        
        
        
        private void btnCancel_Click( System.Object sender, System.EventArgs e ) { 
            // redirect user back to the previous dialog
            ltlScript.Text = @"<script language=""javascript"">"; 
            ltlScript.Text += " Cancel(); "; 
            ltlScript.Text += "</script>"; 
        } 
        
        
        
        private XmlDocument GetXML() { 
            XmlDocument xml = new XmlDocument(); 
            xml.Load( Functions.GetMetadataPath() + @"\_PageTemplates\pagetemplates.config" ); 
            return xml; 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
