using Kentico.CMS.DataEngine; 
using System.Xml; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class PageTemplateList : System.Web.UI.Page { 
        
        protected string editHint; 
        protected string deleteHint; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by dtg_ItemDataBound
             
            BasicDataGrid1.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler( dtg_ItemDataBound ); 
        } 
        
        
        protected /* TRANSINFO: WithEvents */ Kentico.CMS.CMSControls.BasicDataGrid BasicDataGrid1; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlConfirmScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Read" ); 
                return; 
            } 
            
            editHint = ResMan.GetString( "PageTemplateList.EditHint" ); 
            deleteHint = ResMan.GetString( "PageTemplateList.DeleteHint" ); 
            // set column header names
            BasicDataGrid1.Columns[ 0 ].HeaderText = ResMan.GetString( "PageTemplate.Action" ); 
            BasicDataGrid1.Columns[ 1 ].HeaderText = ResMan.GetString( "PageTemplate.Name" ); 
            BasicDataGrid1.Columns[ 2 ].HeaderText = ResMan.GetString( "PageTemplate.FileName" ); 
            // confirmation question
            ltlConfirmScript.Text = @"<input type=""hidden"" id=""confirmationText"" value=""" + ResMan.GetString( "PageTemplate.ConfirmDelete" ) + @""">"; 
            lblHeader.Text = ResMan.GetString( "PageTemplate.Header" ); 
            if ( !( Page.IsPostBack ) ) { 
                DisplayPageTemplates(); 
            } 
        } 
        
        
        
        
        public void DeleteItem( object sender, System.Web.UI.WebControls.DataGridCommandEventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Delete" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Delete" ); 
                return; 
            } 
            
            // delete page template
            string filename = System.Convert.ToString( e.CommandArgument ); 
            XmlDocument xml = GetXML(); 
            XmlNode node = xml.SelectSingleNode( "/templates/template[@filename='" + filename + "']" ); 
            xml.SelectSingleNode( "/templates" ).RemoveChild( node ); 
            xml.Save( Functions.GetMetadataPath() + @"\_PageTemplates\pagetemplates.config" ); 
            Response.Redirect( Page.Request.Url.ToString() ); 
        } 
        
        
        
        ///<summary>Displays list of page templates in a grid.</summary>
        private void DisplayPageTemplates() { 
            XmlDocument xml = GetXML(); 
            DataSet ds = new DataSet(); 
            DataRow dr = null; 
            XmlNode node = null; 
            
            ds.Tables.Add( new DataTable() ); 
            ds.Tables[ 0 ].Columns.Add( new DataColumn( "Name" ) ); 
            ds.Tables[ 0 ].Columns.Add( new DataColumn( "FileName" ) ); 
            foreach ( System.Xml.XmlNode transTemp0 in xml.SelectNodes( "/templates/template" ) ) { 
                node = transTemp0;  
                dr = ds.Tables[ 0 ].NewRow(); 
                dr[ "Name" ] = node.SelectSingleNode( "name" ).InnerText; 
                dr[ "FileName" ] = node.Attributes[ "filename" ].Value; 
                ds.Tables[ 0 ].Rows.Add( dr ); 
            }
            BasicDataGrid1.DataSource = ds; 
        } 
        
        
        
        private void dtg_ItemDataBound( System.Object sender, DataGridItemEventArgs e ) { 
            ImageButton btnCurrentButton = null; 
            
            // set up the Delete button
            if ( e.Item.ItemType == ListItemType.Item | e.Item.ItemType == ListItemType.AlternatingItem ) { 
                btnCurrentButton = ( ( ImageButton )( e.Item.Cells[ 0 ].FindControl( "btnDelete" ) ) ); 
                btnCurrentButton.Attributes.Add( "OnClick", "return ConfirmDelete();" ); 
                btnCurrentButton.Attributes.Add( "title", deleteHint ); 
            } 
        } 
        
        
        
        private XmlDocument GetXML() { 
            XmlDocument xml = new XmlDocument(); 
            xml.Load( Functions.GetMetadataPath() + @"\_PageTemplates\pagetemplates.config" ); 
            return xml; 
        } 
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
} 
