using Kentico.CMS.DataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class PermissionNameEdit : System.Web.UI.Page { 
        
        protected int permissionID; 
        protected int classID; 
        protected int resourceID; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by btnOK_Click
             
            btnOK.Click += new System.EventHandler( btnOK_Click ); 
            // events handled by btnCancel_Click
             
            btnCancel.Click += new System.EventHandler( btnCancel_Click ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblError; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblInfo; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnOK; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnCancel; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblPermissionID; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblPermissionIDValue; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblPermissionDisplayName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblPermissionName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtPermissionDisplayName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtPermissionName; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Read" ); 
                return; 
            } 
            
            GeneralConnection cn = null; 
            DataClass permissionObj = null; 
            
            if ( "" + Request.QueryString[ "id" ] + "" != "" ) { 
                permissionID = int.Parse( "" + Request.QueryString[ "id" ] ); 
            } 
            else { 
                permissionID = 0; 
            } 
            if ( "" + Request.QueryString[ "resourceid" ] + "" != "" ) { 
                resourceID = int.Parse( "" + Request.QueryString[ "resourceid" ] ); 
            } 
            else { 
                resourceID = 0; 
            } 
            if ( "" + Request.QueryString[ "classid" ] + "" != "" ) { 
                classID = int.Parse( "" + Request.QueryString[ "classid" ] ); 
            } 
            else { 
                classID = 0; 
            } 
            lblError.Text = ""; 
            lblError.Visible = false; 
            lblInfo.Text = ""; 
            lblInfo.Visible = false; 
            lblHeader.Text = ResMan.GetString( "PermissionNameEdit.Header" ); 
            lblPermissionID.Text = ResMan.GetString( "PermissionNameEdit.PermissionID" ); 
            lblPermissionName.Text = ResMan.GetString( "PermissionNameEdit.PermissionName" ); 
            lblPermissionDisplayName.Text = ResMan.GetString( "PermissionNameEdit.PermissionDisplayName" ); 
            btnOK.Text = ResMan.GetString( "PermissionNameEdit.OK" ); 
            btnCancel.Text = ResMan.GetString( "PermissionNameEdit.Cancel" ); 
            
            if ( !( Page.IsPostBack ) & permissionID != 0 ) { 
                cn = new GeneralConnection( Functions.GetConnectionString() ); 
                permissionObj = new DataClass( "CMS.Permission", permissionID, cn ); 
                txtPermissionName.Text = System.Convert.ToString( permissionObj.GetValue( "PermissionName" ) ); 
                txtPermissionDisplayName.Text = System.Convert.ToString( permissionObj.GetValue( "PermissionDisplayName" ) ); 
                lblPermissionIDValue.Text = System.Convert.ToString( permissionObj.GetValue( "PermissionID" ) ); 
            } 
            else { 
                lblPermissionIDValue.Text = ResMan.GetString( "PermissionNameEdit.NoPermissionIDValue" ); 
            } 
        } 
        
        
        
        private void btnOK_Click( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( permissionID == 0 ) { 
                if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Create" ) ) ) { 
                    Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Create" ); 
                    return; 
                } 
            } 
            else { 
                if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Modify" ) ) ) { 
                    Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Modify" ); 
                    return; 
                } 
            } 
            
            // validate input
            string errorMessage = ""; 
            GeneralConnection cn = null; 
            string[,] paramsIdent = new string[ 2, 3 ]; 
            DataRow permissionDR = null; 
            DataSet permissionNamesDS = null; 
            string infoMessage = null; 
            DataClass permissionObj = null; 
            
            if ( txtPermissionName.Text.Trim() + "" == "" ) { 
                errorMessage += ResMan.GetString( "PermissionNameEdit.ErrorEmptyPermissionName" ) + " "; 
            } 
            if ( txtPermissionDisplayName.Text.Trim() + "" == "" ) { 
                errorMessage += ResMan.GetString( "PermissionNameEdit.ErrorEmptyPermissionDisplayName" ) + " "; 
            } 
            
            if ( errorMessage + "" == "" ) { 
                // check for existing permission name
                paramsIdent[ 0, 0 ] = "@PermissionName"; 
                paramsIdent[ 0, 1 ] = txtPermissionName.Text.Trim(); 
                cn = new GeneralConnection( Functions.GetConnectionString() ); 
                cn.DataConnection.Open(); 
                
                if ( classID > 0 ) { 
                    paramsIdent[ 1, 0 ] = "@ClassID"; 
                    paramsIdent[ 1, 1 ] = classID.ToString(); 
                    permissionNamesDS = cn.ExecuteQuery( "CMS.Permission.SelectByPermissionNameAndClassID", paramsIdent ); 
                } 
                else { 
                    paramsIdent[ 1, 0 ] = "@ResourceID"; 
                    paramsIdent[ 1, 1 ] = resourceID.ToString(); 
                    permissionNamesDS = cn.ExecuteQuery( "CMS.Permission.SelectByPermissionNameAndResourceID", paramsIdent ); 
                } 
                if ( permissionID == 0 ) { 
                    if ( permissionNamesDS.Tables[ 0 ].Rows.Count > 0 ) { 
                        // permission name already exists
                        errorMessage += ResMan.GetString( "PermissionNameEdit.ErrorExistingPermissionName" ) + " "; 
                    } 
                } 
                else { 
                    foreach ( System.Data.DataRow transTemp0 in permissionNamesDS.Tables[ 0 ].Rows ) { 
                        permissionDR = transTemp0;  
                        if ( System.Convert.ToInt32( permissionDR[ "permissionID" ] ) != permissionID ) { 
                            // permission name already exists
                            errorMessage += ResMan.GetString( "PermissionNameEdit.ErrorExistingPermissionName" ) + " "; 
                        } 
                    }
                } 
                
                if ( errorMessage + "" == "" ) { 
                    // save permission info
                    if ( permissionID == 0 ) { 
                        // insert a new permission name
                        permissionObj = new DataClass( "CMS.Permission", cn ); 
                        permissionObj.SetValue( "PermissionName", txtPermissionName.Text ); 
                        permissionObj.SetValue( "PermissionDisplayName", txtPermissionDisplayName.Text ); 
                        if ( classID > 0 ) { 
                            permissionObj.SetValue( "ClassID", classID ); 
                        } 
                        else { 
                            permissionObj.SetValue( "ResourceID", resourceID ); 
                        } 
                        permissionObj.Insert(); 
                        txtPermissionName.Text = ""; 
                        txtPermissionDisplayName.Text = ""; 
                        infoMessage = ResMan.GetString( "PermissionEdit.ChangesInserted" ); 
                    } 
                    else { 
                        // update an existing user
                        permissionObj = new DataClass( "CMS.Permission", permissionID, cn ); 
                        permissionObj.SetValue( "PermissionName", txtPermissionName.Text ); 
                        permissionObj.SetValue( "PermissionDisplayName", txtPermissionDisplayName.Text ); 
                        if ( classID > 0 ) { 
                            permissionObj.SetValue( "ClassID", classID ); 
                        } 
                        else { 
                            permissionObj.SetValue( "ResourceID", resourceID ); 
                        } 
                        permissionObj.Update(); 
                        infoMessage = ResMan.GetString( "PermissionNameEdit.ChangesSaved" ); 
                    } 
                } 
                cn.DataConnection.Close(); 
            } 
            
            if ( errorMessage + "" != "" ) { 
                lblError.Text = errorMessage; 
                lblError.Visible = true; 
            } 
            if ( infoMessage + "" != "" ) { 
                lblInfo.Text = infoMessage; 
                lblInfo.Visible = true; 
            } 
        } 
        
        
        
        private void btnCancel_Click( System.Object sender, System.EventArgs e ) { 
            // redirect user back to the previous dialog
            ltlScript.Text = @"<script language=""javascript"">"; 
            ltlScript.Text += " Cancel('" + "" + Request.QueryString[ "classid" ] + "', '" + "" + Request.QueryString[ "resourceid" ] + "'); "; 
            ltlScript.Text += "</script>"; 
        } 
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
