using System.IO; 
using System.Xml; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class QueryList : System.Web.UI.Page { 
        
        private string path; 
        private int classID; 
        private string className; 
        protected string editHint; 
        protected string deleteHint; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by Grid1_ItemDataBound
             
            Grid1.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler( Grid1_ItemDataBound ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ Kentico.CMS.CMSControls.BasicDataGrid Grid1; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlConfirmScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Read" ); 
                return; 
            } 
            
            classID = int.Parse( "" + Request.QueryString[ "classid" ] ); 
            className = System.Convert.ToString( Kentico.CMS.TreeEngine.ClassInformationProvider.GetClassRow( classID, Functions.GetTreeProvider() )[ ( ( "ClassName" ) ) ] ); 
            path = Functions.GetMetadataPath() + @"\" + className.Split( '.' )[ 0 ] + @"\" + className.Split( '.' )[ 1 ] + @"\queries.config"; 
            
            editHint = ResMan.GetString( "QueryList.EditHint" ); 
            deleteHint = ResMan.GetString( "QueryList.DeleteHint" ); 
            // set column header names
            Grid1.Columns[ 0 ].HeaderText = ResMan.GetString( "QueryList.Action" ); 
            Grid1.Columns[ 1 ].HeaderText = ResMan.GetString( "QueryList.QueryID" ); 
            
            // confirmation question
            ltlConfirmScript.Text = @"<input type=""hidden"" id=""confirmationText"" value=""" + ResMan.GetString( "QueryList.ConfirmDelete" ) + @""">"; 
            lblHeader.Text = ResMan.GetString( "QueryList.Header" ); 
            
            if ( !( Page.IsPostBack ) ) { 
                DisplayQueries(); 
            } 
        } 
        
        
        
        public void DeleteItem( object sender, System.Web.UI.WebControls.DataGridCommandEventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Delete" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Delete" ); 
                return; 
            } 
            
            // delete Query
            XmlDocument xml = new XmlDocument(); 
            xml.Load( path ); 
            XmlNode node = xml.SelectSingleNode( "/queries/query[@id='" + System.Convert.ToString( e.CommandArgument ) + "']" ); 
            xml.SelectSingleNode( "/queries" ).RemoveChild( node ); 
            xml.Save( path ); 
            Kentico.CMS.MetadataEngine.MetadataProvider.ClearMetadata(); 
            
            ltlScript.Text = @"<script language=""javascript"">"; 
            ltlScript.Text += " Reload(); "; 
            ltlScript.Text += "</script>"; 
        } 
        
        
        
        private void DisplayQueries() { 
            XmlNode node = null; 
            DataSet ds = new DataSet(); 
            DataRow dr = null; 
            XmlDocument xml = new XmlDocument(); 
            // read queries
            if ( File.Exists( path ) ) { 
                xml.Load( path ); 
            } 
            else { 
                xml.LoadXml( "<queries></queries>" ); 
                xml.Save( path ); 
            } 
            
            // prepare dataset
            ds.Tables.Add( new DataTable() ); 
            ds.Tables[ 0 ].Columns.Add( new DataColumn( "QueryID" ) ); 
            ds.Tables[ 0 ].Columns.Add( new DataColumn( "FullQueryName" ) ); 
            // fill dataset
            foreach ( System.Xml.XmlNode transTemp0 in xml.SelectNodes( "/queries/query" ) ) { 
                node = transTemp0;  
                dr = ds.Tables[ 0 ].NewRow(); 
                dr[ "QueryID" ] = node.Attributes[ "id" ].Value; 
                dr[ "FullQueryName" ] = className + "." + node.Attributes[ "id" ].Value; 
                ds.Tables[ 0 ].Rows.Add( dr ); 
            }
            // bind data
            Grid1.DataSource = ds; 
        } 
        
        
        
        private void Grid1_ItemDataBound( System.Object sender, DataGridItemEventArgs e ) { 
            ImageButton btnCurrentButton = null; 
            
            // set up the Delete button
            if ( e.Item.ItemType == ListItemType.Item | e.Item.ItemType == ListItemType.AlternatingItem ) { 
                btnCurrentButton = ( ( ImageButton )( e.Item.Cells[ 0 ].FindControl( "btnDelete" ) ) ); 
                btnCurrentButton.Attributes.Add( "OnClick", "return ConfirmDelete();" ); 
                btnCurrentButton.Attributes.Add( "title", deleteHint ); 
            } 
        } 
        
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
