using Kentico.CMS.DataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class ResourceEdit : System.Web.UI.Page { 
        
        protected int resourceID; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by btnOK_Click
             
            btnOK.Click += new System.EventHandler( btnOK_Click ); 
            // events handled by btnCancel_Click
             
            btnCancel.Click += new System.EventHandler( btnCancel_Click ); 
            // events handled by chkShowInToolsMenu_CheckedChanged
             
            chkShowInToolsMenu.CheckedChanged += new System.EventHandler( chkShowInToolsMenu_CheckedChanged ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblError; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblInfo; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblResourceID; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblResourceIDValue; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblResourceDisplayName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtResourceDisplayName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblResourceName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtResourceName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnOK; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnCancel; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.CheckBox chkShowInToolsMenu; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblResourceURL; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtResourceURL; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblShowInToolsMenu; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Read" ); 
                return; 
            } 
            
            GeneralConnection cn = null; 
            DataClass resourceObj = null; 
            
            if ( "" + Request.QueryString[ "id" ] + "" != "" ) { 
                resourceID = int.Parse( "" + Request.QueryString[ "id" ] ); 
            } 
            else { 
                resourceID = 0; 
            } 
            lblError.Text = ""; 
            lblError.Visible = false; 
            lblInfo.Text = ""; 
            lblInfo.Visible = false; 
            lblHeader.Text = ResMan.GetString( "ResourceEdit.Header" ); 
            lblResourceID.Text = ResMan.GetString( "ResourceEdit.ResourceID" ); 
            lblResourceName.Text = ResMan.GetString( "ResourceEdit.ResourceName" ); 
            lblResourceDisplayName.Text = ResMan.GetString( "ResourceEdit.ResourceDisplayName" ); 
            lblShowInToolsMenu.Text = ResMan.GetString( "ResourceEdit.ShowInToolsMenu" ); 
            lblResourceURL.Text = ResMan.GetString( "ResourceEdit.ResourceURL" ); 
            btnOK.Text = ResMan.GetString( "ResourceEdit.OK" ); 
            btnCancel.Text = ResMan.GetString( "ResourceEdit.Cancel" ); 
            this.txtResourceURL.Enabled = this.chkShowInToolsMenu.Checked; 
            
            if ( !( Page.IsPostBack ) & resourceID != 0 ) { 
                // set values
                cn = new GeneralConnection( Functions.GetConnectionString() ); 
                resourceObj = new DataClass( "CMS.Resource", resourceID, cn ); 
                txtResourceName.Text = System.Convert.ToString( resourceObj.GetValue( "ResourceName" ) ); 
                txtResourceDisplayName.Text = System.Convert.ToString( resourceObj.GetValue( "ResourceDisplayName" ) ); 
                lblResourceIDValue.Text = System.Convert.ToString( resourceObj.GetValue( "ResourceID" ) ); 
                txtResourceURL.Text = System.Convert.ToString( resourceObj.GetValue( "ResourceURL" ) ); 
                chkShowInToolsMenu.Checked = Convert.ToBoolean( resourceObj.GetValue( "ShowInToolsMenu" ) ); 
                this.txtResourceURL.Enabled = this.chkShowInToolsMenu.Checked; 
            } 
            else { 
                lblResourceIDValue.Text = ResMan.GetString( "EditResource.NoResourceIDValue" ); 
            } 
        } 
        
        
        
        private void btnOK_Click( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( resourceID == 0 ) { 
                if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Create" ) ) ) { 
                    Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Create" ); 
                    return; 
                } 
            } 
            else { 
                if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Modify" ) ) ) { 
                    Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Modify" ); 
                    return; 
                } 
            } 
            
            // validate input
            string errorMessage = ""; 
            GeneralConnection cn = null; 
            string[,] paramsIdent = new string[ 1, 3 ]; 
            DataRow resourceDR = null; 
            DataSet resourceNamesDS = null; 
            string infoMessage = null; 
            DataClass resourceObj = null; 
            
            if ( txtResourceName.Text.Trim() + "" == "" ) { 
                errorMessage += ResMan.GetString( "ResourceEdit.ErrorEmptyResourceName" ) + " "; 
            } 
            if ( txtResourceDisplayName.Text.Trim() + "" == "" ) { 
                errorMessage += ResMan.GetString( "ResourceEdit.ErrorEmptyResourceDisplayName" ) + " "; 
            } 
            
            if ( errorMessage + "" == "" ) { 
                // check for existing resource
                paramsIdent[ 0, 0 ] = "@ResourceName"; 
                paramsIdent[ 0, 1 ] = txtResourceName.Text.Trim(); 
                cn = new GeneralConnection( Functions.GetConnectionString() ); 
                cn.DataConnection.Open(); 
                
                resourceNamesDS = cn.ExecuteQuery( "CMS.Resource.SelectByResourceName", paramsIdent ); 
                if ( resourceID == 0 ) { 
                    if ( resourceNamesDS.Tables[ 0 ].Rows.Count > 0 ) { 
                        // resource name already exists
                        errorMessage += ResMan.GetString( "ResourceEdit.ErrorExistingResourceName" ) + " "; 
                    } 
                } 
                else { 
                    foreach ( System.Data.DataRow transTemp0 in resourceNamesDS.Tables[ 0 ].Rows ) { 
                        resourceDR = transTemp0;  
                        if ( System.Convert.ToInt32( resourceDR[ "ResourceID" ] ) != resourceID ) { 
                            // resource name already exists
                            errorMessage += ResMan.GetString( "ResourceEdit.ErrorExistingResourceName" ) + " "; 
                        } 
                    }
                } 
                
                if ( errorMessage + "" == "" ) { 
                    // save resource info
                    if ( resourceID == 0 ) { 
                        // insert a new resource
                        resourceObj = new DataClass( "CMS.Resource", cn ); 
                        resourceObj.SetValue( "ResourceName", txtResourceName.Text ); 
                        resourceObj.SetValue( "ResourceDisplayName", txtResourceDisplayName.Text ); 
                        resourceObj.SetValue( "ShowInToolsMenu", chkShowInToolsMenu.Checked ); 
                        resourceObj.SetValue( "ResourceURL", txtResourceURL.Text ); 
                        resourceObj.Insert(); 
                        txtResourceName.Text = ""; 
                        txtResourceDisplayName.Text = ""; 
                        chkShowInToolsMenu.Checked = false; 
                        txtResourceURL.Text = ""; 
                        infoMessage = ResMan.GetString( "ResourceEdit.ChangesInserted" ); 
                        ltlScript.Text = @"<script language=""javascript"">"; 
                        ltlScript.Text += " RefreshTreeAfterInsert(); "; 
                        ltlScript.Text += "</script>"; 
                    } 
                    else { 
                        // update an existing user
                        resourceObj = new DataClass( "CMS.Resource", resourceID, cn ); 
                        resourceObj.SetValue( "ResourceName", txtResourceName.Text ); 
                        resourceObj.SetValue( "ResourceDisplayName", txtResourceDisplayName.Text ); 
                        resourceObj.SetValue( "ShowInToolsMenu", chkShowInToolsMenu.Checked ); 
                        resourceObj.SetValue( "ResourceURL", txtResourceURL.Text ); 
                        resourceObj.Update(); 
                        infoMessage = ResMan.GetString( "ResourceEdit.ChangesSaved" ); 
                        ltlScript.Text = @"<script language=""javascript"">"; 
                        ltlScript.Text += " RefreshTree(); "; 
                        ltlScript.Text += "</script>"; 
                    } 
                } 
                cn.DataConnection.Close(); 
            } 
            
            if ( errorMessage + "" != "" ) { 
                lblError.Text = errorMessage; 
                lblError.Visible = true; 
            } 
            if ( infoMessage + "" != "" ) { 
                lblInfo.Text = infoMessage; 
                lblInfo.Visible = true; 
            } 
        } 
        
        
        
        private void btnCancel_Click( System.Object sender, System.EventArgs e ) { 
            // redirects user back to the list of resources
            ltlScript.Text = @"<script language=""javascript"">"; 
            ltlScript.Text += " Cancel(); "; 
            ltlScript.Text += "</script>"; 
        } 
        
        
        private void chkShowInToolsMenu_CheckedChanged( System.Object sender, System.EventArgs e ) { 
            this.txtResourceURL.Enabled = this.chkShowInToolsMenu.Checked; 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
