using System.Xml; 
using System.IO; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class SettingsEdit : System.Web.UI.Page { 
        
        private string key; 
        private string className; 
        private int classID; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblKey; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtKey; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblValue; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtValue; 
        private string path; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by btnOK_Click
             
            btnOK.Click += new System.EventHandler( btnOK_Click ); 
            // events handled by btnCancel_Click
             
            btnCancel.Click += new System.EventHandler( btnCancel_Click ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblError; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblInfo; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnOK; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnCancel; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Read" ); 
                return; 
            } 
            
            if ( "" + Request.QueryString[ "action" ] != "insert" ) { 
                key = "" + Request.QueryString[ "key" ].Split( '.' )[ 2 ]; 
                path = Functions.GetMetadataPath() + @"\" + "" + Request.QueryString[ "key" ].Split( '.' )[ 0 ] + @"\" + "" + Request.QueryString[ "key" ].Split( '.' )[ 1 ] + @"\settings.config"; 
                ViewState[ "mode" ] = "modify"; 
                className = "" + Request.QueryString[ "key" ].Split( '.' )[ 0 ] + "." + "" + Request.QueryString[ "key" ].Split( '.' )[ 1 ]; 
                classID = System.Convert.ToInt32( Kentico.CMS.TreeEngine.ClassInformationProvider.GetClassRow( className, Functions.GetTreeProvider() )[ "ClassID" ] ); 
            } 
            else if ( "" + Request.QueryString[ "classid" ] + "" != "" ) { 
                if ( System.Convert.ToString( ViewState[ "mode" ] ) + "" == "" ) { 
                    ViewState[ "mode" ] = "create"; 
                } 
                key = ""; 
                classID = int.Parse( "" + Request.QueryString[ "classid" ] ); 
                className = System.Convert.ToString( Kentico.CMS.TreeEngine.ClassInformationProvider.GetClassRow( classID, Functions.GetTreeProvider() )[ ( ( "ClassName" ) ) ] ); 
                path = Functions.GetMetadataPath() + @"\" + className.Split( '.' )[ 0 ] + @"\" + className.Split( '.' )[ 1 ] + @"\settings.config"; 
            } 
            if ( !( Page.IsPostBack ) ) { 
                ViewState[ "originalKey" ] = key; 
            } 
            lblError.Text = ""; 
            lblInfo.Text = ""; 
            lblHeader.Text = ResMan.GetString( "SettingsEdit.Header" ); 
            lblKey.Text = ResMan.GetString( "SettingsEdit.Key" ); 
            lblValue.Text = ResMan.GetString( "SettingsEdit.Value" ); 
            btnOK.Text = ResMan.GetString( "SettingsEdit.OK" ); 
            btnCancel.Text = ResMan.GetString( "SettingsEdit.Cancel" ); 
            
            if ( !( Page.IsPostBack ) & System.Convert.ToString( ViewState[ "mode" ] ) == "modify" ) { 
                // set values
                XmlDocument xml = new XmlDocument(); 
                xml.Load( path ); 
                XmlNode node = xml.SelectSingleNode( "/settings/add[@key='" + key + "']" ); 
                this.txtKey.Text = key; 
                this.txtValue.Text = node.Attributes[ "value" ].Value; 
            } 
        } 
        
        
        
        private void btnOK_Click( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( System.Convert.ToString( ViewState[ "mode" ] ) == "create" ) { 
                if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Create" ) ) ) { 
                    Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Create" ); 
                    return; 
                } 
            } 
            else { 
                if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Modify" ) ) ) { 
                    Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Modify" ); 
                    return; 
                } 
            } 
            
            // validate input
            string errorMessage = ""; 
            XmlDocument xml = new XmlDocument(); 
            xml.Load( path ); 
            XmlNode node = null; 
            
            if ( txtKey.Text.Trim() + "" == "" ) { 
                errorMessage += ResMan.GetString( "SettingsEdit.ErrorEmptyKey" ) + " "; 
            } 
            else if ( txtKey.Text.Trim().ToLower() != ( System.Convert.ToString( ViewState[ "originalKey" ] ) + "" ).Trim().ToLower() ) { 
                // check uniqueness
                if ( !( xml.SelectSingleNode( "/settings/add[@key='" + txtKey.Text.Trim().ToLower() + "']" ) == null ) ) { 
                    errorMessage += ResMan.GetString( "SettingsEdit.ErrorExistingKey" ); 
                } 
            } 
            if ( errorMessage + "" != "" ) { 
                lblError.Text = errorMessage; 
            } 
            
            // save
            if ( errorMessage + "" == "" ) { 
                txtKey.Text = txtKey.Text.ToLower().Trim(); 
                if ( System.Convert.ToString( ViewState[ "mode" ] ) == "create" ) { 
                    node = xml.CreateNode( XmlNodeType.Element, "", "add", "" ); 
                    node.Attributes.Append( xml.CreateAttribute( "", "key", "" ) ); 
                    node.Attributes.Append( xml.CreateAttribute( "", "value", "" ) ); 
                } 
                else { 
                    node = xml.SelectSingleNode( "/settings/add[@key='" + System.Convert.ToString( ViewState[ "originalKey" ] ) + "']" ); 
                } 
                node.Attributes[ "key" ].Value = this.txtKey.Text.Trim().ToLower(); 
                node.Attributes[ "value" ].Value = this.txtValue.Text; 
                if ( System.Convert.ToString( ViewState[ "mode" ] ) == "create" ) { 
                    // create new                
                    xml.SelectSingleNode( "/settings" ).AppendChild( node ); 
                    xml.Save( path ); 
                    ViewState[ "mode" ] = "modify"; 
                } 
                else { 
                    // modify existing                
                    xml.Save( path ); 
                } 
                ViewState[ "originalKey" ] = this.txtKey.Text; 
                // update metadata
                Kentico.CMS.MetadataEngine.MetadataProvider.ClearMetadata(); 
                lblInfo.Text = ResMan.GetString( "SettingsEdit.ChangesSaved" ); 
            } 
        } 
        
        
        
        private void btnCancel_Click( System.Object sender, System.EventArgs e ) { 
            // redirects user back to the list of resources        
            ltlScript.Text = @"<script language=""javascript"">"; 
            ltlScript.Text += " Cancel('" + classID + "'); "; 
            ltlScript.Text += "</script>"; 
        } 
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
