using System.Xml; 
using Kentico.CMS.MetadataEngine; 
using Kentico.CMS.DataEngine; 
using Kentico.CMS.TreeEngine; 
using System.IO; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class TemplateWizard_Finished : System.Web.UI.UserControl, ITemplateWizardStep
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
     { 
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblIntro; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblNextSteps; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlSteps; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            this.lblIntro.Text = ResMan.GetString( "TemplateWizard_Finished.Intro" ); 
            this.lblNextSteps.Text = ResMan.GetString( "TemplateWizard_Finished.NextSteps" ); 
        } 
        
        
        
        public bool IsValid() { 
            return true; 
        } 
        // interface methods implemented by IsValid
        bool ITemplateWizardStep.IsValid() { return IsValid(); }
        
        
        
        public string GetStepHeader() { 
            return ResMan.GetString( "TemplateWizard_Finished.StepHeader" ); 
        } 
        // interface methods implemented by GetStepHeader
        string ITemplateWizardStep.GetStepHeader() { return GetStepHeader(); }
        
        
        
        public string GetStepDescription() { 
            return ResMan.GetString( "TemplateWizard_Finished.StepDescription" ); 
        } 
        // interface methods implemented by GetStepDescription
        string ITemplateWizardStep.GetStepDescription() { return GetStepDescription(); }
        
        
        
        public void FinishWizard() { 
            bool isCoupled = false; 
            
            isCoupled = System.Convert.ToBoolean( ClassInformationProvider.GetClassRow( this.ClassID, Functions.GetTreeProvider() )[ ( ( "IsCoupledClass" ) ) ] ); 
            // generate transformation
            if ( isCoupled ) { 
                // ASCX Transformation (default)
                string txt = TransformationGenerator.GetASCXTransformation( ClassName + ".default" ); 
                TextWriter strm = new StreamWriter( Functions.GetMetadataPath() + @"\" + ClassName.Split( '.' )[ 0 ] + @"\" + ClassName.Split( '.' )[ 1 ] + @"\transformations\default.ascx" ); 
                strm.Write( txt ); 
                strm.Close(); 
                // XSL Transformation
                // Dim xsl As XmlDocument = TransformationGenerator.GetXSLTransformation(ClassName & ".default")
                // xsl.Save(Functions.GetMetadataPath & "\" & ClassName.Split("."c)(0) & "\" & ClassName.Split("."c)(1) & "\transformations\default.config")
            } 
            
            if ( !( isCoupled ) ) { 
                // generate standard queries for non-coupled classes
                MetadataQuery query = new MetadataQuery(); 
                query.RequiresTransaction = false; 
                // select
                query.QueryText = "Proc_CMS_Tree_Select"; 
                query.QueryType = MetadataQueryTypeEnum.StoredProcedure; 
                MetadataProvider.SetQuery( ClassName + ".select", query ); 
                // insert
                query.QueryText = "Proc_CMS_Tree_Insert"; 
                query.QueryType = MetadataQueryTypeEnum.StoredProcedure; 
                MetadataProvider.SetQuery( ClassName + ".insert", query ); 
                // update
                query.QueryText = "Proc_CMS_Tree_Update"; 
                query.QueryType = MetadataQueryTypeEnum.StoredProcedure; 
                MetadataProvider.SetQuery( ClassName + ".update", query ); 
                // delete
                query.QueryText = "Proc_CMS_Tree_Delete"; 
                query.QueryType = MetadataQueryTypeEnum.StoredProcedure; 
                MetadataProvider.SetQuery( ClassName + ".delete", query ); 
                // selectbypath
                query.QueryText = "select view_cms_tree_joined.* from view_cms_tree_joined where (##WHERE##) and classname = '" + ClassName + "' order by ##orderby##"; 
                query.QueryType = MetadataQueryTypeEnum.SQLQuery; 
                MetadataProvider.SetQuery( ClassName + ".selectbypath", query ); 
                // searchtree
                query.QueryText = "Proc_CMS_Tree_SearchTree"; 
                query.QueryType = MetadataQueryTypeEnum.StoredProcedure; 
                MetadataProvider.SetQuery( ClassName + ".searchtree", query ); 
            } 
            
            // create standard permission names
            CreatePermissionName( ClassID, "Read", ResMan.GetString( "PermissionNames.Read" ) ); 
            CreatePermissionName( ClassID, "Create", ResMan.GetString( "PermissionNames.Create" ) ); 
            CreatePermissionName( ClassID, "Modify", ResMan.GetString( "PermissionNames.Modify" ) ); 
            CreatePermissionName( ClassID, "Delete", ResMan.GetString( "PermissionNames.Delete" ) ); 
            CreatePermissionName( ClassID, "Destroy", ResMan.GetString( "PermissionNames.Destroy" ) ); 
            CreatePermissionName( ClassID, "ModifyPermissions", ResMan.GetString( "PermissionNames.ModifyPermissions" ) ); 
            
            // create icon
            try { 
                if ( isCoupled ) { 
                    File.Copy( Server.MapPath( "../design/icons/default/document.gif" ), Server.MapPath( "../design/icons/" + ClassName + ".gif" ) ); 
                    File.Copy( Server.MapPath( "../design/icons/default/document.gif" ), Server.MapPath( "../design/icons/" + ClassName + "_open.gif" ) ); 
                } 
                else { 
                    File.Copy( Server.MapPath( "../design/icons/default/folder.gif" ), Server.MapPath( "../design/icons/" + ClassName + ".gif" ) ); 
                    File.Copy( Server.MapPath( "../design/icons/default/folder_open.gif" ), Server.MapPath( "../design/icons/" + ClassName + "_open.gif" ) ); 
                } 
            } 
            catch ( Exception ex ) { 
            } 
            
            // update tree menu
            this.ltlScript.Text = @"<script language=""javascript"">" + " parent.frames['header'].ReloadSelectedNodeChildren(); " + "</script>"; 
            
            // show finished steps
            this.ltlSteps.Text = "<ul>"; 
            this.ltlSteps.Text += "<li>" + ResMan.GetString( "TemplateWizard_Finished.ClassCreated" ) + "</li>"; 
            if ( isCoupled == true ) { 
                this.ltlSteps.Text += "<li>" + ResMan.GetString( "TemplateWizard_Finished.TableCreated" ) + "</li>"; 
            } 
            this.ltlSteps.Text += "<li>" + ResMan.GetString( "TemplateWizard_Finished.FormCreated" ) + "</li>"; 
            this.ltlSteps.Text += "<li>" + ResMan.GetString( "TemplateWizard_Finished.ParentTemplatesAdded" ) + "</li>"; 
            this.ltlSteps.Text += "<li>" + ResMan.GetString( "TemplateWizard_Finished.Transformation" ) + "</li>"; 
            this.ltlSteps.Text += "<li>" + ResMan.GetString( "TemplateWizard_Finished.PermissionNames" ) + "</li>"; 
            this.ltlSteps.Text += "<li>" + ResMan.GetString( "TemplateWizard_Finished.DefaultIcon" ) + "</li>"; 
            this.ltlSteps.Text += "</ul>"; 
        } 
        
        
        
        public string ClassName { 
            get { 
                return System.Convert.ToString( ViewState[ "ClassName" ] ); 
            } 
            set { 
                ViewState[ "ClassName" ] = value; 
            } 
        } 
        
        
        public int ClassID { 
            get { 
                return System.Convert.ToInt32( ViewState[ "ClassID" ] ); 
            } 
            set { 
                ViewState[ "ClassID" ] = value; 
            } 
        } 
        
        
        private void CreatePermissionName( int classID, string permissionName, string permissionDisplayName ) { 
            DataClass permissionObj = null; 
            GeneralConnection cn = new GeneralConnection( Functions.GetConnectionString() ); 
            
            permissionObj = new DataClass( "CMS.Permission", cn ); 
            permissionObj.SetValue( "PermissionName", permissionName ); 
            permissionObj.SetValue( "PermissionDisplayName", permissionDisplayName ); 
            permissionObj.SetValue( "ClassID", classID ); 
            permissionObj.Insert(); 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
