using Kentico.CMS.DataEngine; 
using Kentico.CMS.TreeEngine; 
using Kentico.CMS.MetadataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class TemplateWizard_Names : System.Web.UI.UserControl, ITemplateWizardStep
        
     { 
        protected int applicationID; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblDisplayName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblCodeName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtDisplayName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtCodeName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblError; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblApplicationCodeName; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            applicationID = int.Parse( "" + Request.QueryString[ "applicationid" ] ); 
            lblError.Text = ""; 
            
            if ( !( Page.IsPostBack ) ) { 
                this.lblDisplayName.Text = ResMan.GetString( "TemplateWizard_Names.DisplayName" ); 
                this.lblCodeName.Text = ResMan.GetString( "TemplateWizard_Names.CodeName" ); 
                DataSet ds = null; 
                GeneralConnection cn = new GeneralConnection( Functions.GetConnectionString() ); 
                object[,] paramsIdent = new object[ 1, 3 ]; 
                paramsIdent[ 0, 0 ] = "@id"; 
                paramsIdent[ 0, 1 ] = applicationID; 
                ds = cn.ExecuteQuery( "cms.application.select", paramsIdent ); 
                this.lblApplicationCodeName.Text = System.Convert.ToString( ds.Tables[ 0 ].Rows[ 0 ][ "applicationname" ] ); 
            } 
        } 
        
        
        
        public bool IsValid() { 
            string errorMessage = null; 
            
            txtCodeName.Text = txtCodeName.Text.Trim(); 
            txtDisplayName.Text = txtDisplayName.Text.Trim(); 
            if ( this.txtDisplayName.Text + "" == "" ) { 
                errorMessage += ResMan.GetString( "TemplateWizard_Names.ErrorEmptyDisplayName" ) + " "; 
            } 
            if ( this.txtCodeName.Text + "" == "" ) { 
                errorMessage += ResMan.GetString( "TemplateWizard_Names.ErrorEmptyCodeName" ) + " "; 
            } 
            if ( Strings.InStr( this.txtCodeName.Text, ".", (Microsoft.VisualBasic.CompareMethod)(0) ) > 0 ) { 
                errorMessage += ResMan.GetString( "TemplateWizard_Names.ErrorPointInCodeName" ) + " "; 
            } 
            if ( Strings.InStr( this.txtCodeName.Text, " ", (Microsoft.VisualBasic.CompareMethod)(0) ) > 0 ) { 
                errorMessage += ResMan.GetString( "TemplateWizard_Names.ErrorSpaceInCodeName" ) + " "; 
            } 
            
            // check for existing class code name
            string[,] paramsIdent = new string[ 1, 3 ]; 
            GeneralConnection cn = new GeneralConnection( Functions.GetConnectionString() ); 
            DataSet classNamesDS = null; 
            paramsIdent[ 0, 0 ] = "@ClassName"; 
            paramsIdent[ 0, 1 ] = lblApplicationCodeName.Text + "." + txtCodeName.Text; 
            classNamesDS = cn.ExecuteQuery( "CMS.Class.SelectByClassName", paramsIdent ); 
            if ( classNamesDS.Tables[ 0 ].Rows.Count > 0 ) { 
                errorMessage += ResMan.GetString( "TemplateWizard_Names.ErrorExistingCodeName" ) + " "; 
            } 
            
            if ( errorMessage + "" == "" ) { 
                // create class
                DataClass classobj = null; 
                classobj = new DataClass( "CMS.Class", cn ); 
                classobj.SetValue( "ClassName", this.lblApplicationCodeName.Text + "." + txtCodeName.Text ); 
                classobj.SetValue( "ClassDisplayName", txtDisplayName.Text ); 
                classobj.SetValue( "ApplicationID", applicationID ); 
                classobj.SetValue( "IsCoupledClass", true ); 
                classobj.SetValue( "UseVersioning", false ); 
                classobj.SetValue( "WorkflowID", null ); 
                classobj.Insert(); 
                this.ClassID = System.Convert.ToInt32( classobj.GetValue( "ClassID" ) ); 
                this.ClassName = System.Convert.ToString( classobj.GetValue( "ClassName" ) ); 
                
                // create class folder
                Functions.EnsureDiskPath( Functions.GetMetadataPath() + @"\" + this.lblApplicationCodeName.Text + @"\" + this.txtCodeName.Text + @"\config.xml", Functions.GetMetadataPath() ); 
                
                // create settings.config
                MetadataProvider.SetSettingsValue( ClassName, "cmseditpage", "" ); 
                MetadataProvider.SetSettingsValue( ClassName, "cmslistpage", "" ); 
                MetadataProvider.SetSettingsValue( ClassName, "tablename", "" ); 
                MetadataProvider.SetSettingsValue( ClassName, "nodenamesourceattribute", "" ); 
                MetadataProvider.SetSettingsValue( ClassName, "supportfriendlyurls", "true" ); 
                
                // update class information in memory
                ClassInformationProvider.ClearMetadata(); 
                MetadataProvider.ClearMetadata(); 
                return true; 
            } 
            else { 
                this.lblError.Text = errorMessage; 
                return false; 
            } 
        } 
        // interface methods implemented by IsValid
        bool ITemplateWizardStep.IsValid() { return IsValid(); }
        
        
        
        public string GetStepHeader() { 
            return ResMan.GetString( "TemplateWizard_Names.StepHeader" ); 
        } 
        // interface methods implemented by GetStepHeader
        string ITemplateWizardStep.GetStepHeader() { return GetStepHeader(); }
        
        
        
        public string GetStepDescription() { 
            return ResMan.GetString( "TemplateWizard_Names.StepDescription" ); 
        } 
        // interface methods implemented by GetStepDescription
        string ITemplateWizardStep.GetStepDescription() { return GetStepDescription(); }
        
        
        
        public string ClassName { 
            get { 
                return System.Convert.ToString( ViewState[ "ClassName" ] ); 
            } 
            set { 
                ViewState[ "ClassName" ] = value; 
            } 
        } 
        
        
        public int ClassID { 
            get { 
                return System.Convert.ToInt32( ViewState[ "ClassID" ] ); 
            } 
            set { 
                ViewState[ "ClassID" ] = value; 
            } 
        } 
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
