using System.Xml; 
using Kentico.CMS.MetadataEngine; 
using Kentico.CMS.DataEngine; 
using Kentico.CMS.TreeEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class TemplateWizard_NodeName : System.Web.UI.UserControl, ITemplateWizardStep
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
     { 
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by chkUseVersioning_CheckedChanged
             
            chkUseVersioning.CheckedChanged += new System.EventHandler( chkUseVersioning_CheckedChanged ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblSelectField; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.DropDownList lstFields; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblUseVersioningAndWorkflow; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.CheckBox chkUseVersioning; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblWorkflow; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.DropDownList drpWorkflow; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            this.lblSelectField.Text = ResMan.GetString( "TemplateWizard_NodeName.SelectField" ); 
            this.lblUseVersioningAndWorkflow.Text = ResMan.GetString( "ClassEdit.UseVersioningAndWorkflow" ); 
            this.lblWorkflow.Text = ResMan.GetString( "ClassEdit.Workflow" ); 
            
            if ( !( Page.IsPostBack ) ) { 
                this.LoadWorkflows( 0 ); 
            } 
        } 
        
        
        
        public bool IsValid() { 
            MetadataProvider.SetSettingsValue( this.ClassName, "nodenamesourceattribute", this.lstFields.SelectedValue ); 
            if ( this.chkUseVersioning.Checked ) { 
                TreeProvider tree = Functions.GetTreeProvider(); 
                GeneralConnection cn = tree.Connection; 
                int classID = System.Convert.ToInt32( ClassInformationProvider.GetClassRow( this.ClassName, tree )[ "ClassID" ] ); 
                DataClass classObj = new DataClass( "cms.class", classID, cn ); 
                
                classObj.SetValue( "UseVersioning", true ); 
                classObj.SetValue( "WorkflowID", this.drpWorkflow.SelectedValue ); 
                classObj.Update(); 
                MetadataProvider.ClearMetadata(); 
                ClassInformationProvider.ClearMetadata(); 
            } 
            return true; 
        } 
        // interface methods implemented by IsValid
        bool ITemplateWizardStep.IsValid() { return IsValid(); }
        
        
        
        public string GetStepHeader() { 
            return ResMan.GetString( "TemplateWizard_NodeName.StepHeader" ); 
        } 
        // interface methods implemented by GetStepHeader
        string ITemplateWizardStep.GetStepHeader() { return GetStepHeader(); }
        
        
        
        public string GetStepDescription() { 
            return ResMan.GetString( "TemplateWizard_NodeName.StepDescription" ); 
        } 
        // interface methods implemented by GetStepDescription
        string ITemplateWizardStep.GetStepDescription() { return GetStepDescription(); }
        
        
        
        public void LoadFields() { 
            // load fields
            XmlDocument formXML = new XmlDocument(); 
            formXML.Load( Functions.GetMetadataPath() + @"\" + ClassName.Split( '.' )[ 0 ] + @"\" + ClassName.Split( '.' )[ 1 ] + @"\forms\default.config" ); 
            XmlNode fieldNode = null; 
            
            this.lstFields.Items.Add( new ListItem( ResMan.GetString( "TemplateWizard_NodeName.UseNodeName" ), "" ) ); 
            foreach ( System.Xml.XmlNode transTemp0 in formXML.SelectNodes( "/form/field[@visible='true']" ) ) { 
                fieldNode = transTemp0;  
                this.lstFields.Items.Add( new ListItem( fieldNode.Attributes[ "column" ].Value, fieldNode.Attributes[ "column" ].Value ) ); 
            }
        } 
        
        
        
        public string ClassName { 
            get { 
                return System.Convert.ToString( ViewState[ "ClassName" ] ); 
            } 
            set { 
                ViewState[ "ClassName" ] = value; 
            } 
        } 
        
        
        private void chkUseVersioning_CheckedChanged( System.Object sender, System.EventArgs e ) { 
            if ( this.chkUseVersioning.Checked == true ) { 
                this.drpWorkflow.Enabled = true; 
            } 
            else { 
                this.drpWorkflow.Enabled = false; 
            } 
        } 
        
        
        
        private void LoadWorkflows( int selectedWorkflowId ) { 
            DataSet workflowsDS = null; 
            DataRow workflowDR = null; 
            GeneralConnection cn = Functions.GetTreeProvider().Connection; 
            
            workflowsDS = cn.ExecuteQuery( "cms.workflow.selectall", null, "", "WorkflowDisplayName" ); 
            drpWorkflow.Items.Clear(); 
            foreach ( System.Data.DataRow transTemp1 in workflowsDS.Tables[ 0 ].Rows ) { 
                workflowDR = transTemp1;  
                drpWorkflow.Items.Add( new ListItem( System.Convert.ToString( workflowDR[ "WorkflowDisplayName" ] ), System.Convert.ToInt32( workflowDR[ "WorkflowID" ] ).ToString() ) ); 
                if ( ( selectedWorkflowId == System.Convert.ToInt32( workflowDR[ "WorkflowID" ] ) ) | ( selectedWorkflowId == 0 & System.Convert.ToString( workflowDR[ "WorkflowName" ] ).ToLower().Trim() == "default" ) ) { 
                    drpWorkflow.SelectedIndex = drpWorkflow.Items.Count - 1; 
                } 
            }
        } 
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
