using Kentico.CMS.DataEngine; 
using System.Xml; 
using Kentico.CMS.MetadataEngine; 
using System.Data.SqlClient; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class TemplateWizard_Table : System.Web.UI.UserControl, ITemplateWizardStep
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
     { 
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblError; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.RadioButton radCustom; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.RadioButton radContainer; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblTableName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblPKName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtTableName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtPKName; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            lblError.Text = ""; 
            this.radContainer.Text = ResMan.GetString( "TemplateWizard_Table.Container" ); 
            this.radCustom.Text = ResMan.GetString( "TemplateWizard_Table.Custom" ); 
            this.lblTableName.Text = ResMan.GetString( "TemplateWizard_Table.TableName" ); 
            this.lblPKName.Text = ResMan.GetString( "TemplateWizard_Table.PKName" ); 
        } 
        
        
        
        public bool IsValid() { 
            int i = 0; 
            const string INVALIDCHARACTERS = @".,;'`:/\*|?""&%$!-+=()[]{} "; 
            string errorMessage = null; 
            
            if ( this.radCustom.Checked ) { 
                txtTableName.Text = txtTableName.Text.Trim(); 
                txtPKName.Text = txtPKName.Text.Trim(); 
                // check for empty values
                if ( this.txtTableName.Text + "" == "" ) { 
                    errorMessage += ResMan.GetString( "TemplateWizard_Table.ErrorEmptyTableName" ) + " "; 
                } 
                for ( i=0; i<=INVALIDCHARACTERS.Length - 1; i++ ) { 
                    if ( Strings.InStr( this.txtTableName.Text, "" + INVALIDCHARACTERS[ i ], (Microsoft.VisualBasic.CompareMethod)(0) ) > 0 ) { 
                        errorMessage += ResMan.GetString( "TemplateWizard_Table.ErrorTableNameInvalidCharacter" ) + INVALIDCHARACTERS + ". "; 
                    } 
                } 
                for ( i=0; i<=INVALIDCHARACTERS.Length - 1; i++ ) { 
                    if ( Strings.InStr( this.txtPKName.Text, "" + INVALIDCHARACTERS[ i ], (Microsoft.VisualBasic.CompareMethod)(0) ) > 0 ) { 
                        errorMessage += ResMan.GetString( "TemplateWizard_Table.ErrorPKNameInvalidCharacter" ) + INVALIDCHARACTERS + ". "; 
                    } 
                } 
                if ( this.txtPKName.Text + "" == "" ) { 
                    errorMessage += ResMan.GetString( "TemplateWizard_Table.ErrorEmptyPKName" ) + " "; 
                } 
                if ( Strings.InStr( this.txtPKName.Text, " ", (Microsoft.VisualBasic.CompareMethod)(0) ) > 0 ) { 
                    errorMessage += ResMan.GetString( "TemplateWizard_Table.ErrorPKNameWithSpaces" ) + " "; 
                } 
                if ( errorMessage + "" != "" ) { 
                    lblError.Text = errorMessage; 
                    return false; 
                } 
                // try to create the new table            
                try { 
                    string query = null; 
                    string owner = ""; 
                    // use owner if specified
                    if ( ConfigurationSettings.AppSettings[ "CMSDBObjectOwner" ] + "" + "" != "" ) { 
                        owner = "[" + Strings.Trim( ConfigurationSettings.AppSettings[ "CMSDBObjectOwner" ] ) + "]."; 
                    } 
                    query = "  CREATE TABLE " + owner + "[" + this.txtTableName.Text + "] ([" + this.txtPKName.Text + "] [int] IDENTITY (1, 1) NOT NULL, "; 
                    query += " CONSTRAINT [PK_" + this.txtTableName.Text + "] PRIMARY KEY CLUSTERED ([" + this.txtPKName.Text + "])) "; 
                    GeneralConnection cn = new GeneralConnection( Functions.GetConnectionString() ); 
                    cn.DataConnection.ExecuteQuery( query, null, Kentico.CMS.MetadataEngine.MetadataQueryTypeEnum.SQLQuery ); 
                } 
                catch ( Exception ex ) { 
                    this.lblError.Text = ResMan.GetString( "TemplateWizard_Table.ErrorCreateTable" ) + " " + ex.Message; 
                    return false; 
                } 
                
                // update settings.config
                MetadataProvider.SetSettingsValue( ClassName, "tablename", this.txtTableName.Text ); 
                
                // generate schema.config      
                SaveXMLSchema(); 
                
                // create forms and transformations folder
                Functions.EnsureDiskPath( Functions.GetMetadataPath() + @"\" + this.ClassName.Split( '.' )[ 0 ] + @"\" + this.ClassName.Split( '.' )[ 1 ] + @"\Forms\config.config", Functions.GetMetadataPath() ); 
                Functions.EnsureDiskPath( Functions.GetMetadataPath() + @"\" + this.ClassName.Split( '.' )[ 0 ] + @"\" + this.ClassName.Split( '.' )[ 1 ] + @"\Transformations\config.config", Functions.GetMetadataPath() ); 
                return true; 
            } 
            else { 
                // set IsCoupledClass = false
                GeneralConnection cn = new GeneralConnection( Functions.GetConnectionString() ); 
                DataClass classObj = new DataClass( "cms.class", this.ClassID, cn ); 
                classObj.SetValue( "IsCoupledClass", false ); 
                classObj.Update(); 
                // skip step 3            
                ( ( TemplateWizard )( Page ) ).CurrentStep = 4; 
            } 
            return true; 
        } 
        // interface methods implemented by IsValid
        bool ITemplateWizardStep.IsValid() { return IsValid(); }
        
        
        
        public string GetStepHeader() { 
            return ResMan.GetString( "TemplateWizard_Table.StepHeader" ); 
        } 
        // interface methods implemented by GetStepHeader
        string ITemplateWizardStep.GetStepHeader() { return GetStepHeader(); }
        
        
        
        public string GetStepDescription() { 
            return ResMan.GetString( "TemplateWizard_Table.StepDescription" ); 
        } 
        // interface methods implemented by GetStepDescription
        string ITemplateWizardStep.GetStepDescription() { return GetStepDescription(); }
        
        
        
        public string ClassName { 
            get { 
                return System.Convert.ToString( ViewState[ "ClassName" ] ); 
            } 
            set { 
                ViewState[ "ClassName" ] = value; 
                this.txtTableName.Text = value.Split( '.' )[ 0 ] + "_" + value.Split( '.' )[ 1 ]; 
                this.txtPKName.Text = Strings.Replace( ( ( TemplateWizard )( this.Page ) ).ClassName + "", " ", "_", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ).Split( '.' )[ 1 ] + "ID"; 
            } 
        } 
        
        
        public int ClassID { 
            get { 
                return System.Convert.ToInt32( ViewState[ "ClassID" ] ); 
            } 
            set { 
                ViewState[ "ClassID" ] = value; 
            } 
        } 
        
        
        private void SaveXMLSchema() { 
            string tableName = null; 
            string className = null; 
            
            tableName = this.txtTableName.Text.Trim(); 
            className = this.ClassName; 
            // getting XML Schema
            SqlConnection cn = new SqlConnection( Functions.GetConnectionString() ); 
            SqlDataAdapter da = new SqlDataAdapter( "select top 1 * from " + tableName + " order by 1 ", cn ); 
            DataSet ds = new DataSet(); 
            da.FillSchema( ds, SchemaType.Mapped, className ); 
            MetadataProvider.SetXMLSchema( className, Strings.Replace( ds.GetXmlSchema() + "", "utf-16", "utf-8", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) ); 
        } 
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
