using System.Xml; 
using System.IO; 
using Kentico.CMS.MetadataEngine; 
using Kentico.DirectoryUtilities; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class TransformationEdit : System.Web.UI.Page { 
        
        private string transformationName; 
        private string transformationPath; 
        private string className; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnUseDefault; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblTransformationType; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.RadioButton radioXSLTTransformation; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.RadioButton radioASCXTransformation; 
        private int classID; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by btnOK_Click
             
            btnOK.Click += new System.EventHandler( btnOK_Click ); 
            // events handled by btnCancel_Click
             
            btnCancel.Click += new System.EventHandler( btnCancel_Click ); 
            // events handled by btnUseDefault_Click
             
            btnUseDefault.Click += new System.EventHandler( btnUseDefault_Click ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblError; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblInfo; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnOK; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnCancel; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblTransformationName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtTransformationName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblTransformationText; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtTransformation; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Read" ); 
                return; 
            } 
            
            if ( "" + Request.QueryString[ "transformation" ] + "" != "" ) { 
                transformationName = "" + Request.QueryString[ "transformation" ].Split( '.' )[ 2 ]; 
                transformationPath = Functions.GetMetadataPath() + @"\" + "" + Request.QueryString[ "transformation" ].Split( '.' )[ 0 ] + @"\" + "" + Request.QueryString[ "transformation" ].Split( '.' )[ 1 ] + @"\transformations\" + "" + Request.QueryString[ "transformation" ].Split( '.' )[ 2 ]; 
                if ( File.Exists( transformationPath + ".ascx" ) ) { 
                    transformationPath += ".ascx"; 
                    this.radioASCXTransformation.Checked = true; 
                } 
                else { 
                    transformationPath += ".config"; 
                    this.radioXSLTTransformation.Checked = true; 
                } 
                ViewState[ "mode" ] = "modify"; 
                className = "" + Request.QueryString[ "transformation" ].Split( '.' )[ 0 ] + "." + "" + Request.QueryString[ "transformation" ].Split( '.' )[ 1 ]; 
                classID = int.Parse( System.Convert.ToString( Kentico.CMS.TreeEngine.ClassInformationProvider.GetClassRow( className, Functions.GetTreeProvider() )[ "ClassID" ] ) ); 
            } 
            else if ( "" + Request.QueryString[ "classid" ] + "" != "" ) { 
                if ( System.Convert.ToString( ViewState[ "mode" ] ) + "" == "" ) { 
                    ViewState[ "mode" ] = "create"; 
                } 
                transformationName = ""; 
                transformationPath = ""; 
                classID = int.Parse( "" + Request.QueryString[ "classid" ] ); 
                className = System.Convert.ToString( Kentico.CMS.TreeEngine.ClassInformationProvider.GetClassRow( classID, Functions.GetTreeProvider() )[ ( ( "ClassName" ) ) ] ); 
            } 
            if ( !( Page.IsPostBack ) ) { 
                ViewState[ "originalTransformationName" ] = transformationName; 
            } 
            lblError.Text = ""; 
            lblInfo.Text = ""; 
            lblHeader.Text = ResMan.GetString( "TransformationEdit.Header" ); 
            lblTransformationName.Text = ResMan.GetString( "TransformationEdit.TransformationName" ); 
            lblTransformationText.Text = ResMan.GetString( "TransformationEdit.TransformationText" ); 
            lblTransformationType.Text = ResMan.GetString( "TransformationEdit.TransformationType" ); 
            radioXSLTTransformation.Text = ResMan.GetString( "TransformationEdit.XSLTTransformation" ); 
            radioASCXTransformation.Text = ResMan.GetString( "TransformationEdit.ASCXTransformation" ); 
            btnUseDefault.Text = ResMan.GetString( "TransformationEdit.UseDefault" ); 
            btnOK.Text = ResMan.GetString( "TransformationEdit.OK" ); 
            btnCancel.Text = ResMan.GetString( "TransformationEdit.Cancel" ); 
            radioXSLTTransformation.Enabled = false; 
            radioASCXTransformation.Enabled = false; 
            
            if ( !( Page.IsPostBack ) & ( System.Convert.ToString( ViewState[ "mode" ] ) == "modify" ) ) { 
                if ( this.radioXSLTTransformation.Checked ) { 
                    XmlDocument xml = new XmlDocument(); 
                    xml.Load( transformationPath ); 
                    txtTransformation.Text = xml.OuterXml.ToString(); 
                    txtTransformationName.Text = transformationName; 
                } 
                else { 
                    TextReader txt = new StreamReader( transformationPath ); 
                    txtTransformation.Text = txt.ReadToEnd(); 
                    txt.Close(); 
                    txtTransformationName.Text = transformationName; 
                } 
            } 
            if ( System.Convert.ToString( ViewState[ "mode" ] ) == "create" ) { 
                radioXSLTTransformation.Enabled = true; 
                radioASCXTransformation.Enabled = true; 
                if ( !( Page.IsPostBack ) ) { 
                    if ( radioXSLTTransformation.Checked ) { 
                        this.txtTransformation.Text = TransformationGenerator.GetXSLTransformation( className + ".default" ).OuterXml; 
                    } 
                    else { 
                        this.txtTransformation.Text = TransformationGenerator.GetASCXTransformation( className + ".default" ); 
                    } 
                } 
            } 
        } 
        
        
        
        private void btnOK_Click( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( System.Convert.ToString( ViewState[ "mode" ] ) == "create" ) { 
                if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Create" ) ) ) { 
                    Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Create" ); 
                    return; 
                } 
            } 
            else { 
                if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Modify" ) ) ) { 
                    Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Modify" ); 
                    return; 
                } 
            } 
            
            // validate input
            string errorMessage = ""; 
            XmlDocument xml = null; 
            TextWriter txt = null; 
            
            if ( txtTransformationName.Text.Trim() + "" == "" ) { 
                errorMessage += ResMan.GetString( "TransformationEdit.ErrorEmptyTransformationName" ) + " "; 
            } 
            if ( txtTransformation.Text.Trim() + "" == "" ) { 
                errorMessage += ResMan.GetString( "TransformationEdit.ErrorEmptyTransformation" ) + " "; 
            } 
            else { 
                if ( this.radioXSLTTransformation.Checked ) { 
                    xml = new XmlDocument(); 
                    try { 
                        xml.LoadXml( txtTransformation.Text ); 
                    } 
                    catch ( Exception ex ) { 
                        errorMessage += ResMan.GetString( "TransformationEdit.ErrorDocumentNotValid" ); 
                    } 
                } 
            } 
            if ( errorMessage + "" != "" ) { 
                lblError.Text = errorMessage; 
            } 
            // save
            if ( errorMessage + "" == "" ) { 
                string parentPath = null; 
                parentPath = Functions.GetMetadataPath() + @"\" + className.Split( '.' )[ 0 ] + @"\" + className.Split( '.' )[ 1 ] + @"\Transformations"; 
                if ( System.Convert.ToString( ViewState[ "mode" ] ) == "create" ) { 
                    // create new                                
                    if ( !( Directory.Exists( parentPath ) ) ) { 
                        DirectoryHelper.CreateDirectory( parentPath ); 
                    } 
                    if ( this.radioXSLTTransformation.Checked ) { 
                        xml.Save( parentPath + @"\" + this.txtTransformationName.Text + ".config" ); 
                    } 
                    else { 
                        txt = new StreamWriter( parentPath + @"\" + this.txtTransformationName.Text + ".ascx" ); 
                        txt.Write( this.txtTransformation.Text ); 
                        txt.Close(); 
                    } 
                    ViewState[ "originalTransformationName" ] = this.txtTransformationName.Text; 
                    ViewState[ "mode" ] = "modify"; 
                } 
                else { 
                    // modify existing                
                    if ( System.Convert.ToString( ViewState[ "originalTransformationName" ] ) != this.txtTransformationName.Text ) { 
                        if ( this.radioXSLTTransformation.Checked ) { 
                            File.Move( parentPath + @"\" + System.Convert.ToString( ViewState[ "originalTransformationName" ] ) + ".config", parentPath + @"\" + this.txtTransformationName.Text + ".config" ); 
                        } 
                        else { 
                            File.Move( parentPath + @"\" + System.Convert.ToString( ViewState[ "originalTransformationName" ] ) + ".ascx", parentPath + @"\" + this.txtTransformationName.Text + ".ascx" ); 
                        } 
                        ViewState[ "originalTransformationName" ] = this.txtTransformationName.Text; 
                    } 
                    if ( this.radioXSLTTransformation.Checked ) { 
                        xml.Save( parentPath + @"\" + this.txtTransformationName.Text + ".config" ); 
                    } 
                    else { 
                        txt = new StreamWriter( parentPath + @"\" + this.txtTransformationName.Text + ".ascx" ); 
                        txt.Write( this.txtTransformation.Text ); 
                        txt.Close(); 
                    } 
                } 
                // update metadata
                Kentico.CMS.MetadataEngine.MetadataProvider.ClearMetadata(); 
                radioXSLTTransformation.Enabled = false; 
                radioASCXTransformation.Enabled = false; 
                lblInfo.Text = ResMan.GetString( "TransformationEdit.ChangesSaved" ); 
            } 
        } 
        
        
        
        private void btnCancel_Click( System.Object sender, System.EventArgs e ) { 
            // redirects user back to the list of resources        
            ltlScript.Text = @"<script language=""javascript"">"; 
            ltlScript.Text += " Cancel('" + classID + "'); "; 
            ltlScript.Text += "</script>"; 
        } 
        
        
        private void btnUseDefault_Click( System.Object sender, System.EventArgs e ) { 
            if ( radioXSLTTransformation.Checked ) { 
                this.txtTransformation.Text = TransformationGenerator.GetXSLTransformation( className + ".default" ).OuterXml; 
            } 
            else { 
                this.txtTransformation.Text = TransformationGenerator.GetASCXTransformation( className + ".default" ); 
            } 
        } 
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
