using System.IO; 
using Kentico.DirectoryUtilities; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class TransformationList : System.Web.UI.Page { 
        
        protected string editHint; 
        protected string deleteHint; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by Grid1_ItemDataBound
             
            Grid1.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler( Grid1_ItemDataBound ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlConfirmScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        protected /* TRANSINFO: WithEvents */ Kentico.CMS.CMSControls.BasicDataGrid Grid1; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Read" ); 
                return; 
            } 
            
            editHint = ResMan.GetString( "TransformationList.EditHint" ); 
            deleteHint = ResMan.GetString( "TransformationList.DeleteHint" ); 
            // set column header names
            Grid1.Columns[ 0 ].HeaderText = ResMan.GetString( "TransformationList.Action" ); 
            Grid1.Columns[ 1 ].HeaderText = ResMan.GetString( "TransformationList.TransformationName" ); 
            Grid1.Columns[ 2 ].HeaderText = ResMan.GetString( "TransformationList.TransformationType" ); 
            
            // confirmation question
            ltlConfirmScript.Text = @"<input type=""hidden"" id=""confirmationText"" value=""" + ResMan.GetString( "TransformationList.ConfirmDelete" ) + @""">"; 
            lblHeader.Text = ResMan.GetString( "TransformationList.Header" ); 
            
            if ( !( Page.IsPostBack ) ) { 
                DisplayTransformations(); 
            } 
        } 
        
        
        
        public void DeleteItem( object sender, System.Web.UI.WebControls.DataGridCommandEventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Delete" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Delete" ); 
                return; 
            } 
            
            // delete transformation
            string transformationFullName = null; 
            transformationFullName = System.Convert.ToString( e.CommandArgument ); 
            string transformationFileName = Functions.GetMetadataPath() + @"\" + transformationFullName.Split( '.' )[ 0 ] + @"\" + transformationFullName.Split( '.' )[ 1 ] + @"\transformations\" + transformationFullName.Split( '.' )[ 2 ]; 
            if ( File.Exists( transformationFileName + ".config" ) ) { File.Delete( transformationFileName + ".config" ); } 
            if ( File.Exists( transformationFileName + ".ascx" ) ) { File.Delete( transformationFileName + ".ascx" ); } 
            
            Kentico.CMS.MetadataEngine.MetadataProvider.ClearMetadata(); 
            
            ltlScript.Text = @"<script language=""javascript"">"; 
            ltlScript.Text += " Reload(); "; 
            ltlScript.Text += "</script>"; 
        } 
        
        
        
        private void DisplayTransformations() { 
            int classID = 0; 
            string className = null; 
            string transformationsDirPath = null; 
            DirectoryInfo transformationsDirectory = null; 
            FileInfo[] transformations = null; 
            string transformationName = null; 
            int i = 0; 
            DataSet ds = new DataSet(); 
            DataRow dr = null; 
            
            classID = int.Parse( "" + Request.QueryString[ "classid" ] ); 
            className = System.Convert.ToString( Kentico.CMS.TreeEngine.ClassInformationProvider.GetClassRow( classID, Functions.GetTreeProvider() )[ ( ( "ClassName" ) ) ] ); 
            // read transformations            
            transformationsDirPath = Functions.GetMetadataPath() + @"\" + className.Split( '.' )[ 0 ] + @"\" + className.Split( '.' )[ 1 ] + @"\Transformations"; 
            if ( !( Directory.Exists( transformationsDirPath ) ) ) { 
                DirectoryHelper.CreateDirectory( transformationsDirPath ); 
            } 
            transformationsDirectory = new DirectoryInfo( transformationsDirPath ); 
            transformations = transformationsDirectory.GetFiles(); 
            // prepare dataset
            ds.Tables.Add( new DataTable() ); 
            ds.Tables[ 0 ].Columns.Add( new DataColumn( "TransformationFullName" ) ); 
            ds.Tables[ 0 ].Columns.Add( new DataColumn( "TransformationName" ) ); 
            ds.Tables[ 0 ].Columns.Add( new DataColumn( "TransformationType" ) ); 
            // fill dataset
            for ( i=transformations.GetLowerBound( 0 ); i<=transformations.GetUpperBound( 0 ); i++ ) { 
                if ( transformations[ i ].Name.EndsWith( ".config" ) ) { 
                    transformationName = Strings.Replace( transformations[ i ].Name + "", ".config", "", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ); 
                    dr = ds.Tables[ 0 ].NewRow(); 
                    dr[ "TransformationFullName" ] = className + "." + transformationName; 
                    dr[ "TransformationName" ] = transformationName; 
                    dr[ "TransformationType" ] = ResMan.GetString( "TransformationList.XSLTTransformation" ); 
                    ds.Tables[ 0 ].Rows.Add( dr ); 
                } 
                else if ( transformations[ i ].Name.EndsWith( ".ascx" ) ) { 
                    transformationName = Strings.Replace( transformations[ i ].Name + "", ".ascx", "", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ); 
                    dr = ds.Tables[ 0 ].NewRow(); 
                    dr[ "TransformationFullName" ] = className + "." + transformationName; 
                    dr[ "TransformationName" ] = transformationName; 
                    dr[ "TransformationType" ] = ResMan.GetString( "TransformationList.ASCXTransformation" ); 
                    ds.Tables[ 0 ].Rows.Add( dr ); 
                } 
            } 
            // bind data
            Grid1.DataSource = ds; 
        } 
        
        
        
        private void Grid1_ItemDataBound( System.Object sender, DataGridItemEventArgs e ) { 
            ImageButton btnCurrentButton = null; 
            
            // set up the Delete button
            if ( e.Item.ItemType == ListItemType.Item | e.Item.ItemType == ListItemType.AlternatingItem ) { 
                btnCurrentButton = ( ( ImageButton )( e.Item.Cells[ 0 ].FindControl( "btnDelete" ) ) ); 
                btnCurrentButton.Attributes.Add( "OnClick", "return ConfirmDelete();" ); 
                btnCurrentButton.Attributes.Add( "title", deleteHint ); 
            } 
        } 
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
