using Kentico.CMS.TreeEngine; 
using Kentico.CMS.DataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class WorkflowDesigner : System.Web.UI.UserControl { 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by lstSteps_SelectedIndexChanged
             
            lstSteps.SelectedIndexChanged += new System.EventHandler( lstSteps_SelectedIndexChanged ); 
            // events handled by btnOK_Click
             
            btnOK.Click += new System.EventHandler( btnOK_Click ); 
            // events handled by btnNewStep_Click
             
            btnNewStep.Click += new System.Web.UI.ImageClickEventHandler( btnNewStep_Click ); 
            // events handled by btnDeleteStep_Click
             
            btnDeleteStep.Click += new System.Web.UI.ImageClickEventHandler( btnDeleteStep_Click ); 
            // events handled by btnUpStep_Click
             
            btnUpStep.Click += new System.Web.UI.ImageClickEventHandler( btnUpStep_Click ); 
            // events handled by btnDownStep_Click
             
            btnDownStep.Click += new System.Web.UI.ImageClickEventHandler( btnDownStep_Click ); 
            // events handled by btnUpdate_Click
             
            btnUpdate.Click += new System.EventHandler( btnUpdate_Click ); 
            // events handled by btnRemoveRole_Click
             
            btnRemoveRole.Click += new System.Web.UI.ImageClickEventHandler( btnRemoveRole_Click ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblErrorMessage; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblInfo; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnOK; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlConfirmText; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblSteps; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.ListBox lstSteps; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.ImageButton btnUpStep; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.ImageButton btnDownStep; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.ImageButton btnNewStep; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.ImageButton btnDeleteStep; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblStepDisplayName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtStepDisplayName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblStepName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtStepName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblStepProperties; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblWorkflowSteps; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblStepEdit; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblStepPublished; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblAllowedRoles; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.ListBox lstAllowedRoles; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.ImageButton btnAddRole; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.ImageButton btnRemoveRole; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Panel pnlRoles; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtUpdate; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnUpdate; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Read" ); 
                return; 
            } 
            
            lblWorkflowSteps.Text = ResMan.GetString( "WorkflowDesigner.WorkflowSteps" ); 
            lblSteps.Text = ResMan.GetString( "WorkflowDesigner.Steps" ); 
            lblStepProperties.Text = ResMan.GetString( "WorkflowDesigner.StepProperties" ); 
            lblStepDisplayName.Text = ResMan.GetString( "WorkflowDesigner.StepDisplayName" ); 
            lblStepName.Text = ResMan.GetString( "WorkflowDesigner.StepName" ); 
            lblStepEdit.Text = ResMan.GetString( "WorkflowEdit.EditStepDisplayName" ); 
            lblStepPublished.Text = ResMan.GetString( "WorkflowEdit.PublishedStepDisplayName" ); 
            ltlConfirmText.Text = @"<span id=""confirmdelete"" style=""display:none"">" + ResMan.GetString( "WorkflowDesigner.ConfirmDelete" ) + "</span>"; 
            btnDeleteStep.Attributes.Add( "onclick", "javascript:return confirmDelete();" ); 
            btnOK.Text = ResMan.GetString( "WorkflowDesigner.OK" ); 
            btnDeleteStep.ToolTip = ResMan.GetString( "WorkflowDesigner.DeleteStep" ); 
            btnNewStep.ToolTip = ResMan.GetString( "WorkflowDesigner.NewStep" ); 
            btnUpStep.ToolTip = ResMan.GetString( "WorkflowDesigner.StepUp" ); 
            btnDownStep.ToolTip = ResMan.GetString( "WorkflowDesigner.StepDown" ); 
            lblAllowedRoles.Text = ResMan.GetString( "WorkflowDesigner.AllowedRoles" ); 
            btnAddRole.ToolTip = ResMan.GetString( "WorkflowDesigner.AddRole" ); 
            btnRemoveRole.ToolTip = ResMan.GetString( "WorkflowDesigner.RemoveRole" ); 
            
            lblErrorMessage.Text = ""; 
            ltlScript.Text = ""; 
            lblInfo.Text = ""; 
            
            txtUpdate.Attributes.Add( "onpropertychange", Page.GetPostBackEventReference( btnUpdate ) ); 
            
            if ( ViewState[ "StepID" ] == null ) { 
                ViewState[ "StepID" ] = 0; 
            } 
            
            // load steps
            if ( !( Page.IsPostBack ) & WorkflowID != 0 ) { 
                ReloadSteps(); 
            } 
            this.btnAddRole.Attributes.Add( "onclick", "javascript:AddRole();" ); 
        } 
        
        
        
        public int WorkflowID { 
            get { 
                if ( ViewState[ "WorkflowID" ] == null ) { 
                    ViewState[ "WorkflowID" ] = 0; 
                } 
                return System.Convert.ToInt32( ViewState[ "WorkflowID" ] ); 
            } 
            set { 
                ViewState[ "WorkflowID" ] = value; 
            } 
        } 
        
        
        private void lstSteps_SelectedIndexChanged( System.Object sender, System.EventArgs e ) { 
            LoadSelectedStep(); 
        } 
        
        
        
        private void btnOK_Click( System.Object sender, System.EventArgs e ) { 
            DataClass stepObj = null; 
            int stepID = 0; 
            string errorMessage = null; 
            GeneralConnection cn = Functions.GetTreeProvider().Connection; 
            
            if ( ( !( ViewState[ "StepID" ] == null ) ) ) { 
                stepID = System.Convert.ToInt32( ViewState[ "StepID" ] ); 
            } 
            else { 
                stepID = 0; 
            } 
            
            // check permissions
            if ( stepID == 0 && !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Create" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Create" ); 
                return; 
            } 
            // check permissions
            if ( stepID != 0 && !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Modify" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Create" ); 
                return; 
            } 
            
            this.txtStepName.Text = this.txtStepName.Text.Trim(); 
            this.txtStepDisplayName.Text = this.txtStepDisplayName.Text.Trim(); 
            // validate
            if ( this.txtStepName.Text + "" == "" ) { 
                errorMessage += ResMan.GetString( "WorkflowDesigner.ErrorEmptyStepName" ); 
            } 
            if ( this.txtStepDisplayName.Text + "" == "" ) { 
                errorMessage += ResMan.GetString( "WorkflowDesigner.ErrorEmptyStepDisplayName" ); 
            } 
            if ( this.txtStepName.Text.ToLower() == "edit" ) { 
                errorMessage += ResMan.GetString( "WorkflowDesigner.ErrorStepNameEdit" ); 
            } 
            if ( this.txtStepName.Text.ToLower() == "published" ) { 
                errorMessage += ResMan.GetString( "WorkflowDesigner.ErrorStepNamePublished" ); 
            } 
            // check if the step name is unique
            if ( errorMessage + "" == "" ) { 
                DataSet stepNamesDS = cn.ExecuteQuery( "CMS.WorkflowStep.selectworkflowsteps", null, " StepName = '" + this.txtStepName.Text.Replace( "'", "''" ) + "' AND WorkflowID = " + this.WorkflowID ); 
                DataRow stepNameDR = null; 
                if ( stepID == 0 ) { 
                    if ( stepNamesDS.Tables[ 0 ].Rows.Count > 0 ) { 
                        // step name already exists
                        errorMessage += ResMan.GetString( "WorkflowDesigner.ErrorExistingStepName" ) + " "; 
                    } 
                } 
                else { 
                    foreach ( System.Data.DataRow transTemp0 in stepNamesDS.Tables[ 0 ].Rows ) { 
                        stepNameDR = transTemp0;  
                        if ( System.Convert.ToInt32( stepNameDR[ "StepID" ] ) != stepID ) { 
                            // class name already exists
                            errorMessage += ResMan.GetString( "WorkflowDesigner.ErrorExistingStepName" ) + " "; 
                        } 
                    }
                } 
            } 
            
            if ( errorMessage + "" != "" ) { 
                this.lblErrorMessage.Text = errorMessage; 
                return; 
            } 
            else { 
                if ( ( !( ViewState[ "StepID" ] == null ) ) && System.Convert.ToInt32( ViewState[ "StepID" ] ) != 0 ) { 
                    // update
                    stepObj = new DataClass( "cms.workflowstep", System.Convert.ToInt32( ViewState[ "StepID" ] ), Functions.GetTreeProvider().Connection ); 
                    stepObj.SetValue( "StepDisplayName", this.txtStepDisplayName.Text ); 
                    stepObj.SetValue( "StepName", this.txtStepName.Text ); 
                    stepObj.Update(); 
                } 
                else { 
                    // insert
                    // get the "published" step
                    object[,] paramsIdent = new object[ 1, 3 ]; 
                    paramsIdent[ 0, 0 ] = "@WorkflowID"; 
                    paramsIdent[ 0, 1 ] = this.WorkflowID; 
                    int publishedStepID = System.Convert.ToInt32( cn.ExecuteQuery( "cms.workflowstep.selectpublishedstep", paramsIdent ).Tables[ 0 ].Rows[ 0 ][ "StepID" ] ); 
                    DataClass publishedStepObj = new DataClass( "cms.workflowstep", publishedStepID, cn ); 
                    
                    stepObj = new DataClass( "cms.workflowstep", Functions.GetTreeProvider().Connection ); 
                    stepObj.SetValue( "StepDisplayName", this.txtStepDisplayName.Text ); 
                    stepObj.SetValue( "StepName", this.txtStepName.Text ); 
                    stepObj.SetValue( "WorkflowID", this.WorkflowID ); 
                    
                    // set appropriate step order values and save changes
                    stepObj.SetValue( "StepOrder", publishedStepObj.GetValue( "StepOrder" ) ); 
                    publishedStepObj.SetValue( "StepOrder", System.Convert.ToInt32( publishedStepObj.GetValue( "StepOrder" ) ) + 1 ); 
                    
                    cn.DataConnection.Open(); 
                    cn.DataConnection.BeginTransaction(); 
                    try { 
                        publishedStepObj.Update(); 
                        stepObj.Insert(); 
                    } 
                    catch ( Exception exc ) { 
                        cn.DataConnection.RollbackTransaction(); 
                        cn.DataConnection.Close(); 
                        throw exc; 
                    } 
                    cn.DataConnection.CommitTransaction(); 
                    cn.DataConnection.Close(); 
                    
                    ViewState[ "StepID" ] = System.Convert.ToInt32( stepObj.GetValue( "StepID" ) ); 
                } 
                this.lblInfo.Text = ResMan.GetString( "WorkflowDesigner.ChangesSaved" ); 
                ReloadSteps(); 
            } 
        } 
        
        
        
        private void btnNewStep_Click( System.Object sender, System.Web.UI.ImageClickEventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Modify" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Modify" ); 
                return; 
            } 
            
            // first check if there's no other new step
            int i = 0; 
            for ( i=0; i<=lstSteps.Items.Count - 1; i++ ) { 
                if ( lstSteps.Items[ i ].Value == "0" ) { 
                    ShowMessage( ResMan.GetString( "WorkflowDesigner.ErrorCannotCreateAnotherNewAttribute" ) ); 
                    return; 
                } 
            } 
            
            ViewState[ "StepID" ] = 0; 
            this.txtStepName.Text = ""; 
            this.txtStepDisplayName.Text = ""; 
            this.lstSteps.Items.Add( new ListItem( ResMan.GetString( "WorkflowDesigner.NewItem" ), "0" ) ); 
            this.lstSteps.SelectedIndex = this.lstSteps.Items.Count - 1; 
            ReloadRoles(); 
        } 
        
        
        
        private void ReloadSteps() { 
            DataSet stepsDS = Functions.GetTreeProvider().Connection.ExecuteQuery( "cms.workflowstep.selectworkflowsteps", null, " stepname <> 'edit' and stepname <> 'published' and workflowid = " + WorkflowID ); 
            DataRow stepsDR = null; 
            bool stepSelected = false; 
            
            this.lstSteps.Items.Clear(); 
            foreach ( System.Data.DataRow transTemp1 in stepsDS.Tables[ 0 ].Rows ) { 
                stepsDR = transTemp1;  
                // add item to the list
                this.lstSteps.Items.Add( new ListItem( System.Convert.ToString( stepsDR[ "StepDisplayName" ] ), System.Convert.ToInt32( stepsDR[ "StepID" ] ).ToString() ) ); 
                // select current item
                if ( System.Convert.ToInt32( ViewState[ "StepID" ] ) == System.Convert.ToInt32( stepsDR[ "StepID" ] ) ) { 
                    this.lstSteps.SelectedValue = System.Convert.ToInt32( ViewState[ "StepID" ] ).ToString(); 
                    stepSelected = true; 
                } 
            }
            if ( !( stepSelected ) ) { 
                // select the first step
                this.lstSteps.SelectedIndex = 0; 
                // load the first step
                LoadSelectedStep(); 
            } 
            if ( this.lstSteps.Items.Count == 0 ) { 
                ViewState[ "StepID" ] = 0; 
                this.txtStepName.Text = ""; 
                this.txtStepDisplayName.Text = ""; 
            } 
            ReloadRoles(); 
        } 
        
        
        
        private void LoadSelectedStep() { 
            if ( lstSteps.Items.Count == 0 ) { 
                return; 
            } 
            int stepID = int.Parse( lstSteps.SelectedItem.Value.ToString() ); 
            DataClass stepObj = null; 
            
            ViewState[ "StepID" ] = stepID; 
            // load step data
            if ( stepID != 0 ) { 
                stepObj = new DataClass( "cms.workflowstep", stepID, Functions.GetTreeProvider().Connection ); 
                this.txtStepDisplayName.Text = System.Convert.ToString( stepObj.GetValue( "StepDisplayName" ) ); 
                this.txtStepName.Text = System.Convert.ToString( stepObj.GetValue( "StepName" ) ); 
            } 
            ReloadRoles(); 
        } 
        
        
        
        private void ShowMessage( string message ) { 
            this.ltlScript.Text = @"<script language=""javascript"">" + " alert('" + Strings.Replace( message, "'", @"\'", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + "'); " + "</script>"; 
        } 
        
        
        
        private void btnDeleteStep_Click( System.Object sender, System.Web.UI.ImageClickEventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Modify" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Modify" ); 
                return; 
            } 
            
            int stepID = int.Parse( this.lstSteps.SelectedValue ); 
            
            // check if there are nodes at this step
            GeneralConnection cn = Functions.GetTreeProvider().Connection; 
            object[,] selectParams = new object[ 1, 3 ]; 
            selectParams[ 0, 0 ] = "@stepid"; 
            selectParams[ 0, 1 ] = stepID; 
            DataSet stepNodesDS = cn.ExecuteQuery( "cms.workflowstep.nodescount", selectParams ); 
            if ( System.Convert.ToInt32( stepNodesDS.Tables[ 0 ].Rows[ 0 ][ 0 ] ) > 0 ) { 
                // display error message
                ShowMessage( ResMan.GetString( "WorkflowDesigner.ErrorStepIsCurrentlyUsed" ) ); 
                return; 
            } 
            
            // delete
            object[,] paramsIdent = new object[ 1, 3 ]; 
            paramsIdent[ 0, 0 ] = "@id"; 
            paramsIdent[ 0, 1 ] = stepID; 
            cn.ExecuteQuery( "cms.workflowstep.delete", paramsIdent ); 
            this.ReloadSteps(); 
        } 
        
        
        
        // move selected attribute up
        private void btnUpStep_Click( System.Object sender, System.Web.UI.ImageClickEventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Modify" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Modify" ); 
                return; 
            } 
            
            // check if current step is not the top one or if it's not the only one
            if ( lstSteps.Items.Count == 0 || lstSteps.SelectedIndex == 0 ) { 
                return; 
            } 
            
            // get data
            int stepID = int.Parse( lstSteps.SelectedValue ); 
            GeneralConnection cn = Functions.GetTreeProvider().Connection; 
            DataClass currentStepObj = new DataClass( "cms.workflowstep", stepID, cn ); 
            int currentStepOrder = System.Convert.ToInt32( currentStepObj.GetValue( "StepOrder" ) ); 
            DataClass upperStepObj = new DataClass( "cms.workflowstep", int.Parse( this.lstSteps.Items[ this.lstSteps.SelectedIndex - 1 ].Value ), cn ); 
            int upperStepOrder = System.Convert.ToInt32( upperStepObj.GetValue( "StepOrder" ) ); 
            
            // set new values
            currentStepObj.SetValue( "StepOrder", upperStepOrder ); 
            upperStepObj.SetValue( "StepOrder", currentStepOrder ); 
            
            // save new values
            cn.DataConnection.Open(); 
            cn.DataConnection.BeginTransaction(); 
            try { 
                currentStepObj.Update(); 
                upperStepObj.Update(); 
            } 
            catch ( Exception exc ) { 
                cn.DataConnection.RollbackTransaction(); 
                cn.DataConnection.Close(); 
                throw exc; 
            } 
            cn.DataConnection.CommitTransaction(); 
            cn.DataConnection.Close(); 
            
            // reload data
            this.ReloadSteps(); 
        } 
        
        
        
        private void btnDownStep_Click( System.Object sender, System.Web.UI.ImageClickEventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Modify" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Modify" ); 
                return; 
            } 
            
            // check if current step is not the top one or if it's not the only one
            if ( lstSteps.Items.Count == 0 || lstSteps.SelectedIndex == lstSteps.Items.Count - 1 ) { 
                return; 
            } 
            
            // get data
            int stepID = int.Parse( lstSteps.SelectedValue ); 
            GeneralConnection cn = Functions.GetTreeProvider().Connection; 
            DataClass currentStepObj = new DataClass( "cms.workflowstep", stepID, cn ); 
            int currentStepOrder = System.Convert.ToInt32( currentStepObj.GetValue( "StepOrder" ) ); 
            DataClass lowerStepObj = new DataClass( "cms.workflowstep", int.Parse( this.lstSteps.Items[ this.lstSteps.SelectedIndex + 1 ].Value ), cn ); 
            int lowerStepOrder = System.Convert.ToInt32( lowerStepObj.GetValue( "StepOrder" ) ); 
            
            // set new values
            currentStepObj.SetValue( "StepOrder", lowerStepOrder ); 
            lowerStepObj.SetValue( "StepOrder", currentStepOrder ); 
            
            // save new values
            cn.DataConnection.Open(); 
            cn.DataConnection.BeginTransaction(); 
            try { 
                currentStepObj.Update(); 
                lowerStepObj.Update(); 
            } 
            catch ( Exception exc ) { 
                cn.DataConnection.RollbackTransaction(); 
                cn.DataConnection.Close(); 
                throw exc; 
            } 
            cn.DataConnection.CommitTransaction(); 
            cn.DataConnection.Close(); 
            
            // reload data
            this.ReloadSteps(); 
        } 
        
        
        
        private void ReloadRoles() { 
            if ( System.Convert.ToInt32( ViewState[ "StepID" ] ) == 0 ) { 
                pnlRoles.Enabled = false; 
                this.btnAddRole.Attributes.Add( "onclick", "javascript:alert('" + ResMan.GetString( "WorkflowDesigner.SaveStepBeforeAddRole" ) + "');" ); 
                lstAllowedRoles.Items.Clear(); 
                return; 
            } 
            
            pnlRoles.Enabled = true; 
            this.btnAddRole.Attributes.Add( "onclick", "javascript:AddRole();" ); 
            DataSet rolesDS = null; 
            GeneralConnection cn = Functions.GetTreeProvider().Connection; 
            object[,] paramsIdent = new object[ 1, 3 ]; 
            DataRow roleDR = null; 
            
            lstAllowedRoles.Items.Clear(); 
            paramsIdent[ 0, 0 ] = "@stepid"; 
            paramsIdent[ 0, 1 ] = System.Convert.ToInt32( ViewState[ "StepID" ] ); 
            rolesDS = cn.ExecuteQuery( "cms.workflowstep.selectsteproles", paramsIdent ); 
            foreach ( System.Data.DataRow transTemp2 in rolesDS.Tables[ 0 ].Rows ) { 
                roleDR = transTemp2;  
                lstAllowedRoles.Items.Add( new ListItem( System.Convert.ToString( roleDR[ "RoleDisplayName" ] ), System.Convert.ToString( roleDR[ "RoleID" ] ) ) ); 
            }
        } 
        
        
        private void btnUpdate_Click( System.Object sender, System.EventArgs e ) { 
            ReloadRoles(); 
        } 
        
        
        private void btnRemoveRole_Click( System.Object sender, System.Web.UI.ImageClickEventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Modify" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Modify" ); 
                return; 
            } 
            
            GeneralConnection cn = Functions.GetTreeProvider().Connection; 
            
            ListItem itm = null; 
            object[,] paramsIdent = new object[ 2, 3 ]; 
            paramsIdent[ 0, 0 ] = "@stepid"; 
            paramsIdent[ 0, 1 ] = System.Convert.ToInt32( ViewState[ "StepID" ] ); 
            paramsIdent[ 1, 0 ] = "@roleid"; 
            foreach ( System.Web.UI.WebControls.ListItem transTemp3 in this.lstAllowedRoles.Items ) { 
                itm = transTemp3;  
                if ( itm.Selected ) { 
                    paramsIdent[ 1, 1 ] = itm.Value; 
                    cn.ExecuteQuery( "cms.workflowstep.removerole", paramsIdent ); 
                } 
            }
            ReloadRoles(); 
        } 
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
