using Kentico.CMS.DataEngine; 
using Kentico.CMS.MetadataEngine; 
using Kentico.CMS.TreeEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class WorkflowEdit : System.Web.UI.Page { 
        
        protected int WorkflowID; 
        protected /* TRANSINFO: WithEvents */ WorkflowDesigner WorkflowDesigner1; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by btnCancel_Click
             
            btnCancel.Click += new System.EventHandler( btnCancel_Click ); 
            // events handled by btnOK_Click
             
            btnOK.Click += new System.EventHandler( btnOK_Click ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblError; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblInfo; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnOK; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnCancel; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblWorkflowID; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblWorkflowIDValue; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblWorkflowDisplayName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtWorkflowDisplayName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblWorkflowName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtWorkflowName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Panel pnlSteps; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Read" ); 
                return; 
            } 
            
            Functions.RedirectExpressEdition( "CMSDesk.WorkflowEdit" ); 
            
            GeneralConnection cn = null; 
            DataClass workflowObj = null; 
            
            if ( ViewState[ "WorkflowID" ] == null ) { 
                if ( ( "" + Request.QueryString[ "id" ] + "" ).Trim() + "" == "" ) { 
                    ViewState[ "WorkflowID" ] = 0; 
                } 
                else { 
                    ViewState[ "WorkflowID" ] = int.Parse( "" + Request.QueryString[ "id" ] ); 
                } 
            } 
            WorkflowID = int.Parse( System.Convert.ToString( ViewState[ "WorkflowID" ] ) ); 
            WorkflowDesigner1.WorkflowID = WorkflowID; 
            
            lblError.Text = ""; 
            lblInfo.Text = ""; 
            lblHeader.Text = ResMan.GetString( "WorkflowEdit.Header" ); 
            lblWorkflowID.Text = ResMan.GetString( "WorkflowEdit.WorkflowID" ); 
            lblWorkflowName.Text = ResMan.GetString( "WorkflowEdit.WorkflowName" ); 
            lblWorkflowDisplayName.Text = ResMan.GetString( "WorkflowEdit.WorkflowDisplayName" ); 
            btnOK.Text = ResMan.GetString( "WorkflowEdit.OK" ); 
            btnCancel.Text = ResMan.GetString( "WorkflowEdit.Cancel" ); 
            
            if ( WorkflowID == 0 ) { 
                pnlSteps.Enabled = false; 
            } 
            
            if ( !( Page.IsPostBack ) & WorkflowID != 0 ) { 
                // set values
                cn = new GeneralConnection( Functions.GetConnectionString() ); 
                workflowObj = new DataClass( "CMS.Workflow", WorkflowID, cn ); 
                txtWorkflowName.Text = System.Convert.ToString( workflowObj.GetValue( "WorkflowName" ) ); 
                txtWorkflowDisplayName.Text = System.Convert.ToString( workflowObj.GetValue( "WorkflowDisplayName" ) ); 
                lblWorkflowIDValue.Text = System.Convert.ToString( workflowObj.GetValue( "WorkflowID" ) ); 
            } 
            if ( WorkflowID == 0 ) { 
                lblWorkflowIDValue.Text = ResMan.GetString( "EditWorkflow.NoWorkflowIDValue" ); 
            } 
        } 
        
        
        private void btnCancel_Click( System.Object sender, System.EventArgs e ) { 
            // redirect user back to the list of classes
            ltlScript.Text = @"<script language=""javascript"">"; 
            ltlScript.Text += " function Cancel()"; 
            ltlScript.Text += " {"; 
            ltlScript.Text += "   document.location.href='WorkflowList.aspx';"; 
            ltlScript.Text += " }"; 
            ltlScript.Text += " Cancel(); "; 
            ltlScript.Text += "</script>"; 
        } 
        
        
        private void btnOK_Click( System.Object sender, System.EventArgs e ) { 
            // check permissions
            if ( WorkflowID == 0 ) { 
                if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Create" ) ) ) { 
                    Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Create" ); 
                    return; 
                } 
            } 
            else { 
                if ( !( Functions.IsAuthorizedPerResource( "CMS.MetaDesigner", "Modify" ) ) ) { 
                    Functions.RedirectToAccessDenied( "CMS.MetaDesigner", "Modify" ); 
                    return; 
                } 
            } 
            
            // validate input
            string errorMessage = ""; 
            GeneralConnection cn = null; 
            string[,] paramsIdent = new string[ 1, 3 ]; 
            DataRow WorkflowDR = null; 
            string infoMessage = ""; 
            DataClass workflowObj = null; 
            string originalWorkflowName = ""; 
            string newWorkflowName = ""; 
            DataSet workflowNamesDS = null; 
            DataRow workflowNameDR = null; 
            DataClass workflowStep = null; 
            
            txtWorkflowName.Text = txtWorkflowName.Text.Trim(); 
            txtWorkflowDisplayName.Text = txtWorkflowDisplayName.Text.Trim(); 
            if ( txtWorkflowName.Text + "" == "" ) { 
                errorMessage += ResMan.GetString( "WorkflowEdit.ErrorEmptyWorkflowName" ) + " "; 
            } 
            if ( txtWorkflowDisplayName.Text + "" == "" ) { 
                errorMessage += ResMan.GetString( "WorkflowEdit.ErrorEmptyWorkflowDisplayName" ) + " "; 
            } 
            
            if ( errorMessage + "" == "" ) { 
                // check for existing class
                paramsIdent[ 0, 0 ] = "@WorkflowName"; 
                paramsIdent[ 0, 1 ] = txtWorkflowName.Text; 
                cn = Functions.GetTreeProvider().Connection; 
                cn.DataConnection.Open(); 
                
                workflowNamesDS = cn.ExecuteQuery( "CMS.Workflow.SelectByWorkflowName", paramsIdent ); 
                if ( WorkflowID == 0 ) { 
                    if ( workflowNamesDS.Tables[ 0 ].Rows.Count > 0 ) { 
                        // workflow name already exists
                        errorMessage += ResMan.GetString( "WorkflowEdit.ErrorExistingWorkflowName" ) + " "; 
                    } 
                } 
                else { 
                    foreach ( System.Data.DataRow transTemp0 in workflowNamesDS.Tables[ 0 ].Rows ) { 
                        WorkflowDR = transTemp0;  
                        if ( System.Convert.ToInt32( WorkflowDR[ "WorkflowID" ] ) != WorkflowID ) { 
                            // class name already exists
                            errorMessage += ResMan.GetString( "WorkflowEdit.ErrorExistingWorkflowName" ) + " "; 
                        } 
                    }
                } 
                
                if ( errorMessage + "" == "" ) { 
                    // save class info
                    if ( WorkflowID == 0 ) { 
                        cn.DataConnection.Open(); 
                        cn.DataConnection.BeginTransaction(); 
                        try { 
                            // insert a new class                    
                            workflowObj = new DataClass( "CMS.Workflow", cn ); 
                            workflowObj.SetValue( "WorkflowName", txtWorkflowName.Text ); 
                            workflowObj.SetValue( "workflowDisplayName", txtWorkflowDisplayName.Text ); 
                            workflowObj.Insert(); 
                            this.lblWorkflowIDValue.Text = System.Convert.ToInt32( workflowObj.GetValue( "WorkflowID" ) ).ToString(); 
                            // insert default steps
                            workflowStep = new DataClass( "cms.workflowstep", cn ); 
                            workflowStep.SetValue( "StepDisplayName", ResMan.GetString( "WorkflowEdit.EditStepDisplayName" ) ); 
                            workflowStep.SetValue( "StepName", "edit" ); 
                            workflowStep.SetValue( "StepOrder", 1 ); 
                            workflowStep.SetValue( "WorkflowID", System.Convert.ToInt32( workflowObj.GetValue( "WorkflowID" ) ) ); 
                            workflowStep.Insert(); 
                            workflowStep = new DataClass( "cms.workflowstep", cn ); 
                            workflowStep.SetValue( "StepDisplayName", ResMan.GetString( "WorkflowEdit.PublishedStepDisplayName" ) ); 
                            workflowStep.SetValue( "StepName", "published" ); 
                            workflowStep.SetValue( "StepOrder", 2 ); 
                            workflowStep.SetValue( "WorkflowID", System.Convert.ToInt32( workflowObj.GetValue( "WorkflowID" ) ) ); 
                            workflowStep.Insert(); 
                        } 
                        catch ( Exception exc ) { 
                            cn.DataConnection.RollbackTransaction(); 
                            cn.DataConnection.Close(); 
                            throw exc; 
                        } 
                        cn.DataConnection.CommitTransaction(); 
                        cn.DataConnection.Close(); 
                        this.pnlSteps.Enabled = true; 
                        this.WorkflowDesigner1.WorkflowID = System.Convert.ToInt32( workflowObj.GetValue( "WorkflowID" ) ); 
                        ViewState[ "WorkflowID" ] = System.Convert.ToInt32( workflowObj.GetValue( "WorkflowID" ) ); 
                        infoMessage = ResMan.GetString( "WorkflowEdit.ChangesSaved" ); 
                    } 
                    else { 
                        // update an existing class
                        workflowObj = new DataClass( "CMS.Workflow", WorkflowID, cn ); 
                        originalWorkflowName = System.Convert.ToString( workflowObj.GetValue( "WorkflowName" ) ); 
                        newWorkflowName = this.txtWorkflowName.Text; 
                        if ( originalWorkflowName.ToLower().Trim() == "default" & newWorkflowName.ToLower().Trim() != "default" ) { 
                            // you cannot change the name of the default workflow
                            this.lblError.Text = ResMan.GetString( "WorkflowEdit.ErrorCannotChangeDefaultWorkflowName" ); 
                            return; 
                        } 
                        workflowObj.SetValue( "WorkflowName", txtWorkflowName.Text ); 
                        newWorkflowName = System.Convert.ToString( workflowObj.GetValue( "WorkflowName" ) ); 
                        workflowObj.SetValue( "WorkflowDisplayName", txtWorkflowDisplayName.Text ); 
                        workflowObj.Update(); 
                        infoMessage = ResMan.GetString( "WorkflowEdit.ChangesSaved" ); 
                    } 
                } 
                cn.DataConnection.Close(); 
            } 
            
            if ( errorMessage + "" != "" ) { 
                lblError.Text = errorMessage; 
            } 
            if ( infoMessage + "" != "" ) { 
                lblInfo.Text = infoMessage; 
            } 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
