using Kentico.CMS.TreeEngine; 
using Kentico.CMS.DataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class ListMyRecycleBin : System.Web.UI.Page { 
        
        protected string restoreHint; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlConfirmScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblError; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnEmptyRecBin; 
        protected string destroyHint; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by QueryDataGrid1_DataBind
             
            QueryDataGrid1.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler( QueryDataGrid1_DataBind ); 
            // events handled by btnEmptyRecBin_Click
             
            btnEmptyRecBin.Click += new System.EventHandler( btnEmptyRecBin_Click ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ Kentico.CMS.CMSControls.QueryDataGrid QueryDataGrid1; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            this.lblHeader.Text = ResMan.GetString( "ListMyRecycleBin.Header" ); 
            restoreHint = ResMan.GetString( "ListMyRecycleBin.RestoreHint" ); 
            destroyHint = ResMan.GetString( "ListMyRecycleBin.DestroyHint" ); 
            this.QueryDataGrid1.Columns[ 0 ].HeaderText = ResMan.GetString( "ListMyRecycleBin.Restore" ); 
            this.QueryDataGrid1.Columns[ 1 ].HeaderText = ResMan.GetString( "ListMyRecycleBin.NodeNamePath" ); 
            this.QueryDataGrid1.Columns[ 2 ].HeaderText = ResMan.GetString( "ListMyRecycleBin.ModifiedWhen" ); 
            this.QueryDataGrid1.WhereCondition = Functions.GetUserID().ToString(); 
            ltlConfirmScript.Text = @"<input type=""hidden"" id=""confirmationText"" value=""" + ResMan.GetString( "RecycleBin.ConfirmDestroy" ) + @""">"; 
            btnEmptyRecBin.Text = ResMan.GetString( "ListMyRecycleBin.EmptyRecycleBin" ); 
            this.lblError.Text = ""; 
            if ( "" + Request.QueryString[ "displayerror" ] == "true" ) { 
                this.lblError.Text = ResMan.GetString( "ListMyRecycleBin.ErrorSomeNotDestroyed" ); 
            } 
            this.btnEmptyRecBin.Attributes.Add( "onclick", "return confirm('" + ResMan.GetString( "ListMyRecycleBin.ConfirmEmptyRecBin" ).Replace( "'", @"\'" ) + "');" ); 
        } 
        
        
        
        private void QueryDataGrid1_DataBind( System.Object sender, DataGridItemEventArgs e ) { 
            ImageButton btnCurrentButton = null; 
            
            // set up the Delete button
            if ( e.Item.ItemType == ListItemType.Item | e.Item.ItemType == ListItemType.AlternatingItem ) { 
                btnCurrentButton = ( ( ImageButton )( e.Item.Cells[ 0 ].FindControl( "btnDelete" ) ) ); 
                btnCurrentButton.Attributes.Add( "OnClick", "return ConfirmDestroy();" ); 
                btnCurrentButton.Attributes.Add( "title", destroyHint ); 
            } 
        } 
        
        
        
        public void DeleteItem( object sender, System.Web.UI.WebControls.DataGridCommandEventArgs e ) { 
            // get node info
            int versionHistoryId = int.Parse( System.Convert.ToString( e.CommandArgument ) ); 
            TreeNode deletedNode = null; 
            TreeProvider tree = Functions.GetTreeProvider(); 
            VersionManager verMan = new VersionManager( tree ); 
            deletedNode = verMan.GetVersion( versionHistoryId ); 
            string idpath = System.Convert.ToString( deletedNode.GetValue( "IDPath" ) ); 
            int aclId = System.Convert.ToInt32( deletedNode.GetValue( "ACLID" ) ); 
            string className = deletedNode.ClassName; 
            
            // check permissions
            if ( !( ( Functions.IsAuthorizedPerResource( "CMS.Content", "Destroy" ) | Functions.IsAuthorizedPerClass( className, "Destroy" ) | tree.SecurityProvider.IsAuthorizedPerACL( aclId, NodePermissionsEnum.Destroy, Functions.GetUserID() ) ) ) ) { 
                this.lblError.Text = ResMan.GetString( "ListMyRecycleBing.ErrorNotAllowedToDestroy" ); 
                return; 
            } 
            
            // destroy
            Functions.DeleteFriendlyURL( System.Convert.ToString( deletedNode.GetValue( "AliasPath" ) ) ); 
            if ( deletedNode.ClassName.ToLower() == "cms.file" ) { 
                Functions.DeleteAttachment( System.Convert.ToString( deletedNode.GetValue( "AliasPath" ) ), System.Convert.ToString( deletedNode.GetValue( "FileName" ) ) ); 
            } 
            verMan.DestroyNodeHistory( System.Convert.ToInt32( deletedNode.GetValue( "NodeID" ) ) ); 
            Response.Redirect( Page.Request.Url.ToString() ); 
        } 
        
        
        private void btnEmptyRecBin_Click( System.Object sender, System.EventArgs e ) { 
            DataSet ds = null; 
            DataSet filteredDs = null; 
            DataRow dr = null; 
            bool allDeleted = true; 
            TreeProvider tree = new TreeProvider(); 
            VersionManager verMan = new VersionManager( tree ); 
            TreeNode deletedNode = null; 
            bool userHasGlobalDestroyPerm = Functions.IsAuthorizedPerResource( "CMS.Content", "Destroy" ); 
            
            ds = tree.Connection.ExecuteQuery( "cms.root.selectmyrecyclebin", null, Functions.GetUserID().ToString() ); 
            // check permissions and destroy                            
            foreach ( System.Data.DataRow transTemp0 in ds.Tables[ 0 ].Rows ) { 
                dr = transTemp0;  
                deletedNode = verMan.GetVersion( System.Convert.ToInt32( dr[ "versionHistoryId" ] ) ); 
                string idpath = System.Convert.ToString( deletedNode.GetValue( "IDPath" ) ); 
                int aclId = System.Convert.ToInt32( deletedNode.GetValue( "ACLID" ) ); 
                string className = deletedNode.ClassName; 
                
                // check permissions
                if ( !( ( userHasGlobalDestroyPerm | Functions.IsAuthorizedPerClass( className, "Destroy" ) | tree.SecurityProvider.IsAuthorizedPerACL( aclId, NodePermissionsEnum.Destroy, Functions.GetUserID() ) ) ) ) { 
                    allDeleted = false; 
                } 
                else { 
                    // destroy
                    Functions.DeleteFriendlyURL( System.Convert.ToString( deletedNode.GetValue( "AliasPath" ) ) ); 
                    if ( deletedNode.ClassName.ToLower() == "cms.file" ) { 
                        Functions.DeleteAttachment( System.Convert.ToString( deletedNode.GetValue( "AliasPath" ) ), System.Convert.ToString( deletedNode.GetValue( "FileName" ) ) ); 
                    } 
                    verMan.DestroyNodeHistory( System.Convert.ToInt32( dr[ "NodeID" ] ) ); 
                } 
            }
            if ( allDeleted == false ) { 
                Response.Redirect( Page.Request.Url.ToString() + "?displayerror=true" ); 
            } 
            else { 
                Response.Redirect( Page.Request.Url.ToString() ); 
            } 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
