using Kentico.CMS.DataEngine; 
using Kentico.CMS.TreeEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class NewsletterContainerView : System.Web.UI.Page { 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
        } 
        
        
        protected /* TRANSINFO: WithEvents */ Kentico.CMS.CMSControls.QueryDataGrid QueryDataGrid1; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            string idpath = "" + Request.QueryString[ "idpath" ] + ""; 
            string culture = "" + Request.QueryString[ "culture" ] + ""; 
            
            TreeProvider tree = null; 
            TreeNode node = null; 
            
            tree = Functions.GetTreeProvider(); 
            node = tree.SelectSingleNode( idpath, TreePathTypeEnum.IDPath ); 
            if ( Functions.UseMultilingualSupport() & culture + "" != "" ) { 
                string aliaspath = System.Convert.ToString( node.GetValue( "AliasPath" ) ); 
                node = tree.SelectSingleNode( "/" + culture + Functions.RemoveCultureFromAliasPath( aliaspath ), TreePathTypeEnum.AliasPath ); 
                if ( node == null ) { 
                    Response.Redirect( "NewCultureVersion.aspx?idpath=" + idpath + "&aliaspath=" + aliaspath + "&culture=" + culture ); 
                    return; 
                } 
                else { 
                    idpath = System.Convert.ToString( node.GetValue( "idpath" ) ); 
                } 
            } 
            
            // Check permissions.
            if ( !( ( Functions.IsAuthorizedPerResource( "CMS.Newsletter", "Read" ) | Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read ) ) ) ) { 
                Functions.RedirectToAccessDenied( idpath, "Read (NewsletterContainerView.aspx)" ); 
                return; 
            } 
            
            // Set column header names.
            QueryDataGrid1.Columns[ 0 ].HeaderText = ResMan.GetString( "NewsletterContainerView.HeaderNewsletterName" ); 
            QueryDataGrid1.Columns[ 1 ].HeaderText = ResMan.GetString( "NewsletterContainerView.HeaderIssuesCount" ); 
            QueryDataGrid1.Columns[ 2 ].HeaderText = ResMan.GetString( "NewsletterContainerView.HeaderSubscriptionsCount" ); 
            
            // Select suitable data.
            GeneralConnection connection = new GeneralConnection( Functions.GetConnectionString() ); 
            object[,] newslettersParams = new object[ 1, 3 ]; 
            DataSet newsletters = null; 
            
            newslettersParams[ 0, 0 ] = "@IDPath"; 
            newslettersParams[ 0, 1 ] = idpath; 
            
            newsletters = connection.ExecuteQuery( "cms.newslettercontainer.selectnewsletters", newslettersParams ); 
            
            // Assign data to the grid.
            QueryDataGrid1.DataSource = newsletters; 
            QueryDataGrid1.ProcessSorting = true; 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
