using Kentico.CMS.DataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class AddNewsletter : System.Web.UI.Page { 
        
        protected int SubscriberID; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by btnSearch_Click
             
            btnSearch.Click += new System.EventHandler( btnSearch_Click ); 
            // events handled by btnOK_Click
             
            btnOK.Click += new System.EventHandler( btnOK_Click ); 
            // events handled by btnCancel_Click
             
            btnCancel.Click += new System.EventHandler( btnCancel_Click ); 
        } 
        
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtSearch; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnSearch; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.ListBox lstItems; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnOK; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnCancel; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // Check permissions.
            if ( !( Functions.IsAuthorizedPerResource( "CMS.Newsletter", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.Newsletter", "Read" ); 
                return; 
            } 
            
            SubscriberID = int.Parse( "" + Request.QueryString[ "subscriberid" ] ); 
            
            // Set initial values from the resources.
            lblHeader.Text = ResMan.GetString( "AddNewsletter.Header" ); 
            btnSearch.Text = ResMan.GetString( "AddNewsletter.SearchButton" ); 
            btnOK.Text = ResMan.GetString( "AddNewsletter.OK" ); 
            btnCancel.Text = ResMan.GetString( "AddNewsletter.Cancel" ); 
        } 
        
        
        private void btnSearch_Click( System.Object sender, System.EventArgs e ) { 
            GeneralConnection cn = new GeneralConnection(); 
            DataSet ds = null; 
            
            // Find all newsletters whose name contains specified string.
            cn.ConnectionString = Functions.GetConnectionString(); 
            ds = cn.ExecuteQuery( "cms.newsletter.selectlist", null, " NewsletterName LIKE N'%" + txtSearch.Text.Replace( "'", "''" ) + "%' ", "NewsletterName" ); 
            lstItems.DataSource = ds.Tables[ 0 ]; 
            lstItems.DataTextField = "NewsletterName"; 
            lstItems.DataValueField = "NewsletterID"; 
            lstItems.DataBind(); 
        } 
        
        
        private void btnOK_Click( System.Object sender, System.EventArgs e ) { 
            // Check permissions.
            if ( !( Functions.IsAuthorizedPerResource( "CMS.Newsletter", "Modify" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.Newsletter", "Modify" ); 
                return; 
            } 
            
            ListItem item = null; 
            GeneralConnection cn = new GeneralConnection(); 
            object[,] paramsIdent = new object[ 2, 3 ]; 
            
            paramsIdent[ 0, 0 ] = "@SubscriberID"; 
            paramsIdent[ 0, 1 ] = SubscriberID; 
            cn.ConnectionString = Functions.GetConnectionString(); 
            cn.DataConnection.Open(); 
            
            // Get IDs of the selected newsletters and save changes.
            foreach ( System.Web.UI.WebControls.ListItem transTemp0 in lstItems.Items ) { 
                item = transTemp0;  
                if ( item.Selected ) { 
                    paramsIdent[ 1, 0 ] = "@NewsletterID"; 
                    paramsIdent[ 1, 1 ] = int.Parse( item.Value ); 
                    cn.ExecuteQuery( "cms.subscriber.addsubscription", paramsIdent ); 
                } 
            }
            cn.DataConnection.Close(); 
            CloseWindow(); 
        } 
        
        
        private void btnCancel_Click( System.Object sender, System.EventArgs e ) { 
            CloseWindow(); 
        } 
        
        
        ///<summary>Generates script that closes the window and refreshes the parent page.</summary>
        private void CloseWindow() { 
            ltlScript.Text = @"<script language=""javascript"">"; 
            ltlScript.Text += " CloseAndRefresh(); "; 
            ltlScript.Text += "</script>"; 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
