using Kentico.CMS.DataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class EditNewsletters : System.Web.UI.Page { 
        
        protected int SubscriberID; 
        protected string deleteHint; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by dtg_ItemDataBound
             
            QueryDataGrid1.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler( dtg_ItemDataBound ); 
            // events handled by btnOK_Click
             
            btnOK.Click += new System.EventHandler( btnOK_Click ); 
        } 
        
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblNewslettersHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlButtonAddNewsletter; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.ImageButton btnDelete; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlConfirmScript; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ Kentico.CMS.CMSControls.QueryDataGrid QueryDataGrid1; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnOK; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // Check permissions.
            if ( !( Functions.IsAuthorizedPerResource( "CMS.Newsletter", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.Newsletter", "Read" ); 
                return; 
            } 
            
            SubscriberID = int.Parse( "" + Request.QueryString[ "subscriberid" ] ); 
            
            // Set button hints.
            deleteHint = ResMan.GetString( "EditNewsletters.DeleteHint" ); 
            
            // Confirmation question
            ltlConfirmScript.Text = @"<input type=""hidden"" id=""confirmationText"" value=""" + ResMan.GetString( "EditNewsletters.ConfirmDelete" ) + @""">"; 
            
            // Header title
            lblHeader.Text = ResMan.GetString( "EditNewsletters.Header" ); 
            
            // Set label text from the resources.
            ltlButtonAddNewsletter.Text = @"<input type=""button"" value=""" + ResMan.GetString( "EditNewsletters.AddNewsletter" ) + @""" class=""FormButton"" onclick=""javascript:AddNewsletter('" + SubscriberID + @"');"">"; 
            btnOK.Text = ResMan.GetString( "EditNewsletters.OK" ); 
            
            // Set column header names.
            QueryDataGrid1.Columns[ 0 ].HeaderText = ResMan.GetString( "EditNewsletters.Delete" ); 
            QueryDataGrid1.Columns[ 1 ].HeaderText = ResMan.GetString( "EditNewsletters.Newsletter" ); 
            
            DisplayNewsletters(); 
            if ( !( Page.IsPostBack ) ) { 
                // Display subscriber e-mail in the header.
                DataClass subscriber = new DataClass( "cms.subscriber", SubscriberID, Functions.GetTreeProvider().Connection ); 
                string subscriberEmail = ""; 
                
                if ( !( subscriber.IsEmpty() ) ) { 
                    subscriberEmail = "<b>" + System.Convert.ToString( subscriber.GetValue( "SubscriberEmail" ) ) + "</b>"; 
                } 
                lblNewslettersHeader.Text = Strings.Replace( ResMan.GetString( "EditNewsletters.Description" ), "{%email%}", subscriberEmail, 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ); 
            } 
        } 
        
        
        public void DeleteItem( object sender, System.Web.UI.WebControls.DataGridCommandEventArgs e ) { 
            // Check permissions.
            if ( !( Functions.IsAuthorizedPerResource( "CMS.Newsletter", "Modify" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.Newsletter", "Modify" ); 
                return; 
            } 
            
            // Remove selected subscription.
            int newsletterId = int.Parse( System.Convert.ToString( e.CommandArgument ) ); 
            GeneralConnection cn = new GeneralConnection(); 
            object[,] paramsIdent = new object[ 2, 3 ]; 
            
            paramsIdent[ 0, 0 ] = "@SubscriberID"; 
            paramsIdent[ 0, 1 ] = SubscriberID; 
            paramsIdent[ 1, 0 ] = "@NewsletterID"; 
            paramsIdent[ 1, 1 ] = newsletterId; 
            cn.ConnectionString = Functions.GetConnectionString(); 
            cn.ExecuteQuery( "cms.subscriber.removesubscription", paramsIdent ); 
            Response.Redirect( Page.Request.Url.ToString() ); 
        } 
        
        
        ///<summary>Displays subscribed newsletters of the selected user.</summary>
        private void DisplayNewsletters() { 
            GeneralConnection cn = new GeneralConnection(); 
            cn.ConnectionString = Functions.GetConnectionString(); 
            QueryDataGrid1.GeneralConnection = cn; 
            QueryDataGrid1.QueryName = "cms.subscriber.getnewsletters"; 
            QueryDataGrid1.WhereCondition = " SubscriberID = '" + SubscriberID + "' "; 
        } 
        
        
        private void dtg_ItemDataBound( System.Object sender, System.Web.UI.WebControls.DataGridItemEventArgs e ) { 
            ImageButton btnCurrentButton = null; 
            
            // set up the Delete button
            if ( e.Item.ItemType == ListItemType.Item | e.Item.ItemType == ListItemType.AlternatingItem ) { 
                btnCurrentButton = ( ( ImageButton )( e.Item.Cells[ 0 ].FindControl( "btnDelete" ) ) ); 
                btnCurrentButton.Attributes.Add( "OnClick", "return ConfirmDelete();" ); 
                btnCurrentButton.Attributes.Add( "title", deleteHint ); 
            } 
        } 
        
        
        private void btnOK_Click( System.Object sender, System.EventArgs e ) { 
            GoBack(); 
        } 
        
        
        ///<summary>Returns user to the list of subscribers.</summary>
        private void GoBack() { 
            ltlScript.Text = @"<script language=""javascript"">"; 
            ltlScript.Text += " GoBack(); "; 
            ltlScript.Text += "</script>"; 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
