using Kentico.CMS.DataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class EditSubscriber : System.Web.UI.Page { 
        
        protected int SubscriberID; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by btnOK_Click
             
            btnOK.Click += new System.EventHandler( btnOK_Click ); 
            // events handled by btnCancel_Click
             
            btnCancel.Click += new System.EventHandler( btnCancel_Click ); 
        } 
        
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblInfo; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblError; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblSubscriberID; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblSubscriberIDValue; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblEmail; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblFirstName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblLastName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblFullName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtEmail; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtFirstName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtLastName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.TextBox txtFullName; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnOK; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnCancel; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlScript; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            GeneralConnection cn = null; 
            DataClass subscriber = null; 
            
            if ( "" + Request.QueryString[ "id" ] + "" != "" ) { 
                // Check permissions.
                if ( !( Functions.IsAuthorizedPerResource( "CMS.Newsletter", "Modify" ) ) ) { 
                    Functions.RedirectToAccessDenied( "CMS.Newsletter", "Modify" ); 
                    return; 
                } 
                SubscriberID = int.Parse( "" + Request.QueryString[ "id" ] ); 
            } 
            else { 
                // Check permissions.
                if ( !( Functions.IsAuthorizedPerResource( "CMS.Newsletter", "Create" ) ) ) { 
                    Functions.RedirectToAccessDenied( "CMS.Newsletter", "Create" ); 
                    return; 
                } 
                SubscriberID = 0; 
            } 
            
            // Set initial value and label visibility.
            lblError.Text = ""; 
            lblError.Visible = false; 
            lblInfo.Text = ""; 
            lblInfo.Visible = false; 
            
            // Set label text from the resources.
            lblHeader.Text = ResMan.GetString( "EditSubscriber.Header" ); 
            lblSubscriberID.Text = ResMan.GetString( "EditSubscriber.SubscriberID" ); 
            lblEmail.Text = ResMan.GetString( "EditSubscriber.Email" ); 
            lblFirstName.Text = ResMan.GetString( "EditSubscriber.FirstName" ); 
            lblLastName.Text = ResMan.GetString( "EditSubscriber.LastName" ); 
            lblFullName.Text = ResMan.GetString( "EditSubscriber.FullName" ); 
            btnOK.Text = ResMan.GetString( "EditSubscriber.OK" ); 
            btnCancel.Text = ResMan.GetString( "EditSubscriber.Cancel" ); 
            
            // Set subscriber values.
            if ( Page.IsPostBack == false & SubscriberID != 0 ) { 
                cn = new GeneralConnection( Functions.GetConnectionString() ); 
                subscriber = new DataClass( "CMS.Subscriber", SubscriberID, cn ); 
                
                txtEmail.Text = System.Convert.ToString( subscriber.GetValue( "SubscriberEmail" ) ); 
                txtFirstName.Text = System.Convert.ToString( subscriber.GetValue( "SubscriberFirstName" ) ); 
                txtLastName.Text = System.Convert.ToString( subscriber.GetValue( "SubscriberLastName" ) ); 
                txtFullName.Text = System.Convert.ToString( subscriber.GetValue( "SubscriberFullName" ) ); 
                lblSubscriberIDValue.Text = System.Convert.ToString( subscriber.GetValue( "SubscriberID" ) ); 
            } 
            else if ( SubscriberID == 0 ) { 
                lblSubscriberIDValue.Text = ResMan.GetString( "EditSubscriber.NoSubscriberIDValue" ); 
            } 
        } 
        
        
        private void btnOK_Click( System.Object sender, System.EventArgs e ) { 
            string errorMessage = ""; 
            string infoMessage = ""; 
            GeneralConnection cn = null; 
            string[,] paramsIdent = new string[ 1, 3 ]; 
            DataSet subscriberEmails = null; 
            DataClass subscriber = null; 
            
            // Validate input.
            if ( txtEmail.Text.Trim() + "" == "" ) { 
                errorMessage += ResMan.GetString( "EditSubscriber.ErrorEmptyEmail" ) + " "; 
            } 
            
            // Check for existing subscriber.
            if ( errorMessage + "" == "" ) { 
                paramsIdent[ 0, 0 ] = "@SubscriberEmail"; 
                paramsIdent[ 0, 1 ] = txtEmail.Text.Trim(); 
                cn = new GeneralConnection( Functions.GetConnectionString() ); 
                cn.DataConnection.Open(); 
                
                subscriberEmails = cn.ExecuteQuery( "cms.subscriber.selectbyemail", paramsIdent ); 
                if ( SubscriberID == 0 ) { 
                    if ( subscriberEmails.Tables[ 0 ].Rows.Count > 0 ) { 
                        // E-mail address already exists.
                        errorMessage += ResMan.GetString( "EditSubscriber.ErrorExistingEmail" ) + " "; 
                    } 
                } 
                else { 
                    foreach ( System.Data.DataRow subscriberEmail in subscriberEmails.Tables[ 0 ].Rows ) { 
                        if ( System.Convert.ToInt32( subscriberEmail[ "SubscriberID" ] ) != SubscriberID ) { 
                            // E-mail address already exists.
                            errorMessage += ResMan.GetString( "EditSubscriber.ErrorExistingEmail" ) + " "; 
                        } 
                    }
                } 
                
                if ( errorMessage + "" == "" ) { 
                    if ( SubscriberID == 0 ) { 
                        // Insert a new subscriber.
                        subscriber = new DataClass( "CMS.Subscriber", cn ); 
                        subscriber.SetValue( "SubscriberEmail", txtEmail.Text ); 
                        subscriber.SetValue( "SubscriberFirstName", txtFirstName.Text ); 
                        subscriber.SetValue( "SubscriberLastName", txtLastName.Text ); 
                        subscriber.SetValue( "SubscriberFullName", txtFullName.Text ); 
                        subscriber.Insert(); 
                        
                        // Clear form values.
                        txtEmail.Text = ""; 
                        txtFirstName.Text = ""; 
                        txtLastName.Text = ""; 
                        txtFullName.Text = ""; 
                        
                        // Set result of the operation.
                        infoMessage = ResMan.GetString( "EditSubscriber.ChangesInserted" ); 
                    } 
                    else { 
                        // Update an existing subscriber.
                        subscriber = new DataClass( "CMS.Subscriber", SubscriberID, cn ); 
                        subscriber.SetValue( "SubscriberEmail", txtEmail.Text ); 
                        subscriber.SetValue( "SubscriberFirstName", txtFirstName.Text ); 
                        subscriber.SetValue( "SubscriberLastName", txtLastName.Text ); 
                        subscriber.SetValue( "SubscriberFullName", txtFullName.Text ); 
                        subscriber.Update(); 
                        
                        // Set result of the operation.
                        infoMessage = ResMan.GetString( "EditSubscriber.ChangesSaved" ); 
                        GoBack(); 
                    } 
                } 
                
                cn.DataConnection.Close(); 
            } 
            
            // Display information about the operation.
            if ( errorMessage + "" != "" ) { 
                lblError.Text = errorMessage; 
                lblError.Visible = true; 
            } 
            if ( infoMessage + "" != "" ) { 
                lblInfo.Text = infoMessage; 
                lblInfo.Visible = true; 
            } 
        } 
        
        
        private void btnCancel_Click( System.Object sender, System.EventArgs e ) { 
            GoBack(); 
        } 
        
        
        ///<summary>Returns user to the list of subscribers.</summary>
        private void GoBack() { 
            ltlScript.Text = @"<script language=""javascript"">"; 
            ltlScript.Text += " GoBack(); "; 
            ltlScript.Text += "</script>"; 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
