using Kentico.CMS.DataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class SubscriberList : System.Web.UI.Page { 
        
        protected string deleteHint; 
        protected string editHint; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Button btnNew; 
        protected string newslettersHint; 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
            // events handled by dtg_ItemDataBound
             
            QueryDataGrid1.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler( dtg_ItemDataBound ); 
            // events handled by btnNew_Click
             
            btnNew.Click += new System.EventHandler( btnNew_Click ); 
        } 
        
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblHeader; 
        protected /* TRANSINFO: WithEvents */ Kentico.CMS.CMSControls.QueryDataGrid QueryDataGrid1; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlConfirmScript; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            // Check permissions.
            if ( !( Functions.IsAuthorizedPerResource( "CMS.Newsletter", "Read" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.Newsletter", "Read" ); 
                return; 
            } 
            
            Functions.RedirectExpressEdition( "CMSDesk.Newsletter" ); 
            
            // Set button hints.
            deleteHint = ResMan.GetString( "SubscriberList.DeleteHint" ); 
            editHint = ResMan.GetString( "SubscriberList.EditHint" ); 
            newslettersHint = ResMan.GetString( "SubscriberList.NewslettersHint" ); 
            this.btnNew.Text = ResMan.GetString( "SubscriberList.New" ); 
            
            // Confirmation question
            ltlConfirmScript.Text = @"<input type=""hidden"" id=""confirmationText"" value=""" + ResMan.GetString( "SubscriberList.ConfirmDelete" ) + @""">"; 
            
            // Header title
            lblHeader.Text = ResMan.GetString( "SubscriberList.Header" ); 
            
            // Set column header names.
            QueryDataGrid1.Columns[ 0 ].HeaderText = ResMan.GetString( "SubscriberList.Action" ); 
            QueryDataGrid1.Columns[ 1 ].HeaderText = ResMan.GetString( "SubscriberList.FullName" ); 
            QueryDataGrid1.Columns[ 2 ].HeaderText = ResMan.GetString( "SubscriberList.Email" ); 
            QueryDataGrid1.Columns[ 3 ].HeaderText = ResMan.GetString( "SubscriberList.FirstName" ); 
            QueryDataGrid1.Columns[ 4 ].HeaderText = ResMan.GetString( "SubscriberList.LastName" ); 
            
            DisplaySubscribers(); 
        } 
        
        
        public void DeleteItem( object sender, System.Web.UI.WebControls.DataGridCommandEventArgs e ) { 
            // Check permissions.
            if ( !( Functions.IsAuthorizedPerResource( "CMS.Newsletter", "Delete" ) ) ) { 
                Functions.RedirectToAccessDenied( "CMS.Newsletter", "Delete" ); 
                return; 
            } 
            
            // Delete subscriber.
            int id = int.Parse( System.Convert.ToString( e.CommandArgument ) ); 
            GeneralConnection cn = new GeneralConnection(); 
            string[,] paramsIdent = new string[ 1, 3 ]; 
            
            paramsIdent[ 0, 0 ] = "@ID"; 
            paramsIdent[ 0, 1 ] = id.ToString(); 
            cn.ConnectionString = Functions.GetConnectionString(); 
            cn.ExecuteQuery( "cms.subscriber.delete", paramsIdent ); 
            Response.Redirect( Page.Request.Url.ToString() ); 
        } 
        
        
        ///<summary>Displays subscribers in the list.</summary>
        private void DisplaySubscribers() { 
            GeneralConnection cn = new GeneralConnection(); 
            cn.ConnectionString = Functions.GetConnectionString(); 
            QueryDataGrid1.GeneralConnection = cn; 
            QueryDataGrid1.QueryName = "cms.subscriber.selectlist"; 
        } 
        
        
        private void dtg_ItemDataBound( System.Object sender, DataGridItemEventArgs e ) { 
            ImageButton btnCurrentButton = null; 
            
            // set up the Delete button
            if ( e.Item.ItemType == ListItemType.Item | e.Item.ItemType == ListItemType.AlternatingItem ) { 
                btnCurrentButton = ( ( ImageButton )( e.Item.Cells[ 0 ].FindControl( "btnDelete" ) ) ); 
                btnCurrentButton.Attributes.Add( "OnClick", "return ConfirmDelete();" ); 
                btnCurrentButton.Attributes.Add( "title", deleteHint ); 
            } 
        } 
        
        
        private void btnNew_Click( System.Object sender, System.EventArgs e ) { 
            Response.Redirect( "EditSubscriber.aspx" ); 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
