using Kentico.CMS.CMSControls; 
using Kentico.CMS.TreeEngine; 
using Kentico.CMS.DataEngine; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace Kentico.CMS.CMSDesk {
    public class ToolsTreeData : System.Web.UI.Page { 
        
        private TreeProvider tree; 
        private const string cImageBasePath = "../Design/Tree"; 
        private const string cIconsBasePath = "../Design/Icons/"; 
        
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
             
            //base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
             
            base.Load += new System.EventHandler( Page_Load ); 
        } 
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Literal ltlRender; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            string action = null; 
            
            action = Strings.LCase( Strings.Trim( "" + Request.QueryString[ "action" ] + "" ) ); 
            tree = Functions.GetTreeProvider(); 
            ltlRender.Text = @"<script language=""javascript"">" + Constants.vbCrLf; 
            
            switch ( action ) {
                case "expandnode":
                    // check permissions
                    if ( !( Functions.IsAuthorizedPerResource( "CMS.Tools", "Read" ) ) ) { 
                        ShowErrorMessage( ResMan.GetString( "AccessDenied.NotAllowedToRead" ) ); 
                    } 
                    else { 
                        AddRenderScript( GetChildNodes( "" + Request.QueryString[ "nodeid" ], "" + Request.QueryString[ "sample" ], "" + Request.QueryString[ "value" ] ), "" + Request.QueryString[ "nodeid" ] ); 
                    } 
                    break;
            }
            
            ltlRender.Text += "</script>"; 
        } 
        
        
        
        ///<summary>Adds script that removes the given node from the displayed tree.</summary>
        ///<param name="nodeIDPath">IDPath of the node to be removed.</param>
        public void AddRemoveNodeScript( string nodeIDPath ) { 
            ltlRender.Text += " parent.frames['tree'].document.getElementById('nodeID_" + nodeIDPath + "').innerHTML = '';"; 
        } 
        
        
        
        ///<summary>Adds script that reloads the selected node.</summary>
        public void AddReloadSelectedNodeScript() { 
            ltlRender.Text += " parent.frames['tree'].ReloadSelectedNode();" + Constants.vbCrLf; 
        } 
        
        
        
        ///<summary>Adds script that selects given node.</summary>
        ///<param name="selectIDPath">IDPath of the node to be selected.</param>
        public void AddSelectNodeScript( string selectIDPath ) { 
            ltlRender.Text += " SelectNode('" + selectIDPath + "'); " + Constants.vbCrLf + " function SelectNode(selectID) {" + Constants.vbCrLf + "  try {" + Constants.vbCrLf + "  parent.frames['tree'].selectNode(selectID);" + Constants.vbCrLf + "  } catch(e) { } " + Constants.vbCrLf + " } " + Constants.vbCrLf; 
        } 
        
        
        
        ///<summary>Adds content that will be rendered under given parent node.</summary>
        ///<param name="content">Content to be rendered.</param>
        ///<param name="targetNodeIDPath">Target node IDPath.</param>
        public void AddRenderScript( string content, string targetNodeIDPath ) { 
            string innerHTML = null; 
            innerHTML = Strings.Replace( content + "", "'", @"\'", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ); 
            innerHTML = Strings.Replace( innerHTML, @"""", @"\""", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ); 
            innerHTML = Strings.Replace( innerHTML, Constants.vbCrLf, " ", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ); 
            
            ltlRender.Text += " RenderData(); " + Constants.vbCrLf + " function RenderData() {" + Constants.vbCrLf + "  // try {" + Constants.vbCrLf + "  parent.frames['tree'].document.getElementById('sub_" + targetNodeIDPath + "').innerHTML = '" + innerHTML + "'; " + Constants.vbCrLf; 
            if ( innerHTML + "" + "" == "" ) { 
                ltlRender.Text += " parent.frames['tree'].document.getElementById('sub_" + targetNodeIDPath + "').style.display = 'none'; " + Constants.vbCrLf; 
            } 
            ltlRender.Text += "  // } catch(e) { } " + Constants.vbCrLf + " } " + Constants.vbCrLf; 
        } 
        
        
        
        ///<summary>Returns child nodes at 2nd and lower level.</summary>
        ///<param name="NodeID">Parent node ID (IDPath).</param>
        ///<param name="Sample">Sample for displaying tree.</param>
        ///<param name="Value">Value of the parent node.</param>
        public string GetChildNodes( string NodeID, string Sample, string Value ) { 
            TreeNodes nodes = new TreeNodes(); 
            DataRow dr = null; 
            DataRowCollection nodeRows = null; 
            GeneralConnection cn = new GeneralConnection(); 
            
            cn.ConnectionString = Functions.GetConnectionString(); 
            nodes.ImagePathBase = cImageBasePath; 
            // root = resources
            if ( NodeID == "/" ) { 
                foreach ( System.Data.DataRow transTemp0 in cn.ExecuteQuery( "CMS.Resource.SelectList", null, "ShowInToolsMenu=1 AND ResourceURL!=''", "ResourceDisplayName" ).Tables[ 0 ].Rows ) { 
                    dr = transTemp0;  
                    string resURL = null; 
                    string noURL = "notool.htm"; 
                    if ( ( !( dr[ "ResourceURL" ] == DBNull.Value ) ) ) { 
                        resURL = System.Convert.ToString( dr[ "ResourceURL" ] ); 
                        if ( resURL + "" == "" ) { resURL = noURL; } 
                    } 
                    else { 
                        resURL = noURL; 
                    } 
                    nodes.NewNode( System.Convert.ToString( dr[ "ResourceDisplayName" ] ), "/", cIconsBasePath + "resource.gif", cIconsBasePath + "resource.gif", System.Convert.ToString( dr[ "ResourceDisplayName" ] ), "parent.frames['details'].document.location.href = '" + ResolveUrl( resURL ) + "'", "/res_" + System.Convert.ToString( dr[ "ResourceID" ] ), "", false ); 
                }
            } 
            return nodes.NodesHTML(); 
        } 
        
        
        
        ///<summary>Displays an error message.</summary>
        ///<param name="message">Error message.</param>
        public void ShowErrorMessage( string message ) { 
            ltlRender.Text += " alert('" + Strings.Replace( message + "", "'", @"\'", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + "');"; 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
