Imports Kentico.CMS.DataEngine
Imports Kentico.CMS.EventLog

Public Class EventLogList
    Inherits System.Web.UI.Page

    Protected viewHint As String

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents BasicDataGrid1 As Kentico.CMS.CMSControls.BasicDataGrid
    Protected WithEvents lblEventType As System.Web.UI.WebControls.Label
    Protected WithEvents lblUserName As System.Web.UI.WebControls.Label
    Protected WithEvents lblNodeName As System.Web.UI.WebControls.Label
    Protected WithEvents txtUserName As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtNodeName As System.Web.UI.WebControls.TextBox
    Protected WithEvents lstEventType As System.Web.UI.WebControls.DropDownList
    Protected WithEvents btnClear As System.Web.UI.WebControls.Button
    Protected WithEvents ltlConfirmScript As System.Web.UI.WebControls.Literal
    Protected WithEvents btnFilter As System.Web.UI.WebControls.Button
    Protected WithEvents lblEventCode As System.Web.UI.WebControls.Label
    Protected WithEvents txtEventCode As System.Web.UI.WebControls.TextBox

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.Administration", "Read") Then
            Functions.RedirectToAccessDenied("CMS.Administration", "Read")
            Exit Sub
        End If

        'Set view hint
        viewHint = ResMan.GetString("EventLogList.ViewHint")

        'Set filter labels
        lblEventType.Text = ResMan.GetString("EventLogList.FilterEventType")
        lblUserName.Text = ResMan.GetString("EventLogList.FilterUserName")
        lblNodeName.Text = ResMan.GetString("EventLogList.FilterNodeName")
        lblEventCode.Text = ResMan.GetString("EventLogList.FilterEventCode")

        'Set button labels
        btnClear.Text = ResMan.GetString("EventLogList.Clear")
        btnClear.Attributes.Add("onclick", "return ConfirmDelete();")
        btnFilter.Text = ResMan.GetString("EventLogList.FilterButton")

        'Confirmation question
        ltlConfirmScript.Text = "<input type=""hidden"" id=""confirmationText"" value=""" & ResMan.GetString("EventLogList.ConfirmDelete") & """>"

        'Set column header names
        BasicDataGrid1.Columns(0).HeaderText = ResMan.GetString("EventLogList.Action")
        BasicDataGrid1.Columns(1).HeaderText = ResMan.GetString("EventLogList.EventType")
        BasicDataGrid1.Columns(2).HeaderText = ResMan.GetString("EventLogList.EventTime")
        BasicDataGrid1.Columns(3).HeaderText = ResMan.GetString("EventLogList.Source")
        BasicDataGrid1.Columns(4).HeaderText = ResMan.GetString("EventLogList.EventCode")
        BasicDataGrid1.Columns(5).HeaderText = ResMan.GetString("EventLogList.UserName")
        BasicDataGrid1.Columns(6).HeaderText = ResMan.GetString("EventLogList.IPAddress")
        lblHeader.Text = ResMan.GetString("EventLogList.Header")

        'Disable ViewState
        txtNodeName.EnableViewState = False
        txtUserName.EnableViewState = False

        If Not Page.IsPostBack Then
            'Assign event type options
            lstEventType.Items.Add(New ListItem(ResMan.GetString("EventLogList.EventTypeAll"), ""))
            lstEventType.Items.Add(New ListItem(ResMan.GetString("EventLogList.EventTypeInformation"), "I"))
            lstEventType.Items.Add(New ListItem(ResMan.GetString("EventLogList.EventTypeError"), "E"))
            lstEventType.Items.Add(New ListItem(ResMan.GetString("EventLogList.EventTypeWarning"), "W"))
        End If
    End Sub

    Private Sub Page_PreRender(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.PreRender
        'Get filter values
        Dim eventType As String = Me.lstEventType.SelectedValue ' CStr(ViewState("EventType")) & ""
        Dim nodeName As String = Me.txtNodeName.Text 'CStr(ViewState("NodeName")) & ""
        Dim userName As String = Me.txtUserName.Text 'CStr(ViewState("UserName")) & ""
        Dim eventCode As String = Me.txtEventCode.Text

        'lstEventType.SelectedValue = eventType
        'txtNodeName.Text = nodeName
        'txtUserName.Text = userName

        'Build where condition
        Dim where As String = ""
        If eventType.Length = 1 AndAlso "IEW".IndexOf(eventType) >= 0 Then where &= "EventType = '" & eventType & "'"
        If Not nodeName Is Nothing AndAlso nodeName.Length > 0 Then
            If where.Length > 0 Then where &= " AND"
            where &= " NodeNamePath LIKE N'%" & nodeName.Replace("'", "''") & "%' "
        End If
        If Not userName Is Nothing AndAlso userName.Length > 0 Then
            If where.Length > 0 Then where &= " AND"
            where &= " UserName LIKE N'%" & userName.Replace("'", "''") & "%' "
        End If
        If Not eventCode Is Nothing AndAlso eventCode.Length > 0 Then
            If where.Length > 0 Then where &= " AND"
            where &= " EventCode LIKE N'%" & eventCode.Replace("'", "''") & "%' "
        End If

        'Display events
        Me.DisplayEventLog(where)
    End Sub

    '''<summary>Displays events in the list.</summary>
    '''<param name="where">Where condition.</param>
    Private Sub DisplayEventLog(ByVal where As String)
        Dim eventLog As New EventLogProvider(Functions.GetTreeProvider.Connection)

        BasicDataGrid1.DataSource = eventLog.GetAllEvents(where, "")
        BasicDataGrid1.DataBind()
    End Sub

    Private Sub BasicDataGrid1_ItemDataBound(ByVal sender As System.Object, ByVal e As DataGridItemEventArgs) Handles BasicDataGrid1.ItemDataBound
        If e.Item.ItemType = ListItemType.Item OrElse e.Item.ItemType = ListItemType.AlternatingItem Then
            Dim eventType As String = e.Item.Cells(1).Text

            If eventType Is Nothing Then Exit Sub

            'Rewrite event type text.
            Select Case eventType.ToUpper
                Case "I"
                    e.Item.Cells(1).Text = ResMan.GetString("EventLogList.EventTypeInformation")
                Case "E"
                    e.Item.Cells(1).Text = ResMan.GetString("EventLogList.EventTypeError")
                Case "W"
                    e.Item.Cells(1).Text = ResMan.GetString("EventLogList.EventTypeWarning")
            End Select
        End If
    End Sub

    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        'Check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.Administration", "Delete") Then
            Functions.RedirectToAccessDenied("CMS.Administration", "Delete")
            Exit Sub
        End If

        Dim eventLog As New EventLogProvider(Functions.GetTreeProvider.Connection)

        'Clear event log
        eventLog.ClearEventLog(Functions.GetUserID, Web.HttpContext.Current.User.Identity.Name, Request.UserHostAddress)
    End Sub

    Private Sub btnFilter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFilter.Click
        'ViewState("EventType") = lstEventType.SelectedValue
        'ViewState("NodeName") = txtNodeName.Text
        'ViewState("UserName") = txtUserName.Text
        'ViewState("UserName") = txtUserName.Text
    End Sub
End Class