Imports Kentico.CMS.DataEngine

Public Class PermissionMatrix
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents ltlMatrix As System.Web.UI.WebControls.Literal
    Protected WithEvents ltlPageURL As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.Administration", "Read") Then
            Functions.RedirectToAccessDenied("CMS.Administration", "Read")
            Exit Sub
        End If

        If Request.QueryString("id") = "" Then
            'no matrix specified
            ltlMatrix.Text = ResMan.GetString("PermissionMatrix.ChooseSome")
        Else            
            If Request.QueryString("action") <> "" Then
                SetPermission(Integer.Parse(Request.QueryString("action")), Integer.Parse(Request.QueryString("RoleID")), Integer.Parse(Request.QueryString("PermissionID")))
            End If
            ltlMatrix.Text = GetMatrix(Request.QueryString("id"))
        End If

        ltlPageURL.Text = "<input type=""hidden"" ID=""pageURL"" value=""" & Page.Request.Path & "?id=" & Request.QueryString("id") & """>"
    End Sub

    '''<summary>Returns HTML code of the permission matrix for specified class or resource.</summary>
    '''<param name="combinedID">String value consisting of the type ("c" for class, "r" for resource) and its ID.</param>
    Private Function GetMatrix(ByVal combinedID As String) As String
        Dim cn As New GeneralConnection
        Dim dr As DataRow
        Dim lastRoleID As Integer = -1
        Dim params(1, 2) As Object
        Dim itemType As String = Left(combinedID, 1).ToLower
        Dim itemID As Integer
        Dim ds As DataSet
        Dim result As String

        'retrive permission matrix data
        itemID = Integer.Parse(Right(combinedID, Len(combinedID) - 1))
        params(0, 0) = "@ID"
        params(0, 1) = itemID
        params(1, 0) = "@Type"
        params(1, 1) = itemType
        cn.ConnectionString = Functions.GetConnectionString
        ds = cn.ExecuteQuery("CMS.Permission.GetPermissionMatrix", params)
        'render the matrix
        If ds.Tables(0).Rows.Count = 0 Then
            result = ResMan.GetString("PermissionMatrix.Empty")
        Else
            result = "<table cellpadding=0 cellspacing=0 class=""PermissionMatrixTable""><tr><td class=""PermissionMatrixEmptyCell"">&nbsp;</td>"
            lastRoleID = CType(ds.Tables(0).Rows(0)("RoleID"), Integer)
            'render header
            For Each dr In ds.Tables(0).Rows
                If lastRoleID <> CType(dr("RoleID"), Integer) Then
                    result &= "</tr>"
                    Exit For
                Else
                    result &= "<td class=""PermissionMatrixHeader"">" & CType(dr("PermissionDisplayName"), String) & "</td>"
                End If
            Next
            lastRoleID = -1
            'render matrix rows
            For Each dr In ds.Tables(0).Rows
                If lastRoleID <> CType(dr("RoleID"), Integer) Then
                    'new row - start with role name
                    result &= "</tr><tr><td class=""PermissionMatrixHeader"">" & CType(dr("RoleDisplayName"), String) & "</td>"
                    lastRoleID = CType(dr("RoleID"), Integer)
                End If
                result &= "<td class=""PermissionMatrixCell"">"
                If CType(dr("Allowed"), Integer) = 1 Then
                    result &= "<img src=""../../design/buttons/allowed.gif"" style=""cursor:hand"" onclick=""javascript:setPerm('" & CType(dr("RoleID"), Integer) & "', '" & CType(dr("PermissionID"), Integer) & "', '0')"">"
                Else
                    result &= "<img src=""../../design/buttons/denied.gif"" style=""cursor:hand"" onclick=""javascript:setPerm('" & CType(dr("RoleID"), Integer) & "', '" & CType(dr("PermissionID"), Integer) & "', '1')"">"
                End If
                result &= "</td>"
            Next
            result &= "</tr></table>"
        End If
        Return result
    End Function


    '''<summary>Sets or removes specified permission</summary>
    '''<param name="action">Indicates if the permission should be set (1) or removed (0).</param>
    '''<param name="roleID">Role ID.</param>
    '''<param name="permissionID">Permission ID.</param>
    Private Sub SetPermission(ByVal action As Integer, ByVal roleID As Integer, ByVal permissionID As Integer)
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.Administration", "Modify") Then
            Functions.RedirectToAccessDenied("CMS.Administration", "Modify")
            Exit Sub
        End If

        Dim cn As New GeneralConnection
        Dim params(1, 2) As Object
        cn.ConnectionString = Functions.GetConnectionString

        params(0, 0) = "@roleid"
        params(0, 1) = roleID
        params(1, 0) = "@permissionid"
        params(1, 1) = permissionid
        If action = 1 Then
            'grant
            cn.ExecuteQuery("CMS.Permission.AllowPermission", params)
        Else
            'remove
            cn.ExecuteQuery("CMS.Permission.DenyPermission", params)
        End If

        'log event
        Dim roleName As String = ""
        Dim permissionName As String = ""
        Dim resourceName As String = ""
        Dim roleObj As New DataClass("cms.role", roleID, cn)
        Dim permissionNameObj As New DataClass("cms.permission", permissionID, cn)
        Dim resourceObj As DataClass
        If Not (roleObj.IsEmpty Or permissionNameObj.IsEmpty) Then
            roleName = CType(roleObj.GetValue("RoleDisplayName"), String)
            permissionName = CType(permissionNameObj.GetValue("PermissionName"), String)
            If permissionNameObj.GetValue("ClassID") Is Nothing Then
                'resource
                resourceObj = New DataClass("cms.resource", CType(permissionNameObj.GetValue("resourceid"), Integer), cn)
                If Not resourceObj.IsEmpty Then
                    resourceName = CType(resourceObj.GetValue("ResourceName"), String)
                End If
            Else
                'permission
                resourceObj = New DataClass("cms.class", CType(permissionNameObj.GetValue("classid"), Integer), cn)
                If Not resourceObj.IsEmpty Then
                    resourceName = CType(resourceObj.GetValue("ClassName"), String)
                End If
            End If
            If action = 1 Then
                'grant
                Functions.LogEvent("I", "CMS-Administration", "GRANTGLOBALPERMISSION", 0, "", roleName & "," & permissionName & "," & resourceName)
            Else
                'remove
                Functions.LogEvent("I", "CMS-Administration", "REMOVEGLOBALPERMISSION", 0, "", roleName & "," & permissionName & "," & resourceName)
            End If
        End If
    End Sub
End Class
