Imports Kentico.CMS.TreeEngine

Public Class RecycleBin
    Inherits System.Web.UI.Page

    Protected restoreHint As String
    Protected destroyHint As String

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents QueryDataGrid1 As Kentico.CMS.CMSControls.QueryDataGrid
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents btnEmptyRecBin As System.Web.UI.WebControls.Button
    Protected WithEvents ltlConfirmScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        destroyHint = ResMan.GetString("RecycleBin.DestroyHint")
        Me.lblHeader.Text = ResMan.GetString("RecycleBin.Header")
        restoreHint = ResMan.GetString("RecycleBin.RestoreHint")
        ltlConfirmScript.Text = "<input type=""hidden"" id=""confirmationText"" value=""" & ResMan.GetString("RecycleBin.ConfirmDestroy") & """>"
        btnEmptyRecBin.Text = ResMan.GetString("RecycleBin.EmptyRecycleBin")
        Me.lblError.Text = ""
        If Request.QueryString("displayerror") = "true" Then
            Me.lblError.Text = ResMan.GetString("ListMyRecycleBin.ErrorSomeNotDestroyed")
        End If
        Me.btnEmptyRecBin.Attributes.Add("onclick", "return confirm('" & ResMan.GetString("RecycleBin.ConfirmEmptyRecBin").Replace("'", "\'") & "');")

        Me.QueryDataGrid1.Columns(0).HeaderText = ResMan.GetString("RecycleBin.Restore")
        Me.QueryDataGrid1.Columns(1).HeaderText = ResMan.GetString("RecycleBin.NodeNamePath")
        Me.QueryDataGrid1.Columns(2).HeaderText = ResMan.GetString("RecycleBin.DeletedBy")
        Me.QueryDataGrid1.Columns(3).HeaderText = ResMan.GetString("RecycleBin.Deleted")
    End Sub


    Private Sub QueryDataGrid1_DataBind(ByVal sender As System.Object, ByVal e As DataGridItemEventArgs) Handles QueryDataGrid1.ItemDataBound
        Dim btnCurrentButton As ImageButton

        'set up the Delete button
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            btnCurrentButton = CType(e.Item.Cells(0).FindControl("btnDelete"), ImageButton)
            btnCurrentButton.Attributes.Add("OnClick", "return ConfirmDestroy();")
            btnCurrentButton.Attributes.Add("title", destroyHint)
        End If
    End Sub



    Public Sub DeleteItem(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles QueryDataGrid1.DeleteCommand
        'get node info
        Dim versionHistoryId As Integer = Integer.Parse(CType(e.CommandArgument, String))
        Dim deletedNode As TreeNode
        Dim tree As TreeProvider = Functions.GetTreeProvider
        Dim verMan As New VersionManager(tree)
        deletedNode = verMan.GetVersion(versionHistoryId)
        Dim idpath As String = CType(deletedNode.GetValue("IDPath"), String)
        Dim aclId As Integer = CType(deletedNode.GetValue("ACLID"), Integer)
        Dim className As String = deletedNode.ClassName

        'check permissions
        If Not (Functions.IsAuthorizedPerResource("CMS.Content", "Destroy") Or Functions.IsAuthorizedPerClass(className, "Destroy") Or tree.SecurityProvider.IsAuthorizedPerACL(aclId, NodePermissionsEnum.Destroy, Functions.GetUserID)) Then
            Me.lblError.Text = ResMan.GetString("ListMyRecycleBing.ErrorNotAllowedToDestroy")
            Exit Sub
        End If

        'destroy
        Functions.DeleteFriendlyURL(CType(deletedNode.GetValue("AliasPath"), String))
        If deletedNode.ClassName.ToLower = "cms.file" Then
            Functions.DeleteAttachment(CType(deletedNode.GetValue("AliasPath"), String), CType(deletedNode.GetValue("FileName"), String))
        End If
        verMan.DestroyNodeHistory(CType(deletedNode.GetValue("NodeID"), Integer))
        Response.Redirect(Page.Request.Url.ToString)
    End Sub

    Private Sub btnEmptyRecBin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEmptyRecBin.Click
        Dim ds As DataSet
        Dim filteredDs As DataSet
        Dim dr As DataRow
        Dim allDeleted As Boolean = True
        Dim tree As New TreeProvider
        Dim verMan As New VersionManager(tree)
        Dim deletedNode As TreeNode
        Dim userHasGlobalDestroyPerm As Boolean = Functions.IsAuthorizedPerResource("CMS.Content", "Destroy")

        ds = tree.Connection.ExecuteQuery("cms.root.selectrecyclebin", Nothing, "", "1")
        'check permissions and destroy                            
        For Each dr In ds.Tables(0).Rows
            deletedNode = verMan.GetVersion(CType(dr("versionHistoryId"), Integer))
            Dim idpath As String = CType(deletedNode.GetValue("IDPath"), String)
            Dim aclId As Integer = CType(deletedNode.GetValue("ACLID"), Integer)
            Dim className As String = deletedNode.ClassName

            'check permissions
            If Not (userHasGlobalDestroyPerm Or Functions.IsAuthorizedPerClass(className, "Destroy") Or tree.SecurityProvider.IsAuthorizedPerACL(aclId, NodePermissionsEnum.Destroy, Functions.GetUserID)) Then
                allDeleted = False
            Else
                'destroy
                Functions.DeleteFriendlyURL(CType(deletedNode.GetValue("AliasPath"), String))
                If deletedNode.ClassName.ToLower = "cms.file" Then
                    Functions.DeleteAttachment(CType(deletedNode.GetValue("AliasPath"), String), CType(deletedNode.GetValue("FileName"), String))
                End If
                verMan.DestroyNodeHistory(CType(dr("NodeID"), Integer))
            End If
        Next
        If allDeleted = False Then
            Response.Redirect(Page.Request.Url.ToString & "?displayerror=true")
        Else
            Response.Redirect(Page.Request.Url.ToString)
        End If
    End Sub

End Class
