Imports Kentico.CMS.DataEngine

Public Class EditRole
    Inherits System.Web.UI.Page

    Protected RoleID As Integer

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents lblRoleID As System.Web.UI.WebControls.Label
    Protected WithEvents lblRoleIDValue As System.Web.UI.WebControls.Label
    Protected WithEvents lblRoleDisplayName As System.Web.UI.WebControls.Label
    Protected WithEvents txtRoleDisplayName As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblRoleName As System.Web.UI.WebControls.Label
    Protected WithEvents txtRoleName As System.Web.UI.WebControls.TextBox
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents btnCancel As System.Web.UI.WebControls.Button
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim cn As GeneralConnection
        Dim roleObj As DataClass

        If Request.QueryString("id") <> "" Then
            'check permissions
            If Not Functions.IsAuthorizedPerResource("CMS.Administration", "Modify") Then
                Functions.RedirectToAccessDenied("CMS.Administration", "Modify")
                Exit Sub
            End If
            RoleID = Integer.Parse(Request.QueryString("id"))
        Else
            'check permissions
            If Not Functions.IsAuthorizedPerResource("CMS.Administration", "Create") Then
                Functions.RedirectToAccessDenied("CMS.Administration", "Create")
                Exit Sub
            End If
            RoleID = 0
        End If
        lblError.Text = ""
        lblError.Visible = False
        lblInfo.Text = ""
        lblInfo.Visible = False
        lblHeader.Text = ResMan.GetString("EditRole.Header")
        lblRoleID.Text = ResMan.GetString("EditRole.RoleID")
        lblRoleName.Text = ResMan.GetString("EditRole.RoleName")
        lblRoleDisplayName.Text = ResMan.GetString("EditRole.RoleDisplayName")
        btnOK.Text = ResMan.GetString("EditRole.OK")
        btnCancel.Text = ResMan.GetString("EditRole.Cancel")

        'set values
        If Not Page.IsPostBack And RoleID <> 0 Then
            cn = New GeneralConnection(Functions.GetConnectionString)
            roleObj = New DataClass("CMS.Role", RoleID, cn)
            txtRoleName.Text = CType(roleObj.GetValue("RoleName"), String)
            txtRoleDisplayName.Text = CType(roleObj.GetValue("RoleDisplayName"), String)
            lblRoleIDValue.Text = CType(roleObj.GetValue("RoleID"), String)
        Else
            lblRoleIDValue.Text = ResMan.GetString("EditRole.NoRoleIDValue")
        End If
    End Sub


    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        'validate input
        Dim errorMessage As String = ""
        Dim cn As GeneralConnection
        Dim params(0, 2) As String
        Dim roleDR As DataRow
        Dim roleNamesDS As DataSet
        Dim infoMessage As String
        Dim roleObj As DataClass

        If txtRoleName.Text.Trim = "" Then
            errorMessage &= ResMan.GetString("EditRole.ErrorEmptyRoleName") & " "
        End If
        If txtRoleDisplayName.Text.Trim = "" Then
            errorMessage &= ResMan.GetString("EditRole.ErrorEmptyRoleDisplayName") & " "
        End If
        
        If errorMessage = "" Then
            'check for existing role
            params(0, 0) = "@RoleName"
            params(0, 1) = txtRoleName.Text.Trim
            cn = New GeneralConnection(Functions.GetConnectionString)
            cn.DataConnection.Open()

            roleNamesDS = cn.ExecuteQuery("CMS.Role.SelectByRoleName", params)
            If RoleID = 0 Then
                If roleNamesDS.Tables(0).Rows.Count > 0 Then
                    'role name already exists
                    errorMessage &= ResMan.GetString("EditRole.ErrorExistingRoleName") & " "
                End If
            Else
                For Each roleDR In roleNamesDS.Tables(0).Rows
                    If CType(roleDR("RoleID"), Integer) <> RoleID Then
                        'role name already exists
                        errorMessage &= ResMan.GetString("EditRole.ErrorExistingRoleName") & " "
                    End If
                Next
            End If

            If errorMessage = "" Then
                'save role info
                If RoleID = 0 Then
                    'insert a new role
                    roleObj = New DataClass("CMS.Role", cn)
                    roleObj.SetValue("RoleName", txtRoleName.Text)
                    roleObj.SetValue("RoleDisplayName", txtRoleDisplayName.Text)
                    roleObj.Insert()
                    Functions.LogEvent("I", "CMS-Administration", "INSERTROLE", 0, "", Me.txtRoleDisplayName.Text)
                    txtRoleName.Text = ""
                    txtRoleDisplayName.Text = ""
                    infoMessage = ResMan.GetString("EditRole.ChangesInserted")
                Else
                    'update an existing user
                    roleObj = New DataClass("CMS.Role", RoleID, cn)
                    roleObj.SetValue("RoleName", txtRoleName.Text)
                    roleObj.SetValue("RoleDisplayName", txtRoleDisplayName.Text)                    
                    roleObj.Update()
                    Functions.LogEvent("I", "CMS-Administration", "UPDATEROLE", 0, "", Me.txtRoleDisplayName.Text)
                    infoMessage = ResMan.GetString("EditRole.ChangesSaved")
                End If
            End If
            cn.DataConnection.Close()
        End If

        If errorMessage <> "" Then
            lblError.Text = errorMessage
            lblError.Visible = True
        End If
        If infoMessage <> "" Then
            lblInfo.Text = infoMessage
            lblInfo.Visible = True
        End If
    End Sub


    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= " GoBack(); "
        ltlScript.Text &= "</script>"
    End Sub
End Class
