Imports Kentico.CMS.DataEngine

Public Class EditRoleUsers
    Inherits System.Web.UI.Page

    Protected RoleID As Integer
    Protected deleteHint As String

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblUsersHeader As System.Web.UI.WebControls.Label
    Protected WithEvents ltlButtonAddUser As System.Web.UI.WebControls.Literal
    Protected WithEvents btnDelete As System.Web.UI.WebControls.ImageButton
    Protected WithEvents ltlConfirmScript As System.Web.UI.WebControls.Literal
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents Querydatagrid1 As Kentico.CMS.CMSControls.QueryDataGrid
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.Administration", "Read") Then
            Functions.RedirectToAccessDenied("CMS.Administration", "Read")
            Exit Sub
        End If

        RoleID = Integer.Parse(Request.QueryString("id"))
        lblHeader.Text = ResMan.GetString("EditRoleUsers.Header")
        Querydatagrid1.Columns(0).HeaderText = ResMan.GetString("EditRoleUsers.Delete")
        Querydatagrid1.Columns(1).HeaderText = ResMan.GetString("EditRoleUsers.Username")
        Querydatagrid1.Columns(2).HeaderText = ResMan.GetString("EditRoleUsers.Fullname")
        Querydatagrid1.Columns(3).HeaderText = ResMan.GetString("EditRoleUsers.Email")
        btnOK.Text = ResMan.GetString("EditRoleUsers.OK")
        deleteHint = ResMan.GetString("EditRoleUsers.DeleteHint")
        ltlButtonAddUser.Text = "<input type=""button"" value=""" & ResMan.GetString("EditRoleUsers.AddUser") & """ class=""FormButton"" onclick=""javascript:AddUser('" & RoleID & "');"">"
        'confirmation question
        ltlConfirmScript.Text = "<input type=""hidden"" id=""confirmationText"" value=""" & ResMan.GetString("EditRoleUsers.ConfirmDelete") & """>"

        DisplayUsers()
        If Not Page.IsPostBack Then
            'display user name in the header
            Dim roleObj As New DataClass("cms.role", RoleID, Functions.GetTreeProvider.Connection)
            Dim roleName As String = ""
            If Not roleObj.IsEmpty Then
                roleName = "<b>" & CType(roleObj.GetValue("RoleDisplayName"), String) & "</b>"
            End If
            lblUsersHeader.Text = Replace(ResMan.GetString("EditRoleUsers.Description"), "{%rolename%}", roleName)
        End If
    End Sub


    Public Sub DeleteItem(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs)
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.Administration", "Modify") Then
            Functions.RedirectToAccessDenied("CMS.Administration", "Modify")
            Exit Sub
        End If

        'remove user from the selected role
        Dim id As Integer = Integer.Parse(CType(e.CommandArgument, String))
        Dim cn As New GeneralConnection
        Dim params(1, 2) As String

        params(0, 0) = "@RoleID"
        params(0, 1) = RoleID.ToString
        params(1, 0) = "@UserID"
        params(1, 1) = id.ToString
        cn.ConnectionString = Functions.GetConnectionString
        cn.ExecuteQuery("CMS.User.RemoveFromRole", params)

        'log event
        Dim removedUserName As String = ""
        Dim removedUserObj As New DataClass("cms.user", id, cn)
        If Not removedUserObj.IsEmpty Then
            removedUserName = CType(removedUserObj.GetValue("username"), String)
        End If
        Dim removedRoleName As String = ""
        Dim removedRoleObj As New DataClass("cms.role", RoleID, cn)
        If Not removedRoleObj.IsEmpty Then
            removedRoleName = CType(removedRoleObj.GetValue("rolename"), String)
        End If
        Functions.LogEvent("I", "CMS-Administration", "REMOVEUSERFROMROLE", 0, "", removedUserName & "," & removedRoleName)
        Response.Redirect(Page.Request.Url.ToString)
    End Sub


    '''<summary>Displays roles the user is member of in the grid.</summary>
    Private Sub DisplayUsers()
        Dim cn As New GeneralConnection
        cn.ConnectionString = Functions.GetConnectionString
        Querydatagrid1.GeneralConnection = cn
        Querydatagrid1.QueryName = "CMS.Role.GetUsers"
        Querydatagrid1.WhereCondition = " RoleID = '" & RoleID & "' "
    End Sub


    Private Sub dtg_ItemDataBound(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridItemEventArgs) Handles Querydatagrid1.ItemDataBound
        Dim btnCurrentButton As ImageButton

        'set up the Delete button
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            btnCurrentButton = CType(e.Item.Cells(0).FindControl("btnDelete"), ImageButton)
            btnCurrentButton.Attributes.Add("OnClick", "return ConfirmDelete();")
            btnCurrentButton.Attributes.Add("title", deleteHint)
        End If
    End Sub


    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        GoBack()
    End Sub


    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        GoBack()
    End Sub


    '''<summary>Returns user to the list of users.</summary>
    Private Sub GoBack()
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= " GoBack(); "
        ltlScript.Text &= "</script>"
    End Sub
End Class
