Imports Kentico.CMS.DataEngine

Public Class AddRole
    Inherits System.Web.UI.Page

    Protected UserID As Integer

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents txtSearch As System.Web.UI.WebControls.TextBox
    Protected WithEvents btnSearch As System.Web.UI.WebControls.Button
    Protected WithEvents lstItems As System.Web.UI.WebControls.ListBox
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents btnCancel As System.Web.UI.WebControls.Button
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.Administration", "Read") Then
            Functions.RedirectToAccessDenied("CMS.Administration", "Read")
            Exit Sub
        End If

        UserID = Integer.Parse(Request.QueryString("userid"))
        lblHeader.Text = ResMan.GetString("AddRole.Header")
        btnSearch.Text = ResMan.GetString("AddRole.SearchButton")
        btnOK.Text = ResMan.GetString("AddRole.OK")
        btnCancel.Text = ResMan.GetString("AddRole.Cancel")
    End Sub


    Private Sub btnSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSearch.Click
        Dim cn As New GeneralConnection
        Dim ds As DataSet

        'find all roles whose name contains specified string
        cn.ConnectionString = Functions.GetConnectionString
        ds = cn.ExecuteQuery("CMS.Role.SelectList", Nothing, " RoleDisplayName LIKE N'%" & txtSearch.Text.Replace("'", "''") & "%' ", "RoleDisplayName")
        lstItems.DataSource = ds.Tables(0)
        lstItems.DataTextField = "RoleDisplayName"
        lstItems.DataValueField = "RoleID"
        lstItems.DataBind()
    End Sub


    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.Administration", "Modify") Then
            Functions.RedirectToAccessDenied("CMS.Administration", "Modify")
            Exit Sub
        End If

        Dim item As ListItem
        Dim cn As New GeneralConnection
        Dim params(1, 2) As Object

        params(0, 0) = "@UserID"
        params(0, 1) = UserID
        cn.ConnectionString = Functions.GetConnectionString
        cn.DataConnection.Open()
        'get IDs of the selected roles and save changes
        For Each item In lstItems.Items
            If item.Selected Then
                params(1, 0) = "@RoleID"
                params(1, 1) = item.Value
                cn.ExecuteQuery("CMS.User.AddToRole", params)
                Dim addedUserName As String = ""
                Dim addedUserObj As New DataClass("cms.user", UserID, cn)
                If Not addedUserObj.IsEmpty Then
                    addedUserName = CType(addedUserObj.GetValue("username"), String)
                End If
                Functions.LogEvent("I", "CMS-Administration", "ADDUSERTOROLE", 0, "", addedUserName & "," & item.Text)
            End If
        Next
        cn.DataConnection.Close()
        CloseWindow()
    End Sub


    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        CloseWindow()
    End Sub


    '''<summary>Generates script that closes the window and refreshes the parent page.</summary>
    Private Sub CloseWindow()
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= " CloseAndRefresh(); "
        ltlScript.Text &= "</script>"
    End Sub
End Class
