Imports Kentico.CMS.DataEngine

Public Class EditUser
    Inherits System.Web.UI.Page

    Protected UserID As Integer            
    Protected WithEvents lblPreferredUICultureCode As System.Web.UI.WebControls.Label
    Protected WithEvents lblStartingAliasPath As System.Web.UI.WebControls.Label
    Protected WithEvents txtStartingAliasPath As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtPreferredUICultureCode As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblPreferredContentCultureCode As System.Web.UI.WebControls.Label
    Protected WithEvents txtPreferredContentCultureCode As System.Web.UI.WebControls.TextBox
    Const cMaskPassword As String = "?!?!?!?!?!"

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents lblUserID As System.Web.UI.WebControls.Label
    Protected WithEvents lblUserName As System.Web.UI.WebControls.Label
    Protected WithEvents lblFullName As System.Web.UI.WebControls.Label
    Protected WithEvents lblFirstName As System.Web.UI.WebControls.Label
    Protected WithEvents lblMiddleName As System.Web.UI.WebControls.Label
    Protected WithEvents lblLastName As System.Web.UI.WebControls.Label
    Protected WithEvents lblUserIDValue As System.Web.UI.WebControls.Label
    Protected WithEvents txtUserName As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtFullName As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtFirstName As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtMiddleName As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtLastName As System.Web.UI.WebControls.TextBox
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents lblEmail As System.Web.UI.WebControls.Label
    Protected WithEvents txtEmail As System.Web.UI.WebControls.TextBox
    Protected WithEvents btnCancel As System.Web.UI.WebControls.Button
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal
    Protected WithEvents lblPassword As System.Web.UI.WebControls.Label
    Protected WithEvents txtPassword As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblPassword2 As System.Web.UI.WebControls.Label
    Protected WithEvents txtPassword2 As System.Web.UI.WebControls.TextBox

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim cn As GeneralConnection
        Dim userObj As DataClass

        If Request.QueryString("id") <> "" Then
            'check permissions
            If Not Functions.IsAuthorizedPerResource("CMS.Administration", "Modify") Then
                Functions.RedirectToAccessDenied("CMS.Administration", "Modify")
                Exit Sub
            End If
            UserID = Integer.Parse(Request.QueryString("id"))
        Else
            'check permissions
            If Not Functions.IsAuthorizedPerResource("CMS.Administration", "Create") Then
                Functions.RedirectToAccessDenied("CMS.Administration", "Create")
                Exit Sub
            End If
            UserID = 0
        End If

        lblError.Text = ""
        lblError.Visible = False
        lblInfo.Text = ""
        lblInfo.Visible = False
        lblHeader.Text = ResMan.GetString("EditUser.Header")
        lblUserID.Text = ResMan.GetString("EditUser.UserID")
        lblUserName.Text = ResMan.GetString("EditUser.UserName")
        lblFirstName.Text = ResMan.GetString("EditUser.FirstName")
        lblMiddleName.Text = ResMan.GetString("EditUser.MiddleName")
        lblLastName.Text = ResMan.GetString("EditUser.LastName")
        lblEmail.Text = ResMan.GetString("EditUser.Email")
        lblFullName.Text = ResMan.GetString("EditUser.FullName")
        btnOK.Text = ResMan.GetString("EditUser.OK")
        btnCancel.Text = ResMan.GetString("EditUser.Cancel")
        lblPassword.Text = ResMan.GetString("EditUser.Password")
        lblPassword2.Text = ResMan.GetString("EditUser.PasswordConfirm")
        lblPreferredUICultureCode.Text = ResMan.GetString("EditUser.PreferredUICultureCode")
        lblStartingAliasPath.Text = ResMan.GetString("EditUser.StartingAliasPath")
        Me.lblPreferredContentCultureCode.Text = ResMan.GetString("EditUser.PreferredContentCultureCode")

        If Page.IsPostBack = False And UserID <> 0 Then
            'set user values
            cn = New GeneralConnection(Functions.GetConnectionString)
            userObj = New DataClass("CMS.User", UserID, cn)
            txtUserName.Text = CType(userObj.GetValue("UserName"), String)
            txtFirstName.Text = CType(userObj.GetValue("FirstName"), String)
            txtLastName.Text = CType(userObj.GetValue("LastName"), String)
            txtFullName.Text = CType(userObj.GetValue("FullName"), String)
            txtMiddleName.Text = CType(userObj.GetValue("MiddleName"), String)
            txtEmail.Text = CType(userObj.GetValue("Email"), String)
            lblUserIDValue.Text = CType(userObj.GetValue("UserID"), String)
            txtPassword.Attributes.Add("value", cMaskPassword)
            txtPassword2.Attributes.Add("value", cMaskPassword)
            txtPreferredUICultureCode.Text = CType(userObj.GetValue("PreferredUICultureCode"), String)
            txtPreferredContentCultureCode.Text = CType(userObj.GetValue("PreferredContentCultureCode"), String)
            txtStartingAliasPath.Text = CType(userObj.GetValue("StartingAliasPath"), String)
        ElseIf UserID = 0 Then
            lblUserIDValue.Text = ResMan.GetString("EditUser.NoUserIDValue")
        End If

    End Sub


    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        'validate input
        Dim errorMessage As String = ""
        Dim cn As GeneralConnection
        Dim params(0, 2) As String
        Dim userDR As DataRow
        Dim userNamesDS As DataSet
        Dim infoMessage As String
        Dim userObj As DataClass

        If txtUserName.Text.Trim = "" Then
            errorMessage &= ResMan.GetString("EditUser.ErrorEmptyUserName") & " "
        End If
        If txtFullName.Text.Trim = "" Then
            errorMessage &= ResMan.GetString("EditUser.ErrorEmptyFullName") & " "
        End If
        If txtPassword.Text <> txtPassword2.Text Then
            errorMessage &= ResMan.GetString("EditUser.ErrorPasswordConfirmation") & " "
            Me.txtPassword.Text = ""
            Me.txtPassword.Attributes.Remove("value")
            Me.txtPassword2.Text = ""
            Me.txtPassword2.Attributes.Remove("value")
        End If

        If errorMessage = "" Then
            'check for existing user            
            params(0, 0) = "@UserName"
            params(0, 1) = txtUserName.Text.Trim
            cn = New GeneralConnection(Functions.GetConnectionString)
            cn.DataConnection.Open()

            userNamesDS = cn.ExecuteQuery("CMS.User.SelectByUserName", params)
            If UserID = 0 Then
                If userNamesDS.Tables(0).Rows.Count > 0 Then
                    'user name already exists
                    errorMessage &= ResMan.GetString("EditUser.ErrorExistingUserName") & " "
                End If
            Else
                For Each userDR In userNamesDS.Tables(0).Rows
                    If CType(userDR("UserID"), Integer) <> UserID Then
                        'user name already exists
                        errorMessage &= ResMan.GetString("EditUser.ErrorExistingUserName") & " "
                    End If
                Next
            End If

            If errorMessage = "" Then
                'save user info
                If UserID = 0 Then
                    'insert a new user
                    userObj = New DataClass("CMS.User", cn)
                    userObj.SetValue("UserName", txtUserName.Text)
                    userObj.SetValue("FirstName", txtFirstName.Text)
                    userObj.SetValue("MiddleName", txtMiddleName.Text)
                    userObj.SetValue("LastName", txtLastName.Text)
                    userObj.SetValue("FullName", txtFullName.Text)
                    userObj.SetValue("Email", txtEmail.Text)
                    userObj.SetValue("PreferredUICultureCode", txtPreferredUICultureCode.Text.Trim)
                    userObj.SetValue("PreferredContentCultureCode", txtPreferredContentCultureCode.Text.Trim)
                    userObj.SetValue("StartingAliasPath", txtStartingAliasPath.Text.Trim)
                    If txtPassword.Text <> cMaskPassword Then
                        userObj.SetValue("UserPassword", txtPassword.Text)
                    End If
                    userObj.Insert()
                    Functions.LogEvent("I", "CMS-Administration", "CREATEUSER", 0, "", txtUserName.Text)
                    txtUserName.Text = ""
                    txtFullName.Text = ""
                    txtFirstName.Text = ""
                    txtMiddleName.Text = ""
                    txtLastName.Text = ""
                    txtEmail.Text = ""
                    txtPassword.Text = cMaskPassword
                    txtPassword2.Text = cMaskPassword
                    txtPreferredUICultureCode.Text = ""
                    txtPreferredContentCultureCode.Text = ""
                    txtStartingAliasPath.Text = ""
                    infoMessage = ResMan.GetString("EditUser.ChangesInserted")
                Else
                    'update an existing user
                    userObj = New DataClass("CMS.User", UserID, cn)
                    userObj.SetValue("UserName", txtUserName.Text)
                    userObj.SetValue("FirstName", txtFirstName.Text)
                    userObj.SetValue("MiddleName", txtMiddleName.Text)
                    userObj.SetValue("LastName", txtLastName.Text)
                    userObj.SetValue("FullName", txtFullName.Text)
                    userObj.SetValue("Email", txtEmail.Text)
                    userObj.SetValue("PreferredUICultureCode", txtPreferredUICultureCode.Text.Trim)
                    userObj.SetValue("PreferredContentCultureCode", txtPreferredContentCultureCode.Text.Trim)
                    userObj.SetValue("StartingAliasPath", txtStartingAliasPath.Text.Trim)
                    If txtPassword.Text <> cMaskPassword Then
                        userObj.SetValue("UserPassword", txtPassword.Text)
                    End If
                    userObj.Update()
                    Functions.LogEvent("I", "CMS-Administration", "UPDATEUSER", 0, "", txtUserName.Text)
                    infoMessage = ResMan.GetString("EditUser.ChangesSaved")
                    GoBack()
                End If
                HttpContext.Current.Session("CMSUserPreferredUICulture") = Nothing
                HttpContext.Current.Session("CMSPreferredCulture") = Nothing
                Functions.GetPreferredContentCultureCode()
                Functions.GetPreferredUICulture()
            End If
            cn.DataConnection.Close()
        End If

        If errorMessage <> "" Then
            lblError.Text = errorMessage
            lblError.Visible = True
        End If
        If infoMessage <> "" Then
            lblInfo.Text = infoMessage
            lblInfo.Visible = True
        End If
    End Sub


    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        GoBack()
    End Sub


    '''<summary>Returns user to the list of users.</summary>
    Private Sub GoBack()
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= " GoBack(); "
        ltlScript.Text &= "</script>"
    End Sub
End Class
