Imports Kentico.CMS.DataEngine

Public Class UserList
    Inherits System.Web.UI.Page

    Protected editHint As String
    Protected rolesHint As String
    Protected WithEvents btnSearch As System.Web.UI.WebControls.Button
    Protected WithEvents txtFilter As System.Web.UI.WebControls.TextBox
    Protected deleteHint As String

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents QueryDataGrid1 As Kentico.CMS.CMSControls.QueryDataGrid
    Protected WithEvents ltlConfirmScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.Administration", "Read") Then
            Functions.RedirectToAccessDenied("CMS.Administration", "Read")
            Exit Sub
        End If
        editHint = ResMan.GetString("UserList.EditHint")
        rolesHint = ResMan.GetString("UserList.RolesHint")
        deleteHint = ResMan.GetString("UserList.DeleteHint")
        'set column header names
        QueryDataGrid1.Columns(0).HeaderText = ResMan.GetString("UserList.Action")
        QueryDataGrid1.Columns(1).HeaderText = ResMan.GetString("UserList.UserName")
        QueryDataGrid1.Columns(2).HeaderText = ResMan.GetString("UserList.FullName")
        QueryDataGrid1.Columns(3).HeaderText = ResMan.GetString("UserList.Email")
        'confirmation question
        ltlConfirmScript.Text = "<input type=""hidden"" id=""confirmationText"" value=""" & ResMan.GetString("UserList.ConfirmDelete") & """>"
        lblHeader.Text = ResMan.GetString("UserList.Header")
        btnSearch.Text = ResMan.GetString("UserList.Search")

        If Me.IsPostBack Then
            Dim filter As String = Me.txtFilter.Text
            If Not filter Is Nothing AndAlso filter <> "" Then
                Dim where As String = "UserName LIKE '%" & filter & "%' OR FirstName LIKE '%" & filter & "%' OR MiddleName LIKE '%" & filter & "%' OR LastName LIKE '%" & filter & "%' OR FullName LIKE '%" & filter & "%' OR Email LIKE '%" & filter & "%' "
                Me.QueryDataGrid1.WhereCondition = where
            End If
        End If
        DisplayUsers()
    End Sub


    Public Sub DeleteItem(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs)
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.Administration", "Delete") Then
            Functions.RedirectToAccessDenied("CMS.Administration", "Delete")
            Exit Sub
        End If

        'delete user
        Dim id As Integer = Integer.Parse(CType(e.CommandArgument, String))
        Dim cn As New GeneralConnection
        Dim userObj As DataClass
        Dim deletedUserName As String = ""

        cn.ConnectionString = Functions.GetConnectionString
        userObj = New DataClass("cms.user", id, cn)
        If Not userObj.IsEmpty Then
            deletedUserName = CType(userObj.GetValue("username"), String)
            userObj.Delete()
            Functions.LogEvent("I", "CMS-Administration", "DELETEUSER", 0, "", deletedUserName)
        End If
        Response.Redirect(Page.Request.Url.ToString)
    End Sub


    '''<summary>Displays users in the list.</summary>
    Private Sub DisplayUsers()
        Dim cn As New GeneralConnection
        cn.ConnectionString = Functions.GetConnectionString
        QueryDataGrid1.GeneralConnection = cn
        QueryDataGrid1.QueryName = "CMS.User.SelectList"
    End Sub


    Private Sub dtg_ItemDataBound(ByVal sender As System.Object, ByVal e As DataGridItemEventArgs) Handles QueryDataGrid1.ItemDataBound
        Dim btnCurrentButton As ImageButton

        'set up the Delete button
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            btnCurrentButton = CType(e.Item.Cells(0).FindControl("btnDelete"), ImageButton)
            btnCurrentButton.Attributes.Add("OnClick", "return ConfirmDelete();")
            btnCurrentButton.Attributes.Add("title", deleteHint)
        End If
    End Sub

End Class
