Imports Kentico.CMS.TreeEngine
Imports System.IO

Public Class Attachments
    Inherits System.Web.UI.Page

    Protected aliasPath As String
    Protected imgPath As String
    Protected idpath As String
    Protected WithEvents ltlConfirmScript As System.Web.UI.WebControls.Literal
    Protected WithEvents btnSave As System.Web.UI.WebControls.Button
    Protected WithEvents upload As System.Web.UI.HtmlControls.HtmlInputFile
    Protected folderDiskPath As String
    Protected WithEvents pnlFiles As System.Web.UI.WebControls.Panel
    Protected tree As TreeProvider

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents lblUpload As System.Web.UI.WebControls.Label
    Protected WithEvents CMSDataGrid1 As Kentico.CMS.CMSControls.CMSDataGrid

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load        
        'check if the document has already been saved
        Me.lblHeader.Text = ResMan.GetString("Attachments.Header")
        If Request.QueryString("mode") = "insert" Then
            pnlFiles.Visible = False
            Me.lblError.Text = ResMan.GetString("Attachments.SaveDocumentFirst")
            Exit Sub
        End If
        idpath = Request.QueryString("idpath")
        If Not (Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read) Or Functions.IsAuthorizedPerResource("CMS.Content", "Read")) Then
            Functions.RedirectToAccessDenied(idpath, "Read attachment (attachments.aspx)")
            Exit Sub
        End If

        If idpath.EndsWith("/") Then
            Me.CMSDataGrid1.SelectNodesPath = idpath & "%"
        Else
            Me.CMSDataGrid1.SelectNodesPath = idpath & "/%"
        End If

        Me.CMSDataGrid1.Columns(0).HeaderText = ResMan.GetString("Attachments.GridPreview")
        Me.CMSDataGrid1.Columns(1).HeaderText = ResMan.GetString("Attachments.GridSelect")        
        Me.CMSDataGrid1.Columns(2).HeaderText = ResMan.GetString("Attachments.Delete")
        'CType(Me.CMSDataGrid1.Columns(3), ButtonColumn).Text = ResMan.GetString("Attachments.Delete")
        Me.btnSave.Text = ResMan.GetString("Attachments.btnSave")
        ltlConfirmScript.Text = "<input type=""hidden"" id=""confirmationText"" value=""" & ResMan.GetString("Attachments.ConfirmDelete") & """>"
        Me.lblUpload.Text = ResMan.GetString("Attachments.Upload")
        Me.lblError.Text = ""

        tree = Functions.GetTreeProvider
        Dim node As TreeNode = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath)
        aliasPath = Functions.RemoveCultureFromAliasPath(CType(node.GetValue("aliaspath"), String))
        folderDiskPath = Functions.GetFileFolderPath(CType(node.GetValue("aliaspath"), String) & "/temp")
        If Functions.GetConfigValue("CMSWebApplicationVirtualPath") <> "" Then
            imgPath = Functions.GetConfigValue("CMSWebApplicationVirtualPath")
            If imgPath.EndsWith("/") Then
                imgPath = imgPath.Substring(0, imgPath.Length - 1)
            End If
            imgPath = imgPath & aliasPath
        Else
            imgPath = ResolveUrl("~" & aliasPath)
        End If
        If Not imgPath.EndsWith("/") Then
            imgPath &= "/"
        End If

    End Sub

    Private Sub dtg_ItemDataBound(ByVal sender As System.Object, ByVal e As DataGridItemEventArgs) Handles CMSDataGrid1.ItemDataBound
        'Dim btnCurrentButton As ImageButton

        ''set up the Delete button
        'If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
        '    btnCurrentButton = CType(e.Item.Cells(0).FindControl("btnDelete"), ImageButton)
        '    btnCurrentButton.Attributes.Add("OnClick", "return ConfirmDelete();")
        '    btnCurrentButton.Attributes.Add("title", deleteHint)
        '    btnCurrentButton = CType(e.Item.Cells(0).FindControl("btnEdit"), ImageButton)
        '    btnCurrentButton.Attributes.Add("title", editHint)
        'End If
    End Sub


    Public Sub CMSDataGrid1_Delete(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles CMSDataGrid1.ItemCommand
        If e.CommandName <> "Delete" Then
            Exit Sub
        End If

        'check permissions
        If Not (Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Delete) Or Functions.IsAuthorizedPerResource("CMS.Content", "Delete")) Then
            Functions.RedirectToAccessDenied(idpath, "Delete attachment (attachments.aspx)")
            Exit Sub
        End If

        Dim itemCell As TableCell = e.Item.Cells(3)
        Dim delIdPath As String = itemCell.Text        
        Dim delFile As TreeNode = tree.SelectSingleNode(delIdPath, TreePathTypeEnum.IDPath, "cms.file")
        Dim delFileName As String = CType(delFile.GetValue("FileName"), String)
        Dim filePath As String = folderDiskPath & "\" & delFileName        

        'check if it's not used in the article
        Dim publishedText As String = ""
        Dim lastVersionText As String = ""
        Dim articleNode As TreeNode = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath)
        publishedText = CType(articleNode.GetValue("ArticleText"), String).ToLower
        If Not articleNode.GetValue("CheckedOutVersionHistoryID") Is Nothing Then
            Dim verMan As New VersionManager(tree)
            articleNode = verMan.GetVersion(CType(articleNode.GetValue("CheckedOutVersionHistoryID"), Integer))
            lastVersionText = CType(articleNode.GetValue("ArticleText"), String).ToLower
        End If
        If InStr(publishedText, delFileName.ToLower) > 0 Or InStr(lastVersionText, delFileName.ToLower) > 0 Or InStr(publishedText, delFileName.ToLower.Replace(" ", "%20")) > 0 Or InStr(lastVersionText, delFileName.ToLower.Replace(" ", "%20")) > 0 Then
            Me.lblError.Text = ResMan.GetString("Attachments.ErrorAttachmentUsed")
            Exit Sub
        End If

        'delete file
        If File.Exists(filePath) Then
            File.Delete(filePath)
        End If
        delFile.Delete()
        UpdateArticle(0)
    End Sub


    Public Sub CMSDataGrid1_Edit(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles CMSDataGrid1.EditCommand
        'check permissions
        If Not (Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Modify) Or Functions.IsAuthorizedPerResource("CMS.Content", "Modify")) Then
            Functions.RedirectToAccessDenied(idpath, "Modify attachment (attachments.aspx)")
            Exit Sub
        End If

        CMSDataGrid1.EditItemIndex = e.Item.ItemIndex
        viewstate("selectedIdPath") = e.Item.Cells(3).Text
    End Sub

    Private Sub CMSDataGrid1_Update(ByVal source As System.Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles CMSDataGrid1.UpdateCommand
        Dim editBox As TextBox = CType(e.Item.FindControl("txtFileName"), TextBox)
        Dim extensionLabel As Label = CType(e.Item.FindControl("lblFileExtension"), Label)
        Dim oldFileName As String
        Dim oldFileNode As TreeNode = tree.SelectSingleNode(CType(viewstate("selectedIdPath"), String).Trim, TreePathTypeEnum.IDPath, "cms.file")
        oldFileName = CType(oldFileNode.GetValue("FileName"), String)
        If editBox Is Nothing Then
            Exit Sub
        End If
        'check entered file name
        If editBox.Text.Trim = "" Then
            Me.lblError.Text = ResMan.GetString("Attachments.ErrorEmptyFileName")
            Exit Sub
        End If
        'check duplicit file names
        Dim newFileName As String = editBox.Text.Trim & extensionLabel.Text.Trim
        Dim newFilePath As String = folderDiskPath & "\" & newFileName
        If File.Exists(newFilePath) Then
            Me.lblError.Text = ResMan.GetString("Attachments.ErrorFileAlreadyExists")
            Exit Sub
        End If
        'rename file
        File.Move(folderDiskPath & "\" & oldFileName, folderDiskPath & "\" & newFileName)
        oldFileNode.SetValue("FileName", newFileName)
        oldFileNode.Update()
        CMSDataGrid1.EditItemIndex = -1
    End Sub

    Private Sub CMSDataGrid1_Cancel(ByVal source As System.Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles CMSDataGrid1.CancelCommand
        CMSDataGrid1.EditItemIndex = -1
    End Sub

    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
        'check permissions for editing
        If Not (Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Create) Or Functions.IsAuthorizedPerResource("CMS.Content", "Create")) Then
            Functions.RedirectToAccessDenied(idpath, "Create attachment (attachments.aspx)")
            Exit Sub
        End If

        'save file
        If Not upload.PostedFile Is Nothing AndAlso upload.PostedFile.FileName.Trim <> "" Then
            Dim mFileBinary() As Byte
            Dim currentFileName As String
            currentFileName = upload.PostedFile.FileName.Split("\"c)(upload.PostedFile.FileName.Split("\"c).GetUpperBound(0)).Trim
            'get last ID
            Dim articleNode As TreeNode = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath)
            If Not articleNode.GetValue("CheckedOutVersionHistoryID") Is Nothing Then
                Dim verMan As New VersionManager(tree)
                articleNode = verMan.GetVersion(CType(articleNode.GetValue("CheckedOutVersionHistoryID"), Integer))
            End If
            Dim lastAttachmentID As Integer
            If articleNode.GetValue("LastAttachmentID") Is Nothing Then
                lastAttachmentID = 0
            Else
                lastAttachmentID = CType(articleNode.GetValue("LastAttachmentID"), Integer)
            End If
            lastAttachmentID += 1
            UpdateArticle(lastAttachmentID)
            currentFileName = System.IO.Path.GetFileNameWithoutExtension(currentFileName) & "-" & Right("0000" & lastAttachmentID.ToString, 4) & System.IO.Path.GetExtension(currentFileName)
            Dim savePath As String
            If folderDiskPath.EndsWith("\") Then
                savePath = folderDiskPath & currentFileName
            Else
                savePath = folderDiskPath & "\" & currentFileName
            End If
            Dim extension As String = System.IO.Path.GetExtension(upload.PostedFile.FileName)
            If extension.StartsWith(".") Then
                extension = extension.Substring(1)
            End If
            'check if the file extension is allowed
            If (Not ConfigurationSettings.AppSettings("CMSAllowedFileExtensions") Is Nothing) AndAlso ConfigurationSettings.AppSettings("CMSAllowedFileExtensions") <> "" Then
                If InStr(";" & ConfigurationSettings.AppSettings("CMSAllowedFileExtensions").ToLower & ";", ";" & extension.ToLower & ";") = 0 Then
                    Me.lblError.Text = ResMan.GetString("Attachments.ErrorExtensionNotAllowed")
                    Exit Sub
                End If
            End If
            'check if there's no other file of that name already
            'If File.Exists(savePath) Then
            '    Me.lblError.Text = ResMan.GetString("Attachments.ErrorFileAlreadyExists")
            '    Exit Sub
            'End If
            Functions.EnsureDiskPath(savePath, context.Current.Server.MapPath("~/."))
            'save file to the database
            ReDim mFileBinary(upload.PostedFile.ContentLength - 1)
            upload.PostedFile.InputStream.Read(mFileBinary, 0, upload.PostedFile.ContentLength)
            'do not save file to the disk if versioning is used and file is only being updated            
            upload.PostedFile.SaveAs(savePath)
            Dim newFile As New TreeNode("cms.file", tree)
            newFile.SetValue("NodeName", currentFileName)
            newFile.SetValue("FileName", currentFileName)
            newFile.SetValue("FileExtension", extension)
            newFile.SetValue("FileSize", upload.PostedFile.ContentLength)
            newFile.SetValue("FileMimeType", upload.PostedFile.ContentType)
            newFile.SetValue("FileBinary", mFileBinary)
            newFile.Insert(idpath, TreePathTypeEnum.IDPath)
        End If
    End Sub

    Protected Sub cmsdatagrid1_binditem(ByVal sender As Object, ByVal e As DataGridItemEventArgs) Handles CMSDataGrid1.ItemDataBound
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            CType(e.Item.FindControl("deleteButton"), LinkButton).Attributes.Add("onclick", "return ConfirmDelete();")
            CType(e.Item.FindControl("deleteButton"), LinkButton).Text = ResMan.GetString("Attachments.Delete")
        End If
    End Sub

    Protected Function GetFileScript(ByVal fileName As String) As String
        Dim script As String = ""
        If InStr(";.gif;.jpg;.jpeg;.png;.bmp;", ";" & Path.GetExtension(fileName).ToLower & ";") > 0 Then
            'paste image
            script = "PasteImage(""" & Request.QueryString("ftbName") & """, """ & imgPath & fileName & """);"
        Else
            'paste link
            script = "PasteLink(""" & Request.QueryString("ftbName") & """, """ & imgPath & fileName & """, """ & fileName & """);"
        End If
        Return script
    End Function


    Protected Function GetImageTag(ByVal fileName As String) As String
        Dim code As String = ""
        If InStr(";.gif;.jpg;.jpeg;.png;.bmp;", ";" & Path.GetExtension(fileName).ToLower & ";") > 0 Then
            'image
            code = "PasteImage(""" & Request.QueryString("ftbName") & """, """ & imgPath & fileName & """);"
            code = "<img width=""50"" height=""50"" src=""" & imgPath & fileName & """>"
        Else
            'other type
            code = "&nbsp;"
        End If
        Return code        
    End Function


    Protected Sub UpdateArticle(ByVal lastAttachmentId As Integer)
        Dim verMan As New VersionManager(tree)
        Dim node As TreeNode
        node = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath)
        Dim originalNode As TreeNode = node
        node = verMan.GetVersion(CType(node.GetValue("CheckedOutVersionHistoryID"), Integer))
        If node Is Nothing Then
            node = originalNode
        End If
        Try
            tree.Connection.DataConnection.Open()
            tree.Connection.DataConnection.BeginTransaction()
            If ConfigurationSettings.AppSettings("CMSUseCheckinCheckout") = "false" Then
                verMan.CheckOut(CType(node.GetValue("NodeID"), Integer), "")
            End If
            node.SetValue("CheckedOutByUserID", originalNode.GetValue("CheckedOutByUserID"))
            node.SetValue("CheckedOutWhen", originalNode.GetValue("CheckedOutWhen"))
            node.SetValue("CheckedOutVersionHistoryID", originalNode.GetValue("CheckedOutVersionHistoryID"))
            If lastAttachmentId <> 0 Then
                node.SetValue("LastAttachmentID", lastAttachmentId)
            End If            
            verMan.SaveVersion(node)
            'check in the document if content locking is not used
            If ConfigurationSettings.AppSettings("CMSUseCheckinCheckout") = "false" Then
                verMan.CheckIn(CType(node.GetValue("NodeID"), Integer), "", "")
            End If
            tree.Connection.DataConnection.CommitTransaction()
            tree.Connection.DataConnection.Close()
        Catch ex As Exception
            tree.Connection.DataConnection.RollbackTransaction()
            tree.Connection.DataConnection.Close()
            Throw ex
        End Try
    End Sub
End Class
