Imports Kentico.CMS.TreeEngine
Imports Kentico.CMS.MetadataEngine

Public Class BrowseAndEditFrameset
    Inherits System.Web.UI.Page

    Protected targetUrl As String
    Protected idpath As String
    Protected cultureCode As String = ""
    Protected headerSize As Integer

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim path As String
        Dim pathtype As TreePathTypeEnum
        Dim mode As String        
        Dim classname As String
        Dim tree As TreeProvider
        Dim node As TreeNode
        Dim nodes As DataSet
        Dim childpath As String
        Dim closeAndUpdate As String
        headerSize = 50

        'get parameters
        path = Request.QueryString("path") & ""
        mode = Request.QueryString("mode") & ""
        classname = Request.QueryString("classname") & ""
        closeAndUpdate = Request.QueryString("closeandupdate") & ""

        'if not path or mode were specified, exit
        If Trim(path) = "" Or Trim(mode) = "" Then
            Exit Sub
        End If

        If Functions.UseMultilingualSupport Then
            cultureCode = path.Split("/"c)(1)
        End If


        'get path type
        Select Case (Request.QueryString("pathtype") & "").ToLower
            Case "aliaspath"
                pathtype = TreePathTypeEnum.AliasPath
            Case "namepath"
                pathtype = TreePathTypeEnum.NamePath
            Case Else
                pathtype = TreePathTypeEnum.IDPath
        End Select
        tree = Functions.GetTreeProvider

        'get aliaspath if necessary
        If pathtype <> TreePathTypeEnum.AliasPath Then
            Dim tmpNode As TreeNode = tree.SelectSingleNode(path, pathtype)
            If Not tmpNode Is Nothing Then
                path = CType(tmpNode.GetValue("AliasPath"), String)
                pathtype = TreePathTypeEnum.AliasPath
            End If
        End If

        If Functions.UseMultilingualSupport Then
            cultureCode = path.Split("/"c)(1)
        End If

        'get node object to receive its IDPath
        If mode = "new" Then
            node = tree.SelectSingleNode(path, pathtype)
            headerSize = 0
        Else
            node = tree.SelectSingleNode(path, pathtype, classname)
        End If
        If mode = "delete" Then
            headerSize = 0
        End If
        If Not node Is Nothing Then
            idpath = CType(node.GetValue("IDPath"), String)
        Else
            'node not found - try to get the first child node of specified type
            If path = "/" Then
                childpath = "/%"
            Else
                childpath = path & "/%"
            End If
            nodes = tree.SelectNodes(childpath, TreePathTypeEnum.AliasPath, classname)
            If nodes.Tables(0).Rows.Count = 0 Then
                If mode <> "new" Then
                    node = tree.SelectSingleNode(path, pathtype)
                    If node Is Nothing Then
                        If Functions.UseMultilingualSupport Then
                            Dim defaultCultureNode As TreeNode
                            If classname <> "" Then
                                defaultCultureNode = tree.SelectSingleNode("/" & Functions.GetDefaultCulture & Functions.RemoveCultureFromAliasPath(path), TreePathTypeEnum.AliasPath, classname)
                            Else
                                defaultCultureNode = tree.SelectSingleNode("/" & Functions.GetDefaultCulture & Functions.RemoveCultureFromAliasPath(path), TreePathTypeEnum.AliasPath)
                            End If
                            If defaultCultureNode Is Nothing Then
                                'new node
                                mode = "new"
                                Dim parentNode As TreeNode = tree.SelectSingleNode("/" & Functions.GetDefaultCulture & Functions.RemoveCultureFromAliasPath(path), TreePathTypeEnum.AliasPath)
                                If parentNode Is Nothing Then
                                    Exit Sub
                                Else
                                    cultureCode = Functions.GetDefaultCulture
                                    idpath = CType(parentNode.GetValue("idpath"), String)
                                End If
                            Else
                                'new culture version
                                mode = "edit"
                                idpath = CType(defaultCultureNode.GetValue("IDPath"), String)
                            End If
                        Else
                            Exit Sub
                        End If
                    Else
                        mode = "new"
                        idpath = CType(node.GetValue("idpath"), String)
                    End If
                Else
                    Exit Sub
                End If
            Else
                idpath = CType(nodes.Tables(0).Rows(0)("idpath"), String)
            End If
        End If
        'set bottom frame URL according to mode and redirect user to the right form
        Select Case mode
            Case "new"
                If classname = "" Then
                    'no class name specified - let user choose one
                    targetUrl = "new.aspx?newwindow=true&idpath=" & idpath & "&culture=" & cultureCode
                Else
                    'check permissions and redirect user to an appropriate editing form
                    If Functions.IsAuthorizedPerClass(classname, "create") Or Functions.IsAuthorizedPerResource("CMS.Content", "Create") Or Functions.IsAuthorizedPerNode(idpath, Kentico.CMS.TreeEngine.TreePathTypeEnum.IDPath, Kentico.CMS.TreeEngine.NodePermissionsEnum.Create) Then
                        Dim editingPage As String = MetadataProvider.GetSettingsValue(classname, "CMSEditPage")
                        If editingPage = "" Then
                            editingPage = "Edit.aspx"
                        End If
                        targetUrl = editingPage & "?newwindow=true&idpath=" & idpath & "&action=insert&classname=" & classname & "&culture=" & cultureCode
                    Else
                        Functions.RedirectToAccessDenied(idpath, "create")
                    End If
                End If
            Case "edit"
                targetUrl = "edit.aspx?newwindow=true&idpath=" & idpath & "&culture=" & cultureCode
            Case "view"
                targetUrl = "viewFrameset.aspx?newwindow=true&idpath=" & idpath & "&culture=" & cultureCode
            Case "delete"
                targetUrl = "delete.aspx?idpath=" & idpath & "&culture=" & cultureCode
            Case "properties"
                targetUrl = "properties.aspx?idpath=" & idpath & "&culture=" & cultureCode
            Case "lock"
                targetUrl = "lock.aspx?idpath=" & idpath & "&culture=" & cultureCode
            Case "history"
                targetUrl = "history.aspx?idpath=" & idpath & "&culture=" & cultureCode
        End Select
        If closeAndUpdate = "1" Then targetUrl &= "&closeandupdate=1"
    End Sub

End Class
