Imports Kentico.CMS.TreeEngine
Imports Kentico.CMS.MetadataEngine

Public Class Delete
    Inherits System.Web.UI.Page

    Protected node As TreeNode
    Protected usesVersioning As Boolean = False

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents btnYes As System.Web.UI.WebControls.Button
    Protected WithEvents chkDestroy As System.Web.UI.WebControls.CheckBox
    Protected WithEvents btnNo As System.Web.UI.WebControls.Button
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        If Not Page.IsPostBack Then
            Me.lblHeader.Text = ResMan.GetString("Delete.Header")
            Me.chkDestroy.Text = ResMan.GetString("Delete.Destroy")
            Me.btnYes.Text = ResMan.GetString("Delete.Yes")
            Me.btnNo.Text = ResMan.GetString("Delete.No")
        End If
        Me.ltlScript.Text = ""

        Dim idpath As String = Request.QueryString("idpath") & ""
        Dim culture As String = Request.QueryString("culture") & ""
        Dim tree As TreeProvider = Functions.GetTreeProvider

        'get node
        node = Functions.GetNodeByIDPathAndCulture(idpath, culture)

        'multilingual support
        If node Is Nothing Then
            'culture version does not exist            
            node = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath)
            Response.Redirect("NewCultureVersion.aspx?idpath=" & idpath & "&aliaspath=" & CType(node.GetValue("aliaspath"), String) & "&culture=" & culture)
            Exit Sub
        Else
            idpath = CType(node.GetValue("idpath"), String)
        End If

        Me.lblInfo.Text = ResMan.GetString("Delete.Info")
        If Not node Is Nothing Then
            Me.lblInfo.Text &= " """ & CType(node.GetValue("NodeName"), String) & """?"
        End If

        'check permissions
        If Not (Functions.IsAuthorizedPerResource("CMS.Content", "Delete") Or Functions.IsAuthorizedPerResource("CMS.Content", "Destroy") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Delete) Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Destroy)) Then
            Functions.RedirectToAccessDenied(idpath, "Delete (lock.aspx)")
            Exit Sub
        End If

        'check if document type supports versioning
        If Not CType(Functions.GetClassDRValue(CType(node.GetValue("ClassID"), Integer), "UseVersioning"), Boolean) Then
            Me.chkDestroy.Visible = False
            usesVersioning = False
        Else
            'check if document is checked out
            If Not node.GetValue("CheckedOutByUserID") Is Nothing AndAlso CType(node.GetValue("CheckedOutByUserID"), Integer) <> Functions.GetUserID Then
                Me.lblInfo.Text = ResMan.GetString("Delete.ErrorDocumentIsCheckedOut")
                Me.chkDestroy.Enabled = False
                Me.btnYes.Enabled = False
                Me.btnNo.Enabled = False
            End If

            'check if user is not authorized to destroy documents
            If Not (Functions.IsAuthorizedPerResource("CMS.Content", "Destroy") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Destroy)) Then
                Me.chkDestroy.Visible = False
            End If
        End If
    End Sub

    Private Sub btnNo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNo.Click
        'redirect user back to the previous screen
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= "   history.go(-2);"
        ltlScript.Text &= "</script>"
    End Sub

    Private Sub btnYes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnYes.Click
        'delete and update tree
        Dim parentPath As String = node.GetParentPath(TreePathTypeEnum.IDPath)
        ltlScript.Text = "<script language=""javascript"">" & vbCrLf
        ltlScript.Text &= " parent.frames['header'].DeleteSelectedNode('" & Me.chkDestroy.Checked.ToString.ToLower & "'); " & vbCrLf
        ltlScript.Text &= "</script>"
    End Sub
End Class
