Imports Kentico.CMS.TreeEngine

Public Class DocumentPermissions
    Inherits System.Web.UI.Page

    Protected node As TreeNode
    Protected idpath As String
    Protected inheritsPermissions As Boolean
    Protected aclProv As AclProvider
    Protected tree As TreeProvider
    Protected WithEvents btnRemoveOperator As System.Web.UI.WebControls.Button
    Protected WithEvents btnAddOperator As System.Web.UI.WebControls.Button
    Protected WithEvents txtUpdate As System.Web.UI.WebControls.TextBox
    Protected WithEvents btnUpdate As System.Web.UI.WebControls.Button
    Protected WithEvents btnCancel As System.Web.UI.WebControls.Button
    Protected WithEvents lnkInheritance As System.Web.UI.WebControls.LinkButton
    Protected WithEvents lnkRestoreInheritance As System.Web.UI.WebControls.LinkButton
    Protected WithEvents lnkBreakWithCopy As System.Web.UI.WebControls.LinkButton
    Protected WithEvents lnkBreakWithClear As System.Web.UI.WebControls.LinkButton
    Protected WithEvents lblInheritanceInfo As System.Web.UI.WebControls.Label
    Protected WithEvents pnlPermissions As System.Web.UI.WebControls.Panel
    Protected WithEvents pnlInheritance As System.Web.UI.WebControls.Panel
    Protected aclItemsDataSet As DataSet

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents lblUsersRoles As System.Web.UI.WebControls.Label
    Protected WithEvents lstOperators As System.Web.UI.WebControls.ListBox
    Protected WithEvents lblPermissions As System.Web.UI.WebControls.Label
    Protected WithEvents lblFullControl As System.Web.UI.WebControls.Label
    Protected WithEvents lblAllow As System.Web.UI.WebControls.Label
    Protected WithEvents lblDeny As System.Web.UI.WebControls.Label
    Protected WithEvents chkFullControlAllow As System.Web.UI.WebControls.CheckBox
    Protected WithEvents chkFullControlDeny As System.Web.UI.WebControls.CheckBox
    Protected WithEvents lblRead As System.Web.UI.WebControls.Label
    Protected WithEvents lblModify As System.Web.UI.WebControls.Label
    Protected WithEvents lblCreate As System.Web.UI.WebControls.Label
    Protected WithEvents lblDelete As System.Web.UI.WebControls.Label
    Protected WithEvents lblDestroy As System.Web.UI.WebControls.Label
    Protected WithEvents lblExploreTree As System.Web.UI.WebControls.Label
    Protected WithEvents lblManagePermissions As System.Web.UI.WebControls.Label
    Protected WithEvents chkReadAllow As System.Web.UI.WebControls.CheckBox
    Protected WithEvents chkReadDeny As System.Web.UI.WebControls.CheckBox
    Protected WithEvents chkModifyAllow As System.Web.UI.WebControls.CheckBox
    Protected WithEvents chkModifyDeny As System.Web.UI.WebControls.CheckBox
    Protected WithEvents chkCreateAllow As System.Web.UI.WebControls.CheckBox
    Protected WithEvents chkCreateDeny As System.Web.UI.WebControls.CheckBox
    Protected WithEvents chkDeleteAllow As System.Web.UI.WebControls.CheckBox
    Protected WithEvents chkDeleteDeny As System.Web.UI.WebControls.CheckBox
    Protected WithEvents chkDestroyAllow As System.Web.UI.WebControls.CheckBox
    Protected WithEvents chkDestroyDeny As System.Web.UI.WebControls.CheckBox
    Protected WithEvents chkExploreTreeAllow As System.Web.UI.WebControls.CheckBox
    Protected WithEvents chkExploreTreeDeny As System.Web.UI.WebControls.CheckBox
    Protected WithEvents chkManagePermissionsAllow As System.Web.UI.WebControls.CheckBox
    Protected WithEvents chkManagePermissionsDeny As System.Web.UI.WebControls.CheckBox
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Functions.RedirectExpressEdition("CMSDesk.DocumentPermissions")

        Me.lblInfo.Text = ""
        Dim culture As String = Request.QueryString("culture") & ""
        idpath = Request.QueryString("idpath") & ""
        tree = Functions.GetTreeProvider
        aclProv = New AclProvider(tree)

        If (Not Page.IsPostBack) And Request.QueryString("returnback") & "" <> "" Then
            viewstate("returnback") = Request.UrlReferrer.ToString
        End If

        'set labels
        If Not Page.IsPostBack Then
            Me.lblHeader.Text = ResMan.GetString("DocumentPermissions.Header")
            Me.lblUsersRoles.Text = ResMan.GetString("DocumentPermissions.UsersRoles")
            Me.lblPermissions.Text = ResMan.GetString("DocumentPermissions.Permissions")
            Me.lblAllow.Text = ResMan.GetString("DocumentPermissions.Allow")
            Me.lblDeny.Text = ResMan.GetString("DocumentPermissions.Deny")
            Me.lblFullControl.Text = ResMan.GetString("DocumentPermissions.FullControl")
            Me.lblRead.Text = ResMan.GetString("DocumentPermissions.Read")
            Me.lblModify.Text = ResMan.GetString("DocumentPermissions.Modify")
            Me.lblCreate.Text = ResMan.GetString("DocumentPermissions.Create")
            Me.lblDelete.Text = ResMan.GetString("DocumentPermissions.Delete")
            Me.lblDestroy.Text = ResMan.GetString("DocumentPermissions.Destroy")
            Me.lblExploreTree.Text = ResMan.GetString("DocumentPermissions.ExploreTree")
            Me.lblManagePermissions.Text = ResMan.GetString("DocumentPermissions.ManagePermissions")
            Me.btnOK.Text = ResMan.GetString("DocumentPermissions.OK")
            Me.btnAddOperator.Text = ResMan.GetString("DocumentPermissions.AddOperator")
            Me.btnRemoveOperator.Text = ResMan.GetString("DocumentPermissions.RemoveOperator")
            Me.lnkBreakWithClear.Text = ResMan.GetString("DocumentPermissions.BreakWithClear")
            Me.lnkBreakWithCopy.Text = ResMan.GetString("DocumentPermissions.BreakWithCopy")
            Me.lnkRestoreInheritance.Text = ResMan.GetString("DocumentPermissions.RestoreInheritance")
            Me.btnCancel.Text = ResMan.GetString("DocumentPermissions.Cancel")
            Me.lnkInheritance.Text = ResMan.GetString("DocumentPermissions.Inheritance")
        End If

        'get node
        If idpath = "/" Then
            'select the root node even if multilingual support is used
            node = tree.SelectSingleNode("/", TreePathTypeEnum.IDPath)
        Else
            node = Functions.GetNodeByIDPathAndCulture(idpath, culture)

            'multilingual support
            If node Is Nothing Then
                'culture version does not exist            
                node = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath)
                Response.Redirect("NewCultureVersion.aspx?idpath=" & idpath & "&aliaspath=" & CType(node.GetValue("aliaspath"), String) & "&culture=" & culture)
                Exit Sub
            Else
                idpath = CType(node.GetValue("idpath"), String)
            End If
        End If

        'check permissions
        If Not (Functions.IsAuthorizedPerResource("CMS.Content", "ModifyPermissions") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.ModifyPermissions)) Then
            Functions.RedirectToAccessDenied(idpath, "Modify permissions (documentpermissions.aspx)")
            Exit Sub
        End If

        If Not Page.IsPostBack Then
            'load operators
            LoadOperators()
        End If

        'check if document inherits permissions and display info
        inheritsPermissions = aclProv.DoesNodeInheritPermissions(idpath, TreePathTypeEnum.IDPath)
        If inheritsPermissions Then
            Me.lblInheritanceInfo.Text = ResMan.GetString("DocumentPermissions.InheritsInfo.Inherits")
        Else
            Me.lblInheritanceInfo.Text = ResMan.GetString("DocumentPermissions.InheritsInfo.DoesNotInherit")
        End If

        'add additional events to controls
        Me.btnAddOperator.Attributes.Add("onclick", "javascript:AddOperator('" & idpath & "');")
        txtUpdate.Attributes.Add("onpropertychange", Page.GetPostBackEventReference(btnUpdate))

        'hide link to the inheritance settings if this is the parent node
        If idpath = "/" Then
            Me.lnkInheritance.Visible = False
        End If
    End Sub


    '''<summary>Loads users and roles listed in the ACL of the selected document and displays them in the listbox.</summary>
    Private Sub LoadOperators()
        Dim aclItemsDS As DataSet
        Dim aclItemDR As DataRow
        Dim lastOperator As String = ""

        Me.lstOperators.Items.Clear()
        aclItemsDS = Me.GetACLItems
        If Not aclItemsDS Is Nothing AndAlso aclItemsDS.Tables.Count > 0 Then
            For Each aclItemDR In aclItemsDS.Tables(0).Rows
                If CType(aclItemDR("Operator"), String) <> lastOperator Then
                    lastOperator = CType(aclItemDR("Operator"), String)
                    Me.lstOperators.Items.Add(New ListItem(CType(aclItemDR("OperatorName"), String), CType(aclItemDR("Operator"), String)))
                End If
            Next
        End If
        If lstOperators.Items.Count > 0 Then
            lstOperators.SelectedIndex = 0
            DisplayOperatorPermissions(lstOperators.SelectedValue)
        End If
    End Sub


    '''<summary>Returns ACLItems for the selected document.</summary>
    Private Function GetACLItems() As DataSet
        If aclItemsDataSet Is Nothing Then
            aclItemsDataSet = aclProv.GetACLItems(idpath, TreePathTypeEnum.IDPath)
        End If
        Return aclItemsDataSet
    End Function


    '''<summary>Displays permissions of the selected operator (user or role).</summary>
    '''<param name="operatorID">OperatorID in format U123 or R123 where U/R indicates user/role and 123 is UserID/RoleID value.</param>
    Private Sub DisplayOperatorPermissions(ByVal operatorID As String)
        ResetPermissions()

        Dim aclItemsDS As DataSet = Me.GetACLItems
        Dim rows() As DataRow
        Dim i As Integer
        Dim allowed As Integer
        Dim denied As Integer
        Dim hasNativePermissions As Boolean = False
        Dim hasInheritedPermissions As Boolean = False

        If Not aclItemsDS Is Nothing AndAlso aclItemsDS.Tables.Count > 0 Then
            'process inherited permissions
            rows = aclItemsDS.Tables(0).Select(" Operator = '" & operatorID & "' AND OwnerNodeID <> '" & CType(node.GetValue("NodeID"), Integer).ToString & "' ")
            For i = 0 To rows.GetUpperBound(0)
                hasInheritedPermissions = True
                allowed = CType(rows(i)("Allowed"), Integer)
                denied = CType(rows(i)("Denied"), Integer)
                'set "allow" check boxes for inherited permissions
                Me.chkReadAllow.Checked = Me.chkReadAllow.Checked Or IsPermissionTrue(allowed, NodePermissionsEnum.Read)
                Me.chkReadAllow.Enabled = Me.chkReadAllow.Enabled And Not IsPermissionTrue(allowed, NodePermissionsEnum.Read)
                Me.chkModifyAllow.Checked = Me.chkModifyAllow.Checked Or IsPermissionTrue(allowed, NodePermissionsEnum.Modify)
                Me.chkModifyAllow.Enabled = Me.chkModifyAllow.Enabled And Not IsPermissionTrue(allowed, NodePermissionsEnum.Modify)
                Me.chkCreateAllow.Checked = Me.chkCreateAllow.Checked Or IsPermissionTrue(allowed, NodePermissionsEnum.Create)
                Me.chkCreateAllow.Enabled = Me.chkCreateAllow.Enabled And Not IsPermissionTrue(allowed, NodePermissionsEnum.Create)
                Me.chkDeleteAllow.Checked = Me.chkDeleteAllow.Checked Or IsPermissionTrue(allowed, NodePermissionsEnum.Delete)
                Me.chkDeleteAllow.Enabled = Me.chkDeleteAllow.Enabled And Not IsPermissionTrue(allowed, NodePermissionsEnum.Delete)
                Me.chkDestroyAllow.Checked = Me.chkDestroyAllow.Checked Or IsPermissionTrue(allowed, NodePermissionsEnum.Destroy)
                Me.chkDestroyAllow.Enabled = Me.chkDestroyAllow.Enabled And Not IsPermissionTrue(allowed, NodePermissionsEnum.Destroy)
                Me.chkExploreTreeAllow.Checked = Me.chkExploreTreeAllow.Checked Or IsPermissionTrue(allowed, NodePermissionsEnum.ExploreTree)
                Me.chkExploreTreeAllow.Enabled = Me.chkExploreTreeAllow.Enabled And Not IsPermissionTrue(allowed, NodePermissionsEnum.ExploreTree)
                Me.chkManagePermissionsAllow.Checked = Me.chkManagePermissionsAllow.Checked Or IsPermissionTrue(allowed, NodePermissionsEnum.ModifyPermissions)
                Me.chkManagePermissionsAllow.Enabled = Me.chkManagePermissionsAllow.Enabled And Not IsPermissionTrue(allowed, NodePermissionsEnum.ModifyPermissions)
                'set "deny" checkboxes for inherited permissions
                Me.chkReadDeny.Checked = Me.chkReadDeny.Checked Or IsPermissionTrue(denied, NodePermissionsEnum.Read)
                Me.chkReadDeny.Enabled = Me.chkReadDeny.Enabled And Not IsPermissionTrue(denied, NodePermissionsEnum.Read)
                Me.chkModifyDeny.Checked = Me.chkModifyDeny.Checked Or IsPermissionTrue(denied, NodePermissionsEnum.Modify)
                Me.chkModifyDeny.Enabled = Me.chkModifyDeny.Enabled And Not IsPermissionTrue(denied, NodePermissionsEnum.Modify)
                Me.chkCreateDeny.Checked = Me.chkCreateDeny.Checked Or IsPermissionTrue(denied, NodePermissionsEnum.Create)
                Me.chkCreateDeny.Enabled = Me.chkCreateDeny.Enabled And Not IsPermissionTrue(denied, NodePermissionsEnum.Create)
                Me.chkDeleteDeny.Checked = Me.chkDeleteDeny.Checked Or IsPermissionTrue(denied, NodePermissionsEnum.Delete)
                Me.chkDeleteDeny.Enabled = Me.chkDeleteDeny.Enabled And Not IsPermissionTrue(denied, NodePermissionsEnum.Delete)
                Me.chkDestroyDeny.Checked = Me.chkDestroyDeny.Checked Or IsPermissionTrue(denied, NodePermissionsEnum.Destroy)
                Me.chkDestroyDeny.Enabled = Me.chkDestroyDeny.Enabled And Not IsPermissionTrue(denied, NodePermissionsEnum.Destroy)
                Me.chkExploreTreeDeny.Checked = Me.chkExploreTreeDeny.Checked Or IsPermissionTrue(denied, NodePermissionsEnum.ExploreTree)
                Me.chkExploreTreeDeny.Enabled = Me.chkExploreTreeDeny.Enabled And Not IsPermissionTrue(denied, NodePermissionsEnum.ExploreTree)
                Me.chkManagePermissionsDeny.Checked = Me.chkManagePermissionsDeny.Checked Or IsPermissionTrue(denied, NodePermissionsEnum.ModifyPermissions)
                Me.chkManagePermissionsDeny.Enabled = Me.chkManagePermissionsDeny.Enabled And Not IsPermissionTrue(denied, NodePermissionsEnum.ModifyPermissions)
            Next
            'process native permissions
            rows = aclItemsDS.Tables(0).Select(" Operator = '" & operatorID & "' AND OwnerNodeID = '" & CType(node.GetValue("NodeID"), Integer).ToString & "' ")
            For i = 0 To rows.GetUpperBound(0)
                hasNativePermissions = True
                allowed = CType(rows(i)("Allowed"), Integer)
                denied = CType(rows(i)("Denied"), Integer)
                'set "allow" check boxes for native permissions
                SetCheckBoxWithNativePermission(chkReadAllow, IsPermissionTrue(allowed, NodePermissionsEnum.Read))
                SetCheckBoxWithNativePermission(chkModifyAllow, IsPermissionTrue(allowed, NodePermissionsEnum.Modify))
                SetCheckBoxWithNativePermission(chkCreateAllow, IsPermissionTrue(allowed, NodePermissionsEnum.Create))
                SetCheckBoxWithNativePermission(chkDeleteAllow, IsPermissionTrue(allowed, NodePermissionsEnum.Delete))
                SetCheckBoxWithNativePermission(chkDestroyAllow, IsPermissionTrue(allowed, NodePermissionsEnum.Destroy))
                SetCheckBoxWithNativePermission(chkExploreTreeAllow, IsPermissionTrue(allowed, NodePermissionsEnum.ExploreTree))
                SetCheckBoxWithNativePermission(chkManagePermissionsAllow, IsPermissionTrue(allowed, NodePermissionsEnum.ModifyPermissions))
                'set "deny" checkboxes for inherited permissions
                SetCheckBoxWithNativePermission(chkReadDeny, IsPermissionTrue(denied, NodePermissionsEnum.Read))
                SetCheckBoxWithNativePermission(chkModifyDeny, IsPermissionTrue(denied, NodePermissionsEnum.Modify))
                SetCheckBoxWithNativePermission(chkCreateDeny, IsPermissionTrue(denied, NodePermissionsEnum.Create))
                SetCheckBoxWithNativePermission(chkDeleteDeny, IsPermissionTrue(denied, NodePermissionsEnum.Delete))
                SetCheckBoxWithNativePermission(chkDestroyDeny, IsPermissionTrue(denied, NodePermissionsEnum.Destroy))
                SetCheckBoxWithNativePermission(chkExploreTreeDeny, IsPermissionTrue(denied, NodePermissionsEnum.ExploreTree))
                SetCheckBoxWithNativePermission(chkManagePermissionsDeny, IsPermissionTrue(denied, NodePermissionsEnum.ModifyPermissions))
            Next
        End If

        Me.btnRemoveOperator.Enabled = (Not hasInheritedPermissions) And hasNativePermissions
        CheckFullControlBox()
    End Sub


    '''<summary>Parses permission value and return true if appropriate bit is 1.</summary>
    Protected Function IsPermissionTrue(ByVal permissionValue As Integer, ByVal permission As NodePermissionsEnum) As Boolean
        Return ((permissionValue >> CType(permission, Integer)) Mod 2) = 1
    End Function


    '''<summary>Checks checkbox if provided value is true.</summary>
    Protected Sub SetCheckBoxWithNativePermission(ByVal chkBox As CheckBox, ByVal value As Boolean)
        If value = True Then
            chkBox.Checked = value
        End If
    End Sub


    '''<summary>Returns integer value representing permission value of the given checkbox and permission name.</summary>
    Protected Function GetCheckBoxValue(ByVal chkBox As CheckBox, ByVal permission As NodePermissionsEnum) As Integer
        If chkBox.Enabled And chkBox.Checked Then
            Return CType(2 ^ CType(permission, Integer), Integer)
        Else
            Return 0
        End If
    End Function


    Protected Sub lstOperators_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstOperators.SelectedIndexChanged
        If Not lstOperators.SelectedItem Is Nothing Then
            DisplayOperatorPermissions(lstOperators.SelectedValue)
        End If
    End Sub

    '''<summary>Saves data.</summary>
    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        Dim allowed As Integer = 0
        Dim denied As Integer = 0
        Dim operatorID As String

        If Me.lstOperators.SelectedItem Is Nothing Then
            Exit Sub
        Else
            operatorID = lstOperators.SelectedValue
            allowed += Me.GetCheckBoxValue(Me.chkReadAllow, NodePermissionsEnum.Read)
            allowed += Me.GetCheckBoxValue(Me.chkModifyAllow, NodePermissionsEnum.Modify)
            allowed += Me.GetCheckBoxValue(Me.chkCreateAllow, NodePermissionsEnum.Create)
            allowed += Me.GetCheckBoxValue(Me.chkDeleteAllow, NodePermissionsEnum.Delete)
            allowed += Me.GetCheckBoxValue(Me.chkDestroyAllow, NodePermissionsEnum.Destroy)
            allowed += Me.GetCheckBoxValue(Me.chkExploreTreeAllow, NodePermissionsEnum.ExploreTree)
            allowed += Me.GetCheckBoxValue(Me.chkManagePermissionsAllow, NodePermissionsEnum.ModifyPermissions)
            denied += Me.GetCheckBoxValue(Me.chkReadDeny, NodePermissionsEnum.Read)
            denied += Me.GetCheckBoxValue(Me.chkModifyDeny, NodePermissionsEnum.Modify)
            denied += Me.GetCheckBoxValue(Me.chkCreateDeny, NodePermissionsEnum.Create)
            denied += Me.GetCheckBoxValue(Me.chkDeleteDeny, NodePermissionsEnum.Delete)
            denied += Me.GetCheckBoxValue(Me.chkDestroyDeny, NodePermissionsEnum.Destroy)
            denied += Me.GetCheckBoxValue(Me.chkExploreTreeDeny, NodePermissionsEnum.ExploreTree)
            denied += Me.GetCheckBoxValue(Me.chkManagePermissionsDeny, NodePermissionsEnum.ModifyPermissions)

            If operatorID.StartsWith("U") Then
                aclProv.SetUserPermissions(idpath, TreePathTypeEnum.IDPath, allowed, denied, Integer.Parse(operatorID.Substring(1)))
            Else
                aclProv.SetRolePermissions(idpath, TreePathTypeEnum.IDPath, allowed, denied, Integer.Parse(operatorID.Substring(1)))
            End If
            Me.lblInfo.Text = ResMan.GetString("DocumentPermissions.ChangesSaved")
        End If
    End Sub


    Private Sub btnUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUpdate.Click
        Me.LoadOperators()
    End Sub


    '''<summary>Removes selected operator from the ACL.</summary>
    Private Sub btnRemoveOperator_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRemoveOperator.Click
        If lstOperators.SelectedItem Is Nothing Then
            Exit Sub
        End If

        Dim operatorID As String = lstOperators.SelectedValue
        If operatorID.StartsWith("U") Then
            aclProv.RemoveUser(idpath, TreePathTypeEnum.IDPath, Integer.Parse(operatorID.Substring(1)))
        Else
            aclProv.RemoveRole(idpath, TreePathTypeEnum.IDPath, Integer.Parse(operatorID.Substring(1)))
        End If
        LoadOperators()
    End Sub


    '''<summary>Resets all checkboxes representing permissions.</summary>
    Protected Sub ResetPermissions()
        ResetCheckBox(Me.chkReadAllow)
        ResetCheckBox(Me.chkReadDeny)
        ResetCheckBox(Me.chkCreateAllow)
        ResetCheckBox(Me.chkCreateDeny)
        ResetCheckBox(Me.chkModifyAllow)
        ResetCheckBox(Me.chkModifyDeny)
        ResetCheckBox(Me.chkDeleteAllow)
        ResetCheckBox(Me.chkDeleteDeny)
        ResetCheckBox(Me.chkDestroyAllow)
        ResetCheckBox(Me.chkDestroyDeny)
        ResetCheckBox(Me.chkExploreTreeAllow)
        ResetCheckBox(Me.chkExploreTreeDeny)
        ResetCheckBox(Me.chkManagePermissionsAllow)
        ResetCheckBox(Me.chkManagePermissionsDeny)
    End Sub


    '''<summary>Resets given checkbox.</summary>
    Protected Sub ResetCheckBox(ByVal chkBox As CheckBox)
        chkBox.Enabled = True
        chkBox.Checked = False
    End Sub


    '''<summary>Displays inheritance settings.</summary>
    Private Sub lnkInheritance_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkInheritance.Click
        Me.pnlPermissions.Visible = False
        Me.pnlInheritance.Visible = True

        'test if current document inherits permissions
        If inheritsPermissions Then
            Me.lnkBreakWithClear.Visible = True
            Me.lnkBreakWithCopy.Visible = True
            Me.lnkRestoreInheritance.Visible = False
        Else
            Me.lnkBreakWithClear.Visible = False
            Me.lnkBreakWithCopy.Visible = False
            Me.lnkRestoreInheritance.Visible = True
        End If
    End Sub


    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        SwitchBackToPermissionsMode()
    End Sub


    Private Sub SwitchBackToPermissionsMode()
        Me.pnlPermissions.Visible = True
        Me.pnlInheritance.Visible = False
    End Sub


    Private Sub lnkBreakWithCopy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkBreakWithCopy.Click
        'break permission inheritance and copy parent permissions
        aclProv.BreakInherintance(idpath, TreePathTypeEnum.IDPath, True)
        Me.lblInheritanceInfo.Text = ResMan.GetString("DocumentPermissions.InheritsInfo.DoesNotInherit")
        SwitchBackToPermissionsMode()
        LoadOperators()
    End Sub


    Private Sub lnkBreakWithClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkBreakWithClear.Click
        'break permission inheritance and clear permissions
        aclProv.BreakInherintance(idpath, TreePathTypeEnum.IDPath, False)
        Me.lblInheritanceInfo.Text = ResMan.GetString("DocumentPermissions.InheritsInfo.DoesNotInherit")
        SwitchBackToPermissionsMode()
        LoadOperators()
    End Sub


    Private Sub lnkRestoreInheritance_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkRestoreInheritance.Click
        'restore inheritance and add permissions inherited from the parent document
        aclProv.RestoreInheritance(idpath, TreePathTypeEnum.IDPath)
        Me.lblInheritanceInfo.Text = ResMan.GetString("DocumentPermissions.InheritsInfo.Inherits")
        SwitchBackToPermissionsMode()
        LoadOperators()
    End Sub

    Private Sub chkFullControlAllow_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkFullControlAllow.CheckedChanged
        'check all enabled checkboxes
        CheckEnabledCheckbox(Me.chkReadAllow, chkFullControlAllow.Checked)
        CheckEnabledCheckbox(Me.chkCreateAllow, chkFullControlAllow.Checked)
        CheckEnabledCheckbox(Me.chkModifyAllow, chkFullControlAllow.Checked)
        CheckEnabledCheckbox(Me.chkDeleteAllow, chkFullControlAllow.Checked)
        CheckEnabledCheckbox(Me.chkDestroyAllow, chkFullControlAllow.Checked)
        CheckEnabledCheckbox(Me.chkExploreTreeAllow, chkFullControlAllow.Checked)
        CheckEnabledCheckbox(Me.chkManagePermissionsAllow, chkFullControlAllow.Checked)        
    End Sub

    Protected Sub CheckEnabledCheckbox(ByVal chkBox As CheckBox, ByVal checked As Boolean)
        If chkBox.Enabled Then
            chkBox.Checked = checked
        End If
    End Sub

    Private Sub chkFullControlDeny_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkFullControlDeny.CheckedChanged
        'check all deny checkboxes
        CheckEnabledCheckbox(Me.chkReadDeny, chkFullControlDeny.Checked)
        CheckEnabledCheckbox(Me.chkCreateDeny, chkFullControlDeny.Checked)
        CheckEnabledCheckbox(Me.chkModifyDeny, chkFullControlDeny.Checked)
        CheckEnabledCheckbox(Me.chkDeleteDeny, chkFullControlDeny.Checked)
        CheckEnabledCheckbox(Me.chkDestroyDeny, chkFullControlDeny.Checked)
        CheckEnabledCheckbox(Me.chkExploreTreeDeny, chkFullControlDeny.Checked)
        CheckEnabledCheckbox(Me.chkManagePermissionsDeny, chkFullControlDeny.Checked)
    End Sub

    Private Sub chkReadAllow_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkReadAllow.CheckedChanged
        If Me.chkReadAllow.Checked = False Then
            Me.chkFullControlAllow.Checked = False
        End If
        CheckFullControlBox()
    End Sub

    Private Sub chkModifyAllow_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkModifyAllow.CheckedChanged
        If Me.chkModifyAllow.Checked = False Then
            Me.chkFullControlAllow.Checked = False
        End If
        CheckFullControlBox()
    End Sub

    Private Sub chkCreateAllow_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkCreateAllow.CheckedChanged
        If Me.chkCreateAllow.Checked = False Then
            Me.chkFullControlAllow.Checked = False
        End If
        CheckFullControlBox()
    End Sub

    Private Sub chkDeleteAllow_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDeleteAllow.CheckedChanged
        If Me.chkDeleteAllow.Checked = False Then
            Me.chkFullControlAllow.Checked = False
        End If
        CheckFullControlBox()
    End Sub

    Private Sub chkDestroyAllow_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDestroyAllow.CheckedChanged
        If Me.chkDestroyAllow.Checked = False Then
            Me.chkFullControlAllow.Checked = False
        End If
        CheckFullControlBox()
    End Sub

    Private Sub chkExploreTreeAllow_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkExploreTreeAllow.CheckedChanged
        If Me.chkExploreTreeAllow.Checked = False Then
            Me.chkFullControlAllow.Checked = False
        End If
        CheckFullControlBox()
    End Sub

    Private Sub chkManagePermissionsAllow_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkManagePermissionsAllow.CheckedChanged
        If Me.chkManagePermissionsAllow.Checked = False Then
            Me.chkFullControlAllow.Checked = False
        End If
        CheckFullControlBox()
    End Sub


    Private Sub chkReadDeny_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkReadDeny.CheckedChanged
        If Me.chkReadDeny.Checked = False Then
            Me.chkFullControlDeny.Checked = False
        End If
        CheckFullControlBox()
    End Sub


    Private Sub chkModifyDeny_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkModifyDeny.CheckedChanged
        If Me.chkModifyDeny.Checked = False Then
            Me.chkFullControlDeny.Checked = False
        End If
        CheckFullControlBox()
    End Sub

    Private Sub chkCreateDeny_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkCreateDeny.CheckedChanged
        If Me.chkCreateDeny.Checked = False Then
            Me.chkFullControlDeny.Checked = False
        End If
        CheckFullControlBox()
    End Sub

    Private Sub chkDeleteDeny_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDeleteDeny.CheckedChanged
        If Me.chkDeleteDeny.Checked = False Then
            Me.chkFullControlDeny.Checked = False
        End If
        CheckFullControlBox()
    End Sub

    Private Sub chkDestroyDeny_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDestroyDeny.CheckedChanged
        If Me.chkDestroyDeny.Checked = False Then
            Me.chkFullControlDeny.Checked = False
        End If
        CheckFullControlBox()
    End Sub

    Private Sub chkExploreTreeDeny_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkExploreTreeDeny.CheckedChanged
        If Me.chkExploreTreeDeny.Checked = False Then
            Me.chkFullControlDeny.Checked = False
        End If
        CheckFullControlBox()
    End Sub

    Private Sub chkManagePermissionsDeny_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkManagePermissionsDeny.CheckedChanged
        If Me.chkManagePermissionsDeny.Checked = False Then
            Me.chkFullControlDeny.Checked = False
        End If
        CheckFullControlBox()
    End Sub

    Private Sub CheckFullControlBox()
        Me.chkFullControlAllow.Checked = Me.chkReadAllow.Checked And Me.chkModifyAllow.Checked And Me.chkCreateAllow.Checked And Me.chkDeleteAllow.Checked And Me.chkDestroyAllow.Checked And Me.chkExploreTreeAllow.Checked And Me.chkManagePermissionsAllow.Checked
        Me.chkFullControlDeny.Checked = Me.chkReadDeny.Checked And Me.chkModifyDeny.Checked And Me.chkCreateDeny.Checked And Me.chkDeleteDeny.Checked And Me.chkDestroyDeny.Checked And Me.chkExploreTreeDeny.Checked And Me.chkManagePermissionsDeny.Checked
    End Sub
End Class
