Imports Kentico.CMS.DataEngine
Imports Kentico.CMS.TreeEngine

Public Class DocumentPermissionsAddOperator
    Inherits System.Web.UI.Page

    Protected idpath As String
    Protected title As String

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents txtSearch As System.Web.UI.WebControls.TextBox
    Protected WithEvents btnSearch As System.Web.UI.WebControls.Button
    Protected WithEvents lstItems As System.Web.UI.WebControls.ListBox
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents btnCancel As System.Web.UI.WebControls.Button
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        idpath = Request.QueryString("idpath")
        lblHeader.Text = ResMan.GetString("DocumentPermissionsAddOperator.Header")
        btnSearch.Text = ResMan.GetString("DocumentPermissionsAddOperator.SearchButton")
        btnOK.Text = ResMan.GetString("DocumentPermissionsAddOperator.OK")
        btnCancel.Text = ResMan.GetString("DocumentPermissionsAddOperator.Cancel")
        title = ResMan.GetString("DocumentPermissionsAddOperator.Title")

        'check permissions
        If Not (Functions.IsAuthorizedPerResource("CMS.Content", "ModifyPermissions") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.ModifyPermissions)) Then
            Functions.RedirectToAccessDenied(idpath, "Modify permissions (documentpermissions.aspx)")
            Exit Sub
        End If
    End Sub


    Private Sub btnSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSearch.Click
        Dim cn As New GeneralConnection
        Dim ds As DataSet
        Dim searchParams(0, 2) As Object
        searchParams(0, 0) = "@search"
        searchParams(0, 1) = "%" & Me.txtSearch.Text & "%"

        'find all users and roles whose name contains specified string
        cn.ConnectionString = Functions.GetConnectionString
        ds = cn.ExecuteQuery("CMS.Role.SelectRolesAndUsers", searchParams)
        lstItems.DataSource = ds.Tables(0)
        lstItems.DataTextField = "OperatorName"
        lstItems.DataValueField = "OperatorID"
        lstItems.DataBind()
    End Sub


    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        Dim item As ListItem
        Dim queryParams(1, 2) As Object
        Dim aclProv As New AclProvider(Functions.GetTreeProvider)

        'get IDs of the selected users/roles and save changes
        For Each item In lstItems.Items
            If item.Selected Then
                If item.Value.StartsWith("U") Then
                    aclProv.SetUserPermissions(idpath, TreePathTypeEnum.IDPath, 0, 0, Integer.Parse(item.Value.Substring(1)))
                Else
                    aclProv.SetRolePermissions(idpath, TreePathTypeEnum.IDPath, 0, 0, Integer.Parse(item.Value.Substring(1)))
                End If
            End If
        Next
        CloseWindow()
    End Sub


    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        CloseWindow()
    End Sub


    '''<summary>Generates script that closes the window and refreshes the parent page.</summary>
    Private Sub CloseWindow()
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= " CloseAndRefresh(); "
        ltlScript.Text &= "</script>"
    End Sub

End Class
