Imports Kentico.CMS.MetadataEngine
Imports Kentico.CMS.TreeEngine
Imports Kentico.CMS.Form
Imports Kentico.CMS.DataEngine

Public Class Edit
    Inherits System.Web.UI.Page

    Protected action As String
    Protected idpath As String
    Protected classname As String
    Protected nodeculture As String
    Protected WithEvents ltlSetModeScript As System.Web.UI.WebControls.Literal
    Protected WithEvents txtNativeIDPath As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtMode As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected defaultCultureIDPath As String

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents CMSForm1 As Kentico.CMS.Form.CMSForm
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        AddHandler CMSForm1.OnBeforeSave, AddressOf CheckPermissions
        AddHandler CMSForm1.OnAfterSave, AddressOf AfterSave
        ltlScript.Text = ""
        IDPath = Request.QueryString("IDPath")
        action = Request.QueryString("action") & ""
        classname = Request.QueryString("classname")
        nodeculture = Request.QueryString("culture")
        defaultCultureIDPath = Request.QueryString("defaultcultureidpath") & ""

        'set editing mode
        If Not Page.IsPostBack Then
            ltlSetModeScript.Text = "<script language=""JavaScript"">" & vbCrLf            
            ltlSetModeScript.Text &= " try " & vbCrLf
            ltlSetModeScript.Text &= " { " & vbCrLf
            ltlSetModeScript.Text &= "  parent.parent.frames['header'].SetMode('edit'); " & vbCrLf
            ltlSetModeScript.Text &= " } " & vbCrLf
            ltlSetModeScript.Text &= " catch (e)" & vbCrLf
            ltlSetModeScript.Text &= " { " & vbCrLf
            ltlSetModeScript.Text &= " } " & vbCrLf
            ltlSetModeScript.Text &= "</script>" & vbCrLf
        Else
            ltlSetModeScript.Text = ""
        End If

        CMSForm1.TreeProvider = Functions.GetTreeProvider
        'set correctly current culture even when postback occurs
        Functions.GetPreferredUICulture()

        If Not Page.IsPostBack Then
            Dim tree As TreeProvider = Functions.GetTreeProvider
            Dim node As TreeNode
            Dim editPage As String
            Dim aliaspath As String

            'get class name of the node
            If action.ToLower = "insert" Then
                lblHeader.Text = ResMan.GetString("ContentEdit.HeaderCreateDoc")
            Else
                lblHeader.Text = ResMan.GetString("ContentEdit.Header")
                node = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath)
                If Functions.UseMultilingualSupport And nodeculture <> "" Then
                    aliaspath = CType(node.GetValue("AliasPath"), String)
                    node = tree.SelectSingleNode("/" & nodeculture & Functions.RemoveCultureFromAliasPath(aliaspath), TreePathTypeEnum.AliasPath)
                    If node Is Nothing Then
                        Response.Redirect("NewCultureVersion.aspx?idpath=" & idpath & "&aliaspath=" & aliaspath & "&culture=" & nodeculture)
                        Exit Sub
                    Else
                        idpath = CType(node.GetValue("idpath"), String)
                    End If
                End If
                classname = node.ClassName
                viewstate("oldAliasPath") = node.GetValue("AliasPath")
            End If
            lblHeader.Text &= " - " & CType(ClassInformationProvider.GetClassRow(classname, tree)("ClassDisplayName"), String)

            'get the address of the editing page for specified class        
            editPage = Trim(MetadataProvider.GetSettingsValue(classname, "CMSEditPage") & "")
            Me.txtNativeIDPath.Text = idpath
            Me.txtMode.Text = action.ToLower()
            'check permissions
            If action.ToLower = "insert" Then
                'check permissions for inserting
                If Not (Functions.IsAuthorizedPerClass(classname, "Create") Or Functions.IsAuthorizedPerResource("CMS.Content", "Create") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Create)) Then
                    Functions.RedirectToAccessDenied(idpath, "Read document (edit.aspx)")
                    Exit Sub
                End If
                Dim parentNode As TreeNode = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath)
                If Not parentNode Is Nothing Then
                    Dim parentClassID As Integer = CType(parentNode.GetValue("ClassID"), Integer)
                    Dim dr As DataRow = ClassInformationProvider.GetClassRow(classname, tree)
                    If Not dr Is Nothing Then
                        Dim childClassID As Integer = CType(dr.Item("ClassID"), Integer)
                        If Not CheckAllowedChildType(parentClassID, childClassID) Then
                            Response.Redirect("new.aspx?idpath=" & idpath & "&action=insert&classname=" & classname)
                        End If
                    End If
                End If
            Else
                'check permissions for editing
                If Not (Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read) Or Functions.IsAuthorizedPerResource("CMS.Content", "Read")) Then
                    Functions.RedirectToAccessDenied(idpath, "Read document (edit.aspx)")
                    Exit Sub
                End If
            End If
            If editPage = "" Then
                'use KentiForm
                If action.ToLower = "insert" Then
                    CMSForm1.FormMode = FormModeEnum.Insert
                    CMSForm1.FormName = classname & ".default"
                Else
                    CMSForm1.FormMode = FormModeEnum.Update
                End If
                CMSForm1.SelectPath = idpath
                CMSForm1.SelectPathType = TreePathTypeEnum.IDPath

                If (Not ConfigurationSettings.AppSettings("CMSWysiwygEditor") Is Nothing) AndAlso (ConfigurationSettings.AppSettings("CMSWysiwygEditor").ToLower.Trim = "fckeditor") Then
                    CMSForm1.FreeTextBoxSupportFolder = "../aspnet_client/FCKEditor/"
                Else
                    CMSForm1.FreeTextBoxSupportFolder = "../aspnet_client/FreeTextBox/"
                End If
                CMSForm1.Visible = True
            Else
                'redirect user to the editing page
                lblInfo.Text = ResMan.GetString("ContentEdit.Redirect")
                If action = "insert" Then
                    Response.Redirect(editPage & "?idpath=" & idpath & "&action=insert&defaultcultureidpath=" & Request.QueryString("defaultcultureidpath") & "&copydefaultculture=" & Request.QueryString("copydefaultculture"))
                Else
                    Response.Redirect(editPage & "?idpath=" & idpath & "&action=edit&defaultcultureidpath=" & Request.QueryString("defaultcultureidpath"))
                End If
            End If
            'prefill values if required
            If Functions.UseMultilingualSupport AndAlso (Not Request.QueryString("copydefaultculture") Is Nothing) AndAlso Request.QueryString("copydefaultculture").Trim = "1" Then
                CMSForm1.DefaultValuesIdPath = defaultCultureIDPath
            End If
        End If


        'If Request.QueryString("newwindow") = "true" Then
        '    Me.CMSForm1.DisplayCloseWindowButton = True
        'End If
    End Sub


    Private Sub CheckPermissions()
        Dim className As String
        Dim IDPath As String = Request.QueryString("idpath")
        className = Request.QueryString("classname")
        Dim node As TreeNode
        Dim tree As TreeProvider = Functions.GetTreeProvider
        Dim aliaspath As String

        node = tree.SelectSingleNode(IDPath, TreePathTypeEnum.IDPath)
        If Functions.UseMultilingualSupport And nodeculture <> "" Then
            aliaspath = CType(node.GetValue("AliasPath"), String)
            node = tree.SelectSingleNode("/" & nodeculture & Functions.RemoveCultureFromAliasPath(aliaspath), TreePathTypeEnum.AliasPath)
            If node Is Nothing Then
                Response.Redirect("NewCultureVersion.aspx?idpath=" & IDPath & "&aliaspath=" & aliaspath & "&culture=" & nodeculture)
                Exit Sub
            Else
                IDPath = CType(node.GetValue("idpath"), String)
            End If
        End If

        If action.ToLower = "insert" Then
            'check permissions for inserting
            If Not (Functions.IsAuthorizedPerClass(className, "create") Or Functions.IsAuthorizedPerResource("CMS.Content", "Create") Or Functions.IsAuthorizedPerNode(IDPath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Create)) Then
                CMSForm1.StopProcessing = True
                Functions.RedirectToAccessDenied(IDPath, "Create document (edit.aspx)")
                Exit Sub
            End If
        Else
            'check permissions for editing
            If Not (Functions.IsAuthorizedPerNode(IDPath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Modify) Or Functions.IsAuthorizedPerResource("CMS.Content", "Modify")) Then
                CMSForm1.StopProcessing = True
                Functions.RedirectToAccessDenied(IDPath, "Edit document (edit.aspx)")
                Exit Sub
            End If
        End If

        'set the same alias path or all values in case that the node is a translated version of an existing node
        If Functions.UseMultilingualSupport And defaultCultureIDPath <> "" Then
            Dim defaultCultureNode As TreeNode
            Dim nodealias As String
            tree = Functions.GetTreeProvider
            defaultCultureNode = tree.SelectSingleNode(defaultCultureIDPath, TreePathTypeEnum.IDPath)
            nodealias = CType(defaultCultureNode.GetValue("NodeAlias"), String)
            CMSForm1.BasicForm.DataRow("NodeAlias") = nodealias
        End If
    End Sub


    Private Sub AfterSave()
        Dim defaultCultureIDPath As String = Request.QueryString("defaultcultureidpath") & ""

        'ensure folders and for friendly URLs
        Functions.EnsureFriendlyURL(CType(CMSForm1.BasicForm.DataRow("AliasPath"), String), CType(viewstate("oldAliasPath"), String))
        ltlScript.Text = "<script language=""javascript"">"
        If Request.QueryString("closeandupdate") = "1" Then
            ltlScript.Text &= " parent.parent.frames['header'].ReloadSelectedNode(); "
        Else
        If action = "insert" Then
                If Not (Functions.UseMultilingualSupport And defaultCultureIDPath <> "") Then
                    ltlScript.Text &= " if (top.frames['desktop']) {" & vbCrLf
                    ltlScript.Text &= "     top.frames['desktop'].frames['header'].RefreshAfterInsert('" & CType(CMSForm1.BasicForm.DataRow("idpath"), String) & "', '" & idpath & "'); "
                    ltlScript.Text &= " }" & vbCrLf
                    ltlScript.Text &= " else {" & vbCrLf
                    ltlScript.Text &= "     top.frames['header'].RefreshAfterInsert('" & CType(CMSForm1.BasicForm.DataRow("idpath"), String) & "', '" & idpath & "'); "
                    ltlScript.Text &= " }" & vbCrLf
                End If
            Else
                If Not (Functions.UseMultilingualSupport And defaultCultureIDPath <> "") Then
                    ltlScript.Text &= " if (top.frames['desktop']) {" & vbCrLf
                    ltlScript.Text &= "     top.frames['desktop'].frames['header'].ReloadSelectedNode(); "
                    ltlScript.Text &= " }" & vbCrLf
                    ltlScript.Text &= " else {" & vbCrLf
                    ltlScript.Text &= "     top.frames['header'].ReloadSelectedNode(); "
                    ltlScript.Text &= " }" & vbCrLf
                End If
            End If
	end if
        ltlScript.Text &= "</script>"

	if txtMode.Text = "insert" then
	        Me.txtNativeIDPath.Text = CType(CMSForm1.BasicForm.DataRow("idpath"), String)
        	Me.txtMode.Text = "edit"
	end if
    End Sub

    '''<summary>Returns true if specified child type can be placed under specified parent type.</summary>
    Private Function CheckAllowedChildType(ByVal parentClassID As Integer, ByVal childClassID As Integer) As Boolean
        Dim cn As New GeneralConnection(Functions.GetConnectionString)
        Dim ds As DataSet

        ds = cn.ExecuteQuery("cms.allowedchildclasses.selectallowed", Nothing, " parentClassID = '" & parentClassID.ToString & "' AND childClassID = '" & childClassID.ToString & "' ")
        If ds.Tables(0).Rows.Count > 0 Then
            Return True
        Else
            Return False
        End If
    End Function

End Class
