Imports Kentico.CMS.DataEngine
Imports Kentico.CMS.MetadataEngine
Imports Kentico.CMS.TreeEngine

Public Class EditRelationship
    Inherits System.Web.UI.Page

    Protected mainNodeID As Integer = 0

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents pnlLeftNode As System.Web.UI.WebControls.Panel
    Protected WithEvents pnlRightNode As System.Web.UI.WebControls.Panel
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents drpRelationshipName As System.Web.UI.WebControls.DropDownList
    Protected WithEvents lblLeftNode As System.Web.UI.WebControls.Label
    Protected WithEvents lblRightNode As System.Web.UI.WebControls.Label
    Protected WithEvents lblRelationshipName As System.Web.UI.WebControls.Label
    Protected WithEvents btnCancel As System.Web.UI.WebControls.Button
    Protected WithEvents btnSwitch As System.Web.UI.WebControls.Button

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Functions.RedirectExpressEdition("CMSDesk.Relationships")

        Dim leftNodeID As Integer = 0
        Dim rightNodeID As Integer = 0
        Dim relationshipNameID As Integer = 0
        Dim cn As GeneralConnection
        Dim relNameObj As DataClass

        'get return page
        If Not Page.IsPostBack Then
            viewstate("ReturnPage") = Request.UrlReferrer.ToString
        End If

        'get main node id
        mainNodeID = Integer.Parse(Request.QueryString("MainNodeID"))
        lblError.Text = ""
        lblInfo.Text = ""
        lblHeader.Text = ResMan.GetString("EditRelationship.Header")
        lblLeftNode.Text = ResMan.GetString("EditRelationship.lblLeftNodeName")
        lblRightNode.Text = ResMan.GetString("EditRelationship.lblRightNodeName")
        lblRelationshipName.Text = ResMan.GetString("EditRelationship.lblRelationshipName")
        btnOK.Text = ResMan.GetString("EditRelationship.btnOK")
        btnCancel.Text = ResMan.GetString("EditRelationship.btnCancel")
        btnSwitch.Text = ResMan.GetString("EditRelationship.btnSwitch")

        'set values
        cn = New GeneralConnection(Functions.GetConnectionString)
        'new relationship
        If Not Page.IsPostBack Then
            FillRelationshipNames(relationshipNameID)
        End If
        LoadNodeControls()
        relNameObj = New DataClass("CMS.Relationship", relationshipNameID, cn)
    End Sub

    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        Dim mainNode As TreeNode = Functions.GetTreeProvider.SelectSingleNode(mainNodeID)
        Dim mainNodeIDPath As String = CType(mainNode.GetValue("idpath"), String)

        'check permissions
        If Not (Functions.IsAuthorizedPerResource("CMS.Content", "Modify") Or Functions.IsAuthorizedPerNode(mainNodeIDPath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Modify)) Then
            Functions.RedirectToAccessDenied(mainNodeIDPath, "Modify (EditRelationship.aspx)")
            Exit Sub
        End If

        'check if other node is selected
        Dim leftNodeID As Integer = GetLeftNodeID()
        Dim rightNodeID As Integer = GetRightNodeID()
        If leftNodeID = 0 Or rightNodeID = 0 Then
            Me.lblError.Text = ResMan.GetString("EditRelationship.ErrorNoNodeSelected")
            Exit Sub
        End If

        'check if relationshipname is selected
        If Me.drpRelationshipName.SelectedItem Is Nothing Then
            Me.lblError.Text = ResMan.GetString("EditRelationship.ErrorNoRelationshipNameSelected")
            Exit Sub
        End If

        Dim cn As New GeneralConnection(Functions.GetConnectionString)
        Dim relationshipNameID As Integer = Integer.Parse(Me.drpRelationshipName.SelectedValue)

        Dim params(2, 2) As Object
        params(0, 0) = "@LeftNodeID"
        params(0, 1) = leftNodeID
        params(1, 0) = "@RightNodeID"
        params(1, 1) = rightNodeID
        params(2, 0) = "@RelationshipNameID"
        params(2, 1) = relationshipNameID

        'check if relationship already exists
        Dim ds As DataSet = cn.ExecuteQuery("cms.relationship.selectrecord", params)
        If ds.Tables(0).Rows.Count > 0 Then
            'relationship already exists
            Me.lblError.Text = ResMan.GetString("EditRelationship.ErrorRelationshipAlreadyExists")
            Exit Sub
        End If

        'save relationship
        cn.ExecuteQuery("cms.relationship.insert", params)
        Response.Redirect(CType(viewstate("ReturnPage"), String))
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        Response.Redirect(CType(viewstate("ReturnPage"), String))
    End Sub

    Private Sub FillRelationshipNames(ByVal relationshipNameID As Integer)
        Dim ds As DataSet
        Dim dr As DataRow
        Dim cn As New GeneralConnection(Functions.GetConnectionString)

        'load values
        ds = cn.ExecuteQuery("cms.relationshipName.select", Nothing)
        For Each dr In ds.Tables(0).Rows
            Me.drpRelationshipName.Items.Add(New ListItem(CType(dr("RelationshipDisplayName"), String), CType(dr("RelationshipNameID"), Integer).ToString))
        Next

        'select value
        If relationshipNameID <> 0 Then
            Me.drpRelationshipName.SelectedValue = relationshipNameID.ToString
        End If
    End Sub

    Private Function GetMainNode(ByVal nodeID As Integer) As LiteralControl
        Dim ctrl As New LiteralControl
        Dim node As TreeNode = Functions.GetTreeProvider.SelectSingleNode(nodeID)
        ctrl.Text = CType(node.GetValue("NodeName"), String)
        Return ctrl
    End Function

    Private Function GetOtherNode(ByVal nodeID As Integer) As Panel
        Dim pnl As New Panel
        Dim hiddenField As New TextBox
        Dim txtOtherName As New TextBox

        hiddenField.ID = "otherNodeID"
        hiddenField.Attributes.Add("style", "display:none")
        hiddenField.Text = nodeID.ToString

        txtOtherName.ID = "otherNodeID_name"
        txtOtherName.ReadOnly = True
        txtOtherName.Attributes.Add("style", "width:200px")

        'add node name
        If nodeID <> 0 Then
            Dim node As TreeNode = Functions.GetTreeProvider.SelectSingleNode(nodeID)
            txtOtherName.Text = CType(node.GetValue("NamePath"), String)            
            'pnl.Controls.Add(New LiteralControl(CType(node.GetValue("NodeName"), String)))
            pnl.Controls.Add(hiddenField)            
            pnl.Controls.Add(txtOtherName)
        Else
            pnl.Controls.Add(hiddenField)
            pnl.Controls.Add(txtOtherName)
        End If

        'add select button
        pnl.Controls.Add(New LiteralControl("<br><input style=""width:155px"" class=""FormButton"" onclick=""window.open('SelectNodeFrameset.aspx?targetID=" & hiddenField.ClientID & "', '_blank', 'height=500,width=600,left=100,top=50,location=no,menubar=no,resizable=yes,scrollbars=yes,status=no,titlebar=yes,toolbar=no');"" type=""button"" value=""" & ResMan.GetString("EditRelationship.btnSelectNode") & """>"))
        Return pnl
    End Function

    Function GetLeftNodeID() As Integer
        If Me.MainNodePosition = "left" Then
            Return mainNodeID
        Else
            Dim hiddenField As TextBox = CType(Me.pnlLeftNode.FindControl("otherNodeID"), TextBox)
            Return Integer.Parse(hiddenField.Text)
        End If
    End Function

    Function GetRightNodeID() As Integer
        If Me.MainNodePosition = "left" Then
            Dim hiddenField As TextBox = CType(Me.pnlLeftNode.FindControl("otherNodeID"), TextBox)
            Return Integer.Parse(hiddenField.Text)
        Else
            Return mainNodeID
        End If
    End Function


    Private Sub btnSwitch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSwitch.Click
        If Me.MainNodePosition = "left" Then
            Me.SelectedNodeID = Me.GetRightNodeID
            Me.MainNodePosition = "right"
        Else
            Me.SelectedNodeID = Me.GetLeftNodeID
            Me.MainNodePosition = "left"
        End If
        LoadNodeControls()
    End Sub


    Protected Property MainNodePosition() As String
        Get
            If viewstate("MainNodePosition") Is Nothing Then
                viewstate("MainNodePosition") = "left"
            End If
            Return CType(viewstate("MainNodePosition"), String)
        End Get
        Set(ByVal Value As String)
            viewstate("MainNodePosition") = Value
        End Set
    End Property


    Protected Property SelectedNodeID() As Integer
        Get
            If viewstate("SelectedNodeID") Is Nothing Then
                viewstate("SelectedNodeID") = 0
            End If
            Return CType(viewstate("SelectedNodeID"), Integer)
        End Get
        Set(ByVal Value As Integer)
            viewstate("SelectedNodeID") = Value
        End Set
    End Property


    Private Sub LoadNodeControls()
        Me.pnlLeftNode.Controls.Clear()
        Me.pnlRightNode.Controls.Clear()
        If Me.MainNodePosition = "left" Then
            'set left node        
            Me.pnlLeftNode.Controls.Add(GetMainNode(mainNodeID))
            'set right node
            Me.pnlRightNode.Controls.Add(GetOtherNode(Me.SelectedNodeID))
        Else
            'set left node        
            Me.pnlLeftNode.Controls.Add(GetOtherNode(Me.SelectedNodeID))
            'set right node
            Me.pnlRightNode.Controls.Add(GetMainNode(mainNodeID))
        End If
    End Sub
End Class
