Imports Kentico.CMS.TreeEngine
Imports System.IO

Public Class GetFile
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim tree As TreeProvider = Functions.GetTreeProvider
        Dim fileNode As TreeNode
        Dim fileName As String
        Dim idpath As String = Request.QueryString("idpath")        
        Dim aliaspath As String
        Dim fileDiskPath As String
        Dim data() As Byte
        Dim strm As FileStream
        Dim length As Integer
        Dim versionHistoryID As Integer
        Dim filepath As String = Request.QueryString("filepath")

        If Not Request.QueryString("VersionHistoryID") Is Nothing Then
            versionHistoryID = Integer.Parse(Request.QueryString("VersionHistoryID"))
        End If

        If versionHistoryID = 0 Then
            'current version            
            'if it's filepath, convert it to the IDPath
            If (Not filepath Is Nothing) AndAlso filepath <> "" Then
                Dim parentAliasPath As String = System.IO.Path.GetDirectoryName(filepath).Replace("\", "/")
                Dim searchedFileName As String = System.IO.Path.GetFileName(filepath)
                If Not parentAliasPath.EndsWith("/") Then
                    parentAliasPath &= "/"
                End If
                parentAliasPath &= "%"
                'when multilingual support add language string to parentaliaspath
                If (Not ConfigurationSettings.AppSettings("CMSUseMultilingualSupport") Is Nothing) AndAlso (ConfigurationSettings.AppSettings("CMSUseMultilingualSupport") = "true") Then
                    Dim lang As HttpCookie = Request.Cookies("CMSPreferredCulture")
                    If Not lang Is Nothing Then
                        parentAliasPath = "/" & lang.Value & parentAliasPath
                    Else
                        parentAliasPath = "/" & Functions.GetPreferredContentCultureCode() & parentAliasPath
                    End If
                End If
                Dim dsFiles As DataSet = tree.SelectNodes(parentAliasPath, TreePathTypeEnum.AliasPath, "cms.file", " filename = '" & searchedFileName.Replace("'", "''") & "' ")
                If dsFiles.Tables(0).Rows.Count > 0 Then
                    idpath = CType(dsFiles.Tables(0).Rows(0)("IDPath"), String)
                Else
                    Exit Sub
                End If
            End If
            'check permissions
            If Functions.IsAuthorizedPerResource("CMS.Content", "read") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read) Then
                'get file specified by IDPath
                'get file name
                fileNode = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath, "cms.file")
                If fileNode Is Nothing Then
                    Exit Sub
                End If
                fileName = CType(fileNode.GetValue("FileName"), String)
                aliaspath = CType(fileNode.GetValue("AliasPath"), String)
                fileDiskPath = Functions.GetFileFolderPath(aliaspath) & "\" & fileName

                If File.Exists(fileDiskPath) Then
                    strm = File.OpenRead(fileDiskPath)
                    length = CType(strm.Length, Integer)
                    ReDim data(length)
                    strm.Read(data, 0, length)
                    strm.Close()
                End If
                'display file
                Response.Clear()
                Response.ContentType = CType(fileNode.GetValue("FileMimeType"), String)
                Response.AddHeader("Content-Disposition", "attachment; filename=" & fileName)
                Response.OutputStream.Write(data, 0, length)
                Response.End()
            End If
        Else
            'get specified earlier version
            Dim verMan As New VersionManager(tree)
            fileNode = verMan.GetVersion(versionHistoryID)
            If fileNode Is Nothing Then
                Exit Sub
            End If

            'check permissions
            Dim currentNode As TreeNode = tree.SelectSingleNode(CType(fileNode.GetValue("NodeID"), Integer))
            If Not (Functions.IsAuthorizedPerResource("CMS.Content", "Read") Or Functions.IsAuthorizedPerNode(CType(currentNode.GetValue("IDPath"), String), TreePathTypeEnum.IDPath, NodePermissionsEnum.Read)) Then
                Exit Sub
            End If

            'get file name
            fileName = CType(fileNode.GetValue("FileName"), String)
            aliaspath = CType(fileNode.GetValue("AliasPath"), String)
            data = CType(fileNode.GetValue("FileBinary"), Byte())
            'display file
            Response.Clear()
            Response.ContentType = CType(fileNode.GetValue("FileMimeType"), String)
            Response.OutputStream.Write(data, 0, data.Length)
            Response.AddHeader("Content-Disposition", "attachment; filename=" & fileName)
            Response.End()
        End If
    End Sub

End Class
