Imports Kentico.CMS.TreeEngine
Imports Kentico.CMS.DataEngine
Imports Kentico.CMS.MetadataEngine
Imports Kentico.CMS.WorkflowEngine

Public Class History
    Inherits System.Web.UI.Page

    Protected allowRollback As Boolean = True
    Protected viewHint As String
    Protected rollbackHint As String
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents ltlConfirmScript As System.Web.UI.WebControls.Literal
    Protected WithEvents btnDestroyHistory As System.Web.UI.WebControls.Button
    Protected destroyHint As String
    Protected idpath As String

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents QueryDataGrid1 As Kentico.CMS.CMSControls.QueryDataGrid
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        idpath = Request.QueryString("idpath") & ""
        Dim culture As String = Request.QueryString("culture") & ""
        Dim node As TreeNode
        Dim tree As TreeProvider = Functions.GetTreeProvider
        Dim nodeid As Integer

        lblError.Text = ""
        lblHeader.Text = ResMan.GetString("History.Header")
        viewHint = ResMan.GetString("History.ViewHint")
        rollbackHint = ResMan.GetString("History.RollbackHint")
        destroyHint = ResMan.GetString("History.DestroyHint")
        ltlConfirmScript.Text = "<input type=""hidden"" id=""confirmationText"" value=""" & ResMan.GetString("RecycleBin.ConfirmDestroy") & """>"
        btnDestroyHistory.Text = ResMan.GetString("History.DestroyHistory")
        If Not Page.IsPostBack Then
            btnDestroyHistory.Attributes.Add("onclick", "return confirm('" & ResMan.GetString("History.ConfirmHistoryDestroy") & "');")
        End If        
        QueryDataGrid1.Columns(0).HeaderText = ResMan.GetString("History.Action")
        QueryDataGrid1.Columns(1).HeaderText = ResMan.GetString("History.ModifiedWhen")
        QueryDataGrid1.Columns(2).HeaderText = ResMan.GetString("History.ModifiedByUserFullName")
        QueryDataGrid1.Columns(3).HeaderText = ResMan.GetString("History.VersionNumber")
        QueryDataGrid1.Columns(4).HeaderText = ResMan.GetString("History.VersionComment")
        QueryDataGrid1.Columns(5).HeaderText = ResMan.GetString("History.PublishFrom")
        QueryDataGrid1.Columns(6).HeaderText = ResMan.GetString("History.PublishTo")
        QueryDataGrid1.Columns(7).HeaderText = ResMan.GetString("History.WasPublishedFrom")
        QueryDataGrid1.Columns(8).HeaderText = ResMan.GetString("History.WasPublishedTo")    

        'get node
        node = Functions.GetNodeByIDPathAndCulture(idpath, culture)

        'multilingual support
        If node Is Nothing Then
            'culture version does not exist
            node = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath)
            Response.Redirect("NewCultureVersion.aspx?idpath=" & idpath & "&aliaspath=" & CType(node.GetValue("aliaspath"), String) & "&culture=" & culture)
            Exit Sub
        Else
            idpath = CType(node.GetValue("idpath"), String)
        End If
        nodeid = CType(node.GetValue("NodeID"), Integer)

        'check permissions        
        If Not (Functions.IsAuthorizedPerResource("CMS.Content", "Read") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read)) Then
            Functions.RedirectToAccessDenied(idpath, "Read (history.aspx)")
            Exit Sub
        End If
        If Not (Functions.IsAuthorizedPerResource("CMS.Content", "Modify") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Modify)) Then
            'do not allow rollback
            'allowRollback = False
        Else
            'allowRollback = True
        End If

        'check if document type supports versioning
        If Not CType(Functions.GetClassDRValue(CType(node.GetValue("ClassID"), Integer), "UseVersioning"), Boolean) Then
            QueryDataGrid1.Visible = False
            lblInfo.Visible = True
            lblError.Visible = False
            btnDestroyHistory.Visible = False
            lblInfo.Text = ResMan.GetString("Lock.InfoDocumentDoesNotSupportVersioning")
            Exit Sub
        End If

        QueryDataGrid1.WhereCondition = " NodeID = " & nodeid.ToString
    End Sub

    Public Sub DeleteItem(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles QueryDataGrid1.DeleteCommand
        'get node info
        Dim tree As TreeProvider = Functions.GetTreeProvider
        Dim versionHistoryId As Integer = Integer.Parse(CType(e.CommandArgument, String))
        Dim versionHistoryObj As New DataClass("cms.versionhistory", versionHistoryId, tree.Connection)
        Dim verMan As New VersionManager(tree)
        Dim node As TreeNode = tree.SelectSingleNode(CType(versionHistoryObj.GetValue("NodeID"), Integer))
        Dim idpath As String = CType(node.GetValue("IDPath"), String)

        'check permissions
        If Not Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Destroy) Then
            lblError.Text = ResMan.GetString("History.ErrorNotAllowedToDestroy")
            Exit Sub
        End If

        verMan.DestroyVersion(versionHistoryId)
        Response.Redirect(Page.Request.Url.ToString)
    End Sub


    Private Sub QueryDataGrid1_DataBind(ByVal sender As System.Object, ByVal e As DataGridItemEventArgs) Handles QueryDataGrid1.ItemDataBound
        Dim btnCurrentButton As ImageButton

        'set up the Delete button
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            btnCurrentButton = CType(e.Item.Cells(0).FindControl("btnDelete"), ImageButton)
            btnCurrentButton.Attributes.Add("OnClick", "return ConfirmDestroy();")
            btnCurrentButton.Attributes.Add("title", destroyHint)
        End If
    End Sub

    Private Sub btnDestroyHistory_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDestroyHistory.Click
        'check permissions
        If Not Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Destroy) Then
            lblError.Text = ResMan.GetString("History.ErrorNotAllowedToDestroy")
            Exit Sub
        End If

        Dim node As TreeNode = Functions.GetTreeProvider.SelectSingleNode(idpath, TreePathTypeEnum.IDPath)
        If Not node Is Nothing Then
            Dim nodeId As Integer = CType(node.GetValue("NodeID"), Integer)
            Dim verMan As New VersionManager(Functions.GetTreeProvider)
            verMan.DestroyNodeHistory(nodeId)
            Response.Redirect(Page.Request.Url.ToString)
        End If
    End Sub
End Class
