Imports Kentico.CMS.TreeEngine
Imports Kentico.CMS.MetadataEngine

Public Class Listing
    Inherits System.Web.UI.Page

    Protected parentIDPath As String

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblRedirect As System.Web.UI.WebControls.Label
    Protected WithEvents QueryDataGrid1 As Kentico.CMS.CMSControls.QueryDataGrid
    Protected WithEvents CMSDataGrid1 As Kentico.CMS.CMSControls.CMSDataGrid
    Protected WithEvents lblSearchFor As System.Web.UI.WebControls.Label
    Protected WithEvents txtSearchFor As System.Web.UI.WebControls.TextBox
    Protected WithEvents btnSearch As System.Web.UI.WebControls.Button

    Protected selectText As String
    Protected unfoldText As String
    Protected WithEvents ImageButton1 As System.Web.UI.WebControls.ImageButton
    Protected WithEvents Label1 As System.Web.UI.WebControls.Label
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim idPath As String
        Dim tree As TreeProvider
        Dim parentNode As TreeNode
        Dim node As TreeNode
        Dim listingPage As String
        Dim culture As String
        Dim ds As DataSet        

        idPath = Request.QueryString("idpath") & ""
        culture = Request.QueryString("culture") & ""
        ltlScript.Text = ""
        SelectNodeScript(idPath)

        'get default culture parentIDPath
        If idPath = "/" Then
            parentIDPath = "/"
        Else
            parentIDPath = idPath.Substring(0, idPath.LastIndexOf("/"))
        End If
        If parentIDPath = "" Then
            parentIDPath = "/"
        End If
        'set onclick even of the "go up" button
        ImageButton1.Attributes.Add("onclick", "javascript:unfold('" & parentIDPath & "');")

        'optional redirection
        tree = Functions.GetTreeProvider
        'get class name of the node
        node = tree.SelectSingleNode(idPath, TreePathTypeEnum.IDPath)
        'get the address of the listing page for specified class
        listingPage = Trim(MetadataProvider.GetSettingsValue(CType(node.GetValue("ClassName"), String), "CMSListPage") & "")
        If listingPage <> "" Then
            'redirect user to the listing page
            tree.Connection.DataConnection.Close()
            CMSDataGrid1.Visible = False
            lblRedirect.Visible = True
            lblRedirect.Text = ResMan.GetString("ContentListing.Redirect")
            Response.Redirect(listingPage & "?idpath=" & idPath)
        End If

        'display grid        
        Dim parent As TreeNode = tree.SelectSingleNode(idPath, TreePathTypeEnum.IDPath)
        Dim aliasPath As String = CType(parent.GetValue("AliasPath"), String)
        If Functions.UseMultilingualSupport And culture <> "" And idPath <> "/" Then
            aliasPath = "/" & culture & Functions.RemoveCultureFromAliasPath(aliasPath)
            'check if the node exists
            Dim testNode As TreeNode = tree.SelectSingleNode(aliasPath, TreePathTypeEnum.AliasPath)
            If testNode Is Nothing Then
                Response.Redirect("NewCultureVersion.aspx?idpath=" & idPath & "&aliaspath=" & aliasPath & "&culture=" & culture)
                Exit Sub
            Else
                idPath = CType(testNode.GetValue("IDPath"), String)
            End If
        End If
        If aliasPath = "/" Then
            aliasPath = "/%"
        Else
            aliasPath &= "/%"
        End If

        'check permissions
        If (Not (Functions.IsAuthorizedPerResource("CMS.Content", "ExploreTree") Or Functions.IsAuthorizedPerNode(idPath, TreePathTypeEnum.IDPath, NodePermissionsEnum.ExploreTree)) Or (ConfigurationSettings.AppSettings("CMSAllowUnfoldingOfAnyDocument") & "").ToLower.Trim = "false" And Not Functions.IsAuthorizedPerNode(idPath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read)) Then
            Functions.RedirectToAccessDenied("CMS.Content", "ExploreTree (listing.aspx)")
            Exit Sub
        End If

        'get dataset
        Dim gridPreferredCultureCode As String
        Dim gridSelectNodesPath As String
        Dim gridSelectNodesWhere As String
        Dim gridSelectNodesMaxRelativeLevel As Integer

        CMSDataGrid1.TreeProvider = tree
        If Functions.UseMultilingualSupport And culture <> "" And idPath <> "/" Then
            gridPreferredCultureCode = culture
            If Functions.RemoveCultureFromAliasPath(aliasPath) = "/" Then
                gridSelectNodesPath = "/" & culture
            Else
                gridSelectNodesPath = "/" & culture & Functions.RemoveCultureFromAliasPath(aliasPath)
            End If
        Else
            gridSelectNodesPath = aliasPath
        End If
        gridSelectNodesWhere = " NodeLevel <> 0 AND NodeName LIKE N'%" & Me.txtSearchFor.Text.Replace("'", "''") & "%' "
        If culture <> "" Then
            CMSDataGrid1.PreferredCultureCode = culture
        End If
        CMSDataGrid1.SelectNodesPath = Functions.RemoveCultureFromAliasPath(gridSelectNodesPath)
        CMSDataGrid1.SelectNodesPathType = TreePathTypeEnum.AliasPath
        CMSDataGrid1.SelectNodesWhere = gridSelectNodesWhere
        CMSDataGrid1.SelectNodesMaxRelativeLevel = 1

        CMSDataGrid1.Columns(0).HeaderText = ResMan.GetString("ContentListing.HeaderNodeName")
        CMSDataGrid1.Columns(1).HeaderText = ResMan.GetString("ContentListing.HeaderType")
        CMSDataGrid1.Columns(2).HeaderText = ResMan.GetString("ContentListing.HeaderModified")
        Dim currentPath As String = gridSelectNodesPath
        If currentPath.EndsWith("%") Then
            currentPath = currentPath.Substring(0, currentPath.Length - 1)
        End If
        If currentPath.EndsWith("/") AndAlso currentPath <> "/" Then
            currentPath = currentPath.Substring(0, currentPath.Length - 1)
        End If

        'get parent path and display it
        Dim currentNode As TreeNode = Functions.GetTreeProvider.SelectSingleNode(currentPath, TreePathTypeEnum.AliasPath)
        Dim currentNamePath As String = CType(currentNode.GetValue("NamePath"), String)
        Dim usersStartingNamePath As String = CType(Functions.GetTreeProvider.SelectSingleNode(Functions.GetUsersStartingAliasPath, TreePathTypeEnum.AliasPath).GetValue("NamePath"), String)
        Dim isTopMostPath As Boolean = False
        currentNamePath = Functions.RemoveCultureFromAliasPath(currentNamePath)
        If currentNamePath = "" Then
            currentNamePath = "/"
        End If
        usersStartingNamePath = Functions.RemoveCultureFromAliasPath(usersStartingNamePath)
        If usersStartingNamePath = "" Then
            usersStartingNamePath = "/"
        End If
        Dim tmpCurrentNamePathSplit() As String = currentNamePath.Split("/"c)
        Dim tmpUsersStartingNamePathSplit() As String = usersStartingNamePath.Split("/"c)
        If (tmpCurrentNamePathSplit.GetUpperBound(0) = tmpUsersStartingNamePathSplit.GetUpperBound(0) And usersStartingNamePath <> "/") Or (usersStartingNamePath = "/" And currentNamePath = "/") Then
            isTopMostPath = True
        End If
        If usersStartingNamePath <> "/" Then
            Dim i As Integer
            Dim tmpNamePath As String = ""
            For i = tmpUsersStartingNamePathSplit.GetUpperBound(0) To tmpCurrentNamePathSplit.GetUpperBound(0)
                If tmpCurrentNamePathSplit(i) <> "" Then
                    tmpNamePath &= "/" & tmpCurrentNamePathSplit(i)
                End If
            Next
            currentNamePath = tmpNamePath
        End If
        'hide "folder up" image if the current path is the top most path
        If isTopMostPath Then
            Me.ImageButton1.Visible = False
            Me.Label1.Visible = False
        Else
            Me.ImageButton1.Visible = True
            Me.Label1.Visible = True
        End If
        lblHeader.Text = ResMan.GetString("ContentListing.Header") & " " & currentNamePath
        lblSearchFor.Text = ResMan.GetString("ContentListing.SearchFor")
        btnSearch.Text = ResMan.GetString("ContentListing.SearchButton")
        selectText = ResMan.GetString("ContentListing.SelectText")
        unfoldText = ResMan.GetString("ContentListing.UnfoldText")

        If Page.IsPostBack Then
            CMSDataGrid1.SelectedIndex = -1
        End If
    End Sub

    Private Sub btnSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSearch.Click
        CMSDataGrid1.CurrentPageIndex = 0
    End Sub

    Private Sub CMSDataGrid1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CMSDataGrid1.SelectedIndexChanged
        Dim idpath As String = CMSDataGrid1.SelectedItem.Cells(4).Text
        SelectNodeScript(idpath)
    End Sub

    Private Sub CMSDataGrid1_ItemCommand(ByVal sender As System.Object, ByVal e As DataGridCommandEventArgs) Handles CMSDataGrid1.ItemCommand
        If e.CommandName = "Unfold" Then
            Dim idpath As String = CType(e.CommandArgument, String)
            Response.Redirect("listing.aspx?idpath=" & idpath & "&culture=" & Request.QueryString("culture"))
        End If
    End Sub


    Private Sub cmsdatagrid_bound(ByVal sender As Object, ByVal e As DataGridItemEventArgs) Handles CMSDataGrid1.ItemDataBound
        Dim selectButton As LinkButton
        Dim unfoldButton As LinkButton

        'set up the Delete button
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Or e.Item.ItemType = ListItemType.SelectedItem Then
            unfoldButton = CType(e.Item.Cells(0).FindControl("UnfoldButton"), LinkButton)
            unfoldButton.CommandArgument = CType(CType(e.Item.DataItem, DataRowView).Row("IDPath"), String)
            unfoldButton.Attributes.Add("onclick", "javascript:unfold('" & CType(CType(e.Item.DataItem, DataRowView).Row("IDPath"), String) & "');")
        End If

    End Sub

    Private Sub ImageButton1_Click(ByVal sender As System.Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles ImageButton1.Click
        Dim culture As String
        culture = Request.QueryString("culture") & ""
        Response.Redirect("listing.aspx?idpath=" & parentIDPath & "&culture=" & culture)
    End Sub


    Private Sub SelectNodeScript(ByVal idpath As String)
        'update selected node info at the header
        ltlScript.Text = "<script language=""JavaScript"">" & vbCrLf
        ltlScript.Text &= " try { " & vbCrLf
        ltlScript.Text &= " parent.frames['header'].SelectNodeWithoutSelectingMode('" & idpath & "'); " & vbCrLf
        ltlScript.Text &= " } catch (e) {} " & vbCrLf
        ltlScript.Text &= "</script>"
    End Sub
End Class
