Imports Kentico.CMS.TreeEngine
Imports Kentico.CMS.DataEngine
Imports Kentico.CMS.MetadataEngine
Imports Kentico.CMS.WorkflowEngine

Public Class Lock
    Inherits System.Web.UI.Page

    Protected node As TreeNode
    Protected WithEvents btnCancel As System.Web.UI.WebControls.Button
    Protected WithEvents ltlSetModeScript As System.Web.UI.WebControls.Literal
    Protected tree As TreeProvider

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents btnCheckOut As System.Web.UI.WebControls.Button
    Protected WithEvents btnCheckIn As System.Web.UI.WebControls.Button
    Protected WithEvents btnUndoCheckOut As System.Web.UI.WebControls.Button
    Protected WithEvents pnlVersionInfo As System.Web.UI.WebControls.Panel
    Protected WithEvents lblVersionNumber As System.Web.UI.WebControls.Label
    Protected WithEvents lblVersionComment As System.Web.UI.WebControls.Label
    Protected WithEvents txtVersionNumber As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtVersionComment As System.Web.UI.WebControls.TextBox

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim idpath As String = Request.QueryString("idpath") & ""
        Dim culture As String = Request.QueryString("culture") & ""
        tree = Functions.GetTreeProvider

        'set lock mode
        If Not Page.IsPostBack Then
            ltlSetModeScript.Text = "<script language=""JavaScript"">" & vbCrLf
            ltlSetModeScript.Text &= " try " & vbCrLf
            ltlSetModeScript.Text &= " { " & vbCrLf
            ltlSetModeScript.Text &= "  parent.frames['header'].SetMode('lock'); " & vbCrLf
            ltlSetModeScript.Text &= " } " & vbCrLf
            ltlSetModeScript.Text &= " catch (e)" & vbCrLf
            ltlSetModeScript.Text &= " { " & vbCrLf
            ltlSetModeScript.Text &= " } " & vbCrLf
            ltlSetModeScript.Text &= "</script>" & vbCrLf
        Else
            ltlSetModeScript.Text = ""
        End If

        'generate correct return URL
        If (Not Page.IsPostBack) And Request.QueryString("returnback") & "" <> "" Then
            Me.btnCancel.Visible = True
            If InStr(Request.UrlReferrer.ToString.ToLower, "edit.aspx") > 0 AndAlso InStr(Request.UrlReferrer.ToString.ToLower, "action=insert") > 0 Then
                viewstate("returnback") = "edit.aspx?idpath=" & idpath & "&culture=" & culture
            Else
                viewstate("returnback") = Request.UrlReferrer.ToString
            End If
        End If

        Me.lblHeader.Text = ResMan.GetString("Lock.Header")
        Me.btnCheckOut.Text = ResMan.GetString("Lock.CheckOut")
        Me.btnCheckIn.Text = ResMan.GetString("Lock.CheckIn")
        Me.btnUndoCheckOut.Text = ResMan.GetString("Lock.UndoCheckOut")
        Me.lblVersionNumber.Text = ResMan.GetString("Lock.VersionNumber")
        Me.lblVersionComment.Text = ResMan.GetString("Lock.VersionComment")
        Me.btnCancel.Text = ResMan.GetString("Lock.Cancel")

        If Functions.UseMultilingualSupport() Then 'multilingual support
            'get node
            node = Functions.GetNodeByIDPathAndCulture(idpath, culture)
            If node Is Nothing Then
                'culture version does not exist            
                node = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath)
                Response.Redirect("NewCultureVersion.aspx?idpath=" & idpath & "&aliaspath=" & CType(node.GetValue("aliaspath"), String) & "&culture=" & culture)
                Exit Sub
            Else
                idpath = CType(node.GetValue("idpath"), String)
            End If
        Else
            node = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath)
        End If

        'check permissions
        If Not (Functions.IsAuthorizedPerResource("CMS.Content", "Read") Or Functions.IsAuthorizedPerResource("CMS.Content", "CheckInAll") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read)) Then
            Functions.RedirectToAccessDenied(idpath, "Read (lock.aspx)")
            Exit Sub
        End If
        If Not (Functions.IsAuthorizedPerResource("CMS.Content", "Modify") Or Functions.IsAuthorizedPerResource("CMS.Content", "CheckInAll") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Modify)) Then
            'disable form
            pnlVersionInfo.Enabled = False
        End If

        'check if document type supports versioning
        If Not CType(Functions.GetClassDRValue(CType(node.GetValue("ClassID"), Integer), "UseVersioning"), Boolean) Then
            pnlVersionInfo.Visible = False
            lblInfo.Text = ResMan.GetString("Lock.InfoDocumentDoesNotSupportVersioning")
            Exit Sub
        End If

        'check if document is checked out
        If Not Page.IsPostBack Then
            If node.GetValue("CheckedOutByUserID") Is Nothing Then
                'document is not checked out - allow checkout
                DisplayCheckedInInfo(CType(node.GetValue("IDPath"), String))
            Else
                'document is checked out - display information about user
                DisplayCheckedOutInfo(CType(node.GetValue("IDPath"), String))
            End If
        End If
    End Sub


    'do check-out
    Private Sub btnCheckOut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCheckOut.Click
        Dim verman As New VersionManager(Functions.GetTreeProvider)

        'check out the document
        If node.GetValue("CheckedOutVersionHistoryID") Is Nothing Then
            'insert new version history
            Dim versionHistoryObj As DataClass
            Dim versionHistoryID As Integer
            versionHistoryObj = New DataClass("cms.versionhistory", tree.Connection)
            versionHistoryObj.SetValue("NodeID", node.GetValue("NodeID"))
            versionHistoryObj.SetValue("NodeNamePath", node.GetValue("NamePath"))
            versionHistoryObj.SetValue("NodeXML", node.DataRow.Table.DataSet.GetXml())
            versionHistoryObj.SetValue("ModifiedByUserID", Functions.GetUserID)
            versionHistoryObj.SetValue("ModifiedWhen", DateTime.Now)
            versionHistoryObj.SetValue("VersionNumber", "")
            versionHistoryObj.SetValue("VersionComment", "")
            versionHistoryObj.SetValue("ToBePublished", 1)
            versionHistoryObj.Insert()
            versionHistoryID = CType(versionHistoryObj.GetValue("VersionHistoryID"), Integer)
            node.SetValue("CheckedOutVersionHistoryID", versionHistoryID)
            node.SetValue("PublishedVersionHistoryID", versionHistoryID)
            node.Update()
        End If
        verman.CheckOut(CType(node.GetValue("NodeID"), Integer), Me.txtVersionComment.Text)

        If viewstate("returnback") Is Nothing Then
            DisplayCheckedOutInfo(CType(node.GetValue("IDPath"), String))
        Else
            Response.Redirect(CType(viewstate("returnback"), String))
        End If
    End Sub


    'display checked-out information 
    Private Sub DisplayCheckedOutInfo(ByVal idpath As String)
        Dim tree As TreeProvider = Functions.GetTreeProvider
        Dim node As TreeNode = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath)
        Dim checkedoutby As String = CType(node.GetValue("CheckedOutByFullName"), String) & " (" & CType(node.GetValue("CheckedOutByUserName"), String) & ")"
        Dim checkedoutwhen As DateTime = CType(node.GetValue("CheckedOutWhen"), DateTime)
        Dim versionHistoryObj As DataClass

        Me.lblInfo.Text = Replace(Replace(ResMan.GetString("Lock.InfoDocumentCheckedOut"), "{%username%}", checkedoutby), "{%when%}", checkedoutwhen.ToString)
        Me.btnCheckOut.Visible = False
        Me.btnCheckIn.Visible = True
        Me.txtVersionNumber.Enabled = True
        If Not node.GetValue("CheckedOutVersionHistoryID") Is Nothing Then
            versionHistoryObj = New DataClass("cms.versionhistory", CType(node.GetValue("CheckedOutVersionHistoryID"), Integer), tree.Connection)
            Me.txtVersionNumber.Text = CType(versionHistoryObj.GetValue("VersionNumber"), String)
            Me.txtVersionComment.Text = CType(versionHistoryObj.GetValue("VersionComment"), String)
        End If

        'check if it's possible to undo checkout
        Me.btnUndoCheckOut.Visible = False
        Dim params(0, 2) As Object
        Dim ds As DataSet

        params(0, 0) = "@NodeID"
        params(0, 1) = CType(node.GetValue("NodeID"), Integer)
        ds = tree.Connection.ExecuteQuery("cms.versionhistory.selecthistoryversionscount", params)
        If ds.Tables(0).Rows.Count > 0 Then
            If CType(ds.Tables(0).Rows(0)("versioncount"), Integer) > 1 Then
                Me.btnUndoCheckOut.Visible = True
            End If
        End If

        'check if current user is allowed to check in the checked out document
        If CType(node.GetValue("CheckedOutByUserID"), Integer) = Functions.GetUserID Or Functions.IsAuthorizedPerResource("CMS.Content", "CheckInAll") Then
            Me.txtVersionComment.Enabled = True
            Me.txtVersionNumber.Enabled = True
            Me.btnCheckIn.Enabled = True
            Me.btnCheckIn.CssClass = "FormButton200"
            Me.btnUndoCheckOut.Enabled = True
            Me.btnUndoCheckOut.CssClass = "FormButton200"
        Else
            Me.txtVersionComment.Enabled = False
            Me.txtVersionNumber.Enabled = False
            Me.btnCheckIn.Enabled = False
            Me.btnCheckIn.CssClass = "FormButtonDisabled200"
            Me.btnUndoCheckOut.Enabled = False
            Me.btnUndoCheckOut.CssClass = "FormButtonDisabled200"
        End If
    End Sub


    'display checked-in information
    Private Sub DisplayCheckedInInfo(ByVal idpath As String)
        Dim tree As TreeProvider = Functions.GetTreeProvider
        Dim node As TreeNode = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath)
        Dim versionHistoryID As Integer = CType(node.GetValue("CheckedOutVersionHistoryID"), Integer)
        Dim versionHistoryObj As DataClass
        Dim workMan As New WorkflowManager(tree)
        Dim stepInfo As DataClass
        Dim stepName As String

        Me.lblInfo.Text = ResMan.GetString("Lock.InfoDocumentNotCheckedOut")
        If versionHistoryID <> 0 Then
            versionHistoryObj = New DataClass("cms.versionhistory", versionHistoryID, tree.Connection)
            Me.txtVersionNumber.Text = CType(versionHistoryObj.GetValue("VersionNumber"), String)
        End If
        Me.txtVersionNumber.Enabled = False
        Me.txtVersionComment.Text = ""
        Me.btnUndoCheckOut.Visible = False
        Me.btnCheckOut.Visible = True
        Me.btnCheckIn.Visible = False

        stepInfo = workMan.GetStepInfo(CType(node.GetValue("NodeID"), Integer))
        stepName = CType(stepInfo.GetValue("StepName"), String).ToLower

        'test if current user is allowed to edit document in the current workflow step
        If (stepName <> "edit" And stepName <> "published") AndAlso (Not workMan.CanUserApprove(CType(node.GetValue("NodeID"), Integer))) Then
            Me.pnlVersionInfo.Enabled = False
            Me.lblInfo.Text &= " " & ResMan.GetString("Lock.InfoCannotEditDueToWorkflowStatus")
        End If
    End Sub


    'do check-in
    Private Sub btnCheckIn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCheckIn.Click
        Dim verman As New VersionManager(Functions.GetTreeProvider)

        'check out the document        
        verman.CheckIn(CType(node.GetValue("NodeID"), Integer), Me.txtVersionNumber.Text, Me.txtVersionComment.Text)
        If viewstate("returnback") Is Nothing Then
            DisplayCheckedInInfo(CType(node.GetValue("IDPath"), String))
        Else
            Response.Redirect(CType(viewstate("returnback"), String))
        End If
    End Sub


    'undo checkout
    Private Sub btnUndoCheckOut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUndoCheckOut.Click
        Dim verman As New VersionManager(Functions.GetTreeProvider)

        'undo check out
        verman.UndoCheckOut(CType(node.GetValue("NodeID"), Integer))
        DisplayCheckedInInfo(CType(node.GetValue("IDPath"), String))
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        Response.Redirect(CType(viewstate("returnback"), String))
    End Sub
End Class
