Imports Kentico.CMS.DataEngine
Imports Kentico.CMS.TreeEngine
Imports Kentico.CMS.MetadataEngine

Public Class NewDoc
    Inherits System.Web.UI.Page

    Protected parentIDPath As String

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblChooseType As System.Web.UI.WebControls.Label
    Protected WithEvents lstClasses As System.Web.UI.WebControls.ListBox
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents Panel1 As System.Web.UI.WebControls.Panel
    Protected WithEvents Panel2 As System.Web.UI.WebControls.Panel
    Protected WithEvents lblNoAllowedChild As System.Web.UI.WebControls.Label
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal
    Protected WithEvents ltlSetModeScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        parentIDPath = Request.QueryString("IDPath")
        ltlScript.Text = ""

        'set editing mode
        If Not Page.IsPostBack Then
            ltlSetModeScript.Text = "<script language=""JavaScript"">" & vbCrLf
            ltlSetModeScript.Text &= " try " & vbCrLf
            ltlSetModeScript.Text &= " { " & vbCrLf
            ltlSetModeScript.Text &= "  parent.frames['header'].SetMode('edit'); " & vbCrLf
            ltlSetModeScript.Text &= " } " & vbCrLf
            ltlSetModeScript.Text &= " catch (e)" & vbCrLf
            ltlSetModeScript.Text &= " { " & vbCrLf
            ltlSetModeScript.Text &= " } " & vbCrLf
            ltlSetModeScript.Text &= "</script>" & vbCrLf
        Else
            ltlSetModeScript.Text = ""
        End If

        If Not Page.IsPostBack Then
            lblHeader.Text = ResMan.GetString("New.Header")
            lblChooseType.Text = ResMan.GetString("New.ChooseType")
            btnOK.Text = ResMan.GetString("New.OK")
            lblNoAllowedChild.Text = ResMan.GetString("New.NoAllowedChild")

            'get allowed child types
            Dim ds As DataSet
            Dim params(0, 2) As Object
            Dim tree As TreeProvider
            Dim parentNode As TreeNode
            Dim parentClassID As Integer

            tree = Functions.GetTreeProvider
            tree.Connection.DataConnection.Open()
            'get the parent node to read its ClassID
            parentNode = tree.SelectSingleNode(parentIDPath, TreePathTypeEnum.IDPath)
            If parentNode Is Nothing Then
                parentClassID = -1
            Else
                parentClassID = CType(parentNode.GetValue("ClassID"), Integer)
            End If
            'read allowed child classes and display them
            params(0, 0) = "@ParentClassID"
            params(0, 1) = parentClassID
            ds = tree.Connection.ExecuteQuery("CMS.Class.SelectByParentClassID", params)
            tree.Connection.DataConnection.Close()
            lstClasses.DataSource = ds.Tables(0)
            lstClasses.DataTextField = "ClassDisplayName"
            lstClasses.DataValueField = "ClassName"
            lstClasses.DataBind()

            If ds.Tables(0).Rows.Count > 0 Then
                Panel1.Visible = True
                Panel2.Visible = False
                If lstClasses.Items.Count = 1 Then
                    lstClasses.SelectedIndex = 0
                    btnOK_Click(sender, e)
                End If
            Else
                'no allowed child classes
                Panel1.Visible = False
                Panel2.Visible = True
            End If
        End If
    End Sub


    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        'get selected item and redirect user to the appropriate edit page
        If lstClasses.SelectedItem Is Nothing Then
            lblError.Visible = True
            lblError.Text = ResMan.GetString("New.Error_NoItemSelected")
        Else
            'If Functions.IsAuthorizedPerClass(lstClasses.SelectedItem.Value, "create") Or Functions.IsAuthorizedPerResource("CMS.Content", "Create") Then
            Dim editingPage As String = MetadataProvider.GetSettingsValue(lstClasses.SelectedItem.Value, "CMSEditPage")
            If editingPage = "" Then
                editingPage = "Edit.aspx"
            End If
            Response.Redirect(editingPage & "?idpath=" & parentIDPath & "&action=insert&classname=" & lstClasses.SelectedValue)
            'Else
            'lblError.Text = ResMan.GetString("AccessDenied.NotAllowedToCreateDocument")
            'End If
        End If
    End Sub
End Class
