Imports Kentico.CMS.TreeEngine

Public Class NewCultureVersion
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents btnCreateNew As System.Web.UI.WebControls.Button
    Protected WithEvents lblCreateParentNode As System.Web.UI.WebControls.Label
    Protected WithEvents chkUseDefault As System.Web.UI.WebControls.CheckBox

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.lblHeader.Text = ResMan.GetString("NewCultureVersion.Header")
        Me.lblInfo.Text = ResMan.GetString("NewCultureVersion.Info")
        Me.btnCreateNew.Text = ResMan.GetString("NewCultureVersion.CreateNew")
        Me.chkUseDefault.Text = ResMan.GetString("NewCultureVersion.UseDefaultCulture")
    End Sub

    Private Sub btnCreateNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCreateNew.Click
        Dim aliaspath As String = Request.QueryString("aliaspath") & ""
        Dim culture As String = Request.QueryString("culture") & ""
        Dim parentIDPath As String
        Dim tree As TreeProvider = Functions.GetTreeProvider
        Dim node As TreeNode
        Dim idpath As String = Request.QueryString("idpath") & ""
        Dim className As String
        Dim redirectToNewVersion As Boolean = False
        Dim checkParentAliasPath As String

        'get default culture node to find out the class name
        node = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath)
        className = CType(node.GetValue("classname"), String)
        'get parent localized node
        checkParentAliasPath = "/" & culture & Functions.RemoveCultureFromAliasPath(Functions.GetParentPath(aliaspath))
        aliaspath = "/" & culture & Functions.RemoveCultureFromAliasPath(aliaspath)
        node = tree.SelectSingleNode(checkParentAliasPath, TreePathTypeEnum.AliasPath)
        If node Is Nothing Then
            If Functions.GetConfigValue("CMSCreateTranslatedParentDocuments").Trim.ToLower <> "false" Then
                'copy all parent nodes from the default culture
                node = Functions.CreateNodePath(Functions.GetParentPath(aliaspath))
                redirectToNewVersion = True
            Else
                'get last localized node in the path
                While node Is Nothing
                    aliaspath = Functions.GetParentPath(checkParentAliasPath)
                    node = tree.SelectSingleNode(checkParentAliasPath, TreePathTypeEnum.AliasPath)
                End While
                Me.lblCreateParentNode.Text = ResMan.GetString("NewCultureVersion.ErrorCreateParentFirst") & " " & Functions.RemoveCultureFromAliasPath(CType(node.GetValue("NamePath"), String))
            End If
        Else
            redirectToNewVersion = True
        End If
        If redirectToNewVersion Then
            parentIDPath = CType(node.GetValue("idpath"), String)
            Dim copyDefaultCulture As String
            If Me.chkUseDefault.Checked Then
                copyDefaultCulture = "1"
            Else
                copyDefaultCulture = "0"
            End If
            Response.Redirect("edit.aspx?action=insert&idpath=" & parentIDPath & "&defaultcultureidpath=" & idpath & "&classname=" & className & "&copydefaultculture=" & copyDefaultCulture)
        End If
    End Sub
End Class
