Imports Kentico.CMS.TreeEngine
Imports System.IO

Public Class Properties
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblNodeName As System.Web.UI.WebControls.Label
    Protected WithEvents lblNodeType As System.Web.UI.WebControls.Label
    Protected WithEvents lblNodeTypeValue As System.Web.UI.WebControls.Label
    Protected WithEvents lblLastModified As System.Web.UI.WebControls.Label
    Protected WithEvents lblLastModifiedValue As System.Web.UI.WebControls.Label
    Protected WithEvents lblModifiedBy As System.Web.UI.WebControls.Label
    Protected WithEvents lblModifiedByValue As System.Web.UI.WebControls.Label
    Protected WithEvents lblNodeNameValue As System.Web.UI.WebControls.Label
    Protected WithEvents lblNodeAlias As System.Web.UI.WebControls.Label
    Protected WithEvents ltlShowAdvanced As System.Web.UI.WebControls.Literal
    Protected WithEvents lblNodeIDPath As System.Web.UI.WebControls.Label
    Protected WithEvents lblNodeAliasPath As System.Web.UI.WebControls.Label
    Protected WithEvents lblNodeIDPathValue As System.Web.UI.WebControls.Label
    Protected WithEvents lblNodeAliasPathValue As System.Web.UI.WebControls.Label
    Protected WithEvents lblNodeNamePath As System.Web.UI.WebControls.Label
    Protected WithEvents lblNodeNamePathValue As System.Web.UI.WebControls.Label
    Protected WithEvents txtNodeAlias As System.Web.UI.WebControls.TextBox
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents lblCreatedWhen As System.Web.UI.WebControls.Label
    Protected WithEvents lblCreatedBy As System.Web.UI.WebControls.Label
    Protected WithEvents lblCreatedWhenValue As System.Web.UI.WebControls.Label
    Protected WithEvents lblCreatedByValue As System.Web.UI.WebControls.Label

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim idpath As String = Request.QueryString("idpath") & ""
        Dim culture As String = Request.QueryString("culture") & ""
        lblInfo.Text = ""
        lblError.Text = ""
        ltlScript.Text = ""

        lblHeader.Text = ResMan.GetString("ContentProperties.Header")
        lblNodeName.Text = ResMan.GetString("ContentProperties.NodeName")
        lblNodeType.Text = ResMan.GetString("ContentProperties.NodeType")
        lblLastModified.Text = ResMan.GetString("ContentProperties.LastModified")
        lblModifiedBy.Text = ResMan.GetString("ContentProperties.ModifiedBy")
        lblNodeAlias.Text = ResMan.GetString("ContentProperties.NodeAlias")
        lblNodeIDPath.Text = ResMan.GetString("ContentProperties.NodeIDPath")
        lblNodeAliasPath.Text = ResMan.GetString("ContentProperties.NodeAliasPath")
        lblNodeNamePath.Text = ResMan.GetString("ContentProperties.NodeNamePath")
        lblCreatedBy.Text = ResMan.GetString("ContentProperties.CreatedBy")
        lblCreatedWhen.Text = ResMan.GetString("ContentProperties.CreatedWhen")
        ltlShowAdvanced.Text = "<b>" & ResMan.GetString("ContentProperties.ShowAdvanced") & "</b>"
        btnOK.Text = ResMan.GetString("ContentProperties.OK")

        Dim tree As TreeProvider
        Dim node As TreeNode

        If Not Page.IsPostBack Then
            'set values
            tree = Functions.GetTreeProvider
            node = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath)
            If Functions.UseMultilingualSupport And culture <> "" Then
                Dim aliaspath As String = CType(node.GetValue("AliasPath"), String)
                node = tree.SelectSingleNode("/" & culture & Functions.RemoveCultureFromAliasPath(aliaspath), TreePathTypeEnum.AliasPath)
                If node Is Nothing Then
                    Response.Redirect("NewCultureVersion.aspx?idpath=" & idpath & "&aliaspath=" & aliaspath & "&culture=" & culture)
                    Exit Sub
                Else
                    idpath = CType(node.GetValue("idpath"), String)
                End If
            End If
            'check permissions
            If Not (Functions.IsAuthorizedPerResource("CMS.Content", "Read") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read)) Then
                Functions.RedirectToAccessDenied(idpath, "Read (properties.aspx)")
                Exit Sub
            End If
            If Not (Functions.IsAuthorizedPerResource("CMS.Content", "Modify") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Modify)) Then
                Me.txtNodeAlias.ReadOnly = True
                Me.btnOK.Enabled = False
            End If
            If Not node Is Nothing Then
                lblNodeNameValue.Text = Server.HtmlEncode(CType(node.GetValue("NodeName"), String))
                txtNodeAlias.Text = Server.HtmlEncode(CType(node.GetValue("NodeAlias"), String))
                lblNodeTypeValue.Text = CType(node.GetValue("ClassDisplayName"), String)
                lblLastModifiedValue.Text = CType(node.GetValue("ModifiedWhen"), DateTime).ToString
                lblModifiedByValue.Text = CType(node.GetValue("FullName"), String) & " (" & CType(node.GetValue("UserName"), String) & ")"
                lblNodeIDPathValue.Text = CType(node.GetValue("IDPath"), String)
                lblNodeAliasPathValue.Text = Server.HtmlEncode(CType(node.GetValue("AliasPath"), String))
                lblNodeNamePathValue.Text = Server.HtmlEncode(CType(node.GetValue("NamePath"), String))
                lblCreatedWhenValue.Text = CType(node.GetValue("CreatedWhen"), DateTime).ToString
                lblCreatedByValue.Text = CType(node.GetValue("CreatorFullName"), String) & " (" & CType(node.GetValue("CreatorUserName"), String) & ")"
                If CType(node.GetValue("NodeAlias"), String) = "" OrElse (Functions.UseMultilingualSupport() AndAlso node.ClassName.ToLower() = "cms.culture") Then
                    Me.btnOK.Enabled = False
                    Me.txtNodeAlias.ReadOnly = True
                End If
            End If
        End If
    End Sub

    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        'save alias
        Dim nodeAlias As String
        Dim tree As TreeProvider
        Dim node As TreeNode
        Dim oldAliasPath As String
        Dim culture As String = Request.QueryString("culture")

        'check values
        nodeAlias = txtNodeAlias.Text.Trim
        If nodeAlias = "" Then
            lblError.Visible = True
            lblError.Text = ResMan.GetString("ContentProperties.ErrorNoAliasEntered")
        Else
            tree = Functions.GetTreeProvider

            node = tree.SelectSingleNode(Request.QueryString("idpath"), TreePathTypeEnum.IDPath)
            If Functions.UseMultilingualSupport And culture <> "" Then
                'find appropriate culture version
                Dim aliaspath As String = CType(node.GetValue("AliasPath"), String)
                node = tree.SelectSingleNode("/" & culture & Functions.RemoveCultureFromAliasPath(aliaspath), TreePathTypeEnum.AliasPath)
            End If
            If Not node Is Nothing Then
                oldAliasPath = CType(node.GetValue("AliasPath"), String)
                node.SetValue("NodeAlias", nodeAlias)
                node.Update()
                Functions.EnsureFriendlyURL(CType(node.GetValue("AliasPath"), String), oldAliasPath)
                txtNodeAlias.Text = CType(node.GetValue("NodeAlias"), String)
                lblNodeAliasPathValue.Text = CType(node.GetValue("aliaspath"), String)
                lblInfo.Text = ResMan.GetString("ContentProperties.ChangesSaved")
                'Refresh page which opened this dialog.
                If Request.QueryString("closeandupdate") = "1" Then
                    Dim path As String

                    If (Not ConfigurationSettings.AppSettings("CMSWebApplicationVirtualPath") Is Nothing) AndAlso ConfigurationSettings.AppSettings("CMSWebApplicationVirtualPath") <> "" AndAlso ConfigurationSettings.AppSettings("CMSWebApplicationVirtualPath") <> "/" Then
                        path = ConfigurationSettings.AppSettings("CMSWebApplicationVirtualPath") & Functions.RemoveCultureFromAliasPath(CType(node.GetValue("AliasPath"), String))
                    Else
                        path = Functions.RemoveCultureFromAliasPath(CType(node.GetValue("AliasPath"), String))
                    End If

                    'Render client script.
                    ltlScript.Text = "<script language=""javascript"">"
                    ltlScript.Text &= " parent.frames['header'].UpdateContentAndClose('" & Replace(path, "'", "\'") & "'); "
                    ltlScript.Text &= "</script>"
                End If
            End If
        End If
    End Sub
End Class
