Imports Kentico.CMS.TreeEngine
Imports Kentico.CMS.MetadataEngine
Imports Kentico.CMS.WorkflowEngine
Imports Kentico.CMS.DataEngine
Imports Kentico.CMS.Mailer

Public Class Publish
    Inherits System.Web.UI.Page

    Protected node As TreeNode
    Protected WithEvents lblWorkflowSteps As System.Web.UI.WebControls.Label
    Protected WithEvents lblWorkflowHistory As System.Web.UI.WebControls.Label
    Protected WithEvents DataGrid1 As System.Web.UI.WebControls.DataGrid
    Protected stepID As Integer
    Protected WithEvents DataGrid2 As System.Web.UI.WebControls.DataGrid
    Protected WithEvents txtComment As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblComment As System.Web.UI.WebControls.Label
    Protected WithEvents pnlMain As System.Web.UI.WebControls.Panel
    Protected WithEvents pnlForm As System.Web.UI.WebControls.Panel
    Protected WithEvents lblSendMail As System.Web.UI.WebControls.Label
    Protected WithEvents chkSendMail As System.Web.UI.WebControls.CheckBox
    Protected workflowID As Integer
    Protected tree As TreeProvider
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents btnCancel As System.Web.UI.WebControls.Button
    Protected WithEvents lblApprove As System.Web.UI.WebControls.Label
    Protected WithEvents ltlSetModeScript As System.Web.UI.WebControls.Literal
    Protected usesVersioning As Boolean

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents pnlApprove As System.Web.UI.WebControls.Panel
    Protected WithEvents btnApprove As System.Web.UI.WebControls.Button
    Protected WithEvents btnReject As System.Web.UI.WebControls.Button
    Protected WithEvents btnSubmitToApprove As System.Web.UI.WebControls.Button
    Protected WithEvents pnlSubmitToApprove As System.Web.UI.WebControls.Panel

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim idpath As String = Request.QueryString("idpath") & ""
        Dim culture As String = Request.QueryString("culture") & ""
        Tree = Functions.GetTreeProvider
        If (Not Page.IsPostBack) And Request.QueryString("returnback") & "" <> "" Then
            viewstate("returnback") = Request.UrlReferrer.ToString
        End If

        'set publish mode
        If Not Page.IsPostBack Then
            ltlSetModeScript.Text = "<script language=""JavaScript"">" & vbCrLf
            ltlSetModeScript.Text &= " try " & vbCrLf
            ltlSetModeScript.Text &= " { " & vbCrLf
            If ConfigurationSettings.AppSettings("CMSUseCheckinCheckout") = "false" Then
                ltlSetModeScript.Text &= "  parent.frames['header'].SetMode('publishNoLock'); " & vbCrLf
            Else
                ltlSetModeScript.Text &= "  parent.frames['header'].SetMode('publish'); " & vbCrLf
            End If                        
            ltlSetModeScript.Text &= " } " & vbCrLf
            ltlSetModeScript.Text &= " catch (e)" & vbCrLf
            ltlSetModeScript.Text &= " { " & vbCrLf
            ltlSetModeScript.Text &= " } " & vbCrLf
            ltlSetModeScript.Text &= "</script>" & vbCrLf
        Else
            ltlSetModeScript.Text = ""
        End If

        'generate correct return URL
        If (Not Page.IsPostBack) And Request.QueryString("returnback") & "" <> "" Then
            Me.btnCancel.Visible = True
            If InStr(Request.UrlReferrer.ToString.ToLower, "edit.aspx") > 0 AndAlso InStr(Request.UrlReferrer.ToString.ToLower, "action=insert") > 0 Then
                viewstate("returnback") = "edit.aspx?idpath=" & idpath & "&culture=" & culture
            Else
                viewstate("returnback") = Request.UrlReferrer.ToString
            End If
        End If

        'set labels
        If Not Page.IsPostBack Then
            Me.lblHeader.Text = ResMan.GetString("Publish.Header")
            Me.btnSubmitToApprove.Text = ResMan.GetString("Publish.SubmitToApproval")
            Me.btnApprove.Text = ResMan.GetString("Publish.Approve")
            Me.btnReject.Text = ResMan.GetString("Publish.Reject")
            Me.lblWorkflowSteps.Text = ResMan.GetString("Publish.WorkflowSteps")
            Me.lblComment.Text = ResMan.GetString("Publish.Comment")
            Me.lblSendMail.Text = ResMan.GetString("Publish.SendMail")
            Me.btnCancel.Text = ResMan.GetString("Publish.Cancel")
            Me.lblApprove.Text = ResMan.GetString("Publish.Approve")
        End If
        If (ConfigurationSettings.AppSettings("CMSSendWorkflowEmails") & "").ToLower.Trim = "false" Then
            Me.chkSendMail.Visible = False
            Me.lblSendMail.Visible = False
        Else
            Me.chkSendMail.Visible = True
            Me.lblSendMail.Visible = True
        End If
        lblError.Text = ""

        'get node
        node = Functions.GetNodeByIDPathAndCulture(idpath, culture)

        'multilingual support
        If node Is Nothing Then
            'culture version does not exist            
            node = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath)
            Response.Redirect("NewCultureVersion.aspx?idpath=" & idpath & "&aliaspath=" & CType(node.GetValue("aliaspath"), String) & "&culture=" & culture)
            Exit Sub
        Else
            idpath = CType(node.GetValue("idpath"), String)
        End If

        'check permissions        
        If Not (Functions.IsAuthorizedPerResource("CMS.Content", "Read") Or Functions.IsAuthorizedPerResource("CMS.Content", "ManageWorkflow") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read)) Then
            Functions.RedirectToAccessDenied(idpath, "Read (publish.aspx)")
            Exit Sub
        End If
        If Not (Functions.IsAuthorizedPerResource("CMS.Content", "Modify") Or Functions.IsAuthorizedPerResource("CMS.Content", "ManageWorkflow") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Modify)) Then
            'disable form
            DisablePnlForm()
        End If

        'check if document type supports versioning
        If Not CType(Functions.GetClassDRValue(CType(node.GetValue("ClassID"), Integer), "UseVersioning"), Boolean) Then
            pnlMain.Visible = False
            lblInfo.Text = ResMan.GetString("Publish.InfoDocumentDoesNotSupportVersioningWorkflow")
            usesVersioning = False
            Exit Sub
        Else
            usesVersioning = True
        End If

        'check if document isn't checked out
        If Not node.GetValue("CheckedOutByUserID") Is Nothing Then
            lblInfo.Text = ResMan.GetString("Publish.InfoDocumentIsCheckedOut")
            DisablePnlForm()
        End If

        'check if document has any version history record
        If node.GetValue("CheckedOutVersionHistoryID") Is Nothing Then
            lblInfo.Text = ResMan.GetString("Publish.InfoDocumentHasNoHistory")
            DisablePnlForm()
        End If

        'check if the next step is "published" and current step is "edit" show or hide the "send mail" checkbox
        Dim worMan As New WorkflowManager(tree)
        Dim nextStep As DataClass = worMan.GetNextStepInfo(CType(node.GetValue("NodeID"), Integer))
        Dim currentStep As DataClass = worMan.GetStepInfo(CType(node.GetValue("NodeID"), Integer))
        If (Not nextStep Is Nothing) AndAlso (Not nextStep.IsEmpty) Then
            If CType(nextStep.GetValue("StepName"), String).ToLower.Trim = "published" Then
                If (Not currentStep Is Nothing) AndAlso (Not currentStep.IsEmpty) Then
                    If CType(currentStep.GetValue("StepName"), String).ToLower.Trim = "edit" Then
                        'hide
                        Me.chkSendMail.Visible = False
                        Me.lblSendMail.Visible = False
                    End If
                End If
            End If
        End If

        'display steps
        Me.DataGrid1.Columns(1).HeaderText = ResMan.GetString("Publish.StepOrder")
        Me.DataGrid1.Columns(2).HeaderText = ResMan.GetString("Publish.StepName")

        'display workflow history
        Me.lblWorkflowHistory.Text = ResMan.GetString("Publish.WorkflowHistory")
        Me.DataGrid2.Columns(0).HeaderText = ResMan.GetString("Publish.ApprovedWhen")
        Me.DataGrid2.Columns(1).HeaderText = ResMan.GetString("Publish.StepDisplayName")
        Me.DataGrid2.Columns(2).HeaderText = ResMan.GetString("Publish.ApprovedByUserFullName")
        Me.DataGrid2.Columns(3).HeaderText = ResMan.GetString("Publish.Comment")
        Me.DataGrid2.Columns(4).HeaderText = ResMan.GetString("Publish.ApprovedRejected")
    End Sub

    'move to the next step
    Private Sub btnApprove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnApprove.Click
        Dim workMan As New WorkflowManager(Functions.GetTreeProvider)
        stepID = workMan.MoveToNextStep(CType(node.GetValue("NodeID"), Integer), txtComment.Text)
        Me.SendWorkflowApprove()
        Me.txtComment.Text = ""

        'check if current step is "published"
        Dim stepInfo As DataClass = workMan.GetStepInfo(CType(node.GetValue("NodeID"), Integer))
        If CType(stepInfo.GetValue("StepName"), String).ToLower.Trim = "published" Then
            DisablePnlForm()
        End If
    End Sub


    'move to the previous step
    Private Sub btnReject_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReject.Click
        Dim workMan As New WorkflowManager(Functions.GetTreeProvider)
        stepID = workMan.MoveToPreviousStep(CType(node.GetValue("NodeID"), Integer), txtComment.Text)
        Me.SendWorkflowReject()
        Me.txtComment.Text = ""
    End Sub


    'submit to approval
    Private Sub btnSubmitToApprove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSubmitToApprove.Click
        Dim workMan As New WorkflowManager(Functions.GetTreeProvider)
        stepID = workMan.MoveToNextStep(CType(node.GetValue("NodeID"), Integer), txtComment.Text)
        Me.SendWorkflowApprove()
        Me.txtComment.Text = ""

        'check if current step is "published"
        Dim stepInfo As DataClass = workMan.GetStepInfo(CType(node.GetValue("NodeID"), Integer))
        If CType(stepInfo.GetValue("StepName"), String).ToLower.Trim = "published" Then
            DisablePnlForm()
        End If
    End Sub


    'highlight the current workflow step
    Private Sub DataGrid1_ItemDataBound(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridItemEventArgs) Handles DataGrid1.ItemDataBound
        Dim dr As DataRowView

        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            dr = CType(e.Item.DataItem, DataRowView)
            If CType(dr("StepID"), Integer) = stepID Then
                e.Item.CssClass = "TableSelectedRow"
                e.Item.Cells(0).Text = "<img src=""../design/buttons/next.gif"">"
            End If
        End If
    End Sub


    'display approved/rejected
    Private Sub DataGrid2_ItemDataBound(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridItemEventArgs) Handles DataGrid2.ItemDataBound
        Dim dr As DataRowView

        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            dr = CType(e.Item.DataItem, DataRowView)
            If CType(dr("WasRejected"), Boolean) = True Then
                e.Item.Cells(4).Text = ResMan.GetString("Publish.WasRejected")
            Else
                e.Item.Cells(4).Text = ResMan.GetString("Publish.WasApproved")
            End If
        End If
    End Sub


    'update displayed data
    Private Sub Page_Prerender(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.PreRender
        If Not usesVersioning Then
            Exit Sub
        End If

        Me.SetStepDetails()

        Dim ds As DataSet

        'check if document supports versioning (workflow)
        If Not CType(Functions.GetClassDRValue(CType(node.GetValue("ClassID"), Integer), "UseVersioning"), Boolean) Then
            Exit Sub
        End If
        ds = tree.Connection.ExecuteQuery("cms.workflowstep.selectworkflowsteps", Nothing, "WorkflowID = " & workflowID.ToString)
        Me.DataGrid1.DataSource = ds.Tables(0)
        Me.DataGrid1.DataBind()

        ds = tree.Connection.ExecuteQuery("CMS.workflowhistory.selectwherenodeid", Nothing, " nodeid = " & CType(node.GetValue("NodeID"), Integer))
        Me.DataGrid2.DataSource = ds.Tables(0)
        Me.DataGrid2.DataBind()


        'get step info
        Dim workMan As New WorkflowManager(tree)
        Dim stepInfo As DataClass = workMan.GetStepInfo(CType(node.GetValue("NodeID"), Integer))

        'decide what should be displayed
        If CType(stepInfo.GetValue("StepName"), String).ToLower.Trim = "edit" Then
            'editing step
            Me.pnlSubmitToApprove.Visible = True
            Me.pnlApprove.Visible = False
        ElseIf CType(stepInfo.GetValue("StepName"), String).ToLower.Trim = "publish" Then
            'published 
            Me.pnlSubmitToApprove.Visible = False
            Me.pnlApprove.Visible = False
        Else
            'some step inside workflow
            Me.pnlSubmitToApprove.Visible = False
            Me.pnlApprove.Visible = True
        End If
    End Sub


    'send mail to inform next editor(s)
    Public Sub SendWorkflowApprove()
        If (Not Me.chkSendMail.Checked) Or (ConfigurationSettings.AppSettings("CMSSendWorkflowEmails") & "").ToLower.Trim = "false" Then
            Exit Sub
        End If

        Dim tree As TreeProvider = Functions.GetTreeProvider
        Dim currentUserInfo As DataClass
        Dim approvedByMailInfo As String
        Dim lastUserDC As DataClass
        Dim replacements(12, 1) As String
        Dim workMan As New WorkflowManager(tree)
        Dim previousStepInfo As DataClass = workMan.GetPreviousStepInfo(CType(node.GetValue("nodeid"), Integer))
        Dim currentStepInfo As DataClass = workMan.GetStepInfo(CType(node.GetValue("nodeid"), Integer))
        Dim usersDS As DataSet = workMan.GetUsersWhoCanApprove(CType(currentStepInfo.GetValue("StepID"), Integer))

        'get email list
        Dim usersDR As DataRow
        Dim userStartingPath As String
        Dim nodeAliasPath As String
        For Each usersDR In usersDS.Tables(0).Rows
            If (CType(usersDR("Email"), String) & "").Trim <> "" Then
                'add user to the maillist only if the document is located under his/her starting path 
                If usersDR("StartingAliasPath") Is DBNull.Value Then
                    userStartingPath = ""
                Else
                    userStartingPath = CType(usersDR("StartingAliasPath"), String).Trim
                End If
                nodeAliasPath = CType(node.GetValue("AliasPath"), String)
                If Functions.UseMultilingualSupport Then
                    'remove culture code
		    if userStartingPath = "" or userStartingPath = "/" then
			userStartingPath = "/"
		    else
			userStartingPath = Functions.RemoveCultureFromAliasPath( userStartingPath )
		    end if
                    nodeAliasPath = Functions.RemoveCultureFromAliasPath(nodeAliasPath)
                End If
                If userStartingPath = "" Or nodeAliasPath.ToLower.Trim.StartsWith(userStartingPath.ToLower.Trim) Then
                    'send mail to this user
                    If tree.UserID <> 0 Then
                        currentUserInfo = New DataClass("cms.user", tree.UserID, tree.Connection)
                        approvedByMailInfo = CType(currentUserInfo.GetValue("FullName"), String)
                        If Not currentUserInfo.GetValue("Email") Is Nothing Then
                            approvedByMailInfo &= " (<a href=""mailto:" & CType(currentUserInfo.GetValue("Email"), String) & """>" & CType(currentUserInfo.GetValue("Email"), String) & "</a>)"
                        End If
                    End If
                    replacements(0, 0) = "namepath"
                    replacements(0, 1) = CType(node.GetValue("NamePath"), String)
                    replacements(1, 0) = "approvedby"
                    replacements(1, 1) = approvedByMailInfo
                    replacements(2, 0) = "approvedwhen"
                    replacements(2, 1) = DateTime.Now.ToString
                    replacements(3, 0) = "originalstep"
                    replacements(3, 1) = CType(previousStepInfo.GetValue("StepDisplayName"), String)
                    replacements(4, 0) = "currentstep"
                    replacements(4, 1) = CType(currentStepInfo.GetValue("StepDisplayName"), String)
                    replacements(5, 0) = "comment"
                    replacements(5, 1) = Me.txtComment.Text
                    replacements(6, 0) = "idpath"
                    replacements(6, 1) = CType(node.GetValue("IDPath"), String)
                    replacements(7, 0) = "applicationurl"
                    replacements(7, 1) = HttpContext.Current.Request.Url.AbsoluteUri.Substring(0, InStr(HttpContext.Current.Request.Url.AbsoluteUri, "/content/publish.aspx") - 1)
                    replacements(8, 0) = "firstname"
                    replacements(8, 1) = GetDRValue(usersDR, "firstname")
                    replacements(9, 0) = "lastname"
                    replacements(9, 1) = GetDRValue(usersDR, "lastname")
                    replacements(10, 0) = "username"
                    replacements(10, 1) = GetDRValue(usersDR, "username")
                    replacements(11, 0) = "email"
                    replacements(11, 1) = GetDRValue(usersDR, "email")
                    replacements(12, 0) = "fullname"
                    replacements(12, 1) = GetDRValue(usersDR, "fullname")
                    Try
                        MailTemplateSender.SendPage(MetadataEngine.MetadataProvider.GetMetadataPath() & "\_MailTemplates\WorkflowApprove", ConfigurationSettings.AppSettings("CMSSendWorkflowEmailsFrom"), CType(usersDR("email"), String), "", ResMan.GetString("Publish.EmailSubjectApproved") & " " & CType(node.GetValue("NodeName"), String), replacements)
                    Catch ex As Exception
                        'error when sending an e-mail
                        lblError.Text = ResMan.GetString("Publish.SendMailError") & " " & ex.Message
                    End Try
                End If
            End If
        Next

        'send e-mail to the user who started the workflow
        If CType(previousStepInfo.GetValue("StepName"), String).ToLower.Trim <> "edit" Then
            Dim params(0, 2) As Object
            params(0, 0) = "@NodeID"
            params(0, 1) = CType(node.GetValue("NodeID"), Integer)
            Dim firstSubmissionDS As DataSet = tree.Connection.ExecuteQuery("cms.workflowhistory.getfirstsubmission", params)
            Dim dr As DataRow
            If firstSubmissionDS.Tables(0).Rows.Count > 0 Then
                dr = firstSubmissionDS.Tables(0).Rows(0)
            End If
            If (Not dr Is Nothing) AndAlso (Not dr("email") Is DBNull.Value) AndAlso (Not CType(dr("email"), String).Trim = "") Then
                If tree.UserID <> 0 Then
                    currentUserInfo = New DataClass("cms.user", tree.UserID, tree.Connection)
                    approvedByMailInfo = CType(currentUserInfo.GetValue("FullName"), String)
                    If Not currentUserInfo.GetValue("Email") Is Nothing Then
                        approvedByMailInfo &= " (<a href=""mailto:" & CType(currentUserInfo.GetValue("Email"), String) & """>" & CType(currentUserInfo.GetValue("Email"), String) & "</a>)"
                    End If
                End If
                replacements(0, 0) = "namepath"
                replacements(0, 1) = CType(node.GetValue("NamePath"), String)
                replacements(1, 0) = "approvedby"
                replacements(1, 1) = approvedByMailInfo
                replacements(2, 0) = "approvedwhen"
                replacements(2, 1) = DateTime.Now.ToString
                replacements(3, 0) = "originalstep"
                replacements(3, 1) = CType(previousStepInfo.GetValue("StepDisplayName"), String)
                replacements(4, 0) = "currentstep"
                replacements(4, 1) = CType(currentStepInfo.GetValue("StepDisplayName"), String)
                replacements(5, 0) = "comment"
                replacements(5, 1) = Me.txtComment.Text
                replacements(6, 0) = "idpath"
                replacements(6, 1) = CType(node.GetValue("IDPath"), String)
                replacements(7, 0) = "applicationurl"
                replacements(7, 1) = HttpContext.Current.Request.Url.AbsoluteUri.Substring(0, InStr(HttpContext.Current.Request.Url.AbsoluteUri, "/content/publish.aspx") - 1)
                replacements(8, 0) = "firstname"
                replacements(8, 1) = GetDRValue(dr, "firstname")
                replacements(9, 0) = "lastname"
                replacements(9, 1) = GetDRValue(dr, "lastname")
                replacements(10, 0) = "username"
                replacements(10, 1) = GetDRValue(dr, "username")
                replacements(11, 0) = "email"
                replacements(11, 1) = GetDRValue(dr, "email")
                replacements(12, 0) = "fullname"
                replacements(12, 1) = GetDRValue(dr, "fullname")
                Try
                    MailTemplateSender.SendPage(MetadataEngine.MetadataProvider.GetMetadataPath() & "\_MailTemplates\WorkflowApproveToCreator", ConfigurationSettings.AppSettings("CMSSendWorkflowEmailsFrom"), CType(dr("email"), String), "", ResMan.GetString("Publish.EmailSubjectApprovedToCreator") & " " & CType(node.GetValue("NodeName"), String), replacements)
                Catch ex As Exception
                    'error when sending an e-mail
                    lblError.Text = ResMan.GetString("Publish.SendMailError") & " " & ex.Message
                End Try
            End If
        End If
    End Sub


    'send mail to inform previous editor
    Public Sub SendWorkflowReject()
        If (Not Me.chkSendMail.Checked) Or (ConfigurationSettings.AppSettings("CMSSendWorkflowEmails") & "").ToLower.Trim = "false" Then
            Exit Sub
        End If

        Dim tree As TreeProvider = Functions.GetTreeProvider
        Dim currentUserInfo As DataClass
        Dim rejectedByMailInfo As String
        Dim lastUserDR As DataRow
        Dim lastUserDS As DataSet
        Dim replacements(12, 1) As String
        Dim workMan As New WorkflowManager(tree)
        Dim currentStepInfo As DataClass = workMan.GetStepInfo(CType(node.GetValue("nodeid"), Integer))
        Dim params(0, 2) As Object

        params(0, 0) = "@NodeID"
        params(0, 1) = CType(node.GetValue("NodeID"), Integer)
        lastUserDS = tree.Connection.ExecuteQuery("cms.workflowhistory.getlastapprove", params)
        If lastUserDS.Tables(0).Rows.Count > 0 Then
            lastUserDR = lastUserDS.Tables(0).Rows(0)
            If (CType(lastUserDR("Email"), String) & "").Trim <> "" Then
                If tree.UserID <> 0 Then
                    currentUserInfo = New DataClass("cms.user", tree.UserID, tree.Connection)
                    rejectedByMailInfo = CType(currentUserInfo.GetValue("FullName"), String)
                    If Not currentUserInfo.GetValue("Email") Is Nothing Then
                        rejectedByMailInfo &= " (<a href=""mailto:" & CType(currentUserInfo.GetValue("Email"), String) & """>" & CType(currentUserInfo.GetValue("Email"), String) & "</a>)"
                    End If
                End If
                replacements(0, 0) = "namepath"
                replacements(0, 1) = CType(node.GetValue("NamePath"), String)
                replacements(1, 0) = "rejectedby"
                replacements(1, 1) = rejectedByMailInfo
                replacements(2, 0) = "rejectedwhen"
                replacements(2, 1) = DateTime.Now.ToString
                replacements(3, 0) = "currentstep"
                replacements(3, 1) = CType(currentStepInfo.GetValue("StepDisplayName"), String)
                replacements(4, 0) = "comment"
                replacements(4, 1) = Me.txtComment.Text
                replacements(5, 0) = "idpath"
                replacements(5, 1) = CType(node.GetValue("IDPath"), String)
                replacements(6, 0) = "applicationurl"
                replacements(6, 1) = HttpContext.Current.Request.Url.AbsoluteUri.Substring(0, InStr(HttpContext.Current.Request.Url.AbsoluteUri, "/content/publish.aspx") - 1)
                replacements(7, 0) = "applicationurl"
                replacements(7, 1) = HttpContext.Current.Request.Url.AbsoluteUri.Substring(0, InStr(HttpContext.Current.Request.Url.AbsoluteUri, "/content/publish.aspx") - 1)
                replacements(8, 0) = "firstname"
                replacements(8, 1) = GetDRValue(lastUserDR, "firstname")
                replacements(9, 0) = "lastname"
                replacements(9, 1) = GetDRValue(lastUserDR, "lastname")
                replacements(10, 0) = "username"
                replacements(10, 1) = GetDRValue(lastUserDR, "username")
                replacements(11, 0) = "email"
                replacements(11, 1) = GetDRValue(lastUserDR, "email")
                replacements(12, 0) = "fullname"
                replacements(12, 1) = GetDRValue(lastUserDR, "fullname")
                MailTemplateSender.SendPage(MetadataEngine.MetadataProvider.GetMetadataPath() & "\_MailTemplates\WorkflowReject", ConfigurationSettings.AppSettings("CMSSendWorkflowEmailsFrom"), CType(lastUserDR("Email"), String), "", ResMan.GetString("Publish.EmailSubjectRejected") & " " & CType(node.GetValue("NodeName"), String), replacements)
            End If
        End If
    End Sub


    Protected Sub SetStepDetails()
        'get step info
        Dim workMan As New WorkflowManager(tree)
        Dim stepInfo As DataClass = workMan.GetStepInfo(CType(node.GetValue("NodeID"), Integer))
        stepID = CType(stepInfo.GetValue("StepID"), Integer)
        workflowID = CType(stepInfo.GetValue("WorkflowID"), Integer)

        'check if current user can approve/reject the document 
        If CType(stepInfo.GetValue("StepName"), String).ToLower.Trim <> "edit" Then
            If Not (workMan.CanUserApprove(CType(node.GetValue("NodeID"), Integer)) Or Functions.IsAuthorizedPerResource("cms.content", "ManageWorkflow")) Then
                DisablePnlForm()
            End If
        End If

        'check if current step is "published"
        If CType(stepInfo.GetValue("StepName"), String).ToLower.Trim = "published" Then
            DisablePnlForm()
        End If
    End Sub

    Private Function GetDRValue(ByVal dr As DataRow, ByVal columnName As String) As String
        Return CType(IIf(dr(columnName) Is DBNull.Value, "", CType(dr(columnName), String)), String)
    End Function

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        Response.Redirect(CType(viewstate("returnback"), String))
    End Sub

    Private Sub DisablePnlForm()
        pnlForm.Enabled = False
        Me.btnApprove.Enabled = False
        Me.btnApprove.CssClass = "FormButtonDisabled"
        Me.btnCancel.Enabled = False
        Me.btnCancel.CssClass = "FormButtonDisabled"
        Me.btnReject.Enabled = False
        Me.btnReject.CssClass = "FormButtonDisabled"
        Me.btnSubmitToApprove.Enabled = False
        Me.btnSubmitToApprove.CssClass = "FormButtonDisabled"
    End Sub
End Class
