Imports Kentico.CMS.DataEngine
Imports Kentico.CMS.MetadataEngine
Imports Kentico.CMS.TreeEngine

Public Class Relationships
    Inherits System.Web.UI.Page

    Protected editHint As String
    Protected deleteHint As String
    Protected WithEvents btnAddRelationship As System.Web.UI.WebControls.Button
    Protected deleteAllowed As Boolean = False
    Protected nodeID As Integer
    Protected idpath As String

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents btnDelete As System.Web.UI.WebControls.ImageButton
    Protected WithEvents QueryDataGrid1 As Kentico.CMS.CMSControls.QueryDataGrid
    Protected WithEvents ltlConfirmScript As System.Web.UI.WebControls.Literal
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Functions.RedirectExpressEdition("CMSDesk.Relationships")

        idpath = Request.QueryString("idpath") & ""
        Dim culture As String = Request.QueryString("culture") & ""
        Dim tree As TreeProvider
        Dim node As TreeNode

        tree = Functions.GetTreeProvider
        node = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath)

        'multilingual support
        If Functions.UseMultilingualSupport And culture <> "" Then
            Dim aliaspath As String = CType(node.GetValue("AliasPath"), String)
            node = tree.SelectSingleNode("/" & culture & Functions.RemoveCultureFromAliasPath(aliaspath), TreePathTypeEnum.AliasPath)
            If node Is Nothing Then
                Response.Redirect("NewCultureVersion.aspx?idpath=" & idpath & "&aliaspath=" & aliaspath & "&culture=" & culture)
                Exit Sub
            Else
                idpath = CType(node.GetValue("idpath"), String)
            End If
        End If

        viewstate("idpath") = idpath

        'check permissions
        If Not (Functions.IsAuthorizedPerResource("CMS.Content", "Read") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read)) Then
            Functions.RedirectToAccessDenied(idpath, "Read (properties.aspx)")
            Exit Sub
        End If

        'get node id
        nodeID = CType(node.GetValue("NodeID"), Integer)
        Me.QueryDataGrid1.WhereCondition = " LeftNodeID = '" & nodeID.ToString & "' OR RightNodeID = '" & nodeID.ToString & "' "

        editHint = ResMan.GetString("Relationships.EditHint")
        deleteHint = ResMan.GetString("Relationships.DeleteHint")
        'set column header names
        QueryDataGrid1.Columns(0).HeaderText = ResMan.GetString("Relationships.Action")
        QueryDataGrid1.Columns(1).HeaderText = ResMan.GetString("Relationships.LeftNodeDisplayName")
        QueryDataGrid1.Columns(2).HeaderText = ResMan.GetString("Relationships.RelationshipDisplayName")
        QueryDataGrid1.Columns(3).HeaderText = ResMan.GetString("Relationships.RightNodeDisplayName")
        btnAddRelationship.Text = ResMan.GetString("Relationships.btnAddRelationship")

        'confirmation question
        If Not (Functions.IsAuthorizedPerResource("CMS.Content", "Modify") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Modify)) Then
            ltlConfirmScript.Text = "<input type=""hidden"" id=""confirmationText"" value=""" & ResMan.GetString("Relationships.DeleteDenied") & """>"
            deleteAllowed = False
        Else
            ltlConfirmScript.Text = "<input type=""hidden"" id=""confirmationText"" value=""" & ResMan.GetString("Relationships.ConfirmDelete") & """>"
            deleteAllowed = True
        End If

        lblHeader.Text = ResMan.GetString("Relationships.Header")
    End Sub


    '''<summary>Deletes selected relationship name.</summary>
    Public Sub DeleteItem(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs)
        Dim arg() As String = CType(e.CommandArgument, String).Split(","c)
        Dim leftNodeId As Integer = Integer.Parse(arg(0))
        Dim rightNodeId As Integer = Integer.Parse(arg(1))
        Dim relationshipNameId As Integer = Integer.Parse(arg(2))
        Dim cn As GeneralConnection = Functions.GetTreeProvider.Connection

        'delete the workflow
        Dim params(2, 2) As Object
        params(0, 0) = "@LeftNodeID"
        params(0, 1) = leftNodeId
        params(1, 0) = "@RightNodeID"
        params(1, 1) = rightNodeId
        params(2, 0) = "@RelationshipNameID"
        params(2, 1) = relationshipNameId

        cn.ConnectionString = Functions.GetConnectionString
        cn.ExecuteQuery("CMS.Relationship.Delete", params)

        Response.Redirect(Page.Request.Url.ToString)
    End Sub


    Private Sub dtg_ItemDataBound(ByVal sender As System.Object, ByVal e As DataGridItemEventArgs) Handles QueryDataGrid1.ItemDataBound
        Dim btnCurrentButton As ImageButton

        'set up the delete button
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            btnCurrentButton = CType(e.Item.Cells(0).FindControl("btnDelete"), ImageButton)
            If deleteAllowed Then
                btnCurrentButton.Attributes.Add("OnClick", "return ConfirmDelete();")
            Else
                btnCurrentButton.Attributes.Add("OnClick", "DeleteDenied();")
            End If
            btnCurrentButton.Attributes.Add("title", deleteHint)
        End If
    End Sub

    Private Sub btnAddRelationship_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddRelationship.Click
        Response.Redirect("editrelationship.aspx?mainnodeid=" & nodeID)
    End Sub

    Private Shared Function GetNodeText(ByVal nodeName As Object, ByVal nodeIDPath As Object) As String
        Return "<a href=""contentframeset.aspx?expandmode=view&expandidpath=" & CType(nodeIDPath, String) & """>" & CType(nodeName, String) & "</a>"
    End Function
End Class
