Imports Kentico.CMS.TreeEngine
Imports Kentico.CMS.WorkflowEngine
Imports Kentico.CMS.DataEngine

Public Class Rollback
    Inherits System.Web.UI.Page

    Protected versionHistoryId As Integer

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents btnRollBack As System.Web.UI.WebControls.Button
    Protected WithEvents btnCancel As System.Web.UI.WebControls.Button
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.lblHeader.Text = ResMan.GetString("Rollback.Header")
        Me.btnRollBack.Text = ResMan.GetString("Rollback.Rollback")
        Me.lblInfo.Text = ResMan.GetString("Rollback.Confirm")
        Me.btnCancel.Text = ResMan.GetString("Rollback.Cancel")

        viewstate("historyUrl") = "history.aspx?idpath=" & Request.QueryString("idpath") & "&nodeid=" & Request.QueryString("nodeid") & "&culture=" & Request.QueryString("culture")
        versionHistoryId = Integer.Parse(Request.QueryString("VersionHistoryID"))
        Dim nodeID As Integer = Integer.Parse(Request.QueryString("NodeID"))
        Dim tree As TreeProvider = Functions.GetTreeProvider
        Dim node As TreeNode = tree.SelectSingleNode(nodeID)
        Dim idpath As String = CType(node.GetValue("idpath"), String)
        Dim allowRollback As Boolean = False

        'check permissions        
        If Not (Functions.IsAuthorizedPerResource("CMS.Content", "Read") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read)) Then
            Functions.RedirectToAccessDenied(idpath, "Read (history.aspx)")
            Exit Sub
        End If
        If Not (Functions.IsAuthorizedPerResource("CMS.Content", "Modify") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Modify)) Then
            'do not allow rollback
            allowRollback = False
            Me.lblInfo.Text = ResMan.GetString("Rollback.NotAllowedToModify")
        Else
            allowRollback = True
        End If

        'check status (checked-in/out)
        If allowRollback AndAlso Not node.GetValue("CheckedOutByUserID") Is Nothing Then
            allowRollback = False
            Me.lblInfo.Text = ResMan.GetString("Rollback.DocumentIsCheckedOut")
        End If

        'check workflow step
        Dim workMan As New WorkflowManager(tree)
        Dim stepInfo As DataClass = workMan.GetStepInfo(nodeID)
        If allowRollback AndAlso CType(stepInfo.GetValue("StepName"), String).ToLower.Trim <> "edit" AndAlso CType(stepInfo.GetValue("StepName"), String).ToLower.Trim <> "published" AndAlso Not workMan.CanUserApprove(nodeID) Then
            allowRollback = False
            Me.lblInfo.Text = ResMan.GetString("Rollback.CannotModifyInThisStep")
        End If

        Me.btnRollBack.Enabled = allowRollback
    End Sub


    Private Sub btnRollBack_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRollBack.Click
        Dim verMan As New VersionManager(Functions.GetTreeProvider)
        verMan.RollbackVersion(versionHistoryId)
        Me.lblInfo.Text = ResMan.GetString("Rollback.RollbackDone")
        Me.btnRollBack.Enabled = False
    End Sub


    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        'redirect user back to the list of versions
        Response.Redirect(CType(viewstate("historyUrl"), String))
    End Sub
End Class
