Imports System.Xml

Public Class SelectTemplateListing
    Inherits System.Web.UI.Page

    Protected title As String

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lstTemplates As System.Web.UI.WebControls.ListBox
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents btnCancel As System.Web.UI.WebControls.Button
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal
    Protected WithEvents lblSelectTemplate As System.Web.UI.WebControls.Label
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblTemplateName As System.Web.UI.WebControls.Label
    Protected WithEvents ltlTemplateDescription As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim node As XmlNode

        lblHeader.Text = ResMan.GetString("SelectTempalteHeader.Header")
        lblSelectTemplate.Text = ResMan.GetString("SelectTemplateListing.Header")
        btnOK.Text = ResMan.GetString("SelectTemplateListing.OK")
        btnCancel.Text = ResMan.GetString("SelectTemplateListing.Cancel")
        title = ResMan.GetString("SelectTemplateListing.Title")
        ltlScript.Text = ""
        If Not Page.IsPostBack Then
            'fill list of available templates
            For Each node In GetXML.SelectNodes("/templates/template")
                Me.lstTemplates.Items.Add(New ListItem(node.SelectSingleNode("name").InnerText, node.Attributes("filename").Value))
            Next
            If Me.lstTemplates.Items.Count > 0 Then
                Me.lstTemplates.SelectedIndex = 0
            End If
            DisplaySelectedTemplate()
        End If
    End Sub


    Private Function GetXML() As XmlDocument
        Dim xml As New XmlDocument
        xml.Load(Functions.GetMetadataPath & "\_PageTemplates\pagetemplates.config")
        Return xml
    End Function


    Private Sub lstTemplates_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstTemplates.SelectedIndexChanged
        DisplaySelectedTemplate()
    End Sub


    Private Sub DisplaySelectedTemplate()
        Dim node As XmlNode = GetXML.SelectSingleNode("/templates/template[@filename='" & Me.lstTemplates.SelectedValue & "']")
        If Not node Is Nothing Then
            Me.lblTemplateName.Text = node.SelectSingleNode("name").InnerText
            Me.ltlTemplateDescription.Text = node.SelectSingleNode("description").InnerText
        End If
    End Sub


    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        RunScript(" opener.document.getElementById('CMSForm1__ctl0_MenuItemType_hidPageTemplateAspx').value = '" & Replace(Me.lstTemplates.SelectedValue, "'", "\'") & "'; " _
        & "opener.document.getElementById('CMSForm1__ctl0_MenuItemType_txtPageTemplate').value = '" & Replace(Me.lstTemplates.SelectedItem.Text, "'", "\'") & "';window.close();")
    End Sub


    Private Sub RunScript(ByVal script As String)
        Me.ltlScript.Text = "<script language=""javascript"">"
        Me.ltlScript.Text &= script
        Me.ltlScript.Text &= "</script>"
    End Sub


    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        RunScript(" window.close(); ")
    End Sub
End Class
