Imports Kentico.CMS.TreeEngine

Public Class ShowHistoryVersion
    Inherits System.Web.UI.Page

    Protected title As String

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents CMSViewer1 As Kentico.CMS.CMSControls.CMSViewer
    Protected WithEvents pnlFile As System.Web.UI.WebControls.Panel
    Protected WithEvents ltlViewFileValue As System.Web.UI.WebControls.Literal
    Protected WithEvents lblViewFile As System.Web.UI.WebControls.Label
    Protected WithEvents lblFilePathValue As System.Web.UI.WebControls.Label
    Protected WithEvents lblFilePath As System.Web.UI.WebControls.Label
    Protected WithEvents lblFileSizeValue As System.Web.UI.WebControls.Label
    Protected WithEvents lblFileSize As System.Web.UI.WebControls.Label
    Protected WithEvents lblFileNameValue As System.Web.UI.WebControls.Label
    Protected WithEvents lblFileName As System.Web.UI.WebControls.Label
    Protected WithEvents Form1 As System.Web.UI.HtmlControls.HtmlForm
    Protected WithEvents Form2 As System.Web.UI.HtmlControls.HtmlForm

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim versionHistoryID As Integer = 0
        If Not Request.QueryString("VersionHistoryID") Is Nothing Then
            versionHistoryID = Integer.Parse(Request.QueryString("VersionHistoryID"))
        Else
            Exit Sub
        End If

        'set labels
        If Not Page.IsPostBack Then
            Me.lblFileName.Text = ResMan.GetString("ViewFile.FileName")
            Me.lblFilePath.Text = ResMan.GetString("ViewFile.FilePath")
            Me.lblFileSize.Text = ResMan.GetString("ViewFile.FileSize")
            Me.lblViewFile.Text = ResMan.GetString("ViewFile.ViewFile")
            Me.lblHeader.Text = ResMan.GetString("ShowHistoryVersion.Header")
            Me.title = ResMan.GetString("ShowHistoryVersion.Title")
        End If

        Dim tree As TreeProvider = Functions.GetTreeProvider
        Dim verMan As New VersionManager(Functions.GetTreeProvider)
        Dim node As TreeNode = verMan.GetVersion(versionHistoryID)

        'check permissions
        Dim currentNode As TreeNode = tree.SelectSingleNode(CType(node.GetValue("NodeID"), Integer))
        If Not (Functions.IsAuthorizedPerResource("CMS.Content", "Read") Or Functions.IsAuthorizedPerNode(CType(currentNode.GetValue("IDPath"), String), TreePathTypeEnum.IDPath, NodePermissionsEnum.Read)) Then
            Functions.RedirectToAccessDenied(CType(node.GetValue("AliasPath"), String), "Read (ShowHistoryVersion.aspx)")
            Exit Sub
        End If

        If node.ClassName.ToLower = "cms.file" Then
            Me.lblFileNameValue.Text = CType(node.GetValue("FileName"), String)
            Me.lblFilePathValue.Text = Functions.RemoveCultureFromAliasPath(node.GetParentPath(TreePathTypeEnum.AliasPath)) & "/" & CType(node.GetValue("FileName"), String)
            Me.lblFileSizeValue.Text = CType(node.GetValue("FileSize"), Integer).ToString
            If InStr(";.jpg;.gif;.bmp;.png;", ";" & System.IO.Path.GetExtension(CType(node.GetValue("FileName"), String)).ToLower & ";") > 0 Then
                Me.ltlViewFileValue.Text = "<img src=""GetFile.aspx?versionHistoryID=" & versionHistoryID.ToString & """>"
            Else
                Me.ltlViewFileValue.Text = "<a href=""GetFile.aspx?versionhistoryid=" & versionHistoryID.ToString & """ target=""_blank"">" & ResMan.GetString("ViewFile.OpenDocument") & "</a>"
            End If
            Me.CMSViewer1.Visible = False
        Else
            CMSViewer1.VersionHistoryID = Integer.Parse(Request.QueryString("VersionHistoryID") & "")
            Me.pnlFile.Visible = False
        End If
    End Sub

End Class
