Imports Kentico.CMS.CMSControls
Imports Kentico.CMS.TreeEngine
Imports Kentico.CMS.DataEngine

Public Class TreeData
    Inherits System.Web.UI.Page

    Private tree As TreeProvider
    Private Const cImageBasePath As String = "../Design/Tree"
    Private Const cIconsBasePath As String = "../Design/Icons/"

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents ltlRender As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ltlRender.Text = "<script language=""javascript"">" & vbCrLf
        ltlRender.Text &= " try { " & vbCrLf

        Try
            Dim action As String
            Dim idpath As String
            Dim aliasPath As String
            Dim nodeid As String
            Dim findIDPath As String
            Dim parentAliasPath As String

            If (Request.QueryString("idpath") Is Nothing OrElse Request.QueryString("idpath") = "") AndAlso (Not Request.QueryString("nodeid") Is Nothing) AndAlso Request.QueryString("nodeid").Trim <> "" Then
                idpath = Request.QueryString("nodeid")
            Else
                idpath = Request.QueryString("idpath")
            End If
            action = LCase(Trim(Request.QueryString("action") & ""))
            nodeid = Request.QueryString("nodeid")
            findIDPath = Request.QueryString("findidpath")
            tree = Functions.GetTreeProvider
            Select Case action
                Case "expandnode", "findnode"
                    If (Not (Functions.IsAuthorizedPerResource("CMS.Content", "ExploreTree") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.ExploreTree)) Or (ConfigurationSettings.AppSettings("CMSAllowUnfoldingOfAnyDocument") & "").ToLower.Trim = "false" And Not Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read)) Then
                        ShowErrorMessage(ResMan.GetString("AccessDenied.NotAllowedToUnfold"))
                    Else
                        If action = "findnode" AndAlso findIDPath.StartsWith(idpath) Then
                            Dim currentExpandPath As String = idpath
                            Dim newExpandPath As String
                            If currentExpandPath = "/" Then
                                newExpandPath = currentExpandPath & findIDPath.Split("/"c)(1)
                            Else
                                If findIDPath = currentExpandPath Then
                                    newExpandPath = currentExpandPath
                                Else
                                    newExpandPath = currentExpandPath & "/" & findIDPath.Substring(currentExpandPath.Length).Split("/"c)(1)
                                End If
                            End If
                            AddRenderScript(GetChildNodes(currentExpandPath, Request.QueryString("sample"), Request.QueryString("value")), currentExpandPath)
                            If findIDPath <> newExpandPath Then
                                'find child node
                                ltlRender.Text &= " parent.frames['tree'].FindNode('" & findIDPath & "', '" & newExpandPath & "'); "
                            Else
                                'select node
                                AddSelectNodeScript(newExpandPath, False, True)
                                ltlRender.Text &= " parent.frames['header'].SelectNodeWithMode('" & newExpandPath & "', ''); "
                            End If
                        Else
                            AddRenderScript(GetChildNodes(Request.QueryString("nodeid"), Request.QueryString("sample"), Request.QueryString("value")), Request.QueryString("nodeid"))
                            If Request.QueryString("selectID") & "" <> "" Then
                                AddSelectNodeScript(Request.QueryString("selectID"), False, True)
                            End If
                        End If
                    End If
                Case "delete"
                    If Not (Functions.IsAuthorizedPerResource("CMS.Content", "Delete") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Delete)) Then
                        ShowErrorMessage(ResMan.GetString("AccessDenied.NotAllowedToDeleteDocument"))
                    Else
                        Dim deletedIDPathParent As String
                        Dim culture As String = Request.QueryString("culture") & ""
                        Dim destroy As Boolean = False
                        Dim node As TreeNode
                        Dim useVersioning As Boolean

                        If (Request.QueryString("destroy") & "").ToLower.Trim = "true" Then
                            destroy = True
                        End If
                        If Functions.UseMultilingualSupport And culture <> "" Then
                            'aliasPath = "/" & culture & Functions.RemoveCultureFromAliasPath(GetAliasPath(idpath))
                            aliasPath = Functions.GetMultilingualAliasPath(idpath, culture)
                        Else
                            aliasPath = GetAliasPath(idpath)
                        End If
                        node = tree.SelectSingleNode(aliasPath, TreePathTypeEnum.AliasPath)
                        parentAliasPath = node.GetParentPath(TreePathTypeEnum.AliasPath)
                        useVersioning = CType(Functions.GetClassDRValue(CType(node.GetValue("ClassID"), Integer), "UseVersioning"), Boolean)
                        If (destroy = True And useVersioning = True) Or (useVersioning = False) Then
                            Functions.DeleteFriendlyURL(aliasPath)
                            DeleteAttachements(idpath)
                        End If
                        deletedIDPathParent = DeleteNode(idpath, destroy)
                        'update UI
                        If Request.QueryString("closewindow") = "true" Then                            
                            Dim path As String
                            If (Not ConfigurationSettings.AppSettings("CMSWebApplicationVirtualPath") Is Nothing) AndAlso ConfigurationSettings.AppSettings("CMSWebApplicationVirtualPath") <> "" AndAlso ConfigurationSettings.AppSettings("CMSWebApplicationVirtualPath") <> "/" Then
                                path = ConfigurationSettings.AppSettings("CMSWebApplicationVirtualPath") & Functions.RemoveCultureFromAliasPath(parentAliasPath)
                            Else
                                path = Functions.RemoveCultureFromAliasPath(parentAliasPath)
                            End If
                            path = Functions.GetUrlForAliasPath(path)
                            Me.ltlRender.Text &= " parent.frames['header'].UpdateContentAndClose('" & Replace(path, "'", "\'") & "'); " & vbCrLf
                        Else
                                'reload node only if it is of default culture or multilingual support is not used
                                If Functions.UseMultilingualSupport = False Or (Functions.UseMultilingualSupport And aliasPath.Split("/"c).Length > 2 AndAlso (Trim(LCase(culture & "")) = Trim(LCase(ConfigurationSettings.AppSettings("CMSDefaultCultureCode") & "")))) Then
                                    AddSelectNodeScript(deletedIDPathParent, True, False)
                                    AddReloadSelectedNodeScript()
                                End If
                                If Functions.UseMultilingualSupport = True And Trim(LCase(culture & "")) <> Trim(LCase(ConfigurationSettings.AppSettings("CMSDefaultCultureCode") & "")) Then
                                    AddSelectNodeScript(idpath, True, False)
                                    AddReloadSelectedNodeScript()
                                End If
                            End If
                        End If
                Case "copy"
                    If Not ((Functions.IsAuthorizedPerResource("CMS.Content", "read") Or Functions.IsAuthorizedPerNode(Request.QueryString("sourceIDPath"), TreePathTypeEnum.IDPath, NodePermissionsEnum.Read)) And (Functions.IsAuthorizedPerResource("CMS.Content", "create") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Create))) Then
                        ShowErrorMessage(ResMan.GetString("AccessDenied.NotAllowedToCopyDocument"))
                    Else
                        If (Request.QueryString("idpath") & "/").StartsWith(Request.QueryString("sourceIDPath") & "/") Then
                            ShowErrorMessage(ResMan.GetString("TreeData.CannotCopyNodeToItself"))
                        Else
                            'check allowed child types
                            Dim sourceClassID As Integer = CType(tree.SelectSingleNode(Request.QueryString("sourceIDPath"), TreePathTypeEnum.IDPath).GetValue("ClassID"), Integer)
                            Dim targetClassID As Integer = CType(tree.SelectSingleNode(Request.QueryString("idpath"), TreePathTypeEnum.IDPath).GetValue("ClassID"), Integer)
                            If Not CheckAllowedChildType(targetClassID, sourceClassID) Then
                                ShowErrorMessage(ResMan.GetString("TreeData.CannotCopyNodeHere"))
                            Else
                                'copy node
                                CopyNode(Request.QueryString("sourceIDPath"), Request.QueryString("idpath"))
                                AddSelectNodeScript(Request.QueryString("idpath"), True, False)
                                AddReloadSelectedNodeScript()
                            End If
                        End If
                    End If
                Case "move"
                    If Not ((Functions.IsAuthorizedPerResource("CMS.Content", "modify") Or Functions.IsAuthorizedPerNode(Request.QueryString("sourceIDPath"), TreePathTypeEnum.IDPath, NodePermissionsEnum.Modify)) And (Functions.IsAuthorizedPerResource("CMS.Content", "create") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Create))) Then
                        ShowErrorMessage(ResMan.GetString("AccessDenied.NotAllowedToMoveDocument"))
                    Else
                        If (Request.QueryString("idpath") & "/").StartsWith(Request.QueryString("sourceIDPath") & "/") Then
                            ShowErrorMessage(ResMan.GetString("TreeData.CannotMoveNodeToItself"))
                        Else
                            'check allowed child types
                            Dim sourceClassID As Integer = CType(tree.SelectSingleNode(Request.QueryString("sourceIDPath"), TreePathTypeEnum.IDPath).GetValue("ClassID"), Integer)
                            Dim targetClassID As Integer = CType(tree.SelectSingleNode(Request.QueryString("idpath"), TreePathTypeEnum.IDPath).GetValue("ClassID"), Integer)
                            If Not CheckAllowedChildType(targetClassID, sourceClassID) Then
                                ShowErrorMessage(ResMan.GetString("TreeData.CannotMoveNodeHere"))
                            Else
                                'move node
                                MoveNode(Request.QueryString("sourceIDPath"), Request.QueryString("idpath"))
                                AddSelectNodeScript(Request.QueryString("idpath"), True, False)
                                AddRemoveNodeScript(Request.QueryString("sourceIDPath"))
                                AddReloadSelectedNodeScript()
                            End If
                        End If
                    End If
            End Select
        Catch ex As Exception
            ShowErrorMessage("Error:" & ex.Message.Replace(vbCrLf, " "))
        End Try
        ltlRender.Text &= " } " & vbCrLf
        ltlRender.Text &= " catch (e) { " & vbCrLf        
        ltlRender.Text &= " } " & vbCrLf
        ltlRender.Text &= "</script>"
    End Sub


    '''<summary>Adds script that removes the given node from the displayed tree.</summary>
    '''<param name="nodeIDPath">IDPath of the node to be removed.</param>
    Public Sub AddRemoveNodeScript(ByVal nodeIDPath As String)
        ltlRender.Text &= " parent.frames['tree'].document.getElementById('nodeID_" & nodeIDPath & "').innerHTML = '';"
    End Sub


    '''<summary>Adds script that reloads the selected node.</summary>
    Public Sub AddReloadSelectedNodeScript()
        ltlRender.Text &= " parent.frames['tree'].ReloadSelectedNode();" & vbCrLf
    End Sub


    '''<summary>Adds script that selects given node.</summary>
    '''<param name="selectIDPath">IDPath of the node to be selected.</param>
    '''<param name="selectDesktop">Indicates if desktop should be updated.</param>
    '''<param name="selectMenu">Indicates if menu (header) selected item value should be updated.</param>
    Public Sub AddSelectNodeScript(ByVal selectIDPath As String, ByVal selectDesktop As Boolean, ByVal selectMenu As Boolean)
        ltlRender.Text &= " function SelectNode(selectID) {" & vbCrLf & _
                         "  //try {" & vbCrLf & _
                         "  parent.frames['tree'].SelectNode(selectID);" & vbCrLf
        If selectDesktop Then
            ltlRender.Text &= "  parent.frames['header'].SelectNode(selectID);" & vbCrLf
        End If
        If selectMenu Then
            ltlRender.Text &= "  parent.frames['header'].document.getElementById('idpath').value = selectID;" & vbCrLf
        End If
        ltlRender.Text &= "  //} catch(e) { } " & vbCrLf & _
                          " } " & vbCrLf
        ltlRender.Text &= " SelectNode('" & selectIDPath & "'); " & vbCrLf
    End Sub


    '''<summary>Adds content that will be rendered under given parent node.</summary>
    '''<param name="content">Content to be rendered.</param>
    '''<param name="targetNodeIDPath">Target node IDPath.</param>
    Public Sub AddRenderScript(ByVal content As String, ByVal targetNodeIDPath As String)
        Dim innerHTML As String
        innerHTML = Replace(content & "", "'", "\'")
        innerHTML = Replace(innerHTML, """", "\""")
        innerHTML = Replace(innerHTML, vbCrLf, " ")

        ltlRender.Text &= " function RenderData() {" & vbCrLf & _
                            "  parent.frames['tree'].document.getElementById('sub_" & targetNodeIDPath & "').innerHTML = '" & innerHTML & "'; " & vbCrLf
        If innerHTML & "" = "" Then
            ltlRender.Text &= " parent.frames['tree'].document.getElementById('sub_" & targetNodeIDPath & "').style.display = 'none'; " & vbCrLf
        End If
        ltlRender.Text &= " } " & vbCrLf
        ltlRender.Text &= " RenderData(); " & vbCrLf
    End Sub


    '''<summary>Displays an error message.</summary>
    '''<param name="message">Error message.</param>
    Public Sub ShowErrorMessage(ByVal message As String)
        ltlRender.Text &= " alert('" & Replace(Replace(message & "", "\", "\\"), "'", "\'") & "');" & vbCrLf
        ltlRender.Text &= " parent.frames['tree'].document.getElementById('sub_" & Request.QueryString("NodeID") & "').innerHTML = ''; " & vbCrLf
        ltlRender.Text &= " parent.frames['tree'].document.getElementById('sub_" & Request.QueryString("NodeID") & "').style.display = 'none'; " & vbCrLf
    End Sub


    '''<summary>Returns child nodes at 2nd and lower level.</summary>
    '''<param name="NodeID">Parent node ID (IDPath).</param>
    '''<param name="Sample">Sample for displaying tree.</param>
    '''<param name="Value">Value of the parent node.</param>
    Function GetChildNodes(ByVal NodeID As String, ByVal Sample As String, ByVal Value As String) As String
        Dim nodes As New TreeNodes
        Dim dr As DataRow
        Dim nodeRows As DataRowCollection
        Dim maxNodeNumber As Integer = 100
        If (Not ConfigurationSettings.AppSettings("CMSMaxTreeNodes") Is Nothing) AndAlso (ConfigurationSettings.AppSettings("CMSMaxTreeNodes") <> "") Then
            maxNodeNumber = Integer.Parse(ConfigurationSettings.AppSettings("CMSMaxTreeNodes"))
        End If
        Dim nodeNumber As Integer = 0

        nodes.ImagePathBase = cImageBasePath
        If NodeID = "/" Then
            nodeRows = tree.SelectNodes("/%", TreePathTypeEnum.IDPath, "", " NodeLevel <> 0 ", "", 1).Tables(0).Rows()
        Else
            nodeRows = tree.SelectNodes(Value & "/%", TreePathTypeEnum.IDPath, "", "", "", 1).Tables(0).Rows
        End If
        For Each dr In nodeRows
            nodes.NewNode(CType(dr("NodeName"), String), Value, cIconsBasePath & CType(dr("classname"), String) & ".gif", cIconsBasePath & CType(dr("classname"), String) & "_open.gif", CType(dr("NodeName"), String), "parent.frames['header'].SelectNode('" & CType(dr("IDPath"), String) & "')", CType(dr("IDPath"), String), Sample, True)
            nodeNumber += 1
            If nodeNumber >= maxNodeNumber Then
                nodes.NewNode(ResMan.GetString("treedata.uselisting"), Value, cIconsBasePath & "blank.gif", cIconsBasePath & "blank.gif", ResMan.GetString("treedata.uselisting"), "parent.frames['header'].ChooseMode('listing'); parent.frames['header'].SetMode('listing'); parent.frames.header.SelectNode('" & NodeID & "');", "...", Sample, False)
                Exit For
            End If
        Next
        Return nodes.NodesHTML
    End Function


    '''<summary>Deletes specified node and returns IDPath of its parent.</summary>
    '''<param name="IDPath">IDPath of the node to be deleted.</param>
    Function DeleteNode(ByVal IDPath As String, ByVal destroy As Boolean) As String
        'delete the node
        Dim tree As TreeProvider = Functions.GetTreeProvider
        Dim node As TreeNode
        Dim parentIDPath As String
        Dim aliaspath As String
        Dim culture As String = Request.QueryString("culture")
        Dim verMan As New VersionManager(tree)
        Dim isMultilingualContent As Boolean = False
        Dim cultureNode As TreeNode

        node = tree.SelectSingleNode(IDPath, TreePathTypeEnum.IDPath)
        parentIDPath = node.GetParentPath(TreePathTypeEnum.IDPath)
        If Not node Is Nothing Then
            'check if this is a multilingual content
            If IDPath.Split("/"c)(1) <> "" Then
                cultureNode = tree.SelectSingleNode("/" & IDPath.Split("/"c)(1), TreePathTypeEnum.IDPath)
                If cultureNode.ClassName.ToLower = "cms.culture" Then
                    isMultilingualContent = True
                End If
            End If
            If Functions.UseMultilingualSupport And culture <> "" And isMultilingualContent Then
                If Trim(LCase(culture & "")) = Trim(LCase(ConfigurationSettings.AppSettings("CMSDefaultCultureCode") & "")) Then
                    'delete all culture versions
                    Dim drCulture As DataRow
                    Dim aliasPathWithoutCulture As String = Functions.RemoveCultureFromAliasPath(CType(node.GetValue("AliasPath"), String))
                    For Each drCulture In GetCulturesDataSet(tree).Tables(0).Rows
                        Try
                            aliaspath = "/" & CType(drCulture("CultureCode"), String) & aliasPathWithoutCulture
                            node = tree.SelectSingleNode(aliaspath, TreePathTypeEnum.AliasPath)
                            If Not node Is Nothing Then
                                If destroy Then
                                    verMan.DestroyNodeHistory(CType(node.GetValue("NodeID"), Integer))
                                End If
                                node.Delete()
                            End If
                        Catch
                        End Try
                    Next
                Else
                    'delete only selected culture
                    aliaspath = Functions.GetMultilingualAliasPath(IDPath, culture)
                    node = tree.SelectSingleNode(aliaspath, TreePathTypeEnum.AliasPath)
                    If destroy Then
                        verMan.DestroyNodeHistory(CType(node.GetValue("NodeID"), Integer))
                    End If
                    node.Delete()
                End If
            Else
                If destroy Then
                    verMan.DestroyNodeHistory(CType(node.GetValue("NodeID"), Integer))
                End If
                node.Delete()
            End If
        End If
        Return parentIDPath
    End Function

    '''<summary>Deletes attachements from the disk.</summary>
    '''<param name="IDPath">IDPath of the node to be deleted.</param>
    Sub DeleteAttachements(ByVal IDPath As String)
        'delete the node
        Dim tree As TreeProvider = Functions.GetTreeProvider
        Dim node As TreeNode
        Dim parentIDPath As String
        Dim aliaspath As String
        Dim culture As String = Request.QueryString("culture")
        Dim verMan As New VersionManager(tree)
        Dim isMultilingualContent As Boolean = False
        Dim cultureNode As TreeNode

        node = tree.SelectSingleNode(IDPath, TreePathTypeEnum.IDPath)
        parentIDPath = node.GetParentPath(TreePathTypeEnum.IDPath)
        If Not node Is Nothing Then
            'check if this is a multilingual content
            If IDPath.Split("/"c)(1) <> "" Then
                cultureNode = tree.SelectSingleNode("/" & IDPath.Split("/"c)(1), TreePathTypeEnum.IDPath)
                If cultureNode.ClassName.ToLower = "cms.culture" Then
                    isMultilingualContent = True
                End If
            End If
            If Functions.UseMultilingualSupport And culture <> "" And isMultilingualContent Then
                If Trim(LCase(culture & "")) = Trim(LCase(ConfigurationSettings.AppSettings("CMSDefaultCultureCode") & "")) Then
                    'delete all culture versions
                    Dim drCulture As DataRow
                    Dim aliasPathWithoutCulture As String = Functions.RemoveCultureFromAliasPath(CType(node.GetValue("AliasPath"), String))
                    For Each drCulture In GetCulturesDataSet(tree).Tables(0).Rows
                        Try
                            aliaspath = "/" & CType(drCulture("CultureCode"), String) & aliasPathWithoutCulture
                            node = tree.SelectSingleNode(aliaspath, TreePathTypeEnum.AliasPath)
                            If Not node Is Nothing Then
                                Functions.DeleteAttachment(aliaspath)
                            End If
                        Catch
                        End Try
                    Next
                Else
                    'delete only selected culture
                    aliaspath = Functions.GetMultilingualAliasPath(IDPath, culture)
                    Functions.DeleteAttachment(aliaspath)
                End If
            Else
                'if not multilingual version
                aliaspath = GetAliasPath(IDPath)
                Functions.DeleteAttachment(aliaspath)
            End If
        End If
    End Sub

    '''<summary>Copies specified node.</summary>
    '''<param name="sourceID">Source IDPath.</param>
    '''<param name="targetIDPath">Target IDPath.</param>
    Sub CopyNode(ByVal sourceIDPath As String, ByVal targetIDPath As String)
        If sourceIDPath = targetIDPath Then
            Exit Sub
        End If
        Dim tree As TreeProvider
        Dim newNode As TreeNode
        Dim copiedNode As TreeNode
        Dim isSourceMultilingualContent As Boolean = False
        Dim isTargetMultilingualContent As Boolean = False
        Dim cultureNode As TreeNode

        tree = Functions.GetTreeProvider
        If Functions.UseMultilingualSupport Then
            If sourceIDPath.Split("/"c)(1) <> "" Then
                cultureNode = tree.SelectSingleNode("/" & sourceIDPath.Split("/"c)(1), TreePathTypeEnum.IDPath)
                If cultureNode.ClassName.ToLower = "cms.culture" Then
                    isSourceMultilingualContent = True
                End If
            End If
            If targetIDPath.Split("/"c)(1) <> "" Then
                cultureNode = tree.SelectSingleNode("/" & targetIDPath.Split("/"c)(1), TreePathTypeEnum.IDPath)
                If cultureNode.ClassName.ToLower = "cms.culture" Then
                    isTargetMultilingualContent = True
                End If
            End If

            Dim sourceAliasPath As String
            If isSourceMultilingualContent = True Then
                sourceAliasPath = Functions.RemoveCultureFromAliasPath(GetAliasPath(sourceIDPath))
            Else
                sourceAliasPath = GetAliasPath(sourceIDPath)
            End If

            Dim targetAliasPath As String
            If isTargetMultilingualContent = True Then
                targetAliasPath = Functions.RemoveCultureFromAliasPath(GetAliasPath(targetIDPath))
            Else
                targetAliasPath = GetAliasPath(targetIDPath)
            End If

            If isSourceMultilingualContent And isTargetMultilingualContent Then
                Dim dsCultures As DataSet
                Dim drCulture As DataRow
                For Each drCulture In Me.GetCulturesDataSet(tree).Tables(0).Rows
                    Try
                        Dim copySourcePath As String = "/" & CType(drCulture("CultureCode"), String) & sourceAliasPath
                        Dim copyTargetPath As String = "/" & CType(drCulture("CultureCode"), String) & targetAliasPath
                        copiedNode = Nothing
                        'create a all parent nodes in drCulture
                        Functions.CreateNodePath(copyTargetPath)
                        copiedNode = tree.CopyNode(copySourcePath, copyTargetPath, TreePathTypeEnum.AliasPath)
                        If Not copiedNode Is Nothing Then
                            newNode = copiedNode

                            copyTargetPath = CType(newNode.GetValue("AliasPath"), String)
                            If newNode.ClassName.ToLower <> "cms.file" Then
                                Functions.CopyFriendlyURL(copySourcePath, copyTargetPath)
                            End If
                            'copy file for each language version
                            If newNode.ClassName.ToLower = "cms.file" Then
                                Functions.CopyAttachment(copySourcePath, copyTargetPath)
                            End If
                        End If
                    Catch
                    End Try
                Next
            End If

            If isSourceMultilingualContent = False And isTargetMultilingualContent Then
                copiedNode = tree.CopyNode(sourceAliasPath, "/" & ConfigurationSettings.AppSettings("CMSDefaultCultureCode") & targetAliasPath, TreePathTypeEnum.AliasPath)
            End If
            If isSourceMultilingualContent And isTargetMultilingualContent = False Then
                copiedNode = tree.CopyNode("/" & ConfigurationSettings.AppSettings("CMSDefaultCultureCode") & sourceAliasPath, targetAliasPath, TreePathTypeEnum.AliasPath)
            End If
        Else
            newNode = tree.CopyNode(sourceIDPath, targetIDPath, TreePathTypeEnum.IDPath)

            Dim copySourcePath As String = GetAliasPath(sourceIDPath)
            Dim copyTargetPath As String = CType(newNode.GetValue("AliasPath"), String)
            If newNode.ClassName.ToLower <> "cms.file" Then
                Functions.CopyFriendlyURL(copySourcePath, copyTargetPath)
            End If
            If newNode.ClassName.ToLower = "cms.file" Then
                Functions.CopyAttachment(copySourcePath, copyTargetPath)
            End If
        End If
    End Sub

    '''<summary>Moves specified node.</summary>
    '''<param name="sourceID">Source IDPath.</param>
    '''<param name="targetIDPath">Target IDPath.</param>
    Sub MoveNode(ByVal sourceIDPath As String, ByVal targetIDPath As String)
        Dim tree As TreeProvider
        Dim newAliasPath As String
        Dim oldAliasPath As String
        Dim nodeID As Integer
        Dim node As TreeNode
        Dim newNode As TreeNode
        Dim movedNode As TreeNode

        tree = Functions.GetTreeProvider
        node = tree.SelectSingleNode(sourceIDPath, TreePathTypeEnum.IDPath)
        If node Is Nothing Then
            Exit Sub
        End If
        oldAliasPath = CType(node.GetValue("AliasPath"), String)
        nodeID = CType(node.GetValue("NodeID"), Integer)

        If Functions.UseMultilingualSupport Then
            Dim isSourceMultilingualContent As Boolean
            Dim isTargetMultilingualContent As Boolean
            Dim cultureNode As TreeNode

            If sourceIDPath.Split("/"c)(1) <> "" Then
                cultureNode = tree.SelectSingleNode("/" & sourceIDPath.Split("/"c)(1), TreePathTypeEnum.IDPath)
                If cultureNode.ClassName.ToLower = "cms.culture" Then
                    isSourceMultilingualContent = True
                End If
            End If
            If targetIDPath.Split("/"c)(1) <> "" Then
                cultureNode = tree.SelectSingleNode("/" & targetIDPath.Split("/"c)(1), TreePathTypeEnum.IDPath)
                If cultureNode.ClassName.ToLower = "cms.culture" Then
                    isTargetMultilingualContent = True
                End If
            End If

            Dim sourceAliasPath As String
            If isSourceMultilingualContent = True Then
                sourceAliasPath = Functions.RemoveCultureFromAliasPath(GetAliasPath(sourceIDPath))
            Else
                sourceAliasPath = GetAliasPath(sourceIDPath)
            End If

            Dim targetAliasPath As String
            If isTargetMultilingualContent = True Then
                targetAliasPath = Functions.RemoveCultureFromAliasPath(GetAliasPath(targetIDPath))
            Else
                targetAliasPath = GetAliasPath(targetIDPath)
            End If

            If isSourceMultilingualContent And isTargetMultilingualContent Then
                Dim dsCultures As DataSet
                Dim drCulture As DataRow

                For Each drCulture In GetCulturesDataSet(tree).Tables(0).Rows
                    Try
                        Dim copySourcePath As String = "/" & CType(drCulture("CultureCode"), String) & sourceAliasPath
                        Dim copyTargetPath As String = "/" & CType(drCulture("CultureCode"), String) & targetAliasPath
                        movedNode = Nothing
                        'create a all parent nodes in drCulture
                        Functions.CreateNodePath(copyTargetPath)
                        movedNode = tree.MoveNode(copySourcePath, copyTargetPath, TreePathTypeEnum.AliasPath)
                        If Not movedNode Is Nothing Then
                            newNode = movedNode

                            copyTargetPath = CType(newNode.GetValue("AliasPath"), String)
                            If newNode.ClassName.ToLower <> "cms.file" Then
                                Functions.EnsureFriendlyURL(copyTargetPath, oldAliasPath)
                            Else                                
                                Functions.MoveAttachment(oldAliasPath, copyTargetPath)
                            End If
                        End If
                    Catch
                    End Try
                Next
                Exit Sub
            End If

            If isSourceMultilingualContent = False And isTargetMultilingualContent Then
                newNode = tree.MoveNode(sourceAliasPath, "/" & ConfigurationSettings.AppSettings("CMSDefaultCultureCode") & targetAliasPath, TreePathTypeEnum.AliasPath)
            End If
            If isSourceMultilingualContent And isTargetMultilingualContent = False Then
                newNode = tree.MoveNode("/" & ConfigurationSettings.AppSettings("CMSDefaultCultureCode") & sourceAliasPath, targetAliasPath, TreePathTypeEnum.AliasPath)
            End If
        Else
            newNode = tree.MoveNode(sourceIDPath, targetIDPath, TreePathTypeEnum.IDPath)
        End If

        If newNode.ClassName.ToLower <> "cms.file" Then
            Functions.EnsureFriendlyURL(CType(newNode.GetValue("AliasPath"), String), oldAliasPath)
        Else
            Functions.MoveAttachment(oldAliasPath, CType(newNode.GetValue("AliasPath"), String))
        End If
    End Sub


    '''<summary>Converts IDPath to AliasPath.</summary>
    '''<param name="idpath">IDPath to be converted.</param>
    Private Function GetAliasPath(ByVal idpath As String) As String
        Dim tree As TreeProvider = Functions.GetTreeProvider
        Dim node As TreeNode = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath)
        If node Is Nothing Then
            Return ""
        Else
            Return CType(node.GetValue("AliasPath"), String)
        End If
    End Function


    '''<summary>Returns DataSet containing all cultures.</summary>
    Private Function GetCulturesDataSet(ByVal tree As TreeProvider) As DataSet
        Return tree.Connection.ExecuteQuery("cms.culture.selectbypath", Nothing, " 1=1 ", " 1 ")
    End Function


    '''<summary>Returns true if specified child type can be placed under specified parent type.</summary>
    Private Function CheckAllowedChildType(ByVal parentClassID As Integer, ByVal childClassID As Integer) As Boolean
        Dim cn As New GeneralConnection(Functions.GetConnectionString)
        Dim ds As DataSet

        ds = cn.ExecuteQuery("cms.allowedchildclasses.selectallowed", Nothing, " parentClassID = '" & parentClassID.ToString & "' AND childClassID = '" & childClassID.ToString & "' ")
        If ds.Tables(0).Rows.Count > 0 Then
            Return True
        Else
            Return False
        End If
    End Function
End Class
