Imports Kentico.CMS.TreeEngine
Imports Kentico.CMS.ContentEngine
Imports Kentico.CMS.MetadataEngine
Imports System.IO

Public Class View
    Inherits System.Web.UI.Page

    Protected cssPath As String

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblRedirect As System.Web.UI.WebControls.Label
    Protected WithEvents CMSViewer1 As Kentico.CMS.CMSControls.CMSViewer

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim idpath As String = Request.QueryString("idpath") & ""
        Dim culture As String = Request.QueryString("culture") & ""
        Dim versionHistoryID As Integer = 0
        Dim tree As TreeProvider = Functions.GetTreeProvider
        Dim node As TreeNode
        Dim viewPage As String
        Dim aliaspath As String
        Dim verMan As VersionManager

        If Request.QueryString("versionhistoryid") & "" <> "" Then
            versionHistoryID = Integer.Parse(Request.QueryString("versionhistoryid") & "")
        End If

        If versionHistoryID = 0 Then
            'get node to read its class name
            node = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath)
            aliaspath = CType(node.GetValue("AliasPath"), String)
            If Functions.UseMultilingualSupport And culture <> "" Then
                node = tree.SelectSingleNode("/" & culture & Functions.RemoveCultureFromAliasPath(aliaspath), TreePathTypeEnum.AliasPath)
                If node Is Nothing Then
                    Response.Redirect("NewCultureVersion.aspx?idpath=" & idpath & "&aliaspath=" & aliaspath & "&culture=" & culture)
                    Exit Sub
                Else
                    idpath = CType(node.GetValue("idpath"), String)
                End If
            End If

            'check permissions
            If Not (Functions.IsAuthorizedPerResource("CMS.Content", "Read") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read)) Then
                Functions.RedirectToAccessDenied(idpath, "Read (view.aspx)")
                Exit Sub
            End If

            If node.ClassName.ToLower = "cms.root" Or (node.ClassName.ToLower = "cms.menuitem" AndAlso CType(node.GetValue("MenuItemPageTemplate"), String) & "" <> "") Then
                'this is a page, show it
                Dim url As String
                Dim targetAliasPath As String

                If Functions.UseMultilingualSupport() And culture <> "" Then
                    targetAliasPath = Functions.RemoveCultureFromAliasPath(aliaspath)
                    Session("CMSPreferredCulture") = culture
                    Response.Cookies.Add(New HttpCookie("CMSPreferredCulture", culture))
                Else
                    targetAliasPath = aliaspath
                End If
                If ConfigurationSettings.AppSettings("CMSWebApplicationVirtualPath") = "/" Then
                    Response.Redirect(Functions.GetUrlForAliasPath(targetAliasPath))
                Else
                    Response.Redirect(ConfigurationSettings.AppSettings("CMSWebApplicationVirtualPath") & Functions.GetUrlForAliasPath(targetAliasPath))
                End If
                Exit Sub
            End If
            If idpath = "/" Then
                Response.Redirect(ConfigurationSettings.AppSettings("CMSWebApplicationVirtualPath"))
            End If
            'display item using the default transformation
            CMSViewer1.SelectNodesPathType = TreePathTypeEnum.IDPath
            CMSViewer1.SelectNodesPath = idpath
        Else
            CMSViewer1.VersionHistoryID = versionHistoryID
            verMan = New VersionManager(tree)
            node = verMan.GetVersion(versionHistoryID)
            'check permissions
            Dim currentNode As TreeNode = tree.SelectSingleNode(CType(node.GetValue("NodeID"), Integer))
            If Not (Functions.IsAuthorizedPerResource("CMS.Content", "Read") Or Functions.IsAuthorizedPerNode(CType(currentNode.GetValue("IDPath"), String), TreePathTypeEnum.IDPath, NodePermissionsEnum.Read)) Then
                Functions.RedirectToAccessDenied(CType(node.GetValue("AliasPath"), String), "Read (View.aspx)")
                Exit Sub
            End If
        End If

        'find out if there's a special viewing page for the specified node
        viewPage = MetadataProvider.GetSettingsValue(node.ClassName, "CMSViewPage")
        If viewPage <> "" Then
            lblRedirect.Text = ResMan.GetString("ContentView.Redirect")
            lblRedirect.Visible = True
            Dim styleParams As String = "style=" & Request.QueryString("style") & "&ftbName=" & Request.QueryString("ftbName")
            If versionHistoryID = 0 Then
                Response.Redirect(viewPage & "?idpath=" & idpath & "&" & styleParams)
            Else
                Response.Redirect(viewPage & "?versionhistoryid=" & versionHistoryID & "&" & styleParams)
            End If
        End If

        CMSViewer1.SelectNodesClassName = node.ClassName
        CMSViewer1.TreeProvider = tree

        'set css path        
        If File.Exists(ConfigurationSettings.AppSettings("CMSMetadataFolder") & "/" & Replace(node.ClassName & "", ".", "/") & "/transformations/default.css") Then
            cssPath = ConfigurationSettings.AppSettings("CMSMetadataFolder") & "/" & Replace(node.ClassName & "", ".", "/") & "/transformations/default.css"
        Else
            'class'es default css, use main web site css
            If ConfigurationSettings.AppSettings("CMSCSSVirtualPath") & "" = "" Then
                'no default css specified - use ~/main.css instead
                cssPath = ResolveUrl("~/main.css")
            Else
                'css specified
                cssPath = ConfigurationSettings.AppSettings("CMSCSSVirtualPath")
            End If
        End If
    End Sub

End Class
