Imports Kentico.CMS.TreeEngine

Public Class ViewFile
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblFileName As System.Web.UI.WebControls.Label
    Protected WithEvents lblFileNameValue As System.Web.UI.WebControls.Label
    Protected WithEvents lblFileSize As System.Web.UI.WebControls.Label
    Protected WithEvents lblFileSizeValue As System.Web.UI.WebControls.Label
    Protected WithEvents lblFilePath As System.Web.UI.WebControls.Label
    Protected WithEvents lblFilePathValue As System.Web.UI.WebControls.Label
    Protected WithEvents lblViewFile As System.Web.UI.WebControls.Label
    Protected WithEvents ltlViewFileValue As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim idpath As String = Request.QueryString("idpath") & ""
        Dim culture As String = Request.QueryString("culture") & ""
        Dim tree As TreeProvider = Functions.GetTreeProvider
        Dim node As TreeNode
        Dim versionHistoryID As Integer = 0

        If Not Request.QueryString("VersionHistoryID") Is Nothing Then
            versionHistoryID = Integer.Parse(Request.QueryString("VersionHistoryID"))
        End If

        'set labels
        If Not Page.IsPostBack Then
            Me.lblFileName.Text = ResMan.GetString("ViewFile.FileName")
            Me.lblFilePath.Text = ResMan.GetString("ViewFile.FilePath")
            Me.lblFileSize.Text = ResMan.GetString("ViewFile.FileSize")
            Me.lblViewFile.Text = ResMan.GetString("ViewFile.ViewFile")
        End If

        'get node
        If versionHistoryID = 0 Then
            node = Functions.GetNodeByIDPathAndCulture(idpath, culture)

            'multilingual support
            If node Is Nothing Then
                'culture version does not exist            
                node = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath)
                Response.Redirect("NewCultureVersion.aspx?idpath=" & idpath & "&aliaspath=" & CType(node.GetValue("aliaspath"), String) & "&culture=" & culture)
                Exit Sub
            Else
                idpath = CType(node.GetValue("idpath"), String)
            End If

            'check permissions        
            If Not (Functions.IsAuthorizedPerResource("CMS.Content", "Read") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read)) Then
                Functions.RedirectToAccessDenied(idpath, "Read (publish.aspx)")
                Exit Sub
            End If

            node = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath, "cms.file")
        Else
            Dim verMan As New VersionManager(tree)
            node = verMan.GetVersion(versionHistoryID)
            'check permissions
            Dim currentNode As TreeNode = tree.SelectSingleNode(CType(node.GetValue("NodeID"), Integer))
            If Not (Functions.IsAuthorizedPerResource("CMS.Content", "Read") Or Functions.IsAuthorizedPerNode(CType(currentNode.GetValue("IDPath"), String), TreePathTypeEnum.IDPath, NodePermissionsEnum.Read)) Then
                Functions.RedirectToAccessDenied(CType(node.GetValue("AliasPath"), String), "Read (ViewFile.aspx)")
                Exit Sub
            End If
        End If

        Me.lblFileNameValue.Text = CType(node.GetValue("FileName"), String)
        Dim parentPath As String = Functions.RemoveCultureFromAliasPath(node.GetParentPath(TreePathTypeEnum.AliasPath))
        If Not parentPath.EndsWith("/") Then
            parentPath &= "/"
        End If
        Me.lblFilePathValue.Text = parentPath & CType(node.GetValue("FileName"), String)
        Me.lblFileSizeValue.Text = CType(node.GetValue("FileSize"), Integer).ToString
        'If versionHistoryID = 0 Then
        'optionally add "paste" link
        If Request.QueryString("style") <> "" Then
            Dim path As String
            Dim selectorPath As String
            If (Not ConfigurationSettings.AppSettings("CMSFilesFolder") Is Nothing) AndAlso ConfigurationSettings.AppSettings("CMSFilesFolder") <> "" AndAlso Me.lblFilePathValue.Text.ToLower.StartsWith("/files") Then
                path = ResolveUrl(ConfigurationSettings.AppSettings("CMSFilesFolder") & Me.lblFilePathValue.Text.Substring("/files".Length))
            Else
                path = ResolveUrl("~" & Me.lblFilePathValue.Text)
            End If
            'freetextbox
            If (ConfigurationSettings.AppSettings("CMSWysiwygEditor") & "").ToLower.Trim = "freetextbox" And LCase(Request.QueryString("style") & "") = "selectimage" Then
                If Request.QueryString("ftbName") & "" <> "" Then
                    ltlViewFileValue.Text = "<span onclick=""top.window.opener.FTB_InsertText('" & Request.QueryString("ftbName") & "'"
                    ltlViewFileValue.Text &= ", '<img src=\'" & path & "\'>');top.window.close();"" style=""cursor:pointer;text-decoration:underline;color:blue"">" & ResMan.GetString("FileViewHeader.PasteImage") & "</span><br>"
                Else
                    ltlViewFileValue.Text = "<span onclick=""window.top.opener.SetUrl('" & path.Replace("'", "\'") & "');window.top.close();window.top.opener.focus();"" style=""cursor:pointer;color:blue;text-decoration:underline"">" & ResMan.GetString("FileViewHeader.PasteImage") & "</span><br>"
                End If
            End If
            'file selector 
            If LCase(Request.QueryString("style") & "") = "selectpicturepath" Then
                Dim id1 As String = Request.QueryString("ftbName").Split(","c)(0)
                Dim id2 As String = Request.QueryString("ftbName").Split(","c)(1)
                ltlViewFileValue.Text = "<span onclick="""
                ltlViewFileValue.Text &= "top.window.opener.document.getElementById('" & id1 & "').value = '" & Me.lblFilePathValue.Text.Replace("'", "\'") & "';"
                ltlViewFileValue.Text &= "if (top.window.opener.document.getElementById('" & id2 & "') != null) {top.window.opener.document.getElementById('" & id2 & "').src = 'getfile.aspx?filepath=" & Me.lblFilePathValue.Text.Replace("'", "\'") & "';"
                ltlViewFileValue.Text &= "top.window.opener.document.getElementById('" & id2 & "').style.display = 'block';}"
                ltlViewFileValue.Text &= "top.window.close();"" style=""cursor:pointer;text-decoration:underline;color:blue"">" & ResMan.GetString("FileViewHeader.SelectDocument") & "</span><br>"
            End If
            'fckeditor
            If (ConfigurationSettings.AppSettings("CMSWysiwygEditor") & "").ToLower.Trim <> "freetextbox" AndAlso (Request.QueryString("style") & "").ToLower.Trim = "selectimage" Then
                ltlViewFileValue.Text = "<span onclick=""window.top.opener.SetUrl('" & path.Replace("'", "\'") & "');window.top.close();window.top.opener.focus();"" style=""cursor:pointer;color:blue;text-decoration:underline"">" & ResMan.GetString("FileViewHeader.PasteImage") & "</span><br>"
            End If
        End If
        'End If
        If InStr(";.jpg;.gif;.bmp;.png;", ";" & System.IO.Path.GetExtension(CType(node.GetValue("FileName"), String)).ToLower & ";") > 0 Then
            'display image preview
            If versionHistoryID = 0 Then
                Me.ltlViewFileValue.Text &= "<img src=""GetFile.aspx?idpath=" & CType(node.GetValue("idpath"), String) & """>"
            Else
                Me.ltlViewFileValue.Text &= "<img src=""GetFile.aspx?versionHistoryID=" & versionHistoryID.ToString & """>"
            End If
        Else
            'display document link
            If versionHistoryID = 0 Then
                Me.ltlViewFileValue.Text &= "<a href=""GetFile.aspx?idpath=" & CType(node.GetValue("idpath"), String) & """ target=""_blank"">" & ResMan.GetString("ViewFile.OpenDocument") & "</a>"
            Else
                Me.ltlViewFileValue.Text &= "<a href=""GetFile.aspx?versionhistoryid=" & versionHistoryID.ToString & """ target=""_blank"">" & ResMan.GetString("ViewFile.OpenDocument") & "</a>"
            End If
        End If
    End Sub

End Class
