Imports Kentico.CMS.TreeEngine

Public Class ViewFrameset
    Inherits System.Web.UI.Page

    Protected url As String
    Protected urlParams As String
    Protected idPath As String
    Protected headerParams As String

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim culture As String = Request.QueryString("culture") & ""
        Dim aliaspath As String = ""
        Dim tree As TreeProvider
        Dim node As TreeNode
        idpath = Request.QueryString("idpath") & ""

        tree = Functions.GetTreeProvider
        node = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath)
        'if multilingual support is used and the required culture version is not available, redirect user to the NewCultureVersion page
        If Functions.UseMultilingualSupport And LCase(Trim(culture)) <> LCase(Trim(ConfigurationSettings.AppSettings("CMSDefaultCultureCode") & "")) And culture & "" <> "" Then
            aliaspath = "/" & culture & Functions.RemoveCultureFromAliasPath(CType(node.GetValue("AliasPath"), String))
            node = tree.SelectSingleNode("/" & culture & Functions.RemoveCultureFromAliasPath(aliaspath), TreePathTypeEnum.AliasPath)
            If node Is Nothing Then
                Response.Redirect("NewCultureVersion.aspx?idpath=" & idpath & "&aliaspath=" & aliaspath & "&culture=" & culture)
                Exit Sub
            End If
        End If

        If (Not node Is Nothing) AndAlso (Not node.GetValue("CheckedOutVersionHistoryID") Is Nothing) AndAlso CType(Functions.GetClassDRValue(CType(node.GetValue("ClassID"), Integer), "UseVersioning"), Boolean) Then
            'use versioning
            urlParams = "versionhistoryid=" & CType(node.GetValue("CheckedOutVersionHistoryID"), Integer).ToString & "&culture=" & culture
            headerParams = urlParams & "&idpath=" & idPath
        Else
            'do not use versioning
            urlParams = "idpath=" & idPath & "&culture=" & culture
            headerParams = urlParams
        End If

        'check permissions
        If Not (Functions.IsAuthorizedPerResource("CMS.Content", "Read") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read)) Then
            Functions.RedirectToAccessDenied(idpath, "Read (view.aspx)")
            Exit Sub
        End If

        'Set the view page depending on the document class type
        If Not node Is Nothing Then
            If node.ClassName.ToLower() = "cms.file" Then
                url = "viewfile.aspx?ftbname=" & Request.QueryString("ftbName") & "&style=" & Request.QueryString("style") & "&" & urlParams
            ElseIf node.ClassName.ToLower() = "cms.newslettercontainer" Then
                url = "../Tools/Newsletter/NewsletterContainerView.aspx?" & urlParams
            ElseIf node.ClassName.ToLower() = "cms.newsletter" Then
                url = "../Tools/Newsletter/NewsletterView.aspx?" & urlParams
            ElseIf node.ClassName.ToLower() = "cms.newsletterissue" Then
                url = "view.aspx?" & urlParams
            Else
                url = ""
            End If
        End If
    End Sub

End Class
