Imports Kentico.CMS.TreeEngine
Imports Kentico.CMS.MetadataEngine

Public Class ViewHeader
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents radShowLastVersion As System.Web.UI.WebControls.RadioButton
    Protected WithEvents radShowPublishedVersion As System.Web.UI.WebControls.RadioButton
    Protected WithEvents radEdit As System.Web.UI.WebControls.RadioButton
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        lblHeader.Text = ResMan.GetString("ContentView.Header")
        radShowLastVersion.Text = ResMan.GetString("ViewHeader.radShowLastVersion")
        radShowPublishedVersion.Text = ResMan.GetString("ViewHeader.radShowPublishedVersion")
        radEdit.Text = ResMan.GetString("ViewHeader.radEdit")

        Dim idpath As String = Request.QueryString("idpath")
        Dim culture As String = Request.QueryString("culture") & ""
        Dim tree As TreeProvider = Functions.GetTreeProvider
        Dim node As TreeNode 'latest version (current document if versioning not supported
        Dim aliaspath As String

        node = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath)
        'multilingual support
        aliaspath = CType(node.GetValue("AliasPath"), String)
        If Functions.UseMultilingualSupport And culture <> "" Then
            node = tree.SelectSingleNode("/" & culture & Functions.RemoveCultureFromAliasPath(aliaspath), TreePathTypeEnum.AliasPath)
        End If

        'check permissions
        If Not (Functions.IsAuthorizedPerResource("CMS.Content", "Read") Or Functions.IsAuthorizedPerNode(CType(node.GetValue("idpath"), String), TreePathTypeEnum.IDPath, NodePermissionsEnum.Read)) Then
            Functions.RedirectToAccessDenied(idpath, "Read (view.aspx)")
            Exit Sub
        End If

        'get web path of the node
        Dim webpath As String = GetWebPath(node)

        'display or hide radio buttons 
        If (Not node Is Nothing) Then
            Dim publishedscript As String
            'File view mode?
            Select Case CType(node.GetValue("className"), String).ToLower
                Case "cms.file", "cms.newsletter", "cms.newsletterissue", "cms.newslettercontainer"
                    Dim viewpage As String
                    Select Case CType(node.GetValue("className"), String).ToLower
                        Case "cms.file"
                            viewpage = "viewfile.aspx"
                        Case "cms.newsletter"
                            viewpage = "../Tools/Newsletter/NewsletterView.aspx"
                        Case "cms.newslettercontainer"
                            viewpage = "../Tools/Newsletter/NewsletterContainerView.aspx"
                        Case "cms.newsletterissue"
                            viewpage = "View.aspx"
                    End Select
                    Me.ltlScript.Text = ""
                    Me.radEdit.Visible = False
                    If Not IsPostBack Then
                        Me.radShowPublishedVersion.Checked = True
                    End If
                    'check if document type supports versioning
                    If (Not node.GetValue("CheckedOutVersionHistoryID") Is Nothing) AndAlso CType(Functions.GetClassDRValue(CType(node.GetValue("ClassID"), Integer), "UseVersioning"), Boolean) Then
                        'get latest version of the node
                        Dim lastversionscript As String = "parent.frames['viewer'].location.href = '" & ResolveUrl(viewpage) & "?idpath=" & idpath & "&culture=" & Request.QueryString("culture") & "&versionhistoryid=" & CType(node.GetValue("CheckedOutVersionHistoryID"), Integer).ToString & "';"
                        'display last version radio button
                        radShowLastVersion.Visible = True
                        'get VersionHistoryID of the latest version
                        radShowLastVersion.Attributes.Add("OnClick", "javascript:" & lastversionscript)
                    Else
                        Me.radShowLastVersion.Visible = False
                    End If
                    Dim pubnode As TreeNode = tree.SelectSingleNode(CType(node.GetValue("AliasPath"), String), TreePathTypeEnum.AliasPath, CType(node.GetValue("ClassName"), String), True)
                    If Not pubnode Is Nothing Then
                        publishedscript = "parent.frames['viewer'].location.href = '" & ResolveUrl(viewpage) & "?idpath=" & CType(pubnode.GetValue("IDPath"), String) & "&culture=" & Request.QueryString("culture") & "';"
                        radShowPublishedVersion.Attributes.Add("OnClick", "javascript:" & publishedscript)
                    Else
                        Me.radShowPublishedVersion.Visible = False
                    End If
                Case Else
                    Me.radEdit.Visible = True
                    Dim editscript As String
                    'check if document type supports versioning
                    If (Not node.GetValue("CheckedOutVersionHistoryID") Is Nothing) AndAlso CType(Functions.GetClassDRValue(CType(node.GetValue("ClassID"), Integer), "UseVersioning"), Boolean) Then
                        'get latest version of the node
                        Dim verMan As VersionManager = New VersionManager(tree)
                        Dim vernode As TreeNode = verMan.GetVersion(CType(node.GetValue("CheckedOutVersionHistoryID"), Integer))
                        If vernode Is Nothing Then
                            vernode = node
                        End If
                        Dim verwebpath As String = GetWebPath(vernode)
                        Dim lastversionscript As String = "parent.frames['viewer'].location.href = '" & ResolveUrl("../Browse/redirBrowse.aspx") & "?target=" & verwebpath & "&culture=" & culture & "&setmode=browse';"
                        editscript = "parent.frames['viewer'].location.href = '" & ResolveUrl("../Browse/redirBrowse.aspx") & "?target=" & verwebpath & "&culture=" & culture & "&setmode=edit';"
                        'display last version radio button
                        radShowLastVersion.Visible = True
                        'get VersionHistoryID of the latest version
                        radShowLastVersion.Attributes.Add("OnClick", "javascript:" & lastversionscript)
                        'remove - WebSite does not support versioning yet
                        Me.radShowLastVersion.Visible = False
                    Else
                        Me.radShowLastVersion.Visible = False
                        editscript = "parent.frames['viewer'].location.href = '" & ResolveUrl("../Browse/redirBrowse.aspx") & "?target=" & webpath & "&culture=" & culture & "&setmode=edit';"
                    End If
                    'Other choices
                    publishedscript = "parent.frames['viewer'].location.href = '" & ResolveUrl("../Browse/redirBrowse.aspx") & "?target=" & webpath & "&culture=" & culture & "&setmode=browse';"
                    radShowPublishedVersion.Attributes.Add("OnClick", "javascript:" & publishedscript)
                    radEdit.Attributes.Add("OnClick", "javascript:" & editscript)
                    Me.ltlScript.Text = "<script language='javascript'>" & vbCrLf
                    If radEdit.Checked Then
                        Me.ltlScript.Text &= Me.radEdit.Attributes("OnClick") & vbCrLf
                    ElseIf Me.radShowLastVersion.Checked Then
                        Me.ltlScript.Text &= Me.radShowLastVersion.Attributes("OnClick") & vbCrLf
                    ElseIf Me.radShowPublishedVersion.Checked Then
                        Me.ltlScript.Text &= Me.radShowPublishedVersion.Attributes("OnClick") & vbCrLf
                    End If
                    Me.ltlScript.Text &= "</script>" & vbCrLf
            End Select
        Else
            'hide radio buttons
            radShowLastVersion.Visible = False
            Me.radEdit.Visible = False
            Me.radShowPublishedVersion.Visible = False
        End If
    End Sub

    '''<summary>Returns web path of the node</summary>
    '''<param name="node">Node to get webpath to</param>
    Function GetWebPath(ByVal node As TreeNode) As String
        If node Is Nothing Then Return Nothing
        Dim webpath As String
        If ConfigurationSettings.AppSettings("CMSWebApplicationVirtualPath") & "" = "" Then
            webpath = "/"
        Else
            webpath = ConfigurationSettings.AppSettings("CMSWebApplicationVirtualPath")
        End If
        'page in editing mode
        If Not node Is Nothing Then
            Dim relPath As String = Functions.RemoveCultureFromAliasPath(System.Convert.ToString(node.GetValue("AliasPath")))
            If relPath <> "/" And relPath <> "" Then
                If webpath = "/" Then
                    webpath = Functions.GetUrlForAliasPath(relPath)
                Else
                    webpath &= Functions.GetUrlForAliasPath(relPath)
                End If
            End If
        End If
        Return webpath
    End Function

End Class
