Imports System.IO
Imports Kentico.DirectoryUtilities

Public Class FileManagerEdit
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents pnlFile As System.Web.UI.WebControls.Panel
    Protected WithEvents pnlFolder As System.Web.UI.WebControls.Panel
    Protected WithEvents btnFileOK As System.Web.UI.WebControls.Button
    Protected WithEvents btnFolderOK As System.Web.UI.WebControls.Button
    Protected WithEvents btnFolderCancel As System.Web.UI.WebControls.Button
    Protected WithEvents radFileRename As System.Web.UI.WebControls.RadioButton
    Protected WithEvents radFileUpdate As System.Web.UI.WebControls.RadioButton
    Protected WithEvents lblFolderName As System.Web.UI.WebControls.Label
    Protected WithEvents txtFolderName As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblFileUpdate As System.Web.UI.WebControls.Label
    Protected WithEvents txtFileName As System.Web.UI.WebControls.TextBox
    Protected WithEvents btnFileCancel As System.Web.UI.WebControls.Button
    Protected WithEvents upload As System.Web.UI.HtmlControls.HtmlInputFile
    Protected WithEvents lblFileName As System.Web.UI.WebControls.Label
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.Files", "Modify") Then
            Functions.RedirectToAccessDenied("CMS.Files", "Modify")
            Exit Sub
        End If

        If Request.QueryString("idpath") = "/" Then
            'do not allow editing of the root folder
            pnlFile.Visible = False
            pnlFolder.Visible = False
            lblError.Text = ResMan.GetString("FileManagerEdit.ErrorRootPath")
            lblHeader.Text = ResMan.GetString("FileManagerEdit.Header.Edit")
            Exit Sub
        End If

        If Not Page.IsPostBack Then
            SetDiskParentPath()
            SetIsFile()
            SetParentIDPath()
            txtFolderName.Text = Split(Request.QueryString("idpath") & "", "/")(Split(Request.QueryString("idpath") & "", "/").GetUpperBound(0))
            txtFileName.Text = txtFolderName.Text
            SetLastSavedName()
        End If

        If IsFile() Then
            'file
            pnlFile.Visible = True
            pnlFolder.Visible = False
            If Not Page.IsPostBack Then
                radFileRename.Checked = True
                EnableFileRename()
            End If
        Else
            'folder
            pnlFile.Visible = False
            pnlFolder.Visible = True
        End If

        If Not Page.IsPostBack Then
            lblFileName.Text = ResMan.GetString("FileManagerEdit.FileName")
            lblFileUpdate.Text = ResMan.GetString("FileManagerEdit.FileUpdate")
            lblFolderName.Text = ResMan.GetString("FileManagerEdit.FolderName")
            radFileRename.Text = ResMan.GetString("FileManagerEdit.RenameFile")
            radFileUpdate.Text = ResMan.GetString("FileManagerEdit.UpdateFile")
            If IsFile() Then
                lblHeader.Text = ResMan.GetString("FileManagerEdit.Header.File")
            Else
                lblHeader.Text = ResMan.GetString("FileManagerEdit.Header.Folder")
            End If
            btnFileOK.Text = ResMan.GetString("FileManagerEdit.OK")
            btnFileCancel.Text = ResMan.GetString("FileManagerEdit.Cancel")
            btnFolderOK.Text = ResMan.GetString("FileManagerEdit.OK")
            btnFolderCancel.Text = ResMan.GetString("FileManagerEdit.Cancel")
        End If

        lblError.Text = ""
        lblInfo.Text = ""
    End Sub


    Private Sub btnFileOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFileOK.Click
        Dim newPath As String

        If radFileRename.Checked = True Then            
            'check if specified file name already exists
            newPath = GetDiskParentPath() & txtFileName.Text.Trim
            If File.Exists(GetDiskParentPath() & txtFileName.Text.Trim) And Not (LCase(GetDiskParentPath() & txtFileName.Text.Trim) = LCase(GetDiskPath())) Then
                lblError.Text = ResMan.GetString("FileManagerEdit.ErrorExistingFile")
            Else
                'rename file
                If GetDiskPath() <> newPath Then
                    Try
                        File.Move(GetDiskPath, newPath)
                        SetLastSavedName()
                        lblInfo.Text = ResMan.GetString("FileManagerEdit.FileRenamed")
                        Refresh()
                    Catch ex As Exception
                        lblError.Text = ResMan.GetString("FileManager.WriteError") & "<br>&nbsp;<br>" & ex.Message
                    End Try
                End If
            End If
        Else
            'upload file
            Try
                upload.PostedFile.SaveAs(GetDiskPath)
                lblInfo.Text = ResMan.GetString("FileManagerEdit.FileUpdated")
            Catch ex As Exception
                lblError.Text = ResMan.GetString("FileManager.WriteError") & "<br>&nbsp;<br>" & ex.Message
            End Try
        End If
    End Sub


    Private Sub radFileRename_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radFileRename.CheckedChanged
        EnableFileRename()
    End Sub


    Private Sub radFileUpdate_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radFileUpdate.CheckedChanged
        EnableFileUpdate()
    End Sub


    Private Sub btnFileCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFileCancel.Click
        Cancel()
    End Sub


    Private Sub Cancel()
        'redirects user back to the previous dialog
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= " Cancel('" & Replace(CType(viewstate("parentidpath"), String), "'", "&apos;") & "') "
        ltlScript.Text &= "</script>"
    End Sub


    '''<summary>Enables controls for renaming files.</summary>
    Private Sub EnableFileRename()
        lblFileName.Enabled = True
        txtFileName.Enabled = True
        lblFileUpdate.Enabled = False
        upload.Disabled = True
    End Sub


    '''<summary>Enables controls for uploading a new version of the file.</summary>
    Private Sub EnableFileUpdate()
        lblFileName.Enabled = False
        txtFileName.Enabled = False
        lblFileUpdate.Enabled = True
        upload.Disabled = False
    End Sub


    '''<summary>Sets a parent ID path.</summary>
    Private Sub SetParentIDPath()
        Dim idpath As String = Request.QueryString("idpath")

        If idpath = "/" Then
            viewstate("parentidpath") = "/"
        Else
            viewstate("parentidpath") = Left(idpath, Len(idpath) - Len(Split(idpath, "/")(Split(idpath, "/").GetUpperBound(0))))
        End If
    End Sub


    '''<summary>Returns parent path (parent folder) on the disk.</summary>
    Private Function GetDiskParentPath() As String
        Return CType(viewstate("DiskParentPath"), String)
    End Function


    '''<summary>Returns disk path of the current file or folder.</summary>
    Private Function GetDiskPath() As String
        If Right(GetDiskParentPath, 1) = "\" Then
            Return GetDiskParentPath() & CType(viewstate("LastSavedName"), String)
        Else
            Return GetDiskParentPath() & "\" & CType(viewstate("LastSavedName"), String)
        End If
    End Function


    '''<summary>Sets disk path of the parent folder.</summary>
    Private Sub SetDiskParentPath()
        Dim parentIDPath As String
        parentIDPath = Left(Request.QueryString("idpath"), Len(Request.QueryString("idpath")) - Len(Split(Request.QueryString("idpath") & "", "/")(Split(Request.QueryString("idpath"), "/").GetUpperBound(0))))
        viewstate("DiskParentPath") = Functions.GetFilesPath & Replace(parentIDPath, "/", "\")
    End Sub


    '''<summary>Sets last saved name for comparisons in future.</summary>
    Private Sub SetLastSavedName()
        If IsFile() Then
            viewstate("LastSavedName") = txtFileName.Text
        Else
            viewstate("LastSavedName") = txtFolderName.Text
        End If
    End Sub


    '''<summary>Checks if the current item is file or folder and sets an inner variable.</summary>
    Private Sub SetIsFile()
        Dim idpath As String
        Dim fileInf As FileInfo

        idpath = Request.QueryString("idpath")
        fileInf = New FileInfo(Functions.GetFilesPath & Replace(idpath, "/", "\"))
        If (fileInf.Attributes And FileAttributes.Directory) <> FileAttributes.Directory Then
            viewstate("IsFile") = 1
        Else
            viewstate("IsFile") = 0
        End If
    End Sub


    '''<summary>Return true if the current item is a file, returns false if it's a folder.</summary>
    Protected Function IsFile() As Boolean
        If CType(viewstate("IsFile"), Integer) = 1 Then
            Return True
        Else
            Return False
        End If
    End Function


    '''<summary>Refreshes the tree.</summary>
    Protected Sub Refresh()
        Dim parentPath As String

        If CType(viewstate("parentidpath"), String) = "/" Then
            parentPath = "/"
        Else
            parentPath = Left(CType(viewstate("parentidpath"), String), Len(viewstate("parentidpath")) - 1)
        End If
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= " Refresh('" & Replace(CType(viewstate("parentidpath"), String) & CType(viewstate("LastSavedName"), String), "'", "&apos;") & "', '" & parentPath.Replace("'", "&apos;") & "'); "
        ltlScript.Text &= "</script>"
    End Sub


    Private Sub btnFolderCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFolderCancel.Click
        Cancel()
    End Sub


    Private Sub btnFolderOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFolderOK.Click
        Dim oldPath As String
        Dim newPath As String

        oldPath = GetDiskParentPath() & CType(viewstate("LastSavedName"), String)
        newPath = GetDiskParentPath() & txtFolderName.Text
        If CType(viewstate("LastSavedName"), String) <> txtFolderName.Text Then
            If Directory.Exists(newPath) Then
                'folder already exists
                lblError.Text = ResMan.GetString("FileManagerEdit.ErrorExistingFolder")
            Else
                'rename folder            
                DirectoryHelper.MoveDirectory(oldPath, newPath)
                SetLastSavedName()
                lblInfo.Text = ResMan.GetString("FileManagerEdit.FolderRenamed")
                Refresh()
            End If
        End If
    End Sub
End Class
