Imports System.IO
Imports Kentico.CMS.CMSControls

Public Class FileManagerListing
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblRedirect As System.Web.UI.WebControls.Label    
    Protected WithEvents BasicDataGrid1 As BasicDataGrid

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim idPath As String
        Dim fileInf As FileInfo

        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.Files", "Read") Then
            Functions.RedirectToAccessDenied("CMS.Files", "Read")
            Exit Sub
        End If

        idPath = Request.QueryString("idpath")
        'redirect if it's a file
        fileInf = New FileInfo(Functions.GetFilesPath & Replace(idPath & "", "/", "\"))
        If (fileInf.Attributes And FileAttributes.Directory) <> FileAttributes.Directory Then
            'redirect user to the edit page
            lblRedirect.Text = ResMan.GetString("FileManagerListing.Redirect")
            Response.Redirect("FileViewFrameset.aspx?idpath=" & idPath & "&style=" & Request.QueryString("style") & "&ftbName=" & Request.QueryString("ftbName"))
            Exit Sub
        End If

        lblHeader.Text = ResMan.GetString("FileManagerListing.Header")
        BasicDataGrid1.DataSource = GetFoldersAndFiles(idPath)
        BasicDataGrid1.Columns(0).HeaderText = ResMan.GetString("FileManagerListing.FileName")
        BasicDataGrid1.Columns(1).HeaderText = ResMan.GetString("FileManagerListing.FileLastModified")
    End Sub


    '''<summary>Returns a dataset containing all files and folder in the specified folder.</summary>
    '''<param name="relativePath">Relative path to the parent folder.</param>
    Protected Function GetFoldersAndFiles(ByVal relativePath As String) As DataSet
        Dim items() As FileSystemInfo
        Dim ds As New DataSet
        Dim dr As DataRow
        Dim i As Integer

        items = GetFileSystemInfos(relativePath)
        'create an empty table
        ds.Tables.Add(New DataTable)
        ds.Tables(0).Columns.Add(New DataColumn("FileName"))
        ds.Tables(0).Columns.Add(New DataColumn("FileLastModified"))
        'add files
        For i = items.GetLowerBound(0) To items.GetUpperBound(0)
            If (items(i).Attributes() And FileAttributes.Directory) <> FileAttributes.Directory Then
                dr = ds.Tables(0).NewRow()
                dr("FileName") = items(i).Name
                dr("FileLastModified") = items(i).LastWriteTime
                ds.Tables(0).Rows.Add(dr)
            End If
        Next
        Return ds
    End Function


    '''<summary>Returns informatino about files and folders in the specified folder.</summary>
    '''<param name="relativePath">Relative path to the parent folder.</param>
    Protected Function GetFileSystemInfos(ByVal relativePath As String) As FileSystemInfo()
        Dim folderPath As String
        Dim di As DirectoryInfo

        folderPath = Functions.GetFilesPath & Replace(relativePath & "", "/", "\")
        di = New DirectoryInfo(folderPath)
        Return di.GetFileSystemInfos
    End Function
End Class
