Imports System.io
Imports Kentico.DirectoryUtilities

Public Class FileManagerNew
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents upload As System.Web.UI.HtmlControls.HtmlInputFile
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents btnCancel As System.Web.UI.WebControls.Button
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents lblFileName As System.Web.UI.WebControls.Label
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal
    Protected WithEvents lblFolderName As System.Web.UI.WebControls.Label
    Protected WithEvents txtFolderName As System.Web.UI.WebControls.TextBox
    Protected WithEvents radFile As System.Web.UI.WebControls.RadioButton
    Protected WithEvents radFolder As System.Web.UI.WebControls.RadioButton
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents pnlForm As System.Web.UI.WebControls.Panel

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Protected Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim idpath As String
        Dim fileInf As FileInfo

        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.Files", "Create") Then
            Functions.RedirectToAccessDenied("CMS.Files", "Create")
            Exit Sub
        End If

        If Not Page.IsPostBack Then
            lblHeader.Text = ResMan.GetString("FileManagerNew.Header")
            lblFileName.Text = ResMan.GetString("FileManagerNew.FileName")
            btnOK.Text = ResMan.GetString("FileManagerNew.OK")
            btnCancel.Text = ResMan.GetString("FileManagerNew.Cancel")
            radFile.Text = ResMan.GetString("FileManagerNew.CreateFile")
            radFolder.Text = ResMan.GetString("FileManagerNew.CreateFolder")
            lblFolderName.Text = ResMan.GetString("FileManagerNew.FolderName")
            enableNewFile()

            idpath = Request.QueryString("idpath")
            'redirect if parent node is a file
            fileInf = New FileInfo(Functions.GetFilesPath & Replace(idpath & "", "/", "\"))
            If (fileInf.Attributes And FileAttributes.Directory) <> FileAttributes.Directory Then
                'redirect user to the edit page
                lblError.Text = ResMan.GetString("FileManagerNew.ErrorCreateOnlyInFolder")
                pnlForm.Visible = False
                Exit Sub
            End If
        End If
        lblInfo.Text = ""
        lblError.Text = ""
        ltlScript.Text = ""
    End Sub


    Protected Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        Dim diskpath As String
        Dim idpath As String

        idpath = Request.QueryString("idpath")
        If radFile.Checked = True Then
            If upload.Name.Trim = "" Then
                lblError.Text = ResMan.GetString("FileManagerNew.ErrorNoFileSpecified")
            ElseIf Not upload.PostedFile Is Nothing Then
                If idpath = "/" Then
                    diskpath = Functions.GetFilesPath & Replace(idpath, "..", "") & System.IO.Path.GetFileName(upload.PostedFile.FileName)
                Else
                    diskpath = Functions.GetFilesPath & Replace(idpath, "..", "") & "/" & System.IO.Path.GetFileName(upload.PostedFile.FileName)
                End If
                If File.Exists(diskpath) Then
                    lblError.Text = ResMan.GetString("FileManagerNew.ErrorFileExists")
                    Exit Sub
                End If
                Try
                    upload.PostedFile.SaveAs(diskpath)
                    lblInfo.Text = ResMan.GetString("FileManagerNew.FileUploaded")
                    RefreshTree()
                Catch ex As Exception
                    lblError.Text = ResMan.GetString("FileManager.WriteError") & "<br>&nbsp;<br>" & ex.Message
                End Try
            End If
        Else
            If txtFolderName.Text.Trim = "" Then
                lblError.Text = ResMan.GetString("FileManagerNew.ErrorNoFolderName")
            Else
                If idpath = "/" Then
                    diskpath = Replace(Functions.GetFilesPath & Replace(idpath, "..", "") & txtFolderName.Text.Trim, "/", "\")
                Else
                    diskpath = Replace(Functions.GetFilesPath & Replace(idpath, "..", "") & "\" & txtFolderName.Text.Trim, "/", "\")
                End If
                If Directory.Exists(diskpath) Then
                    lblError.Text = ResMan.GetString("FileManagerNew.ErrorFolderExists")
                Else
                    Try
                        DirectoryHelper.CreateDirectory(diskpath)
                        lblInfo.Text = ResMan.GetString("FileManagerNew.FolderCreated")
                        txtFolderName.Text = ""
                        RefreshTree()
                    Catch ex As Exception
                        lblError.Text = ResMan.GetString("FileManager.WriteError") & "<br>&nbsp;<br>" & ex.Message
                    End Try
                End If
            End If            
        End If
    End Sub


    Protected Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        'redirect user back to the listing page
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= "  Cancel('" & Request.QueryString("idpath") & "');"
        ltlScript.Text &= "</script>"
    End Sub


    Protected Sub radFolder_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radFolder.CheckedChanged
        enableNewFolder()
    End Sub


    Protected Sub radFile_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radFile.CheckedChanged
        enableNewFile()
    End Sub


    Protected Sub enableNewFolder()
        'show controls for creating a new folder
        lblFileName.Enabled = False
        upload.Disabled = True
        lblFolderName.Enabled = True
        txtFolderName.Enabled = True
    End Sub


    Protected Sub enableNewFile()
        'show controls for uploading a new file
        lblFileName.Enabled = True
        upload.Disabled = False
        lblFolderName.Enabled = False
        txtFolderName.Enabled = False
    End Sub


    '''<summary>Refreshes the tree file structure.</summary>
    Protected Sub RefreshTree()
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= "  RefreshTree();"
        ltlScript.Text &= "</script>"
    End Sub
End Class
