Imports System.Web
Imports System.Web.SessionState

Public Class Global
    Inherits System.Web.HttpApplication

#Region " Component Designer Generated Code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Component Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Required by the Component Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Component Designer
    'It can be modified using the Component Designer.
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New System.ComponentModel.Container()
    End Sub

#End Region

    Sub Application_Start(ByVal sender As Object, ByVal e As EventArgs)
    End Sub

    Sub Session_Start(ByVal sender As Object, ByVal e As EventArgs)
        ' Fires when the session is started
        If User.Identity.Name & "" <> "" Then
            Functions.SetCurrentUserID(User.Identity.Name)
        End If
    End Sub

    Sub Application_BeginRequest(ByVal sender As Object, ByVal e As EventArgs)
        ' Fires at the beginning of each request        
    End Sub

    Sub Application_AuthenticateRequest(ByVal sender As Object, ByVal e As EventArgs)
        ' Fires upon attempting to authenticate the use
    End Sub

    Sub Application_Error(ByVal sender As Object, ByVal e As EventArgs)
        Try
            Functions.LogEvent("E", "CMSDESK", "EXCEPTION", 0, "", Server.GetLastError.ToString)
        Catch ex As Exception
        End Try        

        'check if it is some common HTTP error
        If Server.GetLastError.GetType() Is GetType(System.Web.HttpException) Then
            Exit Sub
        End If

        'check if custom errors are enabled
        Dim config As New System.Xml.XmlDocument
        config.Load(Server.MapPath("~/web.config"))
        'no custom errors
        If Not config.SelectSingleNode("/configuration/system.web/customErrors[@mode='Off']") Is Nothing Then
            Exit Sub
        End If

        Response.Clear()
        Response.Write("<html><header><title>Error</title></header><body style=""font-family:arial"">")
        Response.Write("<p>An error occurred when processing your request. Please contact your administrator for help.<p>")
        If (Not config.SelectSingleNode("/configuration/system.web/customErrors[@mode='RemoteOnly']") Is Nothing) AndAlso Request.Url.Host.ToLower = "localhost" Then
            Response.Write("<p><span style=""color:blue;cursor:hand"" onclick=""if (document.getElementById('error').style.display == 'none') {document.getElementById('error').style.display='block'} else {document.getElementById('error').style.display = 'none'};"">Show error details</span>")
            Response.Write("<span id=""error"" style=""display:none""><pre>" & Server.GetLastError.ToString & "</pre></span></p>")
        End If
        Response.Write("</body></html>")
        Response.End()
    End Sub

    Sub Session_End(ByVal sender As Object, ByVal e As EventArgs)
    End Sub

    Sub Application_End(ByVal sender As Object, ByVal e As EventArgs)
    End Sub

End Class
