Imports Kentico.CMS.MetadataEngine
Imports Kentico.CMS.TreeEngine
Imports Kentico.LicenseProvider

Public Class Header
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents SignOutButton1 As Kentico.CMS.CMSControls.SignOutButton
    Protected WithEvents lblCurrentUser As System.Web.UI.WebControls.Label
    Protected WithEvents lblVersion As System.Web.UI.WebControls.Label
    Protected WithEvents TabControl1 As Kentico.CMS.CMSControls.BasicTabControl
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal
    Protected WithEvents lblDBName As System.Web.UI.WebControls.Label
    Protected WithEvents lblEdition As System.Web.UI.WebControls.Label

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim tree As TreeProvider = Functions.GetTreeProvider
        Dim showTabs As String
        Dim databaseName As String
        Dim i As Integer
        Dim contentURL As String

        If tree.SelectSingleNode(Functions.GetUsersStartingAliasPath, TreePathTypeEnum.AliasPath) Is Nothing Then
            'user doesn't have the starting path set up correctly
            ShowPage("InvalidStartingPath.aspx")
            Exit Sub
        End If

        tree.Connection.DataConnection.Open()
        databaseName = tree.Connection.DataConnection.NativeConnection.Database
        tree.Connection.DataConnection.Close()
        lblCurrentUser.Text = ResMan.GetString("Header.UserName") & "&nbsp;" & User.Identity.Name
        lblVersion.Text = ResMan.GetString("Header.Version") & "&nbsp;" & tree.GetType.Assembly.GetName.Version.Major & "." & tree.GetType.Assembly.GetName.Version.Minor & "." & tree.GetType.Assembly.GetName.Version.Build
        lblDBName.Text = ResMan.GetString("Header.DBName") & "&nbsp;" & databaseName
        ltlScript.Text = ""
        lblEdition.Text = ResMan.GetString("Header.Edition") & "&nbsp;"
        If LicenseManager.GetProductCode = "CX" Then
            lblEdition.Text &= "Express"
        Else
            lblEdition.Text &= "Professional"
        End If

        'hide Sign Out button if Windows authentication is used
        If Trim(LCase(User.Identity.AuthenticationType & "")) = "forms" Then
            'forms authentication
            SignOutButton1.Visible = True
        Else
            'windows authentication             
            SignOutButton1.Visible = False
        End If

        'check permissions and show or hide tabs
        If Functions.IsAuthorizedPerResource("CMS.Content", "ExploreTree") Or Functions.IsAuthorizedPerNode(Functions.GetUsersStartingPath, TreePathTypeEnum.IDPath, NodePermissionsEnum.ExploreTree) Or (ConfigurationSettings.AppSettings("CMSAllowUnfoldingOfAnyDocument") & "").ToLower.Trim = "true" Then
            showTabs &= "C"
        End If
        If Functions.IsAuthorizedPerResource("CMS.Files", "Read") AndAlso (Not ConfigurationSettings.AppSettings("CMSUseFileManagerForImages") Is Nothing) AndAlso (ConfigurationSettings.AppSettings("CMSUseFileManagerForImages") = "true") Then
            showTabs &= "F"
        End If
        If Functions.IsAuthorizedPerResource("CMS.Tools", "Read") AndAlso ((ConfigurationSettings.AppSettings("CMSShowToolsModule") Is Nothing) OrElse (ConfigurationSettings.AppSettings("CMSShowToolsModule") <> "false")) Then
            showTabs &= "T"
        End If
        If Functions.IsAuthorizedPerResource("CMS.Administration", "Read") Then
            showTabs &= "A"
        End If
        If Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Read") Then
            showTabs &= "M"
        End If
        'decide if the Content section should be hidden
        Dim showContent As Boolean = True
        If Functions.GetConfigValue("CMSHideContentModuleFromRoles") <> "" Then
            Dim treeSec As New TreeSecurityProvider(Functions.GetTreeProvider)
            Dim roles() As String = Functions.GetConfigValue("CMSHideContentModuleFromRoles").Split(";"c)
            Dim index As Integer
            For index = 0 To roles.GetUpperBound(0)
                If treeSec.IsInRole(roles(index)) Then
                    showContent = False
                End If
            Next
        End If

        If showTabs & "" = "" Then
            'user has no permissions
            ShowPage("NoPermissions.aspx")
            Exit Sub
        End If
        Dim tabs(0, 0) As String
        Dim plusConstant As Integer
        If showContent Then
            If Not ConfigurationSettings.AppSettings("CMSUseSiteModule") Is Nothing AndAlso ConfigurationSettings.AppSettings("CMSUseSiteModule").ToLower() = "true" Then
                ReDim tabs(showTabs.Length + 1, 3)
            Else
                ReDim tabs(showTabs.Length, 3)
            End If
            plusConstant = 1
        Else
            If Not ConfigurationSettings.AppSettings("CMSUseSiteModule") Is Nothing AndAlso ConfigurationSettings.AppSettings("CMSUseSiteModule").ToLower() = "true" Then
                ReDim tabs(showTabs.Length, 3)
            Else
                ReDim tabs(showTabs.Length - 1, 3)
            End If
            plusConstant = 0
        End If
        tabs(0, 0) = ResMan.GetString("Header.MyDesk")
        tabs(0, 1) = "parent.frames['desktop'].document.location.href='MyDesk/MyDeskFrameset.aspx';"
        'Show site tab?
        If Not ConfigurationSettings.AppSettings("CMSUseSiteModule") Is Nothing AndAlso ConfigurationSettings.AppSettings("CMSUseSiteModule").ToLower() = "true" Then
            tabs(plusConstant, 0) = ResMan.GetString("Header.Browse")
            tabs(plusConstant, 1) = "parent.frames['desktop'].document.location.href='browse/default.aspx';"
            plusConstant = plusConstant + 1
        End If

        If (Request.QueryString("expandmode") & "").ToLower.StartsWith("browse") Then
            TabControl1.SelectedTab = 1
            ShowPage("browse/default.aspx?expandidpath=" & Request.QueryString("expandidpath") & "&expandmode=" & Request.QueryString("expandmode"))
        End If
        For i = 0 To showTabs.Length - 1
            Select Case showTabs.Chars(i)
                Case "C"c
                    If showContent Then
                        tabs(i + plusConstant, 0) = ResMan.GetString("Header.Content")
                        contentURL = "content/contentframeset.aspx?expandmode=" & Request.QueryString("expandmode") & "&expandidpath=" & Request.QueryString("expandidpath")
                        tabs(i + plusConstant, 1) = "parent.frames['desktop'].document.location.href='" & contentURL & "';"
                        If Request.QueryString("expandidpath") & "" <> "" AndAlso (Not (Request.QueryString("expandmode") & "").ToLower.StartsWith("browse")) Then
                            Me.TabControl1.SelectedTab = i + 2
                            ShowPage(contentURL)
                        End If
                    End If
                Case "F"c
                    tabs(i + plusConstant, 0) = ResMan.GetString("Header.Files")
                    tabs(i + plusConstant, 1) = "parent.frames['desktop'].document.location.href='filemanager/filemanagerframeset.aspx';"
                Case "T"c
                    tabs(i + plusConstant, 0) = ResMan.GetString("Header.Tools")
                    tabs(i + plusConstant, 1) = "parent.frames['desktop'].document.location.href='tools/toolsframeset.aspx';"
                Case "A"c
                    tabs(i + plusConstant, 0) = ResMan.GetString("Header.Administration")
                    tabs(i + plusConstant, 1) = "parent.frames['desktop'].document.location.href='administration/administrationframeset.aspx';"
                Case "M"c
                    tabs(i + plusConstant, 0) = ResMan.GetString("Header.MetaDesigner")
                    tabs(i + plusConstant, 1) = "parent.frames['desktop'].document.location.href='metadesigner/metadesignerframeset.aspx';"
            End Select
        Next
        TabControl1.Tabs = tabs
    End Sub


    '''<summary>Generates client script for displaying the selected page.</summary>
    '''<param name="url">URL of the page to be displayed.</param>
    Private Sub ShowPage(ByVal url As String)
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= " parent.frames['desktop'].document.location.href='" & url & "'; "
        ltlScript.Text &= "</script>"
    End Sub


    '''<summary>Cleans all session variables when user signs out.</summary>
    Private Sub DoSignOut() Handles SignOutButton1.BeforeSignOut
        Session("CMSUserID") = Nothing
        Session("CMSPreferredCulture") = Nothing
        Session("CMSUserPreferredUICulture") = Nothing
    End Sub
End Class
