Imports Kentico.CMS.CMSControls
Imports Kentico.CMS.TreeEngine
Imports System.IO
Imports Kentico.CMS.Newsletter

Public Class Logon
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents LogonForm1 As Kentico.CMS.CMSControls.LogonForm
    Protected WithEvents ltlFrameNameScript As System.Web.UI.WebControls.Literal
    Protected WithEvents lblError As System.Web.UI.WebControls.Label

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Get the parent frame name to view the logon form page in the right frame after the session time outs.
        Dim frameName As String = ConfigurationSettings.AppSettings("CMSParentFrameName")
        If Trim(frameName & "") = "" Then
            frameName = "top"
        End If
        ltlFrameNameScript.Text = ""
        ltlFrameNameScript.Text &= "<script language=""javascript"">"
        ltlFrameNameScript.Text &= " frameName = '" & Replace(frameName, "'", "\'") & "';"
        ltlFrameNameScript.Text &= "</script>"

        If Not Page.IsPostBack Then
            CheckSystemSettings()
            If Request.QueryString("expandidpath") & "" <> "" Then
                Me.LogonForm1.RedirectTo = "default.aspx?expandidpath=" & Request.QueryString("expandidpath") & "&expandmode=" & Request.QueryString("expandmode")
            End If            
            If Request.QueryString("user") <> "" Then
                Me.LogonForm1.UserNameTextBox.Text = Request.QueryString("user")
            End If
        End If

        'run scheduled jobs
        RunScheduledJobs()
    End Sub


    Public Sub LogonSuccessful() Handles LogonForm1.LogonSuccessful
        Functions.SetCurrentUserID(LogonForm1.UserNameTextBox.Text)
    End Sub


    Private Sub CheckSystemSettings()
        Dim errorMessage As String
        'check file system permissions        
        Try
            Dim path As String = Server.MapPath(".") & "\testsystemsettings_" & Session.SessionID & ".txt"
            Dim sw As StreamWriter = File.CreateText(path)
            sw.WriteLine("Test of permissions.")
            sw.Flush()
            sw.Close()
            File.Delete(path)
            path = HttpContext.Current.Server.MapPath("~/testsystemsettings_" & HttpContext.Current.Session.SessionID)
            Kentico.DirectoryUtilities.DirectoryHelper.CreateDirectory(path)
            Directory.Delete(path)
        Catch ex As Exception
            errorMessage &= Replace(ResMan.GetString("Logon.ErrorDiskAccess"), "#ACCOUNT#", System.Security.Principal.WindowsIdentity.GetCurrent().Name) & Server.MapPath("..") & "<br>"
            errorMessage &= ResMan.GetString("Logon.ErrorDiskAccessSetupPermissions") & "<br><img src=""Design\Images\"
            If InStr(System.Security.Principal.WindowsIdentity.GetCurrent().Name.ToLower, "network") > 0 Then
                errorMessage &= "NetworkServiceW2003.gif""><br>"
            Else
                errorMessage &= "setuppermissions.jpg""><br>"
            End If
        End Try
        'check database connection
        Try
            Dim tree As TreeProvider = Functions.GetTreeProvider
            Dim node As TreeNode = tree.SelectSingleNode("/", TreePathTypeEnum.IDPath)
        Catch ex As Exception
            errorMessage &= ResMan.GetString("Logon.ErrorSQLConnection") & " " & ex.Message & "<br>"
        End Try
        If errorMessage <> "" Then
            Me.lblError.Text = errorMessage
        End If
    End Sub


    Protected Sub RunScheduledJobs()
        Dim scheduleMinutes As Integer
        Dim lastTime As DateTime

        If ConfigurationSettings.AppSettings("CMSSchedulerInterval") & "" = "" Then
            Exit Sub
        Else
            scheduleMinutes = Integer.Parse(ConfigurationSettings.AppSettings("CMSSchedulerInterval"))
        End If
        If Application("CMSLastJobRun") Is Nothing Then
            Application("CMSLastJobRun") = DateTime.Now.Add(New TimeSpan(0, -1 - scheduleMinutes, 0))
        End If
        lasttime = CType(Application("CMSLastJobRun"), DateTime)
        If lastTime.Add(New TimeSpan(0, scheduleMinutes, 0)) <= DateTime.Now Then
            'run job
            'publish scheduled documents
            Dim tree As TreeProvider = Functions.GetTreeProvider
            Dim verMan As New VersionManager(tree)
            verMan.PublishAllScheduled()
            tree = Nothing
            verMan = Nothing
            'send scheduled newsletters
            Dim newsMan As New NewsletterManager(Functions.GetTreeProvider)
            newsMan.SendAllScheduledIssues(HttpContext.Current.Request.Url.GetLeftPart(UriPartial.Authority) & HttpContext.Current.Request.ApplicationPath)
            'update last job run
            Application.Lock()
            Application("CMSLastJobRun") = DateTime.Now
            Application.UnLock()
        End If
    End Sub
End Class

