Imports Kentico.CMS.DataEngine

Public Class AllowedAdd
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents txtSearch As System.Web.UI.WebControls.TextBox
    Protected WithEvents lstClasses As System.Web.UI.WebControls.ListBox
    Protected WithEvents btnSearch As System.Web.UI.WebControls.Button
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents btnCancel As System.Web.UI.WebControls.Button
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Read") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Read")
            Exit Sub
        End If

        lblHeader.Text = ResMan.GetString("AllowedAdd.Header")
        btnCancel.Text = ResMan.GetString("AllowedAdd.Cancel")
        btnOK.Text = ResMan.GetString("AllowedAdd.OK")
        btnSearch.Text = ResMan.GetString("AllowedAdd.Search")
    End Sub


    Private Sub btnSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSearch.Click
        Dim cn As New GeneralConnection
        Dim ds As DataSet
        Dim params(0, 2) As Object

        'find all classes whose name contains specified string
        cn.ConnectionString = Functions.GetConnectionString
        params(0, 0) = "@ClassDisplayName"
        params(0, 1) = txtSearch.Text
        ds = cn.ExecuteQuery("CMS.Class.SelectLike", params)
        lstClasses.DataSource = ds.Tables(0)
        lstClasses.DataTextField = "ClassDisplayName"
        lstClasses.DataValueField = "ClassID"
        lstClasses.DataBind()
    End Sub


    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Modify") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Modify")
            Exit Sub
        End If

        Dim cn As New GeneralConnection
        Dim item As ListItem
        Dim params(1, 2) As Object

        'add selected classes among allowed child classes
        params(0, 0) = "@ParentClassID"
        params(0, 1) = Integer.Parse(Request.QueryString("ClassID"))
        params(1, 0) = "@ChildClassID"
        cn.ConnectionString = Functions.GetConnectionString
        cn.DataConnection.Open()
        For Each item In lstClasses.Items
            If item.Selected Then
                params(1, 1) = item.Value
                cn.ExecuteQuery("CMS.AllowedChildClasses.Insert", params)
            End If
        Next
        cn.DataConnection.Close()
        CloseWindow()
    End Sub


    Private Sub CloseWindow()
        'redirects user back to the list of allowed classes
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= "  document.location.href = 'AllowedList.aspx?classid=" & Request.QueryString("classid") & "';"
        ltlScript.Text &= "</script>"
    End Sub


    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        CloseWindow()
    End Sub
End Class
