Imports Kentico.CMS.DataEngine
Imports Kentico.CMS.MetadataEngine
Imports System.IO
Imports Kentico.DirectoryUtilities

Public Class ApplicationEdit
    Inherits System.Web.UI.Page

    Protected ApplicationID As Integer

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents TextBox1 As System.Web.UI.WebControls.TextBox
    Protected WithEvents TextBox2 As System.Web.UI.WebControls.TextBox
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents btnCancel As System.Web.UI.WebControls.Button
    Protected WithEvents txtApplicationDisplayName As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtApplicationName As System.Web.UI.WebControls.TextBox
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal
    Protected WithEvents lblApplicationID As System.Web.UI.WebControls.Label
    Protected WithEvents lblApplicationIDValue As System.Web.UI.WebControls.Label
    Protected WithEvents lblApplicationDisplayName As System.Web.UI.WebControls.Label
    Protected WithEvents lblApplicationName As System.Web.UI.WebControls.Label

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Read") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Read")
            Exit Sub
        End If

        Dim cn As GeneralConnection
        Dim applicationObj As DataClass

        If Request.QueryString("id") <> "" Then
            ApplicationID = Integer.Parse(Request.QueryString("id"))
        Else
            ApplicationID = 0
        End If
        lblError.Text = ""
        lblError.Visible = False
        lblInfo.Text = ""
        lblInfo.Visible = False
        lblHeader.Text = ResMan.GetString("ApplicationEdit.Header")
        lblApplicationID.Text = ResMan.GetString("ApplicationEdit.ApplicationID")
        lblApplicationName.Text = ResMan.GetString("ApplicationEdit.ApplicationName")
        lblApplicationDisplayName.Text = ResMan.GetString("ApplicationEdit.ApplicationDisplayName")
        btnOK.Text = ResMan.GetString("ApplicationEdit.OK")
        btnCancel.Text = ResMan.GetString("ApplicationEdit.Cancel")

        If Not Page.IsPostBack And ApplicationID <> 0 Then
            'set values
            cn = New GeneralConnection(Functions.GetConnectionString)
            applicationObj = New DataClass("CMS.Application", ApplicationID, cn)
            txtApplicationName.Text = CType(applicationObj.GetValue("ApplicationName"), String)
            txtApplicationDisplayName.Text = CType(applicationObj.GetValue("ApplicationDisplayName"), String)
            lblApplicationIDValue.Text = CType(applicationObj.GetValue("ApplicationID"), String)
        Else
            lblApplicationIDValue.Text = ResMan.GetString("EditApplication.NoApplicationIDValue")
        End If
    End Sub


    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        'check permissions
        If ApplicationID = 0 Then
            If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Create") Then
                Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Create")
                Exit Sub
            End If
        Else
            If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Modify") Then
                Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Modify")
                Exit Sub
            End If
        End If

        'validate input
        Dim errorMessage As String = ""
        Dim cn As GeneralConnection
        Dim params(0, 2) As String
        Dim ApplicationDR As DataRow
        Dim ApplicationNamesDS As DataSet
        Dim infoMessage As String
        Dim ApplicationObj As DataClass
        Dim applicationNameChanged As Boolean = False
        Dim originalApplicationName As String

        txtApplicationName.Text = txtApplicationName.Text.Trim
        If txtApplicationName.Text.Trim = "" Then
            errorMessage &= ResMan.GetString("ApplicationEdit.ErrorEmptyApplicationName") & " "
        End If
        If InStr(txtApplicationName.Text, " ") > 0 Then
            errorMessage &= ResMan.GetString("ApplicationEdit.ErrorApplicationNameWithSpaces") & " "
        End If
        If txtApplicationDisplayName.Text.Trim = "" Then
            errorMessage &= ResMan.GetString("ApplicationEdit.ErrorEmptyApplicationDisplayName") & " "
        End If
        If InStr(txtApplicationName.Text, ".") > 0 Then
            errorMessage &= ResMan.GetString("ApplicationEdit.ErrorDot")
        End If

        If errorMessage = "" Then
            'check for existing application
            params(0, 0) = "@ApplicationName"
            params(0, 1) = txtApplicationName.Text.Trim
            cn = New GeneralConnection(Functions.GetConnectionString)
            cn.DataConnection.Open()

            ApplicationNamesDS = cn.ExecuteQuery("CMS.Application.SelectByApplicationName", params)
            If ApplicationID = 0 Then
                If ApplicationNamesDS.Tables(0).Rows.Count > 0 Then
                    'application name already exists
                    errorMessage &= ResMan.GetString("ApplicationEdit.ErrorExistingApplicationName") & " "
                End If
            Else
                For Each ApplicationDR In ApplicationNamesDS.Tables(0).Rows
                    If CType(ApplicationDR("ApplicationID"), Integer) <> ApplicationID Then
                        'application name already exists
                        errorMessage &= ResMan.GetString("ApplicationEdit.ErrorExistingApplicationName") & " "
                    End If
                Next
            End If

            If errorMessage = "" Then
                'save application info
                If ApplicationID = 0 Then
                    'insert a new application
                    ApplicationObj = New DataClass("CMS.Application", cn)
                    ApplicationObj.SetValue("ApplicationName", txtApplicationName.Text)
                    ApplicationObj.SetValue("ApplicationDisplayName", txtApplicationDisplayName.Text)
                    ApplicationObj.Insert()
                    txtApplicationName.Text = ""
                    txtApplicationDisplayName.Text = ""
                    infoMessage = ResMan.GetString("ApplicationEdit.ChangesInserted")
                Else
                    'update an existing application
                    ApplicationObj = New DataClass("CMS.Application", ApplicationID, cn)
                    originalApplicationName = (CType(ApplicationObj.GetValue("ApplicationName"), String) & "")
                    If originalApplicationName.Trim.ToLower <> txtApplicationName.Text.Trim.ToLower Then
                        applicationNameChanged = True
                    End If
                    ApplicationObj.SetValue("ApplicationName", txtApplicationName.Text)
                    ApplicationObj.SetValue("ApplicationDisplayName", txtApplicationDisplayName.Text)
                    ApplicationObj.Update()
                    MetadataProvider.ClearMetadata()
                    infoMessage = ResMan.GetString("ApplicationEdit.ChangesSaved")
                    'if application name was changed, change application folder name in the file system
                    If applicationNameChanged Then
                        If Directory.Exists(Functions.GetMetadataPath & "\" & originalApplicationName) Then
                            DirectoryHelper.MoveDirectory(Functions.GetMetadataPath & "\" & originalApplicationName, Functions.GetMetadataPath & "\" & Me.txtApplicationName.Text.Trim)
                        End If
                        'update underlying classes
                        Dim dsClasses As DataSet
                        Dim drClass As DataRow
                        Dim classObj As DataClass
                        Dim newClassName As String
                        Dim originalClassName As String

                        dsClasses = cn.ExecuteQuery("cms.class.selectclassesofapplication", Nothing, " applicationid = '" & ApplicationID.ToString & "'")
                        For Each drClass In dsClasses.Tables(0).Rows
                            classObj = New DataClass("cms.class", drClass, cn)
                            originalClassName = CType(classObj.GetValue("ClassName"), String)
                            newClassName = Me.txtApplicationName.Text.Trim & "." & originalClassName.Split("."c)(1)
                            classObj.SetValue("ClassName", newClassName)
                            classObj.Update()
                            'rename icon files
                            If File.Exists(Server.MapPath("../design/icons/") & originalClassName & ".gif") Then
                                File.Move(Server.MapPath("../design/icons/") & originalClassName & ".gif", Server.MapPath("../design/icons/") & newClassName & ".gif")
                            End If
                            If File.Exists(Server.MapPath("../design/icons/") & originalClassName & "_open.gif") Then
                                File.Move(Server.MapPath("../design/icons/") & originalClassName & "_open.gif", Server.MapPath("../design/icons/") & newClassName & "_open.gif")
                            End If
                        Next
                    End If
                End If
                ltlScript.Text = "<script language=""javascript"">"
                ltlScript.Text &= " RefreshTree(); "
                ltlScript.Text &= "</script>"
            End If
            cn.DataConnection.Close()
        End If

        If errorMessage <> "" Then
            lblError.Text = errorMessage
            lblError.Visible = True
        End If
        If infoMessage <> "" Then
            lblInfo.Text = infoMessage
            lblInfo.Visible = True
        End If
    End Sub


    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        'redirect user back to the previous dialog
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= " Cancel(); "
        ltlScript.Text &= "</script>"
    End Sub

End Class
