Imports System.IO

Public Class CSSStylesEdit
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents txtStyles As System.Web.UI.WebControls.TextBox
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Read") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Read")
            Exit Sub
        End If

        If Not Page.IsPostBack Then
            lblError.Text = ""
            lblError.Visible = False
            lblInfo.Text = ""
            lblInfo.Visible = False
            lblHeader.Text = ResMan.GetString("CSSStylesEdit.Header")
            btnOK.Text = ResMan.GetString("CSSStylesEdit.OK")
            Dim txt As TextReader
            Try
                txt = New StreamReader(getCSSFilePath())
                txtStyles.Text = txt.ReadToEnd()
            Catch
            Finally
                If Not txt Is Nothing Then
                    txt.Close()
                End If
            End Try
        End If
    End Sub

    '''<summary>Returns path to CSS file name</summary>
    Private Function getCSSFilePath() As String
        Dim cssfile As String
        If ConfigurationSettings.AppSettings("CMSCSSVirtualPath") Is Nothing Then
            cssfile = MapPath("~/main.css")
        Else
            cssfile = MapPath(ConfigurationSettings.AppSettings("CMSCSSVirtualPath"))
        End If
        Return cssfile
    End Function


    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Modify") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Modify")
            Exit Sub
        End If
        ' write content to file
        Dim txt As TextWriter
        Try
            txt = New StreamWriter(getCSSFilePath())
            txt.Write(txtStyles.Text)
        Finally
            If Not txt Is Nothing Then txt.Close()
        End Try
        lblInfo.Text = ResMan.GetString("CSSStylesEdit.ChangesSaved")
        lblInfo.Visible = True
    End Sub
End Class
