Imports Kentico.CMS.DataEngine
Imports Kentico.CMS.MetadataEngine
Imports Kentico.CMS.TreeEngine
Imports System.IO
Imports Kentico.DirectoryUtilities

Public Class ClassEdit
    Inherits System.Web.UI.Page

    Protected ApplicationID As Integer
    Protected WithEvents lblIsCoupledClass As System.Web.UI.WebControls.Label
    Protected WithEvents chkIsCoupledClass As System.Web.UI.WebControls.CheckBox
    Protected WithEvents lblApplicationName As System.Web.UI.WebControls.Label
    Protected WithEvents lblUseVersioningAndWorkflow As System.Web.UI.WebControls.Label
    Protected WithEvents drpWorkflow As System.Web.UI.WebControls.DropDownList
    Protected WithEvents chkUseVersioning As System.Web.UI.WebControls.CheckBox
    Protected WithEvents lblWorkflow As System.Web.UI.WebControls.Label
    Protected ClassID As Integer

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents lblClassID As System.Web.UI.WebControls.Label
    Protected WithEvents lblClassIDValue As System.Web.UI.WebControls.Label
    Protected WithEvents lblClassDisplayName As System.Web.UI.WebControls.Label
    Protected WithEvents txtClassDisplayName As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblClassName As System.Web.UI.WebControls.Label
    Protected WithEvents txtClassName As System.Web.UI.WebControls.TextBox
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents btnCancel As System.Web.UI.WebControls.Button
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Read") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Read")
            Exit Sub
        End If

        Dim cn As GeneralConnection
        Dim classObj As DataClass

        If Request.QueryString("id") <> "" Then
            ClassID = Integer.Parse(Request.QueryString("id"))
        Else
            ClassID = 0
        End If
        If Request.QueryString("applicationid") <> "" Then
            ApplicationID = Integer.Parse(Request.QueryString("applicationid"))
        Else
            ApplicationID = 0
        End If
        lblError.Text = ""
        lblError.Visible = False
        lblInfo.Text = ""
        lblInfo.Visible = False
        lblHeader.Text = ResMan.GetString("ClassEdit.Header")
        lblClassID.Text = ResMan.GetString("ClassEdit.ClassID")
        lblClassName.Text = ResMan.GetString("ClassEdit.ClassName")
        lblClassDisplayName.Text = ResMan.GetString("ClassEdit.ClassDisplayName")
        lblIsCoupledClass.Text = ResMan.GetString("ClassEdit.IsCoupledClass")
        btnOK.Text = ResMan.GetString("ClassEdit.OK")
        btnCancel.Text = ResMan.GetString("ClassEdit.Cancel")
        Me.lblUseVersioningAndWorkflow.Text = ResMan.GetString("ClassEdit.UseVersioningAndWorkflow")
        Me.lblWorkflow.Text = ResMan.GetString("ClassEdit.Workflow")

        If Not Page.IsPostBack And ClassID <> 0 Then
            'set values
            cn = New GeneralConnection(Functions.GetConnectionString)
            classObj = New DataClass("CMS.Class", ClassID, cn)
            lblApplicationName.Text = CType(classObj.GetValue("ClassName"), String).Split("."c)(0)
            txtClassName.Text = CType(classObj.GetValue("ClassName"), String).Split("."c)(1)
            txtClassDisplayName.Text = CType(classObj.GetValue("ClassDisplayName"), String)
            lblClassIDValue.Text = CType(classObj.GetValue("ClassID"), String)
            chkIsCoupledClass.Checked = CType(classObj.GetValue("IsCoupledClass"), Boolean)
            chkUseVersioning.Checked = CType(classObj.GetValue("UseVersioning"), Boolean)
            If chkUseVersioning.Checked Then
                Me.drpWorkflow.Enabled = True
                LoadWorkflows(CType(classObj.GetValue("WorkflowID"), Integer))
            Else
                Me.drpWorkflow.Enabled = False
                LoadWorkflows(0)
            End If
        End If

        If Not Page.IsPostBack And ClassID = 0 Then
            LoadWorkflows(0)
            Me.chkUseVersioning.Checked = True
            Me.drpWorkflow.Enabled = True
            lblClassIDValue.Text = ResMan.GetString("EditClass.NoClassIDValue")
        End If
    End Sub

    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        'check permissions
        If ClassID = 0 Then
            If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Create") Then
                Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Create")
                Exit Sub
            End If
        Else
            If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Modify") Then
                Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Modify")
                Exit Sub
            End If
        End If

        'validate input
        Dim errorMessage As String = ""
        Dim cn As GeneralConnection
        Dim params(0, 2) As String
        Dim ClassDR As DataRow
        Dim ClassNamesDS As DataSet
        Dim infoMessage As String
        Dim ClassObj As DataClass
        Dim originalClassName As String
        Dim newClassName As String

        txtClassName.Text = txtClassName.Text.Trim
        txtClassDisplayName.Text = txtClassDisplayName.Text.Trim
        If txtClassName.Text = "" Then
            errorMessage &= ResMan.GetString("ClassEdit.ErrorEmptyClassName") & " "
        End If
        If txtClassDisplayName.Text = "" Then
            errorMessage &= ResMan.GetString("ClassEdit.ErrorEmptyClassDisplayName") & " "
        End If
        If InStr(txtClassName.Text, " ") > 0 Then
            errorMessage &= ResMan.GetString("ClassEdit.ErrorClassNameWithSpaces") & " "
        End If

        If errorMessage = "" Then
            'check for existing class
            params(0, 0) = "@ClassName"
            params(0, 1) = lblApplicationName.Text & "." & txtClassName.Text.Trim
            cn = New GeneralConnection(Functions.GetConnectionString)
            cn.DataConnection.Open()

            ClassNamesDS = cn.ExecuteQuery("CMS.Class.SelectByClassName", params)
            If ClassID = 0 Then
                If ClassNamesDS.Tables(0).Rows.Count > 0 Then
                    'class name already exists
                    errorMessage &= ResMan.GetString("ClassEdit.ErrorExistingClassName") & " "
                End If
            Else
                For Each ClassDR In ClassNamesDS.Tables(0).Rows
                    If CType(ClassDR("ClassID"), Integer) <> ClassID Then
                        'class name already exists
                        errorMessage &= ResMan.GetString("ClassEdit.ErrorExistingClassName") & " "
                    End If
                Next
            End If

            If errorMessage = "" Then
                'save class info
                If ClassID = 0 Then
                    'insert a new class
                    ClassObj = New DataClass("CMS.Class", cn)
                    ClassObj.SetValue("ClassName", Me.lblApplicationName.Text & "." & txtClassName.Text)
                    ClassObj.SetValue("ClassDisplayName", txtClassDisplayName.Text)
                    If chkIsCoupledClass.Checked Then
                        ClassObj.SetValue("IsCoupledClass", 1)
                    Else
                        ClassObj.SetValue("IsCoupledClass", 0)
                    End If
                    ClassObj.SetValue("ApplicationID", ApplicationID)
                    If Me.chkUseVersioning.Checked Then
                        ClassObj.SetValue("UseVersioning", True)
                        ClassObj.SetValue("WorkflowID", Me.drpWorkflow.SelectedValue)
                    Else
                        ClassObj.SetValue("UseVersioning", False)
                        ClassObj.SetValue("WorkflowID", Nothing)
                    End If
                    ClassObj.Insert()
                    txtClassName.Text = ""
                    txtClassDisplayName.Text = ""
                    chkIsCoupledClass.Checked = False
                    infoMessage = ResMan.GetString("ClassEdit.ChangesInserted")
                    ltlScript.Text = "<script language=""javascript"">"
                    ltlScript.Text &= " RefreshTreeAfterInsert(); "
                    ltlScript.Text &= "</script>"
                Else
                    'update an existing class
                    ClassObj = New DataClass("CMS.Class", ClassID, cn)
                    originalClassName = CType(ClassObj.GetValue("ClassName"), String)
                    ClassObj.SetValue("ClassName", Me.lblApplicationName.Text & "." & txtClassName.Text)
                    newClassName = CType(ClassObj.GetValue("ClassName"), String)
                    ClassObj.SetValue("ClassDisplayName", txtClassDisplayName.Text)
                    If chkIsCoupledClass.Checked Then
                        ClassObj.SetValue("IsCoupledClass", 1)
                    Else
                        ClassObj.SetValue("IsCoupledClass", 0)
                    End If
                    If Me.chkUseVersioning.Checked Then
                        ClassObj.SetValue("UseVersioning", True)
                        ClassObj.SetValue("WorkflowID", Me.drpWorkflow.SelectedValue)
                    Else
                        ClassObj.SetValue("UseVersioning", False)
                        ClassObj.SetValue("WorkflowID", Nothing)
                    End If
                    ClassObj.Update()
                    MetadataProvider.ClearMetadata()
                    infoMessage = ResMan.GetString("ClassEdit.ChangesSaved")
                    ltlScript.Text = "<script language=""javascript"">"
                    ltlScript.Text &= " RefreshTree(); "
                    ltlScript.Text &= "</script>"
                    If originalClassName.Trim.ToLower <> newClassName.Trim.ToLower Then
                        'rename folder
                        If Directory.Exists(Functions.GetMetadataPath & "\" & originalClassName.Split("."c)(0) & "\" & originalClassName.Split("."c)(1)) Then
                            DirectoryHelper.MoveDirectory(Functions.GetMetadataPath & "\" & originalClassName.Split("."c)(0) & "\" & originalClassName.Split("."c)(1), Functions.GetMetadataPath & "\" & newClassName.Split("."c)(0) & "\" & newClassName.Split("."c)(1))
                        End If
                        'rename icon files
                        If File.Exists(Server.MapPath("../design/icons/") & originalClassName & ".gif") Then
                            File.Move(Server.MapPath("../design/icons/") & originalClassName & ".gif", Server.MapPath("../design/icons/") & newClassName & ".gif")
                        End If
                        If File.Exists(Server.MapPath("../design/icons/") & originalClassName & "_open.gif") Then
                            File.Move(Server.MapPath("../design/icons/") & originalClassName & "_open.gif", Server.MapPath("../design/icons/") & newClassName & "_open.gif")
                        End If
                        'update queries
                        Dim query As MetadataQuery
                        query = QueryGenerator.GetQuery(newClassName, BasicQueriesEnum.SelectByPathQuery)
                        MetadataProvider.SetQuery(newClassName & ".selectbypath", query)
                        query = QueryGenerator.GetQuery(newClassName, BasicQueriesEnum.SearchTreeQuery)
                        MetadataProvider.SetQuery(newClassName & ".searchtree", query)
                    End If
                End If
                ClassInformationProvider.ClearMetadata()
            End If
            cn.DataConnection.Close()
        End If

        If errorMessage <> "" Then
            lblError.Text = errorMessage
            lblError.Visible = True
        End If
        If infoMessage <> "" Then
            lblInfo.Text = infoMessage
            lblInfo.Visible = True
        End If
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        'redirect user back to the list of classes
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= " function Cancel()"
        ltlScript.Text &= " {"
        ltlScript.Text &= "   document.location.href='ClassList.aspx?applicationid=" & Request.QueryString("applicationid") & "';"
        ltlScript.Text &= " }"
        ltlScript.Text &= " Cancel(); "
        ltlScript.Text &= "</script>"
    End Sub


    Private Sub LoadWorkflows(ByVal selectedWorkflowId As Integer)
        Dim workflowsDS As DataSet
        Dim workflowDR As DataRow
        Dim cn As GeneralConnection = Functions.GetTreeProvider.Connection

        workflowsDS = cn.ExecuteQuery("cms.workflow.selectall", Nothing, "", "WorkflowDisplayName")
        drpWorkflow.Items.Clear()
        For Each workflowDR In workflowsDS.Tables(0).Rows
            drpWorkflow.Items.Add(New ListItem(CType(workflowDR("WorkflowDisplayName"), String), CType(workflowDR("WorkflowID"), Integer).ToString))
            If (selectedWorkflowId = CType(workflowDR("WorkflowID"), Integer)) Or (selectedWorkflowId = 0 And CType(workflowDR("WorkflowName"), String).ToLower.Trim = "default") Then
                drpWorkflow.SelectedIndex = drpWorkflow.Items.Count - 1
            End If
        Next
    End Sub


    Private Sub chkUseVersioning_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkUseVersioning.CheckedChanged
        If Me.chkUseVersioning.Checked = True Then
            Me.drpWorkflow.Enabled = True
        Else
            Me.drpWorkflow.Enabled = False
        End If
    End Sub
End Class
