Imports Kentico.CMS.DataEngine
Imports Kentico.CMS.MetadataEngine
Imports Kentico.CMS.TreeEngine
Imports System.IO

Public Class ClassList
    Inherits System.Web.UI.Page

    Protected editHint As String
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected deleteHint As String

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Protected WithEvents QueryDataGrid1 As Kentico.CMS.CMSControls.QueryDataGrid
    Protected WithEvents ltlConfirmScript As System.Web.UI.WebControls.Literal
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load        
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Read") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Read")
            Exit Sub
        End If

        editHint = ResMan.GetString("ClassList.EditHint")
        deleteHint = ResMan.GetString("ClassList.DeleteHint")
        Me.lblError.Text = ""
        'set column header names
        QueryDataGrid1.Columns(0).HeaderText = ResMan.GetString("ClassList.Action")
        QueryDataGrid1.Columns(1).HeaderText = ResMan.GetString("ClassList.ClassDisplayName")
        QueryDataGrid1.Columns(2).HeaderText = ResMan.GetString("ClassList.ClassName")

        'confirmation question
        ltlConfirmScript.Text = "<input type=""hidden"" id=""confirmationText"" value=""" & ResMan.GetString("ClassList.ConfirmDelete") & """>"
        lblHeader.Text = ResMan.GetString("ClassList.Header")

        If Not Page.IsPostBack Then
            DisplayClasses()
        End If
    End Sub


    Public Sub DeleteItem(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs)
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Delete") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Delete")
            Exit Sub
        End If

        'delete class
        Dim id As Integer = Integer.Parse(CType(e.CommandArgument, String))        
        Dim cn As GeneralConnection = Functions.GetTreeProvider.Connection
        Dim params(0, 2) As String
        Dim className As String = CType(ClassInformationProvider.GetClassRow(id, Functions.GetTreeProvider)("ClassName"), String)
        If className.ToLower.Trim = "cms.root" Then
            Me.lblError.Text = ResMan.GetString("ClassList.ErrorCannotDeleteRootClass")
            Exit Sub
        End If
        Dim tableName As String = MetadataProvider.GetSettingsValue(className, "tablename")

        params(0, 0) = "@ID"
        params(0, 1) = id.ToString
        cn.ConnectionString = Functions.GetConnectionString
        cn.ExecuteQuery("CMS.Class.Delete", params)

        'delete table if the class is coupled
        If tableName <> "" Then
            cn.DataConnection.ExecuteQuery("DROP TABLE [" & tableName & "]", Nothing, MetadataQueryTypeEnum.SQLQuery)
        End If

        'delete folder
        Try
            Directory.Delete(Functions.GetMetadataPath & "\" & className.Split("."c)(0) & "\" & className.Split("."c)(1), True)
        Catch ex As Exception
        End Try

        'delete image
        Try
            File.Delete(Server.MapPath("..\design\icons\" & className & ".gif"))
            File.Delete(Server.MapPath("..\design\icons\" & className & "_open.gif"))
        Catch ex As Exception
        End Try

        'clear metadata
        MetadataProvider.ClearMetadata()
        ClassInformationProvider.ClearMetadata()

        'udpate tree
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= " Reload(); "
        ltlScript.Text &= "</script>"
    End Sub


    '''<summary>Displays list of classes in the grid.</summary>
    Private Sub DisplayClasses()
        Dim cn As New GeneralConnection
        cn.ConnectionString = Functions.GetConnectionString
        QueryDataGrid1.GeneralConnection = cn
        QueryDataGrid1.QueryName = "CMS.Class.SelectClassesOfApplication"
        QueryDataGrid1.WhereCondition = " applicationid = '" & Replace(Request.QueryString("applicationid"), "'", "''") & "'"
    End Sub


    Private Sub dtg_ItemDataBound(ByVal sender As System.Object, ByVal e As DataGridItemEventArgs) Handles QueryDataGrid1.ItemDataBound
        Dim btnCurrentButton As ImageButton

        'set up the delete button
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            btnCurrentButton = CType(e.Item.Cells(0).FindControl("btnDelete"), ImageButton)
            btnCurrentButton.Attributes.Add("OnClick", "return ConfirmDelete();")
            btnCurrentButton.Attributes.Add("title", deleteHint)
        End If
    End Sub


End Class
