Imports Kentico.CMS.CMSControls
Imports Kentico.CMS.TreeEngine
Imports Kentico.CMS.DataEngine
Imports System.IO
Imports System.Xml

Public Class DesignerTreeData
    Inherits System.Web.UI.Page

    Private tree As TreeProvider
    Private Const cImageBasePath As String = "../Design/Tree"
    Private Const cIconsBasePath As String = "../Design/Icons/"

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents ltlRender As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Put user code to initialize the page here
        Dim action As String

        action = LCase(Trim(Request.QueryString("action") & ""))
        tree = Functions.GetTreeProvider
        ltlRender.Text = "<script language=""javascript"">" & vbCrLf
        Select Case action
            Case "expandnode"
                If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Read") Then
                    ShowErrorMessage(ResMan.GetString("AccessDenied.NotAllowedToRead"))
                Else
                    AddRenderScript(GetChildNodes(Request.QueryString("nodeid"), Request.QueryString("sample"), Request.QueryString("value")), Request.QueryString("nodeid"))
                    If Request.QueryString("selectID") & "" <> "" Then
                        AddSelectNodeScript(Request.QueryString("selectID"), False, True)
                    End If
                End If
        End Select
        ltlRender.Text &= "</script>"
    End Sub


    '''<summary>Adds script that removes the given node from the displayed tree.</summary>
    '''<param name="nodeIDPath">IDPath of the node to be removed.</param>
    Public Sub AddRemoveNodeScript(ByVal nodeIDPath As String)
        ltlRender.Text &= " parent.frames['tree'].document.getElementById('nodeID_" & nodeIDPath & "').innerHTML = '';"
    End Sub


    '''<summary>Adds script that reloads the selected node.</summary>
    Public Sub AddReloadSelectedNodeScript()
        ltlRender.Text &= " parent.frames['tree'].ReloadSelectedNode();" & vbCrLf
    End Sub


    '''<summary>Adds script that selects given node.</summary>
    '''<param name="selectIDPath">IDPath of the node to be selected.</param>
    '''<param name="selectDesktop">Indicates if desktop should be updated.</param>
    '''<param name="selectMenu">Indicates if menu (header) selected item value should be updated.</param>
    Public Sub AddSelectNodeScript(ByVal selectIDPath As String, ByVal selectDesktop As Boolean, ByVal selectMenu As Boolean)
        ltlRender.Text &= " SelectNode('" & selectIDPath & "'); " & vbCrLf & _
                         " function SelectNode(selectID) {" & vbCrLf & _
                         "  //try {" & vbCrLf & _
                         "  parent.frames['tree'].SelectNode(selectID);" & vbCrLf
        If selectDesktop Then
            ltlRender.Text &= "  parent.frames['header'].SelectNode(selectID);" & vbCrLf
        End If
        If selectMenu Then
            ltlRender.Text &= "  parent.frames['header'].document.getElementById('idpath').value = selectID;" & vbCrLf
        End If
        ltlRender.Text &= "  //} catch(e) { } " & vbCrLf & _
                          " } " & vbCrLf
    End Sub


    '''<summary>Adds content that will be rendered under given parent node.</summary>
    '''<param name="content">Content to be rendered.</param>
    '''<param name="targetNodeIDPath">Target node IDPath.</param>
    Public Sub AddRenderScript(ByVal content As String, ByVal targetNodeIDPath As String)
        Dim innerHTML As String
        innerHTML = Replace(content & "", "'", "\'")
        innerHTML = Replace(innerHTML, """", "\""")
        innerHTML = Replace(innerHTML, vbCrLf, " ")

        ltlRender.Text &= " RenderData(); " & vbCrLf & _
                     " function RenderData() {" & vbCrLf & _
                     "  // try {" & vbCrLf & _
                     "  parent.frames['tree'].document.getElementById('sub_" & targetNodeIDPath & "').innerHTML = '" & innerHTML & "'; " & vbCrLf
        If innerHTML & "" = "" Then
            ltlRender.Text &= " parent.frames['tree'].document.getElementById('sub_" & targetNodeIDPath & "').style.display = 'none'; " & vbCrLf
        End If
        ltlRender.Text &= "  // } catch(e) { } " & vbCrLf & _
                     " } " & vbCrLf
    End Sub


    '''<summary>Returns child nodes at 2nd and lower level.</summary>
    '''<param name="NodeID">Parent node ID (IDPath).</param>
    '''<param name="Sample">Sample for displaying tree.</param>
    '''<param name="Value">Value of the parent node.</param>
    Function GetChildNodes(ByVal NodeID As String, ByVal Sample As String, ByVal Value As String) As String
        Dim nodes As New TreeNodes
        Dim dr As DataRow
        Dim nodeRows As DataRowCollection
        Dim cn As New GeneralConnection
        Dim classid As Integer
        Dim classIDPart As String
        Dim className As String
        Dim transformationsDirectory As DirectoryInfo
        Dim transformations() As FileInfo
        Dim i As Integer
        Dim transformationName As String
        Dim transformationsDirPath As String

        cn.ConnectionString = Functions.GetConnectionString
        nodes.ImagePathBase = cImageBasePath
        'root
        If NodeID = "/" Then
            nodes.NewNode(ResMan.GetString("DesignerTreeData.Applications"), "/", cIconsBasePath & "applications.gif", cIconsBasePath & "applications.gif", ResMan.GetString("DesignerTreeData.Applications"), "parent.frames['header'].SelectNode('/apps')", "/apps", "", True)
            nodes.NewNode(ResMan.GetString("DesignerTreeData.PageTemplates"), "/", cIconsBasePath & "pagetemplates.gif", cIconsBasePath & "pagetemplates.gif", ResMan.GetString("DesignerTreeData.PageTemplates"), "parent.frames['header'].SelectNode('/pagetemplates')", "/pagetemplates", "", False)
            nodes.NewNode(ResMan.GetString("DesignerTreeData.Workflow"), "/", cIconsBasePath & "workflows.gif", cIconsBasePath & "workflows.gif", ResMan.GetString("DesignerTreeData.Workflow"), "parent.frames['header'].SelectNode('/workflow')", "/workflow", "", False)
            If Functions.GetConfigValue("CMSEnableRelationships").ToLower.Trim <> "false" Then
                nodes.NewNode(ResMan.GetString("DesignerTreeData.Relationshipnames"), "/", cIconsBasePath & "relationships.gif", cIconsBasePath & "relationships.gif", ResMan.GetString("DesignerTreeData.Relationshipnames"), "parent.frames['header'].SelectNode('/relationshipnames')", "/relationshipnames", "", False)
            End If
            nodes.NewNode(ResMan.GetString("DesignerTreeData.Resources"), "/", cIconsBasePath & "resources.gif", cIconsBasePath & "resources.gif", ResMan.GetString("DesignerTreeData.Resources"), "parent.frames['header'].SelectNode('/resources')", "/resources", "", True)
            nodes.NewNode(ResMan.GetString("DesignerTreeData.CSSStyles"), "/", cIconsBasePath & "cssstyles.gif", cIconsBasePath & "cssstyles.gif", ResMan.GetString("DesignerTreeData.CSSStyles"), "parent.frames['header'].SelectNode('/cssstyles')", "/cssstyles", "", False)
        End If
        'apps
        If NodeID = "/apps" Then
            For Each dr In cn.ExecuteQuery("CMS.Application.SelectList", Nothing, "", "ApplicationDisplayName").Tables(0).Rows
                nodes.NewNode(ResMan.GetString("DesignerTreeData.Application") & " " & CType(dr("ApplicationDisplayName"), String), NodeID, cIconsBasePath & "application.gif", cIconsBasePath & "application.gif", ResMan.GetString("DesignerTreeData.Application") & " " & CType(dr("ApplicationDisplayName"), String), "parent.frames['header'].SelectNode('/apps/app_" & CType(dr("applicationid"), String) & "')", "/apps/app_" & CType(dr("ApplicationID"), String), Sample, True)
            Next
        End If
        'resources
        If NodeID = "/resources" Then
            For Each dr In cn.ExecuteQuery("CMS.Resource.SelectList", Nothing, "", "ResourceDisplayName").Tables(0).Rows
                nodes.NewNode(CType(dr("ResourceDisplayName"), String), NodeID, cIconsBasePath & "resource.gif", cIconsBasePath & "resource.gif", CType(dr("ResourceDisplayName"), String), "parent.frames['header'].SelectNode('/resources/res_" & CType(dr("resourceid"), String) & "')", "/resources/res_" & CType(dr("ResourceID"), String), Sample, True)
            Next
        End If
        'application - read classes
        If Left(NodeID & "1234567890", 10) = "/apps/app_" AndAlso IsNumeric(Replace(NodeID, "/apps/app_", "")) Then
            For Each dr In cn.ExecuteQuery("CMS.Class.SelectClassesOfApplication", Nothing, " applicationid = '" & Replace(Replace(NodeID, "/apps/app_", ""), "'", "''") & "'", "ClassDisplayName").Tables(0).Rows
                nodes.NewNode(CType(dr("ClassDisplayName"), String), NodeID, cIconsBasePath & "class.gif", cIconsBasePath & "class.gif", CType(dr("ClassDisplayName"), String), "parent.frames['header'].SelectNode('" & NodeID & "/class_" & CType(dr("classid"), Integer) & "')", NodeID & "/class_" & CType(dr("ClassID"), String), Sample, True)
            Next
        End If
        'class - allowed child classes, EditTemplateFields
        If InStr(NodeID, "/class_") > 0 And NodeID.Split("/"c).GetUpperBound(0) = 3 Then
            nodes.NewNode(ResMan.GetString("DesignerTreeData.EditTemplateFields"), NodeID, cIconsBasePath & "EditTemplateFields.gif", cIconsBasePath & "EditTemplateFields.gif", ResMan.GetString("DesignerTreeData.EditTemplateFields"), "parent.frames['header'].SelectNode('" & NodeID & "/EditTemplateFields')", NodeID & "/EditTemplateFields", Sample, False)
            nodes.NewNode(ResMan.GetString("DesignerTreeData.Transformations"), NodeID, cIconsBasePath & "Transformations.gif", cIconsBasePath & "Transformations.gif", ResMan.GetString("DesignerTreeData.Transformations"), "parent.frames['header'].SelectNode('" & NodeID & "/Transformations')", NodeID & "/Transformations", Sample, False)
            nodes.NewNode(ResMan.GetString("DesignerTreeData.Queries"), NodeID, cIconsBasePath & "Queries.gif", cIconsBasePath & "Queries.gif", ResMan.GetString("DesignerTreeData.Queries"), "parent.frames['header'].SelectNode('" & NodeID & "/Queries')", NodeID & "/Queries", Sample, False)
            nodes.NewNode(ResMan.GetString("DesignerTreeData.Settings"), NodeID, cIconsBasePath & "Settings.gif", cIconsBasePath & "Settings.gif", ResMan.GetString("DesignerTreeData.Settings"), "parent.frames['header'].SelectNode('" & NodeID & "/Settings')", NodeID & "/Settings", Sample, False)
            nodes.NewNode(ResMan.GetString("DesignerTreeData.AllowedChildClasses"), NodeID, cIconsBasePath & "allowedchildclasses.gif", cIconsBasePath & "allowedchildclasses.gif", ResMan.GetString("DesignerTreeData.AllowedChildClasses"), "parent.frames['header'].SelectNode('" & NodeID & "/allowedchildclasses')", NodeID & "/allowedchildclasses", Sample, False)
            nodes.NewNode(ResMan.GetString("DesignerTreeData.PermissionNames"), NodeID, cIconsBasePath & "permissionnames.gif", cIconsBasePath & "permissionnames.gif", ResMan.GetString("DesignerTreeData.PermissionNames"), "parent.frames['header'].SelectNode('" & NodeID & "/permissionnames')", NodeID & "/permissionnames", Sample, False)
        End If
        'resource - add "permission names" node
        If InStr(NodeID, "/res_") > 0 Then
            nodes.NewNode(ResMan.GetString("DesignerTreeData.PermissionNames"), NodeID, cIconsBasePath & "permissionnames.gif", cIconsBasePath & "permissionnames.gif", ResMan.GetString("DesignerTreeData.PermissionNames"), "parent.frames['header'].SelectNode('" & NodeID & "/permissionnames')", NodeID & "/permissionnames", Sample, False)
        End If
        Return nodes.NodesHTML
    End Function


    '''<summary>Displays an error message.</summary>
    '''<param name="message">Error message.</param>
    Public Sub ShowErrorMessage(ByVal message As String)
        ltlRender.Text &= " alert('" & Replace(message & "", "'", "\'") & "');"
    End Sub
End Class
