Imports Kentico.CMS.MetadataEngine
Imports Kentico.CMS.DataEngine
Imports System.Data.SqlClient
Imports System.io

Public Class EditXMLSchema
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents lblSchema As System.Web.UI.WebControls.Label
    Protected WithEvents lblGenerate As System.Web.UI.WebControls.Label
    Protected WithEvents btnGenerate As System.Web.UI.WebControls.Button
    Protected WithEvents txtTableName As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtSchema As System.Web.UI.WebControls.TextBox
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Read") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Read")
            Exit Sub
        End If

        Dim classid As Integer = Integer.Parse(Request.QueryString("classid"))
        Dim className As String = GetClassName()
        Dim path As String
        Dim str As StreamReader

        lblInfo.Text = ""
        lblError.Text = ""
        If Not Page.IsPostBack Then
            'read file from the disk
            path = MetadataProvider.GetMetadataPath & "\" & Replace(className & "", ".", "\") & "\schema.config"
            If File.Exists(path) Then
                str = File.OpenText(path)
                txtSchema.Text = str.ReadToEnd
                str.Close()
            End If
            'set labels and buttons
            lblHeader.Text = ResMan.GetString("EditXMLSchema.Header")
            lblGenerate.Text = ResMan.GetString("EditXMLSchema.LabelGenerate")
            btnGenerate.Text = ResMan.GetString("EditXMLSchema.ButtonGenerate")
            lblSchema.Text = ResMan.GetString("EditXMLSchema.XMLSchema")
            btnOK.Text = ResMan.GetString("EditXMLSchema.OK")
        End If
    End Sub


    '''<summary>Returns name of the current class in format application.class.</summary>
    Private Function GetClassName() As String
        If CType(viewstate("classname"), String) = "" Then
            Dim cn As New GeneralConnection(Functions.GetConnectionString)
            Dim params(0, 2) As Object
            Dim ds As DataSet
            Dim classid As Integer = Integer.Parse(Request.QueryString("classid"))

            params(0, 0) = "@ID"
            params(0, 1) = classid
            ds = cn.ExecuteQuery("CMS.Class.Select", params)
            If ds.Tables(0).Rows.Count > 0 Then
                viewstate("classname") = ds.Tables(0).Rows(0)("classname")
            Else
                viewstate("classname") = ""
            End If
        End If
        Return CType(viewstate("classname"), String)
    End Function


    Private Sub btnGenerate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGenerate.Click
        'getting XML Schema
        Dim cn As New SqlConnection(Functions.GetConnectionString)
        Dim da As New SqlDataAdapter("select top 1 * from " & txtTableName.Text & " order by 1 ", cn)
        Dim ds As New DataSet
        Try
            cn.Open()
            da.FillSchema(ds, SchemaType.Mapped, GetClassName)
            txtSchema.Text = Replace(ds.GetXmlSchema & "", "utf-16", "utf-8")
            cn.Close()
        Catch
            lblError.Text = ResMan.GetString("EditXMLSchema.Error.CannotGetSchema")
        End Try
    End Sub


    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Modify") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Modify")
            Exit Sub
        End If

        If txtSchema.Text.Trim = "" Then
            lblError.Text = ResMan.GetString("EditXMLSchema.Error.NoSchema")
        Else
            Try
                MetadataProvider.SetXMLSchema(GetClassName, txtSchema.Text)                
                lblInfo.Text = ResMan.GetString("EditXMLSchema.ChangesSaved")
            Catch ex As Exception
                lblError.Text = ResMan.GetString("EditXMLSchema.Error.CannotSaveSchema") & " " & ex.Message.ToString
            End Try
        End If
    End Sub
End Class
