Imports System.Xml

Public Class PageTemplateEdit
    Inherits System.Web.UI.Page

    Protected filename As String

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents lblPageTemplateName As System.Web.UI.WebControls.Label
    Protected WithEvents lblPageTemplateFileName As System.Web.UI.WebControls.Label
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents btnCancel As System.Web.UI.WebControls.Button
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal
    Protected WithEvents lblPageTemplateDescription As System.Web.UI.WebControls.Label
    <CLSCompliantAttribute(False)> Protected WithEvents txtPageTemplateDescription As FreeTextBoxControls.FreeTextBox
    'Protected WithEvents txtPageTemplateDescription As FreeTextBoxControls.FreeTextBox
    Protected WithEvents txtPageTemplateName As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtPageTemplateFileName As System.Web.UI.WebControls.TextBox

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Read") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Read")
            Exit Sub
        End If

        If Request.QueryString("filename") <> "" Then
            If viewstate("filename") Is Nothing Then
                filename = Request.QueryString("filename")
                viewstate("filename") = filename
            Else
                filename = CType(viewstate("filename"), String)
            End If
        Else
            filename = CType(viewstate("filename"), String) & ""
        End If

        lblError.Text = ""
        lblError.Visible = False
        lblInfo.Text = ""
        lblInfo.Visible = False
        lblHeader.Text = ResMan.GetString("PageTemplateEdit.Header")
        lblPageTemplateDescription.Text = ResMan.GetString("PageTemplateEdit.TemplateDescription")
        lblPageTemplateFileName.Text = ResMan.GetString("PageTemplateEdit.TemplateFileName")
        lblPageTemplateName.Text = ResMan.GetString("PageTemplateEdit.TemplateName")
        btnOK.Text = ResMan.GetString("PageTemplateEdit.OK")
        btnCancel.Text = ResMan.GetString("PageTemplateEdit.Cancel")

        If Not Page.IsPostBack And filename <> "" Then
            Dim xml As XmlDocument = GetXML()
            Dim node As XmlNode = xml.SelectSingleNode("/templates/template[@filename='" & filename & "']")
            If Not node Is Nothing Then
                txtPageTemplateName.Text = node.SelectSingleNode("name").InnerText
                txtPageTemplateFileName.Text = node.Attributes("filename").Value
                txtPageTemplateDescription.Text = node.SelectSingleNode("description").InnerText
            End If
        End If
    End Sub


    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        Dim xml As XmlDocument
        xml = GetXML()
        Dim node As XmlNode

        'check permissions
        If filename = "" Then
            If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Create") Then
                Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Create")
                Exit Sub
            End If
        Else
            If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Modify") Then
                Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Modify")
                Exit Sub
            End If
        End If

        'validate input
        Dim errorMessage As String = ""
        Dim infoMessage As String

        If Me.txtPageTemplateName.Text.Trim = "" Then
            errorMessage &= ResMan.GetString("PageTemplateEdit.ErrorEmptyPageTemplateName") & " "
        End If
        If Me.txtPageTemplateFileName.Text.Trim = "" Then
            errorMessage &= ResMan.GetString("PageTemplateEdit.ErrorEmptyPageTemplateFileName") & " "
        End If

        If errorMessage = "" Then
            'check for existing file name or name
            If (filename = "") Or (filename <> "" And filename <> Me.txtPageTemplateFileName.Text) Then
                If xml.SelectNodes("/templates/template[@filename='" & Me.txtPageTemplateFileName.Text & "']").Count > 0 Then
                    errorMessage &= ResMan.GetString("PageTemplateEdit.ErrorExistingPageTemplateFileName") & " "
                End If
            End If

            If errorMessage = "" Then
                'save template details
                If filename = "" Then
                    'insert mode
                    node = xml.CreateElement("template")
                    xml.SelectSingleNode("/templates").AppendChild(node)
                    node.Attributes.Append(xml.CreateAttribute("filename"))
                    node.AppendChild(xml.CreateElement("name"))
                    node.AppendChild(xml.CreateElement("description"))
                Else
                    'update mode
                    node = xml.SelectSingleNode("/templates/template[@filename='" & filename & "']")
                End If
                node.Attributes("filename").Value = Me.txtPageTemplateFileName.Text
                node.SelectSingleNode("name").InnerText = Me.txtPageTemplateName.Text
                node.SelectSingleNode("description").InnerText = Me.txtPageTemplateDescription.Text
                xml.Save(Functions.GetMetadataPath & "\_PageTemplates\pagetemplates.config")
                viewstate("filename") = Me.txtPageTemplateFileName.Text
                infoMessage = ResMan.GetString("PageTemplateEdit.ChangesSaved")
            End If
        End If

        If errorMessage <> "" Then
            lblError.Text = errorMessage
            lblError.Visible = True
        End If
        If infoMessage <> "" Then
            lblInfo.Text = infoMessage
            lblInfo.Visible = True
        End If
    End Sub


    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        'redirect user back to the previous dialog
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= " Cancel(); "
        ltlScript.Text &= "</script>"
    End Sub


    Private Function GetXML() As XmlDocument
        Dim xml As New XmlDocument
        xml.Load(Functions.GetMetadataPath & "\_PageTemplates\pagetemplates.config")
        Return xml
    End Function
End Class
