Imports Kentico.CMS.DataEngine
Imports System.Xml

Public Class PageTemplateList
    Inherits System.Web.UI.Page

    Protected editHint As String
    Protected deleteHint As String

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Protected WithEvents BasicDataGrid1 As Kentico.CMS.CMSControls.BasicDataGrid
    Protected WithEvents ltlConfirmScript As System.Web.UI.WebControls.Literal
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Read") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Read")
            Exit Sub
        End If
    
        editHint = ResMan.GetString("PageTemplateList.EditHint")
        deleteHint = ResMan.GetString("PageTemplateList.DeleteHint")
        'set column header names
        BasicDataGrid1.Columns(0).HeaderText = ResMan.GetString("PageTemplate.Action")
        BasicDataGrid1.Columns(1).HeaderText = ResMan.GetString("PageTemplate.Name")
        BasicDataGrid1.Columns(2).HeaderText = ResMan.GetString("PageTemplate.FileName")
        'confirmation question
        ltlConfirmScript.Text = "<input type=""hidden"" id=""confirmationText"" value=""" & ResMan.GetString("PageTemplate.ConfirmDelete") & """>"
        lblHeader.Text = ResMan.GetString("PageTemplate.Header")
        If Not Page.IsPostBack Then
            DisplayPageTemplates()
        End If        
    End Sub



    Public Sub DeleteItem(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs)
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Delete") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Delete")
            Exit Sub
        End If

        'delete page template
        Dim filename As String = CType(e.CommandArgument, String)
        Dim xml As XmlDocument = GetXML()
        Dim node As XmlNode = xml.SelectSingleNode("/templates/template[@filename='" & filename & "']")
        xml.SelectSingleNode("/templates").RemoveChild(node)
        xml.Save(Functions.GetMetadataPath & "\_PageTemplates\pagetemplates.config")
        Response.Redirect(Page.Request.Url.ToString)
    End Sub


    '''<summary>Displays list of page templates in a grid.</summary>
    Private Sub DisplayPageTemplates()
        Dim xml As XmlDocument = GetXML()
        Dim ds As New DataSet
        Dim dr As DataRow
        Dim node As XmlNode

        ds.Tables.Add(New DataTable)
        ds.Tables(0).Columns.Add(New DataColumn("Name"))
        ds.Tables(0).Columns.Add(New DataColumn("FileName"))
        For Each node In xml.SelectNodes("/templates/template")
            dr = ds.Tables(0).NewRow()
            dr("Name") = node.SelectSingleNode("name").InnerText
            dr("FileName") = node.Attributes("filename").Value
            ds.Tables(0).Rows.Add(dr)
        Next
        BasicDataGrid1.DataSource = ds
    End Sub


    Private Sub dtg_ItemDataBound(ByVal sender As System.Object, ByVal e As DataGridItemEventArgs) Handles BasicDataGrid1.ItemDataBound
        Dim btnCurrentButton As ImageButton

        'set up the Delete button
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            btnCurrentButton = CType(e.Item.Cells(0).FindControl("btnDelete"), ImageButton)
            btnCurrentButton.Attributes.Add("OnClick", "return ConfirmDelete();")
            btnCurrentButton.Attributes.Add("title", deleteHint)
        End If
    End Sub


    Private Function GetXML() As XmlDocument
        Dim xml As New XmlDocument
        xml.Load(Functions.GetMetadataPath & "\_PageTemplates\pagetemplates.config")
        Return xml
    End Function

End Class