Imports Kentico.CMS.DataEngine

Public Class PermissionNameEdit
    Inherits System.Web.UI.Page

    Protected permissionID As Integer
    Protected classID As Integer
    Protected resourceID As Integer

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents btnCancel As System.Web.UI.WebControls.Button
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal
    Protected WithEvents lblPermissionID As System.Web.UI.WebControls.Label
    Protected WithEvents lblPermissionIDValue As System.Web.UI.WebControls.Label
    Protected WithEvents lblPermissionDisplayName As System.Web.UI.WebControls.Label
    Protected WithEvents lblPermissionName As System.Web.UI.WebControls.Label
    Protected WithEvents txtPermissionDisplayName As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtPermissionName As System.Web.UI.WebControls.TextBox

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Read") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Read")
            Exit Sub
        End If

        Dim cn As GeneralConnection
        Dim permissionObj As DataClass

        If Request.QueryString("id") <> "" Then
            permissionID = Integer.Parse(Request.QueryString("id"))
        Else
            permissionID = 0
        End If
        If Request.QueryString("resourceid") <> "" Then
            resourceID = Integer.Parse(Request.QueryString("resourceid"))
        Else
            resourceID = 0
        End If
        If Request.QueryString("classid") <> "" Then
            classID = Integer.Parse(Request.QueryString("classid"))
        Else
            classID = 0
        End If
        lblError.Text = ""
        lblError.Visible = False
        lblInfo.Text = ""
        lblInfo.Visible = False
        lblHeader.Text = ResMan.GetString("PermissionNameEdit.Header")
        lblPermissionID.Text = ResMan.GetString("PermissionNameEdit.PermissionID")
        lblPermissionName.Text = ResMan.GetString("PermissionNameEdit.PermissionName")
        lblPermissionDisplayName.Text = ResMan.GetString("PermissionNameEdit.PermissionDisplayName")
        btnOK.Text = ResMan.GetString("PermissionNameEdit.OK")
        btnCancel.Text = ResMan.GetString("PermissionNameEdit.Cancel")

        If Not Page.IsPostBack And permissionID <> 0 Then
            cn = New GeneralConnection(Functions.GetConnectionString)
            permissionObj = New DataClass("CMS.Permission", permissionID, cn)
            txtPermissionName.Text = CType(permissionObj.GetValue("PermissionName"), String)
            txtPermissionDisplayName.Text = CType(permissionObj.GetValue("PermissionDisplayName"), String)
            lblPermissionIDValue.Text = CType(permissionObj.GetValue("PermissionID"), String)
        Else
            lblPermissionIDValue.Text = ResMan.GetString("PermissionNameEdit.NoPermissionIDValue")
        End If
    End Sub


    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        'check permissions
        If permissionID = 0 Then
            If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Create") Then
                Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Create")
                Exit Sub
            End If
        Else
            If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Modify") Then
                Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Modify")
                Exit Sub
            End If
        End If

        'validate input
        Dim errorMessage As String = ""
        Dim cn As GeneralConnection
        Dim params(1, 2) As String
        Dim permissionDR As DataRow
        Dim permissionNamesDS As DataSet
        Dim infoMessage As String
        Dim permissionObj As DataClass

        If txtPermissionName.Text.Trim = "" Then
            errorMessage &= ResMan.GetString("PermissionNameEdit.ErrorEmptyPermissionName") & " "
        End If
        If txtPermissionDisplayName.Text.Trim = "" Then
            errorMessage &= ResMan.GetString("PermissionNameEdit.ErrorEmptyPermissionDisplayName") & " "
        End If

        If errorMessage = "" Then
            'check for existing permission name
            params(0, 0) = "@PermissionName"
            params(0, 1) = txtPermissionName.Text.Trim
            cn = New GeneralConnection(Functions.GetConnectionString)
            cn.DataConnection.Open()

            If classID > 0 Then
                params(1, 0) = "@ClassID"
                params(1, 1) = classID.ToString
                permissionNamesDS = cn.ExecuteQuery("CMS.Permission.SelectByPermissionNameAndClassID", params)
            Else
                params(1, 0) = "@ResourceID"
                params(1, 1) = resourceID.ToString
                permissionNamesDS = cn.ExecuteQuery("CMS.Permission.SelectByPermissionNameAndResourceID", params)
            End If
            If permissionID = 0 Then
                If permissionNamesDS.Tables(0).Rows.Count > 0 Then
                    'permission name already exists
                    errorMessage &= ResMan.GetString("PermissionNameEdit.ErrorExistingPermissionName") & " "
                End If
            Else
                For Each permissionDR In permissionNamesDS.Tables(0).Rows
                    If CType(permissionDR("permissionID"), Integer) <> permissionID Then
                        'permission name already exists
                        errorMessage &= ResMan.GetString("PermissionNameEdit.ErrorExistingPermissionName") & " "
                    End If
                Next
            End If

            If errorMessage = "" Then
                'save permission info
                If permissionID = 0 Then
                    'insert a new permission name
                    permissionObj = New DataClass("CMS.Permission", cn)
                    permissionObj.SetValue("PermissionName", txtPermissionName.Text)
                    permissionObj.SetValue("PermissionDisplayName", txtPermissionDisplayName.Text)
                    If classID > 0 Then
                        permissionObj.SetValue("ClassID", classID)
                    Else
                        permissionObj.SetValue("ResourceID", resourceID)
                    End If
                    permissionObj.Insert()
                    txtPermissionName.Text = ""
                    txtPermissionDisplayName.Text = ""
                    infoMessage = ResMan.GetString("PermissionEdit.ChangesInserted")
                Else
                    'update an existing user
                    permissionObj = New DataClass("CMS.Permission", permissionID, cn)
                    permissionObj.SetValue("PermissionName", txtPermissionName.Text)
                    permissionObj.SetValue("PermissionDisplayName", txtPermissionDisplayName.Text)
                    If classID > 0 Then
                        permissionObj.SetValue("ClassID", classID)
                    Else
                        permissionObj.SetValue("ResourceID", resourceID)
                    End If
                    permissionObj.Update()
                    infoMessage = ResMan.GetString("PermissionNameEdit.ChangesSaved")
                End If
            End If
            cn.DataConnection.Close()
        End If

        If errorMessage <> "" Then
            lblError.Text = errorMessage
            lblError.Visible = True
        End If
        If infoMessage <> "" Then
            lblInfo.Text = infoMessage
            lblInfo.Visible = True
        End If
    End Sub


    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        'redirect user back to the previous dialog
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= " Cancel('" & Request.QueryString("classid") & "', '" & Request.QueryString("resourceid") & "'); "
        ltlScript.Text &= "</script>"
    End Sub

End Class
