Imports Kentico.CMS.DataEngine

Public Class PermissionNameList
    Inherits System.Web.UI.Page

    Protected editHint As String
    Protected deleteHint As String

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Protected WithEvents QueryDataGrid1 As Kentico.CMS.CMSControls.QueryDataGrid
    Protected WithEvents ltlConfirmScript As System.Web.UI.WebControls.Literal
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Read") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Read")
            Exit Sub
        End If

        editHint = ResMan.GetString("PermissionNameList.EditHint")
        deleteHint = ResMan.GetString("PermissionNameList.DeleteHint")
        'set column header names
        QueryDataGrid1.Columns(0).HeaderText = ResMan.GetString("PermissionNameList.Action")
        QueryDataGrid1.Columns(1).HeaderText = ResMan.GetString("PermissionNameList.PermissionDisplayName")
        QueryDataGrid1.Columns(2).HeaderText = ResMan.GetString("PermissionNameList.PermissionName")
        'confirmation question
        ltlConfirmScript.Text = "<input type=""hidden"" id=""confirmationText"" value=""" & ResMan.GetString("PermissionNameList.ConfirmDelete") & """>"
        lblHeader.Text = ResMan.GetString("PermissionNameList.Header")

        If Not Page.IsPostBack Then
            DisplayPermissionNames()
        End If
    End Sub


    Public Sub DeleteItem(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs)
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Delete") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Delete")
            Exit Sub
        End If

        'delete permission name
        Dim id As Integer = Integer.Parse(CType(e.CommandArgument, String))
        Dim cn As New GeneralConnection
        Dim params(0, 2) As String

        params(0, 0) = "@ID"
        params(0, 1) = id.ToString
        cn.ConnectionString = Functions.GetConnectionString
        cn.ExecuteQuery("CMS.Permission.Delete", params)
        Response.Redirect(Page.Request.Url.ToString)
    End Sub


    '''<summary>Displays list of permission names in a grid.</summary>
    Private Sub DisplayPermissionNames()
        Dim cn As New GeneralConnection
        cn.ConnectionString = Functions.GetConnectionString
        QueryDataGrid1.GeneralConnection = cn
        If Request.QueryString("classid") <> "" Then
            QueryDataGrid1.QueryName = "CMS.Permission.selectpermissionnamesof"
            QueryDataGrid1.WhereCondition = " classid = '" & Replace(Request.QueryString("classid"), "'", "''") & "'"
        Else
            QueryDataGrid1.QueryName = "CMS.Permission.selectpermissionnamesof"
            QueryDataGrid1.WhereCondition = " resourceid = '" & Replace(Request.QueryString("resourceid"), "'", "''") & "'"
        End If
    End Sub


    Private Sub dtg_ItemDataBound(ByVal sender As System.Object, ByVal e As DataGridItemEventArgs) Handles QueryDataGrid1.ItemDataBound
        Dim btnCurrentButton As ImageButton

        'set up the Delete button
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            btnCurrentButton = CType(e.Item.Cells(0).FindControl("btnDelete"), ImageButton)
            btnCurrentButton.Attributes.Add("OnClick", "return ConfirmDelete();")
            btnCurrentButton.Attributes.Add("title", deleteHint)
        End If
    End Sub

End Class
