Imports System.Xml
Imports System.IO

Public Class QueryEdit
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents btnCancel As System.Web.UI.WebControls.Button
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal
    Protected WithEvents lblQueryName As System.Web.UI.WebControls.Label
    Protected WithEvents lblQueryText As System.Web.UI.WebControls.Label
    Protected WithEvents txtQueryText As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblQueryType As System.Web.UI.WebControls.Label
    Protected WithEvents lstQueryType As System.Web.UI.WebControls.ListBox
    Protected WithEvents lblRequiresTransaction As System.Web.UI.WebControls.Label
    Protected WithEvents chkRequiresTransaction As System.Web.UI.WebControls.CheckBox
    Protected WithEvents txtQueryID As System.Web.UI.WebControls.TextBox

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private queryID As String
    Private className As String
    Private classID As Integer
    Private path As String

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Read") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Read")
            Exit Sub
        End If

        If Request.QueryString("action") <> "insert" Then
            queryID = Request.QueryString("queryid").Split("."c)(2)
            path = Functions.GetMetadataPath & "\" & Request.QueryString("queryid").Split("."c)(0) & "\" & Request.QueryString("queryid").Split("."c)(1) & "\queries.config"
            viewstate("mode") = "modify"
            className = Request.QueryString("queryid").Split("."c)(0) & "." & Request.QueryString("queryid").Split("."c)(1)
            classID = CType(Kentico.CMS.TreeEngine.ClassInformationProvider.GetClassRow(className, Functions.GetTreeProvider())("ClassID"), Integer)
        ElseIf Request.QueryString("classid") <> "" Then
            If CType(viewstate("mode"), String) = "" Then
                viewstate("mode") = "create"
            End If
            queryID = ""
            classID = Integer.Parse(Request.QueryString("classid"))
            className = CType(Kentico.CMS.TreeEngine.ClassInformationProvider.GetClassRow(classID, Functions.GetTreeProvider())("ClassName"), String)
            path = Functions.GetMetadataPath & "\" & className.Split("."c)(0) & "\" & className.Split("."c)(1) & "\queries.config"
        End If
        If Not Page.IsPostBack Then
            viewstate("originalQueryID") = queryID
        End If
        lblError.Text = ""
        lblInfo.Text = ""
        lblHeader.Text = ResMan.GetString("QueryEdit.Header")
        lblQueryName.Text = ResMan.GetString("QueryEdit.QueryName")
        lblQueryText.Text = ResMan.GetString("QueryEdit.QueryText")
        lblQueryType.Text = ResMan.GetString("QueryEdit.QueryType")
        lblRequiresTransaction.Text = ResMan.GetString("QueryEdit.RequiresTransaction")
        btnOK.Text = ResMan.GetString("QueryEdit.OK")
        btnCancel.Text = ResMan.GetString("QueryEdit.Cancel")
        If Not Page.IsPostBack Then
            lstQueryType.Items.Add(New ListItem(ResMan.GetString("QueryEdit.QueryTypeText"), "querytext"))
            lstQueryType.Items.Add(New ListItem(ResMan.GetString("QueryEdit.QueryTypeSP"), "sp"))
        End If

        If Not Page.IsPostBack And CType(viewstate("mode"), String) = "modify" Then
            'set values
            Dim xml As New XmlDocument
            xml.Load(path)
            Dim node As XmlNode = xml.SelectSingleNode("/queries/query[@id='" & queryID & "']")
            Me.txtQueryID.Text = queryID
            Me.txtQueryText.Text = node.InnerText
            If Not node.Attributes("transaction") Is Nothing AndAlso node.Attributes("transaction").Value.ToLower = "true" Then
                Me.chkRequiresTransaction.Checked = True
            Else
                Me.chkRequiresTransaction.Checked = False
            End If
            If Not node.Attributes("type") Is Nothing AndAlso node.Attributes("type").Value.ToLower = "sp" Then
                Me.lstQueryType.SelectedValue = "sp"
            Else
                Me.lstQueryType.SelectedValue = "querytext"
            End If
        End If
    End Sub


    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        'check permissions
        If CType(viewstate("mode"), String) = "create" Then
            If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Create") Then
                Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Create")
                Exit Sub
            End If
        Else
            If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Modify") Then
                Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Modify")
                Exit Sub
            End If
        End If

        'validate input
        Dim errorMessage As String = ""
        Dim xml As New XmlDocument
        xml.Load(path)
        Dim node As XmlNode

        If txtQueryID.Text.Trim = "" Then
            errorMessage &= ResMan.GetString("QueryEdit.ErrorEmptyQueryID") & " "
        ElseIf txtQueryID.Text.Trim.ToLower <> (CType(viewstate("originalQueryID"), String) & "").Trim.ToLower Then
            'ensure uniqueness
            If Not xml.SelectSingleNode("/queries/query[@id='" & Me.txtQueryID.Text.Trim.ToLower & "']") Is Nothing Then
                errorMessage &= ResMan.GetString("QueryEdit.ErrorExistingQueryID")
            End If
        End If
        If txtQueryText.Text.Trim = "" Then
            errorMessage &= ResMan.GetString("QueryEdit.ErrorEmptyQuery") & " "
        End If
        If errorMessage <> "" Then
            lblError.Text = errorMessage
        End If

        'save
        If errorMessage = "" Then
            txtQueryID.Text = txtQueryID.Text.ToLower.Trim
            If CType(viewstate("mode"), String) = "create" Then
                node = xml.CreateNode(XmlNodeType.Element, "", "query", "")
                node.Attributes.Append(xml.CreateAttribute("", "id", ""))
            Else
                node = xml.SelectSingleNode("/queries/query[@id='" & CType(viewstate("originalQueryID"), String) & "']")
            End If
            node.Attributes("id").Value = Me.txtQueryID.Text.ToLower.Trim
            node.InnerText = Me.txtQueryText.Text
            If node.Attributes("type") Is Nothing Then
                node.Attributes.Append(xml.CreateAttribute("", "type", ""))
            End If
            node.Attributes("type").Value = lstQueryType.SelectedValue
            If node.Attributes("transaction") Is Nothing Then
                node.Attributes.Append(xml.CreateAttribute("", "transaction", ""))
            End If
            If Me.chkRequiresTransaction.Checked Then
                node.Attributes("transaction").Value = "true"
            Else
                node.Attributes("transaction").Value = "false"
            End If
            If CType(viewstate("mode"), String) = "create" Then
                'create new                
                xml.SelectSingleNode("/queries").AppendChild(node)
                xml.Save(path)
                viewstate("mode") = "modify"
            Else
                'modify existing                
                xml.Save(path)
            End If
            viewstate("originalQueryID") = Me.txtQueryID.Text
            'update metadata
            Kentico.CMS.MetadataEngine.MetadataProvider.ClearMetadata()
            lblInfo.Text = ResMan.GetString("QueryEdit.ChangesSaved")
        End If
    End Sub


    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        'redirects user back to the list of resources        
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= " Cancel('" & classID & "'); "
        ltlScript.Text &= "</script>"
    End Sub

End Class
