Imports Kentico.CMS.DataEngine
Imports Kentico.CMS.MetadataEngine
Imports Kentico.CMS.TreeEngine

Public Class RelationshipNameEdit
    Inherits System.Web.UI.Page

    Protected RelationshipNameID As Integer


#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents lblRelationshipNameID As System.Web.UI.WebControls.Label
    Protected WithEvents lblRelationshipNameIDValue As System.Web.UI.WebControls.Label
    Protected WithEvents lblRelationshipDisplayName As System.Web.UI.WebControls.Label
    Protected WithEvents lblRelationshipName As System.Web.UI.WebControls.Label
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents btnCancel As System.Web.UI.WebControls.Button
    Protected WithEvents txtRelationshipDisplayName As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtRelationshipName As System.Web.UI.WebControls.TextBox
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Read") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Read")
            Exit Sub
        End If

        Functions.RedirectExpressEdition("CMSDesk.RelationshipNames")

        Dim cn As GeneralConnection
        Dim relNameObj As DataClass

        If viewstate("RelationshipNameID") Is Nothing Then
            If (Request.QueryString("id") & "").Trim = "" Then
                viewstate("RelationshipNameID") = 0
            Else
                viewstate("RelationshipNameID") = Integer.Parse(Request.QueryString("id"))
            End If
        End If
        RelationshipNameID = Integer.Parse(CType(viewstate("RelationshipNameID"), String))

        lblError.Text = ""
        lblInfo.Text = ""
        lblHeader.Text = ResMan.GetString("RelationshipNameEdit.Header")
        Me.lblRelationshipNameID.Text = ResMan.GetString("RelationshipNameEdit.RelationshipNameID")
        lblRelationshipName.Text = ResMan.GetString("RelationshipNameEdit.RelationshipName")
        lblRelationshipDisplayName.Text = ResMan.GetString("RelationshipNameEdit.RelationshipDisplayName")
        btnOK.Text = ResMan.GetString("RelationshipNameEdit.OK")
        btnCancel.Text = ResMan.GetString("RelationshipNameEdit.Cancel")

        If Not Page.IsPostBack And RelationshipNameID <> 0 Then
            'set values
            cn = New GeneralConnection(Functions.GetConnectionString)
            relNameObj = New DataClass("CMS.RelationshipName", RelationshipNameID, cn)
            txtRelationshipName.Text = CType(relNameObj.GetValue("RelationshipName"), String)
            txtRelationshipDisplayName.Text = CType(relNameObj.GetValue("RelationshipDisplayName"), String)
            lblRelationshipNameIDValue.Text = CType(relNameObj.GetValue("RelationshipNameID"), String)
        End If
        If RelationshipNameID = 0 Then
            lblRelationshipNameIDValue.Text = ResMan.GetString("RelationshipNameEdit.NoRelationshipNameIDValue")
        End If
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        'redirect user back to the list of classes
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= " function Cancel()"
        ltlScript.Text &= " {"
        ltlScript.Text &= "   document.location.href='RelationshipNamesList.aspx';"
        ltlScript.Text &= " }"
        ltlScript.Text &= " Cancel(); "
        ltlScript.Text &= "</script>"
    End Sub


    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        'check permissions
        If RelationshipNameID = 0 Then
            If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Create") Then
                Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Create")
                Exit Sub
            End If
        Else
            If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Modify") Then
                Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Modify")
                Exit Sub
            End If
        End If

        'validate input
        Dim errorMessage As String = ""
        Dim cn As GeneralConnection
        Dim params(0, 2) As String
        Dim relNameDR As DataRow
        Dim infoMessage As String = ""
        Dim relNameObj As DataClass
        Dim originalRelName As String = ""
        Dim newRelName As String = ""
        Dim RelNamesDS As DataSet
        Dim relNameCheckNameDR As DataRow

        Me.txtRelationshipName.Text = txtRelationshipName.Text.Trim
        Me.txtRelationshipDisplayName.Text = txtRelationshipDisplayName.Text.Trim
        If txtRelationshipName.Text = "" Then
            errorMessage &= ResMan.GetString("RelationshipNameEdit.ErrorEmptyRelationshipName") & " "
        End If
        If txtRelationshipDisplayName.Text = "" Then
            errorMessage &= ResMan.GetString("RelationshipNameEdit.ErrorEmptyRelationshipDisplayName") & " "
        End If

        If errorMessage = "" Then
            'check for existing name
            params(0, 0) = "@RelationshipName"
            params(0, 1) = Me.txtRelationshipName.Text
            cn = Functions.GetTreeProvider.Connection
            cn.DataConnection.Open()

            RelNamesDS = cn.ExecuteQuery("CMS.RelationshipName.SelectByRelationshipName", params)
            If RelationshipNameID = 0 Then
                If RelNamesDS.Tables(0).Rows.Count > 0 Then
                    'relationship name already exists
                    errorMessage &= ResMan.GetString("RelationshipNameEdit.ErrorExistingRelationshipName") & " "
                End If
            Else
                For Each relNameDR In RelNamesDS.Tables(0).Rows
                    If CType(relNameDR("RelationshipNameID"), Integer) <> RelationshipNameID Then
                        'relationship name already exists
                        errorMessage &= ResMan.GetString("RelationshipNameEdit.ErrorExistingRelationshipName") & " "
                    End If
                Next
            End If

            If errorMessage = "" Then
                'save class info
                If RelationshipNameID = 0 Then
                    cn.DataConnection.Open()
                    cn.DataConnection.BeginTransaction()
                    Try
                        'insert a new class                    
                        relNameObj = New DataClass("CMS.RelationshipName", cn)
                        relNameObj.SetValue("RelationshipName", txtRelationshipName.Text)
                        relNameObj.SetValue("RelationshipDisplayName", txtRelationshipDisplayName.Text)
                        relNameObj.Insert()
                        Me.lblRelationshipNameIDValue.Text = CType(relNameObj.GetValue("RelationshipNameID"), Integer).ToString
                    Catch exc As Exception
                        cn.DataConnection.RollbackTransaction()
                        cn.DataConnection.Close()
                        Throw exc
                    End Try
                    cn.DataConnection.CommitTransaction()
                    cn.DataConnection.Close()
                    viewstate("RelationshipNameID") = CType(relNameObj.GetValue("RelationshipNameID"), Integer)
                    infoMessage = ResMan.GetString("RelationshipNameEdit.ChangesSaved")
                Else
                    'update an existing class
                    relNameObj = New DataClass("CMS.RelationshipName", RelationshipNameID, cn)
                    newRelName = Me.txtRelationshipName.Text
                    relNameObj.SetValue("RelationshipName", txtRelationshipName.Text)
                    newRelName = CType(relNameObj.GetValue("RelationshipName"), String)
                    relNameObj.SetValue("RelationshipDisplayName", txtRelationshipDisplayName.Text)
                    relNameObj.Update()
                    infoMessage = ResMan.GetString("RelationshipNameEdit.ChangesSaved")
                End If
            End If
            cn.DataConnection.Close()
        End If

        If errorMessage <> "" Then
            lblError.Text = errorMessage
        End If
        If infoMessage <> "" Then
            lblInfo.Text = infoMessage
        End If
    End Sub
End Class
