Imports Kentico.CMS.DataEngine

Public Class ResourceEdit
    Inherits System.Web.UI.Page

    Protected resourceID As Integer

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents lblResourceID As System.Web.UI.WebControls.Label
    Protected WithEvents lblResourceIDValue As System.Web.UI.WebControls.Label
    Protected WithEvents lblResourceDisplayName As System.Web.UI.WebControls.Label
    Protected WithEvents txtResourceDisplayName As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblResourceName As System.Web.UI.WebControls.Label
    Protected WithEvents txtResourceName As System.Web.UI.WebControls.TextBox
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents btnCancel As System.Web.UI.WebControls.Button
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal
    Protected WithEvents chkShowInToolsMenu As System.Web.UI.WebControls.CheckBox
    Protected WithEvents lblResourceURL As System.Web.UI.WebControls.Label
    Protected WithEvents txtResourceURL As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblShowInToolsMenu As System.Web.UI.WebControls.Label

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Read") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Read")
            Exit Sub
        End If

        Dim cn As GeneralConnection
        Dim resourceObj As DataClass

        If Request.QueryString("id") <> "" Then
            resourceID = Integer.Parse(Request.QueryString("id"))
        Else
            resourceID = 0
        End If
        lblError.Text = ""
        lblError.Visible = False
        lblInfo.Text = ""
        lblInfo.Visible = False
        lblHeader.Text = ResMan.GetString("ResourceEdit.Header")
        lblResourceID.Text = ResMan.GetString("ResourceEdit.ResourceID")
        lblResourceName.Text = ResMan.GetString("ResourceEdit.ResourceName")
        lblResourceDisplayName.Text = ResMan.GetString("ResourceEdit.ResourceDisplayName")
        lblShowInToolsMenu.Text = ResMan.GetString("ResourceEdit.ShowInToolsMenu")
        lblResourceURL.Text = ResMan.GetString("ResourceEdit.ResourceURL")
        btnOK.Text = ResMan.GetString("ResourceEdit.OK")
        btnCancel.Text = ResMan.GetString("ResourceEdit.Cancel")
        Me.txtResourceURL.Enabled = Me.chkShowInToolsMenu.Checked

        If Not Page.IsPostBack And resourceID <> 0 Then
            'set values
            cn = New GeneralConnection(Functions.GetConnectionString)
            resourceObj = New DataClass("CMS.Resource", resourceID, cn)
            txtResourceName.Text = CType(resourceObj.GetValue("ResourceName"), String)
            txtResourceDisplayName.Text = CType(resourceObj.GetValue("ResourceDisplayName"), String)
            lblResourceIDValue.Text = CType(resourceObj.GetValue("ResourceID"), String)
            txtResourceURL.Text = CType(resourceObj.GetValue("ResourceURL"), String)
            chkShowInToolsMenu.Checked = Convert.ToBoolean(resourceObj.GetValue("ShowInToolsMenu"))
            Me.txtResourceURL.Enabled = Me.chkShowInToolsMenu.Checked
        Else
            lblResourceIDValue.Text = ResMan.GetString("EditResource.NoResourceIDValue")
        End If
    End Sub


    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        'check permissions
        If resourceID = 0 Then
            If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Create") Then
                Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Create")
                Exit Sub
            End If
        Else
            If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Modify") Then
                Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Modify")
                Exit Sub
            End If
        End If

        'validate input
        Dim errorMessage As String = ""
        Dim cn As GeneralConnection
        Dim params(0, 2) As String
        Dim resourceDR As DataRow
        Dim resourceNamesDS As DataSet
        Dim infoMessage As String
        Dim resourceObj As DataClass

        If txtResourceName.Text.Trim = "" Then
            errorMessage &= ResMan.GetString("ResourceEdit.ErrorEmptyResourceName") & " "
        End If
        If txtResourceDisplayName.Text.Trim = "" Then
            errorMessage &= ResMan.GetString("ResourceEdit.ErrorEmptyResourceDisplayName") & " "
        End If

        If errorMessage = "" Then
            'check for existing resource
            params(0, 0) = "@ResourceName"
            params(0, 1) = txtResourceName.Text.Trim
            cn = New GeneralConnection(Functions.GetConnectionString)
            cn.DataConnection.Open()

            resourceNamesDS = cn.ExecuteQuery("CMS.Resource.SelectByResourceName", params)
            If resourceID = 0 Then
                If resourceNamesDS.Tables(0).Rows.Count > 0 Then
                    'resource name already exists
                    errorMessage &= ResMan.GetString("ResourceEdit.ErrorExistingResourceName") & " "
                End If
            Else
                For Each resourceDR In resourceNamesDS.Tables(0).Rows
                    If CType(resourceDR("ResourceID"), Integer) <> resourceID Then
                        'resource name already exists
                        errorMessage &= ResMan.GetString("ResourceEdit.ErrorExistingResourceName") & " "
                    End If
                Next
            End If

            If errorMessage = "" Then
                'save resource info
                If resourceID = 0 Then
                    'insert a new resource
                    resourceObj = New DataClass("CMS.Resource", cn)
                    resourceObj.SetValue("ResourceName", txtResourceName.Text)
                    resourceObj.SetValue("ResourceDisplayName", txtResourceDisplayName.Text)
                    resourceObj.SetValue("ShowInToolsMenu", chkShowInToolsMenu.Checked)
                    resourceObj.SetValue("ResourceURL", txtResourceURL.Text)
                    resourceObj.Insert()
                    txtResourceName.Text = ""
                    txtResourceDisplayName.Text = ""
                    chkShowInToolsMenu.Checked = False
                    txtResourceURL.Text = ""
                    infoMessage = ResMan.GetString("ResourceEdit.ChangesInserted")
                    ltlScript.Text = "<script language=""javascript"">"
                    ltlScript.Text &= " RefreshTreeAfterInsert(); "
                    ltlScript.Text &= "</script>"
                Else
                    'update an existing user
                    resourceObj = New DataClass("CMS.Resource", resourceID, cn)
                    resourceObj.SetValue("ResourceName", txtResourceName.Text)
                    resourceObj.SetValue("ResourceDisplayName", txtResourceDisplayName.Text)
                    resourceObj.SetValue("ShowInToolsMenu", chkShowInToolsMenu.Checked)
                    resourceObj.SetValue("ResourceURL", txtResourceURL.Text)
                    resourceObj.Update()
                    infoMessage = ResMan.GetString("ResourceEdit.ChangesSaved")
                    ltlScript.Text = "<script language=""javascript"">"
                    ltlScript.Text &= " RefreshTree(); "
                    ltlScript.Text &= "</script>"
                End If
            End If
            cn.DataConnection.Close()
        End If

        If errorMessage <> "" Then
            lblError.Text = errorMessage
            lblError.Visible = True
        End If
        If infoMessage <> "" Then
            lblInfo.Text = infoMessage
            lblInfo.Visible = True
        End If
    End Sub


    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        'redirects user back to the list of resources
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= " Cancel(); "
        ltlScript.Text &= "</script>"
    End Sub

    Private Sub chkShowInToolsMenu_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkShowInToolsMenu.CheckedChanged
        Me.txtResourceURL.Enabled = Me.chkShowInToolsMenu.Checked
    End Sub
End Class
