Imports System.Xml
Imports System.IO

Public Class SettingsEdit
    Inherits System.Web.UI.Page

    Private key As String
    Private className As String
    Private classID As Integer
    Protected WithEvents lblKey As System.Web.UI.WebControls.Label
    Protected WithEvents txtKey As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblValue As System.Web.UI.WebControls.Label
    Protected WithEvents txtValue As System.Web.UI.WebControls.TextBox
    Private path As String

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents btnCancel As System.Web.UI.WebControls.Button
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Read") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Read")
            Exit Sub
        End If

        If Request.QueryString("action") <> "insert" Then
            key = Request.QueryString("key").Split("."c)(2)
            path = Functions.GetMetadataPath & "\" & Request.QueryString("key").Split("."c)(0) & "\" & Request.QueryString("key").Split("."c)(1) & "\settings.config"
            viewstate("mode") = "modify"
            className = Request.QueryString("key").Split("."c)(0) & "." & Request.QueryString("key").Split("."c)(1)
            classID = CType(Kentico.CMS.TreeEngine.ClassInformationProvider.GetClassRow(className, Functions.GetTreeProvider())("ClassID"), Integer)
        ElseIf Request.QueryString("classid") <> "" Then
            If CType(viewstate("mode"), String) = "" Then
                viewstate("mode") = "create"
            End If
            key = ""
            classID = Integer.Parse(Request.QueryString("classid"))
            className = CType(Kentico.CMS.TreeEngine.ClassInformationProvider.GetClassRow(classID, Functions.GetTreeProvider())("ClassName"), String)
            path = Functions.GetMetadataPath & "\" & className.Split("."c)(0) & "\" & className.Split("."c)(1) & "\settings.config"
        End If
        If Not Page.IsPostBack Then
            viewstate("originalKey") = key
        End If
        lblError.Text = ""
        lblInfo.Text = ""
        lblHeader.Text = ResMan.GetString("SettingsEdit.Header")
        lblKey.Text = ResMan.GetString("SettingsEdit.Key")
        lblValue.Text = ResMan.GetString("SettingsEdit.Value")
        btnOK.Text = ResMan.GetString("SettingsEdit.OK")
        btnCancel.Text = ResMan.GetString("SettingsEdit.Cancel")

        If Not Page.IsPostBack And CType(viewstate("mode"), String) = "modify" Then
            'set values
            Dim xml As New XmlDocument
            xml.Load(path)
            Dim node As XmlNode = xml.SelectSingleNode("/settings/add[@key='" & key & "']")
            Me.txtKey.Text = key
            Me.txtValue.Text = node.Attributes("value").Value
        End If
    End Sub


    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        'check permissions
        If CType(viewstate("mode"), String) = "create" Then
            If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Create") Then
                Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Create")
                Exit Sub
            End If
        Else
            If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Modify") Then
                Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Modify")
                Exit Sub
            End If
        End If

        'validate input
        Dim errorMessage As String = ""
        Dim xml As New XmlDocument
        xml.Load(path)
        Dim node As XmlNode

        If txtKey.Text.Trim = "" Then
            errorMessage &= ResMan.GetString("SettingsEdit.ErrorEmptyKey") & " "
        ElseIf txtKey.Text.Trim.ToLower <> (CType(viewstate("originalKey"), String) & "").Trim.ToLower Then
            'check uniqueness
            If Not xml.SelectSingleNode("/settings/add[@key='" & txtKey.Text.Trim.ToLower & "']") Is Nothing Then
                errorMessage &= ResMan.GetString("SettingsEdit.ErrorExistingKey")
            End If
        End If
        If errorMessage <> "" Then
            lblError.Text = errorMessage
        End If

        'save
        If errorMessage = "" Then
            txtKey.Text = txtKey.Text.ToLower.Trim
            If CType(viewstate("mode"), String) = "create" Then
                node = xml.CreateNode(XmlNodeType.Element, "", "add", "")
                node.Attributes.Append(xml.CreateAttribute("", "key", ""))
                node.Attributes.Append(xml.CreateAttribute("", "value", ""))
            Else
                node = xml.SelectSingleNode("/settings/add[@key='" & CType(viewstate("originalKey"), String) & "']")
            End If
            node.Attributes("key").Value = Me.txtKey.Text.Trim.ToLower
            node.Attributes("value").Value = Me.txtValue.Text
            If CType(viewstate("mode"), String) = "create" Then
                'create new                
                xml.SelectSingleNode("/settings").AppendChild(node)
                xml.Save(path)
                viewstate("mode") = "modify"
            Else
                'modify existing                
                xml.Save(path)
            End If
            viewstate("originalKey") = Me.txtKey.Text
            'update metadata
            Kentico.CMS.MetadataEngine.MetadataProvider.ClearMetadata()
            lblInfo.Text = ResMan.GetString("SettingsEdit.ChangesSaved")
        End If
    End Sub


    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        'redirects user back to the list of resources        
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= " Cancel('" & classID & "'); "
        ltlScript.Text &= "</script>"
    End Sub

End Class
