Imports System.IO
Imports System.Xml

Public Class SettingsList
    Inherits System.Web.UI.Page

    Private path As String
    Private classID As Integer
    Private className As String    

    Protected editHint As String
    Protected deleteHint As String

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents Grid1 As Kentico.CMS.CMSControls.BasicDataGrid
    Protected WithEvents ltlConfirmScript As System.Web.UI.WebControls.Literal
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Read") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Read")
            Exit Sub
        End If

        classID = CType(Request.QueryString("classid"), Integer)
        className = CType(Kentico.CMS.TreeEngine.ClassInformationProvider.GetClassRow(classID, Functions.GetTreeProvider)("ClassName"), String)
        path = Functions.GetMetadataPath & "\" & className.Split("."c)(0) & "\" & className.Split("."c)(1) & "\settings.config"

        editHint = ResMan.GetString("SettingsList.EditHint")
        deleteHint = ResMan.GetString("SettingsList.DeleteHint")
        'set column header names
        Grid1.Columns(0).HeaderText = ResMan.GetString("SettingsList.Action")
        Grid1.Columns(1).HeaderText = ResMan.GetString("SettingsList.Key")
        Grid1.Columns(2).HeaderText = ResMan.GetString("SettingsList.Value")

        'confirmation question
        ltlConfirmScript.Text = "<input type=""hidden"" id=""confirmationText"" value=""" & ResMan.GetString("SettingsList.ConfirmDelete") & """>"
        lblHeader.Text = ResMan.GetString("SettingsList.Header")

        If Not Page.IsPostBack Then
            DisplayQueries()
        End If
    End Sub


    Public Sub DeleteItem(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs)
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Delete") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Delete")
            Exit Sub
        End If

        'delete Query
        Dim xml As New XmlDocument
        xml.Load(path)
        Dim node As XmlNode = xml.SelectSingleNode("/settings/add[@key='" & CType(e.CommandArgument, String) & "']")
        xml.SelectSingleNode("/settings").RemoveChild(node)
        xml.Save(path)
        Kentico.CMS.MetadataEngine.MetadataProvider.ClearMetadata()

        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= " Reload(); "
        ltlScript.Text &= "</script>"
    End Sub


    Private Sub DisplayQueries()
        Dim node As XmlNode
        Dim ds As New DataSet
        Dim dr As DataRow
        Dim xml As New XmlDocument
        'read queries
        If File.Exists(path) Then
            xml.Load(path)
        Else
            xml.LoadXml("<settings></settings>")
            xml.Save(path)
        End If

        'prepare dataset
        ds.Tables.Add(New DataTable)
        ds.Tables(0).Columns.Add(New DataColumn("key"))
        ds.Tables(0).Columns.Add(New DataColumn("value"))
        ds.Tables(0).Columns.Add(New DataColumn("fullkey"))
        'fill dataset
        For Each node In xml.SelectNodes("/settings/add")
            dr = ds.Tables(0).NewRow()
            dr("Key") = node.Attributes("key").Value
            dr("Value") = node.Attributes("value").Value
            dr("Fullkey") = className & "." & node.Attributes("key").Value
            ds.Tables(0).Rows.Add(dr)
        Next
        'bind data
        Grid1.DataSource = ds
    End Sub


    Private Sub Grid1_ItemDataBound(ByVal sender As System.Object, ByVal e As DataGridItemEventArgs) Handles Grid1.ItemDataBound
        Dim btnCurrentButton As ImageButton

        'set up the Delete button
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            btnCurrentButton = CType(e.Item.Cells(0).FindControl("btnDelete"), ImageButton)
            btnCurrentButton.Attributes.Add("OnClick", "return ConfirmDelete();")
            btnCurrentButton.Attributes.Add("title", deleteHint)
        End If
    End Sub


End Class
