Imports System.Xml
Imports System.IO
Imports System.Data.SqlClient
Imports Kentico.CMS.MetadataEngine
Imports Kentico.CMS.TreeEngine

Public Class TemplateDesigner
    Inherits System.Web.UI.UserControl

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblAttributes As System.Web.UI.WebControls.Label
    Protected WithEvents lblProperties As System.Web.UI.WebControls.Label
    Protected WithEvents lstAttributes As System.Web.UI.WebControls.ListBox
    Protected WithEvents btnUpAttribute As System.Web.UI.WebControls.ImageButton
    Protected WithEvents btnDownAttribute As System.Web.UI.WebControls.ImageButton
    Protected WithEvents btnNewAttribute As System.Web.UI.WebControls.ImageButton
    Protected WithEvents btnDeleteAttribute As System.Web.UI.WebControls.ImageButton
    Protected WithEvents lblAttributeName As System.Web.UI.WebControls.Label
    Protected WithEvents lblAttributeType As System.Web.UI.WebControls.Label
    Protected WithEvents lblAttributeSize As System.Web.UI.WebControls.Label
    Protected WithEvents lblAttributeAllowEmpty As System.Web.UI.WebControls.Label
    Protected WithEvents chkDisplayInForm As System.Web.UI.WebControls.CheckBox
    Protected WithEvents pnlDisplayInForm As System.Web.UI.WebControls.Panel
    Protected WithEvents lblFieldType As System.Web.UI.WebControls.Label
    Protected WithEvents lstFieldType As System.Web.UI.WebControls.ListBox
    Protected WithEvents txtFieldCaption As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtDescription As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtAttributeName As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtAttributeSize As System.Web.UI.WebControls.TextBox
    Protected WithEvents lstAttributeType As System.Web.UI.WebControls.ListBox
    Protected WithEvents chkAllowEmpty As System.Web.UI.WebControls.CheckBox
    Protected WithEvents lblFieldCaption As System.Web.UI.WebControls.Label
    Protected WithEvents lblFieldDescription As System.Web.UI.WebControls.Label
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents lblErrorMessage As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents ltlConfirmText As System.Web.UI.WebControls.Literal
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal
    Protected WithEvents pnlTextAreaSettings As System.Web.UI.WebControls.Panel
    Protected WithEvents lblTextAreaCols As System.Web.UI.WebControls.Label
    Protected WithEvents lblTextAreaRows As System.Web.UI.WebControls.Label
    Protected WithEvents txtTextAreaRows As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtTextAreaCols As System.Web.UI.WebControls.TextBox
    Protected WithEvents pnlHTMLAreaSettings As System.Web.UI.WebControls.Panel
    Protected WithEvents pnlDropDownListSettings As System.Web.UI.WebControls.Panel
    Protected WithEvents lblHTMLAreaWidth As System.Web.UI.WebControls.Label
    Protected WithEvents lblHTMLAreaHeight As System.Web.UI.WebControls.Label
    Protected WithEvents txtHTMLAreaWidth As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtHTMLAreaHeight As System.Web.UI.WebControls.TextBox
    Protected WithEvents radDropDownListOptions As System.Web.UI.WebControls.RadioButton
    Protected WithEvents radDropDownListSQL As System.Web.UI.WebControls.RadioButton
    Protected WithEvents txtDropDownListOptions As System.Web.UI.WebControls.TextBox
    Protected WithEvents chkCalendarSettingsEditTime As System.Web.UI.WebControls.CheckBox
    Protected WithEvents pnlCalendarSettings As System.Web.UI.WebControls.Panel
    Protected WithEvents pnlUserControlSettings As System.Web.UI.WebControls.Panel
    Protected WithEvents lblUserControlSettingsName As System.Web.UI.WebControls.Label
    Protected WithEvents txtUserControlSettingsName As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblDefaultValue As System.Web.UI.WebControls.Label
    Protected WithEvents txtDefaultValue As System.Web.UI.WebControls.TextBox

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

#Region "Public Properties"

    Public Property FormName() As String
        Get
            Return CType(viewstate("FormName"), String)
        End Get
        Set(ByVal Value As String)
            viewstate("FormName") = Value
            LoadAttributes()
            LoadSelectedField()
        End Set
    End Property

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim errorMsg As String = Functions.CheckSystemPermissions
        If errorMsg <> "" Then
            Response.Write(errorMsg)
            Response.End()
            Exit Sub
        End If

        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Read") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Read")
            Exit Sub
        End If

        Functions.RedirectExpressEdition("CMSDesk.TemplateDesigner")

        Me.lblAttributes.Text = ResMan.GetString("TemplateDesigner.Attributes")
        Me.lblProperties.Text = ResMan.GetString("TemplateDesigner.AttributeProperties")
        Me.btnDeleteAttribute.ToolTip = ResMan.GetString("TemplateDesigner.DeleteAttribute")
        Me.btnNewAttribute.ToolTip = ResMan.GetString("TemplateDesigner.NewAttribute")
        Me.btnDownAttribute.ToolTip = ResMan.GetString("TemplateDesigner.DownAttribute")
        Me.btnUpAttribute.ToolTip = ResMan.GetString("TemplateDesigner.UpAttribute")
        Me.lblAttributeName.Text = ResMan.GetString("TemplateDesigner.AttributeName")
        Me.lblAttributeSize.Text = ResMan.GetString("TemplateDesigner.AttributeSize")
        Me.lblAttributeType.Text = ResMan.GetString("TemplateDesigner.AttributeType")
        Me.lblFieldCaption.Text = ResMan.GetString("TemplateDesigner.FieldCaption")
        Me.lblFieldDescription.Text = ResMan.GetString("TemplateDesigner.FieldDescription")
        Me.lblFieldType.Text = ResMan.GetString("TemplateDesigner.FieldType")
        Me.btnOK.Text = ResMan.GetString("TemplateDesigner.OK")
        Me.lblAttributeAllowEmpty.Text = ResMan.GetString("TemplateDesigner.AttributeAllowEmpty")
        Me.lblDefaultValue.Text = ResMan.GetString("TemplateDesigner.DefaultValue")
        Me.chkDisplayInForm.Text = ResMan.GetString("TemplateDesigner.DisplayInForm")
        Me.ltlConfirmText.Text = "<span id=""confirmdelete"" style=""display:none"">" & ResMan.GetString("TemplateDesigner.ConfirmDelete") & "</span>"
        Me.btnDeleteAttribute.Attributes.Add("onclick", "javascript:return confirmDelete();")
        Me.lblTextAreaCols.Text = ResMan.GetString("TemplateDesigner.TextAreaCols")
        Me.lblTextAreaRows.Text = ResMan.GetString("TemplateDesigner.TextAreaRows")
        Me.lblHTMLAreaHeight.Text = ResMan.GetString("TemplateDesigner.HTMLAreaHeight")
        Me.lblHTMLAreaWidth.Text = ResMan.GetString("TemplateDesigner.HTMLAreaWidth")
        Me.radDropDownListOptions.Text = ResMan.GetString("TemplateDesigner.DropDownListOptions")
        Me.radDropDownListSQL.Text = ResMan.GetString("TemplateDesigner.DropDownListSQL")
        Me.chkCalendarSettingsEditTime.Text = ResMan.GetString("TemplateDesigner.CalendarSettingsEditTime")
        Me.lblUserControlSettingsName.Text = ResMan.GetString("TemplateDesigner.UserControlSettingsName")
        If Not Page.IsPostBack Then
            Me.LoadAttributeTypes()
        End If

        Me.lblInfo.Text = ""
        Me.lblErrorMessage.Text = ""
        Me.ltlScript.Text = ""
    End Sub


    Private Sub LoadAttributes()
        Dim formXML As XmlDocument
        Dim fieldNodes As XmlNodeList
        Dim fieldNode As XmlNode

        formXML = GetFormXML()
        fieldNodes = formXML.SelectNodes("/form/field")
        lstAttributes.Items.Clear()
        For Each fieldNode In fieldNodes
            lstAttributes.Items.Add(New ListItem(fieldNode.Attributes("column").Value, fieldNode.Attributes("column").Value))
        Next
        Me.lstAttributes.SelectedIndex = 0        
    End Sub


    '''<summary>Returns physical path to the form configuration path.</summary>
    Private Function GetFormFilePath() As String
        Return Functions.GetMetadataPath & "\" & Me.FormName.Split("."c)(0) & "\" & Me.FormName.Split("."c)(1) & "\Forms\" & Me.FormName.Split("."c)(2) & ".config"
    End Function


    '''<summary>Returns XML document containing the form definition.</summary>
    Private Function GetFormXML() As XmlDocument
        Dim xml As XmlDocument
        If File.Exists(Me.GetFormFilePath) Then
            xml = New XmlDocument
            xml.Load(Me.GetFormFilePath)
        End If
        If xml Is Nothing OrElse xml.SelectNodes("/form/field").Count = 0 Then
            xml = MetadataProvider.GetFormXMLFromSchema(GetClassName)
            Functions.EnsureDiskPath(Me.GetFormFilePath, Functions.GetMetadataPath)
            xml.Save(Me.GetFormFilePath)
        End If
        Return xml
    End Function


    '''<summary>Returns physical path to the class schema path.</summary>
    Private Function GetConfigPath() As String
        Return Functions.GetMetadataPath & "\" & Me.FormName.Split("."c)(0) & "\" & Me.FormName.Split("."c)(1) & "\schema.config"
    End Function


    Private Function GetClassName() As String
        Return Me.FormName.Split("."c)(0) & "." & Me.FormName.Split("."c)(1)
    End Function


    Private Sub btnUpAttribute_Click(ByVal sender As System.Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles btnUpAttribute.Click
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Modify") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Modify")
            Exit Sub
        End If

        Dim fieldColumn As String
        Dim formXML As XmlDocument
        Dim fieldNode As XmlNode
        Dim tempNode As XmlNode

        If Me.lstAttributes.SelectedValue & "" = "" OrElse Me.lstAttributes.SelectedIndex = 0 Then
            Exit Sub
        End If
        formXML = Me.GetFormXML
        fieldColumn = Me.lstAttributes.SelectedValue
        fieldNode = formXML.SelectSingleNode("/form/field[@column='" & fieldColumn & "']")
        fieldNode.ParentNode.InsertBefore(fieldNode, fieldNode.PreviousSibling)
        formXML.Save(Me.GetFormFilePath)
        LoadAttributes()
        lstAttributes.SelectedValue = fieldColumn
    End Sub


    Private Sub btnDownAttribute_Click(ByVal sender As System.Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles btnDownAttribute.Click
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Modify") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Modify")
            Exit Sub
        End If

        Dim fieldColumn As String
        Dim formXML As XmlDocument
        Dim fieldNode As XmlNode
        Dim tempNode As XmlNode

        If Me.lstAttributes.SelectedValue & "" = "" OrElse Me.lstAttributes.SelectedIndex >= Me.lstAttributes.Items.Count - 1 Then
            Exit Sub
        End If
        formXML = Me.GetFormXML
        fieldColumn = Me.lstAttributes.SelectedValue
        fieldNode = formXML.SelectSingleNode("/form/field[@column='" & fieldColumn & "']")
        fieldNode.ParentNode.InsertAfter(fieldNode, fieldNode.NextSibling)
        formXML.Save(Me.GetFormFilePath)
        LoadAttributes()
        lstAttributes.SelectedValue = fieldColumn
    End Sub


    Private Sub chkDisplayInForm_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDisplayInForm.CheckedChanged
        ShowOrHideFieldDetails()
    End Sub


    Private Sub lstAttributes_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstAttributes.SelectedIndexChanged
        Dim i As Integer
        For i = 0 To lstAttributes.Items.Count - 1
            If lstAttributes.Items(i).Value = "#new#" Then
                Me.lstAttributes().SelectedValue = "#new#"
                Me.ShowMessage(ResMan.GetString("TemplateDesigner.AlertSaveNewFieldOrDeleteItFirst"))
                EnableFieldEditing()
                Exit Sub
            End If
        Next
        LoadSelectedField()        
    End Sub


    Private Sub LoadSelectedField()
        Dim xml As XmlDocument
        Dim fieldNode As XmlNode
        xml = Me.GetFormXML
        fieldNode = xml.SelectSingleNode("/form/field[@column='" & lstAttributes.SelectedValue & "']")
        Me.txtAttributeName.Text = GetAttributeValue(fieldNode, "column")
        viewstate("originalColumn") = GetAttributeValue(fieldNode, "column")
        Me.txtAttributeSize.Text = GetAttributeValue(fieldNode, "columnsize")
        If fieldNode.Attributes("defaultvalue") Is Nothing Then
            Me.txtDefaultValue.Text = ""
        Else
            Me.txtDefaultValue.Text = fieldNode.Attributes("defaultvalue").Value
        End If
        If Me.lstAttributeType.Items.Count = 0 Then
            LoadAttributeTypes()
        End If
        Me.lstAttributeType.SelectedValue = GetAttributeValue(fieldNode, "columntype")
        Me.FillFieldTypes()
        Me.chkAllowEmpty.Checked = (GetAttributeValue(fieldNode, "allowempty") = "true")
        Me.chkDisplayInForm.Checked = (GetAttributeValue(fieldNode, "visible") = "true")
        Me.lstFieldType.SelectedValue = GetAttributeValue(fieldNode, "fieldtype")
        Me.txtDescription.Text = GetAttributeValue(fieldNode, "fielddescription")
        Me.txtFieldCaption.Text = GetAttributeValue(fieldNode, "fieldcaption")
        'set advanced options values
        Me.txtTextAreaCols.Text = ""
        Me.txtTextAreaRows.Text = ""
        Me.txtHTMLAreaHeight.Text = ""
        Me.txtHTMLAreaWidth.Text = ""
        Me.radDropDownListOptions.Checked = True
        Me.radDropDownListSQL.Checked = False
        Me.txtDropDownListOptions.Text = ""
        Me.chkCalendarSettingsEditTime.Checked = True
        Me.txtUserControlSettingsName.Text = ""
        'primary key not allowed to change
        If fieldNode.Attributes("isPK") Is Nothing Then
            EnableFieldEditing()
        Else
            DisableFieldEditing()
        End If
        'advanced options
        If Not GetAttributeValue(fieldNode, "fieldtype") Is Nothing Then
            Select Case GetAttributeValue(fieldNode, "fieldtype").ToLower
                Case "textarea"
                    If Not fieldNode.SelectSingleNode("settings/cols") Is Nothing Then
                        Me.txtTextAreaCols.Text = fieldNode.SelectSingleNode("settings/cols").InnerText
                    End If
                    If Not fieldNode.SelectSingleNode("settings/rows") Is Nothing Then
                        Me.txtTextAreaRows.Text = fieldNode.SelectSingleNode("settings/rows").InnerText
                    End If
                Case "htmlarea"
                    If Not fieldNode.SelectSingleNode("settings/width") Is Nothing Then
                        Me.txtHTMLAreaWidth.Text = fieldNode.SelectSingleNode("settings/width").InnerText
                    End If
                    If Not fieldNode.SelectSingleNode("settings/height") Is Nothing Then
                        Me.txtHTMLAreaHeight.Text = fieldNode.SelectSingleNode("settings/height").InnerText
                    End If
                Case "dropdownlist"
                    If Not fieldNode.SelectSingleNode("settings/query") Is Nothing Then
                        Me.radDropDownListSQL.Checked = True
                        Me.radDropDownListOptions.Checked = False
                        Me.txtDropDownListOptions.Text = fieldNode.SelectSingleNode("settings/query").InnerText
                    End If
                    If Not fieldNode.SelectSingleNode("settings/options") Is Nothing Then
                        Dim optionNode As XmlNode
                        For Each optionNode In fieldNode.SelectNodes("settings/options/item")
                            Me.txtDropDownListOptions.Text &= optionNode.Attributes("value").Value & ";" & optionNode.Attributes("text").Value & vbCrLf
                        Next
                    End If
                Case "calendar"
                    If Not fieldNode.SelectSingleNode("settings/editTime") Is Nothing Then
                        If fieldNode.SelectSingleNode("settings/editTime").InnerText.ToLower = "true" Then
                            Me.chkCalendarSettingsEditTime.Checked = True
                        Else
                            Me.chkCalendarSettingsEditTime.Checked = False
                        End If
                    End If
                Case "usercontrol"
                    If Not fieldNode.SelectSingleNode("settings/controlname") Is Nothing Then
                        Me.txtUserControlSettingsName.Text = fieldNode.SelectSingleNode("settings/controlname").InnerText
                    End If
            End Select
        End If
        ShowOrHideFieldDetails()
        EnableOrDisableAttributeSize()
        ShowAdvancedOptions()
    End Sub


    Private Function GetAttributeValue(ByVal node As XmlNode, ByVal attributeName As String) As String
        If node.Attributes(attributeName) Is Nothing Then
            Return Nothing
        Else
            Return node.Attributes(attributeName).Value
        End If
    End Function


    Private Sub ShowOrHideFieldDetails()
        If Me.chkDisplayInForm.Checked Then
            ShowFieldDetails()
        Else
            HideFieldDetails()
        End If
    End Sub


    Private Sub ShowFieldDetails()
        Me.pnlDisplayInForm.Enabled = True        
        Me.txtFieldCaption.ReadOnly = False
        Me.txtDescription.ReadOnly = False
        If Not Me.lstFieldType.Attributes.Item("disabled") Is Nothing Then
            Me.lstFieldType.Attributes.Remove("disabled")
        End If
    End Sub


    Private Sub HideFieldDetails()
        Me.pnlDisplayInForm.Enabled = False        
        Me.txtFieldCaption.ReadOnly = True
        Me.txtDescription.ReadOnly = True
        Me.lstFieldType.Attributes.Add("disabled", "true")
    End Sub


    '''<summary>Disables field editing controls, except field name</summary>
    Private Sub DisableFieldEditing()
        Me.txtDefaultValue.Enabled = False
        Me.lstAttributeType.Enabled = False
        Me.chkAllowEmpty.Enabled = False
    End Sub


    '''<summary>Enables field editing controls, except field name</summary>
    Private Sub EnableFieldEditing()
        Me.txtDefaultValue.Enabled = True
        Me.lstAttributeType.Enabled = True
        Me.chkAllowEmpty.Enabled = True
    End Sub


    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Modify") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Modify")
            Exit Sub
        End If

        'validate
        Dim i As Integer
        Const INVALIDCHARACTERS As String = ".,;'`:/\*|?""&%$!-+=()[]{} "

        Dim errorMessage As String = ""
        txtAttributeName.Text = txtAttributeName.Text.Trim
        'check if attribute name isn't empty
        If txtAttributeName.Text = "" Then
            errorMessage &= ResMan.GetString("TemplateDesigner.ErrorEmptyAttributeName") & " "
        End If
        'check if attribute name starts with a letter
        If txtAttributeName.Text <> "" AndAlso Not Char.IsLetter(CType(txtAttributeName.Text.Substring(0, 1), Char)) Then
            errorMessage &= ResMan.GetString("TemplateDesigner.ErrorAttributeNameDoesNotStartWithLetter") & " "
        End If
        'chekc attribute size value
        If lstAttributeType.SelectedValue.ToLower = "text" Then
            If txtAttributeSize.Text = "" Then
                errorMessage &= ResMan.GetString("TemplateDesigner.ErrorEmptyAttributeSize") & " "
            Else
                Try
                    If Integer.Parse(txtAttributeSize.Text) <= 0 Then
                        Throw New Exception("")
                    End If
                Catch ex As Exception
                    errorMessage &= ResMan.GetString("TemplateDesigner.ErrorInvalidAttributeSize") & " "
                End Try
            End If
        End If
        'check if field caption is entered
        If Me.chkDisplayInForm.Checked Then
            If Me.txtFieldCaption.Text.Trim = "" Then
                errorMessage &= ResMan.GetString("TemplateDesigner.ErrorEmptyFieldCaption") & " "
            End If
        End If
        'check check attribute name for invalid characters
        For i = 0 To INVALIDCHARACTERS.Length - 1
            If InStr(txtAttributeName.Text, "" & INVALIDCHARACTERS.Chars(i)) > 0 Then
                errorMessage &= ResMan.GetString("TemplateDesigner.ErrorInvalidCharacter") & INVALIDCHARACTERS & "."
            End If
        Next

        If errorMessage <> "" Then
            lblErrorMessage.Text = errorMessage
        Else
            lblErrorMessage.Text = ""
            SaveSelectedField()
        End If
    End Sub


    Private Sub SaveSelectedField()
        Dim xml As XmlDocument = Me.GetFormXML
        Dim fieldnode As XmlNode
        Dim errorMessage As String

        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Modify") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Modify")
            Exit Sub
        End If


        'ensure uniqueness
        If CType(viewstate("originalColumn"), String) <> Me.txtAttributeName.Text Then
            If Not xml.SelectSingleNode("/form/field[@column='" & Me.txtAttributeName.Text & "']") Is Nothing Then
                Me.lblErrorMessage.Text = ResMan.GetString("TemplateDesigner.ErrorExistingColumnName")
                Exit Sub
            End If
        End If
        If CType(viewstate("originalColumn"), String) = "" Then
            'new node
            fieldnode = xml.CreateNode(XmlNodeType.Element, "", "field", "")
            xml.DocumentElement.AppendChild(fieldnode)
            errorMessage = ""
            errorMessage &= ValidateAdvancedOptions()
            If errorMessage = "" Then
                Dim defValue As String
                'Implicit default value
                If Not Me.chkAllowEmpty.Checked And Me.txtDefaultValue.Text.Trim() = "" Then
                    Select Case Me.lstAttributeType.SelectedValue
                        Case "integer", "double", "boolean"
                            Me.txtDefaultValue.Text = "0"
                        Case "datetime"
                            Me.txtDefaultValue.Text = Now.Date.ToString()
                    End Select
                End If
                If Not Me.chkAllowEmpty.Checked Then
                    defValue = Me.txtDefaultValue.Text
                End If
                If Me.txtDefaultValue.Text <> "" Then
                    defValue = Me.txtDefaultValue.Text
                End If
                'Check if default value is in required format
                If Not defValue Is Nothing AndAlso defvalue <> "" Then
                    Select Case Me.lstAttributeType.SelectedValue
                        Case "integer"
                            Try
                                Dim i As Integer = Integer.Parse(defValue)
                                defValue = i.ToString()
                            Catch
                                defValue = "0"
                                errorMessage = ResMan.GetString("TemplateDesigner.ErrorDefaultValueInteger")
                            End Try
                        Case "double"
                            Try
                                Dim d As Double = Double.Parse(defValue)
                                defValue = d.ToString()
                            Catch
                                defValue = "0"
                                errorMessage = ResMan.GetString("TemplateDesigner.ErrorDefaultValueDouble")
                            End Try
                        Case "boolean"
                            Try
                                Dim b As Integer = CType(defValue, Integer)
                                If b = 0 Then
                                    defValue = "0"
                                ElseIf b = 1 Then
                                    defValue = "1"
                                Else
                                    defValue = "0"
                                    errorMessage = ResMan.GetString("TemplateDesigner.ErrorDefaultValueBoolean")
                                End If
                            Catch
                                defValue = "0"
                                errorMessage = ResMan.GetString("TemplateDesigner.ErrorDefaultValueBoolean")
                            End Try
                        Case "datetime"
                            Try
                                Dim dat As DateTime = DateTime.Parse(defValue)
                                defValue = dat.ToString()
                            Catch
                                defValue = "12:00:00"
                                errorMessage = ResMan.GetString("TemplateDesigner.ErrorDefaultValueDateTime")
                            End Try
                    End Select
                End If
                errorMessage &= AlterTableColumn(Me.txtAttributeName.Text, Me.lstAttributeType.SelectedValue, Me.txtAttributeSize.Text, Me.chkAllowEmpty.Checked, True, defValue)
            End If
            If errorMessage <> "" Then
                lblErrorMessage.Text = errorMessage
                Exit Sub
            End If
        Else
            'existing node
            fieldnode = xml.SelectSingleNode("/form/field[@column='" & CType(viewstate("originalColumn"), String) & "']")
            If (Not fieldnode.Attributes("isPK") Is Nothing) AndAlso fieldnode.Attributes("isPK").Value = "true" Then
                'it's Primary Key
                'check if the attribute type is integer number
                If Not Me.lstAttributeType.SelectedValue = "integer" Then
                    errorMessage &= ResMan.GetString("TemplateDesigner.ErrorPKNotInteger")
                End If
                'check if allow empty is disabled
                If Me.chkAllowEmpty.Checked Then
                    errorMessage &= ResMan.GetString("TemplateDesigner.ErrorPKAllowsNulls")
                End If
                'check that the field type is label
                If Not Me.lstFieldType.SelectedValue = "label" Then
                    errorMessage &= ResMan.GetString("TemplateDesigner.ErrorPKisNotLabel")
                End If
                If errorMessage <> "" Then
                    lblErrorMessage.Text = ResMan.GetString("TemplateDesigner.ErrorPKThisIsPK") & errorMessage
                    Exit Sub
                End If
            End If
            'modify table structure if necessary
            errorMessage &= ValidateAdvancedOptions()
            If errorMessage <> "" Then
                lblErrorMessage.Text = errorMessage
                Exit Sub
            End If
            If fieldnode.Attributes("column").Value <> Me.txtAttributeName.Text Then
                'rename column first, if necessary
                errorMessage = Me.AlterTableRenameColumn(CType(viewstate("originalColumn"), String), Me.txtAttributeName.Text)
            End If
            Dim defValue As String
            If (fieldnode.Attributes("isPK") Is Nothing) AndAlso (fieldnode.Attributes("columntype").Value <> Me.lstAttributeType.SelectedValue Or (fieldnode.Attributes("allowempty").Value = "true" And Not Me.chkAllowEmpty.Checked) Or (fieldnode.Attributes("allowempty").Value = "false" And Me.chkAllowEmpty.Checked) Or (fieldnode.Attributes("columnsize").Value.Trim <> Me.txtAttributeSize.Text.Trim) Or (fieldnode.Attributes("defaultvalue") Is Nothing OrElse fieldnode.Attributes("defaultvalue").Value <> Me.txtDefaultValue.Text)) Then
                'Implicit default value
                If Not Me.chkAllowEmpty.Checked And Me.txtDefaultValue.Text.Trim() = "" Then
                    Select Case Me.lstAttributeType.SelectedValue
                        Case "integer", "double", "boolean"
                            Me.txtDefaultValue.Text = "0"
                        Case "datetime"
                            Me.txtDefaultValue.Text = Now.Date.ToString()
                    End Select
                End If
                If Not Me.chkAllowEmpty.Checked Then
                    defValue = Me.txtDefaultValue.Text
                End If
                If Me.txtDefaultValue.Text <> "" Then
                    defValue = Me.txtDefaultValue.Text
                End If
                'Check if default value is in required format
                If Not defValue Is Nothing AndAlso defvalue <> "" Then
                    Select Case Me.lstAttributeType.SelectedValue
                        Case "integer"
                            Try
                                Dim i As Integer = Integer.Parse(defValue)
                                defValue = i.ToString()
                            Catch
                                defValue = "0"
                                errorMessage = ResMan.GetString("TemplateDesigner.ErrorDefaultValueInteger")
                            End Try
                        Case "double"
                            Try
                                Dim d As Double = Double.Parse(defValue)
                                defValue = d.ToString()
                            Catch
                                defValue = "0"
                                errorMessage = ResMan.GetString("TemplateDesigner.ErrorDefaultValueDouble")
                            End Try
                        Case "boolean"
                            Try
                                Dim b As Integer = CType(defValue, Integer)
                                If b = 0 Then
                                    defValue = "0"
                                ElseIf b = 1 Then
                                    defValue = "1"
                                Else
                                    defValue = "0"
                                    errorMessage = ResMan.GetString("TemplateDesigner.ErrorDefaultValueBoolean")
                                End If
                            Catch
                                defValue = "0"
                                errorMessage = ResMan.GetString("TemplateDesigner.ErrorDefaultValueBoolean")
                            End Try
                        Case "datetime"
                            Try
                                Dim dat As DateTime = DateTime.Parse(defValue)
                                defValue = dat.ToString()
                            Catch
                                defValue = "12:00:00"
                                errorMessage = ResMan.GetString("TemplateDesigner.ErrorDefaultValueDateTime")
                            End Try
                    End Select
                End If
                If errorMessage = "" Then
                    errorMessage = AlterTableColumn(Me.txtAttributeName.Text, Me.lstAttributeType.SelectedValue, Me.txtAttributeSize.Text, Me.chkAllowEmpty.Checked, False, defValue)
                End If
            End If
            If errorMessage <> "" Then
                lblErrorMessage.Text = ResMan.GetString("TemplateDesigner.ErrorDatabaseStructure") & " " & errorMessage
                Exit Sub
            End If
        End If
        'update form xml
        SetAttribute(xml, fieldnode, "column", Me.txtAttributeName.Text.Trim)
        SetAttribute(xml, fieldnode, "columntype", Me.lstAttributeType.SelectedValue)
        SetAttribute(xml, fieldnode, "columnsize", Me.txtAttributeSize.Text.Trim)
        If Me.chkAllowEmpty.Checked Then
            SetAttribute(xml, fieldnode, "allowempty", "true")
        Else
            SetAttribute(xml, fieldnode, "allowempty", "false")
        End If
        SetAttribute(xml, fieldnode, "defaultvalue", Me.txtDefaultValue.Text)
        If Me.chkDisplayInForm.Checked Then
            SetAttribute(xml, fieldnode, "visible", "true")
            SetAttribute(xml, fieldnode, "fieldcaption", Me.txtFieldCaption.Text.Trim)
            SetAttribute(xml, fieldnode, "fieldtype", Me.lstFieldType.SelectedValue)
            SetAttribute(xml, fieldnode, "fielddescription", Me.txtDescription.Text.Trim)
            Dim xmlSettings As XmlNode = xml.CreateNode(XmlNodeType.Element, "", "settings", "")

            Select Case Me.lstFieldType.SelectedValue.ToLower
                Case "textarea"
                    xmlSettings.InnerXml = "<cols>" & Me.txtTextAreaCols.Text & "</cols><rows>" & Me.txtTextAreaRows.Text & "</rows>"
                Case "htmlarea"
                    xmlSettings.InnerXml = "<width>" & Me.txtHTMLAreaWidth.Text & "</width><height>" & Me.txtHTMLAreaHeight.Text & "</height>"
                Case "dropdownlist"
                    If radDropDownListSQL.Checked Then
                        'save query
                        Dim queryNode As XmlNode = xml.CreateNode(XmlNodeType.Element, "", "query", "")
                        queryNode.InnerText = Me.txtDropDownListOptions.Text
                        xmlSettings.AppendChild(queryNode)
                    Else
                        'save options
                        Dim optionsNode As XmlNode = xml.CreateNode(XmlNodeType.Element, "", "options", "")
                        Dim itemNode As XmlNode
                        xmlSettings.AppendChild(optionsNode)
                        Dim lines() As String = Split(Me.txtDropDownListOptions.Text, vbCrLf)
                        Dim lineIndex As Integer
                        Dim line As String
                        For lineIndex = 0 To lines.GetUpperBound(0)
                            line = lines(lineIndex)
                            itemNode = xml.CreateNode(XmlNodeType.Element, "", "item", "")
                            itemNode.Attributes.Append(xml.CreateAttribute("", "value", ""))
                            itemNode.Attributes.Append(xml.CreateAttribute("", "text", ""))
                            If line.IndexOf(";") > 0 Then
                                itemNode.Attributes("value").Value = line.Substring(0, line.IndexOf(";"))
                            End If
                            If line.IndexOf(";") < line.Length - 1 Then
                                itemNode.Attributes("text").Value = line.Substring(line.IndexOf(";") + 1)
                            End If
                            If itemNode.Attributes("value").Value.Trim & itemNode.Attributes("text").Value.Trim <> "" Then
                                optionsNode.AppendChild(itemNode)
                            End If
                        Next
                    End If
                Case "calendar"
                    If Me.chkCalendarSettingsEditTime.Checked Then
                        xmlSettings.InnerXml = "<editTime>true</editTime>"
                    Else
                        xmlSettings.InnerXml = "<editTime>false</editTime>"
                    End If
                Case "usercontrol"
                    Dim usercontrolNode As XmlNode = xml.CreateNode(XmlNodeType.Element, "", "controlname", "")
                    usercontrolNode.InnerText = Me.txtUserControlSettingsName.Text
                    xmlSettings.AppendChild(usercontrolNode)
            End Select

            If Not fieldnode.SelectSingleNode("settings") Is Nothing Then
                fieldnode.RemoveChild(fieldnode.SelectSingleNode("settings"))
            End If
            fieldnode.AppendChild(xmlSettings)
        Else
            SetAttribute(xml, fieldnode, "visible", "false")
        End If
        xml.Save(Me.GetFormFilePath)
        Me.LoadAttributes()
        lstAttributes.SelectedValue = fieldnode.Attributes("column").Value
        Me.lblInfo.Text = ResMan.GetString("TemplateDesigner.InfoChangesSaved")
        viewstate("originalColumn") = Me.txtAttributeName.Text
    End Sub


    Private Sub SetAttribute(ByVal xml As XmlDocument, ByVal fieldNode As XmlNode, ByVal attributeName As String, ByVal value As String)
        If fieldNode.Attributes(attributeName) Is Nothing Then
            fieldNode.Attributes.Append(xml.CreateAttribute("", attributeName, ""))
        End If
        fieldNode.Attributes(attributeName).Value = value
    End Sub


    Private Sub lstAttributeType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstAttributeType.SelectedIndexChanged
        EnableOrDisableAttributeSize()
        FillFieldTypes()
        ShowAdvancedOptions()
    End Sub


    Private Sub EnableOrDisableAttributeSize()
        If lstAttributeType.SelectedValue = "text" Then
            Me.txtAttributeSize.Enabled = True
            Me.lblAttributeSize.Enabled = True
        Else
            Me.txtAttributeSize.Enabled = False
            Me.lblAttributeSize.Enabled = False
            Me.txtAttributeSize.Text = ""
        End If
    End Sub


    Private Sub btnNewAttribute_Click(ByVal sender As System.Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles btnNewAttribute.Click
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Modify") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Modify")
            Exit Sub
        End If

        'first check if there isn't any new column in the listbox
        Dim newListItem As ListItem
        Dim i As Integer
        For i = 0 To lstAttributes.Items.Count - 1
            If lstAttributes.Items(i).Value = "#new#" Then
                ShowMessage(ResMan.GetString("TemplateDesigner.ErrorCannotCreateAnotherNewAttribute"))
                Exit Sub
            End If
        Next
        newListItem = New ListItem(ResMan.GetString("TemplateDesigner.NewAttribute"), "#new#")
        Me.lstAttributes.Items.Add(newListItem)
        Me.lstAttributes.SelectedIndex = Me.lstAttributes.Items.Count - 1
        EnableFieldEditing()
        Me.txtAttributeName.Text = ""
        Me.txtAttributeSize.Text = ""
        Me.txtDefaultValue.Text = ""
        Me.chkAllowEmpty.Checked = True
        Me.chkDisplayInForm.Checked = True
        Me.txtFieldCaption.Text = ""
        Me.txtDescription.Text = ""
        Me.lstAttributeType.SelectedIndex = 0
        Me.lstFieldType.SelectedIndex = 0
        viewstate("originalColumn") = ""
        Me.FillFieldTypes()
        Me.ShowFieldDetails()
        EnableOrDisableAttributeSize()
        ShowAdvancedOptions()
    End Sub


    Private Sub btnDeleteAttribute_Click(ByVal sender As System.Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles btnDeleteAttribute.Click
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Modify") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Modify")
            Exit Sub
        End If

        Dim xml As XmlDocument
        Dim node As XmlNode
        'check if it's a new attribute that is not yet saved
        If Me.lstAttributes.SelectedValue <> "#new#" Then
            'get node representing the attribute
            xml = Me.GetFormXML
            node = xml.SelectSingleNode("/form/field[@column='" & Me.lstAttributes.SelectedValue & "']")
            'do now allow deleting of the primary key
            If (Not node.Attributes("isPK") Is Nothing) AndAlso node.Attributes("isPK").Value.ToLower = "true" Then
                Me.lblErrorMessage.Text = ResMan.GetString("TemplateDesigner.ErrorCannotDeletePK")
                Exit Sub
            End If
            xml.DocumentElement.RemoveChild(node)
            xml.Save(Me.GetFormFilePath)
            Me.AlterTableDropColumn(Me.lstAttributes.SelectedValue)
        End If
        'set new selected attribute
        If Me.lstAttributes.SelectedIndex > 0 Then
            Me.lstAttributes.SelectedIndex -= 1
        End If
        'reload data
        Me.LoadAttributes()
        Me.LoadSelectedField()
    End Sub


    Private Function AlterTableColumn(ByVal columnName As String, ByVal columnType As String, ByVal columnSize As String, ByVal allowNulls As Boolean, ByVal newColumn As Boolean, ByVal columnDefaultValue As String) As String
        Dim tableName As String
        Dim query As String
        Dim tree As TreeProvider = Functions.GetTreeProvider
        Dim defaultValue As String

        tableName = Me.GetTableName
        If tableName = "" Then
            Return ResMan.GetString("TemplateDesigner.ErrorTableNameNotSet")
        End If
        query = "ALTER TABLE [" & tableName & "] "
        If newColumn Then
            query &= " ADD "
        Else
            query &= " ALTER COLUMN "
        End If
        query &= " [" & columnName & "] "
        Dim coltype As String
        Select Case columnType
            Case "integer"
                coltype = " int "
            Case "double"
                coltype = " float "
            Case "boolean"
                coltype = " bit "
            Case "datetime"
                coltype = " datetime "
            Case "longtext"
                coltype = " ntext "
            Case Else
                coltype = " nvarchar(" & columnSize & ") "
        End Select
        query &= coltype
        'drop previous default constraint
        If Not newColumn Then
            Try
                tree.Connection.DataConnection.ExecuteQuery("ALTER TABLE [" & tableName & "] DROP constraint [DEFAULT_" & tableName & "_" & columnName & "] ", Nothing, MetadataQueryTypeEnum.SQLQuery)
            Catch ex As Exception
            End Try
        End If
        'set default value query part
        Select Case columnType
            Case "integer", "double", "boolean"
                'when default value necessary and not given, for number types default 0
                If columnDefaultValue Is Nothing Then
                    If Not allowNulls Then
                        defaultValue = " DEFAULT 0 "
                    End If
                Else
                    If columnDefaultValue.Trim() = "" Then
                        If Not allowNulls Then
                            defaultValue = " DEFAULT 0 "
                        End If
                    Else
                        defaultValue = " DEFAULT " & columnDefaultValue.Replace("'", "''") & " "
                    End If
                End If
            Case "datetime"
                'when default value necessary and not given, for date types default 12:00:00
                If columnDefaultValue Is Nothing Then
                    If Not allowNulls Then
                        defaultValue = " DEFAULT '12:00:00' "
                    End If
                Else
                    If columnDefaultValue.Trim() = "" Then
                        If Not allowNulls Then
                            defaultValue = " DEFAULT '12:00:00' "
                        End If
                    Else
                        defaultValue = " DEFAULT '" & columnDefaultValue.Replace("'", "''") & "' "
                    End If
                End If
            Case Else
                'when default value necessary and not given, for other types default ''
                If columnDefaultValue Is Nothing Then
                    If Not allowNulls Then
                        defaultValue = " DEFAULT '' "
                    End If
                Else
                    If Not allowNulls Or columnDefaultValue <> "" Then
                        defaultValue = " DEFAULT '" & columnDefaultValue.Replace("'", "''") & "' "
                    End If
                End If
        End Select
        If allowNulls Then
            query &= " NULL "
        Else
            If newColumn And Not defaultValue Is Nothing Then
                'newColumn cannot be created with NOT NULL and without DEFAULT specified, thus it must be created as normal one first and after the creation of the default constraint changed to NOT NULL
            Else
                query &= " NOT NULL "
            End If
        End If
        'Alter the table column
        Try
            tree.Connection.DataConnection.ExecuteQuery(query, Nothing, MetadataQueryTypeEnum.SQLQuery)
            SaveXMLSchema()
        Catch ex As Exception
            Return ex.Message
        End Try
        'when default value clause specified, add constraint
        If Not defaultValue Is Nothing Then
            'then add new
            Try
                tree.Connection.DataConnection.ExecuteQuery("ALTER TABLE [" & tableName & "] ADD constraint [DEFAULT_" & tableName & "_" & columnName & "] " & defaultValue & " for [" & columnName & "] ", Nothing, MetadataQueryTypeEnum.SQLQuery)
            Catch ex As Exception
            End Try
            'Alter the table column to NOT NULL if necessary
            If Not allowNulls And newColumn Then
                query = "ALTER TABLE [" & tableName & "] ALTER COLUMN [" & columnName & "] " & coltype & " NOT NULL"
                Try
                    tree.Connection.DataConnection.ExecuteQuery(query, Nothing, MetadataQueryTypeEnum.SQLQuery)
                Catch ex As Exception
                    Return ex.Message
                End Try
            End If
        End If
        Return ""
    End Function


    Private Function AlterTableRenameColumn(ByVal oldName As String, ByVal newName As String) As String
        Dim tableName As String
        Dim query As String
        Dim tree As TreeProvider = Functions.GetTreeProvider

        tableName = Me.GetTableName
        If tableName = "" Then
            Return ResMan.GetString("TemplateDesigner.ErrorTableNameNotSet")
        End If
        'Drop default constraint if exists
        Try
            tree.Connection.DataConnection.ExecuteQuery("ALTER TABLE [" & tableName & "] DROP constraint [DEFAULT_" & tableName & "_" & oldName & "] ", Nothing, MetadataQueryTypeEnum.SQLQuery)
        Catch ex As Exception
        End Try
        query = "EXEC sp_rename '[" & tableName & "].[" & oldName & "]', '" & newName & "', 'COLUMN'"
        Try
            tree.Connection.DataConnection.ExecuteQuery(query, Nothing, MetadataQueryTypeEnum.SQLQuery)
            SaveXMLSchema()
        Catch ex As Exception
            Return ex.Message
        End Try
        Return ""
    End Function


    Private Function AlterTableDropColumn(ByVal columnName As String) As String
        Dim tableName As String
        Dim query As String
        Dim tree As TreeProvider = Functions.GetTreeProvider

        tableName = Me.GetTableName
        If tableName = "" Then
            Return ResMan.GetString("TemplateDesigner.ErrorTableNameNotSet")
        End If
        'remove default constraint
        query = "ALTER TABLE [" & tableName & "] DROP CONSTRAINT [DEFAULT_" & tableName & "_" & columnName & "] "
        Try
            tree.Connection.DataConnection.ExecuteQuery(query, Nothing, MetadataQueryTypeEnum.SQLQuery)
            SaveXMLSchema()
        Catch
        End Try
        'delete column
        query = "ALTER TABLE [" & tableName & "] DROP COLUMN [" & columnName & "]"
        Try
            tree.Connection.DataConnection.ExecuteQuery(query, Nothing, MetadataQueryTypeEnum.SQLQuery)
            SaveXMLSchema()
        Catch ex As Exception
            Return ex.Message
        End Try
        Return ""
    End Function


    Private Sub SaveXMLSchema()
        Dim tableName As String
        Dim className As String

        tableName = GetTableName()
        className = GetClassName()
        'get XML Schema
        Dim cn As New SqlConnection(Functions.GetConnectionString)
        Dim da As New SqlDataAdapter("select top 1 * from " & tableName & " order by 1 ", cn)
        Dim ds As New DataSet
        da.FillSchema(ds, SchemaType.Mapped, className)
        'save XML Schema
        MetadataProvider.SetXMLSchema(className, Replace(ds.GetXmlSchema & "", "utf-16", "utf-8"))

        'generate and save basic queries
        Dim query As MetadataQuery
        query = QueryGenerator.GetQuery(className, BasicQueriesEnum.SelectQuery)
        MetadataProvider.SetQuery(className & ".select", query)
        query = QueryGenerator.GetQuery(className, BasicQueriesEnum.InsertQuery)
        MetadataProvider.SetQuery(className & ".insert", query)
        query = QueryGenerator.GetQuery(className, BasicQueriesEnum.UpdateQuery)
        MetadataProvider.SetQuery(className & ".update", query)
        query = QueryGenerator.GetQuery(className, BasicQueriesEnum.DeleteQuery)
        MetadataProvider.SetQuery(className & ".delete", query)
        query = QueryGenerator.GetQuery(className, BasicQueriesEnum.SelectByPathQuery)
        MetadataProvider.SetQuery(className & ".selectbypath", query)
        query = QueryGenerator.GetQuery(className, BasicQueriesEnum.SearchTreeQuery)
        MetadataProvider.SetQuery(className & ".searchtree", query)
    End Sub


    Private Function GetTableName() As String
        Return MetadataProvider.GetSettingsValue(GetClassName, "tablename")
    End Function


    Private Sub FillFieldTypes()
        Me.lstFieldType.Items.Clear()
        Me.lstFieldType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.FieldTypes.Label"), "label"))
        Select Case Me.lstAttributeType.SelectedValue
            Case "text"
                Me.lstFieldType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.FieldTypes.TextBox"), "textbox"))
                Me.lstFieldType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.FieldTypes.DropDownList"), "dropdownlist"))
                Me.lstFieldType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.FieldTypes.ImagePath"), "imagepath"))
                Me.lstFieldType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.FieldTypes.FilePath"), "filepath"))
                Me.lstFieldType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.FieldTypes.UserControl"), "usercontrol"))
                Me.lstFieldType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.FieldTypes.Upload"), "upload"))
            Case "longtext"
                Me.lstFieldType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.FieldTypes.TextArea"), "textarea"))
                Me.lstFieldType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.FieldTypes.HTMLArea"), "htmlarea"))
                Me.lstFieldType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.FieldTypes.UserControl"), "usercontrol"))
            Case "integer"
                Me.lstFieldType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.FieldTypes.TextBox"), "textbox"))
                Me.lstFieldType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.FieldTypes.DropDownList"), "dropdownlist"))
                Me.lstFieldType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.FieldTypes.UserControl"), "usercontrol"))
            Case "double"
                Me.lstFieldType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.FieldTypes.TextBox"), "textbox"))
                Me.lstFieldType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.FieldTypes.DropDownList"), "dropdownlist"))
                Me.lstFieldType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.FieldTypes.UserControl"), "usercontrol"))
            Case "datetime"
                Me.lstFieldType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.FieldTypes.Calendar"), "calendar"))
                Me.lstFieldType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.FieldTypes.DropDownList"), "dropdownlist"))
                Me.lstFieldType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.FieldTypes.UserControl"), "usercontrol"))
            Case "boolean"
                Me.lstFieldType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.FieldTypes.CheckBox"), "checkbox"))
                Me.lstFieldType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.FieldTypes.DropDownList"), "dropdownlist"))
                Me.lstFieldType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.FieldTypes.UserControl"), "usercontrol"))
        End Select
    End Sub


    Private Sub ShowMessage(ByVal message As String)
        Me.ltlScript.Text = "<script language=""javascript"">" & _
                            " alert('" & Replace(message, "'", "\'") & "'); " & _
                            "</script>"
    End Sub


    Private Sub lstFieldType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstFieldType.SelectedIndexChanged
        ShowAdvancedOptions()
    End Sub


    Private Sub ShowAdvancedOptions()
        Me.pnlCalendarSettings.Visible = False
        Me.pnlDropDownListSettings.Visible = False
        Me.pnlHTMLAreaSettings.Visible = False
        Me.pnlTextAreaSettings.Visible = False
        Me.pnlUserControlSettings.Visible = False

        Select Case Me.lstFieldType.SelectedValue.ToLower
            Case "textarea"
                Me.pnlTextAreaSettings.Visible = True
            Case "htmlarea"
                Me.pnlHTMLAreaSettings.Visible = True
            Case "dropdownlist"
                Me.pnlDropDownListSettings.Visible = True
            Case "calendar"
                Me.pnlCalendarSettings.Visible = True
            Case "usercontrol"
                Me.pnlUserControlSettings.Visible = True
        End Select
    End Sub


    Private Function ValidateAdvancedOptions() As String
        Dim errorMessage As String

        Select Case Me.lstFieldType.SelectedValue.ToLower
            Case "textarea"
                'check cols and rows values
                If txtTextAreaCols.Text.Trim <> "" AndAlso Not (IsNumeric(txtTextAreaCols.Text)) Then
                    errorMessage &= ResMan.GetString("TemplateDesigner.ErrorTextAreaColsNotNumber")
                End If
                If txtTextAreaRows.Text.Trim <> "" AndAlso Not (IsNumeric(txtTextAreaRows.Text)) Then
                    errorMessage &= ResMan.GetString("TemplateDesigner.ErrorTextAreaRowsNotNumber")
                End If
            Case "htmlarea"
                'check width and height values
                If txtHTMLAreaHeight.Text.Trim <> "" AndAlso Not (IsNumeric(txtHTMLAreaHeight.Text)) Then
                    errorMessage &= ResMan.GetString("TemplateDesigner.ErrorHTMLAreaHeightNotNumber")
                End If
                If txtHTMLAreaWidth.Text.Trim <> "" AndAlso Not (IsNumeric(txtHTMLAreaWidth.Text)) Then
                    errorMessage &= ResMan.GetString("TemplateDesigner.ErrorHTMLAreaWidthNotNumber")
                End If
            Case "dropdownlist"
                'check options or sql query
                If radDropDownListSQL.Checked AndAlso Me.txtDropDownListOptions.Text.Trim = "" Then
                    errorMessage &= ResMan.GetString("TemplateDesigner.ErrorDropDownListQueryEmpty")
                End If
                If Me.radDropDownListOptions.Checked Then
                    If Me.txtDropDownListOptions.Text.Trim = "" Then
                        errorMessage &= ResMan.GetString("TemplateDesigner.ErrorDropDownListOptionsEmpty")
                    Else
                        Dim line As String
                        Dim lineIndex As Integer
                        Dim lines() As String = Me.txtDropDownListOptions.Text.Split(Chr(10))
                        For lineIndex = 0 To lines.GetUpperBound(0)
                            If Trim(lines(lineIndex) & "") <> "" AndAlso InStr(lines(lineIndex), ".") > 0 Then
                                errorMessage &= ResMan.GetString("TemplateDesigner.ErrorDropDownListOptionsInvalidFormat")
                            End If
                        Next
                    End If
                End If
                Me.pnlDropDownListSettings.Visible = True
            Case "calendar"
                'do nothing
            Case "usercontrol"
                If Me.txtUserControlSettingsName.Text.Trim = "" Then
                    errorMessage &= ResMan.GetString("TemplateDesigner.ErrorUserControlNameEmpty")
                End If
        End Select
        Return errorMessage
    End Function


    Private Sub LoadAttributeTypes()
        If Me.lstAttributeType.Items.Count > 0 Then
            Exit Sub
        End If
        'fill list
        Me.lstAttributeType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.AttributTypes.Text"), "text"))
        Me.lstAttributeType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.AttributTypes.LongText"), "longtext"))
        Me.lstAttributeType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.AttributTypes.Integer"), "integer"))
        Me.lstAttributeType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.AttributTypes.Double"), "double"))
        Me.lstAttributeType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.AttributTypes.DateAndTime"), "datetime"))
        Me.lstAttributeType.Items.Add(New ListItem(ResMan.GetString("TemplateDesigner.AttributTypes.Boolean"), "boolean"))
    End Sub

End Class
