Public Class TemplateWizard
    Inherits System.Web.UI.Page

    Protected WithEvents TemplateWizard_Names1 As TemplateWizard_Names
    Protected WithEvents TemplateWizard_Attributes1 As TemplateWizard_Attributes
    Protected WithEvents TemplateWizard_ParentTemplates1 As TemplateWizard_ParentTemplates
    Protected WithEvents TemplateWizard_Table1 As TemplateWizard_Table
    Protected WithEvents TemplateWizard_Finished1 As TemplateWizard_Finished
    Protected WithEvents lblErrorPermissions As System.Web.UI.WebControls.Label
    Protected WithEvents TemplateWizard_NodeName1 As TemplateWizard_NodeName

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents btnNext As System.Web.UI.WebControls.Button
    Protected WithEvents lblStepHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblStepDescription As System.Web.UI.WebControls.Label

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Create") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Create")
            Exit Sub
        End If

        Functions.RedirectExpressEdition("CMSDesk.TemplateWizard")

        If Not Page.IsPostBack Then
            Me.lblHeader.Text = ResMan.GetString("TemplateWizard.Header")
            Me.btnNext.Text = ResMan.GetString("TemplateWizard.Next")

            Dim errorMsg As String = Functions.CheckSystemPermissions
            If errorMsg <> "" Then
                lblErrorPermissions.Visible = True
                lblErrorPermissions.Text = errorMsg
                Me.btnNext.Enabled = False
            Else
                CurrentStep = 1
                ShowStep(1)
            End If
        End If
    End Sub


    Private Sub ShowStep(ByVal stepNumber As Integer)
        TemplateWizard_Names1.Visible = False
        TemplateWizard_Attributes1.Visible = False
        TemplateWizard_ParentTemplates1.Visible = False
        TemplateWizard_Table1.Visible = False
        TemplateWizard_Finished1.Visible = False
        TemplateWizard_NodeName1.Visible = False

        Select Case stepNumber
            Case 1
                TemplateWizard_Names1.Visible = True
            Case 2
                TemplateWizard_Table1.Visible = True
            Case 3
                TemplateWizard_Attributes1.Visible = True
            Case 4
                Me.TemplateWizard_NodeName1.Visible = True
            Case 5
                TemplateWizard_ParentTemplates1.Visible = True
            Case 6
                TemplateWizard_Finished1.Visible = True
                Me.btnNext.Enabled = False
        End Select

        Me.lblStepHeader.Text = GetCurrentStepControl.GetStepHeader
        Me.lblStepDescription.Text = GetCurrentStepControl.GetStepDescription
    End Sub


    Public Property CurrentStep() As Integer
        Get
            Return CType(viewstate("CurrentStep"), Integer)
        End Get
        Set(ByVal Value As Integer)
            viewstate("CurrentStep") = Value
        End Set
    End Property


    Private Function GetCurrentStepControl() As ITemplateWizardStep
        Select Case CurrentStep
            Case 1
                Return TemplateWizard_Names1
            Case 2
                Return TemplateWizard_Table1
            Case 3
                Return TemplateWizard_Attributes1
            Case 4
                Return TemplateWizard_NodeName1
            Case 5
                Return TemplateWizard_ParentTemplates1
            Case 6
                Return TemplateWizard_Finished1
            Case Else
                Return TemplateWizard_Names1
        End Select
    End Function


    Private Sub btnNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNext.Click
        If GetCurrentStepControl.IsValid And CurrentStep < 6 Then
            If CurrentStep = 1 Then
                Me.ClassName = Me.TemplateWizard_Names1.ClassName
                Me.ClassID = Me.TemplateWizard_Names1.ClassID
                TemplateWizard_Table1.ClassID = Me.ClassID
                TemplateWizard_Table1.ClassName = Me.ClassName
                TemplateWizard_ParentTemplates1.ClassID = Me.ClassID
                TemplateWizard_NodeName1.ClassName = Me.ClassName
            End If
            If CurrentStep = 2 Then
                Me.TemplateWizard_Attributes1.ClassName = Me.ClassName
            End If
            If CurrentStep = 3 Then
                Me.TemplateWizard_NodeName1.LoadFields()
            End If
            CurrentStep += 1
            If CurrentStep = 5 Then
                TemplateWizard_ParentTemplates1.ClassID = Me.ClassID
                TemplateWizard_Finished1.ClassID = Me.ClassID
                TemplateWizard_Finished1.ClassName = Me.ClassName
                TemplateWizard_Finished1.FinishWizard()
            End If

            Me.ShowStep(CurrentStep)
        End If
    End Sub


    Public Property ClassName() As String
        Get
            Return CType(viewstate("ClassName"), String)
        End Get
        Set(ByVal Value As String)
            viewstate("ClassName") = Value
        End Set
    End Property


    Public Property ClassID() As Integer
        Get
            Return CType(viewstate("ClassID"), Integer)
        End Get
        Set(ByVal Value As Integer)
            viewstate("ClassID") = Value
        End Set
    End Property


End Class
