Imports System.Xml
Imports Kentico.CMS.MetadataEngine
Imports Kentico.CMS.DataEngine
Imports Kentico.CMS.TreeEngine
Imports System.IO

Public Class TemplateWizard_Finished
    Inherits System.Web.UI.UserControl
    Implements ITemplateWizardStep

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblIntro As System.Web.UI.WebControls.Label
    Protected WithEvents lblNextSteps As System.Web.UI.WebControls.Label
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal
    Protected WithEvents ltlSteps As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.lblIntro.Text = ResMan.GetString("TemplateWizard_Finished.Intro")
        Me.lblNextSteps.Text = ResMan.GetString("TemplateWizard_Finished.NextSteps")
    End Sub


    Public Function IsValid() As Boolean Implements ITemplateWizardStep.IsValid
        Return True
    End Function


    Public Function GetStepHeader() As String Implements ITemplateWizardStep.GetStepHeader
        Return ResMan.GetString("TemplateWizard_Finished.StepHeader")
    End Function


    Public Function GetStepDescription() As String Implements ITemplateWizardStep.GetStepDescription
        Return ResMan.GetString("TemplateWizard_Finished.StepDescription")
    End Function


    Public Sub FinishWizard()
        Dim isCoupled As Boolean

        isCoupled = CType(ClassInformationProvider.GetClassRow(Me.ClassID, Functions.GetTreeProvider)("IsCoupledClass"), Boolean)
        'generate transformation
        If isCoupled Then
            'ASCX Transformation (default)
            Dim txt As String = TransformationGenerator.GetASCXTransformation(ClassName & ".default")
            Dim strm As TextWriter = New StreamWriter(Functions.GetMetadataPath & "\" & ClassName.Split("."c)(0) & "\" & ClassName.Split("."c)(1) & "\transformations\default.ascx")
            strm.Write(txt)
            strm.Close()
            'XSL Transformation
            'Dim xsl As XmlDocument = TransformationGenerator.GetXSLTransformation(ClassName & ".default")
            'xsl.Save(Functions.GetMetadataPath & "\" & ClassName.Split("."c)(0) & "\" & ClassName.Split("."c)(1) & "\transformations\default.config")
        End If

        If Not isCoupled Then
            'generate standard queries for non-coupled classes
            Dim query As New MetadataQuery
            query.RequiresTransaction = False
            'select
            query.QueryText = "Proc_CMS_Tree_Select"
            query.QueryType = MetadataQueryTypeEnum.StoredProcedure
            MetadataProvider.SetQuery(ClassName & ".select", query)
            'insert
            query.QueryText = "Proc_CMS_Tree_Insert"
            query.QueryType = MetadataQueryTypeEnum.StoredProcedure
            MetadataProvider.SetQuery(ClassName & ".insert", query)
            'update
            query.QueryText = "Proc_CMS_Tree_Update"
            query.QueryType = MetadataQueryTypeEnum.StoredProcedure
            MetadataProvider.SetQuery(ClassName & ".update", query)
            'delete
            query.QueryText = "Proc_CMS_Tree_Delete"
            query.QueryType = MetadataQueryTypeEnum.StoredProcedure
            MetadataProvider.SetQuery(ClassName & ".delete", query)
            'selectbypath
            query.QueryText = "select view_cms_tree_joined.* from view_cms_tree_joined where (##WHERE##) and classname = '" & ClassName & "' order by ##orderby##"
            query.QueryType = MetadataQueryTypeEnum.SQLQuery
            MetadataProvider.SetQuery(ClassName & ".selectbypath", query)
            'searchtree
            query.QueryText = "Proc_CMS_Tree_SearchTree"
            query.QueryType = MetadataQueryTypeEnum.StoredProcedure
            MetadataProvider.SetQuery(ClassName & ".searchtree", query)
        End If

        'create standard permission names
        CreatePermissionName(ClassID, "Read", ResMan.GetString("PermissionNames.Read"))
        CreatePermissionName(ClassID, "Create", ResMan.GetString("PermissionNames.Create"))
        CreatePermissionName(ClassID, "Modify", ResMan.GetString("PermissionNames.Modify"))
        CreatePermissionName(ClassID, "Delete", ResMan.GetString("PermissionNames.Delete"))
        CreatePermissionName(ClassID, "Destroy", ResMan.GetString("PermissionNames.Destroy"))
        CreatePermissionName(ClassID, "ModifyPermissions", ResMan.GetString("PermissionNames.ModifyPermissions"))

        'create icon
        Try
            If isCoupled Then
                File.Copy(Server.MapPath("../design/icons/default/document.gif"), Server.MapPath("../design/icons/" & ClassName & ".gif"))
                File.Copy(Server.MapPath("../design/icons/default/document.gif"), Server.MapPath("../design/icons/" & ClassName & "_open.gif"))
            Else
                File.Copy(Server.MapPath("../design/icons/default/folder.gif"), Server.MapPath("../design/icons/" & ClassName & ".gif"))
                File.Copy(Server.MapPath("../design/icons/default/folder_open.gif"), Server.MapPath("../design/icons/" & ClassName & "_open.gif"))
            End If
        Catch ex As Exception
        End Try

        'update tree menu
        Me.ltlScript.Text = "<script language=""javascript"">" & _
                            " parent.frames['header'].ReloadSelectedNodeChildren(); " & _
                            "</script>"

        'show finished steps
        Me.ltlSteps.Text = "<ul>"
        Me.ltlSteps.Text &= "<li>" & ResMan.GetString("TemplateWizard_Finished.ClassCreated") & "</li>"
        If isCoupled = True Then
            Me.ltlSteps.Text &= "<li>" & ResMan.GetString("TemplateWizard_Finished.TableCreated") & "</li>"
        End If
        Me.ltlSteps.Text &= "<li>" & ResMan.GetString("TemplateWizard_Finished.FormCreated") & "</li>"
        Me.ltlSteps.Text &= "<li>" & ResMan.GetString("TemplateWizard_Finished.ParentTemplatesAdded") & "</li>"
        Me.ltlSteps.Text &= "<li>" & ResMan.GetString("TemplateWizard_Finished.Transformation") & "</li>"
        Me.ltlSteps.Text &= "<li>" & ResMan.GetString("TemplateWizard_Finished.PermissionNames") & "</li>"
        Me.ltlSteps.Text &= "<li>" & ResMan.GetString("TemplateWizard_Finished.DefaultIcon") & "</li>"
        Me.ltlSteps.Text &= "</ul>"
    End Sub


    Public Property ClassName() As String
        Get
            Return CType(viewstate("ClassName"), String)
        End Get
        Set(ByVal Value As String)
            viewstate("ClassName") = Value
        End Set
    End Property


    Public Property ClassID() As Integer
        Get
            Return CType(viewstate("ClassID"), Integer)
        End Get
        Set(ByVal Value As Integer)
            viewstate("ClassID") = Value
        End Set
    End Property


    Private Sub CreatePermissionName(ByVal classID As Integer, ByVal permissionName As String, ByVal permissionDisplayName As String)
        Dim permissionObj As DataClass
        Dim cn As New GeneralConnection(Functions.GetConnectionString)

        permissionObj = New DataClass("CMS.Permission", cn)
        permissionObj.SetValue("PermissionName", permissionName)
        permissionObj.SetValue("PermissionDisplayName", permissionDisplayName)
        permissionObj.SetValue("ClassID", classID)
        permissionObj.Insert()
    End Sub
End Class
