Imports Kentico.CMS.DataEngine
Imports Kentico.CMS.TreeEngine
Imports Kentico.CMS.MetadataEngine

Public Class TemplateWizard_Names
    Inherits System.Web.UI.UserControl
    Implements ITemplateWizardStep

    Protected applicationID As Integer

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblDisplayName As System.Web.UI.WebControls.Label
    Protected WithEvents lblCodeName As System.Web.UI.WebControls.Label
    Protected WithEvents txtDisplayName As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtCodeName As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents lblApplicationCodeName As System.Web.UI.WebControls.Label

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        applicationID = Integer.Parse(Request.QueryString("applicationid"))
        lblError.Text = ""

        If Not Page.IsPostBack Then
            Me.lblDisplayName.Text = ResMan.GetString("TemplateWizard_Names.DisplayName")
            Me.lblCodeName.Text = ResMan.GetString("TemplateWizard_Names.CodeName")
            Dim ds As DataSet
            Dim cn As GeneralConnection = New GeneralConnection(Functions.GetConnectionString)
            Dim params(0, 2) As Object
            params(0, 0) = "@id"
            params(0, 1) = applicationID
            ds = cn.ExecuteQuery("cms.application.select", params)
            Me.lblApplicationCodeName.Text = CType(ds.Tables(0).Rows(0)("applicationname"), String)
        End If
    End Sub


    Public Function IsValid() As Boolean Implements ITemplateWizardStep.IsValid
        Dim errorMessage As String

        txtCodeName.Text = txtCodeName.Text.Trim
        txtDisplayName.Text = txtDisplayName.Text.Trim
        If Me.txtDisplayName.Text = "" Then
            errorMessage &= ResMan.GetString("TemplateWizard_Names.ErrorEmptyDisplayName") & " "
        End If
        If Me.txtCodeName.Text = "" Then
            errorMessage &= ResMan.GetString("TemplateWizard_Names.ErrorEmptyCodeName") & " "
        End If
        If InStr(Me.txtCodeName.Text, ".") > 0 Then
            errorMessage &= ResMan.GetString("TemplateWizard_Names.ErrorPointInCodeName") & " "
        End If
        If InStr(Me.txtCodeName.Text, " ") > 0 Then
            errorMessage &= ResMan.GetString("TemplateWizard_Names.ErrorSpaceInCodeName") & " "
        End If

        'check for existing class code name
        Dim params(0, 2) As String
        Dim cn As GeneralConnection = New GeneralConnection(Functions.GetConnectionString)
        Dim classNamesDS As DataSet
        params(0, 0) = "@ClassName"
        params(0, 1) = lblApplicationCodeName.Text & "." & txtCodeName.Text
        classNamesDS = cn.ExecuteQuery("CMS.Class.SelectByClassName", params)
        If classNamesDS.Tables(0).Rows.Count > 0 Then
            errorMessage &= ResMan.GetString("TemplateWizard_Names.ErrorExistingCodeName") & " "
        End If

        If errorMessage = "" Then
            'create class
            Dim classobj As DataClass
            classobj = New DataClass("CMS.Class", cn)
            classobj.SetValue("ClassName", Me.lblApplicationCodeName.Text & "." & txtCodeName.Text)
            classobj.SetValue("ClassDisplayName", txtDisplayName.Text)
            classobj.SetValue("ApplicationID", applicationID)
            classobj.SetValue("IsCoupledClass", True)
            classobj.SetValue("UseVersioning", False)
            classobj.SetValue("WorkflowID", Nothing)
            classobj.Insert()
            Me.ClassID = CType(classobj.GetValue("ClassID"), Integer)
            Me.ClassName = CType(classobj.GetValue("ClassName"), String)

            'create class folder
            Functions.EnsureDiskPath(Functions.GetMetadataPath() & "\" & Me.lblApplicationCodeName.Text & "\" & Me.txtCodeName.Text & "\config.xml", Functions.GetMetadataPath)

            'create settings.config
            MetadataProvider.SetSettingsValue(ClassName, "cmseditpage", "")
            MetadataProvider.SetSettingsValue(ClassName, "cmslistpage", "")
            MetadataProvider.SetSettingsValue(ClassName, "tablename", "")
            MetadataProvider.SetSettingsValue(ClassName, "nodenamesourceattribute", "")
            MetadataProvider.SetSettingsValue(ClassName, "supportfriendlyurls", "true")

            'update class information in memory
            ClassInformationProvider.ClearMetadata()
            MetadataProvider.ClearMetadata()
            Return True
        Else
            Me.lblError.Text = errorMessage
            Return False
        End If
    End Function


    Public Function GetStepHeader() As String Implements ITemplateWizardStep.GetStepHeader
        Return ResMan.GetString("TemplateWizard_Names.StepHeader")
    End Function


    Public Function GetStepDescription() As String Implements ITemplateWizardStep.GetStepDescription
        Return ResMan.GetString("TemplateWizard_Names.StepDescription")
    End Function


    Public Property ClassName() As String
        Get
            Return CType(viewstate("ClassName"), String)
        End Get
        Set(ByVal Value As String)
            viewstate("ClassName") = Value
        End Set
    End Property


    Public Property ClassID() As Integer
        Get
            Return CType(viewstate("ClassID"), Integer)
        End Get
        Set(ByVal Value As Integer)
            viewstate("ClassID") = Value
        End Set
    End Property


End Class
