Imports System.Xml
Imports Kentico.CMS.MetadataEngine
Imports Kentico.CMS.DataEngine
Imports Kentico.CMS.TreeEngine

Public Class TemplateWizard_NodeName
    Inherits System.Web.UI.UserControl
    Implements ITemplateWizardStep

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblSelectField As System.Web.UI.WebControls.Label
    Protected WithEvents lstFields As System.Web.UI.WebControls.DropDownList
    Protected WithEvents lblUseVersioningAndWorkflow As System.Web.UI.WebControls.Label
    Protected WithEvents chkUseVersioning As System.Web.UI.WebControls.CheckBox
    Protected WithEvents lblWorkflow As System.Web.UI.WebControls.Label
    Protected WithEvents drpWorkflow As System.Web.UI.WebControls.DropDownList

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.lblSelectField.Text = ResMan.GetString("TemplateWizard_NodeName.SelectField")
        Me.lblUseVersioningAndWorkflow.Text = ResMan.GetString("ClassEdit.UseVersioningAndWorkflow")
        Me.lblWorkflow.Text = ResMan.GetString("ClassEdit.Workflow")

        If Not Page.IsPostBack Then
            Me.LoadWorkflows(0)
        End If
    End Sub


    Public Function IsValid() As Boolean Implements ITemplateWizardStep.IsValid
        MetadataProvider.SetSettingsValue(Me.ClassName, "nodenamesourceattribute", Me.lstFields.SelectedValue)
        If Me.chkUseVersioning.Checked Then
            Dim tree As TreeProvider = Functions.GetTreeProvider
            Dim cn As GeneralConnection = tree.Connection
            Dim classID As Integer = CType(ClassInformationProvider.GetClassRow(Me.ClassName, tree)("ClassID"), Integer)
            Dim classObj As New DataClass("cms.class", classID, cn)

            classObj.SetValue("UseVersioning", True)
            classObj.SetValue("WorkflowID", Me.drpWorkflow.SelectedValue)
            classObj.Update()
            MetadataProvider.ClearMetadata()
            ClassInformationProvider.ClearMetadata()
        End If
        Return True
    End Function


    Public Function GetStepHeader() As String Implements ITemplateWizardStep.GetStepHeader
        Return ResMan.GetString("TemplateWizard_NodeName.StepHeader")
    End Function


    Public Function GetStepDescription() As String Implements ITemplateWizardStep.GetStepDescription
        Return ResMan.GetString("TemplateWizard_NodeName.StepDescription")
    End Function


    Public Sub LoadFields()
        'load fields
        Dim formXML As New XmlDocument
        formXML.Load(Functions.GetMetadataPath & "\" & ClassName.Split("."c)(0) & "\" & ClassName.Split("."c)(1) & "\forms\default.config")
        Dim fieldNode As XmlNode

        Me.lstFields.Items.Add(New ListItem(ResMan.GetString("TemplateWizard_NodeName.UseNodeName"), ""))
        For Each fieldNode In formXML.SelectNodes("/form/field[@visible='true']")
            Me.lstFields.Items.Add(New ListItem(fieldNode.Attributes("column").Value, fieldNode.Attributes("column").Value))
        Next
    End Sub


    Public Property ClassName() As String
        Get
            Return CType(viewstate("ClassName"), String)
        End Get
        Set(ByVal Value As String)
            viewstate("ClassName") = Value
        End Set
    End Property


    Private Sub chkUseVersioning_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkUseVersioning.CheckedChanged
        If Me.chkUseVersioning.Checked = True Then
            Me.drpWorkflow.Enabled = True
        Else
            Me.drpWorkflow.Enabled = False
        End If
    End Sub


    Private Sub LoadWorkflows(ByVal selectedWorkflowId As Integer)
        Dim workflowsDS As DataSet
        Dim workflowDR As DataRow
        Dim cn As GeneralConnection = Functions.GetTreeProvider.Connection

        workflowsDS = cn.ExecuteQuery("cms.workflow.selectall", Nothing, "", "WorkflowDisplayName")
        drpWorkflow.Items.Clear()
        For Each workflowDR In workflowsDS.Tables(0).Rows
            drpWorkflow.Items.Add(New ListItem(CType(workflowDR("WorkflowDisplayName"), String), CType(workflowDR("WorkflowID"), Integer).ToString))
            If (selectedWorkflowId = CType(workflowDR("WorkflowID"), Integer)) Or (selectedWorkflowId = 0 And CType(workflowDR("WorkflowName"), String).ToLower.Trim = "default") Then
                drpWorkflow.SelectedIndex = drpWorkflow.Items.Count - 1
            End If
        Next
    End Sub

End Class
