Imports Kentico.CMS.DataEngine
Imports System.Xml
Imports Kentico.CMS.MetadataEngine
Imports System.Data.SqlClient

Public Class TemplateWizard_Table
    Inherits System.Web.UI.UserControl
    Implements ITemplateWizardStep

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents radCustom As System.Web.UI.WebControls.RadioButton
    Protected WithEvents radContainer As System.Web.UI.WebControls.RadioButton
    Protected WithEvents lblTableName As System.Web.UI.WebControls.Label
    Protected WithEvents lblPKName As System.Web.UI.WebControls.Label
    Protected WithEvents txtTableName As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtPKName As System.Web.UI.WebControls.TextBox

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        lblError.Text = ""
        Me.radContainer.Text = ResMan.GetString("TemplateWizard_Table.Container")
        Me.radCustom.Text = ResMan.GetString("TemplateWizard_Table.Custom")
        Me.lblTableName.Text = ResMan.GetString("TemplateWizard_Table.TableName")
        Me.lblPKName.Text = ResMan.GetString("TemplateWizard_Table.PKName")
    End Sub


    Public Function IsValid() As Boolean Implements ITemplateWizardStep.IsValid
        Dim i As Integer
        Const INVALIDCHARACTERS As String = ".,;'`:/\*|?""&%$!-+=()[]{} "
        Dim errorMessage As String

        If Me.radCustom.Checked Then
            txtTableName.Text = txtTableName.Text.Trim
            txtPKName.Text = txtPKName.Text.Trim
            'check for empty values
            If Me.txtTableName.Text = "" Then
                errorMessage &= ResMan.GetString("TemplateWizard_Table.ErrorEmptyTableName") & " "
            End If
            For i = 0 To INVALIDCHARACTERS.Length - 1
                If InStr(Me.txtTableName.Text, "" & INVALIDCHARACTERS.Chars(i)) > 0 Then
                    errorMessage &= ResMan.GetString("TemplateWizard_Table.ErrorTableNameInvalidCharacter") & INVALIDCHARACTERS & ". "
                End If
            Next
            For i = 0 To INVALIDCHARACTERS.Length - 1
                If InStr(Me.txtPKName.Text, "" & INVALIDCHARACTERS.Chars(i)) > 0 Then
                    errorMessage &= ResMan.GetString("TemplateWizard_Table.ErrorPKNameInvalidCharacter") & INVALIDCHARACTERS & ". "
                End If
            Next
            If Me.txtPKName.Text = "" Then
                errorMessage &= ResMan.GetString("TemplateWizard_Table.ErrorEmptyPKName") & " "
            End If
            If InStr(Me.txtPKName.Text, " ") > 0 Then
                errorMessage &= ResMan.GetString("TemplateWizard_Table.ErrorPKNameWithSpaces") & " "
            End If
            If errorMessage <> "" Then
                lblError.Text = errorMessage
                Return False
            End If
            'try to create the new table            
            Try
                Dim query As String
                Dim owner As String = ""
                'use owner if specified
                If ConfigurationSettings.AppSettings("CMSDBObjectOwner") & "" <> "" Then
                    owner = "[" & Trim(ConfigurationSettings.AppSettings("CMSDBObjectOwner")) & "]."
                End If
                query = "  CREATE TABLE " & owner & "[" & Me.txtTableName.Text & "] ([" & Me.txtPKName.Text & "] [int] IDENTITY (1, 1) NOT NULL, "
                query &= " CONSTRAINT [PK_" & Me.txtTableName.Text & "] PRIMARY KEY CLUSTERED ([" & Me.txtPKName.Text & "])) "
                Dim cn As New GeneralConnection(Functions.GetConnectionString)
                cn.DataConnection.ExecuteQuery(query, Nothing, MetadataEngine.MetadataQueryTypeEnum.SQLQuery)
            Catch ex As Exception
                Me.lblError.Text = ResMan.GetString("TemplateWizard_Table.ErrorCreateTable") & " " & ex.Message
                Return False
            End Try

            'update settings.config
            MetadataProvider.SetSettingsValue(ClassName, "tablename", Me.txtTableName.Text)

            'generate schema.config      
            SaveXMLSchema()

            'create forms and transformations folder
            Functions.EnsureDiskPath(Functions.GetMetadataPath & "\" & Me.ClassName.Split("."c)(0) & "\" & Me.ClassName.Split("."c)(1) & "\Forms\config.config", Functions.GetMetadataPath)
            Functions.EnsureDiskPath(Functions.GetMetadataPath & "\" & Me.ClassName.Split("."c)(0) & "\" & Me.ClassName.Split("."c)(1) & "\Transformations\config.config", Functions.GetMetadataPath)
            Return True
        Else
            'set IsCoupledClass = false
            Dim cn As New GeneralConnection(Functions.GetConnectionString)
            Dim classObj As New DataClass("cms.class", Me.ClassID, cn)
            classObj.SetValue("IsCoupledClass", False)
            classObj.Update()
            'skip step 3            
            CType(Page, TemplateWizard).CurrentStep = 4
        End If
        Return True
    End Function


    Public Function GetStepHeader() As String Implements ITemplateWizardStep.GetStepHeader
        Return ResMan.GetString("TemplateWizard_Table.StepHeader")
    End Function


    Public Function GetStepDescription() As String Implements ITemplateWizardStep.GetStepDescription
        Return ResMan.GetString("TemplateWizard_Table.StepDescription")
    End Function


    Public Property ClassName() As String
        Get
            Return CType(viewstate("ClassName"), String)
        End Get
        Set(ByVal Value As String)
            viewstate("ClassName") = Value
            Me.txtTableName.Text = Value.Split("."c)(0) & "_" & Value.Split("."c)(1)
            Me.txtPKName.Text = Replace(CType(Me.Page, TemplateWizard).ClassName & "", " ", "_").Split("."c)(1) & "ID"
        End Set
    End Property


    Public Property ClassID() As Integer
        Get
            Return CType(viewstate("ClassID"), Integer)
        End Get
        Set(ByVal Value As Integer)
            viewstate("ClassID") = Value
        End Set
    End Property


    Private Sub SaveXMLSchema()
        Dim tableName As String
        Dim className As String

        tableName = Me.txtTableName.Text.Trim
        className = Me.ClassName
        'getting XML Schema
        Dim cn As New SqlConnection(Functions.GetConnectionString)
        Dim da As New SqlDataAdapter("select top 1 * from " & tableName & " order by 1 ", cn)
        Dim ds As New DataSet
        da.FillSchema(ds, SchemaType.Mapped, className)
        MetadataProvider.SetXMLSchema(className, Replace(ds.GetXmlSchema & "", "utf-16", "utf-8"))
    End Sub

End Class
