Imports System.Xml
Imports System.IO
Imports Kentico.CMS.MetadataEngine
Imports Kentico.DirectoryUtilities

Public Class TransformationEdit
    Inherits System.Web.UI.Page

    Private transformationName As String
    Private transformationPath As String
    Private className As String
    Protected WithEvents btnUseDefault As System.Web.UI.WebControls.Button
    Protected WithEvents lblTransformationType As System.Web.UI.WebControls.Label
    Protected WithEvents radioXSLTTransformation As System.Web.UI.WebControls.RadioButton
    Protected WithEvents radioASCXTransformation As System.Web.UI.WebControls.RadioButton
    Private classID As Integer

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents btnCancel As System.Web.UI.WebControls.Button
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal
    Protected WithEvents lblTransformationName As System.Web.UI.WebControls.Label
    Protected WithEvents txtTransformationName As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblTransformationText As System.Web.UI.WebControls.Label
    Protected WithEvents txtTransformation As System.Web.UI.WebControls.TextBox

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Read") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Read")
            Exit Sub
        End If

        If Request.QueryString("transformation") <> "" Then
            transformationName = Request.QueryString("transformation").Split("."c)(2)
            transformationPath = Functions.GetMetadataPath & "\" & Request.QueryString("transformation").Split("."c)(0) & "\" & Request.QueryString("transformation").Split("."c)(1) & "\transformations\" & Request.QueryString("transformation").Split("."c)(2)
            If File.Exists(transformationPath & ".ascx") Then
                transformationPath &= ".ascx"
                Me.radioASCXTransformation.Checked = True
            Else
                transformationPath &= ".config"
                Me.radioXSLTTransformation.Checked = True
            End If
            viewstate("mode") = "modify"
            className = Request.QueryString("transformation").Split("."c)(0) & "." & Request.QueryString("transformation").Split("."c)(1)
            classID = Integer.Parse(CType(Kentico.CMS.TreeEngine.ClassInformationProvider.GetClassRow(className, Functions.GetTreeProvider())("ClassID"), String))
        ElseIf Request.QueryString("classid") <> "" Then
                If CType(viewstate("mode"), String) = "" Then
                    viewstate("mode") = "create"
                End If
                transformationName = ""
                transformationPath = ""
                classID = Integer.Parse(Request.QueryString("classid"))
                className = CType(Kentico.CMS.TreeEngine.ClassInformationProvider.GetClassRow(classID, Functions.GetTreeProvider())("ClassName"), String)
            End If
            If Not Page.IsPostBack Then
                viewstate("originalTransformationName") = transformationName
            End If
            lblError.Text = ""
            lblInfo.Text = ""
            lblHeader.Text = ResMan.GetString("TransformationEdit.Header")
            lblTransformationName.Text = ResMan.GetString("TransformationEdit.TransformationName")
            lblTransformationText.Text = ResMan.GetString("TransformationEdit.TransformationText")
            lblTransformationType.Text = ResMan.GetString("TransformationEdit.TransformationType")
            radioXSLTTransformation.Text = ResMan.GetString("TransformationEdit.XSLTTransformation")
            radioASCXTransformation.Text = ResMan.GetString("TransformationEdit.ASCXTransformation")
            btnUseDefault.Text = ResMan.GetString("TransformationEdit.UseDefault")
            btnOK.Text = ResMan.GetString("TransformationEdit.OK")
            btnCancel.Text = ResMan.GetString("TransformationEdit.Cancel")
            radioXSLTTransformation.Enabled = False
            radioASCXTransformation.Enabled = False

        If Not Page.IsPostBack And (CType(viewstate("mode"), String) = "modify") Then
            If Me.radioXSLTTransformation.Checked Then
                Dim xml As New XmlDocument
                xml.Load(transformationPath)
                txtTransformation.Text = xml.OuterXml.ToString
                txtTransformationName.Text = transformationName
            Else
                Dim txt As TextReader = New StreamReader(transformationPath)
                txtTransformation.Text = txt.ReadToEnd()
                txt.Close()
                txtTransformationName.Text = transformationName
            End If
        End If
        If CType(viewstate("mode"), String) = "create" Then
            radioXSLTTransformation.Enabled = True
            radioASCXTransformation.Enabled = True
            If Not Page.IsPostBack Then
                If radioXSLTTransformation.Checked Then
                    Me.txtTransformation.Text = TransformationGenerator.GetXSLTransformation(className & ".default").OuterXml
                Else
                    Me.txtTransformation.Text = TransformationGenerator.GetASCXTransformation(className & ".default")
                End If
            End If
        End If
    End Sub


    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        'check permissions
        If CType(viewstate("mode"), String) = "create" Then
            If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Create") Then
                Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Create")
                Exit Sub
            End If
        Else
            If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Modify") Then
                Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Modify")
                Exit Sub
            End If
        End If

        'validate input
        Dim errorMessage As String = ""
        Dim xml As XmlDocument
        Dim txt As TextWriter

        If txtTransformationName.Text.Trim = "" Then
            errorMessage &= ResMan.GetString("TransformationEdit.ErrorEmptyTransformationName") & " "
        End If
        If txtTransformation.Text.Trim = "" Then
            errorMessage &= ResMan.GetString("TransformationEdit.ErrorEmptyTransformation") & " "
        Else
            If Me.radioXSLTTransformation.Checked Then
                xml = New XmlDocument
                Try
                    xml.LoadXml(txtTransformation.Text)
                Catch ex As Exception
                    errorMessage &= ResMan.GetString("TransformationEdit.ErrorDocumentNotValid")
                End Try
            End If
        End If
        If errorMessage <> "" Then
            lblError.Text = errorMessage
        End If
        'save
        If errorMessage = "" Then
            Dim parentPath As String
            parentPath = Functions.GetMetadataPath & "\" & className.Split("."c)(0) & "\" & className.Split("."c)(1) & "\Transformations"
            If CType(viewstate("mode"), String) = "create" Then
                'create new                                
                If Not Directory.Exists(parentPath) Then
                    DirectoryHelper.CreateDirectory(parentPath)
                End If
                If Me.radioXSLTTransformation.Checked Then
                    xml.Save(parentPath & "\" & Me.txtTransformationName.Text & ".config")
                Else
                    txt = New StreamWriter(parentPath & "\" & Me.txtTransformationName.Text & ".ascx")
                    txt.Write(Me.txtTransformation.Text)
                    txt.Close()
                End If
                viewstate("originalTransformationName") = Me.txtTransformationName.Text
                viewstate("mode") = "modify"
            Else
                'modify existing                
                If CType(viewstate("originalTransformationName"), String) <> Me.txtTransformationName.Text Then
                    If Me.radioXSLTTransformation.Checked Then
                        File.Move(parentPath & "\" & CType(viewstate("originalTransformationName"), String) & ".config", parentPath & "\" & Me.txtTransformationName.Text & ".config")
                    Else
                        File.Move(parentPath & "\" & CType(viewstate("originalTransformationName"), String) & ".ascx", parentPath & "\" & Me.txtTransformationName.Text & ".ascx")
                    End If
                    viewstate("originalTransformationName") = Me.txtTransformationName.Text
                End If
                If Me.radioXSLTTransformation.Checked Then
                    xml.Save(parentPath & "\" & Me.txtTransformationName.Text & ".config")
                Else
                    txt = New StreamWriter(parentPath & "\" & Me.txtTransformationName.Text & ".ascx")
                    txt.Write(Me.txtTransformation.Text)
                    txt.Close()
                End If
            End If
            'update metadata
            Kentico.CMS.MetadataEngine.MetadataProvider.ClearMetadata()
            radioXSLTTransformation.Enabled = False
            radioASCXTransformation.Enabled = False
            lblInfo.Text = ResMan.GetString("TransformationEdit.ChangesSaved")
        End If
    End Sub


    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        'redirects user back to the list of resources        
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= " Cancel('" & classID & "'); "
        ltlScript.Text &= "</script>"
    End Sub

    Private Sub btnUseDefault_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUseDefault.Click
        If radioXSLTTransformation.Checked Then
            Me.txtTransformation.Text = TransformationGenerator.GetXSLTransformation(className & ".default").OuterXml
        Else
            Me.txtTransformation.Text = TransformationGenerator.GetASCXTransformation(className & ".default")
        End If
    End Sub

End Class
