Imports System.IO
Imports Kentico.DirectoryUtilities

Public Class TransformationList
    Inherits System.Web.UI.Page

    Protected editHint As String
    Protected deleteHint As String

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents ltlConfirmScript As System.Web.UI.WebControls.Literal
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal
    Protected WithEvents Grid1 As Kentico.CMS.CMSControls.BasicDataGrid

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Read") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Read")
            Exit Sub
        End If

        editHint = ResMan.GetString("TransformationList.EditHint")
        deleteHint = ResMan.GetString("TransformationList.DeleteHint")
        'set column header names
        Grid1.Columns(0).HeaderText = ResMan.GetString("TransformationList.Action")
        Grid1.Columns(1).HeaderText = ResMan.GetString("TransformationList.TransformationName")
        Grid1.Columns(2).HeaderText = ResMan.GetString("TransformationList.TransformationType")

        'confirmation question
        ltlConfirmScript.Text = "<input type=""hidden"" id=""confirmationText"" value=""" & ResMan.GetString("TransformationList.ConfirmDelete") & """>"
        lblHeader.Text = ResMan.GetString("TransformationList.Header")

        If Not Page.IsPostBack Then
            DisplayTransformations()
        End If
    End Sub


    Public Sub DeleteItem(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs)
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Delete") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Delete")
            Exit Sub
        End If

        'delete transformation
        Dim transformationFullName As String
        transformationFullName = CType(e.CommandArgument, String)
        Dim transformationFileName As String = Functions.GetMetadataPath & "\" & transformationFullName.Split("."c)(0) & "\" & transformationFullName.Split("."c)(1) & "\transformations\" & transformationFullName.Split("."c)(2)
        If File.Exists(transformationFileName & ".config") Then File.Delete(transformationFileName & ".config")
        If File.Exists(transformationFileName & ".ascx") Then File.Delete(transformationFileName & ".ascx")

        Kentico.CMS.MetadataEngine.MetadataProvider.ClearMetadata()

        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= " Reload(); "
        ltlScript.Text &= "</script>"
    End Sub


    Private Sub DisplayTransformations()
        Dim classID As Integer
        Dim className As String
        Dim transformationsDirPath As String
        Dim transformationsDirectory As DirectoryInfo
        Dim transformations() As FileInfo
        Dim transformationName As String
        Dim i As Integer
        Dim ds As New DataSet
        Dim dr As DataRow

        classID = CType(Request.QueryString("classid"), Integer)
        className = CType(Kentico.CMS.TreeEngine.ClassInformationProvider.GetClassRow(classID, Functions.GetTreeProvider)("ClassName"), String)
        'read transformations            
        transformationsDirPath = Functions.GetMetadataPath & "\" & className.Split("."c)(0) & "\" & className.Split("."c)(1) & "\Transformations"
        If Not Directory.Exists(transformationsDirPath) Then
            DirectoryHelper.CreateDirectory(transformationsDirPath)
        End If
        transformationsDirectory = New DirectoryInfo(transformationsDirPath)
        transformations = transformationsDirectory.GetFiles()
        'prepare dataset
        ds.Tables.Add(New DataTable)
        ds.Tables(0).Columns.Add(New DataColumn("TransformationFullName"))
        ds.Tables(0).Columns.Add(New DataColumn("TransformationName"))
        ds.Tables(0).Columns.Add(New DataColumn("TransformationType"))
        'fill dataset
        For i = transformations.GetLowerBound(0) To transformations.GetUpperBound(0)
            If transformations(i).Name.EndsWith(".config") Then
                transformationName = Replace(transformations(i).Name & "", ".config", "")
                dr = ds.Tables(0).NewRow()
                dr("TransformationFullName") = className & "." & transformationName
                dr("TransformationName") = transformationName
                dr("TransformationType") = ResMan.GetString("TransformationList.XSLTTransformation")
                ds.Tables(0).Rows.Add(dr)
            ElseIf transformations(i).Name.EndsWith(".ascx") Then
                transformationName = Replace(transformations(i).Name & "", ".ascx", "")
                dr = ds.Tables(0).NewRow()
                dr("TransformationFullName") = className & "." & transformationName
                dr("TransformationName") = transformationName
                dr("TransformationType") = ResMan.GetString("TransformationList.ASCXTransformation")
                ds.Tables(0).Rows.Add(dr)
            End If
        Next
        'bind data
        Grid1.DataSource = ds
    End Sub


    Private Sub Grid1_ItemDataBound(ByVal sender As System.Object, ByVal e As DataGridItemEventArgs) Handles Grid1.ItemDataBound
        Dim btnCurrentButton As ImageButton

        'set up the Delete button
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            btnCurrentButton = CType(e.Item.Cells(0).FindControl("btnDelete"), ImageButton)
            btnCurrentButton.Attributes.Add("OnClick", "return ConfirmDelete();")
            btnCurrentButton.Attributes.Add("title", deleteHint)
        End If
    End Sub

End Class
