Imports Kentico.CMS.TreeEngine
Imports Kentico.CMS.DataEngine

Public Class WorkflowDesigner
    Inherits System.Web.UI.UserControl

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblErrorMessage As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents ltlConfirmText As System.Web.UI.WebControls.Literal
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal
    Protected WithEvents lblSteps As System.Web.UI.WebControls.Label
    Protected WithEvents lstSteps As System.Web.UI.WebControls.ListBox
    Protected WithEvents btnUpStep As System.Web.UI.WebControls.ImageButton
    Protected WithEvents btnDownStep As System.Web.UI.WebControls.ImageButton
    Protected WithEvents btnNewStep As System.Web.UI.WebControls.ImageButton
    Protected WithEvents btnDeleteStep As System.Web.UI.WebControls.ImageButton
    Protected WithEvents lblStepDisplayName As System.Web.UI.WebControls.Label
    Protected WithEvents txtStepDisplayName As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblStepName As System.Web.UI.WebControls.Label
    Protected WithEvents txtStepName As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblStepProperties As System.Web.UI.WebControls.Label
    Protected WithEvents lblWorkflowSteps As System.Web.UI.WebControls.Label
    Protected WithEvents lblStepEdit As System.Web.UI.WebControls.Label
    Protected WithEvents lblStepPublished As System.Web.UI.WebControls.Label
    Protected WithEvents lblAllowedRoles As System.Web.UI.WebControls.Label
    Protected WithEvents lstAllowedRoles As System.Web.UI.WebControls.ListBox
    Protected WithEvents btnAddRole As System.Web.UI.WebControls.ImageButton
    Protected WithEvents btnRemoveRole As System.Web.UI.WebControls.ImageButton
    Protected WithEvents pnlRoles As System.Web.UI.WebControls.Panel
    Protected WithEvents txtUpdate As System.Web.UI.WebControls.TextBox
    Protected WithEvents btnUpdate As System.Web.UI.WebControls.Button

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Read") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Read")
            Exit Sub
        End If

        lblWorkflowSteps.Text = ResMan.GetString("WorkflowDesigner.WorkflowSteps")
        lblSteps.Text = ResMan.GetString("WorkflowDesigner.Steps")
        lblStepProperties.Text = ResMan.GetString("WorkflowDesigner.StepProperties")
        lblStepDisplayName.Text = ResMan.GetString("WorkflowDesigner.StepDisplayName")
        lblStepName.Text = ResMan.GetString("WorkflowDesigner.StepName")
        lblStepEdit.Text = ResMan.GetString("WorkflowEdit.EditStepDisplayName")
        lblStepPublished.Text = ResMan.GetString("WorkflowEdit.PublishedStepDisplayName")
        ltlConfirmText.Text = "<span id=""confirmdelete"" style=""display:none"">" & ResMan.GetString("WorkflowDesigner.ConfirmDelete") & "</span>"
        btnDeleteStep.Attributes.Add("onclick", "javascript:return confirmDelete();")
        btnOK.Text = ResMan.GetString("WorkflowDesigner.OK")
        btnDeleteStep.ToolTip = ResMan.GetString("WorkflowDesigner.DeleteStep")
        btnNewStep.ToolTip = ResMan.GetString("WorkflowDesigner.NewStep")
        btnUpStep.ToolTip = ResMan.GetString("WorkflowDesigner.StepUp")
        btnDownStep.ToolTip = ResMan.GetString("WorkflowDesigner.StepDown")
        lblAllowedRoles.Text = ResMan.GetString("WorkflowDesigner.AllowedRoles")
        btnAddRole.ToolTip = ResMan.GetString("WorkflowDesigner.AddRole")
        btnRemoveRole.ToolTip = ResMan.GetString("WorkflowDesigner.RemoveRole")

        lblErrorMessage.Text = ""
        ltlScript.Text = ""
        lblInfo.Text = ""

        txtUpdate.Attributes.Add("onpropertychange", Page.GetPostBackEventReference(btnUpdate))

        If viewstate("StepID") Is Nothing Then
            viewstate("StepID") = 0
        End If

        'load steps
        If Not Page.IsPostBack And WorkflowID <> 0 Then
            ReloadSteps()
        End If
        Me.btnAddRole.Attributes.Add("onclick", "javascript:AddRole();")
    End Sub


    Public Property WorkflowID() As Integer
        Get
            If viewstate("WorkflowID") Is Nothing Then
                viewstate("WorkflowID") = 0
            End If
            Return CType(viewstate("WorkflowID"), Integer)
        End Get
        Set(ByVal Value As Integer)
            viewstate("WorkflowID") = Value
        End Set
    End Property


    Private Sub lstSteps_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstSteps.SelectedIndexChanged
        LoadSelectedStep()
    End Sub


    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        Dim stepObj As DataClass
        Dim stepID As Integer
        Dim errorMessage As String
        Dim cn As GeneralConnection = Functions.GetTreeProvider.Connection

        If (Not viewstate("StepID") Is Nothing) Then
            stepID = CType(viewstate("StepID"), Integer)
        Else
            stepID = 0
        End If

        'check permissions
        If stepID = 0 AndAlso Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Create") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Create")
            Exit Sub
        End If
        'check permissions
        If stepID <> 0 AndAlso Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Modify") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Create")
            Exit Sub
        End If

        Me.txtStepName.Text = Me.txtStepName.Text.Trim
        Me.txtStepDisplayName.Text = Me.txtStepDisplayName.Text.Trim
        'validate
        If Me.txtStepName.Text = "" Then
            errorMessage &= ResMan.GetString("WorkflowDesigner.ErrorEmptyStepName")
        End If
        If Me.txtStepDisplayName.Text = "" Then
            errorMessage &= ResMan.GetString("WorkflowDesigner.ErrorEmptyStepDisplayName")
        End If
        If Me.txtStepName.Text.ToLower = "edit" Then
            errorMessage &= ResMan.GetString("WorkflowDesigner.ErrorStepNameEdit")
        End If
        If Me.txtStepName.Text.ToLower = "published" Then
            errorMessage &= ResMan.GetString("WorkflowDesigner.ErrorStepNamePublished")
        End If
        'check if the step name is unique
        If errorMessage = "" Then
            Dim stepNamesDS As DataSet = cn.ExecuteQuery("CMS.WorkflowStep.selectworkflowsteps", Nothing, " StepName = '" & Me.txtStepName.Text.Replace("'", "''") & "' AND WorkflowID = " & Me.WorkflowID)
            Dim stepNameDR As DataRow
            If stepID = 0 Then
                If stepNamesDS.Tables(0).Rows.Count > 0 Then
                    'step name already exists
                    errorMessage &= ResMan.GetString("WorkflowDesigner.ErrorExistingStepName") & " "
                End If
            Else
                For Each stepNameDR In stepNamesDS.Tables(0).Rows
                    If CType(stepNameDR("StepID"), Integer) <> stepID Then
                        'class name already exists
                        errorMessage &= ResMan.GetString("WorkflowDesigner.ErrorExistingStepName") & " "
                    End If
                Next
            End If
        End If

        If errorMessage <> "" Then
            Me.lblErrorMessage.Text = errorMessage
            Exit Sub
        Else
            If (Not viewstate("StepID") Is Nothing) AndAlso CType(viewstate("StepID"), Integer) <> 0 Then
                'update
                stepObj = New DataClass("cms.workflowstep", CType(viewstate("StepID"), Integer), Functions.GetTreeProvider.Connection)
                stepObj.SetValue("StepDisplayName", Me.txtStepDisplayName.Text)
                stepObj.SetValue("StepName", Me.txtStepName.Text)
                stepObj.Update()
            Else
                'insert
                'get the "published" step
                Dim params(0, 2) As Object
                params(0, 0) = "@WorkflowID"
                params(0, 1) = Me.WorkflowID
                Dim publishedStepID As Integer = CType(cn.ExecuteQuery("cms.workflowstep.selectpublishedstep", params).Tables(0).Rows(0)("StepID"), Integer)
                Dim publishedStepObj As DataClass = New DataClass("cms.workflowstep", publishedStepID, cn)

                stepObj = New DataClass("cms.workflowstep", Functions.GetTreeProvider.Connection)
                stepObj.SetValue("StepDisplayName", Me.txtStepDisplayName.Text)
                stepObj.SetValue("StepName", Me.txtStepName.Text)
                stepObj.SetValue("WorkflowID", Me.WorkflowID)

                'set appropriate step order values and save changes
                stepObj.SetValue("StepOrder", publishedStepObj.GetValue("StepOrder"))
                publishedStepObj.SetValue("StepOrder", CType(publishedStepObj.GetValue("StepOrder"), Integer) + 1)

                cn.DataConnection.Open()
                cn.DataConnection.BeginTransaction()
                Try
                    publishedStepObj.Update()
                    stepObj.Insert()
                Catch exc As Exception
                    cn.DataConnection.RollbackTransaction()
                    cn.DataConnection.Close()
                    Throw exc
                End Try
                cn.DataConnection.CommitTransaction()
                cn.DataConnection.Close()

                viewstate("StepID") = CType(stepObj.GetValue("StepID"), Integer)
            End If
            Me.lblInfo.Text = ResMan.GetString("WorkflowDesigner.ChangesSaved")
            ReloadSteps()
        End If
    End Sub


    Private Sub btnNewStep_Click(ByVal sender As System.Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles btnNewStep.Click
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Modify") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Modify")
            Exit Sub
        End If

        'first check if there's no other new step
        Dim i As Integer
        For i = 0 To lstSteps.Items.Count - 1
            If lstSteps.Items(i).Value = "0" Then
                ShowMessage(ResMan.GetString("WorkflowDesigner.ErrorCannotCreateAnotherNewAttribute"))
                Exit Sub
            End If
        Next

        viewstate("StepID") = 0
        Me.txtStepName.Text = ""
        Me.txtStepDisplayName.Text = ""
        Me.lstSteps.Items.Add(New ListItem(ResMan.GetString("WorkflowDesigner.NewItem"), "0"))
        Me.lstSteps.SelectedIndex = Me.lstSteps.Items.Count - 1
        ReloadRoles()
    End Sub


    Private Sub ReloadSteps()
        Dim stepsDS As DataSet = Functions.GetTreeProvider.Connection.ExecuteQuery("cms.workflowstep.selectworkflowsteps", Nothing, " stepname <> 'edit' and stepname <> 'published' and workflowid = " & WorkflowID)
        Dim stepsDR As DataRow
        Dim stepSelected As Boolean = False

        Me.lstSteps.Items.Clear()
        For Each stepsDR In stepsDS.Tables(0).Rows
            'add item to the list
            Me.lstSteps.Items.Add(New ListItem(CType(stepsDR("StepDisplayName"), String), CType(stepsDR("StepID"), Integer).ToString))
            'select current item
            If CType(viewstate("StepID"), Integer) = CType(stepsDR("StepID"), Integer) Then
                Me.lstSteps.SelectedValue = CType(viewstate("StepID"), Integer).ToString
                stepSelected = True
            End If
        Next
        If Not stepSelected Then
            'select the first step
            Me.lstSteps.SelectedIndex = 0
            'load the first step
            LoadSelectedStep()
        End If
        If Me.lstSteps.Items.Count = 0 Then
            viewstate("StepID") = 0
            Me.txtStepName.Text = ""
            Me.txtStepDisplayName.Text = ""
        End If
        ReloadRoles()
    End Sub


    Private Sub LoadSelectedStep()
        If lstSteps.Items.Count = 0 Then
            Exit Sub
        End If
        Dim stepID As Integer = Integer.Parse(lstSteps.SelectedItem.Value.ToString)
        Dim stepObj As DataClass

        viewstate("StepID") = stepID
        'load step data
        If stepID <> 0 Then
            stepObj = New DataClass("cms.workflowstep", stepID, Functions.GetTreeProvider.Connection)
            Me.txtStepDisplayName.Text = CType(stepObj.GetValue("StepDisplayName"), String)
            Me.txtStepName.Text = CType(stepObj.GetValue("StepName"), String)
        End If
        ReloadRoles()
    End Sub


    Private Sub ShowMessage(ByVal message As String)
        Me.ltlScript.Text = "<script language=""javascript"">" & _
                            " alert('" & Replace(message, "'", "\'") & "'); " & _
                            "</script>"
    End Sub


    Private Sub btnDeleteStep_Click(ByVal sender As System.Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles btnDeleteStep.Click
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Modify") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Modify")
            Exit Sub
        End If

        Dim stepID As Integer = Integer.Parse(Me.lstSteps.SelectedValue)

        'check if there are nodes at this step
        Dim cn As GeneralConnection = Functions.GetTreeProvider.Connection
        Dim selectParams(0, 2) As Object
        selectParams(0, 0) = "@stepid"
        selectParams(0, 1) = stepID
        Dim stepNodesDS As DataSet = cn.ExecuteQuery("cms.workflowstep.nodescount", selectParams)
        If CType(stepNodesDS.Tables(0).Rows(0)(0), Integer) > 0 Then
            'display error message
            ShowMessage(ResMan.GetString("WorkflowDesigner.ErrorStepIsCurrentlyUsed"))
            Exit Sub
        End If

        'delete
        Dim params(0, 2) As Object
        params(0, 0) = "@id"
        params(0, 1) = stepID
        cn.ExecuteQuery("cms.workflowstep.delete", params)
        Me.ReloadSteps()
    End Sub


    'move selected attribute up
    Private Sub btnUpStep_Click(ByVal sender As System.Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles btnUpStep.Click
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Modify") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Modify")
            Exit Sub
        End If

        'check if current step is not the top one or if it's not the only one
        If lstSteps.Items.Count = 0 OrElse lstSteps.SelectedIndex = 0 Then
            Exit Sub
        End If

        'get data
        Dim stepID As Integer = Integer.Parse(lstSteps.SelectedValue)
        Dim cn As GeneralConnection = Functions.GetTreeProvider.Connection
        Dim currentStepObj As New DataClass("cms.workflowstep", stepID, cn)
        Dim currentStepOrder As Integer = CType(currentStepObj.GetValue("StepOrder"), Integer)
        Dim upperStepObj As New DataClass("cms.workflowstep", Integer.Parse(Me.lstSteps.Items(Me.lstSteps.SelectedIndex - 1).Value), cn)
        Dim upperStepOrder As Integer = CType(upperStepObj.GetValue("StepOrder"), Integer)

        'set new values
        currentStepObj.SetValue("StepOrder", upperStepOrder)
        upperStepObj.SetValue("StepOrder", currentStepOrder)

        'save new values
        cn.DataConnection.Open()
        cn.DataConnection.BeginTransaction()
        Try
            currentStepObj.Update()
            upperStepObj.Update()
        Catch exc As Exception
            cn.DataConnection.RollbackTransaction()
            cn.DataConnection.Close()
            Throw exc
        End Try
        cn.DataConnection.CommitTransaction()
        cn.DataConnection.Close()

        'reload data
        Me.ReloadSteps()
    End Sub


    Private Sub btnDownStep_Click(ByVal sender As System.Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles btnDownStep.Click
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Modify") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Modify")
            Exit Sub
        End If

        'check if current step is not the top one or if it's not the only one
        If lstSteps.Items.Count = 0 OrElse lstSteps.SelectedIndex = lstSteps.Items.Count - 1 Then
            Exit Sub
        End If

        'get data
        Dim stepID As Integer = Integer.Parse(lstSteps.SelectedValue)
        Dim cn As GeneralConnection = Functions.GetTreeProvider.Connection
        Dim currentStepObj As New DataClass("cms.workflowstep", stepID, cn)
        Dim currentStepOrder As Integer = CType(currentStepObj.GetValue("StepOrder"), Integer)
        Dim lowerStepObj As New DataClass("cms.workflowstep", Integer.Parse(Me.lstSteps.Items(Me.lstSteps.SelectedIndex + 1).Value), cn)
        Dim lowerStepOrder As Integer = CType(lowerStepObj.GetValue("StepOrder"), Integer)

        'set new values
        currentStepObj.SetValue("StepOrder", lowerStepOrder)
        lowerStepObj.SetValue("StepOrder", currentStepOrder)

        'save new values
        cn.DataConnection.Open()
        cn.DataConnection.BeginTransaction()
        Try
            currentStepObj.Update()
            lowerStepObj.Update()
        Catch exc As Exception
            cn.DataConnection.RollbackTransaction()
            cn.DataConnection.Close()
            Throw exc
        End Try
        cn.DataConnection.CommitTransaction()
        cn.DataConnection.Close()

        'reload data
        Me.ReloadSteps()
    End Sub


    Private Sub ReloadRoles()
        If CType(viewstate("StepID"), Integer) = 0 Then
            pnlRoles.Enabled = False
            Me.btnAddRole.Attributes.Add("onclick", "javascript:alert('" & ResMan.GetString("WorkflowDesigner.SaveStepBeforeAddRole") & "');")
            lstAllowedRoles.Items.Clear()
            Exit Sub
        End If

        pnlRoles.Enabled = True
        Me.btnAddRole.Attributes.Add("onclick", "javascript:AddRole();")
        Dim rolesDS As DataSet
        Dim cn As GeneralConnection = Functions.GetTreeProvider.Connection
        Dim params(0, 2) As Object
        Dim roleDR As DataRow

        lstAllowedRoles.Items.Clear()
        params(0, 0) = "@stepid"
        params(0, 1) = CType(viewstate("StepID"), Integer)
        rolesDS = cn.ExecuteQuery("cms.workflowstep.selectsteproles", params)
        For Each roleDR In rolesDS.Tables(0).Rows
            lstAllowedRoles.Items.Add(New ListItem(CType(roleDR("RoleDisplayName"), String), CType(roleDR("RoleID"), String)))
        Next
    End Sub

    Private Sub btnUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUpdate.Click
        ReloadRoles()
    End Sub

    Private Sub btnRemoveRole_Click(ByVal sender As System.Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles btnRemoveRole.Click
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Modify") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Modify")
            Exit Sub
        End If

        Dim cn As GeneralConnection = Functions.GetTreeProvider.Connection

        Dim itm As ListItem
        Dim params(1, 2) As Object
        params(0, 0) = "@stepid"
        params(0, 1) = CType(viewstate("StepID"), Integer)
        params(1, 0) = "@roleid"
        For Each itm In Me.lstAllowedRoles.Items
            If itm.Selected Then
                params(1, 1) = itm.Value
                cn.ExecuteQuery("cms.workflowstep.removerole", params)
            End If
        Next
        ReloadRoles()
    End Sub

End Class
