Imports Kentico.CMS.DataEngine
Imports Kentico.CMS.MetadataEngine
Imports Kentico.CMS.TreeEngine

Public Class WorkflowEdit
    Inherits System.Web.UI.Page

    Protected WorkflowID As Integer
    Protected WithEvents WorkflowDesigner1 As WorkflowDesigner

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents btnCancel As System.Web.UI.WebControls.Button
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal
    Protected WithEvents lblWorkflowID As System.Web.UI.WebControls.Label
    Protected WithEvents lblWorkflowIDValue As System.Web.UI.WebControls.Label
    Protected WithEvents lblWorkflowDisplayName As System.Web.UI.WebControls.Label
    Protected WithEvents txtWorkflowDisplayName As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblWorkflowName As System.Web.UI.WebControls.Label
    Protected WithEvents txtWorkflowName As System.Web.UI.WebControls.TextBox
    Protected WithEvents pnlSteps As System.Web.UI.WebControls.Panel

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Read") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Read")
            Exit Sub
        End If

        Functions.RedirectExpressEdition("CMSDesk.WorkflowEdit")

        Dim cn As GeneralConnection
        Dim workflowObj As DataClass

        If viewstate("WorkflowID") Is Nothing Then
            If (Request.QueryString("id") & "").Trim = "" Then
                viewstate("WorkflowID") = 0
            Else
                viewstate("WorkflowID") = Integer.Parse(Request.QueryString("id"))
            End If
        End If
        WorkflowID = Integer.Parse(CType(viewstate("WorkflowID"), String))
        WorkflowDesigner1.WorkflowID = WorkflowID

        lblError.Text = ""
        lblInfo.Text = ""
        lblHeader.Text = ResMan.GetString("WorkflowEdit.Header")
        lblWorkflowID.Text = ResMan.GetString("WorkflowEdit.WorkflowID")
        lblWorkflowName.Text = ResMan.GetString("WorkflowEdit.WorkflowName")
        lblWorkflowDisplayName.Text = ResMan.GetString("WorkflowEdit.WorkflowDisplayName")
        btnOK.Text = ResMan.GetString("WorkflowEdit.OK")
        btnCancel.Text = ResMan.GetString("WorkflowEdit.Cancel")

        If WorkflowID = 0 Then
            pnlSteps.Enabled = False
        End If

        If Not Page.IsPostBack And WorkflowID <> 0 Then
            'set values
            cn = New GeneralConnection(Functions.GetConnectionString)
            workflowObj = New DataClass("CMS.Workflow", WorkflowID, cn)
            txtWorkflowName.Text = CType(workflowObj.GetValue("WorkflowName"), String)
            txtWorkflowDisplayName.Text = CType(workflowObj.GetValue("WorkflowDisplayName"), String)
            lblWorkflowIDValue.Text = CType(workflowObj.GetValue("WorkflowID"), String)
        End If
        If WorkflowID = 0 Then
            lblWorkflowIDValue.Text = ResMan.GetString("EditWorkflow.NoWorkflowIDValue")
        End If
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        'redirect user back to the list of classes
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= " function Cancel()"
        ltlScript.Text &= " {"
        ltlScript.Text &= "   document.location.href='WorkflowList.aspx';"
        ltlScript.Text &= " }"
        ltlScript.Text &= " Cancel(); "
        ltlScript.Text &= "</script>"
    End Sub

    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        'check permissions
        If WorkflowID = 0 Then
            If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Create") Then
                Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Create")
                Exit Sub
            End If
        Else
            If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Modify") Then
                Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Modify")
                Exit Sub
            End If
        End If

        'validate input
        Dim errorMessage As String = ""
        Dim cn As GeneralConnection
        Dim params(0, 2) As String
        Dim WorkflowDR As DataRow
        Dim infoMessage As String = ""
        Dim workflowObj As DataClass
        Dim originalWorkflowName As String = ""
        Dim newWorkflowName As String = ""
        Dim workflowNamesDS As DataSet
        Dim workflowNameDR As DataRow
        Dim workflowStep As DataClass

        txtWorkflowName.Text = txtWorkflowName.Text.Trim
        txtWorkflowDisplayName.Text = txtWorkflowDisplayName.Text.Trim
        If txtWorkflowName.Text = "" Then
            errorMessage &= ResMan.GetString("WorkflowEdit.ErrorEmptyWorkflowName") & " "
        End If
        If txtWorkflowDisplayName.Text = "" Then
            errorMessage &= ResMan.GetString("WorkflowEdit.ErrorEmptyWorkflowDisplayName") & " "
        End If

        If errorMessage = "" Then
            'check for existing class
            params(0, 0) = "@WorkflowName"
            params(0, 1) = txtWorkflowName.Text
            cn = Functions.GetTreeProvider.Connection
            cn.DataConnection.Open()

            workflowNamesDS = cn.ExecuteQuery("CMS.Workflow.SelectByWorkflowName", params)
            If WorkflowID = 0 Then
                If workflowNamesDS.Tables(0).Rows.Count > 0 Then
                    'workflow name already exists
                    errorMessage &= ResMan.GetString("WorkflowEdit.ErrorExistingWorkflowName") & " "
                End If
            Else
                For Each WorkflowDR In workflowNamesDS.Tables(0).Rows
                    If CType(WorkflowDR("WorkflowID"), Integer) <> WorkflowID Then
                        'class name already exists
                        errorMessage &= ResMan.GetString("WorkflowEdit.ErrorExistingWorkflowName") & " "
                    End If
                Next
            End If

            If errorMessage = "" Then
                'save class info
                If WorkflowID = 0 Then
                    cn.DataConnection.Open()
                    cn.DataConnection.BeginTransaction()
                    Try
                        'insert a new class                    
                        workflowObj = New DataClass("CMS.Workflow", cn)
                        workflowObj.SetValue("WorkflowName", txtWorkflowName.Text)
                        workflowObj.SetValue("workflowDisplayName", txtWorkflowDisplayName.Text)
                        workflowObj.Insert()
                        Me.lblWorkflowIDValue.Text = CType(workflowObj.GetValue("WorkflowID"), Integer).ToString
                        'insert default steps
                        workflowStep = New DataClass("cms.workflowstep", cn)
                        workflowStep.SetValue("StepDisplayName", ResMan.GetString("WorkflowEdit.EditStepDisplayName"))
                        workflowStep.SetValue("StepName", "edit")
                        workflowStep.SetValue("StepOrder", 1)
                        workflowStep.SetValue("WorkflowID", CType(workflowObj.GetValue("WorkflowID"), Integer))
                        workflowStep.Insert()
                        workflowStep = New DataClass("cms.workflowstep", cn)
                        workflowStep.SetValue("StepDisplayName", ResMan.GetString("WorkflowEdit.PublishedStepDisplayName"))
                        workflowStep.SetValue("StepName", "published")
                        workflowStep.SetValue("StepOrder", 2)
                        workflowStep.SetValue("WorkflowID", CType(workflowObj.GetValue("WorkflowID"), Integer))
                        workflowStep.Insert()                        
                    Catch exc As Exception
                        cn.DataConnection.RollbackTransaction()
                        cn.DataConnection.Close()
                        Throw exc
                    End Try
                    cn.DataConnection.CommitTransaction()
                    cn.DataConnection.Close()
                    Me.pnlSteps.Enabled = True
                    Me.WorkflowDesigner1.WorkflowID = CType(workflowObj.GetValue("WorkflowID"), Integer)
                    viewstate("WorkflowID") = CType(workflowObj.GetValue("WorkflowID"), Integer)
                    infoMessage = ResMan.GetString("WorkflowEdit.ChangesSaved")
                Else
                        'update an existing class
                        workflowObj = New DataClass("CMS.Workflow", WorkflowID, cn)
                        originalWorkflowName = CType(workflowObj.GetValue("WorkflowName"), String)
                        newWorkflowName = Me.txtWorkflowName.Text
                        If originalWorkflowName.ToLower.Trim = "default" And newWorkflowName.ToLower.Trim <> "default" Then
                            'you cannot change the name of the default workflow
                            Me.lblError.Text = ResMan.GetString("WorkflowEdit.ErrorCannotChangeDefaultWorkflowName")
                            Exit Sub
                        End If
                        workflowObj.SetValue("WorkflowName", txtWorkflowName.Text)
                        newWorkflowName = CType(workflowObj.GetValue("WorkflowName"), String)
                        workflowObj.SetValue("WorkflowDisplayName", txtWorkflowDisplayName.Text)
                        workflowObj.Update()
                        infoMessage = ResMan.GetString("WorkflowEdit.ChangesSaved")
                End If
            End If
            cn.DataConnection.Close()
        End If

        If errorMessage <> "" Then
            lblError.Text = errorMessage            
        End If
        If infoMessage <> "" Then
            lblInfo.Text = infoMessage            
        End If
    End Sub
End Class
