Imports Kentico.CMS.DataEngine
Imports Kentico.CMS.MetadataEngine
Imports Kentico.CMS.TreeEngine

Public Class WorkflowList
    Inherits System.Web.UI.Page

    Protected editHint As String
    Protected deleteHint As String


#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents QueryDataGrid1 As Kentico.CMS.CMSControls.QueryDataGrid
    Protected WithEvents ltlConfirmScript As System.Web.UI.WebControls.Literal
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Read") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Read")
            Exit Sub
        End If

        editHint = ResMan.GetString("WorkflowList.EditHint")
        deleteHint = ResMan.GetString("WorkflowList.DeleteHint")
        'set column header names
        QueryDataGrid1.Columns(0).HeaderText = ResMan.GetString("WorkflowList.Action")
        QueryDataGrid1.Columns(1).HeaderText = ResMan.GetString("WorkflowList.WorkflowDisplayName")
        QueryDataGrid1.Columns(2).HeaderText = ResMan.GetString("WorkflowList.WorkflowName")

        'confirmation question
        ltlConfirmScript.Text = "<input type=""hidden"" id=""confirmationText"" value=""" & ResMan.GetString("WorkflowList.ConfirmDelete") & """>"
        lblHeader.Text = ResMan.GetString("WorkflowList.Header")
    End Sub


    '''<summary>Deletes selected workflow.</summary>
    Public Sub DeleteItem(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs)
        'check permissions
        If Not Functions.IsAuthorizedPerResource("CMS.MetaDesigner", "Delete") Then
            Functions.RedirectToAccessDenied("CMS.MetaDesigner", "Delete")
            Exit Sub
        End If

        Dim id As Integer = Integer.Parse(CType(e.CommandArgument, String))
        Dim cn As GeneralConnection = Functions.GetTreeProvider.Connection

        'check if user isn't deleting the default workflow
        Dim workflowObj As New DataClass("cms.workflow", id, cn)
        If (CType(workflowObj.GetValue("WorkflowName"), String) & "").Trim.ToLower = "default" Then
            ltlScript.Text = "<script language=""javascript"">"
            ltlScript.Text &= " alert('" & ResMan.GetString("WorkflowList.CannotDeleteDefaultWorkflow").Replace("'", "\'") & "'); "
            ltlScript.Text &= "</script>"
            Exit Sub
        End If

        'delete the workflow
        Dim params(0, 2) As String
        params(0, 0) = "@ID"
        params(0, 1) = id.ToString
        cn.ConnectionString = Functions.GetConnectionString
        cn.ExecuteQuery("CMS.Workflow.Delete", params)

        Response.Redirect(Page.Request.Url.ToString)
    End Sub


    Private Sub dtg_ItemDataBound(ByVal sender As System.Object, ByVal e As DataGridItemEventArgs) Handles QueryDataGrid1.ItemDataBound
        Dim btnCurrentButton As ImageButton

        'set up the delete button
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            btnCurrentButton = CType(e.Item.Cells(0).FindControl("btnDelete"), ImageButton)
            btnCurrentButton.Attributes.Add("OnClick", "return ConfirmDelete();")
            btnCurrentButton.Attributes.Add("title", deleteHint)
        End If
    End Sub

End Class
