Imports Kentico.CMS.DataEngine
Imports Kentico.CMS.TreeEngine

Public Class NewsletterView
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Protected WithEvents QueryDataGrid1 As Kentico.CMS.CMSControls.QueryDataGrid

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim idpath As String = Request.QueryString("idpath") & ""
        Dim culture As String = Request.QueryString("culture") & ""

        Dim tree As TreeProvider
        Dim node As TreeNode

        tree = Functions.GetTreeProvider
        node = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath)
        If Functions.UseMultilingualSupport And culture <> "" Then
            Dim aliaspath As String = CType(node.GetValue("AliasPath"), String)
            node = tree.SelectSingleNode("/" & culture & Functions.RemoveCultureFromAliasPath(aliaspath), TreePathTypeEnum.AliasPath)
            If node Is Nothing Then
                Response.Redirect("NewCultureVersion.aspx?idpath=" & idpath & "&aliaspath=" & aliaspath & "&culture=" & culture)
                Exit Sub
            Else
                idpath = CType(node.GetValue("idpath"), String)
            End If
        End If

        'Check permissions.
        If Not (Functions.IsAuthorizedPerResource("CMS.Newsletter", "Read") Or Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read)) Then
            Functions.RedirectToAccessDenied(idpath, "Read (NewsletterView.aspx)")
            Exit Sub
        End If

        'Set column header names.
        QueryDataGrid1.Columns(0).HeaderText = ResMan.GetString("NewsletterView.HeaderIssueSubject")
        QueryDataGrid1.Columns(1).HeaderText = ResMan.GetString("NewsletterView.HeaderSentEmails")
        QueryDataGrid1.Columns(2).HeaderText = ResMan.GetString("NewsletterView.HeaderUnsubscribed")

        'Select suitable data.
        Dim connection As New GeneralConnection(Functions.GetConnectionString)
        Dim issuesParams(0, 2) As Object
        Dim issues As DataSet

        issuesParams(0, 0) = "@IDPath"
        issuesParams(0, 1) = idpath

        issues = connection.ExecuteQuery("cms.newsletter.selectissues", issuesParams)

        'Assign data to the grid.
        QueryDataGrid1.DataSource = issues
        QueryDataGrid1.ProcessSorting = True
    End Sub
End Class