Imports Kentico.CMS.DataEngine

Public Class AddNewsletter
    Inherits System.Web.UI.Page

    Protected SubscriberID As Integer

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents txtSearch As System.Web.UI.WebControls.TextBox
    Protected WithEvents btnSearch As System.Web.UI.WebControls.Button
    Protected WithEvents lstItems As System.Web.UI.WebControls.ListBox
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents btnCancel As System.Web.UI.WebControls.Button
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Check permissions.
        If Not Functions.IsAuthorizedPerResource("CMS.Newsletter", "Read") Then
            Functions.RedirectToAccessDenied("CMS.Newsletter", "Read")
            Exit Sub
        End If

        SubscriberID = Integer.Parse(Request.QueryString("subscriberid"))

        'Set initial values from the resources.
        lblHeader.Text = ResMan.GetString("AddNewsletter.Header")
        btnSearch.Text = ResMan.GetString("AddNewsletter.SearchButton")
        btnOK.Text = ResMan.GetString("AddNewsletter.OK")
        btnCancel.Text = ResMan.GetString("AddNewsletter.Cancel")
    End Sub

    Private Sub btnSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSearch.Click
        Dim cn As New GeneralConnection
        Dim ds As DataSet

        'Find all newsletters whose name contains specified string.
        cn.ConnectionString = Functions.GetConnectionString
        ds = cn.ExecuteQuery("cms.newsletter.selectlist", Nothing, " NewsletterName LIKE N'%" & txtSearch.Text.Replace("'", "''") & "%' ", "NewsletterName")
        lstItems.DataSource = ds.Tables(0)
        lstItems.DataTextField = "NewsletterName"
        lstItems.DataValueField = "NewsletterID"
        lstItems.DataBind()
    End Sub

    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        'Check permissions.
        If Not Functions.IsAuthorizedPerResource("CMS.Newsletter", "Modify") Then
            Functions.RedirectToAccessDenied("CMS.Newsletter", "Modify")
            Exit Sub
        End If

        Dim item As ListItem
        Dim cn As New GeneralConnection
        Dim params(1, 2) As Object

        params(0, 0) = "@SubscriberID"
        params(0, 1) = SubscriberID
        cn.ConnectionString = Functions.GetConnectionString
        cn.DataConnection.Open()

        'Get IDs of the selected newsletters and save changes.
        For Each item In lstItems.Items
            If item.Selected Then
                params(1, 0) = "@NewsletterID"
                params(1, 1) = CType(item.Value, Integer)
                cn.ExecuteQuery("cms.subscriber.addsubscription", params)
            End If
        Next
        cn.DataConnection.Close()
        CloseWindow()
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        CloseWindow()
    End Sub

    '''<summary>Generates script that closes the window and refreshes the parent page.</summary>
    Private Sub CloseWindow()
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= " CloseAndRefresh(); "
        ltlScript.Text &= "</script>"
    End Sub
End Class
