Imports Kentico.CMS.DataEngine

Public Class EditNewsletters
    Inherits System.Web.UI.Page

    Protected SubscriberID As Integer
    Protected deleteHint As String

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Protected WithEvents lblNewslettersHeader As System.Web.UI.WebControls.Label
    Protected WithEvents ltlButtonAddNewsletter As System.Web.UI.WebControls.Literal
    Protected WithEvents btnDelete As System.Web.UI.WebControls.ImageButton
    Protected WithEvents ltlConfirmScript As System.Web.UI.WebControls.Literal
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents QueryDataGrid1 As Kentico.CMS.CMSControls.QueryDataGrid
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Check permissions.
        If Not Functions.IsAuthorizedPerResource("CMS.Newsletter", "Read") Then
            Functions.RedirectToAccessDenied("CMS.Newsletter", "Read")
            Exit Sub
        End If

        SubscriberID = Integer.Parse(Request.QueryString("subscriberid"))

        'Set button hints.
        deleteHint = ResMan.GetString("EditNewsletters.DeleteHint")

        'Confirmation question
        ltlConfirmScript.Text = "<input type=""hidden"" id=""confirmationText"" value=""" & ResMan.GetString("EditNewsletters.ConfirmDelete") & """>"

        'Header title
        lblHeader.Text = ResMan.GetString("EditNewsletters.Header")

        'Set label text from the resources.
        ltlButtonAddNewsletter.Text = "<input type=""button"" value=""" & ResMan.GetString("EditNewsletters.AddNewsletter") & """ class=""FormButton"" onclick=""javascript:AddNewsletter('" & SubscriberID & "');"">"
        btnOK.Text = ResMan.GetString("EditNewsletters.OK")

        'Set column header names.
        QueryDataGrid1.Columns(0).HeaderText = ResMan.GetString("EditNewsletters.Delete")
        QueryDataGrid1.Columns(1).HeaderText = ResMan.GetString("EditNewsletters.Newsletter")

        DisplayNewsletters()
        If Not Page.IsPostBack Then
            'Display subscriber e-mail in the header.
            Dim subscriber As New DataClass("cms.subscriber", SubscriberID, Functions.GetTreeProvider.Connection)
            Dim subscriberEmail As String = ""

            If Not subscriber.IsEmpty Then
                subscriberEmail = "<b>" & CType(subscriber.GetValue("SubscriberEmail"), String) & "</b>"
            End If
            lblNewslettersHeader.Text = Replace(ResMan.GetString("EditNewsletters.Description"), "{%email%}", subscriberEmail)
        End If
    End Sub

    Public Sub DeleteItem(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs)
        'Check permissions.
        If Not Functions.IsAuthorizedPerResource("CMS.Newsletter", "Modify") Then
            Functions.RedirectToAccessDenied("CMS.Newsletter", "Modify")
            Exit Sub
        End If

        'Remove selected subscription.
        Dim newsletterId As Integer = Integer.Parse(CType(e.CommandArgument, String))
        Dim cn As New GeneralConnection
        Dim params(1, 2) As Object

        params(0, 0) = "@SubscriberID"
        params(0, 1) = SubscriberID
        params(1, 0) = "@NewsletterID"
        params(1, 1) = newsletterId
        cn.ConnectionString = Functions.GetConnectionString
        cn.ExecuteQuery("cms.subscriber.removesubscription", params)
        Response.Redirect(Page.Request.Url.ToString)
    End Sub

    '''<summary>Displays subscribed newsletters of the selected user.</summary>
    Private Sub DisplayNewsletters()
        Dim cn As New GeneralConnection
        cn.ConnectionString = Functions.GetConnectionString
        QueryDataGrid1.GeneralConnection = cn
        QueryDataGrid1.QueryName = "cms.subscriber.getnewsletters"
        QueryDataGrid1.WhereCondition = " SubscriberID = '" & SubscriberID & "' "
    End Sub

    Private Sub dtg_ItemDataBound(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridItemEventArgs) Handles QueryDataGrid1.ItemDataBound
        Dim btnCurrentButton As ImageButton

        'set up the Delete button
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            btnCurrentButton = CType(e.Item.Cells(0).FindControl("btnDelete"), ImageButton)
            btnCurrentButton.Attributes.Add("OnClick", "return ConfirmDelete();")
            btnCurrentButton.Attributes.Add("title", deleteHint)
        End If
    End Sub

    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        GoBack()
    End Sub

    '''<summary>Returns user to the list of subscribers.</summary>
    Private Sub GoBack()
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= " GoBack(); "
        ltlScript.Text &= "</script>"
    End Sub
End Class
