Imports Kentico.CMS.DataEngine

Public Class EditSubscriber
    Inherits System.Web.UI.Page

    Protected SubscriberID As Integer

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents lblSubscriberID As System.Web.UI.WebControls.Label
    Protected WithEvents lblSubscriberIDValue As System.Web.UI.WebControls.Label
    Protected WithEvents lblEmail As System.Web.UI.WebControls.Label
    Protected WithEvents lblFirstName As System.Web.UI.WebControls.Label
    Protected WithEvents lblLastName As System.Web.UI.WebControls.Label
    Protected WithEvents lblFullName As System.Web.UI.WebControls.Label
    Protected WithEvents txtEmail As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtFirstName As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtLastName As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtFullName As System.Web.UI.WebControls.TextBox
    Protected WithEvents btnOK As System.Web.UI.WebControls.Button
    Protected WithEvents btnCancel As System.Web.UI.WebControls.Button
    Protected WithEvents ltlScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim cn As GeneralConnection
        Dim subscriber As DataClass

        If Request.QueryString("id") <> "" Then
            'Check permissions.
            If Not Functions.IsAuthorizedPerResource("CMS.Newsletter", "Modify") Then
                Functions.RedirectToAccessDenied("CMS.Newsletter", "Modify")
                Exit Sub
            End If
            SubscriberID = Integer.Parse(Request.QueryString("id"))
        Else
            'Check permissions.
            If Not Functions.IsAuthorizedPerResource("CMS.Newsletter", "Create") Then
                Functions.RedirectToAccessDenied("CMS.Newsletter", "Create")
                Exit Sub
            End If
            SubscriberID = 0
        End If

        'Set initial value and label visibility.
        lblError.Text = ""
        lblError.Visible = False
        lblInfo.Text = ""
        lblInfo.Visible = False

        'Set label text from the resources.
        lblHeader.Text = ResMan.GetString("EditSubscriber.Header")
        lblSubscriberID.Text = ResMan.GetString("EditSubscriber.SubscriberID")
        lblEmail.Text = ResMan.GetString("EditSubscriber.Email")
        lblFirstName.Text = ResMan.GetString("EditSubscriber.FirstName")
        lblLastName.Text = ResMan.GetString("EditSubscriber.LastName")
        lblFullName.Text = ResMan.GetString("EditSubscriber.FullName")
        btnOK.Text = ResMan.GetString("EditSubscriber.OK")
        btnCancel.Text = ResMan.GetString("EditSubscriber.Cancel")

        'Set subscriber values.
        If Page.IsPostBack = False And SubscriberID <> 0 Then
            cn = New GeneralConnection(Functions.GetConnectionString)
            subscriber = New DataClass("CMS.Subscriber", SubscriberID, cn)

            txtEmail.Text = CType(subscriber.GetValue("SubscriberEmail"), String)
            txtFirstName.Text = CType(subscriber.GetValue("SubscriberFirstName"), String)
            txtLastName.Text = CType(subscriber.GetValue("SubscriberLastName"), String)
            txtFullName.Text = CType(subscriber.GetValue("SubscriberFullName"), String)
            lblSubscriberIDValue.Text = CType(subscriber.GetValue("SubscriberID"), String)
        ElseIf SubscriberID = 0 Then
            lblSubscriberIDValue.Text = ResMan.GetString("EditSubscriber.NoSubscriberIDValue")
        End If
    End Sub

    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        Dim errorMessage As String = ""
        Dim infoMessage As String = ""
        Dim cn As GeneralConnection
        Dim params(0, 2) As String
        Dim subscriberEmails As DataSet
        Dim subscriber As DataClass

        'Validate input.
        If txtEmail.Text.Trim = "" Then
            errorMessage &= ResMan.GetString("EditSubscriber.ErrorEmptyEmail") & " "
        End If

        'Check for existing subscriber.
        If errorMessage = "" Then
            params(0, 0) = "@SubscriberEmail"
            params(0, 1) = txtEmail.Text.Trim
            cn = New GeneralConnection(Functions.GetConnectionString)
            cn.DataConnection.Open()

            subscriberEmails = cn.ExecuteQuery("cms.subscriber.selectbyemail", params)
            If SubscriberID = 0 Then
                If subscriberEmails.Tables(0).Rows.Count > 0 Then
                    'E-mail address already exists.
                    errorMessage &= ResMan.GetString("EditSubscriber.ErrorExistingEmail") & " "
                End If
            Else
                For Each subscriberEmail As DataRow In subscriberEmails.Tables(0).Rows
                    If CType(subscriberEmail("SubscriberID"), Integer) <> SubscriberID Then
                        'E-mail address already exists.
                        errorMessage &= ResMan.GetString("EditSubscriber.ErrorExistingEmail") & " "
                    End If
                Next
            End If

            If errorMessage = "" Then
                If SubscriberID = 0 Then
                    'Insert a new subscriber.
                    subscriber = New DataClass("CMS.Subscriber", cn)
                    subscriber.SetValue("SubscriberEmail", txtEmail.Text)
                    subscriber.SetValue("SubscriberFirstName", txtFirstName.Text)
                    subscriber.SetValue("SubscriberLastName", txtLastName.Text)
                    subscriber.SetValue("SubscriberFullName", txtFullName.Text)
                    subscriber.Insert()

                    'Clear form values.
                    txtEmail.Text = ""
                    txtFirstName.Text = ""
                    txtLastName.Text = ""
                    txtFullName.Text = ""

                    'Set result of the operation.
                    infoMessage = ResMan.GetString("EditSubscriber.ChangesInserted")
                Else
                    'Update an existing subscriber.
                    subscriber = New DataClass("CMS.Subscriber", SubscriberID, cn)
                    subscriber.SetValue("SubscriberEmail", txtEmail.Text)
                    subscriber.SetValue("SubscriberFirstName", txtFirstName.Text)
                    subscriber.SetValue("SubscriberLastName", txtLastName.Text)
                    subscriber.SetValue("SubscriberFullName", txtFullName.Text)
                    subscriber.Update()

                    'Set result of the operation.
                    infoMessage = ResMan.GetString("EditSubscriber.ChangesSaved")
                    GoBack()
                End If
            End If

            cn.DataConnection.Close()
        End If

        'Display information about the operation.
        If errorMessage <> "" Then
            lblError.Text = errorMessage
            lblError.Visible = True
        End If
        If infoMessage <> "" Then
            lblInfo.Text = infoMessage
            lblInfo.Visible = True
        End If
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        GoBack()
    End Sub

    '''<summary>Returns user to the list of subscribers.</summary>
    Private Sub GoBack()
        ltlScript.Text = "<script language=""javascript"">"
        ltlScript.Text &= " GoBack(); "
        ltlScript.Text &= "</script>"
    End Sub
End Class
