Imports Kentico.CMS.DataEngine

Public Class SubscriberList
    Inherits System.Web.UI.Page

    Protected deleteHint As String
    Protected editHint As String
    Protected WithEvents btnNew As System.Web.UI.WebControls.Button
    Protected newslettersHint As String

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents QueryDataGrid1 As Kentico.CMS.CMSControls.QueryDataGrid
    Protected WithEvents ltlConfirmScript As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Check permissions.
        If Not Functions.IsAuthorizedPerResource("CMS.Newsletter", "Read") Then
            Functions.RedirectToAccessDenied("CMS.Newsletter", "Read")
            Exit Sub
        End If

        Functions.RedirectExpressEdition("CMSDesk.Newsletter")

        'Set button hints.
        deleteHint = ResMan.GetString("SubscriberList.DeleteHint")
        editHint = ResMan.GetString("SubscriberList.EditHint")
        newslettersHint = ResMan.GetString("SubscriberList.NewslettersHint")
        Me.btnNew.Text = ResMan.GetString("SubscriberList.New")

        'Confirmation question
        ltlConfirmScript.Text = "<input type=""hidden"" id=""confirmationText"" value=""" & ResMan.GetString("SubscriberList.ConfirmDelete") & """>"

        'Header title
        lblHeader.Text = ResMan.GetString("SubscriberList.Header")

        'Set column header names.
        QueryDataGrid1.Columns(0).HeaderText = ResMan.GetString("SubscriberList.Action")
        QueryDataGrid1.Columns(1).HeaderText = ResMan.GetString("SubscriberList.FullName")
        QueryDataGrid1.Columns(2).HeaderText = ResMan.GetString("SubscriberList.Email")
        QueryDataGrid1.Columns(3).HeaderText = ResMan.GetString("SubscriberList.FirstName")
        QueryDataGrid1.Columns(4).HeaderText = ResMan.GetString("SubscriberList.LastName")

        DisplaySubscribers()
    End Sub

    Public Sub DeleteItem(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs)
        'Check permissions.
        If Not Functions.IsAuthorizedPerResource("CMS.Newsletter", "Delete") Then
            Functions.RedirectToAccessDenied("CMS.Newsletter", "Delete")
            Exit Sub
        End If

        'Delete subscriber.
        Dim id As Integer = Integer.Parse(CType(e.CommandArgument, String))
        Dim cn As New GeneralConnection
        Dim params(0, 2) As String

        params(0, 0) = "@ID"
        params(0, 1) = id.ToString
        cn.ConnectionString = Functions.GetConnectionString
        cn.ExecuteQuery("cms.subscriber.delete", params)
        Response.Redirect(Page.Request.Url.ToString)
    End Sub

    '''<summary>Displays subscribers in the list.</summary>
    Private Sub DisplaySubscribers()
        Dim cn As New GeneralConnection
        cn.ConnectionString = Functions.GetConnectionString
        QueryDataGrid1.GeneralConnection = cn
        QueryDataGrid1.QueryName = "cms.subscriber.selectlist"
    End Sub

    Private Sub dtg_ItemDataBound(ByVal sender As System.Object, ByVal e As DataGridItemEventArgs) Handles QueryDataGrid1.ItemDataBound
        Dim btnCurrentButton As ImageButton

        'set up the Delete button
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            btnCurrentButton = CType(e.Item.Cells(0).FindControl("btnDelete"), ImageButton)
            btnCurrentButton.Attributes.Add("OnClick", "return ConfirmDelete();")
            btnCurrentButton.Attributes.Add("title", deleteHint)
        End If
    End Sub

    Private Sub btnNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNew.Click
        Response.Redirect("EditSubscriber.aspx")
    End Sub
End Class
