Imports Kentico.CMS.CMSControls
Imports Kentico.CMS.TreeEngine
Imports Kentico.CMS.DataEngine

Public Class ToolsTreeData
    Inherits System.Web.UI.Page

    Private tree As TreeProvider
    Private Const cImageBasePath As String = "../Design/Tree"
    Private Const cIconsBasePath As String = "../Design/Icons/"


#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents ltlRender As System.Web.UI.WebControls.Literal

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim action As String

        action = LCase(Trim(Request.QueryString("action") & ""))
        tree = Functions.GetTreeProvider
        ltlRender.Text = "<script language=""javascript"">" & vbCrLf

        Select Case action
            Case "expandnode"
                'check permissions
                If Not Functions.IsAuthorizedPerResource("CMS.Tools", "Read") Then
                    ShowErrorMessage(ResMan.GetString("AccessDenied.NotAllowedToRead"))
                Else
                    AddRenderScript(GetChildNodes(Request.QueryString("nodeid"), Request.QueryString("sample"), Request.QueryString("value")), Request.QueryString("nodeid"))
                End If
        End Select
        ltlRender.Text &= "</script>"
    End Sub


    '''<summary>Adds script that removes the given node from the displayed tree.</summary>
    '''<param name="nodeIDPath">IDPath of the node to be removed.</param>
    Public Sub AddRemoveNodeScript(ByVal nodeIDPath As String)
        ltlRender.Text &= " parent.frames['tree'].document.getElementById('nodeID_" & nodeIDPath & "').innerHTML = '';"
    End Sub


    '''<summary>Adds script that reloads the selected node.</summary>
    Public Sub AddReloadSelectedNodeScript()
        ltlRender.Text &= " parent.frames['tree'].ReloadSelectedNode();" & vbCrLf
    End Sub


    '''<summary>Adds script that selects given node.</summary>
    '''<param name="selectIDPath">IDPath of the node to be selected.</param>
    Public Sub AddSelectNodeScript(ByVal selectIDPath As String)
        ltlRender.Text &= " SelectNode('" & selectIDPath & "'); " & vbCrLf & _
                         " function SelectNode(selectID) {" & vbCrLf & _
                         "  try {" & vbCrLf & _
                         "  parent.frames['tree'].selectNode(selectID);" & vbCrLf & _
                         "  } catch(e) { } " & vbCrLf & _
                         " } " & vbCrLf
    End Sub


    '''<summary>Adds content that will be rendered under given parent node.</summary>
    '''<param name="content">Content to be rendered.</param>
    '''<param name="targetNodeIDPath">Target node IDPath.</param>
    Public Sub AddRenderScript(ByVal content As String, ByVal targetNodeIDPath As String)
        Dim innerHTML As String
        innerHTML = Replace(content & "", "'", "\'")
        innerHTML = Replace(innerHTML, """", "\""")
        innerHTML = Replace(innerHTML, vbCrLf, " ")

        ltlRender.Text &= " RenderData(); " & vbCrLf & _
                     " function RenderData() {" & vbCrLf & _
                     "  // try {" & vbCrLf & _
                     "  parent.frames['tree'].document.getElementById('sub_" & targetNodeIDPath & "').innerHTML = '" & innerHTML & "'; " & vbCrLf
        If innerHTML & "" = "" Then
            ltlRender.Text &= " parent.frames['tree'].document.getElementById('sub_" & targetNodeIDPath & "').style.display = 'none'; " & vbCrLf
        End If
        ltlRender.Text &= "  // } catch(e) { } " & vbCrLf & _
                     " } " & vbCrLf
    End Sub


    '''<summary>Returns child nodes at 2nd and lower level.</summary>
    '''<param name="NodeID">Parent node ID (IDPath).</param>
    '''<param name="Sample">Sample for displaying tree.</param>
    '''<param name="Value">Value of the parent node.</param>
    Function GetChildNodes(ByVal NodeID As String, ByVal Sample As String, ByVal Value As String) As String
        Dim nodes As New TreeNodes
        Dim dr As DataRow
        Dim nodeRows As DataRowCollection
        Dim cn As New GeneralConnection

        cn.ConnectionString = Functions.GetConnectionString
        nodes.ImagePathBase = cImageBasePath
        'root = resources
        If NodeID = "/" Then
            For Each dr In cn.ExecuteQuery("CMS.Resource.SelectList", Nothing, "ShowInToolsMenu=1 AND ResourceURL!=''", "ResourceDisplayName").Tables(0).Rows
                Dim resURL As String
                Dim noURL As String = "notool.htm"
                If (Not dr("ResourceURL") Is DBNull.Value) Then
                    resURL = CType(dr.Item("ResourceURL"), String)
                    If resURL = "" Then resURL = noURL
                Else
                    resURL = noURL
                End If
                nodes.NewNode(CType(dr("ResourceDisplayName"), String), "/", cIconsBasePath & "resource.gif", cIconsBasePath & "resource.gif", CType(dr("ResourceDisplayName"), String), "parent.frames['details'].document.location.href = '" & ResolveUrl(resURL) & "'", "/res_" & CType(dr("ResourceID"), String), "", False)
            Next
        End If
        Return nodes.NodesHTML
    End Function


    '''<summary>Displays an error message.</summary>
    '''<param name="message">Error message.</param>
    Public Sub ShowErrorMessage(ByVal message As String)
        ltlRender.Text &= " alert('" & Replace(message & "", "'", "\'") & "');"
    End Sub
End Class
