using Kentico.CMS.TreeEngine; 
using System.IO; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace WebProjectCS {
    public class WebProjectGetFile : System.Web.UI.Page { 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
            /* TRANSWARNING: check EventHandler assignment */ 
            base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
            /* TRANSWARNING: check EventHandler assignment */ 
            base.Load += new System.EventHandler( Page_Load ); 
        } 
        
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            TreeProvider tree = Functions.GetTreeProvider(); 
            // parameters
            string aliaspath = Request.QueryString[ "aliaspath" ]; 
            
            // optional parameter filepath
            string filepath = Request.QueryString[ "filepath" ]; 
            if ( aliaspath == null && !( filepath == null ) ) { 
                // when multilingual support add language string to filepath
                if ( ( !( ConfigurationSettings.AppSettings[ "CMSUseMultilingualSupport" ] == null ) ) && ( ConfigurationSettings.AppSettings[ "CMSUseMultilingualSupport" ] == "true" ) ) { 
                    HttpCookie lang = Request.Cookies[ "CMSPreferredCulture" ]; 
                    if ( !( lang == null ) ) { 
                        filepath = "/" + lang.Value + filepath; 
                    } 
                    else { 
                        filepath = "/" + Functions.GetPreferredCulture() + filepath; 
                    } 
                } 
                
                string parpath = filepath.Substring( 0, filepath.LastIndexOf( "/" ) ); 
                string fname = filepath.Substring( filepath.LastIndexOf( "/" ) + 1 ); 
                
                if ( !( parpath.EndsWith( "/" ) ) ) { 
                    parpath += "/"; 
                } 
                parpath += "%"; 
                
                DataSet ds = tree.SelectNodes( parpath, TreePathTypeEnum.AliasPath, "CMS.File", "FileName='" + fname + "'", null, 1 ); 
                if ( !( ds.Tables[ 0 ] == null ) ) { 
                    DataTable dt = ds.Tables[ 0 ]; 
                    if ( dt.Rows.Count > 0 ) { 
                        aliaspath = System.Convert.ToString( dt.Rows[ 0 ][ "AliasPath" ] ); 
                    } 
                } 
            } 
            else { 
                // when multilingual support add language string to aliaspath
                if ( ( !( ConfigurationSettings.AppSettings[ "CMSUseMultilingualSupport" ] == null ) ) && ( ConfigurationSettings.AppSettings[ "CMSUseMultilingualSupport" ] == "true" ) ) { 
                    HttpCookie lang = Request.Cookies[ "CMSPreferredCulture" ]; 
                    if ( !( lang == null ) ) { 
                        aliaspath = "/" + lang.Value + aliaspath; 
                    } 
                    else { 
                        aliaspath = "/" + Functions.GetPreferredCulture() + aliaspath; 
                    } 
                } 
            } 
            
            string width = Request.QueryString[ "width" ]; 
            string height = Request.QueryString[ "height" ]; 
            
            string idpath = null; 
            
            // find corresponding tree node id path
            if ( ( !( aliaspath == null ) ) && ( aliaspath+ "" != "" ) ) { 
                int lastSlash = aliaspath.LastIndexOf( "/" ); 
                string parentAliasPath = null; 
                string nodeAlias = null; 
                // determine parent alias path and node path
                if ( lastSlash >= 0 ) { 
                    parentAliasPath = aliaspath.Substring( 0, lastSlash + 1 ); 
                    nodeAlias = aliaspath.Substring( lastSlash + 1 ); 
                } 
                else { 
                    parentAliasPath = "/"; 
                    nodeAlias = aliaspath; 
                } 
                parentAliasPath += "%"; 
                
                DataSet dsFiles = tree.SelectNodes( parentAliasPath, TreePathTypeEnum.AliasPath, "cms.file", "NodeAlias ='" + nodeAlias + "'" ); 
                
                if ( dsFiles.Tables[ 0 ].Rows.Count > 0 ) { 
                    idpath = System.Convert.ToString( dsFiles.Tables[ 0 ].Rows[ 0 ][ "IDPath" ] ); 
                } 
                else { 
                    return; 
                } 
            } 
            else { 
                return; 
            } 
            TreeNode fileNode = null; 
            string fileName = null; 
            string fileDiskPath = null; 
            byte[] data = null; 
            FileStream strm = null; 
            int length = 0; 
            // get file specified by IDPath
            // get file name
            fileNode = tree.SelectSingleNode( idpath, TreePathTypeEnum.IDPath, "cms.file" ); 
            if ( fileNode == null ) { 
                return; 
            } 
            fileName = System.Convert.ToString( fileNode.GetValue( "FileName" ) ); 
            aliaspath = System.Convert.ToString( fileNode.GetValue( "AliasPath" ) ); 
            fileDiskPath = Functions.GetFileFolderPath( aliaspath ) + @"\" + fileName; 
            
            // Checking secured areas and user permissions when node in secure area
            /* TRANSERROR: map static local variable to static field */ string[] securedAreas = null; 
            int i = 0; 
            if ( ( !( ConfigurationSettings.AppSettings[ "CMSSecuredAreas" ] == null ) ) && ConfigurationSettings.AppSettings[ "CMSSecuredAreas" ]+ "" != "" ) { 
                string aliasWithoutCulture = Functions.RemoveCultureFromAliasPath( System.Convert.ToString( fileNode.GetValue( "AliasPath" ) ) ).ToLower(); 
                securedAreas = ConfigurationSettings.AppSettings[ "CMSSecuredAreas" ].Trim().ToLower().Split( ';' ); 
                for ( i=0; i<=securedAreas.GetUpperBound( 0 ); i++ ) { 
                    if ( securedAreas[ i ]+ "" != "" ) { 
                        if ( aliasWithoutCulture.StartsWith( securedAreas[ i ] ) ) { 
                            // check permissions
                            if ( !( Functions.IsAuthorizedPerNode( idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read ) ) ) { 
                                // user is not authenticated for this node, end response
                                Response.End(); 
                                return; 
                            } 
                        } 
                    } 
                } 
            } 
            
            string contentType = System.Convert.ToString( fileNode.GetValue( "FileMimeType" ) ).ToLower(); 
            if ( File.Exists( fileDiskPath ) ) { 
                switch ( contentType ) {
                    case "image/pjpeg": case "image/gif": case "image/jpeg": case "image/tiff": case "image/png": case "image/bmp": case "image/wmf": case "image/icon":
                        System.Drawing.Bitmap bmp = new Bitmap( fileDiskPath ); 
                        // determine destination width
                        int destwidth = 0; 
                        if ( width + "" == "" ) { 
                            destwidth = bmp.Width; 
                        } 
                        else { 
                            try { 
                                destwidth = int.Parse( width ); 
                            } 
                            catch  { 
                                destwidth = bmp.Width; 
                            } 
                        } 
                        // determine destination height
                        int destheight = 0; 
                        if ( height + "" == "" ) { 
                            destheight = bmp.Height; 
                        } 
                        else { 
                            try { 
                                destheight = int.Parse( height ); 
                            } 
                            catch  { 
                                destheight = bmp.Height; 
                            } 
                        } 
                        // change image size?
                        if ( bmp.Width != destwidth || bmp.Height != destheight ) { 
                            try { 
                                System.Drawing.Bitmap newImage = new System.Drawing.Bitmap( destwidth, destheight ); 
                                Graphics g = null; 
                                g = Graphics.FromImage( newImage ); 
                                g.DrawImage( bmp, new RectangleF( 0, 0, destwidth, destheight ) ); 
                                g.Dispose(); 
                                bmp = newImage; 
                            } 
                            catch  { 
                            } 
                        } 
                        // send file
                        System.Drawing.Imaging.ImageFormat format = System.Drawing.Imaging.ImageFormat.Jpeg; 
                        // select destination format
                        switch ( contentType ) {
                            case "image/pjpeg": case "image/jpeg":
                                format = System.Drawing.Imaging.ImageFormat.Jpeg; 
                                break;
                            case "image/gif":
                                format = System.Drawing.Imaging.ImageFormat.Gif; 
                                break;
                            case "image/tiff":
                                format = System.Drawing.Imaging.ImageFormat.Tiff; 
                                break;
                            case "image/png":
                                format = System.Drawing.Imaging.ImageFormat.Png; 
                                break;
                            case "image/bmp":
                                format = System.Drawing.Imaging.ImageFormat.Bmp; 
                                break;
                            case "image/wmf":
                                format = System.Drawing.Imaging.ImageFormat.Wmf; 
                                break;
                            case "image/icon":
                                format = System.Drawing.Imaging.ImageFormat.Icon; 
                                break;
                        }
                        
                        bmp.Save( Response.OutputStream, format ); 
                        break;
                    default:
                        strm = File.OpenRead( fileDiskPath ); 
                        length = System.Convert.ToInt32( strm.Length ); 
                        data = new byte[ length ]; 
                        strm.Read( data, 0, length ); 
                        strm.Close(); 
                        // send file
                        Response.Cookies.Clear(); 
                        Response.Clear(); 
                        Response.ContentType = contentType; 
                        Response.AddHeader( "Content-Disposition", "attachment; filename=" + fileName ); 
                        Response.OutputStream.Write( data, 0, length ); 
                        Response.End(); 
                        break;
                }
                
            } 
        } 
        
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
