using System.Web; 
using System.Web.SessionState; 

using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace WebProjectCS {
    public class Global : System.Web.HttpApplication { 
        
        private System.Threading.Thread schedThread; 
        
        #region '" Component Designer Generated Code "' 
        
        public Global() : base() { 
            
            
            // This call is required by the Component Designer.
            InitializeComponent(); 
            
            // Add any initialization after the InitializeComponent() call
            
        } 
        
        // Required by the Component Designer
        private System.ComponentModel.IContainer components; 
        
        // NOTE: The following procedure is required by the Component Designer
        // It can be modified using the Component Designer.
        // Do not modify it using the code editor.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            components = new System.ComponentModel.Container(); 
            // events handled by Application_AcquireRequestState
            /* TRANSWARNING: check EventHandler assignment */ 
            base.AcquireRequestState += new System.EventHandler( Application_AcquireRequestState ); 
        } 
        
        
        #endregion 
        
        public void Application_Start( object sender, EventArgs e ) { 
            // start scheduler
            if ( ConfigurationSettings.AppSettings[ "CMSSchedulerInterval" ] + ""+ "" != "" ) { 
                string schedUrl = Strings.Left( HttpContext.Current.Request.Url.AbsoluteUri, Strings.Len( HttpContext.Current.Request.Url.AbsoluteUri ) - Strings.Len( HttpContext.Current.Request.Url.AbsolutePath ) ) + HttpContext.Current.Request.ApplicationPath + "/cmsdesk/logon.aspx"; 
                Scheduler schedObj = new Scheduler( int.Parse( ConfigurationSettings.AppSettings[ "CMSSchedulerInterval" ] ), schedUrl ); 
                System.Threading.ThreadStart threadStartObj = new System.Threading.ThreadStart( schedObj.Start ); 
                schedThread = new System.Threading.Thread( threadStartObj ); 
                schedThread.Start(); 
            } 
        } 
        
        
        public void Session_Start( object sender, EventArgs e ) { 
            //  Fires when the session is started
            if ( User.Identity.Name + ""+ "" != "" ) { 
                Functions.SetCurrentUserID( User.Identity.Name ); 
            } 
            // todo: remove
            // Session("CMSBrowseMode") = "edit"
            Response.Cookies.Add( new HttpCookie( "CMSPreferredCulture", Functions.GetPreferredCulture() ) ); 
        } 
        
        
        public void Application_BeginRequest( object sender, EventArgs e ) { 
            //  Fires at the beginning of each request
            string specialFiles = ";searchresultredirect.aspx;getfile.aspx;newsletterunsubscribe.aspx;".ToLower(); 
            if ( ( !( ConfigurationSettings.AppSettings[ "CMSSecuredAreasLogonPage" ] == null ) ) && ConfigurationSettings.AppSettings[ "CMSSecuredAreasLogonPage" ]+ "" != "" ) { 
                string logonPage = ConfigurationSettings.AppSettings[ "CMSSecuredAreasLogonPage" ].Replace( "~/", "" ); 
                specialFiles += logonPage.ToLower() + ";"; 
            } 
            string currentFile = Request.Path.ToLower().Substring( Request.Path.LastIndexOf( "/" ) + 1 ); 
            if ( specialFiles.IndexOf( ";" + currentFile + ";" ) < 0 ) { 
                Kentico.CMS.UrlRewritingEngine.UrlRewriter.RewriteUrl( Functions.GetConnectionString() ); 
            } 
            if ( Request.Path.ToLower().IndexOf( "getfile.aspx" ) < 0 && Response.ContentType.ToLower() == "text/html" && Strings.InStr( HttpContext.Current.Request.Url.AbsolutePath.ToLower(), "/cmsdesk", (Microsoft.VisualBasic.CompareMethod)(0) ) == 0 ) { 
                Response.Filter = new Kentico.CMS.CMSOutputFilter.OutputFilter( Response.Filter ); 
            } 
        } 
        
        
        public void Application_AcquireRequestState( object sender, EventArgs e ) { 
            // set language if required
            if ( ( !( Request.QueryString[ "lang" ] == null ) ) && Request.QueryString[ "lang" ]+ "" != "" ) { 
                Session[ "CMSPreferredCulture" ] = Request.QueryString[ "lang" ]; 
                Response.Cookies[ "CMSPreferredCulture" ].Value = Request.QueryString[ "lang" ]; 
            } 
        } 
        
        
        public void Application_AuthenticateRequest( object sender, EventArgs e ) { 
            //  Fires upon attempting to authenticate the use
        } 
        
        
        public void Application_AuthorizeRequest( object sender, EventArgs e ) { 
            // check if user is trying to access a secured area and redirect him/her to the logon form if he/she is not authenticated
            /* TRANSERROR: map static local variable to static field */ string[] securedAreas = null; 
            int i = 0; 
            
            // GetFile.aspx has special mode, it checks the authorization by itself, because there might be filepath instead of aliaspath given
            if ( Request.Path.ToLower().IndexOf( "getfile.aspx" ) >= 0 ) { 
                return; 
            } 
            if ( ( !( ConfigurationSettings.AppSettings[ "CMSSecuredAreas" ] == null ) ) && ConfigurationSettings.AppSettings[ "CMSSecuredAreas" ]+ "" != "" ) { 
                if ( !( User.Identity.IsAuthenticated ) ) { 
                    if ( ( !( Request.QueryString[ "aliaspath" ] == null ) ) && Request.QueryString[ "aliaspath" ].Trim()+ "" != "" ) { 
                        if ( securedAreas == null ) { 
                            securedAreas = ConfigurationSettings.AppSettings[ "CMSSecuredAreas" ].Trim().ToLower().Split( ';' ); 
                        } 
                        for ( i=0; i<=securedAreas.GetUpperBound( 0 ); i++ ) { 
                            if ( securedAreas[ i ]+ "" != "" ) { 
                                if ( Request.QueryString[ "aliaspath" ].Trim().ToLower().StartsWith( securedAreas[ i ] ) ) { 
                                    // user is not authenticated and tries to access a secured area - redirect him/her to the logon page
                                    Response.Redirect( ConfigurationSettings.AppSettings[ "CMSSecuredAreasLogonPage" ] + "?redirectto=" + Request.QueryString[ "aliaspath" ] ); 
                                    break; /* TRANSWARNING: check that break is in correct scope */ 
                                } 
                            } 
                        } 
                    } 
                } 
            } 
        } 
        
        
        public void Application_Error( object sender, EventArgs e ) { 
            //  Fires when an error occurs
            
            // check if the error occures in Kentico CMS Desk
            if ( Strings.InStr( Request.Url.ToString().ToLower(), "/cmsdesk/", (Microsoft.VisualBasic.CompareMethod)(0) ) > 0 ) { 
                Functions.LogEvent( "E", "CMSDESK", "EXCEPTION", 0, "", Server.GetLastError().ToString() ); 
                // check if it is some common HTTP error
                if ( Server.GetLastError().GetType() == typeof( System.Web.HttpException ) ) { 
                    return; 
                } 
                
                // check if custom errors are enabled
                System.Xml.XmlDocument config = new System.Xml.XmlDocument(); 
                config.Load( Server.MapPath( "~/web.config" ) ); 
                // no custom errors
                if ( !( config.SelectSingleNode( "/configuration/system.web/customErrors[@mode='Off']" ) == null ) ) { 
                    return; 
                } 
                
                Response.Clear(); 
                Response.Write( @"<html><header><title>Error</title></header><body style=""font-family:arial"">" ); 
                Response.Write( "<p>An error occurred when processing your request. Please contact your administrator for help.<p>" ); 
                if ( ( !( config.SelectSingleNode( "/configuration/system.web/customErrors[@mode='RemoteOnly']" ) == null ) ) && Request.Url.Host.ToLower() == "localhost" ) { 
                    Response.Write( @"<p><span style=""color:blue;cursor:hand"" onclick=""if (document.getElementById('error').style.display == 'none') {document.getElementById('error').style.display='block'} else {document.getElementById('error').style.display = 'none'};"">Show error details</span>" ); 
                    Response.Write( @"<span id=""error"" style=""display:none""><pre>" + Server.GetLastError().ToString() + "</pre></span></p>" ); 
                } 
                Response.Write( "</body></html>" ); 
                Response.End(); 
            } 
            else { 
                Functions.LogEvent( "E", "WebProjectCS", "EXCEPTION", 0, "", Server.GetLastError().ToString() ); 
            } 
        } 
        
        
        public void Session_End( object sender, EventArgs e ) { 
        } 
        
        
        public void Application_End( object sender, EventArgs e ) { 
            //  Fires when the application ends
        } 
        
        
    } 
    
    
} 
