using Kentico.CMS.DataEngine; 
using Kentico.CMS.TreeEngine; 
using Kentico.CMS.Newsletter; 
using System.Text.RegularExpressions; 


using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
namespace WebProjectCS {
    public class NewsletterUnsubscribe : System.Web.UI.Page { 
        
        #region '" Web Form Designer Generated Code "' 
        
        // This call is required by the Web Form Designer.
        [ System.Diagnostics.DebuggerStepThrough() ]
        private void InitializeComponent() { 
            
            // events handled by Page_Init
            /* TRANSWARNING: check EventHandler assignment */ 
            base.Init += new System.EventHandler( Page_Init ); 
            // events handled by Page_Load
            /* TRANSWARNING: check EventHandler assignment */ 
            base.Load += new System.EventHandler( Page_Load ); 
        } 
        
        
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblInfo; 
        protected /* TRANSINFO: WithEvents */ System.Web.UI.WebControls.Label lblError; 
        
        // NOTE: The following placeholder declaration is required by the Web Form Designer.
        // Do not delete or move it.
        private System.Object designerPlaceholderDeclaration; 
        
        private void Page_Init( System.Object sender, System.EventArgs e ) { 
            // CODEGEN: This method call is required by the Web Form Designer
            // Do not modify it using the code editor.
            InitializeComponent(); 
        } 
        
        
        #endregion 
        
        private void Page_Load( System.Object sender, System.EventArgs e ) { 
            string errorMessage = null; 
            string infoMessage = null; 
            
            string email = null; 
            int newsletterId = 0; 
            int newsletterIssueId = 0; 
            int subscriberId = 0; 
            
            // Set initial value and label visibility.
            lblError.Text = ""; 
            lblError.Visible = false; 
            lblInfo.Text = ""; 
            lblInfo.Visible = false; 
            
            // Parsing posted values
            try { 
                email = ParseEmail( Request.QueryString[ "email" ] ); 
            } 
            catch ( ArgumentNullException ex ) { 
                errorMessage += Strings.Replace( ResMan.GetString( "NewsletterUnsubscribe.ErrorMissingParameter" ), "{%parameter%}", "Email", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + " "; 
            } 
            catch ( Exception ex ) { 
                errorMessage += Strings.Replace( ResMan.GetString( "NewsletterUnsubscribe.ErrorInvalidParameter" ), "{%parameter%}", "Email", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + " "; 
            } 
            try { 
                newsletterId = int.Parse( Request.QueryString[ "newsletterid" ] ); 
            } 
            catch ( ArgumentNullException ex ) { 
                errorMessage += Strings.Replace( ResMan.GetString( "NewsletterUnsubscribe.ErrorMissingParameter" ), "{%parameter%}", "NewsletterID", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + " "; 
            } 
            catch ( Exception ex ) { 
                errorMessage += Strings.Replace( ResMan.GetString( "NewsletterUnsubscribe.ErrorInvalidParameter" ), "{%parameter%}", "NewsletterID", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + " "; 
            } 
            try { 
                subscriberId = int.Parse( Request.QueryString[ "subscriberid" ] ); 
            } 
            catch ( ArgumentNullException ex ) { 
                errorMessage += Strings.Replace( ResMan.GetString( "NewsletterUnsubscribe.ErrorMissingParameter" ), "{%parameter%}", "SubscriberID", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + " "; 
            } 
            catch ( Exception ex ) { 
                errorMessage += Strings.Replace( ResMan.GetString( "NewsletterUnsubscribe.ErrorInvalidParameter" ), "{%parameter%}", "SubscriberID", 1, -1, (Microsoft.VisualBasic.CompareMethod)(0) ) + " "; 
            } 
            
            if ( errorMessage + "" == "" ) { 
                NewsletterManager manager = new NewsletterManager( Functions.GetTreeProvider() ); 
                GeneralConnection connection = manager.TreeProvider.Connection; 
                DataClass newsletter = null; 
                DataClass subscriber = null; 
                DataClass newsletterIssue = null; 
                
                // Verify if newsletter is existing.
                newsletter = new DataClass( "CMS.Newsletter", newsletterId, connection ); 
                if ( newsletter == null || newsletter.IsEmpty() == true ) { 
                    errorMessage += ResMan.GetString( "NewsletterUnsubscribe.ErrorNonExistingNewsletter" ) + " "; 
                } 
                
                // Verify if subscriber is existing and valid.
                subscriber = manager.GetSubscriber( email ); 
                if ( subscriber == null || subscriber.IsEmpty() == true || subscriberId != System.Convert.ToInt32( subscriber.GetValue( "SubscriberId" ) ) ) { 
                    errorMessage += ResMan.GetString( "NewsletterUnsubscribe.ErrorNonExistingSubscriber" ) + " "; 
                } 
                
                try { 
                    newsletterIssueId = int.Parse( Request.QueryString[ "newsletterissueid" ] ); 
                    // Verify if newsletter issue is existing.
                    newsletterIssue = new DataClass( "CMS.NewsletterIssue", newsletterIssueId, connection ); 
                    if ( newsletterIssue == null || newsletterIssue.IsEmpty() == true ) { 
                        errorMessage += ResMan.GetString( "NewsletterUnsubscribe.ErrorNonExistingNewsletterIssue" ) + " "; 
                    } 
                } 
                catch  { 
                } 
                
                // Verify if subscription is existing.
                if ( errorMessage + "" == "" ) { 
                    object[,] subscriptionParams = new object[ 2, 3 ]; 
                    DataSet subscription = null; 
                    
                    subscriptionParams[ 0, 0 ] = "@SubscriberID"; 
                    subscriptionParams[ 0, 1 ] = subscriberId.ToString(); 
                    subscriptionParams[ 1, 0 ] = "@NewsletterID"; 
                    subscriptionParams[ 1, 1 ] = newsletterId.ToString(); 
                    subscription = connection.ExecuteQuery( "cms.subscriber.checksubscription", subscriptionParams ); 
                    
                    if ( System.Convert.ToInt32( subscription.Tables[ 0 ].Rows[ 0 ][ 0 ] ) == 0 ) { 
                        errorMessage += ResMan.GetString( "NewsletterUnsubscribe.ErrorNonExistingSubscription" ) + " "; 
                    } 
                } 
                
                // Perform unsubscription.
                if ( errorMessage + "" == "" ) { 
                    // Begin transaction.
                    connection.DataConnection.Open(); 
                    connection.DataConnection.BeginTransaction(); 
                    
                    try { 
                        int currentCount = 0; 
                        if ( !( newsletterIssue == null ) ) { 
                            currentCount = System.Convert.ToInt32( newsletterIssue.GetValue( "NewsletterUnsubscriptions" ) ); 
                        } 
                        
                        // Delete the newsletter subscription.
                        manager.DeleteSubscription( newsletterId, subscriberId ); 
                        
                        // Update unsubscription count.
                        if ( !( newsletterIssue == null ) ) { 
                            newsletterIssue.SetValue( "NewsletterUnsubscriptions", currentCount + 1 ); 
                            newsletterIssue.Update(); 
                        } 
                        
                        // Commit transaction.
                        connection.DataConnection.CommitTransaction(); 
                        
                        // Inform the user about the success.
                        infoMessage = ResMan.GetString( "NewsletterUnsubscribe.SuccessfullyRemoved" ); 
                    } 
                    catch  { 
                        // Rollback transaction.
                        connection.DataConnection.RollbackTransaction(); 
                        // Assign common description.
                        errorMessage += ResMan.GetString( "NewsletterUnsubscribe.ErrorAnErrorOccurred" ) + " "; 
                    } 
                    finally { 
                        // Close data connection.
                        connection.DataConnection.Close(); 
                    } 
                } 
            } 
            
            // Display information about the operation.
            if ( errorMessage+ "" != "" ) { 
                lblError.Text = errorMessage; 
                lblError.Visible = true; 
            } 
            if ( infoMessage+ "" != "" ) { 
                lblInfo.Text = infoMessage; 
                lblInfo.Visible = true; 
            } 
        } 
        
        
        ///<summary>Converts a string to valid e-mail address.</summary>
        ///<param name="value">A string to convert</param>
        private static string ParseEmail( string value ) { 
            if ( value == null ) { throw new ArgumentNullException( "value" ); } 
            
            if ( Regex.IsMatch( value, @"^\s*[a-zA-Z0-9]([_\.\-]?[a-zA-Z0-9]+)*@[a-zA-Z0-9]([\.\-]?[a-zA-Z0-9]+)*\.[a-zA-Z]{2,6}\s*$" ) == false ) { 
                throw new FormatException( "Input value has an invalid format." ); 
            } 
            return value.Trim(); 
        } 
        
        #region " Web Form Designer Generated Code "
        protected override void OnInit( EventArgs e ) { 
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit( e );
        } 
        
        #endregion 
    } 
    
    
} 
