Imports Kentico.CMS.TreeEngine
Imports System.IO

Public Class WebProjectGetFile
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim tree As TreeProvider = Functions.GetTreeProvider
        'parameters
        Dim aliaspath As String = Request.QueryString("aliaspath")

        'optional parameter filepath
        Dim filepath As String = Request.QueryString("filepath")
        If aliaspath Is Nothing AndAlso Not filepath Is Nothing Then
            'when multilingual support add language string to filepath
            If (Not ConfigurationSettings.AppSettings("CMSUseMultilingualSupport") Is Nothing) AndAlso (ConfigurationSettings.AppSettings("CMSUseMultilingualSupport") = "true") Then
                Dim lang As HttpCookie = Request.Cookies("CMSPreferredCulture")
                If Not lang Is Nothing Then
                    filepath = "/" & lang.Value & filepath
                Else
                    filepath = "/" & Functions.GetPreferredCulture() & filepath
                End If
            End If

            Dim parpath As String = filepath.Substring(0, filepath.LastIndexOf("/"))
            Dim fname As String = filepath.Substring(filepath.LastIndexOf("/") + 1)

            If Not parpath.EndsWith("/") Then
                parpath &= "/"
            End If
            parpath &= "%"

            Dim ds As DataSet = tree.SelectNodes(parpath, TreePathTypeEnum.AliasPath, "CMS.File", "FileName='" & fname & "'", Nothing, 1)
            If Not ds.Tables(0) Is Nothing Then
                Dim dt As DataTable = ds.Tables(0)
                If dt.Rows.Count > 0 Then
                    aliaspath = CType(dt.Rows(0).Item("AliasPath"), String)
                End If
            End If
        Else
            'when multilingual support add language string to aliaspath
            If (Not ConfigurationSettings.AppSettings("CMSUseMultilingualSupport") Is Nothing) AndAlso (ConfigurationSettings.AppSettings("CMSUseMultilingualSupport") = "true") Then
                Dim lang As HttpCookie = Request.Cookies("CMSPreferredCulture")
                If Not lang Is Nothing Then
                    aliaspath = "/" & lang.Value & aliaspath
                Else
                    aliaspath = "/" & Functions.GetPreferredCulture() & aliaspath
                End If
            End If
        End If

        Dim width As String = Request.QueryString("width")
        Dim height As String = Request.QueryString("height")

        Dim idpath As String

        'find corresponding tree node id path
        If (Not aliaspath Is Nothing) AndAlso (aliaspath <> "") Then
            Dim lastSlash As Integer = aliaspath.LastIndexOf("/")
            Dim parentAliasPath As String
            Dim nodeAlias As String
            'determine parent alias path and node path
            If lastSlash >= 0 Then
                parentAliasPath = aliaspath.Substring(0, lastSlash + 1)
                nodeAlias = aliaspath.Substring(lastSlash + 1)
            Else
                parentAliasPath = "/"
                nodeAlias = aliaspath
            End If
            parentAliasPath &= "%"

            Dim dsFiles As DataSet = tree.SelectNodes(parentAliasPath, TreePathTypeEnum.AliasPath, "cms.file", "NodeAlias ='" & nodeAlias & "'")

            If dsFiles.Tables(0).Rows.Count > 0 Then
                idpath = CType(dsFiles.Tables(0).Rows(0)("IDPath"), String)
            Else
                Exit Sub
            End If
        Else
            Exit Sub
        End If
        Dim fileNode As TreeNode
        Dim fileName As String
        Dim fileDiskPath As String
        Dim data() As Byte
        Dim strm As FileStream
        Dim length As Integer
        'get file specified by IDPath
        'get file name
        fileNode = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath, "cms.file")
        If fileNode Is Nothing Then
            Exit Sub
        End If
        fileName = CType(fileNode.GetValue("FileName"), String)
        aliaspath = CType(fileNode.GetValue("AliasPath"), String)
        fileDiskPath = Functions.GetFileFolderPath(aliaspath) & "\" & fileName

        'Checking secured areas and user permissions when node in secure area
        Static securedAreas() As String
        Dim i As Integer
        If (Not ConfigurationSettings.AppSettings("CMSSecuredAreas") Is Nothing) AndAlso ConfigurationSettings.AppSettings("CMSSecuredAreas") <> "" Then
            Dim aliasWithoutCulture As String = Functions.RemoveCultureFromAliasPath(CType(fileNode.GetValue("AliasPath"), String)).ToLower()
            securedAreas = ConfigurationSettings.AppSettings("CMSSecuredAreas").Trim.ToLower.Split(";"c)
            For i = 0 To securedAreas.GetUpperBound(0)
                If securedAreas(i) <> "" Then
                    If aliasWithoutCulture.StartsWith(securedAreas(i)) Then
                        'check permissions
                        If Not Functions.IsAuthorizedPerNode(idpath, TreePathTypeEnum.IDPath, NodePermissionsEnum.Read) Then
                            'user is not authenticated for this node, end response
                            Response.End()
                            Exit Sub
                        End If
                    End If
                End If
            Next
        End If

        Dim contentType As String = CType(fileNode.GetValue("FileMimeType"), String).ToLower
        If File.Exists(fileDiskPath) Then
            Select Case contentType
                Case "image/pjpeg", "image/gif", "image/jpeg", "image/tiff", "image/png", "image/bmp", _
                     "image/wmf", "image/icon"
                    Dim bmp As System.Drawing.Bitmap = New Bitmap(fileDiskPath)
                    'determine destination width
                    Dim destwidth As Integer
                    If width = "" Then
                        destwidth = bmp.Width
                    Else
                        Try
                            destwidth = CType(width, Integer)
                        Catch
                            destwidth = bmp.Width
                        End Try
                    End If
                    'determine destination height
                    Dim destheight As Integer
                    If height = "" Then
                        destheight = bmp.Height
                    Else
                        Try
                            destheight = CType(height, Integer)
                        Catch
                            destheight = bmp.Height
                        End Try
                    End If
                    'change image size?
                    If bmp.Width <> destwidth OrElse bmp.Height <> destheight Then
                        Try
                            Dim newImage As System.Drawing.Bitmap = New System.Drawing.Bitmap(destwidth, destheight)
                            Dim g As Graphics
                            g = Graphics.FromImage(newImage)
                            g.DrawImage(bmp, New RectangleF(0, 0, destwidth, destheight))
                            g.Dispose()
                            bmp = newImage
                        Catch
                        End Try
                    End If
                    'send file
                    Dim format As System.Drawing.Imaging.ImageFormat = System.Drawing.Imaging.ImageFormat.Jpeg
                    'select destination format
                    Select Case contentType
                        Case "image/pjpeg", "image/jpeg"
                            format = System.Drawing.Imaging.ImageFormat.Jpeg
                        Case "image/gif"
                            format = System.Drawing.Imaging.ImageFormat.Gif
                        Case "image/tiff"
                            format = System.Drawing.Imaging.ImageFormat.Tiff
                        Case "image/png"
                            format = System.Drawing.Imaging.ImageFormat.Png
                        Case "image/bmp"
                            format = System.Drawing.Imaging.ImageFormat.Bmp
                        Case "image/wmf"
                            format = System.Drawing.Imaging.ImageFormat.Wmf
                        Case "image/icon"
                            format = System.Drawing.Imaging.ImageFormat.Icon
                    End Select
                    bmp.Save(Response.OutputStream, format)
                Case Else
                    strm = File.OpenRead(fileDiskPath)
                    length = CType(strm.Length, Integer)
                    ReDim data(length)
                    strm.Read(data, 0, length)
                    strm.Close()
                    'send file
                    Response.Cookies.Clear()
                    Response.Clear()
                    Response.ContentType = contentType
                    Response.AddHeader("Content-Disposition", "attachment; filename=" & fileName)
                    Response.OutputStream.Write(data, 0, length)
                    Response.End()
            End Select
        End If
    End Sub

End Class
