Imports System.Web
Imports System.Web.SessionState

Public Class Global
    Inherits System.Web.HttpApplication

    Private schedThread As System.Threading.Thread

#Region " Component Designer Generated Code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Component Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Required by the Component Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Component Designer
    'It can be modified using the Component Designer.
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New System.ComponentModel.Container()
    End Sub

#End Region

    Sub Application_Start(ByVal sender As Object, ByVal e As EventArgs)
        'start scheduler
        If ConfigurationSettings.AppSettings("CMSSchedulerInterval") & "" <> "" Then
            Dim schedUrl As String = Left(HttpContext.Current.Request.Url.AbsoluteUri, Len(HttpContext.Current.Request.Url.AbsoluteUri) - Len(HttpContext.Current.Request.Url.AbsolutePath)) & HttpContext.Current.Request.ApplicationPath & "/cmsdesk/logon.aspx"
            Dim schedObj As Scheduler = New Scheduler(Integer.Parse(ConfigurationSettings.AppSettings("CMSSchedulerInterval")), schedUrl)
            Dim threadStartObj As System.Threading.ThreadStart = New System.Threading.ThreadStart(AddressOf schedObj.Start)
            schedThread = New System.Threading.Thread(threadStartObj)
            schedThread.Start()
        End If
    End Sub

    Sub Session_Start(ByVal sender As Object, ByVal e As EventArgs)
        ' Fires when the session is started
        If User.Identity.Name & "" <> "" Then
            Functions.SetCurrentUserID(User.Identity.Name)
        End If
        'todo: remove
        'Session("CMSBrowseMode") = "edit"
        Response.Cookies.Add(New HttpCookie("CMSPreferredCulture", Functions.GetPreferredCulture()))
    End Sub

    Sub Application_BeginRequest(ByVal sender As Object, ByVal e As EventArgs)
        ' Fires at the beginning of each request
        Dim specialFiles As String = ";searchresultredirect.aspx;getfile.aspx;newsletterunsubscribe.aspx;".ToLower
        If (Not ConfigurationSettings.AppSettings("CMSSecuredAreasLogonPage") Is Nothing) AndAlso ConfigurationSettings.AppSettings("CMSSecuredAreasLogonPage") <> "" Then
            Dim logonPage As String = ConfigurationSettings.AppSettings("CMSSecuredAreasLogonPage").Replace("~/", "")
            specialFiles &= logonPage.ToLower & ";"
        End If
        Dim currentFile As String = Request.Path.ToLower.Substring(Request.Path.LastIndexOf("/") + 1)
        If specialFiles.IndexOf(";" & currentFile & ";") < 0 Then
            Kentico.CMS.UrlRewritingEngine.UrlRewriter.RewriteUrl(Functions.GetConnectionString)
        End If
        If Request.Path.ToLower.IndexOf("getfile.aspx") < 0 AndAlso Response.ContentType.ToLower = "text/html" AndAlso InStr(HttpContext.Current.Request.Url.AbsolutePath.ToLower, "/cmsdesk") = 0 Then
            Response.Filter = New Kentico.CMS.CMSOutputFilter.OutputFilter(Response.Filter)
        End If
    End Sub

    Sub Application_AcquireRequestState(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.AcquireRequestState
        'set language if required
        If (Not Request.QueryString("lang") Is Nothing) AndAlso Request.QueryString("lang") <> "" Then
            Session("CMSPreferredCulture") = Request.QueryString("lang")
            Response.Cookies("CMSPreferredCulture").Value = Request.QueryString("lang")
        End If
    End Sub

    Sub Application_AuthenticateRequest(ByVal sender As Object, ByVal e As EventArgs)
        ' Fires upon attempting to authenticate the use
    End Sub

    Sub Application_AuthorizeRequest(ByVal sender As Object, ByVal e As EventArgs)
        'check if user is trying to access a secured area and redirect him/her to the logon form if he/she is not authenticated
        Static securedAreas() As String
        Dim i As Integer

        'GetFile.aspx has special mode, it checks the authorization by itself, because there might be filepath instead of aliaspath given
        If Request.Path.ToLower.IndexOf("getfile.aspx") >= 0 Then
            Exit Sub
        End If
        If (Not ConfigurationSettings.AppSettings("CMSSecuredAreas") Is Nothing) AndAlso ConfigurationSettings.AppSettings("CMSSecuredAreas") <> "" Then
            If Not User.Identity.IsAuthenticated Then
                If (Not Request.QueryString("aliaspath") Is Nothing) AndAlso Request.QueryString("aliaspath").Trim <> "" Then
                    If securedAreas Is Nothing Then
                        securedAreas = ConfigurationSettings.AppSettings("CMSSecuredAreas").Trim.ToLower.Split(";"c)
                    End If
                    For i = 0 To securedAreas.GetUpperBound(0)
                        If securedAreas(i) <> "" Then
                            If Request.QueryString("aliaspath").Trim.ToLower.StartsWith(securedAreas(i)) Then
                                'user is not authenticated and tries to access a secured area - redirect him/her to the logon page
                                Response.Redirect(ConfigurationSettings.AppSettings("CMSSecuredAreasLogonPage") & "?redirectto=" & Request.QueryString("aliaspath"))
                                Exit For
                            End If
                        End If
                    Next
                End If
            End If
        End If
    End Sub

    Sub Application_Error(ByVal sender As Object, ByVal e As EventArgs)
        ' Fires when an error occurs

        'check if the error occures in Kentico CMS Desk
        If InStr(Request.Url.ToString.ToLower, "/cmsdesk/") > 0 Then
            Functions.LogEvent("E", "CMSDESK", "EXCEPTION", 0, "", Server.GetLastError.ToString)
            'check if it is some common HTTP error
            If Server.GetLastError.GetType() Is GetType(System.Web.HttpException) Then
                Exit Sub
            End If

            'check if custom errors are enabled
            Dim config As New System.Xml.XmlDocument
            config.Load(Server.MapPath("~/web.config"))
            'no custom errors
            If Not config.SelectSingleNode("/configuration/system.web/customErrors[@mode='Off']") Is Nothing Then
                Exit Sub
            End If

            Response.Clear()
            Response.Write("<html><header><title>Error</title></header><body style=""font-family:arial"">")
            Response.Write("<p>An error occurred when processing your request. Please contact your administrator for help.<p>")
            If (Not config.SelectSingleNode("/configuration/system.web/customErrors[@mode='RemoteOnly']") Is Nothing) AndAlso Request.Url.Host.ToLower = "localhost" Then
                Response.Write("<p><span style=""color:blue;cursor:hand"" onclick=""if (document.getElementById('error').style.display == 'none') {document.getElementById('error').style.display='block'} else {document.getElementById('error').style.display = 'none'};"">Show error details</span>")
                Response.Write("<span id=""error"" style=""display:none""><pre>" & Server.GetLastError.ToString & "</pre></span></p>")
            End If
            Response.Write("</body></html>")
            Response.End()
        Else
            Functions.LogEvent("E", "WebProject", "EXCEPTION", 0, "", Server.GetLastError.ToString)
        End If
    End Sub

    Sub Session_End(ByVal sender As Object, ByVal e As EventArgs)
    End Sub

    Sub Application_End(ByVal sender As Object, ByVal e As EventArgs)
        ' Fires when the application ends
    End Sub

End Class
