Imports Kentico.CMS.TreeEngine

Public Class SearchResultRedirect
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim idpath As String
        Dim node As TreeNode
        Dim tree As TreeProvider
        Dim pageDR As DataRow
        Dim newAliasPath As String
        Dim redirectPath As String

        'get IDPath and check if it's correct
        idpath = Request.QueryString("idpath")
        If idpath = "" Or idpath = "/" Then
            Response.Redirect("~/.")
        End If
        tree = Functions.GetTreeProvider
        node = tree.SelectSingleNode(idpath, TreePathTypeEnum.IDPath)
        If node Is Nothing Then
            Response.Redirect("~/.")
        End If

        'get nearest parent menu item
        If (Not ConfigurationSettings.AppSettings("CMSSearchResultToNearestPage") Is Nothing) AndAlso ConfigurationSettings.AppSettings("CMSSearchResultToNearestPage").ToLower.Trim = "true" AndAlso node.ClassName.ToLower <> "cms.menuitem" Then
            pageDR = Functions.GetPageInfoDR(Functions.RemoveCultureFromPath(CType(node.GetValue("AliasPath"), String)))
            If Not pageDR Is Nothing Then
                'page found
                newAliasPath = CType(pageDR("AliasPath"), String)
            Else
                'page not found - it's root
                If node.ClassName.ToLower = "cms.file" Then
                    'redirect directly to the file
                    newAliasPath = node.GetParentPath(TreePathTypeEnum.AliasPath) & "/" & CType(node.GetValue("FileName"), String)
                Else
                    'redirect to home page
                    newAliasPath = "/"
                End If
            End If
        Else
            newAliasPath = CType(node.GetValue("AliasPath"), String)
        End If

        'set culture if necessary
        If (Not ConfigurationSettings.AppSettings("CMSUseMultilingualSupport") Is Nothing) AndAlso ConfigurationSettings.AppSettings("CMSUseMultilingualSupport").Trim.ToLower = "true" Then
            HttpContext.Current.Session("CMSPreferredCulture") = newAliasPath.Split("/"c)(1)
            redirectPath = Functions.RemoveCultureFromPath(newAliasPath)
        Else
            redirectPath = newAliasPath
        End If
        redirectPath = Functions.AddUrlExtension(redirectPath)
        'redirect user to the right page
        Response.Redirect("~" & redirectPath)
    End Sub

End Class
